# Symbolics.jl

[![Github Action CI](https://github.com/JuliaSymbolics/Symbolics.jl/workflows/CI/badge.svg)](https://github.com/JuliaSymbolics/Symbolics.jl/actions)
[![codecov](https://codecov.io/gh/JuliaSymbolics/Symbolics.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaSymbolics/Symbolics.jl)
[![Build Status](https://github.com/JuliaSymbolics/Symbolics.jl/workflows/CI/badge.svg)](https://github.com/JuliaSymbolics/Symbolics.jl/actions?query=workflow%3ACI)
[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://docs.sciml.ai/Symbolics/stable/)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://docs.sciml.ai/Symbolics/dev/)

Symbolics.jl is a fast and modern Computer Algebra System (CAS) for a fast and modern
programming language (Julia). The goal is to have a high-performance and parallelized
symbolic algebra system that is directly extendable in the same language as that of the
users.

## Installation

To install Symbolics.jl, use the Julia package manager:

```julia
julia> using Pkg
julia> Pkg.add("Symbolics")
```

## Documentation

For information on using the package, see the [stable documentation](https://juliasymbolics.github.io/Symbolics.jl/stable/).
Use the [in-development documentation](https://juliasymbolics.github.io/Symbolics.jl/dev/)
for the version of the documentation which contains the unreleased features.

## Relationship to Other Packages

- [SymbolicUtils.jl](https://github.com/JuliaSymbolics/SymbolicUtils.jl): This is a
  rule-rewriting system that is the core of Symbolics.jl. Symbolics.jl builds off of
  SymbolicUtils.jl to extend it to a whole symbolic algebra system, complete with
  support for differentiation, solving symbolic systems of equations, etc. If you're
  looking for the barebones to build a new CAS for specific algebras, SymbolicUtils.jl
  is that foundation. Otherwise, Symbolics.jl is for you.
- [ModelingToolkit.jl](https://github.com/SciML/ModelingToolkit.jl): This is a
  symbolic-numeric modeling system for the SciML ecosystem. It heavily uses Symbolics.jl
  for its representation of symbolic equations along with tools like differentiation,
  and adds the representation of common modeling systems like ODEs, SDEs, and more.

## Example

```julia
julia> using Symbolics

julia> @variables t x y
julia> D = Differential(t)

julia> z = t + t^2
julia> D(z) # symbolic representation of derivative(t + t^2, t)
Differential(t)(t + t^2)

julia> expand_derivatives(D(z))
1 + 2t

julia> Symbolics.jacobian([x + x*y, x^2 + y],[x, y])
2×2 Matrix{Num}:
 1 + y  x
    2x  1

julia> B = simplify.([t^2 + t + t^2  2t + 4t
                  x + y + y + 2t  x^2 - x^2 + y^2])
2×2 Matrix{Num}:
  t + 2(t^2)   6t
 x + 2t + 2y  y^2

julia> simplify.(substitute.(B, (Dict(x => y^2),)))
2×2 Matrix{Num}:
    t + 2(t^2)   6t
 2t + y^2 + 2y  y^2

julia> substitute.(B, (Dict(x => 2.0, y => 3.0, t => 4.0),))
2×2 Matrix{Num}:
 36.0  24.0
 16.0   9.0
```

## Citation

If you use Symbolics.jl, please [cite this paper](https://dl.acm.org/doi/10.1145/3511528.3511535) 
(or see the free [arxiv version](https://arxiv.org/abs/2105.03949))

```bib
@article{10.1145/3511528.3511535,
author = {Gowda, Shashi and Ma, Yingbo and Cheli, Alessandro and Gw\'{o}\'{z}zd\'{z}, Maja and Shah, Viral B. and Edelman, Alan and Rackauckas, Christopher},
title = {High-Performance Symbolic-Numerics via Multiple Dispatch},
year = {2022},
issue_date = {September 2021},
publisher = {Association for Computing Machinery},
address = {New York, NY, USA},
volume = {55},
number = {3},
issn = {1932-2240},
url = {https://doi.org/10.1145/3511528.3511535},
doi = {10.1145/3511528.3511535},
abstract = {As mathematical computing becomes more democratized in high-level languages, high-performance symbolic-numeric systems are necessary for domain scientists and engineers to get the best performance out of their machine without deep knowledge of code optimization. Naturally, users need different term types either to have different algebraic properties for them, or to use efficient data structures. To this end, we developed Symbolics.jl, an extendable symbolic system which uses dynamic multiple dispatch to change behavior depending on the domain needs. In this work we detail an underlying abstract term interface which allows for speed without sacrificing generality. We show that by formalizing a generic API on actions independent of implementation, we can retroactively add optimized data structures to our system without changing the pre-existing term rewriters. We showcase how this can be used to optimize term construction and give a 113x acceleration on general symbolic transformations. Further, we show that such a generic API allows for complementary term-rewriting implementations. Exploiting this feature, we demonstrate the ability to swap between classical term-rewriting simplifiers and e-graph-based term-rewriting simplifiers. We illustrate how this symbolic system improves numerical computing tasks by showcasing an e-graph ruleset which minimizes the number of CPU cycles during expression evaluation, and demonstrate how it simplifies a real-world reaction-network simulation to halve the runtime. Additionally, we show a reaction-diffusion partial differential equation solver which is able to be automatically converted into symbolic expressions via multiple dispatch tracing, which is subsequently accelerated and parallelized to give a 157x simulation speedup. Together, this presents Symbolics.jl as a next-generation symbolic-numeric computing environment geared towards modeling and simulation.},
journal = {ACM Commun. Comput. Algebra},
month = {jan},
pages = {92–96},
numpages = {5}
}
```

using Symbolics
using Symbolics: symbol_to_poly, poly_to_symbol
using Groebner
using Test

@variables x y z

syms = [
    [1], [1, BigInt(2)], [x], [x^2 + 2], [x + (5 // 8)y],
    [1 - x * y * z], [(x + y + z)^5], [0, BigInt(0)y^2, Rational(1)z^3],
    [x, sin((44 // 31)y) * z]
]
for sym in syms
    polynoms, pvar2sym, sym2term = Symbolics.symbol_to_poly(sym)
    sym2 = Symbolics.poly_to_symbol(polynoms, pvar2sym, sym2term, Real)
    @test isequal(expand.(sym2), expand.(sym))
end

@test isequal(expand.(groebner_basis([x, y])), [y, x])
@test isequal(expand.(groebner_basis([y, x])), [y, x])
@test isequal(expand.(groebner_basis([x])), [x])
@test isequal(expand.(groebner_basis([x, x^2])), [x])
@test isequal(expand.(groebner_basis([BigInt(1)x + 2 // 3])), [x + 2 // 3])

@test Symbolics.is_groebner_basis([x, y, z])
@test Symbolics.is_groebner_basis([x^2 - x, y^2 - y])
@test !Symbolics.is_groebner_basis([x^2 + y, x * y^3 - 1, y^4 - 1])

@variables x1 x2 x3 x4
@test isequal(expand.(groebner_basis([x1, x, y])), [y, x1, x])

# input unchanged
f1 = [x2, x1, x4, x3]
f2 = [x2, x1, x4, x3]
groebner_basis(f1)
@test isequal(expand.(f1), expand.(f2))

@variables x1 x2 x3 x4 x5
system = [
    x1 + x2 + x3 + x4 + x5,
    x1 * x2 + x1 * x3 + x1 * x4 + x1 * x5 + x2 * x3 + x2 * x4 + x2 * x5 + x3 * x4 + x3 * x5 + x4 * x5,
    x1 * x2 * x3 + x1 * x2 * x4 + x1 * x2 * x5 + x1 * x3 * x4 + x1 * x3 * x5 + x1 * x4 * x5 + x2 * x3 * x4 + x2 * x3 * x5 + x2 * x4 * x5 + x3 * x4 * x5,
    x1 * x2 * x3 * x4 + x1 * x2 * x3 * x5 + x1 * x2 * x4 * x5 + x1 * x3 * x4 * x5 + x2 * x3 * x4 * x5,
    x1 * x2 * x3 * x4 * x5 - 1
]
truebasis = [
    x1 + x2 + x3 + x4 + x5,
    x2^2 + x2 * x3 + x2 * x4 + x2 * x5 + x3^2 + x3 * x4 + x3 * x5 + x4^2 + x4 * x5 + x5^2,
    x3^3 + x3 * (x4^2) + x3 * (x5^2) + x4^3 + x4 * (x3^2) + x5 * (x4^2) + x4 * (x5^2) + x5^3 + x5 * (x3^2) + x3 * x4 * x5,
    x4^4 + x4 * (x5^3) + x5^4 + x5 * (x4^3) + (x4^2) * (x5^2),
    x5^5 - 1
]
basis = expand.(groebner_basis(system))
# monomial order can change, returning different but still valid bases
@test_broken isequal(basis, truebasis)
@test Symbolics.is_groebner_basis(basis)

basis = expand.(groebner_basis(system, linalg=:deterministic))
@test_broken isequal(basis, truebasis)
@test Symbolics.is_groebner_basis(basis)

N = 45671930739135174346839766056203605080877915151
system = [
    x1 + x2 + x3 + x4,
    x1 * x2 + x1 * x3 + x1 * x4 + x2 * x3 + x2 * x4 + x3 * x4,
    x1 * x2 * x3 + x1 * x2 * x4 + x1 * x3 * x4 + x2 * x3 * x4,
    x1 * x2 * x3 * x4 + N
]
truebasis = [
    x1 + x2 + x3 + x4,
    x2^2 + x2 * x3 + x3^2 + x2 * x4 + x3 * x4 + x4^2,
    x3^3 + x3^2 * x4 + x3 * x4^2 + x4^3,
    x4^4 - N
]
basis = expand.(groebner_basis(system))
@test_broken isequal(expand.(basis), truebasis)
@test Symbolics.is_groebner_basis(basis)

# issues/1323
@variables t S(t) R(t)
sys = [-12 + 5S, 2 + 5R]
@test isequal(expand.(groebner_basis(sys, ordering=Lex(S, R))), [2//5 + R, -12//5 + S])
sys = [S^2 + 2*R^2 - 1, S*R - 1]
res = [(1//2) - (1//2)*(R^2) + R^4, S - R + (2//1)*(R^3)]
@test isequal(expand.(groebner_basis(sys, ordering=Lex(S, R))), res)

# Groebner does not yet work with constant ideals
@test_broken groebner_basis([1])

using Symbolics, Test
using Symbolics: Arr
#using SymbolicUtils: substitute

@testset "Symbolic CartesianIndex" begin
    @syms i::Int j::Int k::Int
    I = CartesianIndex(i, j, k)
    @test isequal(I[1], i)
    @test isequal(I[2], j)
    @test isequal(I[3], k)

    J = CartesianIndex(1, 2, 3) + I
    @test isequal(J[1], 1 + i)
    @test isequal(J[2], 2 + j)
    @test isequal(J[3], 3 + k)

    @test isequal(I + I, CartesianIndex(2i, 2j, 2k))
    @test isequal(I + CartesianIndex(1, 2, 3), CartesianIndex(i+1, j+2, k+3))
    @test isequal(CartesianIndex(1, 2, 3) + I, CartesianIndex(1+i, 2+j, 3+k))

    @test isequal(I - I, CartesianIndex(0, 0, 0))
    @test isequal(I - CartesianIndex(1, 2, 3), CartesianIndex(i-1, j-2, k-3))
    @test isequal(CartesianIndex(1, 2, 3) - I, CartesianIndex(1-i, 2-j, 3-k))

    @test isequal(2I, CartesianIndex(2i, 2j, 2k))

    A = rand(2, 4, 6)

    @test substitute(A[J], Dict(i=>1, j=>2, k=>3)) == A[2, 4, 6]

    II = substitute(I, Dict(i=>1, j=>2, k=>3))

    @test A[II] == A[1, 2, 3]
end

@testset "Num Index" begin
    a = rand(5)
    i = Num(1)
    a[i]
end

using Symbolics, Test
import Symbolics: VarDomainPairing
import DomainSets: Interval, Ball, infimum, supremum, radius, center

domain = Interval(0, 1)
@test infimum(domain) == 0
@test supremum(domain) == 1

ball = Ball()
@test radius(ball) == 1.0
@test center(ball) == [0.0,0.0,0.0]

ball = Ball(2.5, [1,2])
@test radius(ball) == 2.5
@test center(ball) == [1,2]

@syms t x
t in domain
domains = [t ∈ Interval(0.0,1.0),
           x ∈ Interval(0.0,1.0)]
@test domains[1] isa VarDomainPairing
@test domains[2] isa VarDomainPairing

@syms y z
@test ((x,y) ∈ Ball(2.0, [0,0])) isa VarDomainPairing
@test ((x,y,z) ∈ Ball(1.5, [1,2,3])) isa VarDomainPairing

# Test tuple gets converted to Interval
var_domain_pair = t ∈ (0,1)
@test var_domain_pair isa VarDomainPairing
@test var_domain_pair.domain isa Interval

# Other types
t = Symbolics.Num(:t)
@assert (t ∈ domain) isa VarDomainPairing
t = Symbolics.variable(:t)
@assert (t ∈ domain) isa VarDomainPairing

"""
$(TYPEDEF)

Represents a difference operator.

# Fields
$(FIELDS)

# Examples

```jldoctest
julia> using Symbolics

julia> @variables t;

julia> Δ = Difference(t; dt=0.01)
(::Difference) (generic function with 2 methods)
```
"""
struct Difference <: Operator
    """Fixed Difference"""
    t
    dt
    update::Bool
    Difference(t; dt, update=false) = new(value(t), dt, update)
end
(D::Difference)(t) = Term{symtype(t)}(D, [t])
(D::Difference)(t::Num) = Num(D(value(t)))
SymbolicUtils.promote_symtype(::Difference, t) = t
"""
$(SIGNATURES)

Represents a discrete update (shift) operator with the semantics
```
DiscreteUpdate(t; dt=0.01)(y) ~ y(t+dt)
```

# Examples

```jldoctest
julia> using Symbolics

julia> @variables t;

julia> U = DiscreteUpdate(t; dt=0.01)
(::Difference) (generic function with 2 methods)
```
"""
DiscreteUpdate(t; dt) = Difference(t; dt=dt, update=true)

Base.show(io::IO, D::Difference) = print(io, "Difference(", D.t, "; dt=", D.dt, ", update=", D.update, ")")

Base.:(==)(D1::Difference, D2::Difference) = isequal(D1.t, D2.t) && isequal(D1.dt, D2.dt) && isequal(D1.update, D2.update)
Base.hash(D::Difference, u::UInt) = hash(D.dt, hash(D.t, xor(u, 0x055640d6d952f101)))

Base.:^(D::Difference, n::Integer) = _repeat_apply(D, n)

"""
    hasdiff(O)

Returns true if the expression or equation `O` contains [`Difference`](@ref) terms (this include [`DiscreteUpdate`](@ref)).
"""
hasdiff(O) = recursive_hasoperator(Difference, O)

"""
Represents a linear ordinary differential equation of the form:

dⁿx/dtⁿ + pₙ(t)(dⁿ⁻¹x/dtⁿ⁻¹) + ... + p₂(t)(dx/dt) + p₁(t)x = q(t)

# Fields
- `x`: dependent variable
- `t`: independent variable
- `p`: coefficient functions of `t` ordered in increasing order (p₁, p₂, ...)
- `q`: right hand side function of `t`, without any `x`

# Examples
```jldoctest
julia> using Symbolics

julia> @variables x, t
2-element Vector{Num}:
 x
 t

julia> eq = SymbolicLinearODE(x, t, [1, 2, 3], 3exp(4t))
(Dt^3)x + (3)(Dt^2)x + (2)(Dt^1)x + (1)(Dt^0)x ~ 3exp(4t)
```
"""
struct SymbolicLinearODE
    x::Num
    t::Num
    p::AbstractArray
    q::Any
    C::Vector{Num}

    SymbolicLinearODE(x, t, p, q) = new(x, t, p, q, variables(:C, 1:length(p)))

    function SymbolicLinearODE(expr, x, t)
        if expr isa Equation
            expr = expr.lhs - expr.rhs
        end

        expr = expand(simplify(expr))

        @assert is_linear_ode(expr, x, t) "Equation must be linear in $x and $t"

        n = _get_der_order(expr, x, t)

        ys = variables(:𝓎, 1:n)
        A, b, islinear = linear_expansion(reduce_order(expr, x, t, ys), ys)

        p = expand.(simplify.(-A[end, 1:end]))
        q = expand(simplify(b[end]))

        new(x, t, p, q)
    end
end

function is_linear_ode(expr, x, t)
    Dt = Differential(t)
    ys = variables(:𝓎, 1:_get_der_order(expr, x, t))
    n = _get_der_order(expr, x, t)
    @assert n >= 1 "ODE must have at least one derivative"
    
    y_sub = Dict([[(Dt^i)(x) => ys[i+1] for i=0:n-1]; (Dt^n)(x) => variable(:𝒴)])
    expr = substitute_in_deriv(expr, y_sub)

    # isolate (Dt^n)(x)
    f = symbolic_linear_solve(expr, variable(:𝒴), check=false)

    # couldn't isolate
    if f === nothing
        return false
    end

    f = f[1]
    system = [ys[2:n]; f]

    A, b, islinear = linear_expansion(system, ys)
    return islinear && all(isempty.(get_variables.(A, x)))
end

Dt(eq::SymbolicLinearODE) = Differential(eq.t)
order(eq::SymbolicLinearODE) = length(eq.p)

"""Generates symbolic expression to represent `SymbolicLinearODE`"""
function get_expression(eq::SymbolicLinearODE)
    (Dt(eq)^order(eq))(eq.x) + sum([(eq.p[n]) * (Dt(eq)^(n - 1))(eq.x) for n in 1:length(eq.p)]) ~ eq.q
end

function Base.string(eq::SymbolicLinearODE)
    "(D$(eq.t)^$(order(eq)))$(eq.x) + " *
    join(
        ["($(eq.p[length(eq.p)-n]))(D$(eq.t)^$(length(eq.p)-n-1))$(eq.x)"
         for n in 0:(order(eq) - 1)],
        " + ") * " ~ $(eq.q)"
end

Base.print(io::IO, eq::SymbolicLinearODE) = print(io, string(eq))
Base.show(io::IO, eq::SymbolicLinearODE) = print(io, eq)
Base.isequal(eq1::SymbolicLinearODE, eq2::SymbolicLinearODE) =
    isequal(eq1.x, eq2.x) && isequal(eq1.t, eq2.t) &&
    isequal(eq1.p, eq2.p) && isequal(eq1.q, eq2.q)

"""Returns true if q(t) = 0 for linear ODE `eq`"""
is_homogeneous(eq::SymbolicLinearODE) = isempty(Symbolics.get_variables(eq.q))
"""Returns true if all coefficient functions p(t) of `eq` are constant"""
has_const_coeffs(eq::SymbolicLinearODE) = all(isempty.(Symbolics.get_variables.(eq.p)))
"""Returns homgeneous version of `eq` where q(t) = 0"""
to_homogeneous(eq::SymbolicLinearODE) = SymbolicLinearODE(eq.x, eq.t, eq.p, 0)

"""
Returns the characteristic polynomial p of `eq` (must have constant coefficients) in terms of variable `r`

p(D) = Dⁿ + aₙ₋₁Dⁿ⁻¹ + ... + a₁D + a₀I
"""
function characteristic_polynomial(eq::SymbolicLinearODE, r)
    poly = 0
    @assert has_const_coeffs(eq) "ODE must have constant coefficients to generate characteristic polynomial"
    p = [eq.p; 1] # add implied coefficient of 1 to highest order
    for i in eachindex(p)
        poly += p[i] * r^(i - 1)
    end

    return poly
end

"""
    symbolic_solve_ode(eq::SymbolicLinearODE)
Symbolically solve a linear ordinary differential equation

# Arguments
- eq: a `SymbolicLinearODE` to solve

# Returns
Symbolic solution to the ODE

# Supported Methods
- first-order integrating factor
- constant coefficient homogeneous solutions (can handle repeated and complex characteristic roots)
- exponential and resonant response formula particular solutions (for any linear combination of `exp`, `sin`, `cos`, or `exp` times `sin` or `cos` (e.g. `e^2t * cos(-t) + e^-3t + sin(5t))`)
- method of undetermined coefficients particular solutions
- linear combinations of above particular solutions

# Examples

```julia
julia> using Symbolics

julia> import SymPy

julia> @variables x, t
2-element Vector{Num}:
 x
 t

julia> symbolic_solve_ode(SymbolicLinearODE(x, t, [5/t], 7t))
(C₁ + t^7) / (t^5)

```

```jldoctest
julia> using Symbolics

julia> import Nemo

julia> @variables x, t
2-element Vector{Num}:
 x
 t

julia> symbolic_solve_ode(SymbolicLinearODE(x, t, [9, -6], 4exp(3t)))
C₁*exp((3//1)*t) + C₂*exp((3//1)*t)*t + (2//1)*exp(3t)*(t^2)

julia> symbolic_solve_ode(SymbolicLinearODE(x, t, [6, 5], 2exp(-t)*cos(t)))
C₁*exp((-2//1)*t) + C₂*exp((-3//1)*t) + (1//5)*cos(t)*exp(-t) + (3//5)*exp(-t)*sin(t)

julia> symbolic_solve_ode(SymbolicLinearODE(x, t, [-3, 2], 2t - 5))
(11//9) - (2//3)*t + C₁*exp(t) + C₂*exp((-3//1)*t)
```
"""
function symbolic_solve_ode(eq::SymbolicLinearODE)
    homogeneous_solutions = find_homogeneous_solutions(eq)
    
    if is_homogeneous(eq) && homogeneous_solutions !== nothing
        return homogeneous_solutions
    end
    
    particular_solution = find_particular_solution(eq)
    if homogeneous_solutions !== nothing && particular_solution !== nothing
        return homogeneous_solutions + particular_solution
    end
    
    if order(eq) == 1
        return integrating_factor_solve(eq)
    end
end

"""
    symbolic_solve_ode(expr::Equation, x, t)
Symbolically solve an ODE

# Arguments
- expr: a symbolic ODE
- x: dependent variable
- t: independent variable

# Supported Methods
- all methods of solving linear ODEs mentioned for `symbolic_solve_ode(eq::SymbolicLinearODE)`
- Clairaut's equation
- Bernoulli equations

# Examples

```jldoctest
julia> using Symbolics

julia> import Nemo

julia> @variables x, t
2-element Vector{Num}:
 x
 t

julia> Dt = Symbolics.Differential(t)
Differential(t, 1)

julia> Symbolics.symbolic_solve_ode(SymbolicLinearODE(x, t, [9, -6], 4exp(3t)))
C₁*exp((3//1)*t) + C₂*exp((3//1)*t)*t + (2//1)*exp(3t)*(t^2)

julia> Symbolics.symbolic_solve_ode(x ~ Dt(x)*t - ((Dt(x))^3), x, t)
C₁*t - (C₁^3)

julia> length(Symbolics.symbolic_solve_ode(SymbolicLinearODE(x, t, [-3, 2], 0)))
1
```
"""
function symbolic_solve_ode(expr::Equation, x, t)
    clairaut = solve_clairaut(expr, x, t)
    if clairaut !== nothing
        return clairaut
    end

    bernoulli = solve_bernoulli(expr, x, t)
    if bernoulli !== nothing
        return bernoulli
    end

    if is_linear_ode(expr, x, t)
        eq = SymbolicLinearODE(expr, x, t)
        return symbolic_solve_ode(eq)
    end
end

"""
Find homogeneous solutions of linear ODE `eq` with integration constants of `eq.C`

Currently only works for constant coefficient ODEs
"""
function find_homogeneous_solutions(eq::SymbolicLinearODE)
    if has_const_coeffs(eq)
        return const_coeff_solve(to_homogeneous(eq))
    end
end

"""
Find a particular solution to linear ODE `eq`

Currently works for any linear combination of exponentials, sin, cos, or an exponential times sin or cos (e.g. e^2t * cos(-t) + e^-3t + sin(5t))
"""
function find_particular_solution(eq::SymbolicLinearODE)
    # if q has multiple terms, find a particular solution for each and sum together
    terms = Symbolics.terms(eq.q)
    if length(terms) != 1
        solutions = find_particular_solution.(SymbolicLinearODE.(Ref(eq.x), Ref(eq.t), Ref(eq.p), terms))
        if any(s -> s === nothing, solutions)
            return nothing
        end
        return sum(solutions)
    end

    if has_const_coeffs(eq)
        rrf = resonant_response_formula(eq)
        if rrf !== nothing
            return rrf
        end
        rrf_trig = exp_trig_particular_solution(eq)
        if rrf_trig !== nothing
            return rrf_trig
        end
    end

    undetermined_coeff = method_of_undetermined_coefficients(eq)
    if undetermined_coeff !== nothing
        return undetermined_coeff
    end
end

"""
Returns homogeneous solutions to linear ODE `eq` with constant coefficients

xₕ(t) = C₁e^(r₁t) + C₂e^(r₂t) + ... + Cₙe^(rₙt)
"""
function const_coeff_solve(eq::SymbolicLinearODE)
    @variables 𝓇
    p = characteristic_polynomial(eq, 𝓇)
    roots = symbolic_solve(p, 𝓇, dropmultiplicity = false)
    roots = map(value, roots)
    # Handle complex + repeated roots
    solutions = exp.(roots * eq.t)
    for i in eachindex(solutions)[1:(end - 1)]
        j = i + 1

        if !isequal(imag(roots[i]), 0) && isequal(roots[i], conj(roots[j]))
            solutions[i] = exp(real(roots[i] * eq.t)) * cos(imag(roots[i] * eq.t))
            solutions[j] = exp(real(roots[i] * eq.t)) * sin(imag(roots[i] * eq.t))
        end

        while j <= length(solutions) && isequal(roots[i], roots[j])
            solutions[j] *= eq.t # multiply by t for each repetition
            j += 1
        end
    end

    solution = sum(eq.C .* solutions)
    if solution isa Complex && isequal(imag(solution), 0)
        solution = real(solution)
    end

    return solution
end

"""
Solve almost any first order ODE using an integrating factor. Requires SymPy!
"""
function integrating_factor_solve(eq::SymbolicLinearODE)
    p = eq.p[1] # only p
    v = 0 # integrating factor
    if isempty(Symbolics.get_variables(p))
        v = exp(p * eq.t)
    else
        v = exp(sympy_integrate(p, eq.t))
    end
    solution = (1 / v) * ((SymbolicUtils._iszero(eq.q) ? 0 : sympy_integrate(eq.q * v, eq.t)) + eq.C[1])

    # When SymPy cannot find a closed form it returns an unevaluated `Integral(...)`,
    # which has no usable symbolic solution. That term comes back as an operation
    # (not a variable), so the previous `get_variables(:Integral)` check never fired
    # and the unevaluated integral was silently mangled into a wrong answer by the
    # `sympy_simplify` below. Detect it on the printed form and bail out instead.
    if occursin("Integral", string(solution))
        return nothing
    end
    return expand(Symbolics.sympy_simplify(solution))
end

"""
Returns a, r from q(t)=a*e^(rt) if it is of that form. If not, returns `nothing`
"""
function get_rrf_coeff(q, t)
    facs = factors(q)

    # handle complex r
    # very convoluted, could probably be improved (possibly by making heavier use of @rule)

    # Description of process:
    # only one factor of c*e^((a + bi)t) -> c*cos(bt)e^at + i*c*sin(bt)e^(at)
    # real(factor) / imag(factor) = cos(bt)/sin(bt) - can extract imaginary part b from this
    # then, divide real(factor) = c*cos(bt)e^at by cos(bt) to get c*e^at
    # call self to get c and a, then add back in b
    get_b = Symbolics.Chain([
        (@rule cos(t) / sin(t) => 1), (@rule cos(~b * t) / sin(~b * t) => ~b)])
    if length(facs) == 1 && !isequal(imag(facs[1]), 0) &&
       !isequal(get_b(real(facs[1]) / imag(facs[1])), real(facs[1]) / imag(facs[1]))
        r_im = get_b(real(facs[1]) / imag(facs[1]))
        real_q = real(facs[1]) / cos(r_im * t)
        if isempty(Symbolics.get_variables(real_q, [t]))
            return real_q, r_im * im
        end
        a, r_re = get_rrf_coeff(real(facs[1]) / cos(r_im * t), t)
        return a, r_re + r_im * im
    end

    a = prod([1; filter(fac -> isempty(Symbolics.get_variables(fac, [t])), facs)])

    not_a = filter(fac -> !isempty(Symbolics.get_variables(fac, [t])), facs) # should just be e^(rt)
    if length(not_a) != 1
        return nothing
    end

    der = expand_derivatives(Differential(t)(not_a[1]))
    r = simplify(der / not_a[1])
    if !isempty(Symbolics.get_variables(r, [t]))
        return nothing
    end

    return a, r
end

"""
For finding particular solution when q(t) = a*e^(rt)*cos(bt) (or sin(bt))
"""
function exp_trig_particular_solution(eq::SymbolicLinearODE)
    facs = _true_factors(eq.q)

    a = prod([1; filter(fac -> isempty(Symbolics.get_variables(fac, [eq.t])), facs)])

    not_a = filter(fac -> !isempty(Symbolics.get_variables(fac, [eq.t])), facs)

    r = nothing
    b = nothing
    is_sin = false

    if length(not_a) == 1 && _parse_trig(not_a[1], eq.t) !== nothing
        r = 0
        b, is_sin = _parse_trig(not_a[1], eq.t)
    elseif length(not_a) != 2
        return nothing
    elseif get_rrf_coeff(not_a[1], eq.t) !== nothing &&
           _parse_trig(not_a[2], eq.t) !== nothing
        r = get_rrf_coeff(not_a[1], eq.t)[2]
        b, is_sin = _parse_trig(not_a[2], eq.t)
    elseif get_rrf_coeff(not_a[2], eq.t) !== nothing &&
           _parse_trig(not_a[1], eq.t) !== nothing
        r = get_rrf_coeff(not_a[2], eq.t)[2]
        b, is_sin = _parse_trig(not_a[1], eq.t)
    else
        return nothing
    end

    # do complex rrf
    # figure out how many times p needs to be differentiated before denominator isn't 0
    k = 0
    @variables 𝓈
    p = characteristic_polynomial(eq, 𝓈)
    Ds = Differential(𝓈)
    while SymbolicUtils._iszero(substitute_in_deriv(expand_derivatives((Ds^k)(p)), Dict(𝓈 => r+b*im)))
        k += 1
    end

    rrf = expand(simplify(wrap(a) * exp((r + b * im) * eq.t) * eq.t^k /
                           (substitute_in_deriv(expand_derivatives((Ds^k)(p)), Dict(𝓈 => r+b*im)))))

    return is_sin ? imag(rrf) : real(rrf)
end

"""
Returns a particular solution to a constant coefficient ODE with q(t) = a*e^(rt)

Exponential Response Formula: x_p(t) = a*e^(rt)/p(r) where p(r) is characteristic polynomial

Resonant Response Formula: If r is a characteristic root, multiply by t and take the derivative of p (possibly multiple times)
"""
function resonant_response_formula(eq::SymbolicLinearODE)
    @assert has_const_coeffs(eq)

    # get a and r from q = a*e^(rt)
    rrf_coeff = get_rrf_coeff(eq.q, eq.t)
    if rrf_coeff === nothing
        return nothing
    end
    a, r = rrf_coeff

    # figure out how many times p needs to be differentiated before denominator isn't 0
    k = 0
    @variables 𝓈
    p = characteristic_polynomial(eq, 𝓈)
    Ds = Differential(𝓈)
    while SymbolicUtils._iszero(substitute_in_deriv(expand_derivatives((Ds^k)(p)), Dict(𝓈 => r)))
        k += 1
    end

    return expand(simplify(a * exp(r * eq.t) * eq.t^k /
                           (substitute_in_deriv(expand_derivatives((Ds^k)(p)), Dict(𝓈 => r)))))
end

function method_of_undetermined_coefficients(eq::SymbolicLinearODE)
    # constant
    p = eq.p[1]
    if isempty(Symbolics.get_variables(p, eq.t)) && isempty(Symbolics.get_variables(eq.q, eq.t))
        return eq.q / p
    end

    # polynomial
    degree = max(Symbolics.degree(eq.q, eq.t), Symbolics.degree.(eq.p, eq.t)...) # just a starting point
    a = Symbolics.variables(:𝒶, 1:degree+1)
    form = sum(a[n]*eq.t^(n-1) for n = 1:degree+1)
    eq_subbed = substitute_in_deriv(get_expression(eq), Dict(eq.x => form))
    eq_subbed = eq_subbed.lhs - eq_subbed.rhs
    eq_subbed = expand_derivatives(eq_subbed)
    
    try
        coeff_solution = solve_interms_ofvar(eq_subbed, eq.t)
    catch
        coeff_solution = nothing
    end
    
    if degree > 0 && coeff_solution !== nothing && !isempty(coeff_solution) && SymbolicUtils._iszero(expand(substitute_in_deriv(eq_subbed, coeff_solution[1])))
        return substitute_in_deriv(form, coeff_solution[1])
    end

    # exponential
    coeff = get_rrf_coeff(eq.q, eq.t)
    if coeff !== nothing
        a_form = form # use form from polynomial case

        r = coeff[2]
        form = a_form*exp(r*eq.t)
        eq_subbed = substitute_in_deriv(get_expression(eq), Dict(eq.x => form))
        eq_subbed = expand_derivatives(eq_subbed)
        eq_subbed = simplify(expand((eq_subbed.lhs - eq_subbed.rhs) / exp(r*eq.t)))
        coeff_solution = solve_interms_ofvar(eq_subbed, eq.t)
        
        if coeff_solution !== nothing && !isempty(coeff_solution)
            return substitute_in_deriv(form, coeff_solution[1])
        end
    end

    # sin and cos
    # this is a hacky way of doing things
    @variables 𝒶, 𝒷
    @variables 𝒸𝓈, 𝓈𝓃
    parsed = _parse_trig(_true_factors(eq.q)[end], eq.t)
    if parsed !== nothing
        ω = parsed[1]
        form = 𝒶*cos(ω*eq.t) + 𝒷*sin(ω*eq.t)
        eq_subbed = substitute_in_deriv(get_expression(eq), Dict(eq.x => form))
        eq_subbed = expand_derivatives(eq_subbed)
        eq_subbed = expand(substitute_in_deriv(eq_subbed.lhs - eq_subbed.rhs, Dict(cos(ω*eq.t)=>𝒸𝓈, sin(ω*eq.t)=>𝓈𝓃)))
        cos_eq = simplify(sum(filter(term -> !isempty(Symbolics.get_variables(term, 𝒸𝓈)), terms(eq_subbed)))/𝒸𝓈)
        sin_eq = simplify(sum(filter(term -> !isempty(Symbolics.get_variables(term, 𝓈𝓃)), terms(eq_subbed)))/𝓈𝓃)
        if !isempty(Symbolics.get_variables(cos_eq, [eq.t,𝓈𝓃,𝒸𝓈])) || !isempty(Symbolics.get_variables(sin_eq, [eq.t,𝓈𝓃,𝒸𝓈]))
            coeff_solution = nothing
        else
            coeff_solution = symbolic_solve([cos_eq, sin_eq], [𝒶,𝒷])
        end
        
        if coeff_solution !== nothing && !isempty(coeff_solution)
            return substitute_in_deriv(form, coeff_solution[1])
        end
    end
end

"""
Initial value problem (IVP) for a linear ODE
"""
struct IVP
    eq::SymbolicLinearODE
    initial_conditions::Vector{Num} # values at t = 0 of nth derivative of x

    function IVP(eq::SymbolicLinearODE, initial_conditions::Vector{<:Number})
        @assert length(initial_conditions) == order(eq) "# of Initial conditions must match order of ODE"
        new(eq, initial_conditions)
    end
end

function solve_symbolic_IVP(ivp::IVP)
    general_solution = symbolic_solve_ode(ivp.eq)
    if general_solution === nothing
        return nothing
    end

    eqs = []
    for i in eachindex(ivp.initial_conditions)
        eq::Num = expand_derivatives((Dt(ivp.eq)^(i-1))(general_solution)) - ivp.initial_conditions[i]

        eq = substitute_in_deriv(eq, Dict(ivp.eq.t => 0), fold=Val(false))
        
        # make sure exp, sin, and cos don't evaluate to floats
        exp0 = substitute_in_deriv(exp(ivp.eq.t), Dict(ivp.eq.t => 0), fold=Val(false))
        sin0 = substitute_in_deriv(sin(ivp.eq.t), Dict(ivp.eq.t => 0), fold=Val(false))
        cos0 = substitute_in_deriv(cos(ivp.eq.t), Dict(ivp.eq.t => 0), fold=Val(false))

        eq = expand(simplify(substitute_in_deriv(eq, Dict(exp0 => 1, sin0 => 0, cos0 => 1), fold=Val(false))))
        push!(eqs, eq)
    end

    return expand(simplify(substitute_in_deriv(general_solution, symbolic_solve(eqs, ivp.eq.C)[1])))
end

"""
    solve_symbolic_IVP(eq::SymbolicLinearODE, initial_conditions::Vector{<:Number})

Solve an initial value problem for a linear ODE with given initial conditions.

# Arguments
- `eq`: A `SymbolicLinearODE` to solve
- `initial_conditions`: Vector of initial conditions for x(0), x'(0), x''(0), etc.

# Returns
Symbolic solution satisfying the initial conditions

# Examples
```jldoctest
julia> using Symbolics

julia> @variables x, t
2-element Vector{Num}:
 x
 t

julia> eq = SymbolicLinearODE(x, t, [-3, 2], 0)  # d²x/dt² + 2dx/dt - 3x = 0
(Dt^2)x + (2)(Dt^1)x + (-3)(Dt^0)x ~ 0

julia> solve_symbolic_IVP(eq, [1, -1])  # x(0) = 1, x'(0) = -1
(1//2)*exp(t) + (1//2)*exp((-3//1)*t)
```
"""
function solve_symbolic_IVP(eq::SymbolicLinearODE, initial_conditions::Vector{<:Number})
    return solve_symbolic_IVP(IVP(eq, initial_conditions))
end

"""
Solve Clairaut's equation of the form x = x'*t + f(x').

Returns solution of the form x = C*t + f(C) where C is a constant.
"""
function solve_clairaut(expr, x, t)
    Dt = Differential(t)
    rhs = 0
    if isequal(expr.rhs, x)
        rhs = expr.lhs
    elseif isequal(expr.lhs, x)
        rhs = expr.rhs
    else
        return nothing
    end

    terms = Symbolics.terms(rhs)
    matched = false # if expr contains term Dt(x)*t
    f = 0
    for term in terms
        if isequal(term, Dt(x)*t)
            matched = true
        elseif !isempty(Symbolics.get_variables(term, [t]))
            return nothing
        else
            f += term
        end
    end

    if !matched
        return nothing
    end

    C = Symbolics.variable(:C, 1) # constant of integration
    f = substitute_in_deriv(f, Dict(Dt(x) => C))
    if !isempty(Symbolics.get_variables(f, [x]))
        return nothing
    end

    return C*t + f
end

"""
Linearize a Bernoulli equation of the form dx/dt + p(t)x = q(t)x^n into a `SymbolicLinearODE` of the form dv/dt + (1-n)p(t)v = (1-n)q(t) where v = x^(1-n)
"""
function linearize_bernoulli(expr, x, t, v)
    Dt = Differential(t)

    if expr isa Equation
        expr = expr.lhs - expr.rhs
    end

    terms = Symbolics.terms(expr)

    p = 0
    q = 0
    n = 0
    leading_coeff = 1
    for term in terms
        if Symbolics.hasderiv(Symbolics.value(term))
            facs = _true_factors(term)
            leading_coeff = prod([1; filter(fac -> !Symbolics.hasderiv(Symbolics.value(fac)), facs)])
            if !isequal(term/leading_coeff, Dt(x))
                return nothing
            end
        elseif !isempty(Symbolics.get_variables(term, [x]))
            facs = _true_factors(term)
            x_fac = filter(fac -> !isempty(Symbolics.get_variables(fac, [x])), facs)
            if length(x_fac) != 1
                return nothing
            end

            if isequal(x_fac[1], x)
                p = prod([1; filter(fac -> isempty(Symbolics.get_variables(fac, [x])), facs)])
            else
                n = degree(x_fac[1])
                q = -prod([1; filter(fac -> isempty(Symbolics.get_variables(fac, [x])), facs)])
            end
        end
    end
    
    p /= leading_coeff
    if q isa Union{Num, BasicSymbolic{VartypeT}}
        q /= leading_coeff
    else
        q /= leading_coeff
    end
    
    return SymbolicLinearODE(v, t, [p*(1-n)], q*(1-n)), n
end

"""
Solve Bernoulli equations of the form dx/dt + p(t)x = q(t)x^n. May require SymPy to solve using integrating factor
"""
function solve_bernoulli(expr, x, t)
    @variables 𝓋
    linearized = linearize_bernoulli(expr, x, t, 𝓋)
    if linearized === nothing
        return nothing
    end

    eq, n = linearized

    solution = symbolic_solve_ode(eq)
    if solution === nothing
        return nothing
    end

    return simplify(solution^(1//(1-n)))
end

"""
Solve Bernoulli equations of the form dx/dt + p(t)x = q(t)x^n with initial condition x(0) = x0
"""
function solve_bernoulli(expr, x, t, x0)
    @variables v
    eq, n = linearize_bernoulli(expr, x, t, v)

    v0 = x0^(1-n) # convert initial condition from x(0) to v(0)

    ivp = IVP(eq, [v0])
    solution = solve_IVP(ivp)
    if solution === nothing
        return nothing
    end

    return symbolic_solve(solution ~ x^(1-n), x)
end

using Symbolics
using Test

using Random

@variables x y z

@testset "simple expressions" begin
    d, r = semipolynomial_form(x, [x], 1)
    @test d == Dict(x => 1)
    @test r == 0

    d, r = semipolynomial_form(x + sin(x) + 1 + y, [x], 1)
    @test isequal(d, Dict(1 => 1 + y, x => 1))
    @test isequal(r, sin(x))

    d, r = semipolynomial_form(x^2 + 1 + y, [x], 1)
    @test isequal(d, Dict(1 => 1 + y))
    @test isequal(r, x^2)

    d, r = semipolynomial_form((x + 2)^12, [x], 1)
    @test isequal(d, Dict(1 => 1 << 12, x => (1 << 11) * 12))
end

@testset "maintain SymbolicUtils.Symbolic subtype" begin
    pow_expr = 7^(3y + sin(y))
    @test SymbolicUtils.ispow(Symbolics.unwrap(pow_expr))
    dict, nl = semipolynomial_form(pow_expr, [y], Inf)
    @test isempty(dict)
    # expect a SymbolicUtils.Pow object instead of SymbolicUtils.Term with f = ^
    @test isequal(nl, pow_expr)
    @test SymbolicUtils.ispow(nl)

    mul_expr = 9 * 7^y * sin(x)^4 * tan(x + y)^3
    @test SymbolicUtils.ismul(Symbolics.unwrap(mul_expr))
    dict, nl = semipolynomial_form(mul_expr, [x, y], Inf)
    @test isempty(dict)
    # expect a SymbolicUtils.Mul object instead of SymbolicUtils.Term with f = *
    @test isequal(nl, mul_expr)
    @test SymbolicUtils.ismul(nl)

    div_expr = x / y
    @test SymbolicUtils.isdiv(Symbolics.unwrap(div_expr))
    dict, nl = semipolynomial_form(div_expr, [x, y], Inf)
    @test isempty(dict)
    # expect a SymbolicUtils.Div object instead of SymbolicUtils.Term with f = /
    @test isequal(nl, div_expr)
    @test SymbolicUtils.isdiv(nl)
    dict, nl = semipolynomial_form(div_expr, [x], Inf)
    @test isequal(dict, Dict(x => 1 / y))
    @test iszero(nl)
    dict, nl = semipolynomial_form(div_expr, [y], Inf)
    @test isempty(dict)
    @test isequal(nl, div_expr)
end

@testset "negative exponent" begin
    # `SymbolicUtils.Pow` object with a negative exponent normally cannot be created.
    # For example, `x^-1` returns `1 / x` which is a `SymbolicUtils.Div`.
    # But `expand_derivatives` may result in a `SymbolicUtils.Pow` with a negative exponent.
    sqrt_x = sqrt(x)
    deriv = expand_derivatives(Differential(x)(sqrt_x)) # (1//2)*(sqrt(x)^-1)
    expr = substitute(deriv, Dict(sqrt_x => y)) # (1//2)*(y^-1)
    d, r = semipolynomial_form(expr, [x, y], Inf)
    @test isempty(d)
end

@testset "negative input degree" begin
    @test_logs (:warn,) semipolynomial_form(x, [x], -1.2)
    @test_logs (:warn,) semipolynomial_form(x, [x], -10)
    @test_logs (:warn,) semipolynomial_form(x, [x], -Inf)
    @test_logs (:warn,) semipolynomial_form(x, [], -1 // 2)
end

@testset "(x + y)*(y^-1)" begin
    sqrt_x = sqrt(x)
    Dx = Differential(x)
    deriv = expand_derivatives(Dx(sqrt_x)) # (1//2)*(sqrt(x)^-1)
    expr = substitute(deriv, Dict(sqrt_x => y)) # (1//2)*(y^-1)
    y_1 = expr * 2 # y^-1
    expr = y_1 * (x + y) # (x + y)*(y^-1)

    d, r = semipolynomial_form(expr, [x, y], Inf)
    @test isequal(d, Dict(1 => 1))
    @test isequal(r, x / y)

    d, r = semipolynomial_form(expr, [x, y], 0)
    @test isequal(d, Dict(1 => 1))
    @test isequal(r, x / y)

    d, r = semipolynomial_form(expr, [x, y], 0.3)
    @test isequal(d, Dict(1 => 1))
    @test isequal(r, x / y)

    d, r = semipolynomial_form(expr, [x, y], 1 // 2)
    @test isequal(d, Dict(1 => 1))
    @test isequal(r, x / y)

    d, r = semipolynomial_form(expr, [x], 1)
    @test isequal(d, Dict(1 => 1, x => 1 / y)) || isequal(d, Dict(1 => 1, x => y_1))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [x], 1 // 1)
    @test isequal(d, Dict(1 => 1, x => 1 / y)) || isequal(d, Dict(1 => 1, x => y_1))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [x], Int32(1))
    @test isequal(d, Dict(1 => 1, x => 1 / y)) || isequal(d, Dict(1 => 1, x => y_1))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [x], 1.0)
    @test isequal(d, Dict(1 => 1, x => 1 / y)) || isequal(d, Dict(1 => 1, x => y_1))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [x], Float32(1.0))
    @test isequal(d, Dict(1 => 1, x => 1 / y)) || isequal(d, Dict(1 => 1, x => y_1))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [x], 1.5)
    @test isequal(d, Dict(1 => 1, x => 1 / y)) || isequal(d, Dict(1 => 1, x => y_1))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [x], 0.9)
    @test isequal(d, Dict(1 => 1))
    @test isequal(r, x / y) || isequal(r, x * y_1)

    d, r = semipolynomial_form(expr, [x], 99 // 100)
    @test isequal(d, Dict(1 => 1))
    @test isequal(r, x / y) || isequal(r, x * y_1)

    d, r = semipolynomial_form(expr, [], 0.9)
    @test isequal(d, Dict(1 => 1 + x / y)) || isequal(d, Dict(1 => 1 + x * y_1))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [], 0)
    @test isequal(d, Dict(1 => 1 + x / y)) || isequal(d, Dict(1 => 1 + x * y_1))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [], 0.0)
    @test isequal(d, Dict(1 => 1 + x / y)) || isequal(d, Dict(1 => 1 + x * y_1))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [], 0 // 1)
    @test isequal(d, Dict(1 => 1 + x / y)) || isequal(d, Dict(1 => 1 + x * y_1))
    @test iszero(r)
end

# 682
@testset "(y^-1)*(x^4 + y^4)" begin
    sqrt_x = sqrt(x)
    Dx = Differential(x)
    deriv = expand_derivatives(Dx(sqrt_x)) # (1//2)*(sqrt(x)^-1)
    expr = substitute(deriv, Dict(sqrt_x => y)) # (1//2)*(y^-1)
    y_1 = expr * 2 # y^-1
    expr = y_1 * (x^4 + y^4) # (y^-1)*(x^4 + y^4)

    d, r = semipolynomial_form(expr, [x, y], 2)
    @test isempty(d)
    @test isequal(r, y_1 * x^4 + y^3) || isequal(r, x^4 / y + y^3)

    d, r = semipolynomial_form(expr, [x, y], 3)
    @test isequal(d, Dict(y^3 => 1))
    @test isequal(r, y_1 * x^4) || isequal(r, x^4 / y)

    d, r = semipolynomial_form(expr, [x, y], 4)
    @test isequal(d, Dict(y^3 => 1))
    @test isequal(r, y_1 * x^4) || isequal(r, x^4 / y)

    d, r = semipolynomial_form(expr, [x], 2)
    @test isequal(d, Dict(1 => y^3))
    @test isequal(r, y_1 * x^4) || isequal(r, x^4 / y)

    d, r = semipolynomial_form(expr, [x], 3)
    @test isequal(d, Dict(1 => y^3))
    @test isequal(r, y_1 * x^4) || isequal(r, x^4 / y)

    d, r = semipolynomial_form(expr, [x], 4)
    @test isequal(d, Dict(1 => y^3, x^4 => y_1))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [y], 2)
    @test isempty(d)
    @test isequal(r, y_1 * x^4 + y^3) || isequal(r, x^4 / y + y^3)

    d, r = semipolynomial_form(expr, [y], 3)
    @test isequal(d, Dict(y^3 => 1))
    @test isequal(r, y_1 * x^4) || isequal(r, x^4 / y)

    d, r = semipolynomial_form(expr, [y], 4)
    @test isequal(d, Dict(y^3 => 1))
    @test isequal(r, y_1 * x^4) || isequal(r, x^4 / y)

    d, r = semipolynomial_form(expr, [], 0)
    @test isequal(d, Dict(1 => y_1 * x^4 + y^3)) || isequal(d, Dict(1 => x^4 / y + y^3))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [], 2)
    @test isequal(d, Dict(1 => y_1 * x^4 + y^3)) || isequal(d, Dict(1 => x^4 / y + y^3))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [], 3)
    @test isequal(d, Dict(1 => y_1 * x^4 + y^3)) || isequal(d, Dict(1 => x^4 / y + y^3))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [], 4)
    @test isequal(d, Dict(1 => y_1 * x^4 + y^3)) || isequal(d, Dict(1 => x^4 / y + y^3))
    @test iszero(r)
end

@testset "nested ^ exponentiation" begin
    expr = ((x + 1)^4 + x)^3
    d, r = semipolynomial_form(expr, [x], 2)

    @test isequal(d, Dict(1 => 1, x => 15, x^2 => 93))
    @test isequal(r, 317x^3 + 681x^4 + 1014x^5 + 1095x^6 + 876x^7 + 519x^8 + 223x^9
                     + 66x^10 + 12x^11 + x^12)
end

@testset "rational exponent" begin
    expr = y^(1//1)

    d, r = semipolynomial_form(expr, [x], 0)
    @test isequal(d, Dict(1 => y))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [x], 1)
    @test isequal(d, Dict(1 => y))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [y], 0)
    @test isempty(d)
    @test isequal(r, y)

    d, r = semipolynomial_form(expr, [y], 1)
    @test isequal(d, Dict(y => 1))
    @test iszero(r)

    expr = (x^(4//3) + y^(5//2))^3

    d, r = semipolynomial_form(expr, [x, y], 0)
    @test isempty(d)
    @test isequal(r, x^4 + 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2))

    d, r = semipolynomial_form(expr, [x, y], 1)
    @test isempty(d)
    @test isequal(r, x^4 + 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2))

    d, r = semipolynomial_form(expr, [x, y], 2)
    @test isempty(d)
    @test isequal(r, x^4 + 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2))

    d, r = semipolynomial_form(expr, [x, y], 3)
    @test isempty(d)
    @test isequal(r, x^4 + 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2))

    d, r = semipolynomial_form(expr, [x, y], 4)
    @test isequal(d, Dict(x^4 => 1))
    @test isequal(r, 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2))

    d, r = semipolynomial_form(expr, [x, y], 5)
    @test isequal(d, Dict(x^4 => 1))
    @test isequal(r, 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2))

    d, r = semipolynomial_form(expr, [x, y], 6)
    @test isequal(d, Dict(x^4 => 1))
    @test isequal(r, 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2))

    d, r = semipolynomial_form(expr, [y], 3)
    @test isequal(d, Dict(1 => x^4))
    @test isequal(r, 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2))

    d, r = semipolynomial_form(expr, [y], 4)
    @test isequal(d, Dict(1 => x^4))
    @test isequal(r, 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2))

    d, r = semipolynomial_form(expr, [y], 5)
    @test isequal(d, Dict(1 => x^4, y^5 => 3x^(4//3)))
    @test isequal(r, 3x^(8//3) * y^(5//2) + y^(15//2))

    d, r = semipolynomial_form(expr, [y], 6)
    @test isequal(d, Dict(1 => x^4, y^5 => 3x^(4//3)))
    @test isequal(r, 3x^(8//3) * y^(5//2) + y^(15//2))

    d, r = semipolynomial_form(expr, [x], 3)
    @test isequal(d, Dict(1 => y^(15//2)))
    @test isequal(r, x^4 + 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5)

    d, r = semipolynomial_form(expr, [x], 4)
    @test isequal(d, Dict(1 => y^(15//2), x^4 => 1))
    @test isequal(r, 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5)

    d, r = semipolynomial_form(expr, [x], 5)
    @test isequal(d, Dict(1 => y^(15//2), x^4 => 1))
    @test isequal(r, 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5)

    d, r = semipolynomial_form(expr, [x], 6)
    @test isequal(d, Dict(1 => y^(15//2), x^4 => 1))
    @test isequal(r, 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5)

    d, r = semipolynomial_form(expr, [], 0)
    @test isequal(d, Dict(1 => x^4 + 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2)))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [], 1)
    @test isequal(d, Dict(1 => x^4 + 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2)))
    @test iszero(r)

    d, r = semipolynomial_form(expr, [], 2)
    @test isequal(d, Dict(1 => x^4 + 3x^(8//3) * y^(5//2) + 3x^(4//3) * y^5 + y^(15//2)))
    @test iszero(r)

    expr = (x + y)^(1//2)

    d, r = semipolynomial_form(expr, [x, y], 2)
    @test isempty(d)
    @test isequal(r, expr)
end

@testset "floating-point exponent" begin
    expr = (x^0.5 + y)^2

    d, r = semipolynomial_form(expr, [x, y], 0)
    @test isempty(d)
    @test isequal(r, x + 2x^0.5 * y + y^2)

    d, r = semipolynomial_form(expr, [x, y], 1)
    @test isequal(d, Dict(x => 1))
    @test isequal(r, 2x^0.5 * y + y^2)

    d, r = semipolynomial_form(expr, [x, y], 2)
    @test isequal(d, Dict(x => 1, y^2 => 1))
    @test isequal(r, 2x^0.5 * y)

    d, r = semipolynomial_form(expr, [x, y], 3)
    @test isequal(d, Dict(x => 1, y^2 => 1))
    @test isequal(r, 2x^0.5 * y)

    # 680
    expr = (x^(1//2) + y^0.5)^2
    d, r = semipolynomial_form(expr, [x, y], 4)
    @test isequal(d, Dict(x => 1, y => 1))
    @test isequal(r, 2x^(1//2) * y^(1//2))

    expr = (3x^4 + y)^0.5

    for degree in [0, 1, 2]
        d, r = semipolynomial_form(expr, [x, y], degree)
        @test isempty(d)
        @test isequal(r, expr)
    end
end

# SymbolicUtils.simplify_fractions takes a bit long time at the time of writing this code,
# so semipolyform_terms does not do fraction simplification.
# but this may be changed later.
@testset "unsimplified fraction" begin
    expr = (x^2 - 1) / (x - 1)
    d, r = semipolynomial_form(expr, [x, y], Inf)
    @test isempty(d)
    @test isequal(r, expr)
end

@testset "semilinear" begin
    # 657
    @test iszero(semilinear_form([x * cos(x) + x^2 * 3sin(x) + 4exp(x)], [x])[1])

    exprs = [3x + tan(z),
             y / z + 5z,
             x * y + y * z / x]
    A , c = semilinear_form(exprs, [x, y, z])
    @test A[1, 1] == 3
    @test A[1, 2] == 0
    @test A[1, 3] == 0
    @test A[2, 1] == 0
    @test A[2, 2] == 0
    @test A[2, 3] == 5
    @test A[3, 1] == 0
    @test A[3, 2] == 0
    @test A[3, 3] == 0
    @test isequal(c, [tan(z), y / z, x * y + y * z / x])
end

@testset "expr = 0" begin
    d, r = semipolynomial_form(0, [], Inf)
    @test isempty(d)
    @test iszero(r)

    d, r = semipolynomial_form(0//1, [], Inf)
    @test isempty(d)
    @test iszero(r)

    d, r = semipolynomial_form(0.0, [], Inf)
    @test isempty(d)
    @test iszero(r)
end

@testset "sqrt" begin
    expr = sqrt(x)

    d, r = semipolynomial_form(expr, [x], Inf)
    @test isempty(d)
    @test isequal(r, x^(1//2))

    expr = sqrt(x)^2

    d, r = semipolynomial_form(expr, [x], Inf)
    @test isequal(d, Dict(x => 1))
    @test iszero(r)

    expr = (sqrt(x) + sqrt(y))^2

    d, r = semipolynomial_form(expr, [x, y], Inf)
    @test isequal(d, Dict(x => 1, y => 1))
    @test isequal(r, 2x^(1//2) * y^(1//2))

    d, r = semipolynomial_form(expr, [x], Inf)
    @test isequal(d, Dict(x => 1, 1 => y))
    @test isequal(r, 2x^(1//2) * y^(1//2))

    d, r = semipolynomial_form(expr, [], Inf)
    @test isequal(d, Dict(1 => x + y + 2x^(1//2) * y^(1//2)))
    @test iszero(r)
end

@syms a b c

const components = [2, a, b, c, x, y, z, (1+x), (1+y)^2, z*y, z*x]

function verify(t::Symbolics.BasicSymbolic{Number}, d, wrt, nl)
    verify(Num(t), d, wrt, nl)
end

function verify(t, d, wrt, nl)
    try
        iszero(t - (isempty(d) ? nl : sum(k*v for (k, v) in d) + nl))
    catch err
        println("""Error verifying semi-pf result for $t
                 wrt = $wrt
                 d = $d
                 nl = $nl""")
        rethrow(err)
    end
end

seed = 0

function trial()
    global seed += 1
    Random.seed!(666+seed)
    n = rand(2:length(components)-1)
    l, r = rand(components, n), vcat(rand(components, n), [1, 0, 1//2, 1.5])

    t = *(map(1:rand(1:3)) do _
        pow = rand([1,1,1,1,1,1,1,1,2,3])
        nterms = rand(2:5)
        sum(rand(l, nterms) .* rand(r, nterms)) ^ pow
    end...)

    @show t

    for _ = 1:4
        wrt = unique(rand([a,b,c,x,y,z], rand(1:6)))
        for deg=Any[1,2,3,4,Inf]
            if deg == 1
                A, c = semilinear_form([t], wrt)
                res = iszero(A*wrt + c - [t])
                if !res
                    println("Semi-linear form is wrong: [$t]  w.r.t   $wrt ")
                    @show A c
                end
            elseif deg == 2
                A,B,v2, c = semiquadratic_form([t], wrt)
                res = iszero(A * wrt + B * v2 + c - [t])
                if !res
                    println("Semi-quadratic form is wrong: $t  w.r.t   $wrt")
                    @show A B v2 c
                end
            else
                if isfinite(deg)
                    d, nl = semipolynomial_form(t, wrt, deg)
                    @test all(x->Symbolics.pdegree(x) <= deg, keys(d))
                    for x in wrt
                        d2, enl = semipolynomial_form(expand(nl), wrt, Inf)
                        elim = all(x->Symbolics.pdegree(x)>deg, keys(d2))
                        if !elim
                            println("Imperfect elimination:")
                            @show t wrt deg nl expand(nl)
                        end
                        @test elim
                    end
                else
                    d, nl = polynomial_coeffs(t, wrt)
                end

                res = verify(t, d, wrt, nl)
                if !res
                    println("""Semi-poly form is wrong: $t  w.r.t   $wrt  deg=$deg
                            Result: $d + $nl""")
                end
            end

            @test res
        end
    end
end

for i=1:20
    @testset "fuzz semi-polynomial-form ($i/20)" begin
        trial()
    end
end

@testset "Extracted from fuzz testing" begin
    @test verify(2.25(2.0 + 2c)*(c^2), Dict{Any, Any}(c^3 => 4.5, c^2 => 4.5), Num[c, y, z], 0)
end

@testset "With array variables" begin
    @register_symbolic foo(x::AbstractArray)
    @variables t x(t)[1:3]
    expr = x[2] * 4 + 2x[1] + 2x[3] * x[1] + foo(x)
    mapping, resid = semipolynomial_form(expr, collect(x), 2)
    @test mapping[x[2]] == 4
    @test mapping[x[1]] == 2
    @test mapping[x[3] * x[1]] == 2
    @test isequal(resid, foo(x))

    expr = x[2] * 4 + 2x[1] + 2x[3] * x[1] + foo([x[1]])
    mapping, resid = semipolynomial_form(expr, collect(x), 2)
    @test mapping[x[2]] == 4
    @test mapping[x[1]] == 2
    @test mapping[x[3] * x[1]] == 2
    @test isequal(resid, foo([x[1]]))

    @variables x[1:4]
    expr = x[3] * x[4]
    mapping, resid = semipolynomial_form(expr, [x[3]], 2)
    @test isequal(mapping[x[3]], x[4])
    @test isequal(resid, 0)
end

# Fetch packages.
using Symbolics
using Symbolics.RewriteHelpers
using Test 

@variables t X(t) Y(t) Z(t)
@syms a b
D = Differential(t)
my_f(x, y) = x^3 + 2y

# Check `replacenode` function.
let
    # Simple replacements.
    @test isequal(replacenode(X + X + X, X =>1), 3)
    @test isequal(replacenode(X + X + X, Y => 1), 3X)
    res = replacenode(X + X + my_f(X, Z), X => Y)
    @test isequal(res, Y^3 + 2Y + 2Z)
    @test length(arguments(res)) == 3
    @test isequal(replacenode(X + Y^2 - Z, Y^2 => Z), X)

    # When the rule is a function.
    rep_func(expr) = Symbolics.is_derivative(expr) ? b : expr
    @test isequal(replacenode(D(X + Y) - log(a*Z), rep_func), b - log(a*Z))
    @test isequal(replacenode(D(Z^2) + my_f(D(X), D(Y)) + Z, rep_func), b^3 + 3b + Z)
    @test isequal(replacenode(X + sin(Y + a) + a, rep_func), X + sin(Y + a) + a)

    # On non-symbolic inputs.
    @test isequal(replacenode(1, X =>2.0), 1)
    @test isequal(replacenode(1, rep_func), 1)
end

# Test `hasnode` function.
let
    ex1 = 2X^a - log(b + my_f(Y,Y)) - 3
    ex2 = X^(Y^(Z-a)) +log(log(log(b)))
    ex3 = sin(X) + sin(Y) + a*a*a*(1-X)
    ex4 = exp(a)/(pi*a) + D(Y) + D(my_f(1,Z))
    ex5 = a + 5b^2
    
    # Test for variables.
    @test hasnode(X, ex1)
    @test hasnode(X, ex2)
    @test hasnode(X, ex3)
    @test !hasnode(X, ex4)
    @test hasnode(Y, ex1)
    @test hasnode(Y, ex2)
    @test hasnode(Y, ex3)
    @test hasnode(Y, ex4)
    @test !hasnode(Z, ex1)
    @test hasnode(Z, ex2)
    @test !hasnode(Z, ex3)
    @test hasnode(Z, ex4)
    
    # Test for variables.
    @test hasnode(a, ex1)
    @test hasnode(a, ex2)
    @test hasnode(a, ex3)
    @test hasnode(a, ex4)
    @test hasnode(a, ex5)
    @test hasnode(b, ex1)
    @test hasnode(b, ex2)
    @test !hasnode(b, ex3)
    @test !hasnode(b, ex4)
    @test hasnode(b, ex5)
    
    # Test for function.
    @test !hasnode(is_derivative, ex1)
    @test !hasnode(is_derivative, ex2)
    @test !hasnode(is_derivative, ex3)
    @test hasnode(is_derivative, ex4)

    # On non symbolic inputs:
    @test !hasnode(X, 1)
    @test !hasnode(a, 1)
    @test !hasnode(is_derivative, 1)

    # Array variables.
    @variables x(t)[1:2] y(t)[1:2, 1:2]
    @test hasnode(t, x)
    ex6 = D(x)
    @test hasnode(is_derivative, ex6)
    @test hasnode(x, ex6)
    ex7 = D(x) + log.(y*x)
    @test hasnode(is_derivative, ex7)
    @test hasnode(y, ex7)
    ex8 = log(a^b) + x[1]
    @test hasnode(a, ex8)
    @test hasnode(b, ex8)
end

# Check `filterchildren` function.
let 
    ex1 = 2X^a - log(b + my_f(Y,Y)) - 3
    ex2 = X^(Y^(Z-a)) +log(log(log(b)))
    ex3 = sin(X) + sin(Y) + a*a*a*(1-X)
    ex4 = exp(a)/(pi*a) + D(Y) + D(my_f(1,Z))
    ex5 = a + 5b^2

    # Test for variables.
    @test isequal(filterchildren(X, ex1), [X])
    @test isequal(filterchildren(X, ex2), [X])
    @test isequal(filterchildren(X, ex3), [X, X])
    @test isequal(filterchildren(X, ex4), [])
    @test isequal(filterchildren(Y, ex1), [Y, Y])
    @test isequal(filterchildren(Y, ex2), [Y])
    @test isequal(filterchildren(Y, ex3), [Y])
    @test isequal(filterchildren(Y, ex4), [Y])
    @test isequal(filterchildren(Z, ex1), [])
    @test isequal(filterchildren(Z, ex2), [Z])
    @test isequal(filterchildren(Z, ex3), [])
    @test isequal(filterchildren(Z, ex4), [Z])

    # Test for syms.
    @test isequal(filterchildren(a, ex1), [a])
    @test isequal(filterchildren(a, ex2), [a])
    @test isequal(filterchildren(a, ex3), [a])
    @test isequal(filterchildren(a, ex4), [a, a])
    @test isequal(filterchildren(a, ex5), [a])
    @test isequal(filterchildren(b, ex1), [b])
    @test isequal(filterchildren(b, ex2), [b])
    @test isequal(filterchildren(b, ex3), [])
    @test isequal(filterchildren(b, ex4), [])
    @test isequal(filterchildren(b, ex5), [b])

    # Test for function.
    @test isequal(filterchildren(is_derivative, ex1), [])
    @test isequal(filterchildren(is_derivative, ex2), [])
    @test isequal(filterchildren(is_derivative, ex3), [])
    @test isequal(filterchildren(is_derivative, ex4), [D(Y), D(my_f(1,Z))])
end

# https://github.com/JuliaSymbolics/Symbolics.jl/issues/1175
let
    @variables w z α::Real β::Real;
    r3 = @rule ~x * +(~~ys) => sum(map(y-> ~x * y, ~~ys));
    @test r3(2 * (w+w+α+β)) isa Num
end

module SymbolicsStaticArraysExt

using Symbolics: Num, unwrap
import StaticArrays
import SymbolicUtils

function Base.:(/)(x::StaticArrays.SHermitianCompact{N, T}, y::Num) where {N, T <: Real}
    return SymbolicUtils.term(/, x, unwrap(y))
end
function Base.:(\)(x::Num, y::StaticArrays.SHermitianCompact{N, T}) where {N, T <: Real}
    return SymbolicUtils.term(\, unwrap(x), y)
end

end

using Symbolics: Sym, FnType, Term, value, scalarize
using Symbolics
using LinearAlgebra
using SparseArrays: sparse, sparsevec
using StaticArraysCore: SArray
import SpecialFunctions
using Test
using SymbolicUtils: BasicSymbolic, evaluate

a, b, c = :runtime_symbol_value, :value_b, :value_c
vars = @variables t $a $b(t) $c(t)[1:3]
@test t isa Num
@test a === :runtime_symbol_value
@test b === :value_b
@test c === :value_c
@test isequal(vars[1], t)
@test isequal(vars[2], Num(Sym{SymReal}(a; type = Real)))
@test isequal(vars[3], Num(Sym{SymReal}(b; type = FnType{Tuple,Real,Nothing})(value(t))))

vars = @variables a,b,c,d,e,f,g,h,i
@test isequal(vars, [a,b,c,d,e,f,g,h,i])
@test isequal(transpose(a), a)
@test isequal(a', a)
@test isequal(sincos(a), (sin(a), cos(a)))

# https://github.com/JuliaSymbolics/Symbolics.jl/issues/1763
@test isequal(sincospi(a), (sinpi(a), cospi(a)))
@test isinteger(Num(2))
@test !isinteger(Num(2.5))
@test !isinteger(a)
@variables nint::Int
@test isinteger(nint)
@variables zcplx::Complex
# `sinpi(::Complex{Num})` / `cospi(::Complex{Num})` go through `Base`'s
# complex implementations, which dispatch on `isinteger(::Num)`.
@test sinpi(zcplx) isa Complex{Num}
@test cospi(zcplx) isa Complex{Num}
@test sincospi(zcplx) isa Tuple{Complex{Num}, Complex{Num}}

@test substitute(a ~ b, Dict(a=>1, b=>c)) == (1 ~ c)

# test hashing
aa = a; # old a

@variables a

@test isequal(a, aa)
@test hash(a) == hash(aa)

@test isequal(Symbolics.get_variables(a+aa+1), Set([a]))

@test hash(a+b ~ c+d) == hash(a+b ~ c+d)

# test some matrix operations don't throw errors
X = [0 b c;
     d e f;
     g h i]

@test iszero(expand(det(X) - (-b * (d*i-f*g) + c * (d*h - e*g))))


F = lu(X)
@test_nowarn lu(X'), lu(transpose(X))
@test F.p == [2, 1, 3]
R = simplify_fractions.(F.L * F.U - X[F.p, :])
@test iszero(R)
@test simplify_fractions.(F \ X) == I
@test Symbolics._solve(X, X, true) == I
inv(X)
qr(X)

X2 = [0 b c; 0 0 0; 0 h 0]
@test_throws SingularException lu(X2)
F2 = lu(X2, check=false)
@test F2.info == 1

# test operations with sparse arrays
# note `isequal` instead of `==` because `==` would give another symbolic type

# test that we can create a symbolic sparse array
Oarray = zeros(Num, 2,2)
Oarray[2,2] = a
@test isequal(sparse(Oarray), sparse([2], [2], [a]))

@test isequal(a * sparse([2], [2], [1]), sparse([2], [2], [a * 1]))

A = sparse([2], [2], [a])
B = sparse([2], [2], [b])
@test isequal(A + B, sparse([2], [2], [a+b]))

C = sparse([1, 2], [2, 1], [c, c])
D = sparse([1, 2], [2, 1], [d, d])

@test isequal(C * D, sparse([1,2], [1,2], [c * d, c * d]))

@variables t σ ρ β
@variables x(t) y(t) z(t)
D = Differential(t)
Dx = Differential(x)
Dy = Differential(y)
Dz = Differential(z)

eqs = [D(x) ~ σ*(y-x),
       D(y) ~ x*(ρ-z)-y,
       D(z) ~ x*y - β*z]
J = Num[Dx(eqs[1].rhs) Dy(eqs[1].rhs) Dz(eqs[1].rhs)
 Dx(eqs[2].rhs) Dy(eqs[2].rhs) Dz(eqs[2].rhs)
 Dx(eqs[3].rhs) Dy(eqs[3].rhs) Dz(eqs[3].rhs)]

J = expand_derivatives.(J)
using LinearAlgebra
luJ = lu(J,Val(false))

@variables M[1:2,1:2]
inv(M)

@variables b[1:2]
M = [1 0; 0 2]
M \ b
M \ reshape(b,2,1)
M = [1 1; 0 2]
M \ reshape(b,2,1)


M = [1 a; 0 2]
M \ b
M \ [1, 2]

# test det
@variables X[1:4,1:4]
d1 = det(X, laplace=true)
_det1 = eval(build_function(d1,X))
A = [1 1 1 1
     1 0 1 1
     1 1 0 1
     1 1 1 0]
@test _det1(map(Num, A)) == -1

@variables X[1:3,1:3]
d1 = det(X, laplace=true)
_det1 = eval(build_function(d1, X))
A = [1 1 1
     1 0 1
     1 1 1]
@test _det1(map(Num, A)) == 0

@variables a b c d
z1 = a + b * im
z2 = c + d * im
@test isequal(a/im, - a*im)
@test z1 * 2 - Complex(2a, 2b) == 0
@test isequal(2z1, Complex(2a, 2b))
@test isequal(simplify_fractions(z1 / z1), 1)
@test isequal(z1 / z2, Complex((a*c + b*d)/(c^2 + d^2), (b*c - a*d)/(c^2 + d^2)))
@test isequal(1 / z2, Complex(c/(c^2 + d^2), -d/(c^2 + d^2)))
@test isequal(z1 / c, Complex(a/c, b/c))
@test isequal(a / z2, Complex(a*c/(c^2 + d^2), -a*d/(c^2 + d^2)))
@test isequal(z1 * z2, Complex(a*c - b*d, a*d + b*c))
@test isequal(z1 - z2, Complex(a - c, b - d))
@test isequal(z1 + z2, Complex(a + c, b + d))
@test isequal(z1 + 2, Complex(a + 2, b))
@test isequal(2 + z1, Complex(2 + a, b))
@test isequal(z1 - 2, Complex(a - 2, b))
@test isequal(2 - z1, Complex(2 - a, -b))
@test isequal(z1 ^ 2, a^2 - b^2 + 2a*b*im)

@testset "Num dispatch intersections" begin
    @test Num(1 + 0im) isa Num
    @test_throws InexactError Num(1 + 2im)
    @test_throws InexactError convert(Num, 1 + 2im)
    @test (1 + 2im == a) isa Num
    @test (a == 1 + 2im) isa Num
    @test (Base.MathConstants.pi == a) isa Num
    @test (a == Base.MathConstants.pi) isa Num
    @test !isequal(1 + 2im, a)
    @test !isequal(a, 1 + 2im)
    @test isequal((Complex(a, b)^false), Complex(1, 0))
    @test promote_type(Complex{Float64}, Num) === Complex{Num}

    for value in (1.0, 1 + 2im, unwrap(a))
        @test (SymbolicUtils.:<ₑ(a, value)) isa Bool
        @test (SymbolicUtils.:<ₑ(value, a)) isa Bool
    end
end

@testset "Num package-array intersections" begin
    bits = BitVector([true, false])
    sparse_vector = sparsevec([1], [1.0], 2)
    static_vector = SArray{Tuple{2}}((1.0, 2.0))

    @test bits / a isa BasicSymbolic
    @test a / bits isa BasicSymbolic
    @test sparse_vector / a isa BasicSymbolic
    @test static_vector / a isa BasicSymbolic
    @test a \ static_vector isa BasicSymbolic
    @test view([1.0 2.0; 3.0 4.0], :, :) / a isa BasicSymbolic
    @test a \ view([1.0, 2.0], :) isa BasicSymbolic
    @test sparse([1.0 0.0; 0.0 2.0]) / a isa BasicSymbolic
    @test a / (1:3) isa BasicSymbolic
    @test (a in 1:3) isa BasicSymbolic
    @test (a in static_vector) isa BasicSymbolic
    for values in (
            view([1.0, 2.0], :), Diagonal([1.0, 2.0]),
            Symmetric([1.0 0.0; 0.0 2.0]), adjoint([1.0, 2.0]),
        )
        @test (a in values) isa BasicSymbolic
    end

    upper = UpperTriangular(Num[1 1; 0 1])
    upper_rhs = sparsevec([1, 2], Num[2, 1], 2)
    @test ldiv!(upper, upper_rhs) == Num[1, 1]
    upper_rhs = sparsevec([1, 2], Num[2, 1], 2)
    upper_output = Num[0, 0]
    @test ldiv!(upper, upper_rhs, upper_output) == Num[1, 1]

    unit_lower = UnitLowerTriangular(Num[1 0; 1 1])
    lower_rhs = sparsevec([1, 2], Num[1, 2], 2)
    @test ldiv!(unit_lower, lower_rhs) == Num[1, 1]
    lower_rhs = sparsevec([1, 2], Num[1, 2], 2)
    lower_output = Num[0, 0]
    @test ldiv!(unit_lower, lower_rhs, lower_output) == Num[1, 1]
end

@testset "Num scalar method intersections" begin
    for f in (
            SpecialFunctions.besseli, SpecialFunctions.besselj,
            SpecialFunctions.besselk, SpecialFunctions.bessely,
        )
        @test f(a, 1.0) isa Num
        @test f(a, 1.0im) isa Num
    end
    @test copysign(1, a) isa Num
    @test copysign(1.0f0, a) isa Num
    @test copysign(1.0, a) isa Num
    @test SpecialFunctions.polygamma(1, a) isa Num
end

@testset "Num structured-array intersections" begin
    structured = (
        Bidiagonal([1.0, 2.0], [3.0], :U),
        Diagonal([1.0, 2.0]),
        Tridiagonal([1.0], [2.0, 3.0], [4.0]),
        SymTridiagonal([1.0, 2.0], [3.0]),
        Symmetric([1.0 2.0; 2.0 3.0]),
        Hermitian([1.0 2.0; 2.0 3.0]),
        UpperHessenberg([1.0 2.0; 3.0 4.0]),
        UpperTriangular([1.0 2.0; 0.0 3.0]),
        LowerTriangular([1.0 0.0; 2.0 3.0]),
        UnitUpperTriangular([1.0 2.0; 0.0 1.0]),
        UnitLowerTriangular([1.0 0.0; 2.0 1.0]),
    )
    for matrix in structured
        @test (matrix / a) isa BasicSymbolic
        @test (a \ matrix) isa BasicSymbolic
    end
    for matrix in (structured[2], structured[4], structured[5], structured[6])
        @test (matrix^a) isa BasicSymbolic
    end
    @test (a^[1.0 0.0; 0.0 1.0]) isa BasicSymbolic
end

@test isequal((0 ~ a+0*im), 0 ~ a)
@test isequal((im ~ b+c*im), [0 ~ b; 1 ~ c])
@test isequal((0 ~ z1), [0 ~ a, 0 ~ b])
@test isequal((z1 ~ z2), [a ~ c, b ~ d])

@test a + im === Complex(a, Num(1))
@test real(a) === a
@test conj(a) === a
@test imag(a) === Num(0)

@test isequal(sign(x), Num(SymbolicUtils.Term{SymReal}(sign, [Symbolics.value(x)]; type = Real)))
@test sign(Num(1)) isa Num
@test isequal(evaluate(sign(Num(1))), Num(1))
@test isequal(evaluate(sign(Num(-1))), Num(-1))

@test isequal(ℯ^a, exp(a))

@test isequal(Symbolics.derivative(abs(x), x), ifelse(signbit(x), -1, 1))
@test isequal(Symbolics.derivative(sign(x), x), 0)
@test isequal(Symbolics.derivative(signbit(x), x), 0)

@test iszero(Num(0.0))
@test isone(Num(1.0))
@test isone(complex(Num(1), Num(0)))
@test iszero(complex(Num(0), Num(0)))

x = Num.(randn(10))
@test value(evaluate(norm(x))) ≈ norm(Symbolics.value.(x))
@test value(evaluate(norm(x, Inf))) == norm(Symbolics.value.(x), Inf)
@test value(evaluate(norm(x, 1))) ≈ norm(Symbolics.value.(x), 1)
@test value(evaluate(norm(x, 1.2))) ≈ norm(Symbolics.value.(x), 1.2)

@test evaluate.(clamp.(x, 0, 1)) == clamp.(Symbolics.value.(x), 0, 1)
@test isequal(Symbolics.derivative(clamp(a, 0, 1), a), ifelse(a < 0, 0, ifelse(a>1, 0, 1)))

@variables x[1:2]
@test isequal(scalarize(norm(x)), sqrt(abs2(x[1]) + abs2(x[2])))
@test isequal(scalarize(norm(x, Inf)), max(abs(x[1]), abs(x[2])))
@test isequal(scalarize(norm(x, 1)), abs(x[1]) + abs(x[2]))
@test isequal(scalarize(norm(x, 1.2)), (abs(x[1])^1.2 + abs(x[2])^1.2)^(1/1.2))

@variables x y
@test isequal(expand((x+y)^2), x^2 + y^2 + 2x*y)

@variables t p x(t) y(t) z(t)
@test isequal(substitute(y ~ x*p, Dict(x => z, y => t)), t ~ z*p)
@test ~(!((1 < x) & (x < 2) | (x >= 100) ⊻ (x <= 1000) & (x != 100))) isa Num

# Maybe move me

@variables x[1:3]
ex = x[1]+x[2]
@test issetequal(Symbolics.get_variables(ex), Symbolics.scalarize(x[1:2]))

@variables x
A = [x[1] 2
     2    0.0]
B = [x[1] 1.0
    2.0 0.0]
@test_throws MethodError Matrix{Float64}(A)
@test_broken Matrix{Float64}(A-B) isa Matrix{Float64}
@test_broken Matrix{Float64}(A-B) == [0.0 1.0;0.0 0.0]

@test isequal(simplify(cos(x)^2 + sin(x)^2 + im * x), 1 + x*im)

using Base.MathConstants: catalan, γ, π, φ, ℯ
for q in (catalan, γ, π, φ, ℯ)
    nq = Num(q)
    @test 3nq^5/7 isa Num
    @test Symbolics.value(substitute(3nq^5/7, Dict(nq=>big(q)))) ≈ 3big(q)^5/7
end

using Markdown
@variables x
d = Base.Docs.getdoc(x)
@test d isa Markdown.MD
stringcontent = string(d.content)
@test occursin("Metadata", stringcontent)
@test occursin("(:variables, :x)", stringcontent)

@variables t
for f in [<, <=, >, >=, isless]
    @test_nowarn f(t, 1.0)
end

@test_nowarn binomial(t, 1)

# test for https://github.com/JuliaSymbolics/Symbolics.jl/issues/1028
let
    @variables t A(t) B
    @test try binomial(A, 2*B^2)
        true
    catch
        false
    end
    @test try binomial(Symbolics.value(A), Symbolics.value(2*B^2))
        true
    catch
        false
    end
end

using Symbolics: scalarize
@variables X[1:3, 1:3] x
sX = fill(x, 3, 3)
sx = fill(x, 3)
@test isequal(scalarize(X + sX), scalarize(X) + sX)
@test isequal(scalarize(X * sX), scalarize(X) * sX)
@test isequal(scalarize(X * sx), scalarize(X) * sx)

@testset "Equations from nonsymbolic operands" begin
    @variables x y
    @test (1 ~ 3) isa Equation
    @test (nothing ~ nothing) isa Equation
    @test ([x, y] ~ [1, 2]) isa Equation
    @test isequal(substitute(x ~ y, Dict(x => 1, y => 2)), Equation(1, 2))
    @test copysign(1 // 2, x) isa Num
end

:(function (ˍ₋out, u)
      let _out = ˍ₋out
          var"%_out" = for _2 = 1:1:5
                  for _1 = 1:1:5
                      begin
                          _out[(CartesianIndex)(_1, _2)] = (+)((getindex)(_out, _1, _2), (getindex)(u, (Main.limit2)((+)(-1, (getindex)(1:1:5, _2)), 5), (Main.limit2)((+)(1, (getindex)(1:1:5, _1)), 5)))
                          nothing
                      end
                  end
              end
          _out
      end
  end)

import Base: getindex
inner_unwrap(x) = x isa AbstractArray ? unwrap.(x) : x

##### getindex #####
@inline _indexed_ndims(idx, idxs...) = SymbolicUtils._indexed_ndims(typeof(idx)) + _indexed_ndims(idxs...)
@inline _indexed_ndims() = 0

function wrapper_fn_from_idxs(x::Arr{T, N}, idxs...) where {T, N}
    any(i -> i isa Union{Num, BasicSymbolic{VartypeT}, Arr}, idxs) && return identity
    
    nd = _indexed_ndims(idxs...)
    return nd == 0 ? is_wrapper_type(T) ? T : identity : Arr{T, nd}
end
wrapper_fn_from_idxs(x::Arr{T, N}, idx::SymbolicUtils.StableIndex{Int}) where {T, N} = T
# Wrapped array should wrap the elements too
function Base.getindex(x::Arr{T, N}, idx::CartesianIndex{N}) where {T, N}
    if is_wrapper_type(T)
        T(unwrap(x)[idx])
    else
        unwrap(x)[idx]
    end
end
function Base.getindex(x::Arr, idx...)
    wrapper_fn_from_idxs(x, idx...)(unwrap(x)[unwrap.(idx)...])
end
const SymIdxT = Union{Num, BasicSymbolic{VartypeT}}
function Base.getindex(x::Arr, idx::SymIdxT, idxs...)
    wrapper_fn_from_idxs(x, unwrap(idx), idxs...)(unwrap(x)[unwrap(idx), unwrap.(idxs)...])
end
function Base.getindex(x::Arr, i1, idx::SymIdxT, idxs...)
    wrapper_fn_from_idxs(x, i1, unwrap(idx), idxs...)(unwrap(x)[(i1), unwrap(idx), unwrap.(idxs)...])
end
function Base.getindex(x::Arr, i1::SymIdxT, idx::SymIdxT, idxs...)
    wrapper_fn_from_idxs(x, unwrap(i1), unwrap(idx), idxs...)(unwrap(x)[unwrap(i1), unwrap(idx), unwrap.(idxs)...])
end
function Base.getindex(x::Arr, i1, i2, idx::SymIdxT, idxs...)
    wrapper_fn_from_idxs(x, i1, i2, unwrap(idx), idxs...)(unwrap(x)[unwrap(i1), unwrap(i2), unwrap(idx), unwrap.(idxs)...])
end
function Base.getindex(x::Arr, i1::SymIdxT, i2, idx::SymIdxT, idxs...)
    return wrapper_fn_from_idxs(x, unwrap(i1), i2, unwrap(idx), idxs...)(unwrap(x)[unwrap(i1), unwrap(i2), unwrap(idx), unwrap.(idxs)...])
end
function Base.getindex(x::Arr, i1, i2::SymIdxT, idx::SymIdxT, idxs...)
    wrapper_fn_from_idxs(x, i1, unwrap(i2), unwrap(idx), idxs...)(unwrap(x)[unwrap(i1), unwrap(i2), unwrap(idx), unwrap.(idxs)...])
end
function Base.getindex(x::Arr, i1::SymIdxT, i2::SymIdxT, idx::SymIdxT, idxs...)
    wrapper_fn_from_idxs(x, unwrap(i1), unwrap(i2), unwrap(idx), idxs...)(unwrap(x)[unwrap(i1), unwrap(i2), unwrap(idx), unwrap.(idxs)...])
end

import Base: +, -, *

#### Broadcast ####

# On wrapper:
struct SymWrapBroadcast <: Broadcast.BroadcastStyle end

Broadcast.BroadcastStyle(::Type{T}) where {T <: Arr} = SymWrapBroadcast()

Broadcast.BroadcastStyle(::SymWrapBroadcast,
    ::Broadcast.BroadcastStyle) = SymWrapBroadcast()
Broadcast.BroadcastStyle(::SymWrapBroadcast, ::Broadcast.Unknown) = SymWrapBroadcast()
Broadcast.BroadcastStyle(::SymbolicUtils.SymBroadcast,
    ::SymWrapBroadcast) = Broadcast.Unknown()

unwrap_broadcasts(head, args...) = (unwrap_broadcast(head), unwrap_broadcasts(args...)...)
unwrap_broadcasts() = ()
unwrap_broadcast(x) = unwrap(x)
function unwrap_broadcast(bc::Broadcast.Broadcasted{SymWrapBroadcast})
    Broadcast.Broadcasted{SymbolicUtils.SymBroadcast{VartypeT}}(bc.f, unwrap_broadcasts(bc.args...), bc.axes)
end

function Base.copy(bc::Broadcast.Broadcasted{SymWrapBroadcast})
    return wrap(copy(unwrap_broadcast(bc)))
end

#################### POLYADIC ################

*(x::Arr, y::Number) = *(unwrap(x), unwrap(y))
*(x::Number, y::Arr) = *(unwrap(x), unwrap(y))
*(x::Arr, y::BasicSymbolic{VartypeT}) = *(unwrap(x), y)
*(x::Arr, y::Arr) = *(unwrap(x), unwrap(y))
*(x::Arr, y::AbstractMatrix) = *(unwrap(x), y)
for T in (LinearAlgebra.Adjoint, LinearAlgebra.Transpose)
    @eval *(x::Arr{<:Any, 1}, y::$T{<:Any, <:AbstractMatrix}) = *(unwrap(x), y)
end
*(x::Arr, y::AbstractVector) = *(unwrap(x), y)
*(x::AbstractMatrix, y::Arr) = *(x, unwrap(y))
*(x::LinearAlgebra.Diagonal, y::Arr) = *(x, unwrap(y))
*(x::Arr{<:Any, 2}, y::LinearAlgebra.Diagonal) = *(unwrap(x), y)
const _Triangular = Union{
    LinearAlgebra.LowerTriangular, LinearAlgebra.UnitLowerTriangular,
    LinearAlgebra.UnitUpperTriangular, LinearAlgebra.UpperTriangular,
}
# Julia 1.10's LinearAlgebra dispatches on the non-public abstract `AbstractTriangular`;
# later versions use the concrete union, which needs the second set of methods.
for T in (LinearAlgebra.AbstractTriangular, _Triangular), N in (1, 2)
    @eval *(x::$T, y::Arr{<:Any, $N}) = *(x, unwrap(y))
end
for T in (LinearAlgebra.AbstractTriangular, _Triangular)
    @eval *(x::Arr{<:Any, 2}, y::$T) = *(unwrap(x), y)
end
for T in (LinearAlgebra.Adjoint, LinearAlgebra.Transpose), N in (1, 2)
    @eval *(
        x::$T{<:Any, <:AbstractVector}, y::Arr{<:Any, $N}
    ) = *(x, unwrap(y))
end
# The combined signature resolves the intersection with LinearAlgebra's union method.
function *(
        x::Union{
            LinearAlgebra.Adjoint{<:Any, <:AbstractVector},
            LinearAlgebra.Transpose{<:Any, <:AbstractVector},
        }, y::Arr{<:Any, 1}
    )
    return *(x, unwrap(y))
end
function *(x::LinearAlgebra.Adjoint{T, <:AbstractVector}, y::Arr{S, 1}) where {
        T <: Number, S <: Number,
    }
    return *(x, unwrap(y))
end
function *(x::LinearAlgebra.Transpose{T, <:AbstractVector}, y::Arr{T, 1}) where {T <: Real}
    return *(x, unwrap(y))
end
function *(
        x::_StaticArray{Tuple{N, M}, T, 2}, y::Arr{S, 1}
    ) where {N, M, T, S}
    return *(x, unwrap(y))
end
function *(
        x::Arr, y::Union{
            LinearAlgebra.Adjoint{<:Any, <:AbstractVector},
            LinearAlgebra.Transpose{<:Any, <:AbstractVector},
        }
    )
    return *(unwrap(x), y)
end
function *(
        x::LinearAlgebra.Adjoint{<:Number, <:AbstractVector}, y::Arr,
        z::AbstractVector{<:Number}
    )
    return *(x, unwrap(y), unwrap(z))
end
function *(
        x::LinearAlgebra.Transpose{<:Real, <:AbstractVector}, y::Arr,
        z::AbstractVector{<:Real}
    )
    return *(x, unwrap(y), unwrap(z))
end
function *(
        x::Union{Real, Complex}, y::Arr{T, 2}, z::Arr{S, 1}
    ) where {T <: Union{Real, Complex}, S <: Union{Real, Complex}}
    return *(unwrap(x), unwrap(y), unwrap(z))
end
*(x::Arr, y::Arr, z::Number) = *(unwrap(x), unwrap(y), unwrap(z))

function +(x::Arr, args::AbstractArray...)
    return +(unwrap(x), args...)
end
function +(x::Arr, y::AbstractArray, args::AbstractArray...)
    return +(unwrap(x), y, args...)
end
function +(x1::Arr, x2::Arr, args::AbstractArray...)
    return +(unwrap(x1), unwrap(x2), args...)
end
function +(x::Arr, y::_StaticArray)
    return +(unwrap(x), y)
end

for T1 in [Arr, AbstractArray], T2 in [Arr, AbstractArray]
    T1 == T2 == AbstractArray && continue
    @eval Base.:(\)(x1::$T1{Num, 1}, x2::$T2{Num, 1}) = Num(unwrap(x1) \ unwrap(x2))
    @eval Base.:(\)(x1::$T1{Num, 1}, x2::$T2{Num, 2}) = Arr{Num, 2}(unwrap(x1) \ unwrap(x2))
    if T1 == Arr
        @eval Base.:(\)(x1::$T1{Num, 2}, x2::$T2{Num, 1}) = Arr{Num, 1}(unwrap(x1) \ unwrap(x2))
        @eval Base.:(\)(x1::$T1{Num, 2}, x2::$T2{Num, 2}) = Arr{Num, 2}(unwrap(x1) \ unwrap(x2))
    end

    @eval Base.:(/)(x1::$T1{Num, 1}, x2::$T2{Num, 1}) = Arr{Num, 2}(unwrap(x1) / unwrap(x2))
    @eval Base.:(/)(x1::$T1{Num, 1}, x2::$T2{Num, 2}) = Arr{Num, 2}(unwrap(x1) / unwrap(x2))
    @eval Base.:(/)(x1::$T1{Num, 2}, x2::$T2{Num, 2}) = Arr{Num, 2}(unwrap(x1) / unwrap(x2))
end

Base.:(/)(x1::Num, x2::Arr{Num, 1}) = Arr{Num, 2}(unwrap(x1) / unwrap(x2))

const _TriangularNum = Union{
    LinearAlgebra.LowerTriangular{Num}, LinearAlgebra.UpperTriangular{Num},
}
const _UnitTriangularNum = Union{
    LinearAlgebra.UnitLowerTriangular{Num}, LinearAlgebra.UnitUpperTriangular{Num},
}
# The vector cases are dispatch bridges that preserve the underlying dimension error.
for T in (LinearAlgebra.Diagonal{Num}, _TriangularNum, _UnitTriangularNum), N in (1, 2)
    @eval Base.:(/)(A::Arr{Num, $N}, B::$T) = Arr{Num, 2}(unwrap(A) / unwrap(B))
end
for T in (
        LinearAlgebra.Bidiagonal{Num},
        LinearAlgebra.Adjoint{Num, <:LinearAlgebra.Bidiagonal},
        LinearAlgebra.Transpose{Num, <:LinearAlgebra.Bidiagonal},
    )
    @eval Base.:(/)(A::Arr{Num, 2}, B::$T) = Arr{Num, 2}(unwrap(A) / unwrap(B))
end
for T in (LinearAlgebra.Adjoint, LinearAlgebra.Transpose)
    @eval function Base.:(/)(
            A::$T{Num, <:AbstractVector}, B::Arr{Num, 2}
        )
        return Arr{Num, 2}(unwrap(A) / unwrap(B))
    end
end

Base.exp(m::Matrix{Num}) = Arr{Num, 2}(exp(SConst(m)))
Base.exp(m::Matrix{Complex{Num}}) = Arr{Complex{Num}, 2}(exp(SConst(m)))

function LinearAlgebra.transpose(x::Arr{T, N}) where {T, N}
    return Arr{T, 2}(LinearAlgebra.transpose(unwrap(x)))
end

#################### MAP-REDUCE ################

for Tf in (BasicSymbolic, Any)
    @eval begin
        function Base.map(f::$Tf, x::Arr)
            return wrap(map(f, unwrap(x)))
        end
        function Base.map(f::$Tf, x::Arr, xs::Arr...)
            return wrap(map(f, unwrap(x), unwrap.(xs)...))
        end
        function Base.map(f::$Tf, x::Arr, y::BasicSymbolic, ys...)
            return wrap(map(f, unwrap(x), y, unwrap.(ys)...))
        end
        function Base.map(f::$Tf, x::Arr, y::AbstractArray, ys::AbstractArray...)
            return wrap(map(f, unwrap(x), y, unwrap.(ys)...))
        end
        function Base.map(f::$Tf, x::Arr, y::_StaticArray, ys::AbstractArray...)
            return wrap(map(f, unwrap(x), y, unwrap.(ys)...))
        end
        function Base.map(f::$Tf, x::AbstractArray, y::Arr, ys::Arr...)
            return wrap(map(f, x, unwrap(y), unwrap.(ys)...))
        end
        function Base.map(f::$Tf, x::_StaticArray, y::Arr, ys::Arr...)
            return wrap(map(f, x, unwrap(y), unwrap.(ys)...))
        end
        function Base.map(f::$Tf, x::BasicSymbolic, y::Arr, ys::Arr...)
            return wrap(map(f, x, unwrap(y), unwrap.(ys)...))
        end
    end
end
for Tf in (BasicSymbolic, Any), Tr in (BasicSymbolic, Any)
    @eval begin
        function Base.mapreduce(f::$Tf, op::$Tr, x::Arr; kw...)
            return wrap(mapreduce(f, op, unwrap(x); kw...))
        end
        function Base.mapreduce(f::$Tf, op::$Tr, x::Arr, xs::Arr...; kw...)
            return wrap(mapreduce(f, op, unwrap(x), unwrap.(xs)...; kw...))
        end
        function Base.mapreduce(
                f::$Tf, op::$Tr, x::Arr, y::AbstractArray,
                ys::AbstractArray...; kw...
            )
            return wrap(mapreduce(f, op, unwrap(x), y, unwrap.(ys)...; kw...))
        end
        function Base.mapreduce(
                f::$Tf, op::$Tr, x::AbstractArray, y::Arr, ys::Arr...; kw...
            )
            return wrap(mapreduce(f, op, x, unwrap(y), unwrap.(ys)...; kw...))
        end
        function Base.mapreduce(
                f::$Tf, op::$Tr, x::BasicSymbolic, y::Arr, ys::Arr...; kw...
            )
            return wrap(mapreduce(f, op, x, unwrap(y), unwrap.(ys)...; kw...))
        end
    end
end

function LinearAlgebra.dot(x::Arr{T}, y::Arr{T}) where {T}
    T(LinearAlgebra.dot(unwrap(x), unwrap(y)))
end

#################### REGISTRATION ################

@register_array_symbolic LinearAlgebra.triu(x::AbstractArray) begin
    size = size(x)
    eltype = eltype(x)
    ndims = ndims(x)
end

@register_array_symbolic LinearAlgebra.tril(x::AbstractArray) begin
    size = size(x)
    eltype = eltype(x)
    ndims = ndims(x)
end

@register_array_symbolic LinearAlgebra.normalize(x::AbstractArray) begin
    size = size(x)
    eltype = eltype(x)
    ndims = ndims(x)
end

@register_symbolic LinearAlgebra.tr(x::AbstractMatrix)

# Eigenvalues of a symbolic matrix have no closed form, so `eigmax`/`eigmin`
# build unevaluated symbolic terms (like `tr`) rather than computing numerically;
# without this they fall through to `eigvals!`, which errors on a symbolic matrix.
@register_symbolic LinearAlgebra.eigmax(x::AbstractMatrix)
@register_symbolic LinearAlgebra.eigmin(x::AbstractMatrix)

module SymbolicsPreallocationToolsExt

using PreallocationTools
import PreallocationTools: _restructure, get_tmp
using Symbolics, ForwardDiff

function get_tmp(dc::DiffCache, u::Type{X}) where {T,N, X<: ForwardDiff.Dual{T, Num, N}}
    if length(dc.du) > length(dc.any_du)
        resize!(dc.any_du, length(dc.du))
    end
    _restructure(dc.du, dc.any_du)
end

function get_tmp(dc::DiffCache, u::X) where {T,N, X<: ForwardDiff.Dual{T, Num, N}}
    if length(dc.du) > length(dc.any_du)
        resize!(dc.any_du, length(dc.du))
    end
    _restructure(dc.du, dc.any_du)
end

function get_tmp(dc::DiffCache, u::AbstractArray{X}) where {T,N, X<: ForwardDiff.Dual{T, Num, N}}
    if length(dc.du) > length(dc.any_du)
        resize!(dc.any_du, length(dc.du))
    end
    _restructure(dc.du, dc.any_du)
end

function get_tmp(dc::FixedSizeDiffCache, u::Type{X}) where {T,N, X<: ForwardDiff.Dual{T, Num, N}}
    if length(dc.du) > length(dc.any_du)
        resize!(dc.any_du, length(dc.du))
    end
    _restructure(dc.du, dc.any_du)
end

function get_tmp(dc::FixedSizeDiffCache, u::X) where {T,N, X<: ForwardDiff.Dual{T, Num, N}}
    if length(dc.du) > length(dc.any_du)
        resize!(dc.any_du, length(dc.du))
    end
    _restructure(dc.du, dc.any_du)
end

function get_tmp(dc::FixedSizeDiffCache, u::AbstractArray{X}) where {T,N, X<: ForwardDiff.Dual{T, Num, N}}
    if length(dc.du) > length(dc.any_du)
        resize!(dc.any_du, length(dc.du))
    end
    _restructure(dc.du, dc.any_du)
end

end

:(function (x,)
      let _out = (zeros)(Float64, (4, 4))
          var"%_out" = for _2 = 1:1:4
                  for _1 = 1:1:4
                      begin
                          _out[(CartesianIndex)(_1, _2)] = (+)((getindex)(_out, _1, _2), (getindex)(x, _2, _1))
                          nothing
                      end
                  end
              end
          _out
      end
  end)

"""
    turn_to_poly(expr, var)

Traverses an expression and keeps track of transcendental functions,
if multiple types or versions of transcendental functions are found,
it aborts subbing into the expression since this expression becomes
and unsolvable by polynomial substitution. Say ``log(x)^2 + sin(x) + 1``
What should we sub here? no sub makes it a solvable polynomial.
Moreover, if the transcendental functions are not exactly the same,
it also aborts. E.g. ``log(x+1)^2 + log(x) + 1``. here we have two
"versions" of logs, so we can not sub here too.

# Arguments
- expr A Num expression.
- var: Num and should satisfy is_singleton

# Examples
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> let result = Symbolics.turn_to_poly(log(x)^2 + log(x) + 1, x)
           length(result[2]) == 1 && isequal(only(values(result[2])), log(x))
       end
true

julia> let result = Symbolics.turn_to_poly(9^x + 3^x + 2, x)
           length(result[2]) == 1 && isequal(only(values(result[2])), 3^x)
       end
true
```
"""
function turn_to_poly(expr, var)
    expr = unwrap(expr)
    !iscall(expr) && return (expr, Dict())

    args = copy(parent(sorted_arguments(expr)))

    sub = 0
    broken = Ref(false)

    for (i, arg) in enumerate(args)
        !iscall(arg) && continue
        arg_oper = operation(arg)

        if arg_oper === (^)
            args[i], tp = trav_pow(args[i], var, broken, sub)
            sub = isequal(tp, false) ? sub : tp
            continue
        end
        if arg_oper === (*)
            args[i], sub = trav_mult(arg, var, broken, sub)
            continue
        end
        isequal(add_sub(sub, arg, var, broken), false) && continue
        sub = arg
    end

    for arg in args
        if check_poly_inunivar(arg, var) && any(isequal(var, x) for x in get_variables(arg))
            !isequal(sub, 0) && return (expr, Dict())
        end
    end

    if broken[] || isequal(sub, 0)
        return (expr, Dict{Any, Any}())
    end

    new_var = gensym()
    new_var = (@variables $new_var)[1]
    expr = maketerm(typeof(expr), operation(expr), args, metadata(expr))
    return ssubs(expr, Dict(sub => new_var)), Dict{Any, Any}(new_var => sub)
end

"""
    trav_pow(arg, var, broken, sub)

Traverses an argument `arg` passed from ``turn_to_poly`` if it satisfies
``oper === (^)``. Returns the new `arg` and `sub` if `sub` is changed from 0 to a new
transcendental function or its value is kept the same, or else `false` if these 2 cases
do not occur.

# Arguments
- args: The original arguments array of the expression passed to ``turn_to_poly``
- index: The index of the argument in the args array that needs to be traversed
- var: Num and should satisfy is_singleton
- broken: A reference bool which the value of is altered if a different transc function is found than sub
- sub: The sub stored in memory in ``turn_to_poly``. 

# Examples
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> Symbolics.trav_pow(Symbolics.unwrap(9^x), x, Ref(false), 3^x)
((3^x)^2, 3^x)

julia> Symbolics.trav_pow(Symbolics.unwrap(x^2), x, Ref(false), 3^x)
(x^2, false)
```
"""
function trav_pow(arg, var, broken, sub)
    args_arg = arguments(arg)
    base = value(args_arg[1])
    power = value(args_arg[2])

    # case 1: log(x)^2 .... 9^x = 3^2^x = 3^2x = (3^x)^2
    !isequal(add_sub(sub, base, var, broken), false) && power isa Integer && return arg, base

    # case 2: int^f(x)
    # n_func_occ may not be strictly 1, we could attempt attracting it after solving
    if base isa Integer && n_func_occ(power, var) == 1
        factors = collect(Primes.factor(base))
        length(factors) != 1 && return false
        b, p = factors[1]
        new_b = b^power
        sub = isequal(sub, 0) ? new_b : sub
        if !isequal(sub, new_b)
            broken[] = true
            return arg, false
        end
        new_b = ^(new_b, p)
        return new_b, sub
    end

    return arg, false
end

"""
    trav_mult(arg, var, broken, sub)

Traverses an argument passed from ``turn_to_poly`` if it
satisfies ``oper === (*)``. Returns the new `arg` and `sub` if its changed from 0
to a new transcendental function or its value is 
kept the same, but changes broken if these 2 cases do not occur. It
traverses the * argument by sub_arg and compares it to sub using
the function ``add_sub``

# Arguments
- arg: The arg to be traversed.
- var: Num and should satisfy is_singleton
- broken: A reference bool which the value of is altered if a different transc function is found than sub
- sub: The sub stored in memory in ``turn_to_poly``. 

# Examples
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> Symbolics.trav_mult(Symbolics.unwrap(9*log(x)), x, Ref(false), log(x))
(9log(x), log(x))

julia> Symbolics.trav_mult(Symbolics.unwrap(9*log(x)^2), x, Ref(false), log(x))
(9(log(x)^2), log(x))

julia> Symbolics.trav_mult(Symbolics.unwrap(9*log(x+1)), x, Ref(false), log(x))
(9log(1 + x), log(x))
```
"""
function trav_mult(arg, var, broken, sub)
    args_arg = copy(parent(arguments(arg)))
    for (i, arg2) in enumerate(args_arg)
        !iscall(arg2) && continue

        oper = operation(arg2)
        if oper === (^)
            args_arg[i], tp = trav_pow(args_arg[i], var, broken, sub)
            sub = isequal(tp, false) ? sub : tp
            continue
        end

        isequal(add_sub(sub, arg2, var, broken), false) && continue
        sub = arg2
    end
    arg = maketerm(typeof(arg), operation(arg), args_arg, metadata(arg))
    return arg, sub
end

"""
    add_sub(sub, arg, var, broken::Ref{Bool})

Checks if arg contains var, and compares it directly to sub,
if they're the same, returns true, if sub is 0 and arg contains
a transcendental function in var, returns true. If both cases are
not met, false is returned indicating that the previous function
in the stack should not sub. ``add_sub`` also changes ``broken``
to true if arg contains a transcendental function thats different from
sub in any way.

# Arguments
- sub: The sub stored in memory in ``turn_to_poly``. 
- arg: The arg to be compared to sub.
- var: Num and should satisfy is_singleton
- broken: A reference bool which the value of is altered if a different transc function is found than sub

# Examples
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> Symbolics.add_sub(3^x, Symbolics.unwrap(3^x), x, Ref(false))
true

julia> Symbolics.add_sub(0, Symbolics.unwrap(log(x)), x, Ref(false))
true

julia> Symbolics.add_sub(log(x+1), Symbolics.unwrap(log(x)), x, Ref(false))
false
```
"""
function add_sub(sub, arg, var, broken::Ref{Bool})
    if contains_transcendental(arg, var)
        if isequal(sub, 0)
            return true
        elseif !isequal(sub, arg)
            broken[] = true
            return false
        end
    end

    cond1 = n_occurrences(arg, var) > 0
    cond2 = isequal(sub, arg)
    return (cond1 && cond2)
end

"""
    contains_transcendental(arg, var, n_occ=1)

Simple helper function to check if arg contains a julia
transcendental function and has number of occurrences of var = n_occ.

# Arguments
- arg: The arg to be checked. Should be of type ``SymbolicUtils.BasicSymbolic{Real}``.
- var: Num and should satisfy is_singleton
- n_occ: The number of occurrences that arg should contain. Default value is 1.

# Examples
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> Symbolics.contains_transcendental(Symbolics.unwrap(log(x)), x)
true

julia> Symbolics.contains_transcendental(Symbolics.unwrap(x), x)
false

julia> Symbolics.contains_transcendental(Symbolics.unwrap(x^2), x)
false

julia> Symbolics.contains_transcendental(Symbolics.unwrap(1), x)
false

julia> Symbolics.contains_transcendental(Symbolics.unwrap(sin(x)), x)
true
```
"""
function contains_transcendental(arg, var, n_occ = 1)
    !iscall(arg) && return false
    arg_oper = operation(arg)

    friends = append!(monadic_nonlinear, [slog, ssqrt, scbrt])
    if any(isequal(arg_oper, oper) for oper in friends) && n_func_occ(arg, var) == n_occ
        return true
    end
    return false
end

function check_sqrt(arg, sqrt_term, var)
    if operation(arg) == sqrt && check_poly_inunivar(arguments(arg)[1], var) && !sqrt_term
        return true
    elseif operation(arg) == sqrt && sqrt_term
        return false
    end
end

# f(x) + sqrt(g(x)) + c
function detect_sqrtpoly(lhs, var)
    lhs = unwrap(expand(lhs))
    !iscall(lhs) && return false
    args = arguments(lhs)
    oper = operation(lhs)
    !isequal(oper, (+)) && return false
    sqrt_term = false
    poly_term_n = 0
    sqrt_term_n = 0

    for arg in args
        if check_poly_inunivar(arg, var)
            poly_term_n += arg
            continue
        end
        !iscall(arg) && continue

        if isequal(check_sqrt(arg, sqrt_term, var), true)
            sqrt_term_n += arg
            sqrt_term = true
            continue
        elseif isequal(check_sqrt(arg, sqrt_term, var), false)
            return false
        end

        if operation(arg) == (*)
            args_arg = arguments(arg)
            for i in eachindex(args_arg)
                !iscall(args_arg[i]) && continue
                if isequal(check_sqrt(args_arg[i], sqrt_term, var), true)
                    sqrt_term_n += arg
                    sqrt_term = true
                elseif isequal(check_sqrt(args_arg[i], sqrt_term, var), false)
                    return false
                end
            end
        end
    end

    isequal(sqrt_term_n + poly_term_n, lhs)
end

function attract_and_solve_sqrtpoly(lhs, var)
    sqrt_term = 0
    poly_term = 0
    lhs = unwrap(lhs)
    subs, filtered_expr = filter_poly(lhs, var)
    filtered_expr = unwrap(filtered_expr)
    args = arguments(filtered_expr)
    oper = operation(filtered_expr)
    !isequal(oper, (+)) && return []

    for arg in args
        if check_poly_inunivar(arg, var)
            poly_term += arg
            continue
        end

        if isequal(check_sqrt(arg, false, var), true)
            sqrt_term = arg
            continue
        end

        if operation(arg) == (*)
            args_arg = arguments(arg)
            found = false
            for i in eachindex(args_arg)
                !iscall(args_arg[i]) && continue
                if isequal(check_sqrt(args_arg[i], false, var), true)
                    found = true
                end
            end
            if found
                sqrt_term = arg
            end
            continue
        end
    end
    lhs = lhs - sqrt_term + ssqrt(arguments(sqrt_term)[1])
    eq_to_solve = expand((poly_term)^2 - arguments(sqrt_term)[1])
    eq_to_solve = ssubs(eq_to_solve, subs)
    roots = solve_univar(eq_to_solve, var)
    answers = []

    for root in roots
        if isapprox(
            value(substitute(lhs, Dict(var => eval(Symbolics.toexpr(root))); fold = Val(true))), 0, atol = 1e-4)
            push!(answers, root)
        end
    end
    return answers
end

using Symbolics
using Symbolics: hasdiff
using Test

@variables t x
D1 = Difference(t; dt=0.01)
D2 = Difference(t; dt=0.01)

@test D1 == D2
@test Base.isequal(D1, D2)
@test Base.hash(D1) == Base.hash(D2)

@test D1(x) isa Num

@test isequal((D1^2)(x), D1(D1(x)))

# hasdiff
@test hasdiff(D1)
@test hasdiff(D1(x) ~ x)
@test hasdiff(x ~ D1(x))
@test !hasdiff(t ~ x)
@test hasdiff((D1^2)(x) ~ x)
@test hasdiff(D1(x) ~ D2(x))

using SciMLTesting
import StaticArrays

symbolic_utils = Symbolics.SymbolicUtils
basic_symbolic = symbolic_utils.BasicSymbolic{symbolic_utils.SymReal}
basic_symbolic_wrapper = getfield(parentmodule(basic_symbolic), nameof(basic_symbolic))

run_qa(
    Symbolics;
    aqua_kwargs = (;
        # Shared SymbolicUtils interfaces are jointly owned. Base has no binary `~`, so
        # Symbolics' equation operator cannot collide with anything it does not own.
        piracies = (;
            treat_as_own = (
                Base.:~,
                basic_symbolic_wrapper,
                symbolic_utils.arguments,
                symbolic_utils.Code.cse_inside_expr,
                symbolic_utils.promote_shape,
                symbolic_utils.promote_symtype,
            ),
        ),
    ),
    ei_kwargs = (;
        # These are upstream names used for compatibility with Base, LinearAlgebra,
        # DiffRules, MacroTools, and NaNMath; those owners do not declare them public.
        all_qualified_accesses_are_public = (;
            ignore = (
                :BlasInt, :Cartesian, :Experimental, :ParseError, :ReshapedArray,
                :Unknown, :acos, :acosh, :alignment, :asin, :atanh, :checknonsingular,
                :cos, :diffrule, :diffrules, :eval, :getdoc, :log, :log10, :log1p,
                :log2, :max, :min, :nocolor, :power_by_squaring, :register_error_hint,
                :AbstractCompressedVector, :AbstractSparseMatrixCSC, :AbstractTriangular,
                :Slice, :StaticArray, :TwicePrecision, :TypedEndpointsInterval,
                :sin, :sqrt, :striplines, :tan,
            ),
        ),
    ),
    reexports_allow = (
        Symbol("@acrule"), Symbol("@arrayop"), Symbol("@makearray"),
        Symbol("@rule"), Symbol("@syms"), :BS, :IRStructure, :Rewriters,
        :RuleSet, :SafeReal, :SymReal, :SymbolicUtils, :TreeReal, :Unknown,
        :arguments, :expand, :flatten_fractions, :get_reachability, :getmetadata,
        :hasmetadata, :ifelse_branching, :ifelse_eager, :iscall, :istree,
        :operation, :populate_ir!, :print_ir, :quick_cancel, :scalarize,
        :setmetadata, :shape, :simplify, :simplify_fractions, :sorted_arguments,
        :substitute, :term, :unwrap, :unwrap_const, :vartype,
    ),
)

using Test, Symbolics
using Symbolics: symstruct, juliatype, symbolic_getproperty, symbolic_setproperty!, symbolic_constructor

struct Jörgen
    a::Int
    b::Float64
end

S = symstruct(Jörgen)
@variables x::S
xa = Symbolics.unwrap(symbolic_getproperty(x, :a))
@test Symbolics.symtype(xa) == Int
@test Symbolics.operation(xa) == Symbolics.typed_getfield
@test isequal(Symbolics.arguments(xa), [Symbolics.unwrap(x), Val{:a}()])
xa = Symbolics.unwrap(symbolic_setproperty!(x, :a, 10))
@test Symbolics.operation(xa) == setfield!
@test isequal(Symbolics.arguments(xa), [Symbolics.unwrap(x), Meta.quot(:a), 10])
@test Symbolics.symtype(xa) == Int

xb = Symbolics.unwrap(symbolic_setproperty!(x, :b, 10))
@test Symbolics.operation(xb) == setfield!
@test isequal(Symbolics.arguments(xb), [Symbolics.unwrap(x), Meta.quot(:b), 10])
@test Symbolics.symtype(xb) == Float64

s = Symbolics.symbolic_constructor(S, 1, 1.0)
@test Symbolics.symtype(s) == S

"""
    _toexpr_metadata(O, ::Type{Ctx}, val; latexwrapper) -> Union{Nothing, Any}

Hook for customizing Latexify output based on metadata. Return `nothing` to fall back
to the default behavior.

Defined in `Symbolics` (not in the Latexify extension) so downstream packages can add
methods via `import Symbolics` without reaching into the extension with
`Base.get_extension`. The Latexify extension calls this hook while building LaTeX
expressions and provides the `_toexpr_plain` and `default_latex_wrapper` helpers for
composing output inside a method.
"""
_toexpr_metadata(::Any, ::DataType, @nospecialize(val); kwargs...) = nothing

"""
    _toexpr_op(op, args; latexwrapper) -> Union{Nothing, Any}

Hook for customizing Latexify output based on the operation of a call. Return `nothing`
to fall back to the default behavior.

Defined in `Symbolics` (not in the Latexify extension) so downstream packages can add
methods via `import Symbolics` without reaching into the extension with
`Base.get_extension`.
"""
_toexpr_op(@nospecialize(op), args; kwargs...) = nothing

using Symbolics
import Symbolics: CallWithMetadata, getsource, getdefaultval, wrap, unwrap, getname
import SymbolicUtils: Term, symtype, FnType, BasicSymbolic, promote_symtype
using LinearAlgebra
using Test

@variables t
Symbolics.@register_symbolic fff(t)
@test isequal(fff(t), Symbolics.Num(Symbolics.Term{Real}(fff, [Symbolics.value(t)])))

const SymMatrix{T,N} =  Symmetric{T, AbstractArray{T, N}}
many_vars = @variables t=0 a=1 x[1:4]=2 y(t)[1:4]=3 w[1:4] = 1:4 z(t)[1:4] = 2:5 p(..)[1:4]

let
    @register_array_symbolic ggg(x::AbstractVector) begin
        container_type=SymMatrix
        size=(length(x) * 2, length(x) * 2)
        eltype=eltype(x)
    end false

    ## @variables

    gg = ggg(x)

    @test ndims(gg) == 2
    @test size(gg) == (8,8)
    @test eltype(gg) == Real
    @test symtype(unwrap(gg)) == SymMatrix{Real, 2}
    @test promote_symtype(ggg, symtype(unwrap(x))) == Any # no promote_symtype defined

    gg = ggg([a, 2a])
    @test ndims(gg) == 2
    @test size(gg) == (4, 4)
    @test eltype(gg) == Real
    @test symtype(unwrap(gg)) == SymMatrix{Real, 2}
    @test promote_symtype(ggg, Vector{symtype(typeof(a))}) == Any

    _a = unwrap(a)
    gg = ggg([_a, 2_a])
    @test ndims(gg) == 2
    @test size(gg) == (4, 4)
    @test eltype(gg) == Real
    @test symtype(unwrap(gg)) == SymMatrix{Real, 2}
    @test promote_symtype(ggg, Vector{symtype(typeof(a))}) == Any
end
let
    # redefine with promote_symtype
    @register_array_symbolic ggg(x::AbstractVector) begin
        container_type=SymMatrix
        size=(length(x) * 2, length(x) * 2)
        eltype=eltype(x)
    end
    @test promote_symtype(ggg, symtype(unwrap(x))) == SymMatrix{Real}
end

# ndims specified

# in terms of argument
@register_array_symbolic ggg(x::AbstractVector) begin
    container_type=SymMatrix
    size=(length(x) * 2, length(x) * 2)
    eltype=eltype(x)
    ndims = ndims(x) + 1
end
@test promote_symtype(ggg, symtype(unwrap(x))) == SymMatrix{Real, 2}

@register_array_symbolic ggg(x::AbstractVector) begin
    container_type=SymMatrix
    size=(length(x) * 2, length(x) * 2)
    eltype=eltype(x)
    ndims = 2
end
@test promote_symtype(ggg, symtype(unwrap(x))) == SymMatrix{Real, 2}

gg = ggg(x)

struct CanCallWithArray{T}
    params::T
end

ccwa = CanCallWithArray((length=10,))
@register_array_symbolic (c::CanCallWithArray)(x::AbstractArray, b::AbstractVector) begin
    size=(size(x, 1), length(b), c.params.length)
    eltype=Real
end false # without promote_symtype

hh = ccwa(gg, x)
@test size(hh) == (8,4,10)
@test eltype(hh) == Real
@test isequal(arguments(unwrap(hh)), unwrap.([gg, x]))

_args = [[a 2a; 4a 6a; 3a 5a], [4a, 6a]]
hh = ccwa(_args...)
@test size(hh) == (3, 2, 10)
@test eltype(hh) == Real
@test isequal(arguments(unwrap(hh)), unwrap.(_args))

@test all(t->getsource(t)[1] === :variables, many_vars)
@test getdefaultval(t) == 0
@test getdefaultval(a) == 1
@test getdefaultval(x) == 2
@test getdefaultval(x[1]) == 2
@test getdefaultval(y[2]) == 3
@test getdefaultval(w[2]) == 2
@test getdefaultval(w[4]) == 4
@test getdefaultval(z[3]) == 4

@test symtype(p) <: FnType{Tuple, Array{Real,1}}
@test promote_symtype(ccwa, symtype(unwrap(gg)), symtype(unwrap(x))) == Any
@test p(t)[1] isa Symbolics.Num


struct CanCallWithArray2{T}
    params::T
end

ccwa = CanCallWithArray2((length=10,))
@register_array_symbolic (c::CanCallWithArray2)(x::AbstractArray, b::AbstractVector) begin
    size=(size(x, 1), length(b), c.params.length)
    eltype=Real
end
@test promote_symtype(ccwa, symtype(unwrap(gg)), symtype(unwrap(x))) == AbstractArray{Real}

struct CanCallWithArray3{T}
    params::T
end

ccwa = CanCallWithArray3((length=10,))
# ndims specified
@register_array_symbolic (c::CanCallWithArray3)(x::AbstractArray, b::AbstractVector) begin
    size=(size(x, 1), length(b), c.params.length)
    eltype=Real
    ndims = 3
end
@test promote_symtype(ccwa, symtype(unwrap(gg)), symtype(unwrap(x))) == AbstractArray{Real, 3}

## Wrapper types

abstract type AbstractFoo{T} end

struct Foo{T}<:AbstractFoo{T}
end
@symbolic_wrap struct FooWrap{T} <: AbstractFoo{T}
    val::Foo{T}
end

Symbolics.unwrap(r::FooWrap) = r.val

@test Symbolics.wrapper_type(AbstractFoo) == FooWrap
@test Symbolics.wrapper_type(AbstractFoo{Int}) == FooWrap # removes the type param.
                                                          # If required,
                                                          # a new method must be defined
                                                          # by the user of @symbolic_wrap

x = Foo{Int}()
@test wrap(x) isa FooWrap{Int}
@test unwrap(wrap(x)) isa Foo{Int}

@wrapped function foo(f::AbstractFoo, x::Real)
    x > 1 ? (x > 5 ? "hi" : Foo{Int}()) : 0
end

@test !applicable(foo, x, 2)
@test applicable(foo, x, wrap(2))
@test applicable(foo, wrap(x), 2)
@test applicable(foo, wrap(x), wrap(2))

@test foo(x, wrap(2)) isa FooWrap
@test foo(x, wrap(1)) isa Num
@test foo(x, wrap(6)) isa String


let
    vars = @variables t a b(a) c(..) x[1:2] y(t)[1:3] z(..)[1:2]
    vars2 = [Symbolics.rename(v, Symbol(Symbolics.getname(v), "_2")) for v in vars]

    for (v, v2) in zip(vars, vars2)
        @test typeof(v) == typeof(v2)
        @test Symbol(Symbolics.getname(v), "_2") == Symbolics.getname(v2)
    end


    @test Symbolics.getname(Symbolics.rename(y[2], :u)) === :u
end

let
    s = :y
    x = (1:2,1:3)
    t, y = @variables t $s(t)[x...]

    @test ndims(y) == 2
    @test size(y) == (2,3)
end


# Edge case when no symbolic values are passed
struct A end
Symbolics.@register_symbolic bar(t, x::A)
Symbolics.@register_symbolic baz(x, y)
if !@isdefined(bar_catchall_defined)
    @test_throws MethodError bar(0.1, A())
    @test_throws MethodError bar(Num(0.1), A())
else
    @warn("skipping 2 tests because this file was run more than once")
end

bar_catchall_defined = true
bar(t, x::A) = 1
@test bar(1, A()) == 1

let
    @variables x y
    @test bar(x, A()) isa Num
    @test bar(unwrap(x), A()) isa BasicSymbolic
    @test typeof(baz(x, unwrap(y))) == Num
    @test typeof(baz(unwrap(x), unwrap(y))) <: BasicSymbolic
end

# 402#issuecomment-1074261734
Symbolics.@register_symbolic oof(x::AbstractVector)
Symbolics.@variables x[1:100]
@test oof(x) isa Num

# Register callable structs
# 806
struct B
    x::Float64
end
(b::B)(x) = b.x * x

Symbolics.@register_symbolic (b::B)(x)

@test B(2.0)(2.0) == 4.0
let
    foo = B(2.0)
    @variables x
    @test foo(x) isa Num
    @test foo(unwrap(x)) isa BasicSymbolic
end

@variables t y(t)
yy = Symbolics.variable(:y, T = Symbolics.FnType{Tuple{Any}, Real})
yyy = yy(t)
@test isequal(yyy, y)
@test yyy isa Num
@test y isa Num
yy = Symbolics.variable(:y, T = Symbolics.FnType{Tuple, Real})
yyy = yy(t)
@test !isequal(yyy, y)
@variables y(..)
@test isequal(yyy, y(t))

spam(x) = 2x
@register_symbolic spam(x::AbstractArray)

sym = spam([a, 2a])
@test sym isa Num
@test unwrap(sym) isa BasicSymbolic{Real}

fn_defaults = [print, min, max, identity, (+), (-), max, sum, vcat, (*)]
fn_names = [Symbol(:f, i) for i in 1:10]

struct VariableFoo end
Symbolics.option_to_metadata_type(::Val{:foo}) = VariableFoo

function test_all_functions(fns)
    f1, f2, f3, f4, f5, f6, f7, f8, f9, f10 = fns
    @variables x y::Int z::Function w[1:3, 1:3] v[1:3, 1:3]::String
    @test f1 isa CallWithMetadata{FnType{Tuple, Real}}
    @test all(x -> symtype(x) <: Real, [f1(), f1(1), f1(x), f1(x, y), f1(x, y, x+y)])
    @test f2 isa CallWithMetadata{FnType{Tuple{Any, Vararg}, Int}}
    @test all(x -> symtype(x) <: Int, [f2(1), f2(z), f2(x), f2(x, y), f2(x, y, x+y)])
    @test_throws ErrorException f2()
    @test f3 isa CallWithMetadata{FnType{Tuple, Real, typeof(max)}}
    @test all(x -> symtype(x) <: Real, [f3(), f3(1), f3(x), f3(x, y), f3(x, y, x+y)])
    @test f4 isa CallWithMetadata{FnType{Tuple{Int}, Real}}
    @test all(x -> symtype(x) <: Real, [f4(1), f4(y), f4(2y)])
    @test_throws ErrorException f4(x)
    @test f5 isa CallWithMetadata{FnType{Tuple{Int, Vararg{Int}}, Real}}
    @test all(x -> symtype(x) <: Real, [f5(1), f5(y), f5(y, y), f5(2, 3)])
    @test_throws ErrorException f5(x)
    @test f6 isa CallWithMetadata{FnType{Tuple{Int, Int}, Int}}
    @test all(x -> symtype(x) <: Int, [f6(1, 1), f6(y, y), f6(1, y), f6(y, 1)])
    @test_throws ErrorException f6()
    @test_throws ErrorException f6(1)
    @test_throws ErrorException f6(x, y)
    @test_throws ErrorException f6(y)
    @test f7 isa CallWithMetadata{FnType{Tuple{Int, Int}, Int, typeof(max)}}
    # call behavior tested by f6
    @test f8 isa CallWithMetadata{FnType{Tuple{Function, Vararg}, Real, typeof(sum)}}
    @test all(x -> symtype(x) <: Real, [f8(z), f8(z, x), f8(identity), f8(identity, x)])
    @test_throws ErrorException f8(x)
    @test_throws ErrorException f8(1)
    @test f9 isa CallWithMetadata{FnType{Tuple, Vector{Real}}}
    @test all(x -> symtype(unwrap(x)) <: Vector{Real} && size(x) == (3,), [f9(), f9(1), f9(x), f9(x + y), f9(z), f9(1, x)])
    @test f10 isa CallWithMetadata{FnType{Tuple{Matrix{<:Real}, Matrix{<:Real}}, Matrix{Real}, typeof(*)}}
    @test all(x -> symtype(unwrap(x)) <: Matrix{Real} && size(x) == (3, 3), [f10(w, w), f10(w, ones(3, 3)), f10(ones(3, 3), ones(3, 3)), f10(w + w, w)])
    @test_throws ErrorException f10(w, v)
end

function test_functions_defaults(fns)
    for (fn, def) in zip(fns, fn_defaults)
        @test Symbolics.getdefaultval(fn, nothing) == def
    end
end

function test_functions_metadata(fns)
    for (i, fn) in enumerate(fns)
        @test Symbolics.getmetadata(fn, VariableFoo, nothing) == i
    end
end

fns = @test_nowarn @variables begin
    f1(..)
    f2(::Any, ..)::Int
    (f3::typeof(max))(..)
    f4(::Int)
    f5(::Int, (..)::Int)
    f6(::Int, ::Int)::Int
    (f7::typeof(max))(::Int, ::Int)::Int
    (f8::typeof(sum))(::Function, ..)
    f9(..)[1:3]
    (f10::typeof(*))(::Matrix{<:Real}, ::Matrix{<:Real})[1:3, 1:3]
    # f11[1:3](::Int)::Int
end

test_all_functions(fns)

fns = @test_nowarn @variables begin
    f1(..) = fn_defaults[1]
    f2(::Any, ..)::Int = fn_defaults[2]
    (f3::typeof(max))(..) = fn_defaults[3]
    f4(::Int) = fn_defaults[4]
    f5(::Int, (..)::Int) = fn_defaults[5]
    f6(::Int, ::Int)::Int = fn_defaults[6]
    (f7::typeof(max))(::Int, ::Int)::Int = fn_defaults[7]
    (f8::typeof(sum))(::Function, ..) = fn_defaults[8]
    f9(..)[1:3] = fn_defaults[9]
    (f10::typeof(*))(::Matrix{<:Real}, ::Matrix{<:Real})[1:3, 1:3] = fn_defaults[10]
end

test_all_functions(fns)
test_functions_defaults(fns)

fns = @variables begin
    f1(..) = fn_defaults[1], [foo = 1]
    f2(::Any, ..)::Int = fn_defaults[2], [foo = 2;]
    (f3::typeof(max))(..) = fn_defaults[3], [foo = 3;]
    f4(::Int) = fn_defaults[4], [foo = 4;]
    f5(::Int, (..)::Int) = fn_defaults[5], [foo = 5;]
    f6(::Int, ::Int)::Int = fn_defaults[6], [foo = 6;]
    (f7::typeof(max))(::Int, ::Int)::Int = fn_defaults[7], [foo = 7;]
    (f8::typeof(sum))(::Function, ..) = fn_defaults[8], [foo = 8;]
    f9(..)[1:3] = fn_defaults[9], [foo = 9;]
    (f10::typeof(*))(::Matrix{<:Real}, ::Matrix{<:Real})[1:3, 1:3] = fn_defaults[10], [foo = 10;]
end

test_all_functions(fns)
test_functions_defaults(fns)
test_functions_metadata(fns)

fns = @test_nowarn @variables begin
    f1(..), [foo = 1,]
    f2(::Any, ..)::Int, [foo = 2,]
    (f3::typeof(max))(..), [foo = 3,]
    f4(::Int), [foo = 4,]
    f5(::Int, (..)::Int), [foo = 5,]
    f6(::Int, ::Int)::Int, [foo = 6,]
    (f7::typeof(max))(::Int, ::Int)::Int, [foo = 7,]
    (f8::typeof(sum))(::Function, ..), [foo = 8,]
    f9(..)[1:3], [foo = 9,]
    (f10::typeof(*))(::Matrix{<:Real}, ::Matrix{<:Real})[1:3, 1:3], [foo = 10,]
end

test_all_functions(fns)
test_functions_metadata(fns)

fns = @test_nowarn @variables begin
    $(fn_names[1])(..)
    $(fn_names[2])(::Any, ..)::Int
    ($(fn_names[3])::typeof(max))(..)
    $(fn_names[4])(::Int)
    $(fn_names[5])(::Int, (..)::Int)
    $(fn_names[6])(::Int, ::Int)::Int
    ($(fn_names[7])::typeof(max))(::Int, ::Int)::Int
    ($(fn_names[8])::typeof(sum))(::Function, ..)
    $(fn_names[9])(..)[1:3]
    ($(fn_names[10])::typeof(*))(::Matrix{<:Real}, ::Matrix{<:Real})[1:3, 1:3]
end

test_all_functions(fns)

# Tests that variables can be declared using vectors of dependants.
let
    @variables x y z v w
    args1 = [x]
    args2 = [x, y]
    args3 = [x, y, z]

    v1 = only(@variables X(x))
    v2 = only(@variables X(args1...))
    @test isequal(v1, v2)

    v1 = only(@variables X(x,y))
    v2 = only(@variables X(args3[1:2]...))
    @test isequal(v1, v2)

    v1 = only(@variables X(x, y, z))
    v2 = only(@variables X([args2; z]...))
    @test isequal(v1, v2)

    v1 = only(@variables X(x, y, z, v))
    v2 = only(@variables X(vcat(args2, [z, v])...))
    @test isequal(v1, v2)

    v1 = only(@variables X(x, y, z, v, w))
    v2 = only(@variables X([v for v in [args3; [v, w]]]...))
    @test isequal(v1, v2)
end

@testset "Unwrap defaults and other metadata" begin
    @variables a b[1:2]
    @variables x = a [foo = 1 + a]
    @variables y = b [foo = [a, b[1]]]

    @test getdefaultval(x) isa BasicSymbolic
    @test Symbolics.getmetadata(unwrap(x), VariableFoo, nothing) isa BasicSymbolic
    @test getdefaultval(y) isa BasicSymbolic
    @test Symbolics.getmetadata(unwrap(y), VariableFoo, nothing) isa Vector{<:BasicSymbolic}
end

@testset "`hash(::CallWithMetadata)` is consistent with `isequal`" begin
    @variables f(..)
    ff = setmetadata(f, Int, 3)
    @test isequal(f, ff)
    @test hash(f) == hash(ff)
end

using Symbolics, Test, SparseArrays
@variables a b c

# Auxiliary Functions
get_sparsity_pattern(h::Union{SparseVector{Num}, SparseMatrixCSC{Num,Int}}) = get_sparsity_pattern(Array(h))
get_sparsity_pattern(h::Array{Num}) = sparse(Int.(.!isequal.(h, 0)))

input = [1, 2, 3]

# ===== Dense tests =====
# Arrays of Matrices
h_dense_arraymat = [[a 1; b 0], [0 0; 0 0], [a c; 1 0]] # empty array support required
function h_dense_arraymat_julia!(out, x)
    a, b, c = x
    out[1] .= [a[1] 1; b[1] 0]
    out[2] .= [0 0; 0 0]
    out[3] .= [a[1] c[1]; 1 0]
end

h_dense_arraymat_ip! = eval(Symbolics.build_function(h_dense_arraymat, [a, b, c])[2])
h_dense_arraymat_ip_skip! = eval(Symbolics.build_function(h_dense_arraymat, [a, b, c], skipzeros=true, fillzeros=false)[2])
out_1_arraymat = [fill(42, 2, 2) for i in 1:3]
out_2_arraymat = deepcopy(out_1_arraymat)
h_dense_arraymat_julia!(out_1_arraymat, input)
h_dense_arraymat_ip_skip!(out_2_arraymat, input)
@test all(isequal(42), out_2_arraymat[2])
foreach(mat->fill!(mat, 0), out_2_arraymat)
h_dense_arraymat_ip_skip!(out_2_arraymat, input)
@test out_1_arraymat == out_2_arraymat
h_dense_arraymat_ip!(out_2_arraymat, input)
@test out_1_arraymat == out_2_arraymat

# Arrays of Matrices, Heterogeneous element types
test_exp = [exp(a) * exp(b), a]
h_dense_arraymat_het = [Symbolics.hessian(t, [a, b]) for t in test_exp]
function h_dense_arraymat_het_julia!(out, x)
    a, b, c = x
    out[1] .= [exp(a[1]) * exp(b[1]) exp(a[1]) * exp(b[1]); exp(a[1]) * exp(b[1]) exp(a[1]) * exp(b[1])]
    out[2] .= [0 0; 0 0]
end

h_dense_arraymat_het_str = Symbolics.build_function(h_dense_arraymat_het, [a, b, c])
h_dense_arraymat_het_cse_str = Symbolics.build_function(h_dense_arraymat_het, [a, b, c], cse=true)
h_dense_arraymat_het_ip! = eval(h_dense_arraymat_het_str[2])
h_dense_arraymat_het_cse_ip! = eval(h_dense_arraymat_het_cse_str[2])
out_1_arraymat_het = [Array{Float64}(undef, 2, 2) for i in 1:2]
out_2_arraymat_het = [similar(x) for x in out_1_arraymat_het]
out_3_arraymat_het = [similar(x) for x in out_1_arraymat_het]
h_dense_arraymat_het_julia!(out_1_arraymat_het, input)
h_dense_arraymat_het_ip!(out_2_arraymat_het, input)
h_dense_arraymat_het_cse_ip!(out_3_arraymat_het, input)
@test out_1_arraymat_het == out_2_arraymat_het == out_3_arraymat_het

# Arrays of 1D Vectors
h_dense_arrayvec = [[a, 0, c], [0, 0, 0], [1, a, b]] # same for empty vectors, etc.
function h_dense_arrayvec_julia!(out, x)
    a, b, c = x
    out[1] .= [a[1], 0, c[1]]
    out[2] .= [0, 0, 0]
    out[3] .= [1, a[1], b[1]]
end

h_dense_arrayvec_str = Symbolics.build_function(h_dense_arrayvec, [a, b, c])
h_dense_arrayvec_ip! = eval(h_dense_arrayvec_str[2])
out_1_arrayvec = [Vector{Int64}(undef, 3) for i in 1:3]
out_2_arrayvec = [Vector{Int64}(undef, 3) for i in 1:3]
h_dense_arrayvec_julia!(out_1_arrayvec, input)
h_dense_arrayvec_ip!(out_2_arrayvec, input)
@test out_1_arrayvec == out_2_arrayvec

# Arrays of Arrays of Matrices
h_dense_arrayNestedMat = [[[a 1; b 0], [0 0; 0 0]], [[b 1; a 0], [b c; 0 1]]]
function h_dense_arrayNestedMat_julia!(out, x)
    a, b, c = x
    out[1][1] .= [a[1] 1; b[1] 0]
    out[1][2] .= [0 0; 0 0]
    out[2][1] .= [b[1] 1; a[1] 0]
    out[2][2] .= [b[1] c[1]; 0 1]
end

h_dense_arrayNestedMat_str = Symbolics.build_function(h_dense_arrayNestedMat, [a, b, c])
h_dense_arrayNestedMat_ip! = eval(h_dense_arrayNestedMat_str[2])
out_1_arrayNestedMat = [[rand(Int64, 2, 2), rand(Int64, 2, 2)], [rand(Int64, 2, 2), rand(Int64, 2, 2)]] # avoid undef broadcasting issue
out_2_arrayNestedMat = [[rand(Int64, 2, 2), rand(Int64, 2, 2)], [rand(Int64, 2, 2), rand(Int64, 2, 2)]]
h_dense_arrayNestedMat_julia!(out_1_arrayNestedMat, input)
h_dense_arrayNestedMat_ip!(out_2_arrayNestedMat, input)
@test out_1_arrayNestedMat == out_2_arrayNestedMat

# Arrays of Arrays of Matrices, Heterogeneous element types
test_exp = [exp(a) * exp(b), a]
h_dense_arrayNestedMat_het = [[Symbolics.hessian(t, [a, b]) for t in test_exp], [Num[0 0; 0 0], Num[0 0; 0 0]]]
function h_dense_arrayNestedMat_het_julia!(out, x)
    a, b, c = x
    out[1][1] .= [exp(a[1]) * exp(b[1]) exp(a[1]) * exp(b[1]); exp(a[1]) * exp(b[1]) exp(a[1]) * exp(b[1])]
    out[1][2] .= [0 0; 0 0]
    out[2][1] .= [0 0; 0 0]
    out[2][2] .= [0 0; 0 0]
end
h_dense_arrayNestedMat_het_str = Symbolics.build_function(h_dense_arrayNestedMat_het, [a, b, c])
h_dense_arrayNestedMat_het_ip! = eval(h_dense_arrayNestedMat_het_str[2])
out_1_arrayNestedMat_het = [[rand(Int64, 2, 2), rand(Int64, 2, 2)], [rand(Int64, 2, 2), rand(Int64, 2, 2)]] # avoid undef broadcasting issue
out_2_arrayNestedMat_het = [[rand(Int64, 2, 2), rand(Int64, 2, 2)], [rand(Int64, 2, 2), rand(Int64, 2, 2)]]
h_dense_arrayNestedMat_julia!(out_1_arrayNestedMat_het, input)
h_dense_arrayNestedMat_ip!(out_2_arrayNestedMat_het, input)
@test out_1_arrayNestedMat_het == out_2_arrayNestedMat_het

# ===== Sparse tests =====
# Array of Matrices
h_sparse_arraymat = sparse.([[a 1; b 0], [0 0; 0 0], [a c; 1 0]])
function h_sparse_arraymat_julia!(out, x)
    a, b, c = x
    out[1][1, 1] = a[1]
    out[1][1, 2] = 1
    out[1][2, 1] = b[1]
    out[2] = sparse([0 0; 0 0]) # no undef constructor for SparseMatrixCSC
    out[3][1, 1] = a[1]
    out[3][1, 2] = c[1]
    out[3][2, 1] = 1
end

h_sparse_arraymat_str = Symbolics.build_function(h_sparse_arraymat, [a, b, c])
h_sparse_arraymat_ip! = eval(h_sparse_arraymat_str[2])
h_sparse_arraymat_sparsity_patterns = map(get_sparsity_pattern, h_sparse_arraymat)
out_1_arraymat = [similar(h) for h in h_sparse_arraymat_sparsity_patterns]
out_2_arraymat = [similar(h) for h in h_sparse_arraymat_sparsity_patterns] # can't do similar() because it will just be #undef, with the wrong sparsity pattern
h_sparse_arraymat_ip!(out_2_arraymat, input)
h_sparse_arraymat_julia!(out_1_arraymat, input)
@test out_1_arraymat == out_2_arraymat

# Array of 1D Vectors
h_sparse_arrayvec = sparse.([[a, 0, c], [0, 0, 0], [1, a, b]])
function h_sparse_arrayvec_julia!(out, x)
    a, b, c = x
    out[1][1] = a[1]
    out[1][3] = c[1]
    out[2] = sparse([0, 0, 0]) # necessary because sparsity pattern is 3 elements with 0 stored, not 0 elements
    out[3][1] = 1
    out[3][2] = a[1]
    out[3][3] = b[1]
end

h_sparse_arrayvec_str = Symbolics.build_function(h_sparse_arrayvec, [a, b, c])
h_sparse_arrayvec_ip! = eval(h_sparse_arrayvec_str[2])
h_sparse_arrayvec_sparsity_patterns = map(get_sparsity_pattern, h_sparse_arrayvec)
out_1_arrayvec = [similar(h) for h in h_sparse_arrayvec_sparsity_patterns]
out_2_arrayvec = [similar(h) for h in h_sparse_arrayvec_sparsity_patterns]
h_sparse_arrayvec_julia!(out_1_arrayvec, input)
h_sparse_arrayvec_ip!(out_2_arrayvec, input)
@test out_1_arrayvec == out_2_arrayvec

# Arrays of Arrays of Matrices
h_sparse_arrayNestedMat = [sparse.([[a 1; b 0], [0 0; 0 0]]), sparse.([[b 1; a 0], [b c; 0 1]])]
function h_sparse_arrayNestedMat_julia!(out, x)
    a, b, c = x
    out[1][1][1, 1] = a[1]
    out[1][1][1, 2] = 1
    out[1][1][2, 1] = b[1]
    out[1][2] = sparse([0 0; 0 0])
    out[2][1][1, 1] = b[1]
    out[2][1][1, 2] = 1
    out[2][1][2, 1] = a[1]
    out[2][2][1, 1] = b[1]
    out[2][2][1, 2] = c[1]
    out[2][2][2, 2] = 1
end

h_sparse_arrayNestedMat_str = Symbolics.build_function(h_sparse_arrayNestedMat, [a, b, c])
h_sparse_arrayNestedMat_ip! = eval(h_sparse_arrayNestedMat_str[2])
h_sparse_arrayNestedMat_sparsity_patterns = [map(get_sparsity_pattern, h) for h in h_sparse_arrayNestedMat]
out_1_arrayNestedMat = [[similar(h_sub) for h_sub in h] for h in h_sparse_arrayNestedMat_sparsity_patterns]
out_2_arrayNestedMat = [[similar(h_sub) for h_sub in h] for h in h_sparse_arrayNestedMat_sparsity_patterns]
h_sparse_arrayNestedMat_julia!(out_1_arrayNestedMat, input)
h_sparse_arrayNestedMat_ip!(out_2_arrayNestedMat, input)
@test out_1_arrayNestedMat == out_2_arrayNestedMat

# Additional Tests
# Returning 0-element structures (corresponding to empty Jacobians)
# Arrays of Matrices
h_empty = [[a b; c 0], Array{Num,2}(undef, 0,0)]
h_empty_str = Symbolics.build_function(h_empty, [a, b, c])
h_empty_ip! = eval(h_empty_str[2])
out = [Matrix{Int64}(undef, 2, 2), Matrix{Int64}(undef, 0, 0)]
h_empty_ip!(out, input) # should just not fail

# Array of Vectors
h_empty_vec = [[a, b, c, 0], Vector{Num}(undef,0)]
h_empty_vec_str = Symbolics.build_function(h_empty_vec, [a, b, c])
h_empty_vec_ip! = eval(h_empty_vec_str[2])
out = [Vector{Int64}(undef, 4), Vector{Int64}(undef, 0)]
h_empty_vec_ip!(out, input) # should just not fail

# Arrays of Arrays of Matrices
h_emptyNested = [[[a b; c 0]], Array{Array{Num, 2}}(undef, 0)] # emptyNested array of arrays
h_emptyNested_str = Symbolics.build_function(h_emptyNested, [a, b, c])
h_emptyNested_ip! = eval(h_emptyNested_str[2])
out = [[[1 2;3 4]], Array{Array{Int64,2},1}(undef, 0)]
h_emptyNested_ip!(out, input) # should just not fail

@testset "_recursive_unwrap does not drop non-structural zeros" begin
    A = sparse([0 1 1 0; 0 0 0 1; 0 1 0 0; 0 1 0 1; 0 0 0 0])
    @test nnz(A) == 6
    A[1, 2] = 0
    A[1, 3] = 0
    A = Symbolics._recursive_unwrap(A)
    @test nnz(A) == 6
    @test size(A) == (5, 4)

    A = sparse([sparse([0, 1, 1, 0]), sparse([0, 0, 0, 1]), sparse([0, 0, 0, 0])])
    @test nnz(A[1]) == 2
    @test nnz(A[2]) == 1
    A[1][2] = 0
    A[2][4] = 0
    A = Symbolics._recursive_unwrap(A)
    @test nnz(A[1]) == 2
    @test nnz(A[2]) == 1
    @test length(A[1]) == 4
end

"""
    $TYPEDEF

Wrapper type for symbolic structs. Requires that the wrapped struct type `T` be registered
with [`@symstruct`](@ref). After registration, `@variables` can be used to create the
symbolic struct.

```julia
# Here, `record` has type `SymStruct{Record}`
@variables record::Record
```

`getproperty` access on this is a symbolic operation, and returns an expression performing
the appropriate field access. This can only wrap concrete struct types (`isconcretetype(T)`
must be `true`). `getproperty` on this struct leverages `fieldnames` and `fieldtypes`.
Thus, will thus not respect custom `getproperty` methods on the wrapped struct type.

`SymStruct{T}` subtypes `AbstractVector{Symbolics.SymbolicT}`. For a fully registered type
where all fields (including those of nested symbolic structs) are of known size, `SymStruct{T}`
can be linearly indexed to access fields in order. Array fields are indexed linearly.
"""
struct SymStruct{T}
    sym::SymbolicT

    function SymStruct{T}(x::SymbolicT) where {T}
        @assert isconcretetype(T)
        # Ensure wrapped types have been registered as such
        @assert wrapper_type(T) === SymStruct{T}
        # Ensure that the symbolic represents the correct type
        @assert symtype(x) === T
        new{T}(x)
    end
end

is_wrapper_type(::Type{SymStruct}) = false
is_wrapper_type(::Type{S}) where {T, S <: SymStruct{<:T}} = true
wraps_type(::Type{S}) where {T, S <: SymStruct{T}} = T
iswrapped(::SymStruct{T}) where {T} = true

"""
    issymstruct(x) -> Bool

Return `true` if `x` is a `SymStruct` or a symbolic expression whose `symtype` has been
registered via [`@symstruct`](@ref). Return `false` otherwise.
"""
issymstruct(x) = false
issymstruct(x::SymStruct) = true
function issymstruct(x::SymbolicT)
    T = symtype(x)
    return has_symwrapper(T)::Bool && wrapper_type(T)::DataType === SymStruct{T}
end

SymbolicUtils.unwrap(x::SymStruct) = getfield(x, 1)
SymbolicUtils.infer_vartype(::Type{SymStruct{T}}) where {T} = VartypeT

function Base.isequal(a::SymStruct{T}, b::SymStruct{T}) where {T}
    isequal(unwrap(a), unwrap(b))
end
Base.isequal(a::SymStruct{T}, b::SymbolicT) where {T} = isequal(unwrap(a), b)
Base.isequal(a::SymbolicT, b::SymStruct{T}) where {T} = isequal(a, unwrap(b))
Base.hash(a::SymStruct{T}, h::UInt64) where {T} = hash(unwrap(a), h)

function field_shape end

"""
    @symstruct Foo{T1, T2, ...}
    @symstruct Foo{T1, T2, ...} begin
      # options...
    end

A macro which enables using type `Foo` with `SymStruct` as a symbolic struct. The first
argument to the macro must be the struct type, with all type parameters named. The optional
second argument is an optional `begin..end` block containing options that influence the
behavior of the macro. The following options are allowed:

- `shape(:field) = # expression`. For array fields, the shape of the field cannot be
  inferred from the type. In case the type of the field can be inferred from the
  type, it can be specified using this syntax. The expression must evaluate to an object of type
  `Union{SymbolicUtils.Unknown, AbstractVector{UnitRange{Int}}, Tuple{Vararg{UnitRange{Int}}}}`.
  The expression has access to the concrete type of the struct being accessed, with all
  type parameters available as declared in the first argument.

For example, given the following struct:

```julia
struct Record{T}
  x::Int
  y::Real
  z::T
end
```

It can be registered as

```julia
# Note: the type parameter must be declared, but the name itself does not matter
@symstruct Record{V} begin
# If `V` is an `AbstractVector` then field `z` is a 3-vector. Otherwise, it is a scalar.
  shape(:z) = V <: AbstractVector ? [1:3] : ()
end
```

Now,

```julia
@variables rec::Record{Int} rec2::Record{Vector{Int}}
```

`rec.x`, `rec2.x` will be `Num`s with symtype `Int`. `rec.y` and `rec2.y` will be `Num`s
with symtype `Real`. `rec.z` will be a `Num` with symtype `Int`. `rec2.z` will be an
`Arr{Num, 1}` with symtype `Vector{Int}` and shape `[1:2]`.

In case the shape of a field is not provided, it will be inferred from the type. For
`AbstractArray` subtypes, it will be `SymbolicUtils.Unknown(ndims(arr_type))`. Otherwise,
it will be treated as a scalar.
"""
macro symstruct(T, opts = Expr(:block))
    block = Expr(:block)
    where_args = Expr[]
    nocurly_name = T
    if Meta.isexpr(T, :curly)
        for x in @view(T.args[2:end])
            push!(where_args, esc(x))
        end
        nocurly_name = T.args[1]
    end
    T = esc(T)
    nocurly_name = esc(nocurly_name)
    temp_typevar = :S
    push!(block.args, quote
        function (::$(typeof(has_symwrapper)))(::Type{$temp_typevar}) where {$(where_args...), $temp_typevar <: $T}
            true
        end
        function (::$(typeof(wrapper_type)))(::Type{$temp_typevar}) where {$(where_args...), $temp_typevar <: $T}
            isconcretetype($temp_typevar) ? $SymStruct{$temp_typevar} : $SymStruct{<:$temp_typevar}
        end
    end)

    @assert Meta.isexpr(opts, :block) """
    Options to `@symstruct` must be specified as a `begin...end` block. Got $opts.
    """
    for stmt in opts.args
        stmt isa LineNumberNode && continue
        @assert Meta.isexpr(stmt, :(=)) """
        Each option to `@symstruct` must be of the form `option(args...) = value`. \
        Got $stmt.
        """
        head, val = stmt.args
        @assert Meta.isexpr(head, :call) """
        Each option to `@symstruct` must be of the form `option(args...) = value`. \
        Got $head instead of `option(args...)`.
        """
        opt = head.args[1]
        args = @view(head.args[2:end])
        if opt === :shape
            @assert length(args) == 1 """
            The `shape` option must be of the form `shape(:field_name) = value`. Instead \
            of a single argument `:field_name`, multiple arguments $args were found.
            """
            @assert args[1] isa QuoteNode """
            The field name provided to the `shape` option must be a literal `Symbol`.
            Found `$(args[1])`.
            """
            field = args[1]
            push!(block.args, __field_shape_expr(T, field, where_args, val))
        else
            error("Unsupported option $opt.")
        end
    end

    return block
end

function __field_shape_expr(T::Union{Symbol, Expr}, field::QuoteNode,
                            where_args::Vector{Expr}, val::Union{Expr, Symbol})
    quote
        function (::$(typeof(field_shape)))(sym::Type{S}, ::Val{$field}) where {$(where_args...), S <: $T}
            val = $(esc(val))
            if val isa $(SymbolicUtils.Unknown)
                return val
            elseif val isa $(SymbolicUtils.ShapeVecT)
                return val
            elseif val isa $(AbstractVector{UnitRange{Int}})
                return $(SymbolicUtils.ShapeVecT)(val)
            elseif val isa $(Tuple{Vararg{UnitRange{Int}}})
                return $(SymbolicUtils.ShapeVecT)(val)
            else
                error("""
                Invalid usage of `@symstruct` macro for type $($T). The shape for field \
                $($field) was specified incorrectly. The result of the expression must be \
                one of `SymbolicUtils.Unknown`, `AbstractVector{UnitRange{Int}}` or \
                `Tuple{Vararg{UnitRange{Int}}}`. Found a value of type $(typeof(val)).
                """)
            end
        end
    end
end

# Generated `if..elseif..else` chain for `getproperty`.
@generated function Base.getproperty(sym::SymStruct{T}, name::Symbol) where {T}
    chain = Expr(:if)
    cur = chain
    for fname in fieldnames(T)
        fname = Meta.quot(fname)
        push!(cur.args, :(name === $fname))
        push!(cur.args, :(return $_literal_getproperty(sym, Val{$fname}())))
        push!(cur.args, Expr(:elseif))
        cur = cur.args[end]
    end
    cur.head = :block
    push!(cur.args, quote
        if @isdefined(FieldError)
            throw(FieldError($T, name))
        else
            error("type $($T) has no field $(name). Available fields are $($(fieldnames(T)))")
        end
    end)
    return chain
end

"""
    $TYPEDEF

Struct used as operation for symbolic getproperty on `SymStruct{T}` with field `field`.
"""
struct SymbolicGetproperty{T, field} end

"""
    field_name(f::SymbolicGetproperty{T, field}) -> Symbol

Return the name of the struct field accessed by `f`.
"""
field_name(::SymbolicGetproperty{T, field}) where {T, field} = field

function (f::SymbolicGetproperty{T})(x::SymbolicT) where {T}
    unwrap(f(SymStruct{T}(x)))
end
function (::SymbolicGetproperty{T, field})(x::SymStruct{T}) where {T, field}
    _literal_getproperty(x, Val{field}())
end
function (::SymbolicGetproperty{T, field})(x::T) where {T, field}
    getproperty(x, field)
end

function SymbolicUtils.promote_symtype(::SymbolicGetproperty{T, field}, x::SymbolicUtils.TypeT) where {T, field}
    @assert x == T
    fieldtype(x, field)
end

function SymbolicUtils.promote_shape(::SymbolicGetproperty{T, field},
                                     @nospecialize(x::SymbolicUtils.ShapeT)) where {T, field}
    @assert x isa SymbolicUtils.ShapeVecT && isempty(x)
    field_shape(T, Val{field}())
end

"""
    $TYPEDSIGNATURES

Called by the generated `getproperty` for `SymStruct`. Performs symbolic field access.
"""
function _literal_getproperty(sym::SymStruct{T}, ::Val{name}) where {T, name}
    fT = fieldtype(T, name)
    fShape = field_shape(T, Val{name}())
    fname = BSImpl.Const{VartypeT}(name)
    _struct = unwrap(sym)
    args = ArgsT{VartypeT}((_struct,))
    val = BSImpl.Term{VartypeT}(SymbolicGetproperty{T, name}(), args; type = fT, shape = fShape)
    if has_symwrapper(fT)
        return wrapper_type(fT)(val)
    else
        return val
    end
end

"""
    $TYPEDSIGNATURES

Obtain the shape of the value obtained by accessing field `name` of type `T`. Only
implemented by `@symstruct` via the `shape` option.
"""
function field_shape(::Type{T}, ::Val{name}) where {T, name}
    shape_from_type(fieldtype(T, name))
end

"""
    shape_from_type(::Type{T})

Infer the symbolic shape of a value of type `T`. For `AbstractArray{E, N}` subtypes,
returns `SymbolicUtils.Unknown(N)` (unknown shape with known rank). For all other types,
returns an empty `ShapeVecT`, indicating a scalar.
"""
shape_from_type(::Type{A}) where {T, N, A <: AbstractArray{T, N}} = SymbolicUtils.Unknown(N)
shape_from_type(::Type{T}) where {T} = SymbolicUtils.ShapeVecT()

function SymbolicUtils.show_call(io::IO, @nospecialize(f::SymbolicGetproperty), x::SymbolicT)
    fname = field_name(f)::Symbol
    @match x begin
        BSImpl.Term(; args) => print(io, args[1])
    end
    print(io, ".")
    print(io, fname)
end

function Base.show(io::IO, x::SymStruct)
    show(io, unwrap(x))
end

function SymbolicUtils.Code.function_to_expr(@nospecialize(f::SymbolicGetproperty), x::SymbolicT, st)
    out = get(st.rewrites, x, nothing)
    out === nothing  || return out

    fname = field_name(f)::Symbol
    args = @match x begin
        BSImpl.Term(; args) => args
    end
    return :($(SymbolicUtils.Code.toexpr(args[1], st)).$fname)
end

"""
    symstruct_field_supports_linear_indexing(::Type{T}, ::Val{field}) -> Bool

Return `true` if field `field` of struct type `T` can participate in linear indexing of a
`SymStruct{T}`. A field is indexable when its shape is fully known (i.e. not
`SymbolicUtils.Unknown`). Nested `SymStruct` fields are recursively checked via
[`symstruct_supports_linear_indexing`](@ref).
"""
function symstruct_field_supports_linear_indexing(::Type{T}, ::Val{field}) where {T, field}
    fT = fieldtype(T, field)
    if has_symwrapper(fT) && wrapper_type(fT) === SymStruct{fT}
        return symstruct_supports_linear_indexing(fT)
    end
    if fT <: Union{AbstractArray, Tuple}
        efT = eltype(fT)
        return field_shape(T, Val{field}()) isa SU.ShapeVecT && (
            !has_symwrapper(efT) || wrapper_type(efT) !== SymStruct{efT} ||
                symstruct_supports_linear_indexing(efT)
        )
    end
    return field_shape(T, Val{field}()) isa SU.ShapeVecT
end

"""
    symstruct_supports_linear_indexing(::Type{T}) -> Bool

Return `true` if every field of struct type `T` supports linear indexing, meaning that a
`SymStruct{T}` can be indexed with a single integer via `getindex`. This requires each
field (and any nested `SymStruct` fields) to have a fully known, statically determinable
shape.
"""
@generated function symstruct_supports_linear_indexing(::Type{T}) where {T}
    expr = Expr(:&&)
    for i in 1:fieldcount(T)
        fnameval = Val{fieldname(T, i)}()
        push!(expr.args, :($symstruct_field_supports_linear_indexing(T, $fnameval)))
    end
    return expr
end

"""
    symstruct_field_length(::Type{T}, ::Val{field}) -> Int

Return the number of scalar symbolic elements contributed by field `field` of struct type
`T` to the linear index space of a `SymStruct{T}`. Scalars contribute `1`, arrays
contribute the product of their shape ranges, and nested `SymStruct` fields contribute
their own [`symstruct_length`](@ref).
"""
function symstruct_field_length(::Type{T}, ::Val{field}) where {T, field}
    fT = fieldtype(T, field)
    if has_symwrapper(fT) && wrapper_type(fT) === SymStruct{fT}
        return symstruct_length(fT)
    end
    # The entire function is well-inferred, and this edge case
    # allows const-prop to collapse `symstruct_length` to a constant
    # when all fields are scalars.
    if !(fT <: Union{AbstractArray, Tuple})
        return 1
    end
    efT = eltype(fT)
    baselen = prod(length, field_shape(T, Val{field}())::SU.ShapeVecT; init = 1)
    if has_symwrapper(efT) && wrapper_type(efT) === SymStruct{efT}
        return baselen * symstruct_length(efT)
    end
    return baselen
end

"""
    symstruct_length(::Type{T}) -> Int

Return the total number of scalar symbolic elements in the linear index space of a
`SymStruct{T}`, equal to the sum of [`symstruct_field_length`](@ref) over all fields.
This is the value returned by `length` on a `SymStruct{T}` instance.
"""
@generated function symstruct_length(::Type{T}) where {T}
    expr = Expr(:call, (+))
    for i in 1:fieldcount(T)
        push!(expr.args, :($symstruct_field_length(T, Val{$(QuoteNode(fieldname(T, i)))}())))
    end
    return expr
end

Base.length(s::SymStruct{T}) where {T} = symstruct_length(T)

"""
    symstruct_checkbounds([Bool], s::SymStruct{T}, idx::Integer)

Check whether linear index `idx` is within bounds for `s`. The two-argument form (without
`Bool`) throws a `BoundsError` on failure. The three-argument form with `Bool` as first
argument returns `true` or `false` without throwing.
"""
function symstruct_checkbounds(::Type{Bool}, s::SymStruct{T}, idx::Integer) where {T}
    return 1 <= idx <= symstruct_length(T)
end
function symstruct_checkbounds(s::SymStruct{T}, idx::Integer) where {T}
    symstruct_checkbounds(Bool, s, idx) || throw(BoundsError(s, idx))
end

"""
    symstruct_field_range(::Type{T}, ::Val{field}) -> UnitRange{Int}

Return the range of linear indices within a `SymStruct{T}` that correspond to field
`field`. Always starts at `1`; the upper bound equals
[`symstruct_field_length`](@ref)`(T, Val{field}())`.
"""
function symstruct_field_range(::Type{T}, ::Val{field}) where {T, field}
    return 1:symstruct_field_length(T, Val{field}())
    fT = fieldtype(T, field)
    if has_symwrapper(fT) && wrapper_type(fT) === SymStruct{fT}
        return 1:symstruct_length(fT)
    end
    # Same fast-path as in `symstruct_field_length`
    if !(fT <: Union{AbstractArray, Tuple})
        return 1:1
    end
    fshape = field_shape(T, Val{field}())::SU.ShapeVecT
    return 1:prod(length, fshape; init = 1)
end

"""
    symstruct_field_getindex(s::SymStruct{T}, ::Val{field}, i::Integer) -> SymbolicT

Return the `i`-th scalar symbolic element within field `field` of `s`. For nested
`SymStruct` fields, delegates recursively. For array fields whose elements are nested
`SymStruct`s, maps `i` to the appropriate element and inner index.
"""
function symstruct_field_getindex(s::SymStruct{T}, ::Val{field}, i::Integer) where {T, field}
    fT = fieldtype(T, field)
    if has_symwrapper(fT) && wrapper_type(fT) === SymStruct{fT}
        return getindex(SymbolicGetproperty{T, field}()(s), i)
    end
    fval = SymbolicGetproperty{T, field}()(s)
    if fval isa Num
        return unwrap(fval)
    elseif fval isa SymbolicT
        return fval
    end
    fval = unwrap(fval)
    efT = eltype(fT)
    if has_symwrapper(efT) && wrapper_type(efT) === SymStruct{efT}
        N = symstruct_length(efT)
        return SymStruct{efT}(fval[SymbolicUtils.stable_eachindex(fval)[div(i - 1, N) + 1]])[mod1(i, N)]
    end
    return fval[SymbolicUtils.stable_eachindex(fval)[i]]
end

@generated function Base.getindex(s::SymStruct{T}, idx::Integer) where {T}
    conditions = Expr[]
    bodies = Expr[]
    offset = 0
    body = Expr(:block)
    for i in 1:fieldcount(T)
        fname = fieldname(T, i)
        ftype = fieldtype(T, i)
        fieldval = Val{fieldname(T, i)}()
        push!(body.args, :(if idx in $symstruct_field_range(T, $fieldval)
            return $symstruct_field_getindex(s, $fieldval, idx)::$SymbolicT
        else
            idx -= $symstruct_field_length(T, $fieldval)
        end))
    end

    return Expr(:block, Expr(:call, symstruct_checkbounds, :s, :idx), body, :(error("Unreachable")))
end

function Base.iterate(s::SymStruct{T}) where {T}
    return (s[1], 2)
end
function Base.iterate(s::SymStruct{T}, i::Int) where {T}
    i > length(s) && return nothing
    return (s[i], i + 1)
end
Base.eltype(s::SymStruct) = SymbolicT

"""
    rootfunction(f)

Given a function `f` with a discontinuity or discontinuous derivative, return the rootfinding
function of `f`. The rootfinding function `g` takes the same arguments as `f`, and is such
that `f` can be described as a piecewise function based on the sign of `g`, where each piece
is continuous and has a continuous derivative. The pieces are obtained using
`left_continuous_function(f)` and `right_continuous_function(f)`.

More formally,
```julia
f(args...) = if g(args...) < 0
    left_continuous_function(f)(args...)
else
    right_continuous_function(f)(args...)
end
```

For example, if `f` is `max(x, y)`, the root function is `(x, y) -> x - y` with
`left_continuous_function` as `(x, y) -> y` and `right_continuous_function` as
`(x, y) -> x`.

See also: [`left_continuous_function`](@ref), [`right_continuous_function`](@ref).
"""
function rootfunction end

"""
    left_continuous_function(f)

Given a function `f` with a discontinuity or discontinuous derivative, return a function
taking the same arguments as `f` which is continuous and has a continuous derivative
when `rootfinding_function(f)` is negative.

See also: [`rootfunction`](@ref).
"""
function left_continuous_function end

"""
    right_continuous_function(f)

Given a function `f` with a discontinuity or discontinuous derivative, return a function
taking the same arguments as `f` which is continuous and has a continuous derivative
when `rootfinding_function(f)` is positive.

See also: [`rootfunction`](@ref).
"""
function right_continuous_function end

"""
    @register_discontinuity f(arg1, arg2, ...) root_expr left_expr right_expr

Utility macro to register functions with discontinuities. The function `f` with
arguments `arg1, arg2, ...` has a `rootfunction` of `root_expr`, a
`left_continuous_function` of `left_expr` and `right_continuous_function` of
`right_expr`. `root_expr`, `left_expr` and `right_expr` are all expressions in terms
of `arg1, arg2, ...`.

For example, `max(x, y)` can be registered as `@register_discontinuity max(x, y) x - y y x`.

See also: [`rootfunction`](@ref)
"""
macro register_discontinuity(f, root, left, right)
    Meta.isexpr(f, :call) || error("Expected function call as first argument")
    args = f.args[2:end]
    fn = esc(f.args[1])
    rootname = gensym(:root)
    symbolic_check_expr = Expr(:||)
    for arg in args
        push!(symbolic_check_expr.args, :($unwrap($arg) isa $SymbolicT))
    end
    rootfn = :(function $rootname($(args...))
        $root
    end)
    leftname = gensym(:left)
    leftfn = :(function $leftname($(args...))
        result = $left
        if $symbolic_check_expr
            result = $SConst(result)
        end
        return result
    end)
    rightname = gensym(:right)
    rightfn = :(function $rightname($(args...))
        result = $right
        if $symbolic_check_expr
            result = $SConst(result)
        end
        return result
    end)
    return quote
        $rootfn
        (::$typeof($rootfunction))(::$typeof($fn)) = $rootname
        $leftfn
        (::$typeof($left_continuous_function))(::$typeof($fn)) = $leftname
        $rightfn
        (::$typeof($right_continuous_function))(::$typeof($fn)) = $rightname
    end
end

# a triangle function which is zero when x is a multiple of period
function _triangle(x, period)
    x /= 2period
    abs(x + 1 // 4 - floor(x + 3 // 4)) - 1 // 2
end

@register_discontinuity abs(x) x -x x
# just needs a rootfind to hit the discontinuity
@register_discontinuity mod(x, y) _triangle(x, y) mod(x, y) mod(x, y)
@register_discontinuity rem(x, y) _triangle(x, y) rem(x, y) rem(x, y)
@register_discontinuity div(x, y) _triangle(x, y) div(x, y) div(x, y)
@register_discontinuity max(x, y) x - y y x
@register_discontinuity min(x, y) x - y x y
@register_discontinuity NaNMath.max(x, y) x - y y x
@register_discontinuity NaNMath.min(x, y) x - y x y
@register_discontinuity <(x, y) x - y true false
@register_discontinuity <=(x, y) y - x false true
@register_discontinuity >(x, y) y - x true false
@register_discontinuity >=(x, y) x - y false true

"""
    majorization_function(f)

Given a function `f`, return a majorization function `m` for `f`. The function `m` should
have the signature `m(k, args...)` where `args...` are the same arguments as `f`. `k` is a
`Real` value which acts as an approximation factor. For higher `k`, the function `m` should
more closely approximate `f` over the domain. A majorization function is such that
`m(k, args...) >= f(args...)` for all `args...` in the domain.
"""
function majorization_function end

"""
    minorization_function(f)

Given a function `f`, return a minorization function `m` for `f`. The function `m` should
have the signature `m(k, args...)` where `args...` are the same arguments as `f`. `k` is a
`Real` value which acts as an approximation factor. For higher `k`, the function `m` should
more closely approximate `f` over the domain. A minorization function is such that
`m(k, args...) <= f(args...)` for all `args...` in the domain.
"""
function minorization_function end

"""
    approximation_function(f)

Given a function `f`, return an approximation function `appr` for `f`. The function `appr` should
have the signature `appr(k, args...)` where `args..` are the same arguments as `f`. `k` is a
`Real` value acting as an approximation factor. For higher `k`, the function `appr` should more
closely approximate `f` over the domain. The function `appr` offers no guarantees other than
infinite differentiability over the domain. At any point in the domain, it may evaluate to a
value greater or less than the value returned by `f` for the same point.
"""
function approximation_function end

function _approx_max(m, a, b)
    if a isa Union{Num, SymbolicT} || b isa Union{Num, SymbolicT}
        return STerm(
            _approx_max, SArgsT((m, a, b));
            type = SU.promote_symtype(_approx_max, SU.symtype(m), SU.symtype(a), SU.symtype(b)),
            shape = SU.ShapeVecT()
        )
    end
    return (a + b + _approx_abs(m, a - b)) / 2
end

function SU.promote_symtype(::typeof(_approx_max), M::SU.TypeT, A::SU.TypeT, B::SU.TypeT)
    return SU.promote_symtype(*, SU.promote_symtype(+, A, B), M)
end

function SU.promote_shape(::typeof(_approx_max), @nospecialize(shapes::Vararg{SU.ShapeT, 3}))
    return SU.ShapeVecT()
end

function _approx_min(m, a, b)
    -_approx_max(m, -a, -b)
end

function SU.promote_symtype(::typeof(_approx_min), args::SU.TypeT...)
    return SU.promote_symtype(_approx_max, args...)
end

function SU.promote_shape(::typeof(_approx_min), @nospecialize(shapes::Vararg{SU.ShapeT, 3}))
    return SU.ShapeVecT()
end

function _approx_abs(m, a)
    return sqrt(a^2 + 1/(8m + 1))
end

function SU.promote_symtype(::typeof(_approx_abs), M::SU.TypeT, A::SU.TypeT)
    return SU.promote_symtype(*, M, A)
end

function SU.promote_shape(::typeof(_approx_abs), @nospecialize(shapes::Vararg{SU.ShapeT, 2}))
    return SU.ShapeVecT()
end

function _approx_ge(m, a, b)
    (tanh(m * ((a - b) + eps(float(typeof(m))))) + 1) / 2
end

function SU.promote_symtype(::typeof(_approx_ge), args::SU.TypeT...)
    return SU.promote_symtype(_approx_max, args...)
end

function SU.promote_shape(::typeof(_approx_ge), @nospecialize(shapes::Vararg{SU.ShapeT, 3}))
    return SU.ShapeVecT()
end

_approx_le(m, a, b) = _approx_ge(m, b, a)

function SU.promote_symtype(::typeof(_approx_le), args::SU.TypeT...)
    return SU.promote_symtype(_approx_max, args...)
end

function SU.promote_shape(::typeof(_approx_le), @nospecialize(shapes::Vararg{SU.ShapeT, 3}))
    return SU.ShapeVecT()
end

function _sigmoid(x)
    if x > 0
        return one(x) / (one(x) + exp(-x))
    else
        tmp = exp(x)
        return tmp / (1 + tmp)
    end
end

function SU.promote_symtype(::typeof(_sigmoid), T::SU.TypeT)
    return T
end

function SU.promote_shape(::typeof(_sigmoid), @nospecialize(sh::SU.ShapeT))
    return SU.ShapeVecT()
end

for T in [SymbolicT, Num]
    @eval function _sigmoid(x::$T)
        return STerm(_sigmoid, SArgsT((unwrap(x),)); type = SU.symtype(unwrap(x)), shape = SU.ShapeVecT())
    end
end

function _sigder(x)
    tmp = _sigmoid(x)
    return tmp * (1 - tmp)
end

function SU.promote_symtype(::typeof(_sigder), T::SU.TypeT)
    return T
end

function SU.promote_shape(::typeof(_sigder), @nospecialize(sh::SU.ShapeT))
    return SU.ShapeVecT()
end

function _approx_eq(m, a, b)
    # `2m` to try and make `_approx_eq` similarly steep for the same `m` as other
    # approximators.
    4_sigder(2m * (a - b))
end

function SU.promote_symtype(::typeof(_approx_eq), M::SU.TypeT, A::SU.TypeT, B::SU.TypeT)
    return SU.promote_symtype(*, SU.promote_symtype(+, A, B), M)
end

function SU.promote_shape(::typeof(_approx_eq), @nospecialize(sh::Vararg{SU.ShapeT, 3}))
    return SU.ShapeVecT()
end

approximation_function(::typeof(max)) = _approx_max
majorization_function(::typeof(max)) = _approx_max
approximation_function(::typeof(min)) = _approx_min
minorization_function(::typeof(min)) = _approx_min
approximation_function(::typeof(NaNMath.max)) = _approx_max
majorization_function(::typeof(NaNMath.max)) = _approx_max
approximation_function(::typeof(NaNMath.min)) = _approx_min
minorization_function(::typeof(NaNMath.min)) = _approx_min
approximation_function(::typeof(abs)) = _approx_abs
majorization_function(::typeof(abs)) = _approx_abs

approximation_function(::typeof(>=)) = _approx_ge
approximation_function(::typeof(>)) = _approx_ge
approximation_function(::typeof(<=)) = _approx_le
approximation_function(::typeof(<)) = _approx_le

approximation_function(::typeof(==)) = _approx_eq

# recursively find highest derivative order in `expr`
function _get_der_order(expr::SymbolicT, x, t)
    if !hasderiv(unwrap(expr))
        return 0
    end
    @match expr begin
        BSImpl.Term(; f, args) && if f isa Differential && isequal(f.x, t) && isequal(args[1], x) end => begin
            return f.order
        end
        _ => begin
            best = 0
            args = arguments(expr)
            for arg in args
                _order = _get_der_order(arg, x, t)
                best = max(best, _order)
            end
            return best
        end
    end
end
_get_der_order(eq::Equation, x, t) = max(_get_der_order(eq.lhs, x, t), _get_der_order(eq.rhs, x, t))

function reduce_rule(expr, Dt)
    iscall(expr) && isequal(operation(expr), Dt) ? wrap(arguments(expr)[1]) : nothing
end

"""
    unwrap_der(expr, Dt)

Helper function to unwrap derivatives of `f(t)` in `expr` with respect to the differential operator `Dt = Differential(t)`. Returns a tuple `(n, base_expr)`, where `n` is the order of the derivative and `base_expr` is the expression with the derivatives removed. If `expr` does not contain `f(t)` or its derivatives, returns `(0, expr)`.
"""
function unwrap_der(expr, Dt)
    expr = unwrap(expr)
    if iscall(expr) && operation(expr) isa Differential && isequal(operation(expr).x, Dt.x)
        return operation(expr).order, wrap(arguments(expr)[1])
    end
    return 0, expr
end

# takes into account fractions
function _true_factors(expr)
    expr = flatten_fractions(unwrap(expr)) # flatten nested fractions

    numerator_factors = SymbolicUtils.numerators(unwrap(expr))
    denominator_factors = SymbolicUtils.denominators(unwrap(expr))

    facs = filter(fac -> !_isone(fac), [numerator_factors; 1 ./ denominator_factors])
    return isempty(facs) ? [1] : facs
end

"""
    reduce_order(eq, x, t, ys)

Reduce order of an ODE by substituting variables for derivatives to form a system of first order ODEs
"""
function reduce_order(eq, x, t, ys)
    Dt = Differential(t)
    n = _get_der_order(eq, x, t)
    @assert n >= 1 "ODE must have at least one derivative"
    
    # reduction of order
    y_sub = Dict([[(Dt^i)(x) => ys[i+1] for i=0:n-1]; (Dt^n)(x) => variable(:𝒴)])
    eq = substitute_in_deriv(eq, y_sub)
    
    # isolate (Dt^n)(x)
    f = symbolic_linear_solve(eq, variable(:𝒴), check=false)
    @assert f !== nothing "Failed to isolate highest order derivative term"
    f = f[1]
    system = [ys[2:n]; f]

    return system
end

function unreduce_order(expr, x, t, ys)
    Dt = Differential(t)
    rev_y_sub = Dict(ys[i] => (Dt^(i-1))(x) for i in eachindex(ys))

    return substitute_in_deriv(expr, rev_y_sub)
end

function is_solution(solution, eq::Equation, x, t)
    is_solution(solution, eq.lhs - eq.rhs, x, t)
end

function is_solution(solution, eq::SymbolicLinearODE)
    is_solution(solution, get_expression(eq), eq.x, eq.t)
end

function is_solution(solution, eq, x, t)
    if solution === nothing
        return false
    end

    expr = substitute_in_deriv(eq, Dict(x => solution))
    expr = expand(expand_derivatives(expr))
    return SymbolicUtils._iszero(expr)
end

function _parse_trig(expr, t)
    if iscall(expr) && isequal(operation(expr), sin) && any(isequal.(t, factors(arguments(expr)[1])))
        return unwrap_const(arguments(expr)[1]/t), true
    end

    if iscall(expr) && isequal(operation(expr), cos) && any(isequal.(t, factors(arguments(expr)[1])))
        return unwrap_const(arguments(expr)[1]/t), false
    end

    return nothing
end

"""
    limit(expr, var, h[, side::Symbol])

Compute the limit of `expr` as `var` approaches `h`.

`side` indicates the direction from which `var` approaches `h`. It may be one of `:left`,
`:right`, or `:both`. If `side` is `:both` and the two sides do not align, an error is
thrown. Side defaults to `:both` for finite `h`, `:left` for `h = Inf`, and `:right` for
`h = -Inf`.

`expr` must be composed of `log`, `exp`, constants, and the rational operators `+`, `-`,
`*`, and `/`. This limitation may eventually be relaxed.

!!! warning
    Because symbolic limit computation is undecidable, this function necessarily employs
    heuristics and may occasionally return wrong answers. Nevertheless, please report wrong
    answers as issues as we aim to have heuristics that produce correct answers in all
    practical cases.
"""
limit(expr, var, h, side...) = SymbolicLimits.limit(expr, var, h, side...)[1]

using BenchmarkTools, Symbolics, Random, LinearAlgebra
using Symbolics: linear_expansion

const SUITE = BenchmarkGroup()

# ── matrix / linear-algebra ───────────────────────────────────────────────────

vars = @variables a, b, c, d, e, f, g, h, i

X = [0 b c;
     d e f;
     g h i]

F = lu(X)
FbyX = F \ X

x = (f + ((((g*(c^2)*(e^2)) / d - e*h*(c^2)) / b + (-c*e*f*g) / d + c*e*i) /
          (i + ((c*e*g) / d - c*h) / b + (-f*g) / d) - c*e) / b +
     ((g*(f^2)) / d + ((-c*e*f*g) / d + c*f*h) / b - f*i) /
     (i + ((c*e*g) / d - c*h) / b + (-f*g) / d)) / d

o = (d + (e*((c*(g + (-d*g) / d)) / (i + (-c*(h + (-e*g) / d)) / b + (-f*g) / d))) / b +
     (-f*(g + (-d*g) / d)) / (i + (-c*(h + (-e*g) / d)) / b + (-f*g) / d)) / d

SUITE["iszero/1"] = @benchmarkable iszero($((b*(h + (-e*g) / d)) / b + (e*g) / d - h))
SUITE["isone/1"]  = @benchmarkable FbyX == I
SUITE["iszero/2"] = @benchmarkable iszero(x)
SUITE["isone/2"]  = @benchmarkable isone(o)
SUITE["lu"]       = @benchmarkable lu(X)
SUITE["_solve"]   = @benchmarkable Symbolics._solve(X, X, true)

# ── random expression tree helpers ────────────────────────────────────────────

const _UNARY_OPS = [sin, cos, exp]

# Recursively build a random symbolic expression tree of the given depth.
# All leaf nodes are drawn from `atoms`. The RNG must be seeded before calling
# to ensure reproducibility.
function _random_expr(rng::AbstractRNG, atoms::AbstractVector, depth::Int)
    depth == 0 && return rand(rng, atoms)
    r = rand(rng)
    if r < 0.25      # unary: sin / cos / exp
        return rand(rng, _UNARY_OPS)(_random_expr(rng, atoms, depth - 1))
    elseif r < 0.50  # n-ary sum
        nargs = rand(rng, 2:4)
        return +([_random_expr(rng, atoms, depth - 1) for _ in 1:nargs]...)
    elseif r < 0.75  # n-ary product
        nargs = rand(rng, 2:3)
        return *([_random_expr(rng, atoms, depth - 1) for _ in 1:nargs]...)
    else             # binary difference
        return _random_expr(rng, atoms, depth - 1) - _random_expr(rng, atoms, depth - 1)
    end
end

# Build a linear expression in `var` with `depth` nested levels of multiplication:
#   coeff_d * (... (coeff_1 * var + b_1) ...) + b_d
# Symbolics distributes the products, yielding an Add with d+1 terms where the linear Mul
# has d+1 distinct complex factors. linear_expansion must iterate over every factor to
# locate var, so runtime scales with depth.
function _random_linear_expr_deep(
        rng::AbstractRNG, coeff_atoms::AbstractVector, var, depth::Int)
    depth == 0 && return var
    coeff      = _random_expr(rng, coeff_atoms, 2)
    const_term = _random_expr(rng, coeff_atoms, 2)
    return coeff * _random_linear_expr_deep(rng, coeff_atoms, var, depth - 1) + const_term
end

# Build n expressions (one per unknown), each linear in all variables in `unknowns`.
function _random_linear_system(
        rng::AbstractRNG, coeff_atoms::AbstractVector, unknowns::AbstractVector, depth::Int)
    n = length(unknowns)
    map(1:n) do _
        constant    = _random_expr(rng, coeff_atoms, depth)
        linear_part = sum(_random_expr(rng, coeff_atoms, depth) * u for u in unknowns)
        constant + linear_part
    end
end

# Build a linear expression in `var` with `depth` nested ifelse layers:
#   ifelse(cond_d, tc_d * inner + b_d, fc_d * inner + d_d)  where inner = depth-1 version.
# Unlike plain multiplication, Symbolics does NOT distribute `tc * ifelse(...)`, so the
# nested ifelse structure is preserved in the expression tree. linear_expansion recurses
# through each layer — into both branches of every ifelse — before reaching var.
function _random_ifelse_linear_expr_deep(
        rng::AbstractRNG, coeff_atoms::AbstractVector, var, depth::Int)
    depth == 0 && return var
    inner       = _random_ifelse_linear_expr_deep(rng, coeff_atoms, var, depth - 1)
    cond        = rand(rng, coeff_atoms) > rand(rng, coeff_atoms)
    true_coeff  = _random_expr(rng, coeff_atoms, 2)
    true_const  = _random_expr(rng, coeff_atoms, 2)
    false_coeff = _random_expr(rng, coeff_atoms, 2)
    false_const = _random_expr(rng, coeff_atoms, 2)
    return ifelse(cond, true_coeff * inner + true_const, false_coeff * inner + false_const)
end

# Build n expressions (one per unknown) each containing per-unknown ifelse terms linear
# in all variables in `unknowns`.
function _random_ifelse_linear_system(
        rng::AbstractRNG, coeff_atoms::AbstractVector, unknowns::AbstractVector, depth::Int)
    n = length(unknowns)
    map(1:n) do _
        constant = _random_expr(rng, coeff_atoms, depth)
        terms = map(unknowns) do u
            cond        = rand(rng, coeff_atoms) > rand(rng, coeff_atoms)
            true_coeff  = _random_expr(rng, coeff_atoms, depth)
            true_const  = _random_expr(rng, coeff_atoms, depth)
            false_coeff = _random_expr(rng, coeff_atoms, depth)
            false_const = _random_expr(rng, coeff_atoms, depth)
            ifelse(cond, true_coeff * u + true_const, false_coeff * u + false_const)
        end
        constant + sum(terms)
    end
end

# ── symbolic AD: expand_derivatives ──────────────────────────────────────────

@variables p q

const _ad_atoms = [p, q]
const _Dp = Differential(p)

const SUITE_AD = SUITE["AD"] = BenchmarkGroup()

for depth in (3, 5, 7, 9, 11)
    expr = _Dp(_random_expr(Xoshiro(42), _ad_atoms, depth))
    SUITE_AD["expand_derivatives/depth=$depth"] = @benchmarkable expand_derivatives($expr)
end

# ── linear_expansion ──────────────────────────────────────────────────────────

@variables r           # scalar unknown
@variables s[1:4]     # coefficient atoms
@variables w[1:64]    # vector unknowns (for matrix benchmarks)

const _le_unknown  = r
const _le_coeffs   = collect(s)
const _le_unknowns = collect(w)

const SUITE_LE = SUITE["linear_expansion"] = BenchmarkGroup()

# scalar: `coeff * linear_expr(var)` nested depth levels deep; each level adds one more
# factor to the linear Mul that linear_expansion must iterate through.
for depth in (2, 8, 32, 128, 512)
    expr = _random_linear_expr_deep(Xoshiro(42), _le_coeffs, _le_unknown, depth)
    SUITE_LE["scalar/depth=$depth"] = @benchmarkable linear_expansion($expr, $r)
end

# matrix: n×n system (n equations linear in n unknowns); coefficient depth fixed at 2
for n in (4, 8, 16, 32, 64)
    unknowns = _le_unknowns[1:n]
    eqs      = _random_linear_system(Xoshiro(42), _le_coeffs, unknowns, 2)
    SUITE_LE["matrix/n=$n"] = @benchmarkable linear_expansion($eqs, $unknowns)
end

# ifelse/scalar: `tc * ifelse_expr(var)` nested depth levels deep.
# Symbolics does not distribute multiplication into ifelse, so the tree depth is preserved.
# linear_expansion recurses through each ifelse layer in both branches before reaching var.
for depth in (2, 8, 32, 128, 512)
    expr = _random_ifelse_linear_expr_deep(Xoshiro(42), _le_coeffs, _le_unknown, depth)
    SUITE_LE["ifelse/scalar/depth=$depth"] = @benchmarkable linear_expansion($expr, $r)
end

# ifelse/matrix: n equations where each per-unknown term is an ifelse expression.
for n in (4, 8, 16, 32)
    unknowns = _le_unknowns[1:n]
    eqs      = _random_ifelse_linear_system(Xoshiro(42), _le_coeffs, unknowns, 2)
    SUITE_LE["ifelse/matrix/n=$n"] = @benchmarkable linear_expansion($eqs, $unknowns)
end

using Symbolics
using ADTypes: ADTypes
using Test

detector = SymbolicsSparsityDetector()
@test detector isa ADTypes.AbstractSparsityDetector

f(x) = reshape(vcat(x[1], diff(vec(x))), size(x))
f!(y, x) = copyto!(vec(y), vec(f(x)))

for x in (rand(4), rand(4, 5))
    @test sum(ADTypes.jacobian_sparsity(f, x, detector)) == 2length(x) - 1
    @test sum(ADTypes.jacobian_sparsity(f!, similar(x), x, detector)) == 2length(x) - 1
end

g(x) = sum(abs2, diff(vec(x)))

for x in (rand(4), rand(4, 5))
    @test sum(ADTypes.hessian_sparsity(g, x, detector)) == 3length(x) - 2
end

export @symbolic_wrap, @wrapped

# Turn A{X} <: B{Int, X} into
#
# B{Int, X} where X
function set_where(subt, supert)
    if !(supert isa Expr && supert.head == :curly)
        return supert
    end

    Ss = []
    if subt isa Expr && subt.head == :curly
        Ss = subt.args[2:end]
    end

    Ts = intersect(supert.args[2:end], Ss)
    Expr(:where, supert, Ts...)
end

function _get_type_name(x::Union{Symbol, Expr})
    x isa Symbol && return x
    @assert Meta.isexpr(x, :curly)
    return x.args[1]
end

"""
    @symbolic_wrap struct W <: T
        ...
    end

Define `W` as the symbolic wrapper type for the symbolic type `T`, and register the
correspondence between the two with Symbolics.

Symbolic expressions are stored as untyped expression trees (`BasicSymbolic`), but Julia
code dispatches on types: a function written for `Real` will not accept an expression tree.
Symbolics bridges the two by *wrapping* an expression tree in a struct that subtypes the
type the expression stands for. `Num <: Real` is the built-in example — it holds an
expression tree whose `symtype` is `Real` and can therefore be passed anywhere a `Real` is
expected. `@symbolic_wrap` is how a package declares its own such pairing, so that
Symbolics knows to wrap results of that symbolic type in `W` and to unwrap `W` back to the
expression tree at the boundaries.

The macro takes a struct definition whose supertype is the symbolic type being wrapped. It
emits the struct unchanged, plus the trait methods that tie `W` and `T` together:
`Symbolics.has_symwrapper(::Type{<:T})`, `Symbolics.wrapper_type(::Type{<:T}) = W`,
`Symbolics.is_wrapper_type(::Type{<:W})`, `Symbolics.wraps_type(::Type{W}) = T` and
`Symbolics.iswrapped(::W)`. Once those exist, [`Symbolics.wrap`](@ref) maps a value of
symbolic type `T` to a `W`, [`SymbolicUtils.unwrap`](https://symbolicutils.juliasymbolics.org/api/#SymbolicUtils.unwrap) maps it back, [`@wrapped`](@ref)
generates wrapper-accepting methods, and `@register_symbolic` knows `W` counts as symbolic.

Two things are the caller's responsibility. `W` must be constructible from the value it
wraps, because that is how `Symbolics.wrap` builds it, and a `Symbolics.unwrap` method must
be defined for `W` to get the value back out.

The registration is on the *unparameterized* supertype, so
`Symbolics.wrapper_type(T{Int})` also returns `W`; if a parameterized wrapper is wanted
there, add the method by hand.

Only one wrapper may be registered per symbolic type, and `Real` is already taken by `Num`.
`@symbolic_wrap` is therefore for introducing wrappers over *new* symbolic types, not for
replacing the built-in ones.

# Example

```julia
using Symbolics

abstract type AbstractFoo{T} end
struct Foo{T} <: AbstractFoo{T} end

@symbolic_wrap struct FooWrap{T} <: AbstractFoo{T}
    val::Foo{T}
end

Symbolics.unwrap(r::FooWrap) = r.val

wrap(Foo{Int}())            # FooWrap{Int}
unwrap(wrap(Foo{Int}()))    # Foo{Int}
```

With that in place, [`@wrapped`](@ref) can generate methods that accept `FooWrap` wherever
they declare an `AbstractFoo` argument.

See also: [`@wrapped`](@ref), [`Symbolics.wrap`](@ref),
[`SymbolicUtils.unwrap`](https://symbolicutils.juliasymbolics.org/api/#SymbolicUtils.unwrap).
"""
macro symbolic_wrap(expr)
    @assert expr isa Expr && expr.head == :struct
    @assert expr.args[2].head == :(<:)
    sig = expr.args[2]
    T = _get_type_name(sig.args[1])
    supertype = set_where(sig.args[1], sig.args[2])

    quote
        $expr

        Symbolics.has_symwrapper(::Type{<:$supertype}) = true
        Symbolics.wrapper_type(::Type{<:$supertype}) = $T
        Symbolics.is_wrapper_type(::Type{<:$T}) = true # used in `@register`
        Symbolics.wraps_type(::Type{$T}) = $supertype
        Symbolics.iswrapped(::$T) = true
    end |> esc
end

iswrapped(x) = false

"""
    $(TYPEDSIGNATURES)

Wrap the symbolic or non-symbolic value `x` in the appropriate wrapper type.
"""
function wrap(x)
    T = SymbolicUtils.symtype(x)
    Symbolics.has_symwrapper(T) ?
        Symbolics.wrapper_type(T)(x) : x
end

function wrapper_type end
function wraps_type end

has_symwrapper(::Type) = false
is_wrapper_type(::Type) = false

function wrap_func_expr(mod, expr, wrap_arrays = true)
    @assert expr.head == :function || (expr.head == :(=) &&
                                       expr.args[1] isa Expr &&
                                       expr.args[1].head == :call)

    def = splitdef(expr)

    sig = expr.args[1]
    body = def[:body]

    fname = def[:name]
    args = get(def, :args, [])
    kwargs = get(def, :kwargs, [])

    if fname isa Expr && fname.head == :(::) && length(fname.args) > 1
        self = fname.args[1]
    else
        self = :nothing # LOL -- in this case the argument named nothing is passed nothing
    end
    impl_name = Symbol(fname,"_", hash(string(args)*string(kwargs)))

    function kwargname(kwarg)
        if kwarg isa Expr && kwarg.head == :kw
            kwarg.args[1]
        elseif kwarg isa Expr && kwarg.head == :(...)
            kwarg.args[1]
        else
            kwarg
        end
    end

    function argname(arg)
        if arg isa Expr && (arg.head == :(::) || arg.head == :(...))
            arg.args[1]
        elseif arg isa Expr
            error("$arg not supported as an argument")
        else
            arg
        end
    end

    names = vcat(argname.(args), kwargname.(kwargs))

    function type_options(arg)
        # for every argument find the types that
        # should be allowed as argument. These are:
        #
        # (1) T    (2) wrapper_type(T)    (3) BasicSymbolic
        #
        # However later while emitting methods we omit the one
        # method where all arguments are (1) since those are
        # expected to be defined outside Symbolics
        if arg isa Expr && arg.head == :(::)
            T = Base.eval(mod, arg.args[2])
            if has_symwrapper(T)
                Ts = (T, SymbolicT, wrapper_type(T))
            else
                Ts = (T, SymbolicT)
            end
            if T <: AbstractArray && wrap_arrays
                eT = eltype(T)
                if eT == Any
                    eT = Real
                end
                _arr_type_fn = if hasmethod(ndims, Tuple{Type{T}})
                    (elT) -> AbstractArray{S, ndims(T)} where {S <: elT}
                else
                    (elT) -> AbstractArray{S} where {S <: elT}
                end
                if has_symwrapper(eT)
                    Ts = (Ts..., _arr_type_fn(SymbolicT), _arr_type_fn(wrapper_type(eT)))
                else
                    Ts = (Ts..., _arr_type_fn(SymbolicT))
                end
            end
            Ts
        elseif arg isa Expr && arg.head == :(...)
            Ts = type_options(arg.args[1])
            map(x->Vararg{x},Ts)
        else
            (Any,)
        end
    end

    types = map(type_options, args)

    impl = :(function $impl_name($self, $(names...))
        $body
    end)

    function is_wrapped_array_eltype(T)
        T <: AbstractArray || return false
        if T isa UnionAll
            _inner = T.body
            while _inner isa UnionAll
                _inner = _inner.body
            end
            return _inner.parameters[1] == T.var && is_wrapper_type(T.var.ub)::Bool ||
                is_wrapper_type(eltype(T))::Bool
        elseif T isa DataType
            return is_wrapper_type(eltype(T))::Bool
        end
        error("Unreachable")
    end
    # TODO: maybe don't drop first lol
    methods = map(Iterators.drop(Iterators.product(types...), 1)) do Ts
        method_args = map(names, Ts) do n, T
            :($n::$T)
        end

        any_wrapper = false
        impl_args = map(enumerate(names)) do (i, name)
            if is_wrapper_type(Ts[i])
                any_wrapper = true
                :($unwrap($name))
            elseif Ts[i] <: AbstractArray && is_wrapped_array_eltype(Ts[i])
                any_wrapper = true
                :($_recursive_unwrap($name))
            else
                name
            end
        end
        implcall = :($impl_name($self, $(impl_args...)))
        if any_wrapper
            implcall = :($wrap($implcall))
        end

        body = Expr(:block)
        for (i, T) in enumerate(Ts)
            if T === BasicSymbolic{VartypeT}
                push!(body.args, :(@assert $symtype($(names[i])) <: $(types[i][1])))
            elseif T <: (AbstractArray{S} where {S <: SymbolicT}) && eltype(types[i][1]) !== Any
                push!(body.args, :(@assert $symtype($(names[i])[1]) <: $(eltype(types[i][1]))))
            end
        end
        push!(body.args, implcall)

        if isempty(kwargs)
            :(function $fname($(method_args...))
                  $body
              end)
        else
            :(function $fname($(method_args...); $(kwargs...))
                  $body
              end)
        end
    end

    quote
        $impl
        $(methods...)
    end
end

"""
    @wrapped function f(x::T, ...) ... end
    @wrapped f(x::T, ...) = ...
    @wrapped function f(x::T, ...) ... end false

Given one function definition written against concrete types, generate the additional
methods that accept symbolic expressions and wrapper types in those argument positions.

A function written as `f(x::Real)` will not accept a `Num`, because `Num` holds an
expression tree rather than a number, and will not accept a raw `BasicSymbolic` either.
Writing the symbolic methods by hand means one method per combination of "concrete /
symbolic / wrapped" across all arguments, each of which has to unwrap its wrapper
arguments, call the body, and re-wrap the result. `@wrapped` writes that combinatorial
expansion for you.

The body is emitted once under a private name, and one method of `f` is emitted per element
of the product of the type options for each argument. For an argument annotated `::T` the
options are `T` itself, a symbolic expression whose `symtype` is `T`, and — when `T` has a
wrapper registered via [`@symbolic_wrap`](@ref) — that wrapper type. When `T` is an array
type, array-of-symbolic and array-of-wrapper options are added as well. Unannotated
arguments are left as `Any`.

The all-concrete method is deliberately *not* emitted: `@wrapped function f(x::Real)` does
not define `f(::Real)`. That method is assumed to already exist outside Symbolics (often it
is the very Base function being extended), and emitting it would be piracy. Consequently
`f` must have a non-symbolic definition of its own if it is to be called on plain values.

In each generated method, wrapper-typed arguments are unwrapped before the body runs, and
the result is re-wrapped with [`Symbolics.wrap`](@ref) whenever at least one argument was
wrapped — so passing `Num`s in gets a `Num` back out, while passing raw `BasicSymbolic`s in
returns a raw expression. Symbolic arguments additionally get an `@assert` that their
`symtype` matches the declared annotation, which turns a type mismatch into an error at the
call rather than a wrong answer downstream.

Keyword arguments are forwarded as declared and are not expanded over; only positional
arguments participate in the product.

The optional trailing argument (default `true`) controls whether array-typed arguments are
expanded over their symbolic-array and wrapped-array options. Pass `false` to suppress
that, which is useful when the method is meant to see the container itself rather than a
symbolic array.

# Example

Continuing the wrapper from [`@symbolic_wrap`](@ref):

```julia
@wrapped function foo(f::AbstractFoo, x::Real)
    x > 1 ? Foo{Int}() : 0
end

applicable(foo, Foo{Int}(), 2)             # false: the all-concrete method is not emitted
applicable(foo, Foo{Int}(), wrap(2))       # true
applicable(foo, wrap(Foo{Int}()), 2)       # true
applicable(foo, wrap(Foo{Int}()), wrap(2)) # true
```

See also: [`@symbolic_wrap`](@ref), [`Symbolics.wrap`](@ref),
[`SymbolicUtils.unwrap`](https://symbolicutils.juliasymbolics.org/api/#SymbolicUtils.unwrap).
"""
macro wrapped(expr, wrap_arrays = true)
    esc(wrap_func_expr(__module__, expr, wrap_arrays))
end

using Symbolics, Test

@testset "limits" begin
    @syms x
    @test limit(exp(x+exp(-x))-exp(x), x, Inf) == 1
    @test limit(x^7/exp(x), x, Inf) == 0
    @test limit(log(log(x*exp(x*exp(x))+1))-exp(exp(log(log(x))+1/x)), x, Inf) == 0
    @test limit(2exp(-x)/exp(-x), x, 0) == 2

    @test_throws ArgumentError limit(1/x, x, 0)
    @test limit(1/x, x, 0, :left)[1] == -Inf
    @test limit(1/x, x, 0, :right)[1] == Inf
end

using Symbolics

const SAFE_ALTERNATIVES = Dict(log => slog, sqrt => ssqrt, cbrt => scbrt)

function isolate(lhs, var; warns=true, conditions=[], complex_roots = true, periodic_roots = true)
    rhs = Vector{Any}([0])
    original_lhs = deepcopy(lhs)
    lhs = unwrap(lhs)

    old_lhs = nothing
    
    while !isequal(lhs, var)
        subs, poly = filter_poly(lhs, var)

        if check_polynomial(poly, strict=false)
            roots = []
            new_var = gensym()
            new_var = (@variables $new_var)[1]
            if Base.get_extension(Symbolics, :SymbolicsNemoExt) !== nothing
                lhs_roots = solve_univar(lhs - new_var, var)
            else
                a, b, islin = linear_expansion(lhs - new_var, var)
                if islin
                    lhs_roots = [-b / a]
                else
                    lhs_roots = [RootsOf(lhs - new_var, var)]
                    if warns
                        @warn "Nemo is required to properly solve this expression. Execute `using Nemo` to enable this functionality."
                    end
                end
            end

            for i in eachindex(lhs_roots)
                for j in eachindex(rhs)
                    if iscall(lhs_roots[i]) && operation(lhs_roots[i]) === RootsOf
                        _args = copy(parent(arguments(lhs_roots[i])))
                        _args[1] = substitute(_args[1], Dict(new_var => rhs[j]), fold = Val(false))
                        T = typeof(lhs_roots[i])
                        _op = operation(lhs_roots[i])
                        _meta = metadata(lhs_roots[i])
                        lhs_roots[i] = maketerm(T, _op, _args, _meta)
                        push!(roots, lhs_roots[i])
                    else
                        push!(roots, substitute(lhs_roots[i], Dict(new_var=>rhs[j]), fold=Val(false)))
                    end
                end
            end
            return roots, conditions
        end

        if isequal(old_lhs, lhs) 
            warns && @warn("This expression cannot be solved with the methods available to ia_solve. Try a numerical method instead.")
            return nothing, conditions
        end

        old_lhs = lhs

        oper = operation(lhs)
        args = arguments(lhs)

        if oper === (+)
            for arg in args
                vars = get_variables(arg)
                if any(isequal(x, var) for x in vars)
                    continue
                end
                lhs = lhs - arg
                rhs = map(sol -> sol - arg, rhs)
            end

        elseif oper === (*)
            for arg in args
                vars = get_variables(arg)
                if any(isequal(x, var) for x in vars)
                    continue
                end
                lhs = lhs / arg
                rhs = map(sol -> sol / arg, rhs)
            end

        elseif oper === (/)
            var_innumerator = any(isequal(x, var) for x in get_variables(numerator(lhs)))
            if var_innumerator
                # x / 2 = y
                rhs = map(sol -> sol * denominator(lhs), rhs)
                lhs = unwrap(numerator(lhs))
            else
                # 2 / x = y
                rhs = map(sol -> /(numerator(lhs), sol), rhs)
                lhs = unwrap(denominator(lhs))
            end

        elseif oper === (^)
            var_in_base = any(isequal(x, var) for x in get_variables(args[1]))
            var_in_pow = n_occurrences(args[2], var) != 0
            a2 = unwrap_const(args[2])
            if var_in_base && !var_in_pow && a2 isa Integer
                lhs = args[1]
                power = a2
                new_roots = []

                if complex_roots
                    for i in eachindex(rhs)
                        for k in 0:(a2 - 1)
                            r = ^(rhs[i], (1 // power))
                            c = *(2 * (k), pi) * im / power
                            root = r * Base.MathConstants.e^c
                            push!(new_roots, root)
                        end
                    end
                else
                    for i in eachindex(rhs)
                        push!(new_roots, ^(rhs[i], (1 // power)))
                        if iseven(power)
                            push!(new_roots, -new_roots[end])
                        end
                    end
                end
                rhs = []
                append!(rhs, new_roots)
            elseif var_in_base && !var_in_pow
                lhs = args[1]
                s, power = filter_stuff(args[2])
                rhs = map(sol ->^(sol, 1 / power), rhs)
            else
                lhs = args[2]
                rhs = map(sol -> /(slog(sol), slog(args[1])), rhs)
            end
        elseif has_left_inverse(oper)
            lhs = args[1]
            ia_conditions!(oper, lhs, rhs, conditions)
            invop = left_inverse(oper)
            invop = get(SAFE_ALTERNATIVES, invop, invop)
            if is_periodic(oper) && periodic_roots
                new_var = gensym()
                new_var = (@variables $new_var)[1]
                period = fundamental_period(oper)
                rhs = map(
                    sol -> invop(sol) +
                           *(period, new_var),
                    rhs)
                @info string(new_var) * " ϵ" * " Ζ"
            else
                rhs = map(sol -> invop(sol), rhs)
            end
        end

        lhs = simplify(lhs)
    end

    return rhs, conditions
end

function attract(lhs, var; warns = true, complex_roots = true, periodic_roots = true)
    if n_func_occ(simplify(lhs), var) <= n_func_occ(lhs, var)
        lhs = simplify(lhs)
    end
    conditions = []

    if detect_exponential(lhs, var)
        lhs = attract_exponential(lhs, var)
    end
    if detect_addlogs(lhs, var)
        lhs, new_conds = attract_logs(lhs, var)
        append!(conditions, new_conds)
    end
    lhs = attract_trig(lhs, var)

    if n_func_occ(lhs, var) == 1
        return isolate(lhs, var; warns, conditions, complex_roots, periodic_roots)
    end

    lhs, sub = turn_to_poly(lhs, var)

    if (isequal(sub, Dict()) || n_func_occ(lhs, collect(keys(sub))[1]) != 1)
        sqrt_poly = detect_sqrtpoly(lhs, var)
        if sqrt_poly
            return attract_and_solve_sqrtpoly(lhs, var), conditions
        else
            warns && @warn("This expression cannot be solved with the methods available to ia_solve. Try \
            a numerical method instead.")
            return nothing, conditions
        end
    end
    
    new_var = collect(keys(sub))[1]
    new_var_val = collect(values(sub))[1]

    roots, new_conds = isolate(lhs, new_var; warns = warns, complex_roots, periodic_roots)
    append!(conditions, new_conds)
    new_roots = []

    for root in roots
        iscall(root) && operation(root) == RootsOf && continue
        new_sol, new_conds = isolate(new_var_val - root, var; warns = warns, complex_roots, periodic_roots)
        append!(conditions, new_conds)
        push!(new_roots, new_sol)
    end
    new_roots = collect(Iterators.flatten(new_roots))

    return new_roots, conditions
end

"""
    ia_solve(lhs, var; kwargs...)
This function attempts to solve transcendental functions by first checking
the "smart" number of occurrences in the input LHS. By smart here we mean
that polynomials are counted as 1 occurrence. for example `x^2 + 2x` is 1
occurrence of x. So we abstract all occurrences of x's as polynomials.
Say: `log(x+1) + x^2` is seen as `log(f(x)) + g(x)` so there are 2 occurrences
of x. If there is only 1 occurrence of x in an input expression, isolate is called.

Isolate reverses all operations applied on the occurrence of x until we have
`f(x) = some constant` then we can solve this using our polynomial solvers.

If more than 1 occurrence of x is found, `ia_solve` attempts to attract the
occurrences of x in order to reduce these occurrences to 1. For example,
`log(x+1) + log(x-1)` can be converted to `log(x^2 - 1)` which now could be
isolated using Isolate.

`attract(lhs, var)` currently uses 4 techniques for attraction.
- Log addition: `log(f(x)) + log(g(x)) => log(h(x))`
- Exponential simplification: `a*b^(f(x)) + c*d^(g(x)) => f(x) * log(b) - g(x) * log(d) + log(-a/c)`. And now this is actually 1 occurrence of x since `f(x)` and `g(x)` are just multiplied by constants not wrapped in some operation.
- Trig simplification: this bruteforces multiple trig identities and doesn't detect them before hand.
- Polynomialization: as a last resort, attract attempts to polynomialize the expression. Say `sin(x+2)^2 + sin(x+2) + 10` is converted to `X^2 + X + 10`, we then solve this using our polynomial solver, and afterwards, isolate `sin(x+2) = the roots found by solve for X^2 + X + 10`

After attraction, we check the number of occurrences again, and if its 1, we isolate, if not,
we throw an error to tell the user that this is currently unsolvable by our covered techniques.

# Arguments
- lhs: a Num/SymbolicUtils.BasicSymbolic
- var: variable to solve for.

# Keyword arguments
- `warns = true`: Whether to emit warnings for unsolvable expressions.
- `complex_roots = true`: Whether to consider complex roots of `x ^ n ~ y`, where `n` is an integer.
- `periodic_roots = true`: If `true`, isolate `f(x) ~ y` as `x ~ finv(y) + n * period` where
   `is_periodic(f) == true`, `finv = left_inverse(f)` and `period = fundamental_period(f)`. `n`
   is a new anonymous symbolic variable.

# Examples
```julia
julia> using Symbolics

julia> a = only(@variables a)
a

julia> b = only(@variables b)
b

julia> c = only(@variables c)
c

julia> x = only(@variables x)
x

julia> typeof(Symbolics.ia_solve(a*x^b + c, x)) <: AbstractVector
true
```

```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> length(Symbolics.ia_solve(2^(x+1) + 5^(x+3), x))
1
```

```julia
julia> using Symbolics

julia> x = only(@variables x)
x

julia> Symbolics.ia_solve(log(x+1)+log(x-1), x)
1-element Vector{Any}:
 (1//2)*√(8.0)
```

```julia
julia> using Symbolics

julia> x = only(@variables x)
x

julia> expr = sin(x+2)^2 + sin(x+2) + 10
10 + sin(2 + x) + sin(2 + x)^2

julia> length(Symbolics.ia_solve(expr, x))
2
```

All transcendental functions for which `left_inverse` is defined are supported.
To enable `ia_solve` to handle custom transcendental functions, define an inverse or
left inverse. If the function is periodic, `is_periodic` and `fundamental_period` must
be defined. If the function imposes certain conditions on its input or output (for
example, `log` requires that its input be positive) define `ia_conditions!`.

See also: [`left_inverse`](@ref), [`inverse`](@ref), [`is_periodic`](@ref),
[`fundamental_period`](@ref), [`ia_conditions!`](@ref).

# References
[^1]: [R. W. Hamming, *Coding and Information Theory*, 1980](https://books.google.com/books/about/Coding_and_information_theory.html?hl=en&id=0d5QAAAAMAAJ).
"""
function ia_solve(lhs, var; warns = true, complex_roots = true, periodic_roots = true)
    nx = n_func_occ(lhs, var)
    sols = []
    conditions = []
    if nx == 0
        warns && @warn("Var not present in given expression")
        return nothing
    elseif nx == 1
       sols, conditions = isolate(lhs, var; warns = warns, complex_roots, periodic_roots)
    elseif nx > 1
        sols, conditions = attract(lhs, var; warns = warns, complex_roots, periodic_roots)
    end

    isequal(sols, nothing) && return nothing

    
    filtered_sols = []
    for i in eachindex(sols)
        if length(get_variables(sols[i])) > 0
            push!(filtered_sols, sols[i])
            continue
        end
        domain_error = false
        for j in eachindex(conditions)
            condition, t = conditions[j]
            cond_val = unwrap_const(substitute(condition, Dict(var=>eval(toexpr(sols[i]))); fold = Val(true)))
            cond_val isa Complex && continue
            domain_error |= !t(cond_val, 0)
        end
        !domain_error && push!(filtered_sols, sols[i])
    end

    return filtered_sols
end

using SymbolicUtils: FnType, Sym
using TermInterface: metadata
using Setfield

const IndexMap = Dict{Char,Char}(
            '-' => '₋',
            '0' => '₀',
            '1' => '₁',
            '2' => '₂',
            '3' => '₃',
            '4' => '₄',
            '5' => '₅',
            '6' => '₆',
            '7' => '₇',
            '8' => '₈',
            '9' => '₉')

abstract type AbstractVariableMetadata end
"""
    $TYPEDEF

Symbolic metadata key for storing the default value of a symbolic variable.
"""
struct VariableDefaultValue <: AbstractVariableMetadata end
"""
    $TYPEDEF

Symbolic metadata key for storing the macro used to create a symbolic variable.
"""
struct VariableSource <: AbstractVariableMetadata end

function setdefaultval(x, val)
    val === nothing && return x
    sh = shape(x)
    if sh isa SymbolicUtils.Unknown
        @assert sh.ndims == -1 || ndims(val) == sh.ndims """
        Variable $x must have default of matching `ndims`. Got $val with `ndims` \
        $(ndims(val)).
        """
    else
        @assert val === missing || isempty(sh) || symtype(x) <: FnType || size(x) == size(val) """
        Variable $x must have default of matching size. Got $val with size \
        $(size(val)).
        """
    end
    setmetadata(x, VariableDefaultValue, val)
end

"""
    map_subscripts(indices)

Convert the decimal characters in an index to the Unicode subscript
characters used in symbolic variable names.

# Arguments

- `indices`: an integer or other value whose string representation consists of
  characters in `-0123456789`.

# Examples

```julia
julia> Symbolics.map_subscripts(-12)
"₋₁₂"
```
"""
function map_subscripts(indices)
    str = string(indices)
    join(IndexMap[c] for c in str)
end


# Build variables more easily
"""
    $(TYPEDSIGNATURES)

Parse variables using the syntax expected by `@variables`. Used for implementing custom
macros similar to `@variables`. `macroname` refers to the name of the macro creating the
variables. This is stored in the `VariableSource` metadata of created variables. `type`
is the default type of created variables. `x` is the tuple of expressions passed to the
macro. `transform` is an optional function that takes constructed variables and performs
custom postprocessing to them, returning the created variables. This function returns the
`Expr` for constructing the parsed variables.

See also: [`_parse_vars`](@ref).
"""
function parse_vars(macroname, type, x, transform = identity)
    esc(_parse_vars(macroname, type, x, transform))
end

"""
    $TYPEDSIGNATURES

The worker function for [`parse_vars`](@ref). This returns the expanded code, exactly as it
should be run. In other words, this does not require sanitization and the result should be
passed through `esc` before returning from the macro. `parse_vars` does this automatically.
This function also guarantees that the last expression in the returned `Expr(:block)` is an
`Expr(:vect)` of the identifiers for the created variables.
"""
function _parse_vars(macroname, type, x, transform = identity)
    ex = Expr(:block)
    var_names = Expr(:vect)
    # if parsing things in the form of
    # begin
    #     x
    #     y
    #     z
    # end
    x = x isa Tuple && first(x) isa Expr && first(x).head == :tuple ? first(x).args : x # tuple handling
    x = flatten_expr!(x)
    cursor = 0
    isoption(ex) = Meta.isexpr(ex, [:vect, :vcat, :hcat])
    while cursor < length(x)
        cursor += 1
        var_expr = x[cursor]

        default = nothing
        options = nothing
        if Meta.isexpr(var_expr, :(=))
            var_expr, default = var_expr.args
            # defaults with metadata for function variables
            if Meta.isexpr(default, :block)
                Base.remove_linenums!(default)
                default = only(default.args)
            end
            if Meta.isexpr(default, :tuple) && length(default.args) == 2 && isoption(default.args[2])
                options = default.args[2].args
                default = default.args[1]
            end
        end
        parse_result = SymbolicUtils.parse_variable(var_expr; default_type = type)
        handle_nonconcrete_symtype!(parse_result)
        sym = SymbolicUtils.sym_from_parse_result(parse_result, VartypeT; do_esc = false)
        sym = handle_maybe_dependent_variable!(parse_result, sym, type)

        if options === nothing && cursor < length(x) && isoption(x[cursor + 1])
            options = x[cursor + 1].args
            cursor += 1
        end
        sym = _add_metadata(parse_result, sym, default, macroname, options)
        sym = handle_maybe_callandwrap!(parse_result, sym)
        sym = Expr(:call, transform, Expr(:call, wrap, sym))

        if parse_result[:isruntime]
            varname = gensym(Symbol(parse_result[:name]))
        else
            varname = parse_result[:name]
        end
        push!(var_names.args, varname)
        push!(ex.args, Expr(:(=), varname, sym))
    end
    push!(ex.args, var_names)
    return ex
end

function handle_nonconcrete_symtype!(parse_result)
    type = parse_result[:type]
    if type == :Complex
        parse_result[:type] = :(Complex{Real})
    end
    if Meta.isexpr(type, :curly)
        if type.args[1] in (:Array, :Vector, :Matrix, Array, Vector, Matrix) && type.args[2] == :Complex
            type.args[2] = :(Complex{Real})
        end
        if type.args[1] == :FnType || type.args[1] == SymbolicUtils.FnType
            if Meta.isexpr(type.args[2], :curly) # Tuple{...}
                for i in 2:length(type.args[2].args)
                    if type.args[2].args[i] == :Complex
                        type.args[2].args[i] = :(Complex{Real})
                    end
                end
            end
            if type.args[3] == :Complex
                type.args[3] = :(Complex{Real})
            end
            for parse_arg in parse_result[:args]
                handle_nonconcrete_symtype!(parse_arg)
            end
        end
    end
    return nothing
end

function parse_result_is_dependent_variable(parse_result)
    # This means it is a function call
    return haskey(parse_result, :args) &&
    # This checks `fnT` in `FnType{argsT, retT, fnT}`
        parse_result[:type].args[4] === Nothing &&
    # This ensures all arguments have defined names
        all(n -> n !== nothing && n != :..,
            (get(arg, :name, nothing) for arg in parse_result[:args]))
end

function handle_maybe_dependent_variable!(parse_result, sym, type)
    # is a function call and the function doesn't have a type and all arguments
    # are named
    parse_result_is_dependent_variable(parse_result) || return sym

    args = parse_result[:args]
    argnames = Any[get(arg, :name, nothing) for arg in args]
    # if the last arg is a `Vararg`, splat it
    if !isempty(args) && Meta.isexpr(args[end][:type], :curly) && args[end][:type].args[1] == :Vararg
        argnames[end] = Expr(:..., argnames[end])
    end
    # Turn the result into something of the form `@variables x(..)`.
    # This makes it so that the `FnType` is recognized as a dependent variable
    # according to `SymbolicUtils.is_function_symtype`
    parse_result[:args] = [SymbolicUtils.parse_variable(:(..); default_type = type)]
    parse_result[:type].args[2] = Tuple
    # Re-create the `Sym`
    sym = SymbolicUtils.sym_from_parse_result(parse_result, VartypeT; do_esc = false)
    # Change the type
    parse_result[:type] = parse_result[:type].args[3]
    sym = Expr(:call, sym)
    append!(sym.args, argnames)
    return sym
end

function handle_maybe_callandwrap!(parse_result, sym)
    type = parse_result[:type]
    if Meta.isexpr(type, :curly) && (type.args[1] == :FnType || type.args[1] === SymbolicUtils.FnType)
        sym = Expr(:call, CallAndWrap, sym)
    end
    return sym
end

function _add_metadata(parse_result, var::Expr, default, macroname::Symbol, metadata::Union{Nothing, Vector{Any}})
    @nospecialize var default metadata
    if default !== nothing
        var = Expr(:call, setdefaultval, var, default)
    end
    varname = parse_result[:name]
    if !parse_result[:isruntime]
        varname = Meta.quot(varname)
    end
    var = Expr(:call, setmetadata, var, VariableSource, Expr(:tuple, Meta.quot(macroname), varname))
    metadata === nothing && return var
    for ex in metadata
        Meta.isexpr(ex, :(=)) || error("Metadata must of the form of `key = value`")
        key, value = ex.args
        key_type = option_to_metadata_type(Val{key}())::DataType
        var = Expr(:call, setmetadata, var, key_type, value)
    end
    return var
end

"""
    $(TYPEDSIGNATURES)

Define a new metadata key assignable in `@variables`. This function should take `Val{name}`
where `name` is a `Symbol`, and return the key type for the given metadata name `name`. For
example,

```julia
Symbolics.option_to_metadata_type(::Val{:custom_name}) = CustomType
```

Allows the following syntax:

```julia
@variables x [custom_name = 1]
```

And stores `1` as the value associated with the `CustomType` key in the symbolic metadata
of `x`.
"""
function option_to_metadata_type(::Val{opt}) where {opt}
    throw(Base.Meta.ParseError("unknown property type $opt"))
end

# add enough additional methods that the compiler gives up on specializing this
# and downstream definitions don't cause massive invalidation.
option_to_metadata_type(::Val{:_____!_internal_1}) = error("Invalid option")
option_to_metadata_type(::Val{:_____!_internal_2}) = error("Invalid option")
option_to_metadata_type(::Val{:_____!_internal_3}) = error("Invalid option")
option_to_metadata_type(::Val{:_____!_internal_4}) = error("Invalid option")
option_to_metadata_type(::Val{:_____!_internal_5}) = error("Invalid option")

"""

Define one or more unknown variables.

```julia
@variables t α σ(..) β[1:2]
@variables w(..) x(t) y z(t, α, x)

expr = β[1]* x + y^α + σ(3) * (z - t) - β[2] * w(t - 1)
```

`(..)` signifies that the value should be left uncalled.

Symbolics supports creating variables that denote an array of some size.

```jldoctest
julia> @variables x[1:3]
1-element Vector{Symbolics.Arr{Num, 1}}:
 x[1:3]

julia> @variables y[1:3, 1:6] # support for  tensors
1-element Vector{Symbolics.Arr{Num, 2}}:
 y[1:3,1:6]

julia> @variables t z(t)[1:3] # also works for dependent variables
2-element Vector{Any}:
 t
  (z(t))[1:3]
```

A symbol or expression that represents an array can be turned into an array of
symbols or expressions using the `scalarize` function.

```jldoctest
julia> @variables t z(t)[1:3]
2-element Vector{Any}:
 t
  (z(t))[1:3]

julia> Symbolics.scalarize(z)
3-element Vector{Num}:
 (z(t))[1]
 (z(t))[2]
 (z(t))[3]
```

Note that `@variables` returns a vector of all the defined variables.

`@variables` can also take runtime symbol values by the `\$` interpolation
operator, and in this case, `@variables` doesn't automatically assign the value,
instead, it only returns a vector of symbolic variables. All the rest of the
syntax also applies here.

```jldoctest
julia> a, b, c = :runtime_symbol_value, :value_b, :value_c
(:runtime_symbol_value, :value_b, :value_c)

julia> length(@variables t \$a \$b(t) \$c(t)[1:3])
4
```
"""
macro variables(xs...)
    parse_vars(:variables, Real, xs)
end

const _fail = Dict()

getsource(x, val=_fail) = getmetadata(unwrap(x), VariableSource, val)

SymbolicIndexingInterface.symbolic_type(::Type{Symbolics.Num}) = ScalarSymbolic()
SymbolicIndexingInterface.symbolic_type(::Type{Complex{Symbolics.Num}}) = ScalarSymbolic()
SymbolicIndexingInterface.symbolic_type(::Type{Symbolics.Arr{T, N}}) where {T, N} = ArraySymbolic()
SymbolicIndexingInterface.symbolic_type(::Type{Symbolics.Arr{T}}) where {T} = ArraySymbolic()
SymbolicIndexingInterface.symbolic_type(::Type{Symbolics.Arr}) = ArraySymbolic()

SymbolicIndexingInterface.hasname(x::Union{Num,Arr,Complex{Num}}) = hasname(unwrap(x))
function SymbolicIndexingInterface.getname(x::Union{Num, Arr, Complex{Num}})
    SymbolicIndexingInterface.getname(unwrap(x))
end

function SymbolicIndexingInterface.symbolic_evaluate(ex::Union{Num, Arr, BasicSymbolic, Equation, Inequality}, d::Dict; kwargs...)
    val = fixpoint_sub(ex, d; fold = Val(true), kwargs...)
    return _recursive_unwrap(val, Val(true))
end

for T in [LinearAlgebra.UpperTriangular, LinearAlgebra.LowerTriangular]
    @eval function _recursive_unwrap(val::$T, ::Val{eval} = Val(false)) where {eval}
        $T(_recursive_unwrap(collect(val), Val{eval}()))
    end
end

function _recursive_unwrap(val, ::Val{eval} = Val(false)) where {eval}
    if symbolic_type(val) == NotSymbolic() && val isa Union{AbstractArray, Tuple}
        if parent(val) !== val
            return Setfield.@set val.parent = _recursive_unwrap(parent(val), Val{eval}())
        end
        return _recursive_unwrap.(val, Val{eval}())
    else
        return eval ? value(val) : unwrap(val)
    end
end

function _recursive_unwrap(val::StaticArraysCore.SizedVector, ::Val{eval} = Val(false)) where {eval}
    return _recursive_unwrap.(val, Val{eval}())
end

function _recursive_unwrap(val::AbstractSparseArray, ::Val{eval} = Val(false)) where {eval}
    if val isa AbstractSparseVector
        (Is, Vs) = findnz(val)
        Vs = _recursive_unwrap.(Vs, Val{eval}())
        return SparseVector(length(val), Is, Vs)
    else
        (Is, Js, Vs) = findnz(val)
        Vs = _recursive_unwrap.(Vs, Val{eval}())
        return sparse(Is, Js, Vs, size(val)...) 
    end
end

struct FPSubFilterer{O, F}
    fallback_filterer::F
end

function FPSubFilterer{O}(; fallback_filterer = SymbolicUtils.default_substitute_filter) where {O}
    FPSubFilterer{O, typeof(fallback_filterer)}(fallback_filterer)
end

function (filt::FPSubFilterer{O})(ex::BasicSymbolic{T}) where {T, O}
    @match ex begin
        BSImpl.Term(; f) && if f isa Operator end => !(f isa O)
        _ => filt.fallback_filterer(ex)
    end
end

"""
    FixpointSubstituter{Fold, #= ... =# } <: SymbolicUtils.Substituter{Fold}

A substituter which repeatedly substitutes an expression until a fixpoint is reached,
or a maximum number of substitutions in case of circular rules. For example, the rules
`[x => y, y => x]` will lead to hitting the maximum iterations. This follows
the same caching rules as
[`SymbolicUtils.Substituter`](https://symbolicutils.juliasymbolics.org/api/).

See also: [`fixpoint_sub`](@ref).
"""
struct FixpointSubstituter{Fold, S <: SU.Substituter{Fold}} <: SU.Substituter{Fold}
    wrapped::S
    maxiters::Int
    warn_maxiters::Bool
end

"""
    $TYPEDSIGNATURES

Construct a `FixpointSubstituter` from the given substituter `subber`. Optionally specify
the maximum number of iterations to substitute. Set `warn_maxiters = false` to suppress
the warning emitted when substitution hits the iteration limit.
"""
function FixpointSubstituter(subber::S; maxiters::Integer = 1000, warn_maxiters::Bool = true) where {Fold, S <: SU.Substituter{Fold}}
    return FixpointSubstituter{Fold, S}(subber, maxiters, warn_maxiters)
end

"""
    $TYPEDSIGNATURES

Construct a `FixpointSubstituter`, specifying whether it constant-folds via `Fold`.
`Op` prevents substitution of expressions inside operators of the given type. Set
`warn_maxiters = false` to suppress the warning emitted when substitution hits the
iteration limit.
"""
function FixpointSubstituter{Fold}(
    rules, filterer = SU.default_substitute_filter, op::Type{Op} = Nothing; maxiters = 1000,
    warn_maxiters::Bool = true) where {Fold, Op}
    fpfilterer = FPSubFilterer{Op}(; fallback_filterer = filterer)
    return FixpointSubstituter(SU.Substituter{Fold}(rules, fpfilterer); maxiters, warn_maxiters)
end

SymbolicUtils.clear_cache!(s::FixpointSubstituter) = SU.clear_cache!(s.wrapped)
function SymbolicUtils.get_substitution_dict(s::FixpointSubstituter)
    return SU.get_substitution_dict(s.wrapped)
end

function (sub::FixpointSubstituter)(ex::SymbolicT)
    iters = sub.maxiters
    new_ex = sub.wrapped(ex)
    while !isequal(ex, new_ex) && iters > 0
        ex = new_ex
        new_ex = sub.wrapped(new_ex)
        iters -= 1
    end

    if !isequal(ex, new_ex) && iters == 0 && sub.warn_maxiters
        @warn lazy"""
        Did not converge after `maxiters = $(sub.maxiters)` substitutions. Either there \
        is a cycle in the rules or `maxiters` needs to be higher.
        """
    end

    return new_ex
end

"""
    fixpoint_sub(
        expr, dict, ::Type{OP} = Nothing;
        maxiters = 1000,
        warn_maxiters = true,
        filterer = SymbolicUtils.default_substitute_filter,
        fold = Val(false),
    )

Recursively apply the substitutions in `dict` until `expr` no longer changes.
Substitutions that depend on one another are fully expanded. Circular substitutions stop
after `maxiters` applications.

# Arguments

- `expr`: symbolic expression, equation, inequality, or array to transform.
- `dict`: substitution rules accepted by `SymbolicUtils.Substituter`.
- `OP`: operator type whose contents should not be substituted. The default `Nothing`
  does not exclude an operator type.

# Keywords

- `maxiters::Integer = 1000`: maximum number of repeated substitutions.
- `warn_maxiters::Bool = true`: emit a warning when the iteration limit is reached.
- `filterer = SymbolicUtils.default_substitute_filter`: predicate controlling which
  expression nodes may be substituted.
- `fold::Val = Val(false)`: whether to constant-fold while substituting.

# Returns

The transformed value after reaching a fixpoint or the iteration limit.

# Examples

```jldoctest
julia> using Symbolics

julia> @variables x y;

julia> Symbolics.fixpoint_sub(x, Dict(x => y, y => 3))
3
```

See also: [`FixpointSubstituter`](@ref).
"""
function fixpoint_sub(x, dict, ::Type{OP} = Nothing; maxiters = 1000, warn_maxiters::Bool = true, filterer = SymbolicUtils.default_substitute_filter, fold::Val{FOLD} = Val{false}(), kw...) where {OP, FOLD}
    if get(kw, :operator, nothing) !== nothing
        Base.depwarn("""
        The `operator` keyword to `fixpoint_sub` is deprecated. Please pass it as the \
        third positional argument instead.
        """, :fixpoint_sub_op_kwarg)
        return fixpoint_sub(x, dict, kw[:operator]; maxiters, warn_maxiters, filterer, fold)
    end
    subber = FixpointSubstituter{FOLD}(dict, filterer, OP; maxiters, warn_maxiters)
    return subber(x)
end

function is_array_of_symbolics(x)
    symbolic_type(x) == ArraySymbolic() && return true
    symbolic_type(x) == ScalarSymbolic() && return false
    x isa AbstractArray &&
        any(y -> symbolic_type(y) != NotSymbolic() || is_array_of_symbolics(y), x)
end

function getmetadata_maybe_indexed(x::SymbolicT, key::DataType, default)
    hasmetadata(x, key) && return getmetadata(x, key, default)
    @match x begin
        BSImpl.Term(; f, args) && if f === getindex end => begin
            hasmetadata(args[1], key) || return default
            idxs = unwrap_const.(@view args[2:end])
            return getmetadata(args[1], key)[idxs...]
        end
        _ => return default
    end
end

function getdefaultval(x, val=_fail)
    x = unwrap(x)
    val = getmetadata(x, VariableDefaultValue, val)
    if val !== _fail
        return val
    else
        @match x begin
            BSImpl.Term(; f, args) && if f === getindex end => begin
                parentval = getdefaultval(args[1], val)
                if parentval === missing
                    return missing
                end
                idxs = Iterators.map(unwrap_const, Iterators.drop(args, 1))
                return parentval[idxs...]
            end
            _ => error("$x has no default value")
        end
    end
end

"""
    variables(name::Symbol, indices...)

Create a multi-dimensional array of individual variables named with subscript
notation. Use `@variables` instead to create symbolic array variables (as
opposed to array of variables). See `variable` to create one variable with
subscripts.

```jldoctest
julia> Symbolics.variables(:x, 1:3, 3:6)
3×4 Matrix{Num}:
 x₁ˏ₃  x₁ˏ₄  x₁ˏ₅  x₁ˏ₆
 x₂ˏ₃  x₂ˏ₄  x₂ˏ₅  x₂ˏ₆
 x₃ˏ₃  x₃ˏ₄  x₃ˏ₅  x₃ˏ₆
```
"""
function variables(name, indices...; T=Real)
    [variable(name, ij...; T=T) for ij in Iterators.product(indices...)]
end

"""
    variable(name::Symbol, idx::Integer...; T=Real)

Create a variable with the given name along with subscripted indices with the
`symtype=T`. When `T=FnType`, it creates a symbolic function.

```jldoctest
julia> Symbolics.variable(:x, 4, 2, 0)
x₄ˏ₂ˏ₀

julia> Symbolics.variable(:x, 4, 2, 0, T=Symbolics.FnType{Tuple{Real}, Real, Nothing})
x₄ˏ₂ˏ₀⋆
```

Also see `variables`.
"""
function variable(name, idx...; T=Real)
    name_ij = Symbol(name, join(map_subscripts.(idx), "ˏ"))
    v = Sym{VartypeT}(name_ij; type = T)
    wrap(setmetadata(v, VariableSource, (:variables, name_ij)))
end

##### Renaming #####
# getname
# rename
# getindex parent
# calls
# symbolic function x[1:3](..)
#
# x_t
# sys.x

function renamed_metadata(metadata::Union{Nothing, SymbolicUtils.MetadataT}, name::Symbol)
    @nospecialize metadata
    if metadata === nothing
        return metadata
    elseif metadata isa Base.ImmutableDict{DataType, Any}
        newmeta = Base.ImmutableDict{DataType, Any}()
        for (k, v) in metadata
            if k === VariableSource
                v = v::NTuple{2, Symbol}
                v = (v[1], name)
            end
            newmeta = Base.ImmutableDict{DataType, Any}(newmeta, k, v)
        end
        return newmeta
    end
    error()
end

rename(x::Union{Num, Arr}, name) = wrap(rename(unwrap(x), name))

function rename(x::BasicSymbolic{T}, newname::Symbol) where {T}
    @match x begin
        BSImpl.Sym(; name, type, shape, metadata) => begin
            metadata = renamed_metadata(metadata, newname)
            return BSImpl.Sym{T}(newname; type, shape, metadata)
        end
        BSImpl.Term(; f, args, type, shape, metadata) && if f === getindex end => begin
            newargs = copy(parent(args))
            newargs[1] = rename(newargs[1], newname)
            return BSImpl.Term{T}(f, newargs; type, shape, metadata)
        end
        BSImpl.Term(; f, args, type, shape, metadata) && if f isa BasicSymbolic{T} end => begin
            f = rename(f, newname)
            metadata = renamed_metadata(metadata, newname)
            return BSImpl.Term{T}(f, args; type, shape, metadata)
        end
        _ => error("Cannot rename $x.")
    end
end

#### Callable ###

struct CallAndWrap{T}
    f::BasicSymbolic{VartypeT}
end

rettype_from_fntype(::Type{T}) where {A, R, T <: SymbolicUtils.FnType{A, R}} = R

function CallAndWrap(f::BasicSymbolic{VartypeT})
    @assert symtype(f) <: SymbolicUtils.FnType
    R = rettype_from_fntype(symtype(f))
    if hasmethod(wrapper_type, Tuple{Type{R}})
        CallAndWrap{wrapper_type(R)}(f)
    else
        f
    end
end

function (caw::CallAndWrap{T})(args...) where {T}
    T(caw.f(args...))
end

SymbolicIndexingInterface.symbolic_type(::Type{CallAndWrap{T}}) where {T} = ScalarSymbolic()
SymbolicIndexingInterface.symbolic_type(::Type{CallAndWrap}) = ScalarSymbolic()

Base.isequal(a::CallAndWrap, b::CallAndWrap) = isequal(a.f,  b.f)
Base.isequal(a::BasicSymbolic{VartypeT}, b::CallAndWrap) = isequal(a,  b.f)
Base.isequal(a::CallAndWrap, b::BasicSymbolic{VartypeT}) = isequal(a.f,  b)
Base.hash(x::CallAndWrap, h::UInt) = hash(x.f, h)

function Base.show(io::IO, caw::CallAndWrap)
    warn_load_latexify()
    show(io, caw.f)
    print(io, "⋆")
end

has_symwrapper(::Type{T}) where {A, R, T <: SymbolicUtils.FnType{A, R}} = has_symwrapper(R)
wrapper_type(::Type{T}) where {A, R, T <: SymbolicUtils.FnType{A, R}} = CallAndWrap{wrapper_type(R)}
is_wrapper_type(::Type{T}) where {T <: CallAndWrap} = true
wraps_type(::Type{T}) where {W, T <: CallAndWrap{W}} = FnType{A, R} where {A, R <: wraps_type(W)}
iswrapped(::CallAndWrap) = true
SymbolicUtils.unwrap(x::CallAndWrap) = x.f
SymbolicUtils.infer_vartype(::Type{CallAndWrap{T}}) where {T} = VartypeT
SymbolicUtils.symtype(x::CallAndWrap) = symtype(x.f)
SymbolicIndexingInterface.getname(x::CallAndWrap) = getname(x.f)
SymbolicIndexingInterface.hasname(x::CallAndWrap) = hasname(x.f)
Symbolics.rename(x::CallAndWrap, name) = CallAndWrap(rename(x.f, name))
SymbolicUtils.getmetadata(x::CallAndWrap, args...) = SymbolicUtils.getmetadata(x.f, args...)
SymbolicUtils.setmetadata(x::CallAndWrap, args...) = SymbolicUtils.setmetadata(x.f, args...)
SymbolicUtils.hasmetadata(x::CallAndWrap, args...) = SymbolicUtils.hasmetadata(x.f, args...)

function nterms(t::SymbolicT, cache::Base.IdDict{SymbolicT, Int} = Base.IdDict{SymbolicT, Int}())
    closure = let t = t, cache = cache
        function __closure()
            iscall(t) || return 1
            return sum(Base.Fix2(nterms, cache), arguments(t))
        end
    end
    get!(closure, cache, t)
end
nterms(t::Num) = nterms(unwrap(t))
nterms(t::Num, cache) = nterms(unwrap(t), cache)

# Soft pivoted
function sym_lu(A::AbstractMatrix{Num}; check=true)
    nterms_cache = Base.IdDict{SymbolicT, Int}()
    SINGULAR = typemax(Int)
    m, n = size(A)
    F = Matrix{Num}(undef, size(A)...)
    copyto!(F, A)
    minmn = min(m, n)
    p = Vector{LinearAlgebra.BlasInt}(undef, minmn)
    info = 0
    for k = 1:minmn
        kp = k
        amin = SINGULAR
        for i in k:m
            absi = _iszero(F[i, k]) ? SINGULAR : nterms(F[i,k], nterms_cache)
            if absi < amin
                kp = i
                amin = absi
            end
        end

        p[k] = kp

        if amin == SINGULAR && iszero(info)
            info = k
        end

        # swap
        for j in 1:n
            F[k, j], F[kp, j] = F[kp, j], F[k, j]
        end

        for i in k+1:m
            F[i, k] = F[i, k] / F[k, k]
        end
        for j = k+1:n
            for i in k+1:m
                F[i, j] = F[i, j] - F[i, k] * F[k, j]
            end
        end
    end
    check && LinearAlgebra.checknonsingular(info)
    LU(F, p, convert(LinearAlgebra.BlasInt, info))
end

"""
    solve_for(eqs, vars; simplify = false, check = true)

Deprecated. Use [`Symbolics.symbolic_linear_solve`](@ref) instead, which takes the same
arguments and returns the same result.

`solve_for` was the original name for Symbolics' linear equation solver. It was renamed to
`symbolic_linear_solve` when [`Symbolics.symbolic_solve`](@ref) was added, so that the two
solvers have names that say how they differ: `symbolic_solve` handles nonlinear (polynomial)
systems and returns all roots, while `symbolic_linear_solve` solves a linear system by
factorization and returns the single solution.

Calling `solve_for` forwards to `symbolic_linear_solve` and emits a deprecation warning. It
will be removed in the next breaking release.
"""
function solve_for(eq::Any, var::Any; simplify=false, check=true)
    Base.depwarn("solve_for is deprecated, please use symbolic_linear_solve instead.", :solve_for)
    return symbolic_linear_solve(eq, var; simplify=simplify, check=check)
end

"""
$(TYPEDSIGNATURES)

Solve equation(s) `eqs` for a set of variables `vars`.

Assumes `length(eqs) == length(vars)`

Currently only works if all equations are linear. `check` if the expr is linear
w.r.t `vars`.

# Examples
```jldoctest
julia> @variables x y
2-element Vector{Num}:
 x
 y

julia> Symbolics.symbolic_linear_solve(x + y ~ 0, x)
-y

julia> all(Symbolics.value.(Symbolics.symbolic_linear_solve([x + y ~ 0, x - y ~ 2], [x, y])) .== [1, -1])
true
```
"""
function symbolic_linear_solve(eq, var; simplify=false, check=true) # scalar case
    # simplify defaults for `false` as canonicalization should handle most of
    # the cases.
    a, b, islinear = linear_expansion(eq, var)
    check && @assert islinear
    islinear || return nothing
    # a * x + b = 0
    x = __solve(a, b, simplify)
    simplify || return x
    if x isa SymbolicT
        return SymbolicUtils.simplify(x)
    end
    map!(SymbolicUtils.simplify, x, x)
    return x
end

function __solve(a::AbstractArray{SymbolicT}, b::AbstractArray{SymbolicT}, simplify::Bool)
    @inbounds for i in eachindex(b)
        b[i] = -b[i]
    end
    return _solve(a, b, simplify)
end
function __solve(a::SymbolicT, b::SymbolicT, simplify::Bool)
    if (a === COMMON_ZERO) || _iszero(a)
        return SymbolicUtils.Const{VartypeT}(NaN)
    end
    return a \ -b
end
__solve(a::Num, b::Num, simplify::Bool) = Num(__solve(unwrap(a), unwrap(b), simplify))

symbolic_linear_solve(eq::Equation, var::T; x...) where {T<:AbstractArray} = symbolic_linear_solve([eq], var; x...)
symbolic_linear_solve(eq::T, var::Num; x...) where {T<:AbstractArray} = first(symbolic_linear_solve(eq, [var]; x...))


function _solve(A::AbstractMatrix{SymbolicT}, b, do_simplify)
    _solve(Num.(A), b, do_simplify)
end
function _solve(A::AbstractMatrix{Num}, b::Union{AbstractArray{Num}, AbstractArray{SymbolicT}}, do_simplify)
    for i in eachindex(A)
        A[i] = SymbolicUtils.quick_cancel(A[i])
    end
    for i in eachindex(b)
        b[i] = SymbolicUtils.quick_cancel(b[i])
    end
    sol = sym_lu(A) \ b
    do_simplify ? SymbolicUtils.simplify_fractions.(sol) : sol
end

function symsub!(A::UpperTriangular, b::AbstractVector, x::AbstractVector = b)
    Base.require_one_based_indexing(A, b, x)
    n = size(A, 2)
    if !(n == length(b) == length(x))
        throw(DimensionMismatch("second dimension of left hand side A, $n, length of output x, $(length(x)), and length of right hand side b, $(length(b)), must be equal"))
    end
    @inbounds for j in n:-1:1
        _iszero(A.data[j,j]) && throw(SingularException(j))
        xj = x[j] = b[j] / A.data[j,j]
        for i in j-1:-1:1
            sub = _isone(xj) ? A.data[i,j] : A.data[i,j] * xj
            if !_iszero(sub)
                b[i] -= sub
            end
        end
    end
    x
end

function symsub!(A::UnitLowerTriangular, b::AbstractVector, x::AbstractVector = b)
    Base.require_one_based_indexing(A, b, x)
    n = size(A, 2)
    if !(n == length(b) == length(x))
        throw(DimensionMismatch("second dimension of left hand side A, $n, length of output x, $(length(x)), and length of right hand side b, $(length(b)), must be equal"))
    end
    @inbounds for j in 1:n
        xj = x[j] = b[j]
        for i in j+1:n
            sub = _isone(xj) ? A.data[i,j] : A.data[i,j] * xj
            if !_iszero(sub)
                b[i] -= sub
            end
        end
    end
    x
end

const _SymEltype = Union{BasicSymbolic, RCNum}
# The two-argument methods mirror LinearAlgebra's own signatures so that its strided and
# sparse `ldiv!` methods do not take precedence over the symbolic substitution.
for T in (UpperTriangular, UnitLowerTriangular)
    @eval begin
        LinearAlgebra.ldiv!(A::$T{<:_SymEltype}, b::StridedVector{<:_SymEltype}) = symsub!(A, b, b)
        LinearAlgebra.ldiv!(A::$T{<:_SymEltype}, b::AbstractVector{<:_SymEltype}, x::AbstractVector{<:_SymEltype}) = symsub!(A, b, x)
    end
    for S in (:(StridedMatrix{E}), :(Adjoint{E, <:StridedMatrix{E}}), :(Transpose{E, <:StridedMatrix{E}}))
        @eval LinearAlgebra.ldiv!(A::$T{E, <:$S}, b::SparseVector{<:_SymEltype}) where {E <: _SymEltype} = symsub!(A, b, b)
    end
end

minor(B, j) = @view B[2:end, 1:size(B, 2) .!= j]
minor(B, i, j) = @view B[1:size(B,1) .!= i, 1:size(B,2) .!= j]
function LinearAlgebra.det(A::AbstractMatrix{<:RCNum}; laplace=true)
    if laplace
        n = LinearAlgebra.checksquare(A)
        if n == 1
            return A[1, 1]
        elseif n == 2
            return A[1, 1] * A[2, 2] - A[1, 2] * A[2, 1]
        else
            return sum((-1)^(1+j) * A[1,j] * det(minor(A,j), laplace=true)
                       for j in axes(A,2))
        end
    else
        if istriu(A) || istril(A)
            return det(UpperTriangular(A))
        end
        return det(lu(A; check = false))
    end
end

Base.inv(A::AbstractMatrix{<:RCNum}; laplace=true) = _invl(A; laplace=laplace)
Base.inv(A::StridedMatrix{<:RCNum}; laplace=true) = _invl(A; laplace=laplace)

function _invl(A::AbstractMatrix{<:RCNum}; laplace=true)
    if laplace
		n = LinearAlgebra.checksquare(A)
        A⁻¹ = similar(A)
        idet = 1/det(A; laplace=true)
	if n==1
	    A⁻¹[1,1] = idet
	    return A⁻¹
	end
        for i=1:size(A,1)
            for j = 1:size(A,1)
                A⁻¹[i,j] = (-1)^(i+j)*det(minor(A, j, i); laplace=true)*idet
            end
        end
        return A⁻¹
    else
        if istriu(A) || istril(A)
            return inv(UpperTriangular(A))
        end
        return inv(lu(A; check = false))
    end
end

"""
    (a, b, islinear) = linear_expansion(t, x)

When `islinear`, return `a` and `b` such that `a * x + b == t`. Instead of calling
`linear_expansion` multiple times with the same `x`, prefer using
[`Symbolics.LinearExpander`](@ref).
"""
function linear_expansion(t, x::Num)
    a, b, islin = linear_expansion(t, unwrap(x))
    Num(a), Num(b), islin
end

@inline function linear_expansion(t, x::SymbolicT)
    return LinearExpander(x)(unwrap(t))
end

function linear_expansion(ts::AbstractArray{T}, xs::AbstractArray{S}) where {T <: Union{Num, SymbolicT, Equation}, S <: Union{SymbolicT, Num}}
    ts = vec(ts)
    xs = vec(xs)
    A = Matrix{SymbolicT}(undef, length(ts), length(xs))
    bvec = Vector{SymbolicT}(undef, length(ts))
    map!(bvec, ts) do t
        if t isa Equation
            return t.rhs - t.lhs
        elseif t isa Num
            return unwrap(t)
        else
            return t
        end
    end
    for (j, x) in enumerate(xs)
        lex = LinearExpander(unwrap(x))
        for (i, t) in enumerate(bvec)
            a, resid, islin = lex(t)
            islin || return A, bvec, false
            A[i, j] = a
            bvec[i] = resid
        end
    end
    return A, bvec, true
end
@inline trivial_linear_expansion(t, x) = isequal(t, x) ? (COMMON_ONE, COMMON_ZERO, true) : (COMMON_ZERO, t, true)

is_expansion_leaf(t) = !iscall(t) || (operation(t) isa Operator)
@noinline throw_bad_expansion() = error("The operation is an Operator. This should never happen.")

const LinearExpansionResultT = Tuple{SymbolicT, SymbolicT, Bool}
"""
    $TYPEDEF

A functor which acts as the workhorse for [`Symbolics.linear_expansion`](@ref). The operation
`linear_expansion(t::Symbolics.SymbolicT, x::Symbolics.SymbolicT)` can equivalently be
phrased as `LinearExpander(x)(t)`. This functor caches data during processing, and thus
several `linear_expansion` calls with the same `x` can be rephrased as multiple calls to
`LinearExpansion(x)`. This can help avoid repeated computation and allocations.
"""
struct LinearExpander
    x::SymbolicT
    arr::Union{SymbolicT, Nothing}
    occursin_cache::Dict{SymbolicT, Bool}
    result_cache::Dict{SymbolicT, LinearExpansionResultT}
    strict::Bool
end

"""
    $TYPEDSIGNATURES

Create a `LinearExpander`. If `strict == true`, `ex` occurring in the condition of `ifelse`
will not be considered linear.
"""
function LinearExpander(ex::SymbolicT; strict = false)
    @match ex begin
        BSImpl.Term(; f, args) && if f === getindex end => begin
            LinearExpander(ex, args[1], Dict{SymbolicT, Bool}(ex => true, args[1] => true), Dict{SymbolicT, LinearExpansionResultT}(), strict)
        end
        _ => LinearExpander(ex, nothing, Dict{SymbolicT, Bool}(ex => true), Dict{SymbolicT, LinearExpansionResultT}(), strict)
    end
end
LinearExpander(ex::Num; kw...) = LinearExpander(unwrap(ex); kw...)

@inline function _linear_expansion_predicate(lex::LinearExpander, t::SymbolicT)
    (; x, arr) = lex
    isequal(t, x) && return true
    arr isa SymbolicT && isequal(t, arr) && return true
end

function _linear_expansion_occursin(lex::LinearExpander, t::SymbolicT)
    (; x, arr, occursin_cache) = lex
    cached = get(occursin_cache, t, nothing)
    if cached isa Bool
        return cached
    end
    _linear_expansion_predicate(lex, t) && return true
    iscall(t) || return false
    return occursin_cache[t] = any(Base.Fix1(_linear_expansion_occursin, lex), arguments(t))
end

function _linear_expansion_recurse(lex::LinearExpander, t::SymbolicT)
    result = get(lex.result_cache, t, nothing)
    if result isa LinearExpansionResultT
        return result
    end
    result = lex(t)
    lex.result_cache[t] = result
    return result
end

# _linear_expansion always returns `SymbolicT`
(lex::LinearExpander)(t) = (COMMON_ZERO, SConst(t), true)

function (lex::LinearExpander)(t::Equation)
    a₂, b₂, islinear = lex(t.rhs)
    islinear || return (COMMON_ZERO, COMMON_ZERO, false)
    a₁, b₁, islinear = lex(t.lhs)
    # t.rhs - t.lhs = 0
    return (a₂ - a₁, b₂ - b₁, islinear)
end

(lex::LinearExpander)(t::Num) = lex(unwrap(t))

const SUPPORTS_LINEAR_EXPANDER_NEED_REMAINDER = true

function (lex::LinearExpander)(t::SymbolicT; need_remainder::Bool = true)
    (; x) = lex
    is_expansion_leaf(t) && return trivial_linear_expansion(t, x)
    isequal(t, x) && return (COMMON_ONE, COMMON_ZERO, true)
    _linear_expansion_occursin(lex, t) || return (COMMON_ZERO, t, true)

    @match t begin
        BSImpl.Term(; f) && if f isa Operator end => throw_bad_expansion()
        BSImpl.AddMul(; coeff, dict, variant, type, shape) => begin
            if variant === SymbolicUtils.AddMulVariant.ADD
                # `t = coeff + Σ v*k` with each `k = a_k*x + b_k`. Addends free of
                # `x` have `a_k == 0` and `b_k === k`, so keep them in the original
                # dict and only splice in the ones that change, instead of re-summing
                # (re-hashconsing) every addend.
                a_buffer = SArgsT()
                b_newdict = dict
                b_extras = SArgsT()
                b_dirty = false
                for (k, v) in dict
                    a, b, islin = _linear_expansion_recurse(lex, k)
                    islin || return (COMMON_ZERO, COMMON_ZERO, false)
                    if _iszero(a) && isequal(b, k)
                        continue
                    end
                    _iszero(a) || push!(a_buffer, a * v)
                    # When the caller doesn't need the remainder skip rebuilding it:
                    need_remainder || continue
                    if !b_dirty
                        b_newdict = copy(dict)
                        b_dirty = true
                    end
                    delete!(b_newdict, k)
                    _iszero(b) || push!(b_extras, b * v)
                end
                a = isempty(a_buffer) ? COMMON_ZERO : SymbolicUtils.add_worker(VartypeT, a_buffer)
                need_remainder || return (a, COMMON_ZERO, true)
                if !b_dirty
                    return a, t, true
                end
                b = SymbolicUtils.Add{VartypeT}(coeff, b_newdict; type, shape)
                if !isempty(b_extras)
                    push!(b_extras, b)
                    b = SymbolicUtils.add_worker(VartypeT, b_extras)
                end
                return a, b, true
            else
                a = COMMON_ZERO
                b = COMMON_ZERO
                k = COMMON_ZERO
                newdict = dict
                dirty = false
                extras = SArgsT()
                for (_k, _v) in dict
                    _a, _b, islin = _linear_expansion_recurse(lex, _k)
                    islin || return (COMMON_ZERO, COMMON_ZERO, false)
                    _a_zero = _iszero(_a)
                    if _a_zero
                        isequal(_b, _k) && continue
                        if !dirty
                            newdict = copy(dict)
                            dirty = true
                        end
                        delete!(newdict, _k)
                        if SymbolicUtils.ismul(_b)
                            push!(extras, _b ^ _v)
                        else
                            newdict[_b] = _v
                        end
                        continue
                    end
                    _a_zero && continue
                    a === COMMON_ZERO || return (COMMON_ZERO, COMMON_ZERO, false)
                    _isone(_v) || return (COMMON_ZERO, COMMON_ZERO, false)
                    a = _a
                    b = _b
                    k = _k
                end
                if a === COMMON_ZERO
                    dirty || return (COMMON_ZERO, t, true)
                    b = SymbolicUtils.Mul{VartypeT}(coeff, newdict; type, shape)
                    if !isempty(extras)
                        push!(extras, b)
                        b = SymbolicUtils.mul_worker(VartypeT, extras)
                    end
                    return (COMMON_ZERO, b, true)
                end
                if !dirty
                    newdict = copy(dict)
                end
                delete!(newdict, k)
                tmp = SymbolicUtils.Mul{VartypeT}(coeff, newdict; type, shape)
                if !isempty(extras)
                    push!(extras, tmp)
                    tmp = SymbolicUtils.mul_worker(VartypeT, extras)
                end
                return (a * tmp, b * tmp, true)
            end
        end
        BSImpl.Term(; f, args) => begin
            if f === (-)
                @assert length(args) == 1
                a, b, islin = _linear_expansion_recurse(lex, args[1])
                islin || return (COMMON_ZERO, COMMON_ZERO, false)
                return -a, -b, islin
            elseif f === (^)
                # If we are here, then both the base and exponent are non-trivial yet the
                # expression contains `x`. Thus `t` cannot be linear in `x`
                return (COMMON_ZERO, COMMON_ZERO, false)
            elseif f === getindex
                # This is a `getindex` expression that somehow contains `x`. It is not
                # identical to `x`, otherwise we would have exited earlier.
                #
                # Case 1: `x` is an indexed array and `t` is another element of the same
                # array
                arrt = args[1]
                @match x begin
                    BSImpl.Term(; f = fx, args = argsx) && if fx === getindex end => begin
                        isequal(arrt, argsx[1]) && return (COMMON_ZERO, t, true)
                    end
                    _ => nothing
                end

                indexed_t = scalarize(t)
                # when indexing a registered function/callable symbolic
                # scalarizing and indexing leads to the same symbolic variable
                # which causes a StackOverflowError without this
                isequal(t, indexed_t) && return (COMMON_ZERO, COMMON_ZERO, false)
                return _linear_expansion_recurse(lex, indexed_t)
            elseif f === ifelse
                cond, iftrue, iffalse = args
                if lex.strict && _linear_expansion_occursin(lex, cond)
                    return (COMMON_ZERO, COMMON_ZERO, false)
                end
                truea, trueb, istruelinear = _linear_expansion_recurse(lex, iftrue)
                istruelinear || return (COMMON_ZERO, t, false)
                falsea, falseb, isfalselinear = _linear_expansion_recurse(lex, iffalse)
                isfalselinear || return (COMMON_ZERO, t, false)
                a = isequal(truea, falsea) ? truea : ifelse(cond, truea, falsea)
                b = isequal(trueb, falseb) ? trueb : ifelse(cond, trueb, falseb)
                return (a, b, true)
            elseif f === LinearAlgebra.dot
                a, b = args
                sh = SymbolicUtils.shape(a)
                if !SymbolicUtils.is_array_shape(sh)
                    return _linear_expansion_recurse(lex, a * b)
                end
                if sh isa SymbolicUtils.Unknown
                    return (COMMON_ZERO, t, false)
                end
                sh = sh::SymbolicUtils.ShapeVecT
                add_buffer = SymbolicUtils.ArgsT{VartypeT}()
                sizehint!(add_buffer, length(a))
                for i in SymbolicUtils.stable_eachindex(a)
                    push!(add_buffer, LinearAlgebra.dot(a[i], b[i]))
                end
                res = SymbolicUtils.add_worker(VartypeT, add_buffer)
                return _linear_expansion_recurse(lex, res)
            else
                for (i, arg) in enumerate(args)
                    _linear_expansion_predicate(lex, arg) && return (COMMON_ZERO, COMMON_ZERO, false)
                    a, b, islin = _linear_expansion_recurse(lex, arg)
                    (_iszero(a) && islin) || return (COMMON_ZERO, COMMON_ZERO, false)
                end
                return (COMMON_ZERO, t, true)
            end
        end
        BSImpl.Div(; num, den, type, shape) => begin
            if _linear_expansion_occursin(lex, den)
                return (COMMON_ZERO, COMMON_ZERO, false)
            end
            a, b, islin = _linear_expansion_recurse(lex, num)
            islin || return (COMMON_ZERO, COMMON_ZERO, false)
            a = SymbolicUtils.Div{VartypeT}(a, den, false; type, shape)
            b = SymbolicUtils.Div{VartypeT}(b, den, false; type, shape)
            return a, b, true
        end
        BSImpl.ArrayOp(; output_idx) => begin
            if isempty(output_idx)
                # is scalar
                scal = SymbolicUtils.scalarize(t, Val{true}())::SymbolicT
                return _linear_expansion_recurse(lex, scal)
            else
                # TODO: call `_linear_expansion(t.expr, x)` and parse the result
                return COMMON_ZERO, COMMON_ZERO, false
            end
        end
    end
end

###
### Utilities
###

# Pretty much just copy-pasted from stdlib
function _sparse(::Type{Tv}, ::Type{Ti}, M) where {Tv, Ti}
    nz = count(!_iszero, M)
    colptr = zeros(Ti, size(M, 2) + 1)
    nzval = Vector{Tv}(undef, nz)
    rowval = Vector{Ti}(undef, nz)
    colptr[1] = 1
    cnt = 1
    @inbounds for j in 1:size(M, 2)
        for i in 1:size(M, 1)
            v = M[i, j]
            if !_iszero(v)
                rowval[cnt] = i
                nzval[cnt] = v
                cnt += 1
            end
        end
        colptr[j+1] = cnt
    end
    return SparseMatrixCSC(size(M, 1), size(M, 2), colptr, rowval, nzval)
end

function activeState end
function entry end
function ticksInState end
function timeInState end

for (s, T) in [(:timeInState, :Real),
               (:ticksInState, :Integer),
               (:entry, :Bool),
               (:activeState, :Bool)]
    seed = hash(s)
    @eval begin
        $s(x) = wrap(term($s, x))
        SymbolicUtils.promote_symtype(::typeof($s), _...) = $T
        function SymbolicUtils.show_call(io, ::typeof($s), args)
            if isempty(args)
                print(io, $s, "()")
            else
                arg = only(args)
                print(io, $s, "(", arg isa Number ? arg : nameof(arg), ")")
            end
        end
    end
    if s != :activeState
        @eval $s() = wrap(term($s))
    end
end

"""
    timeInState()
    timeInState(state)

Get the time (in seconds) spent in a state in a finite state machine.

When used to query the time spent in the enclosing state, the method without arguments is used, i.e.,
```julia
@mtkmodel FSM begin
    ...
    @equations begin
        var(k+1) ~ timeInState() >= 2 ? 0.0 : var(k)
    end
end
```

If used to query the residence time of another state, the state is passed as an argument.

This operator can be used in both equations and transition conditions.

See also [`ticksInState`](@ref) and [`entry`](@ref)
"""
timeInState

"""
    ticksInState()
    ticksInState(state)

Get the number of ticks spent in a state in a finite state machine.

When used to query the number of ticks spent in the enclosing state, the method without arguments is used, i.e.,
```julia
@mtkmodel FSM begin
    ...
    @equations begin
        var(k+1) ~ ticksInState() >= 2 ? 0.0 : var(k)
    end
end
```

If used to query the number of ticks in another state, the state is passed as an argument.

This operator can be used in both equations and transition conditions.

See also [`timeInState`](@ref) and [`entry`](@ref)
"""
ticksInState

"""
    entry()
    entry(state)

When used in a finite-state machine, this operator returns true at the first tick when the state is active, and false otherwise.

When used to query the entry of the enclosing state, the method without arguments is used, when used to query the entry of another state, the state is passed as an argument.

This can be used to perform a unique action when entering a state.
"""
entry

"""
    activeState(state)

When used in a finite state machine, this operator returns `true` if the queried state is active and false otherwise. 
"""
activeState

:(function (x,)
      let _out = (zeros)(Float64, (map)(length, (1:6, 1:6)))
          var"%_out" = begin
                  _out_1 = (view)(_out, 2:5, 2:5)
                  var"%_out_1" = for var"%jj′" = (zip)(Base.OneTo(4), (Symbolics.reset_to_one)(Base.OneTo(4)))
                          begin
                              j = var"%jj′"[1]
                              j′ = var"%jj′"[2]
                              for var"%ii′" = (zip)(Base.OneTo(4), (Symbolics.reset_to_one)(Base.OneTo(4)))
                                  begin
                                      i = var"%ii′"[1]
                                      i′ = var"%ii′"[2]
                                      begin
                                          _out_1[(CartesianIndex)(i′, j′)] = (+)((getindex)(_out_1, i′, j′), (getindex)(x, j, i))
                                          nothing
                                      end
                                  end
                              end
                          end
                      end
                  nothing
              end
          _out
      end
  end)

struct Struct{T} <: Real
end

"""
    symstruct(T)

Create a symbolic wrapper for struct from a given struct `T`.
"""
symstruct(::Type{T}) where T = Struct{T}
Struct{T}(vals...) where T = T(vals...)

function Base.hash(x::Struct{T}, seed::UInt) where T
    h1 = hash(T, seed)
    h2 ⊻ (0x0e39036b7de2101a % UInt)
end

"""
    juliatype(s::Type{<:Struct})

Get the Julia type that `s` is representing.
"""
juliatype(::Type{Struct{T}}) where T = T
getelements(s::Type{<:Struct}) = fieldnames(juliatype(s))
getelementtypes(s::Type{<:Struct}) = fieldtypes(juliatype(s))

typed_getfield(obj, ::Val{fieldname}) where fieldname = getfield(obj, fieldname)

"""
    symbolic_getproperty(ss, name::Symbol)

Symbolic term corresponding to accessing the field with name `name`.
"""
function symbolic_getproperty(ss, name::Symbol)
    s = symtype(ss)
    idx = findfirst(isequal(name), getelements(s))
    idx === nothing && error("$(juliatype(s)) doesn't have field $(name)!")
    T = getelementtypes(s)[idx]
    if isstructtype(T)
        T = Struct{T}
    end
    SymbolicUtils.term(typed_getfield, ss, Val{name}(), type = T)
end
function symbolic_getproperty(s::Union{Arr, Num}, name::Symbol)
    wrap(symbolic_getproperty(unwrap(s), name))
end

"""
    symbolic_setproperty!(ss, name::Symbol)

Symbolic term corresponding to modifying the field with name `name` to val `val`.
"""
function symbolic_setproperty!(ss, name::Symbol, val)
    s = symtype(ss)
    idx = findfirst(isequal(name), getelements(s))
    idx === nothing && error("$(juliatype(s)) doesn't have field $(name)!")
    T = getelementtypes(s)[idx]
    SymbolicUtils.term(setfield!, ss, Meta.quot(name), val, type = T)
end
function symbolic_setproperty!(s::Union{Arr, Num}, name::Symbol, val)
    wrap(symbolic_setproperty!(unwrap(s), name, val))
end

function symbolic_constructor(s::Type{<:Struct}, vals...)
    N = length(getelements(s))
    N′ = length(vals)
    N′ == N || error("$(juliatype(s)) needs $N field. Got $N′ fields!")
    SymbolicUtils.term(s, vals..., type = s)
end

# We cannot precisely derive the type after `getfield` due to SU limitations,
# so give up and just say Real.
function SymbolicUtils.promote_symtype(::typeof(typed_getfield), ::Type{<:Struct{T}}, v::Type{Val{fieldname}}) where {T, fieldname} 
    FT = fieldtype(T, fieldname)
    if isstructtype(FT)
        return Struct{FT}
    end 
    FT
end

function SymbolicUtils.promote_symtype(s::Type{<:Struct{T}}, _...) where T
    s
end

SymbolicUtils.promote_symtype(::typeof(setfield!), ::Type{<:Struct}, _, ::Type{T}) where T = T

module SymbolicsLatexifyExt

using Symbolics
using Latexify
using LaTeXStrings
using TermInterface
using SymbolicUtils
using Symbolics: value, hide_lhs, wrap
using MacroTools: postwalk
using SymbolicUtils: BSImpl, FnType, unwrap, symtype, BasicSymbolic
using Moshi.Match: @match

# metadata to specify how to format syms
struct SymLatexWrapper end
Symbolics.option_to_metadata_type(::Val{:latexwrapper}) = SymLatexWrapper

function default_latex_wrapper(sym)
    length(sym) <= 1 && return sym
    return string("\\mathtt{", sym, "}")
end

prettify_expr(expr) = expr
prettify_expr(f::Function) = nameof(f)
prettify_expr(expr::Expr) = Expr(expr.head, prettify_expr.(expr.args)...)

function cleanup_exprs(ex)
    return postwalk(x -> iscall(x) && length(arguments(x)) == 0 ? operation(x) : x, ex)
end

function latexify_derivatives(ex)
    return postwalk(ex) do x
        Meta.isexpr(x, :call) || return x
        if x.args[1] == :_derivative
            num, den, deg = x.args[2:end]
            if num isa Expr && length(num.args) == 2
                return Expr(
                    :call, :/,
                    Expr(
                        :call, :*,
                        "\\mathrm{d}$(deg == 1 ? "" : "^{$deg}")", num
                    ),
                    diffdenom(den)
                )
            else
                return Expr(
                    :call, :*,
                    Expr(
                        :call, :/,
                        "\\mathrm{d}$(deg == 1 ? "" : "^{$deg}")",
                        diffdenom(den)
                    ),
                    num
                )
            end
        elseif x.args[1] === :_integral
            lower, upper, var_of_int, integrand = x.args[2:end]
            lower_s = strip(latexify(lower).s, '\$')
            upper_s = strip(latexify(upper).s, '\$')
            return Expr(
                :call, :*,
                "\\int_{$lower_s}^{$upper_s)}",
                var_of_int,
                integrand
            )
        elseif x.args[1] === :_textbf
            ls = latexify(latexify_derivatives(sorted_arguments(x)[1])).s
            return "\\textbf{" * strip(ls, '\$') * "}"
        else
            return x
        end
    end
end

# `latexify_derivatives` can collapse a top-level node into a bare `String` (e.g.
# `_textbf(...)` -> "\\textbf{...}", reachable both from the array-symbol branch and from
# a custom `_toexpr_metadata`/`_toexpr_op` hook). Latexify would try to re-parse such a
# `String` as an expression and fail, so wrap a top-level string as a `LaTeXString`, which
# is emitted verbatim. Strings nested inside an `Expr` are left untouched.
_as_latexstring(x) = x
_as_latexstring(x::AbstractString) = LaTeXString(x)

recipe(n) = _as_latexstring(latexify_derivatives(cleanup_exprs(_toexpr(n))))

function align_side(n)
    wrapped = wrap(n)
    return wrapped isa Symbolics.Arr ? recipe(n) : wrapped
end

@latexrecipe function f(n::Num)
    env --> :equation
    mult_symbol --> "~"
    fmt --> FancyNumberFormatter(5)
    index --> :subscript
    snakecase --> true
    safescripts --> true

    return recipe(value(n))
end

@latexrecipe function f(z::Complex{Num})
    env --> :equation
    mult_symbol --> "~"
    index --> :subscript

    iszero(z.im) && return :($(recipe(value(z.re))))
    iszero(z.re) && return :($(recipe(value(z.im))) * $im)
    return :($(recipe(value(z.re))) + $(recipe(value(z.im))) * $im)
end

@latexrecipe function f(n::Function)
    env --> :equation
    mult_symbol --> "~"
    index --> :subscript

    return nameof(n)
end


@latexrecipe function f(n::Symbolics.Arr)
    env --> :equation
    mult_symbol --> "~"
    index --> :subscript

    return value(n)
end

@latexrecipe function f(n::Symbolics.CallAndWrap)
    env --> :equation
    mult_symbol --> "~"
    index --> :subscript

    return n.f
end

@latexrecipe function f(n::SymbolicUtils.BasicSymbolic)
    env --> :equation
    mult_symbol --> "~"
    index --> :subscript

    return recipe(n)
end

@latexrecipe function f(eqs::Vector{Equation})
    index --> :subscript
    has_connections = any(x -> hide_lhs(value(x.lhs)), eqs)
    if has_connections
        env --> :equation
        return map(first ∘ first ∘ Latexify.apply_recipe, eqs)
    else
        env --> :align
        return align_side.(getfield.(eqs, :lhs)), align_side.(getfield.(eqs, :rhs))
    end
end

@latexrecipe function f(eq::Equation)
    env --> :equation
    index --> :subscript

    if hide_lhs(value(eq.lhs)) || !(value(eq.lhs) isa Union{Number, AbstractArray, BasicSymbolic})
        return value(eq.rhs)
    else
        return Expr(:(=), recipe(eq.lhs), recipe(eq.rhs))
    end
end

Base.show(io::IO, ::MIME"text/latex", x::Symbolics.RCNum) = print(io, "\$\$ " * latexify(x) * " \$\$")
Base.show(io::IO, ::MIME"text/latex", x::SymbolicUtils.BasicSymbolic) = print(io, "\$\$ " * latexify(x) * " \$\$")
Base.show(io::IO, ::MIME"text/latex", x::Equation) = print(io, "\$\$ " * latexify(x) * " \$\$")
Base.show(io::IO, ::MIME"text/latex", x::Vector{Equation}) = print(io, "\$\$ " * latexify(x) * " \$\$")
Base.show(io::IO, ::MIME"text/latex", x::AbstractArray{<:Symbolics.RCNum}) = print(io, "\$\$ " * latexify(x) * " \$\$")

# Iterate a node's metadata, dispatching to the `Symbolics._toexpr_metadata` hook for
# each context. The per-context hook (and the `Symbolics._toexpr_op` hook used below) is
# defined in `Symbolics` so downstream packages can extend it via `import Symbolics`
# without reaching into this extension with `Base.get_extension`.
function Symbolics._toexpr_metadata(O; latexwrapper = default_latex_wrapper)
    md = SymbolicUtils.metadata(O)
    md isa AbstractDict || return nothing
    for (ctx, val) in md
        out = Symbolics._toexpr_metadata(O, ctx, val; latexwrapper)
        out === nothing || return out
    end
    return nothing
end

# `_toexpr` is only used for latexify
function _toexpr(O; latexwrapper = default_latex_wrapper)
    O = unwrap(O)
    SymbolicUtils.isconst(O) && return value(O)
    custom = Symbolics._toexpr_metadata(O; latexwrapper)
    custom === nothing || return custom
    return _toexpr_plain(O; latexwrapper)
end

function _toexpr_plain(O; latexwrapper = default_latex_wrapper)
    if SymbolicUtils.ismul(O)
        m = O
        numer = Any[]
        denom = Any[]

        # We need to iterate over each term in m, ignoring the numeric coefficient.
        # This iteration needs to be stable, so we can't iterate over m.dict.
        for term in Iterators.drop(sorted_arguments(m), isone(m.coeff) ? 0 : 1)
            if !SymbolicUtils.ispow(term)
                push!(numer, _toexpr(term))
                continue
            end
            base, pow = arguments(term)
            pow = value(pow)
            isneg = (pow isa Number && pow < 0) || (iscall(pow) && operation(pow) === (-) && length(arguments(pow)) == 1)
            if !isneg
                if SymbolicUtils._isone(pow)
                    pushfirst!(numer, _toexpr(base))
                else
                    pushfirst!(numer, Expr(:call, :^, _toexpr(base), _toexpr(pow)))
                end
            else
                newpow = -1 * pow
                if SymbolicUtils._isone(newpow)
                    pushfirst!(denom, _toexpr(base))
                else
                    pushfirst!(denom, Expr(:call, :^, _toexpr(base), _toexpr(newpow)))
                end
            end
        end

        if !isreal(m.coeff)
            numer_expr = Expr(:call, :*, m.coeff, numer...)
        elseif isempty(numer) || !isone(abs(m.coeff))
            numer_expr = Expr(:call, :*, abs(m.coeff), numer...)
        else
            numer_expr = length(numer) > 1 ? Expr(:call, :*, numer...) : numer[1]
        end

        if isempty(denom)
            frac_expr = numer_expr
        else
            denom_expr = length(denom) > 1 ? Expr(:call, :*, denom...) : denom[1]
            frac_expr = Expr(:call, :/, numer_expr, denom_expr)
        end

        if isreal(m.coeff) && real(m.coeff) < 0
            return Expr(:call, :-, frac_expr)
        else
            return frac_expr
        end
    end
    if SymbolicUtils.issym(O)
        sym = string(nameof(O))
        sym = replace(sym, Symbolics.NAMESPACE_SEPARATOR => ".")

        # override if the sym has its own latex wrapper
        symwrapper = hasmetadata(O, SymLatexWrapper) ? getmetadata(O, SymLatexWrapper) :
            latexwrapper
        sym = symwrapper(sym)
        return Symbol(sym)
    end
    !iscall(O) && return O

    op = operation(O)
    args = sorted_arguments(O)
    latexwrapper = hasmetadata(O, SymLatexWrapper) ? getmetadata(O, SymLatexWrapper) :
        default_latex_wrapper

    custom_op = Symbolics._toexpr_op(op, args; latexwrapper)
    custom_op === nothing || return custom_op

    if (op === (*)) && (args[1] === -1)
        arg_mul = Expr(:call, :(*), _toexpr(args[2:end])...)
        return Expr(:call, :(-), arg_mul)
    end

    if op isa Differential
        #  DERIVATIVES LOGIC
        num = args[1]
        diff_var = op.x

        deg = op.order

        while iscall(num) && operation(num) isa Differential && isequal(operation(num).x, diff_var)
            inner_op = operation(num)
            deg += inner_op.order
            num = arguments(num)[1]
        end

        den = deg > 1 ? (diff_var^deg) : diff_var
        return :(_derivative($(_toexpr(num)), $den, $deg))

    elseif op isa Integral
        lower = op.domain.domain.left
        upper = op.domain.domain.right
        vars = op.domain.variables
        integrand = args[1]
        var = if vars isa Tuple
            Expr(:call, :(*), _toexpr(vars...))
        else
            _toexpr(vars)
        end
        return Expr(:call, :_integral, _toexpr(lower), _toexpr(upper), vars, _toexpr(integrand))
    elseif symtype(op) <: FnType
        isempty(args) && return nameof(op)
        return Expr(:call, _toexpr(op; latexwrapper), _toexpr(args)...)
    elseif op === getindex && symtype(args[1]) <: AbstractArray
        return getindex_to_symbol(O)
    elseif op === (\)
        return :(solve($(_toexpr(args[1])), $(_toexpr(args[2]))))
    elseif SymbolicUtils.issym(op) && SymbolicUtils.symtype(op) <: AbstractArray
        return :(_textbf($(nameof(op))))
    elseif op === identity
        return _toexpr(only(args)) # suppress identity transformations (e.g. "identity(π)" -> "π")
    end
    return Expr(:call, Symbol(op), _toexpr(args; latexwrapper)...)
end
_toexpr(x::Integer; latexwrapper = default_latex_wrapper) = x
_toexpr(x::AbstractFloat; latexwrapper = default_latex_wrapper) = x

function _toexpr(eq::Equation; latexwrapper = default_latex_wrapper)
    return Expr(:(=), _toexpr(eq.lhs), _toexpr(eq.rhs))
end

_toexpr(eqs::AbstractArray; latexwrapper = default_latex_wrapper) = map(eq -> _toexpr(eq), eqs)
_toexpr(x::Num; latexwrapper = default_latex_wrapper) = _toexpr(value(x))

function getindex_to_symbol(t)
    @assert iscall(t) && operation(t) === getindex && SymbolicUtils.symtype(sorted_arguments(t)[1]) <: AbstractArray
    args = sorted_arguments(t)
    idxs = args[2:end]
    O = args[1]
    latexwrapper = (O isa SymbolicUtils.BasicSymbolic && hasmetadata(O, SymLatexWrapper)) ? getmetadata(O, SymLatexWrapper) :
        default_latex_wrapper

    # this is to ensure X(t)[1] becomes X_1(t) in Latex
    if iscall(O) && SymbolicUtils.issym(operation(O))
        oop = operation(O)
        oargs = sorted_arguments(O)
        return :($(_toexpr(oop; latexwrapper))[$(idxs...)]($(_toexpr(oargs)...)))
    else
        return :($(_toexpr(O; latexwrapper))[$(idxs...)])
    end
end

function diffdenom(e)
    e = unwrap(e)
    return if SymbolicUtils.issym(e)
        LaTeXString("\\mathrm{d}$e")
    elseif SymbolicUtils.ispow(e)
        base, expo = arguments(e)
        suffix = SymbolicUtils._isone(expo) ? "" : "^{$(expo)}"
        LaTeXString("\\mathrm{d}$(base)$(suffix)")
    elseif SymbolicUtils.ismul(e)
        LaTeXString(prod(diffdenom(arg).s for arg in arguments(e)))
    else
        LaTeXString("\\mathrm{d}$e")
    end
end

end

# Checks that the expression is a polynomial with integer or rational
# coefficients
function check_polynomial(poly; strict=true)
    poly = wrap(poly)
    vars = get_variables(poly)
    distr, rem = polynomial_coeffs(poly, vars)
    if strict
        @assert isequal(rem, 0) "Not a polynomial"
        @assert all(c -> c isa Integer || c isa Rational, collect(values(distr))) "Coefficients must be integer or rational"
        return true
    else
        return isequal(rem, 0)
    end
end

# factor(x^2*y + b*x*y - a*x - a*b)  ->  (x*y - a)*(x + b)
function factor_use_nemo(poly::Any)
    throw("Nemo is required. Execute `using Nemo` to enable this functionality.")
end

using Symbolics
import Symbolics: symbolic_to_float, var_from_nested_derivative, unwrap, 
                  isblock, flatten_expr!, build_expr, get_variables, get_differential_vars,
                  is_singleton, diff2term, tosymbol, lower_varname, 
                  makesubscripts, degree, coeff
using SparseArrays
using Test

@testset "get_variables" begin
    @variables t x y z(t)

    ex1 = x + y + sin(z)
    vars1 = Symbolics.get_variables(ex1)
    @test length(vars1) == 3
    @test allunique(vars1)

    sorted_vars1 = Symbolics.get_variables(ex1; sort = true)
    @test isequal(sorted_vars1, [x, y, z])

    ex2 = x - y
    vars2 = Symbolics.get_variables(ex2)
    @test length(vars2) == 2
    @test allunique(vars2)

    sorted_vars2 = Symbolics.get_variables(ex2; sort = true)
    @test isequal(sorted_vars2, [x, y])

    @variables c(..)
    ex3 = c(x) + c(t) - c(c(t) + y)
    vars3 = Symbolics.get_variables(ex3)
    @test length(vars3) == 4

    sorted_vars3 = Symbolics.get_variables(ex3; sort = true)
    @test isequal(sorted_vars3, [c.f, t, x, y])
end

@testset "symbolic_to_float" begin
    @variables x
    @test symbolic_to_float((1//2 * x)/x) isa Rational{Int}
    @test symbolic_to_float((1/2 * x)/x) isa Float64
    @test symbolic_to_float((1//2)*√(279//4)) isa Float64
    @test symbolic_to_float((big(1)//2)*√(279//4)) isa BigFloat
    @test symbolic_to_float((-1//2)*√(279//4)) isa Float64
end

@testset "var_from_nested_derivative" begin
    @variables t x(t) p(..)
    D = Differential(t)
    @test var_from_nested_derivative(x) == (x, 0)
    @test var_from_nested_derivative(D(x)) == (x, 1)
    @test var_from_nested_derivative(p) == (p, 0)
    @test var_from_nested_derivative(D(p(x))) == (p(x), 1)
end

@testset "fixpoint_sub maxiters" begin
    @variables x y
    expr = Symbolics.fixpoint_sub(x, Dict(x => y, y => x))
    @test isequal(expr, x)
    expr = Symbolics.fixpoint_sub(x, Dict(x => y, y => x); maxiters = 9)
    @test isequal(expr, y)
end

@testset "Issue#1342 substitute working on called symbolics" begin
    @variables p(..) x y
    arg = unwrap(substitute(p(x), [p => identity]))
    @test iscall(arg) && operation(arg) == identity && isequal(only(arguments(arg)), x)
    @test unwrap(substitute(p(x), [p => sqrt, x => 4.0])) ≈ 2.0
    arg = Symbolics.fixpoint_sub(p(x), [p => sqrt, x => 2y + 3, y => 1.0 + p(4)])
    @test arg ≈ 3.0
end

# Helper Functions
@variables x y z t u(x, t) v(t) w[1:2]

@testset "isblock" begin
    @test isblock([Expr(:block, :(x + y))]) == true
    @test isblock([Expr(:call, :f, x, y)]) == false
    @test isblock([Expr(:block, :(begin x; y; end))]) == true
    @test isblock([Expr(:return, :(x + y))]) == false
end

@testset "flatten_expr!" begin
    expr = Expr(:block, :(x + y))
    @test flatten_expr!(expr.args) == Any[:(x + y)]

    expr2 = Expr(:block, :(begin x + y; z; end))
    @test flatten_expr!(expr2.args) == Any[:(x + y), :z]
end

@testset "build_expr" begin
    expr = build_expr(:block, [:(x + y), :(y + z)])
    @test expr.head == :block
    @test expr.args == [:(x + y), :(y + z)]
end

@testset "is_singleton" begin
    @test is_singleton(x) == false
    @test is_singleton(sin(x)) == false
    @test is_singleton(u) == false
end

@testset "tosymbol" begin
    expr1 = sin(x)
    @test tosymbol(expr1) == Symbol("sin(x)")

    expr2 = cos(y)
    @test tosymbol(expr2) == Symbol("cos(y)")

    expr4 = u
    @test tosymbol(expr4) == Symbol("u(x, t)")
end

@testset "degree" begin
    expr1 = x^2 + y^3
    @test degree(expr1, x) == 2
    @test degree(expr1, y) == 3

    expr2 = x * y^2 + x^3
    @test degree(expr2, x) == 3
    @test degree(expr2, y) == 2

    expr3 = 1
    @test degree(expr3, x) == 0
end

@testset "coeff" begin
    expr1 = 3x + 2y
    @test coeff(expr1, x) == 3
    @test coeff(expr1, y) == 2
    @test coeff(expr1, x^2) == 0

    expr2 = x^2 + 3x + 2
    @test coeff(expr2, x) == 3
    @test coeff(expr2, x^2) == 1
end

@testset "makesubscripts" begin
    sub1 = makesubscripts(5)
    @test length(sub1) == 5
    @test typeof(sub1[1]) == SymbolicUtils.BasicSymbolic{Int64}

    sub2 = makesubscripts(10)
    @test length(sub2) == 10
end

@testset "diff2term" begin
    @variables x t u(x, t) z(t)
    Dt = Differential(t)
    Dx = Differential(x)

    test_var = x
    result = diff2term(test_var)
    @test result === x

    test_nested_derivative = Dx(Dt(Dt(u)))
    result = diff2term(Symbolics.value(test_nested_derivative))
    @test typeof(result) === Symbolics.BasicSymbolic{Real}

    @testset "staged diff2term on arrays" begin
        @variables t x(t)[1:2]
        D = Differential(t)
        xt = diff2term(unwrap(D(x[1])))
        xtt = diff2term(D(xt))
        xtt_true = diff2term(unwrap(D(D(x[1]))))
        @test isequal(xtt, xtt_true)
    end
end

@testset "get_differential_vars" begin
    @variables t x u(x, t) v(t) w[1:2]
    Dt = Differential(t)
    Dx = Differential(x)

    # Test with no differentials
    expr1 = u + v + x
    diff_vars1 = Symbolics.get_differential_vars(expr1)
    @test length(diff_vars1) == 0

    # Test with single differential
    expr2 = Dt(u) + u
    diff_vars2 = Symbolics.get_differential_vars(expr2)
    @test length(diff_vars2) == 1
    @test isequal(diff_vars2[1], Dt(u))

    # Test with multiple differentials
    expr3 = Dx(u) + Dt(u) + sin(Dt(v))
    diff_vars3 = Symbolics.get_differential_vars(expr3)
    @test length(diff_vars3) == 3
    @test any(isequal(Symbolics.value(Dt(u))), diff_vars3)
    @test any(isequal(Symbolics.value(Dx(u))), diff_vars3)
    @test any(isequal(Symbolics.value(Dt(v))), diff_vars3)

    # Test with nested differentials (finds both outer and inner)
    expr4 = Dx(Dt(u)) + u
    diff_vars4 = Symbolics.get_differential_vars(expr4)
    @test length(diff_vars4) == 2
    @test any(isequal(Symbolics.value(Dx(Dt(u)))), diff_vars4)
    @test any(isequal(Symbolics.value(Dt(u))), diff_vars4)

    # Test with duplicates (should be unique)
    expr5 = Dt(u) + 2*Dt(u) + sin(Dt(u))
    diff_vars5 = Symbolics.get_differential_vars(expr5)
    @test length(diff_vars5) == 1
    @test isequal(diff_vars5[1], Dt(u))

    # Test sorting
    expr6 = Dt(v) + Dx(u) + Dt(u)
    diff_vars6_sorted = Symbolics.get_differential_vars(expr6; sort = true)
    @test length(diff_vars6_sorted) == 3
    # Should be sorted by string representation
    strings = string.(diff_vars6_sorted)
    @test issorted(strings)

    # Test with varlist restriction  
    target_vars = [Symbolics.value(Dt(u)), Symbolics.value(Dx(u))]
    expr7 = Dt(u) + Dx(u) + Dt(v) + u
    diff_vars7 = Symbolics.get_differential_vars(expr7, target_vars)
    @test length(diff_vars7) == 2
    @test any(isequal(Symbolics.value(Dt(u))), diff_vars7)
    @test any(isequal(Symbolics.value(Dx(u))), diff_vars7)
    @test !any(isequal(Symbolics.value(Dt(v))), diff_vars7)

    # Test with Num wrapper
    expr8 = Num(Dt(u)) + Num(u)
    diff_vars8 = Symbolics.get_differential_vars(expr8)
    @test length(diff_vars8) == 1
    @test isequal(diff_vars8[1], Dt(u))

    # Test with array elements
    @variables z(t)[1:2]
    Dz1 = Dt(z[1])
    Dz2 = Dt(z[2])
    expr9 = Dz1 + Dz2 + z[1]
    diff_vars9 = Symbolics.get_differential_vars(expr9)
    @test length(diff_vars9) == 2
    @test any(isequal(Symbolics.value(Dz1)), diff_vars9)
    @test any(isequal(Symbolics.value(Dz2)), diff_vars9)

    # Test with equations
    eq = Dt(u) ~ Dx(u) + u
    diff_vars_eq = Symbolics.get_differential_vars(eq)
    @test length(diff_vars_eq) == 2
    @test any(isequal(Symbolics.value(Dt(u))), diff_vars_eq)
    @test any(isequal(Symbolics.value(Dx(u))), diff_vars_eq)
end

@testset "`fast_substitute` inside array symbolics" begin
    @variables x y z
    @register_symbolic foo(a::AbstractArray, b)
    ex = foo([x, y], z)
    ex2 = Symbolics.fixpoint_sub(ex, Dict(y => 1.0, z => 2.0))
    @test isequal(ex2, foo([x, 1.0], 2.0))
end

@testset "`fast_substitute` of subarray symbolics" begin
    @variables p[1:4] q[1:5]
    @test isequal(p[1:2], Symbolics.fast_substitute(p[1:2], Dict()))
    @test isequal(p[1:2], Symbolics.fast_substitute(p[1:2], p => p))
    @test isequal(q[1:2], Symbolics.fast_substitute(p[1:2], Dict(p => q)))
    @test isequal(q[1:2], Symbolics.fast_substitute(p[1:2], p => q))
end

@testset "`fast_substitute` folding `getindex`" begin
    @variables x[1:3]
    @test isequal(Symbolics.fast_substitute(x[1], Dict(unwrap(x) => collect(unwrap(x)))), x[1])
    @test isequal(Symbolics.fast_substitute(x[1], unwrap(x) => collect(unwrap(x))), x[1])
end

@testset "`fixpoint_sub` and `fast_substitute` on sparse arrays" begin
    @variables x y z
    mat = Num[x 0 0; 0 y 0; 0 0 z]
    mat = sparse(mat)
    mat = unwrap.(mat)
    rules = Dict(x => y, y => z, z => 1)
    res = Symbolics.fixpoint_sub(mat, rules)
    @test res isa SparseMatrixCSC
    @test res[1, 1] == res[2, 2] == res[3, 3] == 1
end

@testset "numerator and denominator" begin
    @variables x y
    num_den(x) = (numerator(x), denominator(x))
    @test num_den(x) == (x, 1)
    @test num_den(1/x) == (1, x)
    @test num_den(x/y) == (x, y)
end

@testset "factors and terms" begin
    @variables x y z

    @test Set(factors(0)) == Set([0])
    @test Set(factors(1)) == Set([1])
    @test Set(factors(x)) == Set([x])
    @test Set(factors(x*y*z)) == Set([x, y, z])

    @test Set(terms(0)) == Set([0])
    @test Set(terms(x)) == Set([x])
    @test Set(terms(x + y + z)) == Set([x, y, z])
    @test Set(terms(-x - y + z)) == Set([-x, -y, z])
end

@testset "evaluate" begin
    @variables x y
    eqn_1 = x ~ y 
    gtr = x ≳ y
    ltr = x ≲ y

    @test Symbolics.evaluate(eqn_1, Dict(x => 1, y => 1))
    @test !Symbolics.evaluate(eqn_1, Dict(x => 1, y => 2))
    @test !Symbolics.evaluate(gtr, Dict(x => 1, y => 2))
    @test Symbolics.evaluate(gtr, Dict(x => 2, y => 1))
    @test Symbolics.evaluate(ltr, Dict(x => 1, y => 2))
    @test !Symbolics.evaluate(ltr, Dict(x => 2, y => 1))
end

using SnoopCompile: @snoop_invalidations, invalidation_trees
using Symbolics

struct FakeType end

@testset "`option_to_metadata_type`" begin
    invs = @snoop_invalidations Symbolics.option_to_metadata_type(::Val{:____!_internal_999}) = FakeType
    @test isempty(invalidation_trees(invs))
end

using Symbolics
using Test

@variables t a b c
@variables x y z
@variables u(t) v(t)[1:3] w(t)[1:3]

@test (a ≲ 2) == Inequality(a, 2, Symbolics.leq)
@test (a * x ≲ b / z) == Inequality(a * x, b / z, Symbolics.leq)
@test (a ≲ u) == Inequality(a, u, Symbolics.leq)
@test (a ≲ sin(u)) == Inequality(a, sin(u), Symbolics.leq)
@test Symbolics.scalarize(v .≲ u) == [Inequality(v[1], u, Symbolics.leq), Inequality(v[2], u, Symbolics.leq), Inequality(v[3], u, Symbolics.leq)]
@test Symbolics.scalarize(v .≲ w .+ 3) == [Inequality(v[1], w[1] + 3, Symbolics.leq), Inequality(v[2], w[2] + 3, Symbolics.leq), Inequality(v[3], w[3] + 3, Symbolics.leq)]

@test Symbolics.canonical_form(a + b *c ≲ x + 2 * x) == (a + b*c - 3x ≲ 0)

@test Symbolics.substitute(a ≲ 2, a => 1) == (1 ≲ 2)

@test (a ≳ 2) == Inequality(a, 2, Symbolics.geq)
@test (a * x ≳ b / z) == Inequality(a * x, b / z, Symbolics.geq)
@test (a ≳ u) == Inequality(a, u, Symbolics.geq)
@test (a ≳ sin(u)) == Inequality(a, sin(u), Symbolics.geq)
@test Symbolics.scalarize(v .≳ u) == [Inequality(v[1], u, Symbolics.geq), Inequality(v[2], u, Symbolics.geq), Inequality(v[3], u, Symbolics.geq)]
@test Symbolics.scalarize(v .≳ w .+ 3) == [Inequality(v[1], w[1] + 3, Symbolics.geq), Inequality(v[2], w[2] + 3, Symbolics.geq), Inequality(v[3], w[3] + 3, Symbolics.geq)]

@test Symbolics.canonical_form(a + b *c ≳ x + 2 * x) == (3x - a - b*c ≲ 0)

@test Symbolics.substitute(a ≳ 2, a => 1) == (1 ≳ 2)

"""
    detect_addlog(lhs, var)

Traverses expression arg by arg and if two logs of
degree 1 are found it returns true if both of them
have n_func_occ of 1, so they're solvable after 
getting attracted. Returns true if found, 
false if not.

# Arguments
- lhs: A Num expression.
- var: Num and should satisfy is_singleton

# Examples
```jldoctest
julia> detect_addlogs(log(x+1) + log(x-1), x)
true
```
"""
function detect_addlogs(lhs, var)
    u_lhs = unwrap(lhs)
    args = arguments(u_lhs)
    oper = operation(u_lhs)
    !isequal(oper, (+)) && return false

    found = [false, false]
    c = 1
    for arg in args
        !iscall(arg) && continue
        isequal(n_occurrences(arg, var), 0) && continue

        # arg has target var and iscall
        if arg_contains_log(arg, var) && c < 3
            found[c] = true
            c += 1
        end
    end

    return all(found)
end

"""
    detect_exponential(lhs, var)

Traverses an expression and attempts to match the
expression to ``a*b^f(x) + c*d^g(x)``. Hence why it
expects only 2 arguments in the input expression.
Returns true if found, false if not.

# Arguments
- lhs: A Num expression.
- var: Num and should satisfy is_singleton

# Examples
```jldoctest
julia> detect_exponential(2*3^(x+1) + 5^(x^2 + 3), x)
true
```
"""
function detect_exponential(lhs, var)
    lhs = unwrap(lhs)
    !iscall(lhs) && return false
    args = arguments(lhs)
    oper = operation(lhs)
    !isequal(oper, (+)) && return false
    length(args) != 2 && return false

    found = [false, false]
    c = 1
    for arg in args
        n_occurrences(arg, var) == 0 && continue
        !iscall(arg) && continue

        oper = operation(arg)
        if isequal(oper, ^)
            args_arg = arguments(arg)
            n_occurrences(args_arg[1], var) != 0 && continue
            !check_poly_inunivar(args_arg[2], var) && continue

            found[c] = true
            c += 1

        elseif isequal(oper, *) && find_logandexpon(arg, var, ^, 2)
            found[c] = true
            c += 1
        end
    end

    return all(found)
end

"""
    attract_logs(lhs, var)

Rewrites any 2 logs in lhs where the log contains the
input variable var. so ``log(x) + log(y)`` is not attracted.
When attracted, it returns an slog.

# Arguments
- lhs: A Num expression.
- var: Num and should satisfy is_singleton

# Examples
```jldoctest
julia> RootFinding.attract_logs(log(x+1)+log(x-1), x)
Main.RootFinding.slog(-1 + x^2)
```
"""
function attract_logs(lhs, var)
    contains_var(arg) = n_occurrences(arg, var) > 0

    r_addlogs = Vector{Any}()
    r_conditionx = Vector{Any}()
    r_conditiony = Vector{Any}()
    #! format: off
    push!(r_addlogs, @acrule log(~x::(contains_var)) + log(~y::(contains_var)) => slog(~x * ~y))
    push!(r_addlogs, @acrule ~z*log(~x::(contains_var)) + log(~y::(contains_var)) => slog((~x)^(~z) * ~y))
    push!(r_addlogs, @acrule ~z*log(~x::(contains_var)) + ~h*log(~y::(contains_var)) => slog((~x)^(~z) * (~y)^(~h)))

    push!(r_conditionx, @acrule log(~x::(contains_var)) + log(~y::(contains_var)) => ~x)
    push!(r_conditionx, @acrule ~z*log(~x::(contains_var)) + log(~y::(contains_var)) => ~x)
    push!(r_conditionx, @acrule ~z*log(~x::(contains_var)) + ~h*log(~y::(contains_var)) => ~x)
    push!(r_conditiony, @acrule log(~x::(contains_var)) + log(~y::(contains_var)) => ~y)
    push!(r_conditiony, @acrule ~z*log(~x::(contains_var)) + log(~y::(contains_var)) => ~y)
    push!(r_conditiony, @acrule ~z*log(~x::(contains_var)) + ~h*log(~y::(contains_var)) => ~y)
    #! format: on
    condition_x = expand(simplify(lhs, rewriter = SymbolicUtils.Postwalk(SymbolicUtils.Chain(r_conditionx))))
    condition_y = expand(simplify(lhs, rewriter = SymbolicUtils.Postwalk(SymbolicUtils.Chain(r_conditiony))))
    lhs = expand(simplify(lhs, rewriter = SymbolicUtils.Postwalk(SymbolicUtils.Chain(r_addlogs))))

    return lhs, [(condition_x, >), (condition_y, >)]
end

"""
    attract_exponential(lhs, var)

Rewrites ``a*b^f(x) + c*d^g(x)`` into 
``f(x) * log(b) - g(x) * log(d) + log(-a/c)``
Which is a solvable polynomial, hence reducing the smart
number of occurrences of x in the expression.

# Arguments
- lhs: A Num expression.
- var: Num and should satisfy is_singleton

# Examples
```jldoctest
julia> attract_exponential(2^(x+1) + 5^(x+3), x)
Main.RootFinding.slog(2) + log(complex(-1)) - 3Main.RootFinding.slog(5) + x*Main.RootFinding.slog(2) - x*Main.RootFinding.slog(5)
```
"""
function attract_exponential(lhs, var)
    lhs = unwrap(lhs)
    contains_var(arg) = n_occurrences(arg, var) > 0

    r_addexpon = Vector{Any}()

    #! format: off
    push!(r_addexpon, @acrule (~b)^(~f::(contains_var)) + (~d)^(~g::(contains_var)) => ~f*term(slog, ~b) - ~g*term(slog, ~d) + term(log, term(complex, -1)))
    push!(r_addexpon, @acrule (~a)*(~b)^(~f::(contains_var)) + (~d)^(~g::(contains_var)) => ~f*term(slog, ~b) - ~g*term(slog, ~d) + term(slog, -~a))
    push!(r_addexpon, @acrule (~a)*(~b)^(~f::(contains_var)) + (~c)*(~d)^(~g::(contains_var)) => ~f*term(slog, ~b) - ~g*term(slog, ~d) + term(slog, -(~a)//(~c)))
    #! format: on

    lhs = expand(simplify(
        lhs, rewriter = SymbolicUtils.Postwalk(SymbolicUtils.Chain(r_addexpon))))

    return expand(lhs)
end

"""
    attract_trig(lhs, var)

This function brute forces a bunch of trig identities
on the input lhs as an attempt to reduce the occurrences
of x in the lhs.

# Arguments
- lhs: A Num expression.
- var: Num and should satisfy is_singleton

# Examples
```jldoctest
julia> attract_trig(2sin(x)cos(x), x)
sin(2x)

julia> attract_trig(sin(x)^2 + cos(x)^2, x)
1

julia> RootFinding.attract_trig(cosh(x)^2 + sinh(x)^2, x)
cosh(2x)
"""
function attract_trig(lhs, var)
    lhs = unwrap(lhs)
    contains_var(arg) = n_occurrences(arg, var) > 0

    # r_doubleangle1 = @acrule 2*sin(~x::(contains_var))*cos(~x::(contains_var)) => sin(2*~x)
    r_trig = [@acrule(sin(~x::(contains_var))^2 + cos(~x::(contains_var))^2=>one(~x))
              @acrule(sin(~x::(contains_var))^2 + -1=>-1 * cos(~x)^2)
              @acrule(cos(~x::(contains_var))^2 + -1=>-1 * sin(~x)^2)
              @acrule(cos(~x::(contains_var))^2 + -1 * sin(~x::(contains_var))^2=>cos(2*~x))
              @acrule(sin(~x::(contains_var))^2 + -1 * cos(~x::(contains_var))^2=>-cos(2*~x))
              @acrule(cos(~x::(contains_var)) * sin(~x::(contains_var))=>sin(2 * ~x) / 2)
              @acrule(tan(~x::(contains_var))^2 + -1 * sec(~x::(contains_var))^2=>one(~x))
              @acrule(-1 * tan(~x::(contains_var))^2 + sec(~x::(contains_var))^2=>one(~x))
              @acrule(tan(~x::(contains_var))^2 + 1=>sec(~x)^2)
              @acrule(sec(~x::(contains_var))^2 + -1=>tan(~x)^2)
              @acrule(cot(~x::(contains_var))^2 + -1 * csc(~x)^2=>one(~x))
              @acrule(cot(~x::(contains_var))^2 + 1=>csc(~x)^2)
              @acrule(csc(~x::(contains_var))^2 + -1=>cot(~x)^2)
              @acrule(cosh(~x::(contains_var))^2 + -1 * sinh(~x)^2=>one(~x))
              @acrule(cosh(~x::(contains_var))^2 + -1=>sinh(~x)^2)
              @acrule(sinh(~x::(contains_var))^2 + 1=>cosh(~x)^2)
              @acrule(cosh(~x::(contains_var))^2 + sinh(~x::(contains_var))^2=>cosh(2 * ~x))
              @acrule(cosh(~x::(contains_var)) * sinh(~x::(contains_var))=>sinh(2 * ~x) / 2)]

    lhs = expand(simplify(
        lhs, rewriter = SymbolicUtils.Postwalk(SymbolicUtils.Chain(r_trig))))

    return lhs
end

# `ifelse_eager` and `ifelse_branching` are defined in SymbolicUtils (alongside `ifelse`),
# including their symbolic term construction, type/shape promotion, code generation and
# `simplify` rules. Here we only add the `Num`/`Arr` wrappers, mirroring `ifelse` in `num.jl`
# and `arrays.jl`. Differentiation and linearity/sparsity rules live in `diff.jl`.
for op in (:ifelse_eager, :ifelse_branching)
    @eval begin
        $op(c::Num, x, y) = $op(unwrap(c), unwrap(x), unwrap(y))
        $op(c::Num, x::Num, y) = Num($op(unwrap(c), unwrap(x), unwrap(y)))
        $op(c::Num, x, y::Num) = Num($op(unwrap(c), unwrap(x), unwrap(y)))
        $op(c::Num, x::Num, y::Num) = Num($op(unwrap(c), unwrap(x), unwrap(y)))

        $op(c::Num, x::Arr{T, N}, y) where {T, N} = Arr{T, N}($op(
            unwrap(c), unwrap(x), unwrap(y)))
        $op(c::Num, x, y::Arr{T, N}) where {T, N} = Arr{T, N}($op(
            unwrap(c), unwrap(x), unwrap(y)))
        function $op(c::Num, x::Arr, y::Arr)
            size(x) == size(y) || error("Both branches of `ifelse` must have the same shape.")
            return Arr($op(unwrap(c), unwrap(x), unwrap(y)))
        end
        # Disambiguate mixed scalar/array branches (intersections of the methods above).
        $op(c::Num, x::Num, y::Arr{T, N}) where {T, N} = Arr{T, N}($op(
            unwrap(c), unwrap(x), unwrap(y)))
        $op(c::Num, x::Arr{T, N}, y::Num) where {T, N} = Arr{T, N}($op(
            unwrap(c), unwrap(x), unwrap(y)))
    end
end

module SymbolicsDistributionsExt

using Symbolics
using Distributions
using Symbolics: Num, Arr, VartypeT, unwrap, BasicSymbolic, shape


for f in [pdf, logpdf, cdf, logcdf, quantile]
    @eval function (::$(typeof(f)))(dist::Distributions.Distribution, x::Num)
        $f(dist, unwrap(x))
    end
    @eval function (::$(typeof(f)))(dist::Distributions.Distribution, x::Arr)
        $f(dist, unwrap(x))
    end
    @eval function (::$(typeof(f)))(dist::BasicSymbolic{VartypeT}, x::Num)
        $f(dist, unwrap(x))
    end
    @eval function (::$(typeof(f)))(dist::BasicSymbolic{VartypeT}, x::Arr)
        $f(dist, unwrap(x))
    end
    @eval function (::$(typeof(f)))(dist::BasicSymbolic{VartypeT}, x)
        $f(dist, unwrap(x))
    end
end

for f in [Distributions.Uniform, Distributions.Normal]
    for (T1, T2) in Iterators.product(Iterators.repeated([Real, BasicSymbolic{VartypeT}, Num], 2)...)
        if T1 != Num && T2 != Num
            continue
        end
        @eval function (::Type{$f})(a::$T1, b::$T2)
            $f(unwrap(a), unwrap(b))
        end
    end
end

end

import DomainSets.ClosedInterval

# from https://tutorial.math.lamar.edu/Classes/DE/Laplace_Table.aspx
transform_rules(f, t, F, s) = Symbolics.Chain([
    @rule 1 => 1/s
    @rule exp(t) => 1/(s - 1)
    @rule exp(~a * t) => 1/(-~a + s)
    @rule t => 1/s^2
    @rule t^~n => factorial(~n)/s^(~n + 1)
    @rule sqrt(t) => term(sqrt, pi)/(2 * s^(3/2))
    @rule sin(t) => 1/(1 + s^2)
    @rule sin(~a * t) => ~a/((~a)^2 + s^2)
    @rule cos(t) => s/(1 + s^2)
    @rule cos(~a * t) => s/((~a)^2 + s^2)
    @rule t*sin(t) => 1/(1 + s^2)^2
    @rule t*sin(~a * t) => 2*~a*s / ((~a)^2 + s^2)^2
    @rule t*cos(t) => (s^2 - 1) / (1 + s^2)^2
    @rule t*cos(~a * t) => (-(~a)^2 + s^2) / ((~a)^2 + s^2)^2
    @rule sin(t) - t*cos(t) => 2 / (1 + s^2)^2
    @rule sin(~a*t) - ~a*t*cos(~a*t) => 2*(~a)^3 / ((~a)^2 + s^2)^2
    @rule sin(t) + t*cos(t) => 2s^2 / (1 + s^2)^2
    @rule sin(~a*t) + ~a*t*cos(~a*t) => 2*~a*s^2 / ((~a)^2 + s^2)^2
    @rule cos(~a*t) - ~a*t*sin(~a*t) => s*((~a)^2 + s^2) / ((~a)^2 + s^2)^2
    @rule cos(~a*t) + ~a*t*sin(~a*t) => s*(s^2 + 3*(~a)^2) / ((~a)^2 + s^2)^2
    @rule sin(~b + ~a*t) => (s*sin(~b) + ~a*cos(~b)) / ((~a)^2 + s^2)
    @rule cos(~b + ~a*t) => (s*cos(~b) - ~a*sin(~b)) / ((~a)^2 + s^2)
    @rule sinh(~a * t) => ~a/(-(~a)^2 + s^2)
    @rule cosh(~a * t) => s/(-(~a)^2 + s^2)
    @rule exp(~a*t) * sin(~b * t) => ~b / ((~b)^2 + (-~a+s)^2)
    @rule exp(~a*t) * cos(~b * t) => (-~a+s) / ((~b)^2 + (-~a+s)^2)
    @rule exp(~a*t) * sinh(~b * t) => ~b / (-(~b)^2 + (-~a+s)^2)
    @rule exp(~a*t) * cosh(~b * t) => (-~a+s) / (-(~b)^2 + (-~a+s)^2)
    @rule t^~n * exp(~a * t) => factorial(~n) / (-~a + s)^(~n + 1)
    @rule t*exp(~a * t) => 1 / (-~a + s)^(2)
    @rule t^~n * exp(t) => factorial(~n) / (s)^(~n + 1)
    @rule t*exp(t) => 1 / (s)^(2)
    @rule exp(~c*t) * ~g => laplace(~g, f, t, F, s - ~c) # s-shift rule
    @rule f(t)*t => -Differential(s)(F(s)) # s-derivative rule
    @rule f(t)*t^(~n) => (-1)^(~n) * (Differential(s)^~n)(F(s)) # s-derivative rule
    @rule f(~a + t) => exp(~a*s)*F(s) # t-shift rule
    @rule f(t) => F(s)
])

"""
    laplace(expr, f, t, F, s)

Performs the Laplace transform of `expr` with respect to the variable `t`, where `f(t)` is a function in `expr` being transformed, and `F(s)` is the Laplace transform of `f(t)`. Returns the transformed expression in terms of `s`.

Note that `f(t)` and `F(s)` should be defined using `@syms`

Currently relies mostly on linearity and a rules table. When the rules table does not apply, it falls back to the integral definition of the Laplace transform.

# Examples

```jldoctest
julia> using Symbolics

julia> @variables t, s
2-element Vector{Num}:
 t
 s

julia> @syms f(t)::Real F(s)::Real
(f, F)

julia> laplace(exp(4t) + 5, f, t, F, s)
1 / (-4 + s) + 5 / s

julia> laplace(10 + 4t - t^2, f, t, F, s)
10 / s + 4 / (s^2) + -2 / (s^3)

julia> laplace(exp(-2t)*cos(3t) + 5exp(-2t)*sin(3t), f, t, F, s)
(2 + s) / (9 + (2 + s)^2) + 15 / (9 + (2 + s)^2)

julia> laplace(t^2 * f(t), f, t, F, s) # s-derivative rule
Differential(s, 2)(F(s))

julia> laplace(5f(t-4), f, t, F, s) # t-shift rule
5F(s)*exp(-4s)

julia> laplace(log(t), f, t, F, s) # fallback to definition
Integral(t, 0.0 .. Inf)(exp(-s*t)*log(t))
```
"""
function laplace(expr, f, t, F, s; rules=nothing)
    expr = expand(expr)

    if isequal(expr, 0)
        return 0
    end

    Dt = Differential(t)

    if rules === nothing
        rules = transform_rules(f, t, F, s)
    end

    transformed = rules(expr)

    # Check if transformation was successful
    if !isequal(transformed, expr)
        return transformed
    end

    # t-derivative rule ((Dt^n)(f(t)) -> s^n*F(s) - s^(n-1)*f(0) - s^(n-2)*f'(0) - ... - f^(n-1)(0))
    n, expr = unwrap_der(expr, Dt)
    if n != 0 && isequal(expr, f(t))
        f0 = Symbolics.variables(:𝒻0, 0:(n-1))
        transformed = s^n*F(s)
        for i = 1:n
            transformed -= s^(n-i)*f0[i]
        end

        return transformed
    end

    terms = Symbolics.terms(expr)
    result = 0

    # unable to apply linearity, so return based on definition
    if length(terms) == 1 && length(filter(x->isempty(Symbolics.get_variables(x)), _true_factors(terms[1]))) == 0
        return Integral(t in ClosedInterval(0, Inf))(expr*exp(-s*t))
    end

    # apply linearity by splitting into terms and factoring out constants
    for term in terms
        factors = _true_factors(term)
        constant = filter(x -> isempty(Symbolics.get_variables(x)), factors)
        if !isempty(constant)
            result += laplace(term / constant[1], f, t, F, s, rules=rules) * constant[1]
        else 
            result += laplace(term, f, t, F, s, rules=rules)
        end
    end

    return result
end

function laplace(expr::Equation, f, t, F, s)
    return laplace(expr.lhs, f, t, F, s) ~ laplace(expr.rhs, f, t, F, s)
end

# postprocess_root prevents automatic evaluation of sqrt to its floating point value
function processed_sqrt(x)
    return postprocess_root(term(sqrt, x))
end

# F and f aren't used here, but are here for future-proofing
inverse_transform_rules(F, s, f, t) = Symbolics.Chain([
    @rule 1/s => 1
    @rule 1/(~a + s) => exp(-~a * t)
    @rule 1/s^(~n) => t^(~n-1) / factorial(~n-1)
    @rule 1/(2 * s^(3/2)) => sqrt(t)/term(term(sqrt, pi))
    @rule 1/(~a + s^2) => sin(processed_sqrt(~a) * t)/processed_sqrt(~a)
    @rule s/(~a + s^2) => cos(processed_sqrt(~a) * t)
    @rule s / (~a + s^2)^2 => t*sin(processed_sqrt(~a) * t)/(2*processed_sqrt(~a))
    @rule (-~a + s^2) / (~a + s^2)^2 => t*cos(processed_sqrt(~a) * t)
    @rule 1 / (~a + s^2)^2 => (sin(processed_sqrt(~a)*t) - processed_sqrt(~a)*t*cos(processed_sqrt(~a)*t))/ (2*processed_sqrt(~a)^3)
    @rule s^2 / (~a + s^2)^2 => (sin(processed_sqrt(~a)*t) + processed_sqrt(~a)*t*cos(processed_sqrt(~a)*t)) / (2*processed_sqrt(~a))
    @rule s*(~a + s^2) / (~a + s^2)^2 => cos(processed_sqrt(~a)*t) - processed_sqrt(~a)*t*sin(processed_sqrt(~a)*t)
    @rule s*(3*~a + s^2) / (~a + s^2)^2 => cos(processed_sqrt(~a)*t) + processed_sqrt(~a)*t*sin(processed_sqrt(~a)*t)
    @rule (s*sin(~b) + ~a*cos(~b)) / (~a + s^2) => sin(~b + processed_sqrt(~a)*t)
    @rule (s*cos(~b) - ~a*sin(~b)) / ((~a)^2 + s^2) => cos(~b + ~a*t)
    @rule 1/(s^2 - (~b)^2) => sinh(~b * t)/~b
    @rule s/(s^2 - (~b)^2) => cosh(~b * t)
    @rule 1 / ((~c+s)^2 + (~b)^2) => exp(-~c*t) * sin(~b * t) / ~b
    @rule (~c+s) / ((~c+s)^2 + (~b)^2) => exp(-~c*t) * cos(~b * t)
    @rule 1 / ((~c+s)^2 - (~b)^2) => exp(-~c*t) * sinh(~b * t) / ~b
    @rule (~c+s) / ((~c+s)^2 - (~b)^2) => exp(-~c*t) * cosh(~b * t)
    @rule 1 / (~a + s)^(~n) => t^(~n-1) * exp(-~a * t) / factorial(~n-1)
])

"""
    inverse_laplace(expr, F, s, f, t)

Performs the inverse Laplace transform of `expr` with respect to the variable `s`, where `F(s)` is the Laplace transform of `f(t)`. Returns the transformed expression in terms of `t`.

Note that `f(t)` and `F(s)` should be defined using `@syms`.

Will perform partial fraction decomposition and linearity before applying the inverse Laplace transform rules. When unable to find a result, returns `nothing`.

# Examples

```jldoctest
julia> using Symbolics

julia> import Nemo, Groebner

julia> @variables t, s
2-element Vector{Num}:
 t
 s

julia> @syms f(t)::Real F(s)::Real
(f, F)

julia> inverse_laplace(7/(s+3)^3, F, s, f, t)
(7//2)*exp(-3t)*(t^2)

julia> inverse_laplace((s+2)/(s^2 - 3s - 4), F, s, f, t)
-(1//5)*exp(-t) + (6//5)*exp((4//1)*t)

julia> inverse_laplace(1/s^4, F, s, f, t)
(t^3) / 6
```
"""
function inverse_laplace(expr, F, s, f, t; rules=nothing, warns=true)
    if isequal(expr, 0)
        return 0
    end
    
    # check for partial fractions
    partial_fractions = partial_frac_decomposition(expr, s, warns=warns)
    if partial_fractions !== nothing && !isequal(partial_fractions, expr)
        return inverse_laplace(partial_fractions, F, s, f, t, warns=warns)
    end

    if rules === nothing
        rules = inverse_transform_rules(F, s, f, t)
    end

    transformed = rules(expr)

    # Check if transformation was successful
    if !isequal(transformed, expr)
        return transformed
    end

    _terms = terms(numerator(expr)) ./ denominator(expr)
    
    result = 0
    if length(_terms) == 1 && length(filter(x -> isempty(get_variables(x)), _true_factors(_terms[1]))) == 0
        warns && @warn "Inverse laplace failed: $expr"
        return nothing # no result
    end

    # apply linearity by splitting into terms and factoring out constants
    for term in _terms
        factors = _true_factors(term)
        constant = filter(x -> isempty(get_variables(x)), factors)
        non_constant = filter(x -> !isempty(get_variables(x)), factors)
        if !isempty(constant)
            transformed_term = inverse_laplace(prod(non_constant), F, s, f, t, rules=rules, warns=warns)
            isnothing(transformed_term) && return nothing
            result += transformed_term * constant[1]
        else
            transformed_term = inverse_laplace(term, F, s, f, t, rules=rules, warns=warns)
            isnothing(transformed_term) && return nothing
            result += transformed_term
        end
    end

    return result
end

function inverse_laplace(expr::Equation, F, s, f, t; warns=true)
    return inverse_laplace(expr.lhs, F, s, f, t, warns=warns) ~ inverse_laplace(expr.rhs, F, s, f, t, warns=warns)
end

"""
    laplace_solve_ode(eq, f, t, f0)
    
Solves the ordinary differential equation `eq` for the function `f(t)` using the Laplace transform method.
    
    `f0` is a vector of initial conditions evaluated at `t=0` (`[f(0), f'(0), f''(0), ...]`, must be same length as order of `eq`).

# Examples

```jldoctest
julia> using Symbolics

julia> @variables t, s
2-element Vector{Num}:
 t
 s

julia> @syms f(t)::Real F(s)::Real
(f, F)

julia> Dt = Differential(t)
Differential(t, 1)

julia> laplace_solve_ode(Dt(f(t)) + 3f(t) ~ t^2*exp(-3t) + t*exp(-2t) + t, f, t, [1])
-(1//9) - exp((-2//1)*t) + (19//9)*exp((-3//1)*t) + (1//3)*t + exp((-2//1)*t)*t + (1//3)*exp((-3//1)*t)*(t^3)

julia> laplace_solve_ode((Dt^2)(f(t)) + f(t) ~ 2 + 2cos(t), f, t, [0, 0])
(2//1) - (2//1)*cos(t) + sin(t)*t

julia> laplace_solve_ode((Dt^3)(f(t)) - Dt(f(t)) ~ 6 - 3t^2, f, t, [1, 1, 1])
exp(t) + t^3
```
"""
function laplace_solve_ode(eq, f, t, f0; warns=true)
    s = variable(:𝓈)
    @syms 𝓕(s)

    # transform equation
    transformed_eq = laplace(eq, f, t, 𝓕, s)
    # substitute in initial conditions
    transformed_eq = substitute(transformed_eq, Dict(𝓕(s) => variable(:𝓕), [variable(:𝒻0, i-1) => f0[i] for i=1:length(f0)]...))
    transformed_eq = expand(transformed_eq.lhs - transformed_eq.rhs)

    # solve for/isolate F(s)
    F_terms = 0
    other_terms = []
    for term in terms(transformed_eq)
        if isempty(get_variables(term, [variable(:𝓕)]))
            push!(other_terms, -1*term)
        else
            F_terms += term/variable(:𝓕) # assumes term is something times F
        end
    end

    if isempty(other_terms)
        other_terms = 0
    end

    # (a + b + ...)*F(s) = (c + d + ...)  ->  F(s) = (c + d + ...) / (a + b + ...)
    transformed_soln = simplify(sum(other_terms ./ F_terms))

    # perform inverse laplace transform to get f(t)
    return expand(inverse_laplace(transformed_soln, 𝓕, s, f, t, warns=warns))
end

import SparseArrays
import StaticArraysCore

# StaticArrays dispatches on this non-public abstract storage type, so exact
# intersections with its scalar arithmetic cannot use the public concrete aliases.
const _StaticArray = StaticArraysCore.StaticArray

@symbolic_wrap struct Num <: Real
    val::BasicSymbolic{VartypeT}

    function Num(ex::BasicSymbolic{VartypeT})
        # need `<: Number` instead of `<: Real` to allow the primitive `@number_methods`
        # methods below to infer. They could be made to infer `Union{Complex{Num}, Num}`
        # by manually checking the `symtype` of the result and branching instead of using
        # `wrap`. However, this causes issues with LinearAlgebra methods because it
        # preallocates a buffer using the inferred result type, and then tries to
        # e.g. set an integer into it, which fails because `convert(::Type{Union{..}}, ::T)`
        # doesn't work.
        @assert symtype(ex) <: Number
        return new(Const{VartypeT}(ex))
    end
    function Num(ex::Number)
        return new(Const{VartypeT}(unwrap(ex)))
    end
end

const RCNum = Union{Num, Complex{Num}}

SymbolicUtils.unwrap(x::Num) = x.val
SU.infer_vartype(::Type{Num}) = VartypeT

"""
    Num(val)

Wrap anything in a type that is a subtype of Real
"""
Num

const show_numwrap = Ref(false)

Num(x::Num) = x # ideally this should never be called
function Num(x::Complex)
    iszero(imag(x)) || throw(InexactError(:Num, Num, x))
    return Num(real(x))
end
(n::Num)(args...) = Num(value(n)(map(value, args)...))
# Fixes an inference issue with https://github.com/JuliaApproximation/DomainSets.jl/blob/b68ee034ebcd2e3fc10dd334792cee17a8d5c633/src/domains/point.jl#L13
# causing `Num(::Any)` to infer as `::Any`
Num(x::DomainSets.Point{<:Number}) = Num(x.x)::Num

SymbolicUtils.@number_methods(Num,
    Num(f(unwrap(a))),
    Num(f(unwrap(a), unwrap(b))),
    [conj, real, transpose, +, -, *, ^, //, /, \])

Base.:+(x::Num) = x
function Base.:+(x1::Num, xs::Real...)
    Num(+(unwrap(x1), unwrap.(xs)...))
end
function Base.:*(x1::Num, xs::Real...)
    Num(*(unwrap(x1), unwrap.(xs)...))
end

Base.:-(x::Num) = Num(-(unwrap(x)))
for f in [-, ^, /, \]
    for (T1, T2) in Iterators.product([Num, Real], [Num, Real])
        T1 === Num || T2 === Num || continue
        @eval function (::$(typeof(f)))(x1::$T1, x2::$T2)
            Num($f(unwrap(x1), unwrap(x2)))
        end
    end
end
for (T1, T2) in Iterators.product([Num, Integer], [Num, Integer])
    T1 === Num || T2 === Num || continue
    @eval function Base.://(x1::$T1, x2::$T2)
        Num(//(unwrap(x1), unwrap(x2)))
    end
end

for f in [^]
    @eval function (::$(typeof(f)))(x1::AbstractArray{<:Real}, x2::Num)
        $f(x1, unwrap(x2))
    end

    @eval function (::$(typeof(f)))(x1::Num, x2::AbstractArray{<:Real})
        $f(unwrap(x1), x2)
    end
end

function Base.:(\)(x1::AbstractArray{<:Real}, x2::Num)
    return \(x1, unwrap(x2))
end
function Base.:(\)(x1::Num, x2::AbstractArray{<:Real})
    return \(unwrap(x1), x2)
end

function Base.:(/)(x1::AbstractArray{<:Real}, x2::Num)
    return /(unwrap(x1), unwrap(x2))
end

function Base.:(/)(x1::Num, x2::AbstractVector{<:Real})
    return /(unwrap(x1), unwrap(x2))
end
function Base.:(/)(x1::BitArray, x2::Num)
    return SymbolicUtils.term(/, x1, unwrap(x2))
end
function Base.:(/)(x1::Num, x2::BitArray)
    return SymbolicUtils.term(/, unwrap(x1), x2)
end
function Base.:(/)(x1::SparseArrays.SparseVector{<:Real}, x2::Num)
    return SymbolicUtils.term(/, x1, unwrap(x2))
end
function Base.:(/)(
        x1::SparseArrays.AbstractCompressedVector{<:Real}, x2::Num
    )
    return SymbolicUtils.term(/, x1, unwrap(x2))
end
function Base.:(/)(
        x1::SubArray{
            T, 1, <:SparseArrays.AbstractSparseMatrixCSC{T, Ti},
            Tuple{Base.Slice{Base.OneTo{Int}}, Int}, false,
        }, x2::Num
    ) where {T <: Real, Ti}
    return SymbolicUtils.term(/, x1, unwrap(x2))
end
function Base.:(/)(
        x1::Union{
            SparseArrays.AbstractCompressedVector{T, Ti},
            SubArray{
                T, 1, <:SparseArrays.AbstractSparseMatrixCSC{T, Ti},
                Tuple{Base.Slice{Base.OneTo{Int}}, Int}, false,
            },
            SubArray{
                T, 1, <:SparseArrays.AbstractSparseVector{T, Ti},
                Tuple{Base.Slice{Base.OneTo{Int}}}, false,
            },
        }, x2::Num
    ) where {T <: Real, Ti}
    return SymbolicUtils.term(/, x1, unwrap(x2))
end
function Base.:(/)(
        x1::SubArray{
            T, 1, <:SparseArrays.AbstractSparseVector{T, Ti},
            Tuple{Base.Slice{Base.OneTo{Int}}}, false,
        }, x2::Num
    ) where {T <: Real, Ti}
    return SymbolicUtils.term(/, x1, unwrap(x2))
end
function Base.:(/)(
        x1::StepRangeLen{<:Real, <:Base.TwicePrecision}, x2::Num
    )
    return SymbolicUtils.term(/, x1, unwrap(x2))
end
function Base.:(/)(x1::_StaticArray{S, T, N}, x2::Num) where {S <: Tuple, T <: Real, N}
    return SymbolicUtils.term(/, x1, unwrap(x2))
end
function Base.:(\)(x1::Num, x2::_StaticArray{S, T, N}) where {S <: Tuple, T <: Real, N}
    return SymbolicUtils.term(\, unwrap(x1), x2)
end

for T in (
        LinearAlgebra.Bidiagonal,
        LinearAlgebra.Diagonal,
        LinearAlgebra.Hermitian,
        LinearAlgebra.LowerTriangular,
        LinearAlgebra.Symmetric,
        LinearAlgebra.SymTridiagonal,
        LinearAlgebra.Tridiagonal,
        LinearAlgebra.UnitLowerTriangular,
        LinearAlgebra.UnitUpperTriangular,
        LinearAlgebra.UpperHessenberg,
        LinearAlgebra.UpperTriangular,
    )
    @eval begin
        function Base.:(/)(x1::$T{S}, x2::Num) where {S <: Real}
            return SymbolicUtils.term(/, x1, unwrap(x2))
        end
        function Base.:(\)(x1::Num, x2::$T{S}) where {S <: Real}
            return SymbolicUtils.term(\, unwrap(x1), x2)
        end
    end
end

const _StridedMatrixStorage = Union{
    Base.StridedMatrix,
    LinearAlgebra.Adjoint{<:Any, <:Base.StridedMatrix},
    LinearAlgebra.Transpose{<:Any, <:Base.StridedMatrix},
}
for T in (LinearAlgebra.LowerTriangular, LinearAlgebra.UpperTriangular)
    @eval begin
        function Base.:(/)(
                x1::$T{S, A}, x2::Num
            ) where {S <: Real, A <: _StridedMatrixStorage}
            return SymbolicUtils.term(/, x1, unwrap(x2))
        end
        function Base.:(\)(
                x1::Num, x2::$T{S, A}
            ) where {S <: Real, A <: _StridedMatrixStorage}
            return SymbolicUtils.term(\, unwrap(x1), x2)
        end
    end
end

function Base.:(^)(x1::AbstractMatrix{T}, x2::Num) where {T <: Real}
    return invoke(^, Tuple{AbstractArray{<:Real}, Num}, x1, x2)
end
function Base.:(^)(x1::Num, x2::AbstractMatrix{<:Real})
    return invoke(^, Tuple{Num, AbstractArray{<:Real}}, x1, x2)
end
for T in (
        LinearAlgebra.Diagonal,
        LinearAlgebra.Hermitian,
        LinearAlgebra.Symmetric,
        LinearAlgebra.SymTridiagonal,
    )
    @eval function Base.:(^)(x1::$T{S}, x2::Num) where {S <: Real}
        return SymbolicUtils.term(^, x1, unwrap(x2))
    end
end

Base.conj(x::Num) = x
Base.transpose(x::Num) = x

Base.eps(::Type{Num}) = Num(0)
Base.typemin(::Type{Num}) = Num(-Inf)
Base.typemax(::Type{Num}) = Num(Inf)
Base.float(x::Num) = x
function Base.isapprox(a::Num, b::Num; kw...)
    err = value(a - b)
    err isa BasicSymbolic{VartypeT} && return false
    isapprox(err, 0.0; kw...)
end

function SymbolicUtils.search_variables!(buffer, expr::Num; kw...)
    SymbolicUtils.search_variables!(buffer, unwrap(expr); kw...)
end

"""
    ifelse(cond::Num, x, y)

Symbolic conditional expression. Returns `x` if `cond` evaluates to true, and `y` if `cond`
evaluates to false. This allows encoding conditional logic in symbolic expressions.

# Examples
```julia
@variables a b c
ifelse(a > b, c, 0)  # Returns c if a > b, otherwise 0
```
"""
Base.ifelse(x::Num, y, z) = ifelse(unwrap(x), unwrap(y), unwrap(z))
Base.ifelse(x::Num, y::Num, z) = Num(ifelse(unwrap(x), unwrap(y), unwrap(z)))
Base.ifelse(x::Num, y, z::Num) = Num(ifelse(unwrap(x), unwrap(y), unwrap(z)))
Base.ifelse(x::Num, y::Num, z::Num) = Num(ifelse(unwrap(x), unwrap(y), unwrap(z)))

Base.promote_rule(::Type{Bool}, ::Type{Num}) = Num
Base.promote_rule(::Type{T}, ::Type{Num}) where {T <: AbstractIrrational} = Num
Base.promote_rule(::Type{Complex{Num}}, ::Type{Num}) = Complex{Num}
for C in [Complex, Complex{Bool}]
    @eval begin
        function Base.:*(x::Num, z::$C)
            x = unwrap(x)
            rx = real(x)
            ix = imag(x)
            rz = real(z)
            iz = imag(z)
            Complex(Num(rx * rz - ix * iz), Num(rx * iz + ix * rz))
        end
        function Base.:*(z::$C, x::Num)
            x = unwrap(x)
            rx = real(x)
            ix = imag(x)
            rz = real(z)
            iz = imag(z)
            Complex(Num(rx * rz - ix * iz), Num(rx * iz + ix * rz))
        end
        function Base.:/(x::Num, z::$C)
            x = unwrap(x)
            rz, iz = reim(z)
            den = rz^2 + iz^2
            rx = real(x)
            ix = imag(x)
            return Complex(Num((rx * rz + ix * iz) / den), Num((ix * rz - rx * iz) / den))
        end
        function Base.:/(z::$C, x::Num)
            x = unwrap(x)
            rz, iz = reim(z)
            rx = real(x)
            ix = imag(x)
            den = rx^2 + ix^2
            return Complex(Num((rx * rz + ix * iz) / den), Num((rx * iz - ix * rz) / den))
        end
        function Base.:+(x::Num, z::$C)
            x = unwrap(x)
            rx = real(x)
            ix = imag(x)
            rz, iz = reim(z)
            return Complex(Num(rx + rz), Num(ix + iz))
        end
        function Base.:+(z::$C, x::Num)
            x = unwrap(x)
            rx = real(x)
            ix = imag(x)
            rz, iz = reim(z)
            return Complex(Num(rx + rz), Num(ix + iz))
        end
        function Base.:-(x::Num, z::$C)
            x = unwrap(x)
            rx = real(x)
            ix = imag(x)
            rz, iz = reim(z)
            return Complex(Num(rx - rz), Num(ix - iz))
        end
        function Base.:-(z::$C, x::Num)
            x = unwrap(x)
            rx = real(x)
            ix = imag(x)
            rz, iz = reim(z)
            return Complex(Num(rz - rx), Num(iz - ix))
        end
    end
end

function Base.inv(z::Complex{Num})
    a, b = reim(z)
    den = a^2 + b^2
    Complex(a/den, -b/den)
end
function Base.:/(x::Complex{Num}, y::Complex{Num})
    a, b = reim(x)
    c, d = reim(y)
    den = c^2 + d^2
    Complex((a*c + b*d)/den, (b*c - a*d)/den)
end
Base.:^(z::Complex{Num}, n::Integer) = Base.power_by_squaring(z, n)
Base.:^(z::Complex{Num}, n::Bool) = invoke(^, Tuple{Complex{Num}, Integer}, z, n)
Base.:^(::Irrational{:ℯ}, x::Num) = exp(x)

function Base.show(io::IO, z::Complex{<:Num})
    warn_load_latexify()
    r, i = reim(z)
    compact = get(io, :compact, false)
    show(io, r)
    print(io, (compact ? "+" : " + ") * "(")
    show(io, i)
    print(io, ")*im")
end

SymbolicUtils.symtype(n::Num) = symtype(value(n))
Base.nameof(n::Num) = nameof(value(n))

Base.iszero(x::Num) = SymbolicUtils._iszero(unwrap(x))
Base.isone(x::Num) = SymbolicUtils._isone(unwrap(x))

const COMMON_ZERO_NUM = Num(COMMON_ZERO)
const COMMON_ONE_NUM = Num(COMMON_ONE)
Base.zero(::Num) = COMMON_ZERO_NUM
Base.zero(::Type{Num}) = COMMON_ZERO_NUM
Base.one(::Num) = COMMON_ONE_NUM
Base.one(::Type{Num}) = COMMON_ONE_NUM

import SymbolicUtils: <ₑ, Term, operation, arguments

function Base.show(io::IO, n::Num)
    warn_load_latexify()
    show_numwrap[] ? print(io, :(Num($(value(n))))) : Base.show(io, value(n))
end

Base.promote_rule(::Type{T}, ::Type{Num}) where {T <: Number} = Num
Base.promote_rule(::Type{BigFloat}, ::Type{Num}) = Num
<ₑ(s::Num, x) = value(s) <ₑ value(x)
<ₑ(s, x::Num) = value(s) <ₑ value(x)
<ₑ(s::Num, x::Num) = value(s) <ₑ value(x)
for T in (Real, Complex, BasicSymbolic)
    @eval begin
        <ₑ(s::Num, x::$T) = value(s) <ₑ value(x)
        <ₑ(s::$T, x::Num) = value(s) <ₑ value(x)
    end
end

function Num(q::AbstractIrrational)
    args = SymbolicUtils.ArgsT{VartypeT}((q,))
    Num(Term{VartypeT}(identity, args; type = Real, shape = SymbolicUtils.ShapeVecT()))
end

for T in (Integer, Rational)
    @eval Base.:(^)(n::Num, i::$T) = Num(value(n)^i)
end

macro num_method(f, expr, Ts = nothing)
    if Ts === nothing
        Ts = [Any]
    else
        @assert Ts.head == :tuple
        # e.g. a tuple or vector
        Ts = Ts.args
    end

    ms = [quote
              $f(a::$T, b::$Num) = $expr
              $f(a::$Num, b::$T) = $expr
          end
          for T in Ts]
    quote
        $f(a::$Num, b::$Num) = $expr
        $(ms...)
    end |> esc
end

# Boolean operations
for (f, Domain) in
    [:(==) => :((AbstractFloat, Number)), :(!=) => :((AbstractFloat, Number)),
    :(<=) => :((Real,)), :(>=) => :((Real,)),
    :(isless) => :((Real, AbstractFloat)),
    :(<) => :((Real,)), :(>) => :((Real,)),
    :(&) => :((Bool,)), :(|) => :((Bool,)),
    :xor => :((Bool,))]
    @eval @num_method Base.$f (val = $f(value(a), value(b)); val isa Bool ? val : Num(val)) $Domain
end

for f in [:!, :~]
    @eval Base.$f(x::Num) = (val = $f(value(x)); val isa Bool ? val : Num(val))
end
@num_method Base.isequal begin
    va = value(a)
    vb = value(b)
    isequal(va, vb)::Bool
end (AbstractFloat, Number, BasicSymbolic)

for f in (:(==), :isequal)
    @eval begin
        Base.$f(a::Complex, b::Num) = invoke(Base.$f, Tuple{Number, Num}, a, b)
        Base.$f(a::Num, b::Complex) = invoke(Base.$f, Tuple{Num, Number}, a, b)
    end
end
Base.:(==)(a::AbstractIrrational, b::Num) = invoke(==, Tuple{Number, Num}, a, b)
Base.:(==)(a::Num, b::AbstractIrrational) = invoke(==, Tuple{Num, Number}, a, b)

Base.to_index(x::Num) = Base.to_index(value(x))

Base.hash(x::Num, h::UInt) = hash(unwrap(x), h)::UInt

function Base.convert(::Type{Num}, x::BasicSymbolic{VartypeT})
    symtype(x) <: Real || error("`symtype` must be `<:Real`")
    Num(x)
end

function LinearAlgebra.lu(
        x::Union{Adjoint{<:RCNum}, Transpose{<:RCNum}, Array{<:RCNum}}; check = true, kw...)
    sym_lu(x; check = check)
end

Code.cse(x::Num) = Code.cse(unwrap(x))

## Documentation
# This method makes the docstring show all entries in the metadata dict associated with an instance of Num
function Base.Docs.getdoc(x::Num)
    x = unwrap(x)
    strings = ["A variable of type Symbolics.Num (Num wraps anything in a type that is a subtype of Real)";
               "# Metadata"]
    for (key, val) in collect(pairs(x.metadata))
        push!(strings, string(string(key), ": ", string(val)))
    end
    Markdown.parse(join(strings, "\n\n  "))
end

# https://github.com/JuliaSymbolics/Symbolics.jl/issues/1206#issuecomment-2271847091
"""
$(TYPEDSIGNATURES)

Return the alignment of printing `x` of type `Num`.

The alignment is a tuple `(left, right)` showing how many characters are needed
on either side of an alignment feature. This function returns the text width
of `x` and `0` to avoid matching special characters, such as `e`and `f`, with
the alignment algorithm in Julia Base, which leads to extra white spaces on the
left of the characters when displaying array of symbolic variables.
"""
function Base.alignment(io::IO, x::Num)
    s = sprint(show, x, context = Base.nocolor(io), sizehint = 0)
    textwidth(s), 0
end

Base.:^(a::Complex{<:Real}, b::Num) = Symbolics.Pow(a, b)
"""
    symbolic_solve(expr, x; dropmultiplicity=true, warns=true)

`symbolic_solve` is a function which attempts to solve input equations/expressions symbolically using various methods.

## Arguments
- expr: Could be a single univar expression in the form of a poly or multiple univar expressions or multiple multivar polys or a transcendental nonlinear function.

- x: Could be a single variable or an array of variables which should be solved

- dropmultiplicity (optional): Should the output be printed `n` times where `n` is the number of occurrence of the root? Say we have `(x+1)^2`, we then have 2 roots `x = -1`, by default the output is `[-1]`, If dropmultiplicity is inputted as false, then the output is `[-1, -1]`.

- warns (optional): When invalid expressions or cases are inputted, should the solver warn you of such cases before returning nothing? if this is set to false, the solver returns nothing. By default, warns are set to true.

## Supported input
The base solver (`symbolic_solve`) has multiple solvers which chooses from depending on the the type of input
(multiple/uni var and multiple/single expression) only after ensuring that the input is valid.

The expressions inputted can contain parameters, which are assumed to be transcendental.
A parameter "a" is transcendental if there exists no polynomial P with
rational coefficients such that P(a) = 0. Check the examples section.

Currently, `symbolic_solve` supports
- Linear and polynomial equations (with parameters)
- Systems of linear and polynomials equations (without extra parameters, for now)
- Equations with transcendental functions (with parameters)

## Examples

### `solve_univar` (uses factoring and analytic solutions up to degree 4)
!!! note
    The package `Nemo` is needed in order to use `solve_univar` as well as `solve_multipoly`,
    so executing `using Nemo` as you will see in the following examples is necessary; otherwise,
    the function will throw an error.
```jldoctest
julia> using Symbolics, Nemo;

julia> @variables x a b;

julia> expr = expand((x + b)*(x^2 + 2x + 1)*(x^2 - a))
-a*b - a*x - 2a*b*x - 2a*(x^2) + b*(x^2) + x^3 - a*b*(x^2) - a*(x^3) + 2b*(x^3) + 2(x^4) + b*(x^4) + x^5

julia> roots = symbolic_solve(expr, x);

julia> length(roots)
4

julia> length(unique(roots))
4

julia> roots_with_multiplicity = symbolic_solve(expr, x, dropmultiplicity=false);

julia> length(roots_with_multiplicity)
5

julia> length(unique(roots_with_multiplicity))
4
```
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> a = only(@variables a)
a

julia> Symbolics.symbolic_solve(x^2 + a*x + 6, x)
2-element Vector{SymbolicUtils.BasicSymbolicImpl.var"typeof(BasicSymbolicImpl)"{SymReal}}:
 -(1//2)*a + (1//2)*√(-24 + a^2)
 -(1//2)*a - (1//2)*√(-24 + a^2)
```
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> Symbolics.symbolic_solve(x^7 - 1, x)
2-element Vector{SymbolicUtils.BasicSymbolicImpl.var"typeof(BasicSymbolicImpl)"{SymReal}}:
 roots_of((1//1) + x + x^2 + x^3 + x^4 + x^5 + x^6, x)
 1
```
### `solve_multivar` (uses Groebner basis and `solve_univar` to find roots)
!!! note
    Similar to `solve_univar`, `Groebner` is needed for `solve_multivar` or to be fully functional.
```jldoctest
julia> using Symbolics, Groebner

julia> @variables x y z
3-element Vector{Num}:
 x
 y
 z

julia> eqs = [x+y^2+z, z*x*y, z+3x+y]
3-element Vector{Num}:
 x + z + y^2
       x*y*z
  3x + y + z

julia> length(Symbolics.symbolic_solve(eqs, [x,y,z]))
3
```

!!! note
    If `Nemo` or `Groebner` are not imported when needed, the solver throws an error.
```julia
julia> using Symbolics

julia> @variables x y z;

julia> symbolic_solve(x+1, x)
ERROR: "Nemo is required. Execute `using Nemo` to enable this functionality."

julia> symbolic_solve([x+1, y], [x, y])
ERROR: "Groebner bases engine is required. Execute `using Groebner` to enable this functionality."
```
### `solve_multipoly` (uses GCD between the input polys)
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> Symbolics.symbolic_solve([x-1, x^3 - 1, x^2 - 1, (x-1)^20], x)
1-element Vector{Any}:
 1
```

### `ia_solve` (solving by isolation and attraction)
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> length(Symbolics.symbolic_solve(2^(x+1) + 5^(x+3), x))
1
```
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> Symbolics.symbolic_solve(log(x+1)+log(x-1), x)
1-element Vector{SymbolicUtils.BasicSymbolicImpl.var"typeof(BasicSymbolicImpl)"{SymReal}}:
 (1//2)*√(8.0)
```
```jldoctest
julia> using Symbolics

julia> a = only(@variables a)
a

julia> b = only(@variables b)
b

julia> c = only(@variables c)
c

julia> x = only(@variables x)
x

julia> typeof(Symbolics.symbolic_solve(a*x^b + c, x)) <: AbstractVector
true
```

### Evaluating output (converting to floats)
If you want to evaluate the exact expressions found by `symbolic_solve`, you can do the following:
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> roots = Symbolics.symbolic_solve(2^(x+1) + 5^(x+3), x); length(roots)
1

julia> length(Symbolics.symbolic_to_float.(roots))
1
```
"""
function symbolic_solve(expr, x::T; dropmultiplicity = true, warns = true) where {T}
    expr_univar = false
    x_univar = false

    if (T === Num || T === BasicSymbolic{VartypeT} && symtype(x) <: Real)
        x_univar = true
        check_x(x)
    else
        for var in x
            check_x(var)
        end
    end
    if !(expr isa Vector)
        expr_univar = true
        expr = expr isa Equation ? expr.lhs - expr.rhs : expr
        check_expr_validity(expr)
        isequal(expr, 0) && return []
    else
        expr = Vector{Any}(expr)
        for i in eachindex(expr)
            expr[i] = expr[i] isa Equation ? expr[i].lhs - expr[i].rhs : expr[i]
            check_expr_validity(expr[i])
            if !check_poly_inunivar(expr[i], x)
                warns && @warn("Solve can not solve this input currently")
                return nothing
            end
        end
        expr = Vector{Num}(expr)
    end

    if !expr_univar && x_univar
        x = [x]
        x_univar = false
    end

    if x_univar
        sols = check_poly_inunivar(expr, x) ?
               solve_univar(expr, x, dropmultiplicity = dropmultiplicity) :
               ia_solve(expr, x, warns = warns)
        isequal(sols, nothing) && return nothing
        sols = map(postprocess_root, sols)
        return sols
    elseif expr_univar
        all_vars = get_variables(expr)
        diff_vars = setdiff(wrap.(all_vars), x)
        if length(diff_vars) == 1
            return solve_interms_ofvar(expr, diff_vars[1], dropmultiplicity=dropmultiplicity, warns=warns)
        end

        expr = [expr]
    end


    if !x_univar
        for e in expr
            for var in x
                if !check_poly_inunivar(e, var)
                    warns && @warn("This system can not be currently solved by `symbolic_solve`.")
                    return nothing
                end
            end
        end

        sols = solve_multivar(expr, x, dropmultiplicity=dropmultiplicity, warns=warns)
        isequal(sols, nothing) && return nothing
        sols = convert(Vector{Any}, sols)
        for i in eachindex(sols)
            for var in x
                sols[i][var] = postprocess_root(sols[i][var])
            end
            if length(collect(keys(sols[i]))) == 1
                sols[i] = collect(values(sols[i]))[1]
            end
        end

        return sols
    end
end

function symbolic_solve(expr; x...)
    if expr isa Vector
        expr = convert(Vector{Any}, expr)
        for i in eachindex(expr)
            expr[i] = expr[i] isa Equation ? expr[i].lhs - expr[i].rhs : expr[i]
        end
    else
        expr = expr isa Equation ? expr.lhs - expr.rhs : expr
    end


    r = filter_poly.(expr)
    subs, filtered = r isa Tuple ? r : (map(t -> t[1], r), map(t -> t[2], r))

    sub_vars = []
    if !isempty(subs)
        sub_vars = reduce(vcat, subs isa Dict ? collect(keys(subs)) : collect.(keys.(subs)))
    end

    vars_list = Set{BasicSymbolic{VartypeT}}()
    for ex in wrap(filtered)
        SymbolicUtils.search_variables!(vars_list, ex)
    end
    # vars_list = get_variables.(filtered)
    # filt_vars = unique(isa(vars_list, AbstractArray) && all(isa.(vars_list, AbstractArray)) ? reduce(vcat, vars_list) : vars_list)
    filt_vars = collect(vars_list)
    vars = isempty(sub_vars) ? filt_vars : setdiff(filt_vars, sub_vars)
    vars = wrap.(vars)
    @assert all(v isa Num for v in vars) "All variables should be Nums or BasicSymbolics"

    vars = isone(length(vars)) ? vars[1] : vars
    return symbolic_solve(expr, vars; x...)
end


"""
    solve_univar(expression, x; dropmultiplicity=true)
This solver uses analytic solutions up to degree 4 to solve univariate polynomials.
It first handles the special case of the expression being of operation `^`. E.g. ```math (x+2)^{20}```.
We solve this by removing the int `20`, then solving the poly ```math x+2``` on its own.
If the parameter mult of the solver is set to true, we then repeat the found roots of ```math x+2```
twenty times before returning the results to the user.

Step 2 is filtering the expression after handling this special case, and then factoring
it using `factor_use_nemo`. We then solve all the factors outputted using the analytic methods
implemented in the function `get_roots` and its children.

# Arguments
- expr: Single symbolics Num or SymbolicUtils.BasicSymbolic expression. This is equated to 0 and then solved. E.g. `expr = x+2`, we solve `x+2 = 0`

- x: Single symbolics variable

- dropmultiplicity (optional): Print repeated roots or not?

- strict (optional): Bool that enables/disables strict assert if input expression is a univariate polynomial or not. If strict=true and expression is not a polynomial, `solve_univar` throws an assertion error.

# Examples

"""
function solve_univar(expression, x; dropmultiplicity=true, strict=true)
    args = []
    mult_n = 1
    expression = unwrap(expression)

    # handle multiplicities (repeated roots), i.e. (x+1)^20
    if iscall(expression)
        expr = unwrap(simplify((copy(wrap(expression)))))
        args = arguments(expr)
        operation = SymbolicUtils.operation(expr)
        if isequal(operation, ^) && SymbolicUtils.isconst(args[2]) && (a2 = unwrap_const(args[2]); a2 isa Int64)
            expression = wrap(args[1])
            mult_n = a2
        end
    end

    subs, filtered_expr, assumptions = filter_poly(expression, x, assumptions=true)
    if !strict && !check_polynomial(filtered_expr, strict=false)
        return [RootsOf(wrap(expression), wrap(x))]
    end
    coeffs, constant = polynomial_coeffs(filtered_expr, [x])
    degree = sdegree(coeffs, x)

    u, factors = factor_use_nemo(wrap(filtered_expr))
    factors = convert(Vector{Any}, factors)

    factors_subbed = map(factor -> ssubs(factor, subs), factors)
    arr_roots = []
    is_unfactored = length(factors_subbed) == 1 &&
        isequal(u * first(factors_subbed), wrap(expression))

    if degree < 5 && is_unfactored
        arr_roots = get_roots(expression, x)

        # multiplicities (repeated roots)
        if !dropmultiplicity
            og_arr_roots = copy(arr_roots)
            for i in 1:(mult_n - 1)
                append!(arr_roots, og_arr_roots)
            end
        end
    elseif !is_unfactored
        for i in eachindex(factors_subbed) 
            if !any(isequal(x, var) for var in get_variables(factors[i]))
                continue
            end
            roots = solve_univar(factors_subbed[i], x, dropmultiplicity = dropmultiplicity)
            append!(arr_roots, roots)
        end
    end

    for i in reverse(eachindex(arr_roots))
        for j in eachindex(assumptions)
            if isequal(substitute(assumptions[j], Dict(x=>arr_roots[i])), 0)
                deleteat!(arr_roots, i)
            end
        end
    end

    if isequal(arr_roots, [])
        return [RootsOf(wrap(expression), wrap(x))]
    end

    return arr_roots
end

function solve_multivar(eqs::Any, vars::Any; dropmultiplicity = true, warns = true)
    throw("Groebner bases engine is required. Execute `using Groebner` to enable this functionality.")
end

function get_roots_deg1(expression, x, subs, coeffs)
    @assert isequal(sdegree(coeffs, x), 1) "Expected a polynomial of degree 1 in $x, got $expression"

    m = get(coeffs, x, 0)
    c = get(coeffs, x^0, 0)
    root = -c / m
    root = unwrap(ssubs(root, subs))
    return [root]
end

function get_roots_deg1(expression, x)
    subs, filtered_expr = filter_poly(expression, x)
    coeffs, = polynomial_coeffs(filtered_expr, [x])
    get_roots_deg1(expression, x, subs, coeffs)
end

function get_deg2_with_coeffs(a, b, c)
    a, b, c = bigify(a), bigify(b), bigify(c)

    root1 = (-b + term(ssqrt, (b^2 - 4(a * c)))) / 2a
    root2 = (-b - term(ssqrt, (b^2 - 4(a * c)))) / 2a

    return [root1, root2]
end

function get_roots_deg2(expression, x)
    # ax^2 + bx + c = 0
    subs, filtered_expr = filter_poly(expression, x)
    coeffs, constant = polynomial_coeffs(filtered_expr, [x])

    @assert isequal(sdegree(coeffs, x), 2) "Expected a polynomial of degree 2 in $x, got $expression"

    results = (bigify(ssubs(get(coeffs, x^i, 0), subs)) for i in 2:-1:0)
    a, b, c = results

    root1 = (-b + term(ssqrt, (b^2 - 4(a * c)))) / 2a
    root2 = (-b - term(ssqrt, (b^2 - 4(a * c)))) / 2a

    return [root1, root2]
end

function get_roots_deg3(expression, x)
    subs, filtered_expr = filter_poly(expression, x)
    coeffs, constant = polynomial_coeffs(filtered_expr, [x])

    @assert isequal(sdegree(coeffs, x), 3) "Expected a polynomial of degree 3 in $x, got $expression"

    results = (bigify(unwrap(ssubs(get(coeffs, x^i, 0), subs))) for i in 3:-1:0)
    a, b, c, d = results

    Q = (((3 * a * c) - b^2)) / (9a^2)
    R = ((9 * a * b * c - ((27 * (a^2) * d) + 2b^3))) / (54a^3)

    S = term(scbrt, (R + term(ssqrt, (Q^3 + R^2))))
    T = term(scbrt, (R - term(ssqrt, (Q^3 + R^2))))

    root1 = S + T - (b / (3 * a))
    root2 = -((S + T) / 2) - (b // (3 * a)) + (im * (term(ssqrt, 3)) / 2) * (S - T)
    root3 = -((S + T) / 2) - (b // (3 * a)) - (im * (term(ssqrt, 3)) / 2) * (S - T)

    return [root1, root2, root3]
end

function get_roots_deg4(expression, x)
    subs, filtered_expr = filter_poly(expression, x)
    coeffs, constant = polynomial_coeffs(filtered_expr, [x])

    @assert isequal(sdegree(coeffs, x), 4) "Expected a polynomial of degree 4 in $x, got $expression"

    results = (bigify(unwrap(ssubs(get(coeffs, x^i, 0), subs))) for i in 4:-1:0)
    a, b, c, d, e = results

    p = (8(a * c) - 3(b^2)) // (8(a^2))

    q = (b^3 - 4(a * b * c) + 8(d * a^2)) // (8 * a^3)

    r = (-3(b^4) + 256(e * a^3) - 64(d * b * a^2) + 16(c * (b^2) * a)) // (256 * a^4)

    m = gensym()
    m = (@variables $m)[1]
    eq_m = 8m^3 + 8(p) * m^2 + (2(p^2) - 8r)m - q^2

    roots_m = solve_univar(eq_m, m)
    m = 0

    # Yassin: this thing is a problem for parametric
    for root in roots_m
        vars = get_variables(root)
        if isempty(vars) && !SymbolicUtils._iszero(eval(toexpr(root)))
            m = unwrap(copy(wrap(root)))
            break
        end
    end
    if SymbolicUtils._iszero(m)
        @info "Assuming $(roots_m[1] != 0)"
        m = roots_m[1]
    end

    arr = get_yroots(m, p, q)
    for i in eachindex(arr)
        arr[i] -= unwrap(b // 4a)
    end

    return arr
end

function get_yroots(m, p, q)
    a = 1
    b1 = term(ssqrt, 2m)
    c1 = (p / 2) + m - (q / (2 * term(ssqrt, 2m)))
    b2 = -term(ssqrt, 2m)
    c2 = (p / 2) + m + (q / (2 * term(ssqrt, 2m)))

    root1, root2 = get_deg2_with_coeffs(a, b1, c1)
    root3, root4 = get_deg2_with_coeffs(a, b2, c2)
    return [root1, root2, root3, root4]
end

function get_roots(expression, x)
    @assert is_singleton(unwrap(x)) "Expected a variable, got $x"

    subs, filtered_expr = filter_poly(expression, x)
    coeffs, constant = polynomial_coeffs(filtered_expr, [x])
    @assert SymbolicUtils._iszero(constant) "Expected a polynomial in $x, got $expression"

    degree = sdegree(coeffs, x)

    if degree == 0 && isequal(expression, 0)
        return [x]
    elseif degree == 0 && !isequal(expression, 0)
        return [] # no roots!
    end

    if degree == 1
        return get_roots_deg1(expression, x, subs, coeffs)
    end

    if degree == 2
        return get_roots_deg2(expression, x)
    end

    if degree == 3
        return get_roots_deg3(expression, x)
    end

    if degree == 4
        return get_roots_deg4(expression, x)
    end
end

using Test
using SymPyPythonCall
using Symbolics

@variables x y f(x)

# Test 1: Round-trip conversion
expr = x^2 + y
sympy_expr = symbolics_to_sympy_pythoncall(expr)
back_expr = sympy_pythoncall_to_symbolics(sympy_expr, [x, y])
@test isequal(Symbolics.simplify(expr), Symbolics.simplify(back_expr))

# Test 2: Algebraic solver (single equation)
eq = x^2 - 4
sol = sympy_pythoncall_algebraic_solve(eq, x)
@test length(sol) == 2

# Test 3: Integration
expr = x^2
result = sympy_pythoncall_integrate(expr, x)
@test Symbolics.simplify(result - x^3/3) == 0

# Test 4: Simplification
expr = x^2 + 2x^2
result = sympy_pythoncall_simplify(expr)
@test isequal(Symbolics.simplify(result), 3x^2)

using Symbolics
using D3Trees
using Test

@variables x y z

@testset "D3Trees Extension" begin
    # Test simple expression
    expr1 = x + y
    tree1 = D3Tree(expr1)
    @test tree1 isa D3Tree
    
    # Test complex expression
    expr2 = sin(x) * cos(y) + z^2
    tree2 = D3Tree(expr2, init_expand = 5)
    @test tree2 isa D3Tree
    
    # Test nested expression
    expr3 = (x + y)^3 * exp(z)
    tree3 = D3Tree(expr3)
    @test tree3 isa D3Tree
    
    # Test with custom kwargs
    expr4 = x^2 + 2*x*y + y^2
    tree4 = D3Tree(expr4, init_expand = 10)
    @test tree4 isa D3Tree
end

module SymbolicsD3TreesExt

using Symbolics
using SymbolicUtils
using D3Trees
using D3Trees.AbstractTrees

function sym_nodelabel(x)
    if x isa SymbolicUtils.BasicSymbolic
        if SymbolicUtils.iscall(x)
            string(SymbolicUtils.operation(x))
        else
            string(x)
        end
    else
        string(x)
    end
end

function D3Trees.D3Tree(t::Symbolics.Num; kwargs...)
    symbolic = Symbolics.unwrap(t)

    merged_kwargs = merge(
        (
            detect_repeat = false,
            text = sym_nodelabel, tooltip = string,
            lazy_expand_after_depth = 8, lazy_subtree_depth = 4, init_expand = 8
        ),
        kwargs
    )

    D3Tree(symbolic; merged_kwargs...)
end

end # module SymbolicsD3TreesExt

"""
    series(cs, x, [x0=0,], ns=0:length(cs)-1)

Return the power series in `x` around `x0` to the powers `ns` with coefficients `cs`.

    series(y, x, [x0=0,] ns)

Return the power series in `x` around `x0` to the powers `ns` with coefficients automatically created from the variable `y`.

Examples
========

```jldoctest
julia> @variables x y[0:3] z
3-element Vector{Any}:
 x
  y[0:3]
 z

julia> series(y, x, 2)
y[0] + (-2 + x)*y[1] + ((-2 + x)^2)*y[2] + ((-2 + x)^3)*y[3]

julia> series(z, x, 2, 0:3)
z[0] + (-2 + x)*z[1] + ((-2 + x)^2)*z[2] + ((-2 + x)^3)*z[3]
```
"""
function series(cs::AbstractArray, x::Number, x0::Number, ns::AbstractArray = 0:length(cs)-1)
    length(cs) == length(ns) || error("There are different numbers of coefficients and orders")
    s = sum(c * (x - x0)^n for (c, n) in zip(cs, ns))
    return s
end
function series(cs::AbstractArray, x::Number, ns::AbstractArray = 0:length(cs)-1)
    return series(cs, x, 0, ns)
end
function series(y::Num, x::Number, x0::Number, ns::AbstractArray)
    cs, = @variables $(nameof(y))[ns]
    return series(cs, x, x0, ns)
end
function series(y::Num, x::Number, ns::AbstractArray)
    return series(y, x, 0, ns)
end

"""
    taylor_coeff(f, x[, n]; rationalize=true, kwargs...)

Calculate the `n`-th order coefficient(s) in the Taylor series of `f` around `x = 0`.
If `rationalize`, float coefficients are approximated as rational numbers (this can produce unexpected results for irrational numbers, for example).
Keyword arguments `kwargs...` are forwarded to internal `substitute()` calls.

Examples
========
```jldoctest
julia> @variables x y
2-element Vector{Num}:
 x
 y

julia> taylor_coeff(series(y, x, 0:5), x, 0:2:4)
3-element Vector{Num}:
 y[0]
 y[2]
 y[4]
```
"""
function taylor_coeff(f, x, n = missing; rationalize=true, kwargs...)
    if n isa AbstractArray
        # return array of expressions/equations for each order
        return taylor_coeff.(Ref(f), Ref(x), n; rationalize, kwargs...)
    elseif f isa Equation
        if ismissing(n)
            # assume user wants maximum order in the equation
            n = 0:max(degree(f.lhs, x), degree(f.rhs, x))
            return taylor_coeff(f, x, n; rationalize, kwargs...)
        else
            # return new equation with coefficients of each side
            return taylor_coeff(f.lhs, x, n; rationalize, kwargs...) ~ taylor_coeff(f.rhs, x, n; rationalize, kwargs...)
        end
    elseif ismissing(n)
        # assume user wants maximum order in the expression
        n = 0:degree(f, x)
        return taylor_coeff(f, x, n; rationalize, kwargs...)
    end

    # TODO: error if x is not a "pure variable"
    D = Differential(x)
    n! = factorial(n)
    c = (D^n)(f) / n! # TODO: optimize the implementation for multiple n with a loop that avoids re-differentiating the same expressions
    c = expand_derivatives(c)
    c = substitute(c, x => 0; kwargs...)
    if rationalize && unwrap(c) isa Number
        # TODO: make rational coefficients "organically" and not using rationalize (see https://github.com/JuliaSymbolics/Symbolics.jl/issues/1299)
        c = unwrap(c)
        c = Base.rationalize(c) # convert integers/floats to rational numbers; avoid name clash between rationalize and Base.rationalize()
    end
    return c
end

"""
    taylor(f, x, [x0=0,] n; rationalize=true, kwargs...)

Calculate the `n`-th order term(s) in the Taylor series of `f` around `x = x0`.
If `rationalize`, float coefficients are approximated as rational numbers (this can produce unexpected results for irrational numbers, for example).
Keyword arguments `kwargs...` are forwarded to internal `substitute()` calls.

Examples
========
```jldoctest
julia> @variables x
1-element Vector{Num}:
 x

julia> taylor(exp(x), x, 0:3)
1 + x + (1//2)*(x^2) + (1//6)*(x^3)

julia> taylor(exp(x), x, 0:3; rationalize=false)
1.0 + x + 0.5(x^2) + 0.16666666666666666(x^3)

julia> taylor(√(x), x, 1, 0:3)
1 + (1//2)*(-1 + x) - (1//8)*((-1 + x)^2) + (1//16)*((-1 + x)^3)

julia> isequal(taylor(exp(im*x), x, 0:5), taylor(exp(im*x), x, 0:5))
true
```
"""
function taylor(f, x, ns; rationalize=true, kwargs...)
    if f isa AbstractArray
        return taylor.(f, Ref(x), Ref(ns); rationalize, kwargs...)
    elseif f isa Equation
        return taylor(f.lhs, x, ns; rationalize, kwargs...) ~ taylor(f.rhs, x, ns; rationalize, kwargs...)
    end

    return sum(taylor_coeff(f, x, n; rationalize, kwargs...) * x^n for n in ns)
end
function taylor(f, x, x0, n; rationalize=true, kwargs...)
    # 1) substitute dummy x′ = x - x0
    name = Symbol(nameof(x), "′") # e.g. Symbol("x′")
    x′ = only(@variables $name)
    f = substitute(f, x => x′ + x0; kwargs...)

    # 2) expand f around x′ = 0
    s = taylor(f, x′, n; rationalize, kwargs...)

    # 3) substitute back x = x′ + x0
    return substitute(s, x′ => x - x0; kwargs...)
end

if get(ENV, "CI", nothing) !== nothing
    # copied and modified from https://github.com/tkf/IPython.jl/blob/master/test/install_dependencies.jl

    # Adding Pkg in test/REQUIRE would be an error in 0.6.  Using
    # Project.toml still has some gotchas.  So:
    Pkg = Base.require(Base.PkgId(Base.UUID(0x44cfe95a1eb252eab672e2afdf69b78f), "Pkg"))

    # Let PyCall.jl use Python interpreter from Conda.jl
    # See: https://github.com/JuliaPy/PyCall.jl
    ENV["PYTHON"] = ""
    Pkg.build("PyCall")
end

using Test

using SymPy
using Symbolics

@variables t p(t) x y(t)
expr = x * p + (x^2 - 1 + y) * (p + 2t)
sexpr = symbolics_to_sympy(expr)
sp = symbolics_to_sympy(p)

@test SymPy.simplify(symbolics_to_sympy(Symbolics.symbolic_linear_solve(expr, p))) ==
      SymPy.simplify(SymPy.solve(sexpr, sp)[1])

symbolics_sol = SymPy.simplify(symbolics_to_sympy(Symbolics.symbolic_linear_solve(expr, p)))
sympy_sols = SymPy.solve(SymPy.expand(sexpr), sp)
@test !isempty(sympy_sols) && isequal(symbolics_sol, sympy_sols[1])

@variables x y f(x)

# Test 1: Round-trip conversion
expr = x^2 + y
sympy_expr = symbolics_to_sympy(expr)
back_expr = sympy_to_symbolics(sympy_expr, [x, y])
@test isequal(Symbolics.simplify(expr), Symbolics.simplify(back_expr))

# Test 2: Linear solver
A = [1 2; 3 4]
b = [x, y]
sol = sympy_linear_solve(A, b)
@test length(sol) == 2

# Test 3: Algebraic solver
eq = x^2 - 4
sol = sympy_algebraic_solve(eq, x)
@test length(sol) == 2 && all(s -> isequal(s, 2) || isequal(s, -2), sol)

# Test 4: System of equations
eqs = [x^2 + y^2 - 4, x - y]
sol_sys = sympy_algebraic_solve(eqs, [x, y])
@test length(sol_sys) == 2 && any(
    d -> isapprox(Symbolics.substitute(d[x], Dict()), sqrt(2)) &&
         isapprox(Symbolics.substitute(d[y], Dict()), sqrt(2)),
    sol_sys)

# Test 5: Integration
expr = x^2
result = sympy_integrate(expr, x)
@test isequal(Symbolics.simplify(result), x^3/3)

# Test 6: Limit
expr = 1/x
result = sympy_limit(expr, x, 0)
@test isequal(result, Inf)

# Test 7: Simplification
expr = x^2 + 2x^2
result = sympy_simplify(expr)
@test isequal(Symbolics.simplify(result), 3x^2)

# Test 8: ODE solver
D = Symbolics.Differential(x)
@variables C1
ode = D(f) - 2*f
sol_ode = sympy_ode_solve(ode, f, x)
sol_vars = Symbolics.get_variables(sol_ode)
const_sym = only(filter(v -> startswith(string(Symbolics.nameof(v)), "C"), sol_vars))
expected_sol = C1 * exp(2 * x)
canonical_sol_ode = Symbolics.substitute(sol_ode, Dict(const_sym => C1))
@test isequal(canonical_sol_ode, expected_sol)

## Native ODE solver, but using sympy_integrate
@variables x, t
Dt = Symbolics.Differential(t)
C = Symbolics.variables(:C, 1:5)

@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [5/t], 7t)), Symbolics.sympy_simplify(C[1]*t^(-5) + t^2))
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [cos(t)], cos(t))), 1 + C[1]*exp(-sin(t)))
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [-(1+t)], 1+t)), Symbolics.expand(Symbolics.sympy_simplify(C[1]*exp((1//2)t^2 + t) - 1)))
# SymPy is being weird and not simplifying correctly (and some symbols are wrong, like pi and erf being syms), but these otherwise work
@test_broken isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [-2t], 1)), Symbolics.sympy_simplify(exp(t^2)*sqrt(Symbolics.variable(:pi))*erf(t)/2 + C[1]*exp(t^2)))

## Bernoulli equations
@test isequal(symbolic_solve_ode(Dt(x) + (4/t)*x ~ t^3 * x^2, x, t), 1/(C[1]t^4 - t^4 * log(t)))
@test isnothing(symbolic_solve_ode(Dt(x) + sqrt(t)*x ~ sin(4t)*x^3, x, t))

# Test issue #1605: Power with symbolic exponent
@variables x y
expr_power = x^y
sympy_expr_power = symbolics_to_sympy(expr_power)
back_expr_power = sympy_to_symbolics(sympy_expr_power, [x, y])
@test isequal(Symbolics.simplify(expr_power), Symbolics.simplify(back_expr_power))

using Symbolics
using HypergeometricFunctions
using Test

@testset "HypergeometricFunctions Extension" begin
    @testset "Symbolic registration and evaluation" begin
        # Create symbolic variables with default values
        @variables a=1.0 b=2.0 c=3.0 z=0.5
        @variables a₁=1.0 a₂=2.0 a₃=3.0 b₁=4.0 b₂=5.0

        # Test _₁F₁: symbolic call should produce symbolic result
        expr1 = HypergeometricFunctions._₁F₁(a, b, z)
        @test Symbolics.iscall(Symbolics.unwrap(expr1))

        # Substituting values should give same result as direct numerical call
        val1 = Symbolics.value(Symbolics.substitute(expr1, Dict(a => 1.0, b => 2.0, z => 0.5); fold = Val(true)))
        ref1 = HypergeometricFunctions._₁F₁(1.0, 2.0, 0.5)
        @test val1 ≈ ref1

        # Test _₂F₁
        expr2 = HypergeometricFunctions._₂F₁(a, b, c, z)
        @test Symbolics.iscall(Symbolics.unwrap(expr2))

        val2 = Symbolics.value(Symbolics.substitute(expr2, Dict(a => 1.0, b => 2.0, c => 3.0, z => 0.5); fold = Val(true)))
        ref2 = HypergeometricFunctions._₂F₁(1.0, 2.0, 3.0, 0.5)
        @test val2 ≈ ref2

        # Test _₃F₂
        expr3 = HypergeometricFunctions._₃F₂(a₁, a₂, a₃, b₁, b₂, z)
        @test Symbolics.iscall(Symbolics.unwrap(expr3))

        val3 = Symbolics.value(Symbolics.substitute(expr3, Dict(a₁ => 1.0, a₂ => 2.0, a₃ => 3.0, b₁ => 4.0, b₂ => 5.0, z => 0.5); fold = Val(true)))
        ref3 = HypergeometricFunctions._₃F₂(1.0, 2.0, 3.0, 4.0, 5.0, 0.5)
        @test val3 ≈ ref3
    end

    @testset "Derivative rules" begin
        @variables a=1.0 b=2.0 c=3.0 z=0.5
        @variables a₁=1.0 a₂=2.0 a₃=3.0 b₁=4.0 b₂=5.0
        D = Differential(z)

        # Test d/dz _₁F₁(a, b, z) = (a/b) * _₁F₁(a+1, b+1, z)
        expr1 = HypergeometricFunctions._₁F₁(a, b, z)
        deriv1 = expand_derivatives(D(expr1))

        # Evaluate derivative symbolically and compare with expected formula
        deriv1_val = Symbolics.value(Symbolics.substitute(deriv1, Dict(a => 1.0, b => 2.0, z => 0.5); fold = Val(true)))
        expected1 = (1.0 / 2.0) * HypergeometricFunctions._₁F₁(2.0, 3.0, 0.5)
        @test deriv1_val ≈ expected1

        # Test d/dz _₂F₁(a, b, c, z) = (a*b/c) * _₂F₁(a+1, b+1, c+1, z)
        expr2 = HypergeometricFunctions._₂F₁(a, b, c, z)
        deriv2 = expand_derivatives(D(expr2))

        deriv2_val = Symbolics.value(Symbolics.substitute(deriv2, Dict(a => 1.0, b => 2.0, c => 3.0, z => 0.5); fold = Val(true)))
        expected2 = (1.0 * 2.0 / 3.0) * HypergeometricFunctions._₂F₁(2.0, 3.0, 4.0, 0.5)
        @test deriv2_val ≈ expected2

        # Test d/dz _₃F₂
        expr3 = HypergeometricFunctions._₃F₂(a₁, a₂, a₃, b₁, b₂, z)
        deriv3 = expand_derivatives(D(expr3))

        deriv3_val = Symbolics.value(Symbolics.substitute(deriv3, Dict(a₁ => 1.0, a₂ => 2.0, a₃ => 3.0, b₁ => 4.0, b₂ => 5.0, z => 0.5); fold = Val(true)))
        expected3 = (1.0 * 2.0 * 3.0) / (4.0 * 5.0) * HypergeometricFunctions._₃F₂(2.0, 3.0, 4.0, 5.0, 6.0, 0.5)
        @test deriv3_val ≈ expected3
    end

    @testset "Chain rule" begin
        @variables a=1.0 b=2.0 t=0.5
        Dt = Differential(t)

        # d/dt _₁F₁(a, b, t²) = (a/b) * _₁F₁(a+1, b+1, t²) * 2t
        expr = HypergeometricFunctions._₁F₁(a, b, t^2)
        deriv = expand_derivatives(Dt(expr))

        deriv_val = Symbolics.value(Symbolics.substitute(deriv, Dict(a => 1.0, b => 2.0, t => 0.5); fold = Val(true)))
        # At t=0.5: inner derivative * outer derivative = (a/b) * _₁F₁(a+1, b+1, 0.25) * 2*0.5
        expected = (1.0 / 2.0) * HypergeometricFunctions._₁F₁(2.0, 3.0, 0.25) * 1.0
        @test deriv_val ≈ expected
    end

    @testset "Higher-order derivatives" begin
        @variables a=1.0 b=2.0 z=0.5
        D = Differential(z)
        D2 = D^2

        expr = HypergeometricFunctions._₁F₁(a, b, z)
        deriv2 = expand_derivatives(D2(expr))

        # d²/dz² _₁F₁(a,b,z) = (a*(a+1)) / (b*(b+1)) * _₁F₁(a+2, b+2, z)
        deriv2_val = Symbolics.value(Symbolics.substitute(deriv2, Dict(a => 1.0, b => 2.0, z => 0.5); fold = Val(true)))
        expected = (1.0 * 2.0) / (2.0 * 3.0) * HypergeometricFunctions._₁F₁(3.0, 4.0, 0.5)
        @test deriv2_val ≈ expected
    end

    @testset "Composition with other functions" begin
        @variables a=1.0 b=2.0 z=0.5
        D = Differential(z)

        # Product rule: d/dz [sin(z) * _₁F₁(a, b, z)]
        expr = sin(z) * HypergeometricFunctions._₁F₁(a, b, z)
        deriv = expand_derivatives(D(expr))

        deriv_val = Symbolics.value(Symbolics.substitute(deriv, Dict(a => 1.0, b => 2.0, z => 0.5); fold = Val(true)))
        # cos(z) * _₁F₁ + sin(z) * (a/b) * _₁F₁(a+1, b+1, z)
        expected = cos(0.5) * HypergeometricFunctions._₁F₁(1.0, 2.0, 0.5) +
                   sin(0.5) * (1.0 / 2.0) * HypergeometricFunctions._₁F₁(2.0, 3.0, 0.5)
        @test deriv_val ≈ expected
    end
end

using SafeTestsets, Test, Pkg
using Symbolics

const GROUP = get(ENV, "GROUP", "All")

function activate_downstream_env()
    Pkg.activate("downstream")
    Pkg.develop(PackageSpec(path=dirname(@__DIR__)))
    Pkg.instantiate()
end

function activate_sympy_env()
    Pkg.activate("sympy")
    Pkg.develop(PackageSpec(path=dirname(@__DIR__)))
    Pkg.instantiate()
end

function activate_sympy_pythoncall_env()
    Pkg.activate("sympy_pythoncall")
    Pkg.develop(PackageSpec(path=dirname(@__DIR__)))
    Pkg.instantiate()
end

if haskey(ENV, "BENCHMARK_ONLY")
    include("benchmark.jl")
end

# this needs to be defined at top level
limit2(a, N) = a == N + 1 ? 1 : a == 0 ? N : a
@register_symbolic limit2(a, N)::Integer

if GROUP == "All" || GROUP == "Core"
    @testset begin
        @safetestset "Invalidations Test" begin include("invalidations.jl") end
        @safetestset "Struct Test" begin include("struct.jl") end
        @safetestset "Macro Test" begin include("macro.jl") end
        @safetestset "Arrays" begin include("arrays.jl") end
        @safetestset "View-setting" begin include("stencils.jl") end
        @safetestset "Complex" begin include("complex.jl") end
        @safetestset "Semi-polynomial" begin include("semipoly.jl") end
        @safetestset "Fuzz Arrays" begin include("fuzz-arrays.jl") end
        @safetestset "Differentiation Test" begin include("diff.jl") end
        @safetestset "Utils Test" begin include("utils.jl") end
        @safetestset "ADTypes Test" begin include("adtypes.jl") end
        @safetestset "Difference Test" begin include("difference.jl") end
        @safetestset "Degree Test" begin include("degree.jl") end
        @safetestset "Coeff Test" begin include("coeff.jl") end
        @safetestset "Parsing Test" begin include("parsing.jl") end
        @safetestset "Is Linear or Affine Test" begin include("islinear_affine.jl") end
        @safetestset "Linear Solver Test" begin include("linear_solver.jl") end
        @safetestset "Overloading Test" begin include("overloads.jl") end
        @safetestset "ForwardDiff Extension Test" begin include("forwarddiff_symbolic_dual_ops.jl") end
        @safetestset "Nested ForwardDiff Sparsity Test" begin include("nested_forwarddiff_sparsity.jl") end
        @safetestset "Build Function Test" begin include("build_function.jl") end
        @safetestset "Build Function Array Test" begin include("build_function_arrayofarray.jl") end
        @safetestset "Build Function Array Test Named Tuples" begin include("build_function_arrayofarray_named_tuples.jl") end
        @safetestset "Rewrite Helper Function Test" begin include("rewrite_helpers.jl") end
        VERSION >= v"1.9" && @safetestset "Build Targets Test" begin include("build_targets.jl") end
        @safetestset "Latexify Test" begin include("latexify.jl") end
        @safetestset "Domain Test" begin include("domains.jl") end
        @safetestset "Inequality Test" begin include("inequality.jl") end
        @safetestset "Integral Test" begin include("integral.jl") end
        @safetestset "CartesianIndex Test" begin include("cartesianindex.jl") end
        @safetestset "LogExpFunctions Test" begin include("logexpfunctions.jl") end
        @safetestset "LuxCore extensions Test" begin include("extensions/lux.jl") end
        @safetestset "Registration without using Test" begin include("registration_without_using.jl") end
        @safetestset "Show Test" begin include("show.jl") end
        @safetestset "Utility Function Test" begin include("utils.jl") end
        @safetestset "RootFinding solver" begin include("solver.jl") end
        @safetestset "Function inverses test" begin include("inverse.jl") end
        @safetestset "Taylor Series Test" begin include("taylor.jl") end
        @safetestset "Discontinuity registration test" begin include("discontinuities.jl") end
        @safetestset "ODE solver test" begin include("diffeqs.jl") end
    end
end

if GROUP == "All" || GROUP == "GroebnerExt"
    @safetestset "Groebner extension Test" begin include("extensions/groebner.jl") end
end

if GROUP == "All" || GROUP == "LuxExt"
    @safetestset "Lux extension Test" begin include("extensions/lux.jl") end
end

if GROUP == "All" || GROUP == "D3TreesExt"
    @safetestset "D3Trees extension Test" begin include("extensions/d3trees.jl") end
end

if GROUP == "All" || GROUP == "Core" || GROUP == "SymbolicIndexingInterface"
    @safetestset "SymbolicIndexingInterface Trait Test" begin
        include("symbolic_indexing_interface_trait.jl")
    end
    @safetestset "SymbolicIndexingInterface Parameter Indexing Test" begin
        include("symbolic_indexing_interface_parameter_indexing.jl")
    end
    @safetestset "SymbolicIndexingInterface Symbolic Evaluate Test" begin
        include("symbolic_indexing_interface_symbolic_evaluate.jl")
    end
end

if GROUP == "All" || GROUP == "Downstream"
    activate_downstream_env()
    #@time @safetestset "ParameterizedFunctions MATLABDiffEq Regression Test" begin include("downstream/ParameterizedFunctions_MATLAB.jl") end
    @safetestset "ModelingToolkit Variable Utils Test" begin include("downstream/modeling_toolkit_utils.jl") end
    @safetestset "DI Test" begin include("downstream/differentiation_interface.jl") end
end

if GROUP == "All" || GROUP == "SymPy"
    activate_sympy_env()
    @safetestset "SymPy Test" begin include("sympy.jl") end
end

if GROUP == "All" || GROUP == "SymPyPythonCall"
    activate_sympy_pythoncall_env()
    @safetestset "SymPyPythonCall Test" begin include("sympy_pythoncall.jl") end
end

using Symbolics, Test
import SymbolicUtils: evaluate

evalsol(x) = Symbolics.value(evaluate(x))

# test all variations of series() input
ns = 0:3
Y, = @variables y[ns]
@variables x y

# 1) first argument is a variable
@test isequal(series(y, x, 7, ns), Y[0] + Y[1]*(x-7)^1 + Y[2]*(x-7)^2 + Y[3]*(x-7)^3)
@test isequal(series(y, x, ns), substitute(series(y, x, 7, ns), x => x + 7))
@test_throws ErrorException series(2*y, x, ns) # 2*y is a meaningless variable name

# 2) first argument is coefficients
@test isequal(series(Y, x, 7), series(y, x, 7, ns))
@test isequal(series(Y, x, ns), substitute(series(Y, x, 7), x => x + 7))
@test isequal(series([1,2,3], 8, 4, [5,6,7]), 1*(8-4)^5 + 2*(8-4)^6 + 3*(8-4)^7)
@test isequal(series([1,2,3], 8, 4), 1 + 2*(8-4)^1 + 3*(8-4)^2)
@test isequal(series([1,2,3], 4, [5,6,7]), series([1,2,3], 8, 4, [5,6,7]))
@test isequal(series([1,2,3], 4), 1^0 + 2*4^1 + 3*4^2)

# https://en.wikipedia.org/wiki/Taylor_series#List_of_Maclaurin_series_of_some_common_functions
@variables x
@test evalsol(expand(taylor(exp(x), x, 0:9) - sum(x^n/factorial(n) for n in 0:9))) == 0
@test evalsol(expand(taylor(log(1-x), x, 0:9) - sum(-x^n/n for n in 1:9))) == 0
@test evalsol(expand(taylor(log(1+x), x, 0:9) - sum((-1)^(n+1)*x^n/n for n in 1:9))) == 0

@test evalsol(expand(taylor(1/(1-x), x, 0:9) - sum(x^n for n in 0:9))) == 0
@test evalsol(expand(taylor(1/(1-x)^2, x, 0:8) - sum(n * x^(n-1) for n in 1:9))) == 0
@test evalsol(expand(taylor(1/(1-x)^3, x, 0:7) - sum((n-1)*n*x^(n-2)/2 for n in 2:9))) == 0
for α in (-1//2, 0, 1//2, 1, 2, 3)
    @test evalsol(expand(taylor((1+x)^α, x, 0:7) - sum(binomial(α, n)*x^n for n in 0:7))) == 0
end

@test evalsol(expand(taylor(sin(x), x, 0:7) - sum((-1)^n/factorial(2*n+1) * x^(2*n+1) for n in 0:3))) == 0
@test evalsol(expand(taylor(cos(x), x, 0:7) - sum((-1)^n/factorial(2*n) * x^(2*n) for n in 0:3))) == 0
@test evalsol(expand(taylor(tan(x), x, 0:7) - taylor(taylor(sin(x), x, 0:7) / taylor(cos(x), x, 0:7), x, 0:7))) == 0
@test evalsol(expand(taylor(asin(x), x, 0:7) - sum(factorial(2*n)/(4^n*factorial(n)^2*(2*n+1)) * x^(2*n+1) for n in 0:3))) == 0
@test evalsol(expand(taylor(acos(x), x, 0:7) - (π/2 - taylor(asin(x), x, 0:7)))) == 0 # TODO: make π/2 a proper fraction (like Num(π)/2)
@test evalsol(expand(taylor(atan(x), x, 0:7) - taylor(asin(x/√(1+x^2)), x, 0:7))) == 0

@test evalsol(expand(taylor(sinh(x), x, 0:7) - sum(1/factorial(2*n+1) * x^(2*n+1) for n in 0:3))) == 0
@test evalsol(expand(taylor(cosh(x), x, 0:7) - sum(1/factorial(2*n) * x^(2*n) for n in 0:3))) == 0
@test evalsol(expand(taylor(tanh(x), x, 0:7) - (x - x^3/3 + 2/15*x^5 - 17/315*x^7))) == 0

# around x ≠ 0
@test evalsol(substitute(taylor(√(x), x, 1, 0:6), x => x + 1) - taylor(√(1+x), x, 0:6)) == 0

# equations
eq = sin(2*x) ~ 2*sin(x)*cos(x)
eq = taylor(eq, x, 0:7)
eqs = taylor_coeff(eq, x) # should automatically expand to 7th order
@test length(eqs) == 7+1 && all(isequal(evaluate(eq.lhs), evaluate(eq.rhs)) for eq in eqs)

# expand quintic equation around x=1
@variables ϵ
x_series = series(x, ϵ, 0:3)
x_coeffs = taylor_coeff(x_series, ϵ)
eq = x^5 + ϵ*x ~ 1
eqs = taylor_coeff(substitute(eq, x => x_series), ϵ, 0:3)
sol = x_coeffs .=> [1, -1//5, -1//25, -1//125] # e.g. https://ekamperi.github.io/mathematics/2020/06/21/perturbation-theory.html#MathJax-Element-39-Frame
eqs = substitute(eqs, Dict(sol))
@test all(isequal(eq.lhs, eq.rhs) for eq in eqs)

# system of equations
@test evaluate(taylor(exp(im*x) ~ 0, x, 0:5)) == evaluate(taylor([cos(x) ~ 0, sin(x) ~ 0], x, 0:5))

# don't evaluate numerical expressions
eq = y ~ 2*Num(π)*x
eq = taylor(eq, x, 0, 1; rationalize=false, fold=Val(false))
@test contains(string(eq), "π") # should not turn 2*π into 6.28...

# integral with symbolic limits
@variables a
I = Integral(x in (0, 2a))
@test isequal(taylor_coeff(I(ϵ^2*x+1), ϵ, 1), I(0))

# inside derivatives
@test isequal(taylor(Differential(x)(sin(x)), x, 0:7), taylor(cos(x), x, 0:6)) # D(sin(x)) = cos(x)

"""
    inverse(f)

Given a single-input single-output function `f`, return its inverse `g`. This requires
that `f` is bijective. If `inverse` is defined for a function, `left_inverse` and
`right_inverse` should return `inverse(f)`. `inverse(g)` should also be defined to
return `f`.

See also: [`left_inverse`](@ref), [`right_inverse`](@ref), [`@register_inverse`](@ref).
"""
function inverse end

"""
    left_inverse(f)

Given a single-input single-output function `f`, return its left inverse `g`. This
requires that `f` is injective. If `left_inverse` is defined for a function,
`right_inverse` and `inverse` must not be defined and should error. `right_inverse(g)`
should also be defined to return `f`.

See also: [`inverse`](@ref), [`right_inverse`](@ref), [`@register_inverse`](@ref).
"""
function left_inverse end

"""
    right_inverse(f)

Given a single-input single-output function `f`, return its right inverse `g`. This
requires that `f` is surjective. If `right_inverse` is defined for a function,
`left_inverse` and `inverse` must not be defined and should error. `left_inverse(g)`
should also be defined to return `f`.

See also [`inverse`](@ref), [`left_inverse`](@ref), [`@register_inverse`](@ref).
"""
function right_inverse end

"""
    @register_inverse f g
    @register_inverse f g left
    @register_inverse f g right

Mark `f` and `g` as inverses of each other. By default, assume that `f` and `g` are
bijective. Also defines `left_inverse` and `right_inverse` to call `inverse`. If the
third argument is `left`, assume that `f` is injective and `g` is its left inverse. If
the third argument is `right`, assume that `f` is surjective and `g` is its right
inverse.
"""
macro register_inverse(f, g, dir::QuoteNode = :(:both))
    dir = dir.value
    f = esc(f)
    g = esc(g)
    if dir == :both
        quote
            (::$typeof($inverse))(::$typeof($f)) = $g
            (::$typeof($inverse))(::$typeof($g)) = $f
            (::$typeof($left_inverse))(::$typeof($f)) = $(inverse)($f)
            (::$typeof($right_inverse))(::$typeof($f)) = $(inverse)($f)
            (::$typeof($left_inverse))(::$typeof($g)) = $(inverse)($g)
            (::$typeof($right_inverse))(::$typeof($g)) = $(inverse)($g)
        end
    elseif dir == :left
        quote
            (::$typeof($left_inverse))(::$typeof($f)) = $g
            (::$typeof($right_inverse))(::$typeof($g)) = $f
        end
    elseif dir == :right
        quote
            (::$typeof($right_inverse))(::$typeof($f)) = $g
            (::$typeof($left_inverse))(::$typeof($g)) = $f
        end
    else
        throw(ArgumentError("The third argument to `@register_inverse` must be `left` or `right`"))
    end
end

"""
    $(TYPEDSIGNATURES)

Check if the provided function has an inverse defined via [`inverse`](@ref). Uses
`hasmethod` to perform the check.
"""
has_inverse(::T) where {T} = hasmethod(inverse, Tuple{T})

"""
    $(TYPEDSIGNATURES)

Check if the provided function has a left inverse defined via [`left_inverse`](@ref)
Uses `hasmethod` to perform the check.
"""
has_left_inverse(::T) where {T} = hasmethod(left_inverse, Tuple{T})

"""
    $(TYPEDSIGNATURES)

Check if the provided function has a left inverse defined via [`left_inverse`](@ref)
Uses `hasmethod` to perform the check.
"""
has_right_inverse(::T) where {T} = hasmethod(right_inverse, Tuple{T})

"""
    $(TYPEDSIGNATURES)

A simple utility function which returns the square of the input. Used to define
the inverse of `sqrt`.
"""
square(x) = x ^ 2

"""
    $(TYPEDSIGNATURES)

A simple utility function which returns the cube of the input. Used to define
the inverse of `cbrt`.
"""
cube(x) = x ^ 3

"""
    $(TYPEDSIGNATURES)

A simple utility function which takes `x` and returns `acos(x) / pi`. Used to
define the inverse of `acospi`.
"""
acosbypi(x) = acos(x) / pi

@register_inverse sin asin
@register_inverse cos acos
@register_inverse tan atan
@register_inverse csc acsc
@register_inverse sec asec
@register_inverse cot acot
@register_inverse sind asind
@register_inverse cosd acosd
@register_inverse tand atand
@register_inverse cscd acscd
@register_inverse secd asecd
@register_inverse cotd acotd
@register_inverse sinh asinh
@register_inverse cosh acosh
@register_inverse tanh atanh
@register_inverse csch acsch
@register_inverse sech asech
@register_inverse coth acoth
@register_inverse cospi acosbypi
@register_inverse SpecialFunctions.digamma SpecialFunctions.invdigamma
@register_inverse log exp
@register_inverse log2 exp2
@register_inverse log10 exp10
@register_inverse log1p expm1
@register_inverse deg2rad rad2deg
@register_inverse sqrt square :left
@register_inverse cbrt cube
@register_inverse NaNMath.sin NaNMath.asin
@register_inverse NaNMath.cos NaNMath.acos
# can't use macro since it would be a re-definition of `inverse(atan)`
inverse(::typeof(NaNMath.tan)) = inverse(tan)
inverse(::typeof(NaNMath.acosh)) = inverse(acosh)
inverse(::typeof(NaNMath.atanh)) = inverse(atanh)
inverse(::typeof(NaNMath.log)) = inverse(log)
inverse(::typeof(NaNMath.log10)) = inverse(log10)
inverse(::typeof(NaNMath.log1p)) = inverse(log1p)
inverse(::typeof(NaNMath.log2)) = inverse(log2)
left_inverse(::typeof(NaNMath.sqrt)) = left_inverse(sqrt)
# inverses of solve helpers
left_inverse(::typeof(ssqrt)) = left_inverse(sqrt)
left_inverse(::typeof(scbrt)) = left_inverse(cbrt)
left_inverse(::typeof(slog)) = left_inverse(log)

function inverse(f::ComposedFunction)
    return inverse(f.inner) ∘ inverse(f.outer)
end
has_inverse(f::ComposedFunction) = has_inverse(f.inner) && has_inverse(f.outer)
function left_inverse(f::ComposedFunction)
    return left_inverse(f.inner) ∘ left_inverse(f.outer)
end
function has_left_inverse(f::ComposedFunction)
    return has_left_inverse(f.inner) && has_left_inverse(f.outer)
end
function right_inverse(f::ComposedFunction)
    return right_inverse(f.inner) ∘ right_inverse(f.outer)
end
function has_right_inverse(f::ComposedFunction)
    return has_right_inverse(f.inner) && has_right_inverse(f.outer)
end

using Symbolics, Test

ex = [:(y ~ x)
      :(y ~ -2x + 3 / z)
      :(z ~ 2)]
eqs = parse_expr_to_symbolic.(ex, (@__MODULE__,))

@variables x y z
ex = [y ~ x
      y ~ -2x + 3 / z
      z ~ 2]
@test all(isequal.(eqs,ex))

ex = [:(b(t) ~ a(t))
      :(b(t) ~ -2a(t) + 3 / c(t))
      :(c(t) ~ 2)]
eqs = parse_expr_to_symbolic.(ex, (@__MODULE__,))
@variables t a(t) b(t) c(t)
ex = [b ~ a
      b ~ -2a + 3 / c
      c ~ 2]
@test_broken all(isequal.(eqs,ex))

# Unlike above tests variables need to be defined ahead of time
# To avoid BoundsError
# https://github.com/JuliaSymbolics/Symbolics.jl/issues/1534
@variables m[1:3]
ex = [:(m[2] ~ m[1])
      :(m[2] ~ -2m[1] + 3 / m[3])
      :(m[3] ~ 2)]
eqs = parse_expr_to_symbolic.(ex, (@__MODULE__,))
ex = [m[2] ~ m[1]
      m[2] ~ -2m[1] + 3 / m[3]
      m[3] ~ 2]
@test all(isequal.(eqs,ex))

"""
```julia
parse_expr_to_symbolic(ex, mod::Union{Module,AbstractDict})
```

Applies the `parse_expr_to_symbolic` function in the current module, i.e.
`parse_expr_to_symbolic(ex, mod)` where `mod` is the module of the function
caller.

## Arguments

* `ex`: the expression to parse
* `mod`: the module or dictionary to apply the parsing in. See the limitations section for details.

## Example

```julia
ex = :(y(t) ~ x(t))
parse_expr_to_symbolic(ex,Main) # gives the symbolic expression `y(t) ~ x(t)` in empty Main

# Now do a whole system

ex = [:(y ~ x)
      :(y ~ -2x + 3 / z)
      :(z ~ 2)]
eqs = parse_expr_to_symbolic.(ex, (Main,))

@variables x y z
ex = [y ~ x
      y ~ -2x + 3 / z
      z ~ 2]
all(isequal.(eqs,ex)) # true
```
## Limitations

### Symbolic-ness Tied to Environment Definitions

The parsing to a symbolic expression has to be able to recognize the difference between
functions, numbers, and globals defined within one's Julia environment and those that
are to be made symbolic. The way this functionality handles this problem is that it
does not define anything as symbolic that is already defined in the chosen `mod` module.
For example, `f(x,y)` will have `f` as non-symbolic if the function `f` (named `f`)
is defined in `mod`, i.e. if `isdefined(mod,:f)` is true. When the symbol is defined, it
will be replaced by its value. Notably, this means that the parsing behavior changes
depending on the environment that it is applied.

For example:

```julia
parse_expr_to_symbolic(:(x - y),@__MODULE__) # x - y
x = 2.0
parse_expr_to_symbolic(:(x - y),@__MODULE__) # 2.0 - y
```

This is required to detect that standard functions like `-` are functions instead of
symbolic symbols. For safety, one should create anonymous modules or other sub-environments
to ensure no stray variables are defined.

### Metadata is Blank

Because all the variables defined by the expressions are not defined with the standard
`@variables`, there is no metadata that is or can be associated with any of the generated
variables. Instead, they all have blank metadata, but are defined in the `Real` domain.
Thus, the variables which come out of this parsing may not evaluate as equal to a symbolic
variable defined elsewhere.
"""
function parse_expr_to_symbolic end

parse_expr_to_symbolic(x::Number, mod::Union{Module, AbstractDict}) = x

function parse_expr_to_symbolic(x::Symbol, mod::Module)
    if isdefined(mod, x)
        getfield(mod, x)
    else
        (@variables $x)[1]
    end
end

function parse_expr_to_symbolic(x::Symbol, dict::AbstractDict)
    if haskey(dict, x)
        dict[x]
    else
        (@variables $x)[1]
    end
end

function parse_expr_to_symbolic(ex::Expr, mod::Union{Module,AbstractDict})
    if ex.head == :call
        op = ex.args[1]
        args = ex.args[2:end]
        parsed_args = parse_expr_to_symbolic.(args, Ref(mod))
        
        # Handle built-in operators
        if op in (:+, :-, :*, :/, :^)
            if op == :- && length(args) == 1  # Unary minus
                return -parsed_args[1]
            end
            return getfield(Base, op)(parsed_args...)
        end
        
        # Handle common mathematical functions
        math_functions = Dict(
            :sqrt => Base.sqrt,
            :sin => Base.sin,
            :cos => Base.cos,
            :tan => Base.tan,
            :exp => Base.exp,
            :log => Base.log
        )
        if op in keys(math_functions)
            return math_functions[op](parsed_args...)
        end
        
        # Handle oth defined functions or symbols
        if (mod isa Module && isdefined(mod, op)) || (mod isa AbstractDict && haskey(mod, op))
            func = mod isa Module ? getfield(mod, op) : mod[op]
            return func(parsed_args...)
        else
            # Treat as symbolic function or term
            x = parse_expr_to_symbolic(op, mod)
            return Term{Real}(x, parsed_args)
        end
    elseif ex.head == :ref
        arr = parse_expr_to_symbolic(ex.args[1], mod)
        indices = parse_expr_to_symbolic.(ex.args[2:end], Ref(mod))
        return arr[indices...]
    else
        error("Unsupported expression head: $(ex.head)")
    end
end

# Handle non-Expr inputs
parse_expr_to_symbolic(ex, mod::Union{Module,AbstractDict}) = ex

"""
```julia
@parse_expr_to_symbolic ex
```

Applies the `parse_expr_to_symbolic` function in the current module, i.e.
`parse_expr_to_symbolic(ex, mod)` where `mod` is the module of the function
caller.

## Arguments

* `ex`: the expression to parse

## Example

```julia
ex = :(y(t) ~ x(t))
@parse_expr_to_symbolic ex # gives the symbolic expression `y(t) ~ x(t)`
```

## Limitations

The same limitations apply as for the function `parse_expr_to_symbolic`.
See its docstring for more details.
"""
macro parse_expr_to_symbolic(ex)
    :(parse_expr_to_symbolic($ex, @__MODULE__))
end

module SymbolicsHypergeometricFunctionsExt

using Symbolics
using HypergeometricFunctions

using Symbolics: @register_symbolic, @register_derivative

# Register the main hypergeometric functions as symbolic
# These are the fixed-arity versions that work well with Symbolics

# ₁F₁(a, b, z) - Kummer's confluent hypergeometric function
@register_symbolic HypergeometricFunctions._₁F₁(a, b, z)

# ₂F₁(a, b, c, z) - Gauss hypergeometric function
@register_symbolic HypergeometricFunctions._₂F₁(a, b, c, z) false

# ₃F₂(a₁, a₂, a₃, b₁, b₂, z) - Generalized hypergeometric function
@register_symbolic HypergeometricFunctions._₃F₂(a₁, a₂, a₃, b₁, b₂, z) false

# Register derivatives with respect to z (the last argument)
# These follow the standard differentiation formulas for hypergeometric functions:
#   d/dz ₁F₁(a, b, z) = (a/b) ₁F₁(a+1, b+1, z)
#   d/dz ₂F₁(a, b, c, z) = (ab/c) ₂F₁(a+1, b+1, c+1, z)
#   d/dz ₃F₂(a₁, a₂, a₃, b₁, b₂, z) = (a₁a₂a₃)/(b₁b₂) ₃F₂(a₁+1, a₂+1, a₃+1, b₁+1, b₂+1, z)

@register_derivative HypergeometricFunctions._₁F₁(a, b, z) 3 (a / b) * HypergeometricFunctions._₁F₁(a + 1, b + 1, z)

@register_derivative HypergeometricFunctions._₂F₁(a, b, c, z) 4 (a * b / c) * HypergeometricFunctions._₂F₁(a + 1, b + 1, c + 1, z)

@register_derivative HypergeometricFunctions._₃F₂(a₁, a₂, a₃, b₁, b₂, z) 6 (a₁ * a₂ * a₃) / (b₁ * b₂) * HypergeometricFunctions._₃F₂(a₁ + 1, a₂ + 1, a₃ + 1, b₁ + 1, b₂ + 1, z)

end

function cross_multiply(eq)
    og_oper = operation(unwrap(eq))
    done = true
    loop_add = false

    term_tm = 1
    if og_oper === (/)
        done = false
        args = arguments(unwrap(eq))
        eq = wrap(args[1])
    end

    # do this until no / are present
    if og_oper === (+)
        while !loop_add
            args = arguments(unwrap(eq))
            loop_add = true

            for arg in args
                !iscall(arg) && continue
                oper = operation(arg)
                if oper == (/) 
                    done = false
                    loop_add = false
                    term_tm *= wrap(arguments(arg)[2])
                end
            end
            args = [arg*term_tm for arg in args]
            eq = expand(Symbolics.term((+), unwrap.(args)...))
            term_tm = 1
        end
    end

    if done
        return eq
    else
        return cross_multiply(eq)
    end
end
"""
    solve_interms_ofvar(eq, s; dropmultiplicity=true, warns=true)
This special case solver expects a single equation in multiple variables and a
variable `s` (this can be any Num, `s` is used for convenience). The function generates
a system of equations to by observing the coefficients of the powers of `s` present in `eq`.
E.g. a system would look like `a+b = 1`, `a-2b = 3` for the eq `(a+b)s + (a-2b)s^2 - (1)s - (3)s^2 = 0`.
After generating this system, it calls `symbolic_solve`, which uses `solve_multivar`. `symbolic_solve` was chosen
instead of `solve_multivar` because it postprocesses the roots in order to simplify them and make them more user friendly.

Generation of system uses cross multiplication in order to simplify the equation and convert it
to a polynomial like shape.


# Arguments
- eq: Single symbolics Num or SymbolicUtils.BasicSymbolic. This is equated to 0 and then solved. E.g. `expr = x+2`, we solve `x+2 = 0`

- s: Variable to "isolate", i.e. ignore and generate the system of equations based on this variable's coefficients.

- dropmultiplicity (optional): Print repeated roots or not?

- warns (optional, this is not used currently): Warn user when something is wrong or not.

# Examples
```jldoctest
julia> @variables a b x s;

julia> eq = (a*x^2+b)*s^2 - 2s^2 + 2*b*s - 3*s + 2(x^2)*(s^3) + 10*s^3;

julia> Symbolics.solve_interms_ofvar(eq, s)
2-element Vector{Any}:
 Dict{Num, Any}(a => -1//10, b => 3//2, x => (0 - 1im)*√(5))
 Dict{Num, Any}(a => -1//10, b => 3//2, x => (0 + 1im)*√(5))
```
```jldoctest
julia> eq = ((s^2 + 1)/(s^2 + 2*s + 1)) - ((s^2 + a)/(b*c*s^2 + (b+c)*s + d));

julia> Symbolics.solve_interms_ofvar(eq, s)
1-element Vector{Any}:
 Dict{Num, Any}(a => 1, d => 1, b => 1, c => 1)
```
"""
function solve_interms_ofvar(eq, s; dropmultiplicity=true, warns=true)
    @assert iscall(unwrap(eq))
    vars = Symbolics.get_variables(eq)
    vars = filter(v -> !isequal(v, s), vars)
    vars = wrap.(vars)

    term_tm = 1
        
    eq = cross_multiply(eq)
    coeffs, constant = polynomial_coeffs(eq, [s])
    eqs = wrap.(collect(values(coeffs)))

    symbolic_solve(eqs, vars, dropmultiplicity=dropmultiplicity, warns=warns)
end

# an attempt at using ia_solve recursively.
function find_v(eqs, v, vars)
    vars = filter(var -> !isequal(var, v), vars)
    n_eqs = deepcopy(eqs)

    if isequal(n_eqs[1], 0)
        n_eqs = n_eqs[2:end]
    end
    
    present_vars = Symbolics.get_variables(n_eqs[1])
    var = present_vars[1]
    if length(present_vars) == 1 && isequal(present_vars[1], v)
        return ia_solve(n_eqs[1], var)
    end
    if isequal(present_vars[1], v)
        var = present_vars[2]
    end

    @info "" n_eqs[1]
    @info "" var
    sols = ia_solve(n_eqs[1], var)
    isequal(sols, nothing) && return []

    for s in sols
        for j in 2:length(n_eqs)
            n_eqs[j] = substitute(n_eqs[j], Dict(var => s))
        end
        # other solutions are cut out here
        return find_v(n_eqs[2:end], v, vars)
    end

end

export semipolynomial_form, semilinear_form, semiquadratic_form, polynomial_coeffs

const SemipolyDictT = Dict{BasicSymbolic{VartypeT}, BasicSymbolic{VartypeT}}

function canonicalize_poly(poly_to_bs, bs_to_poly, poly, degree, vars::AbstractSet)
    subskeys = SymbolicUtils.PolyVarT[]
    subsvals = SymbolicUtils.PolynomialT[]
    for pvar in MP.variables(poly)
        var = poly_to_bs[pvar]
        if isdiv(var)
            var = SymbolicUtils.flatten_fractions(var)
        end
        @match var begin
            BSImpl.Div(; num, den) => begin
                den_has_vars = SymbolicUtils.query(in(vars), den)
                # We only care about terms up to degree `degree`. So we only care about
                # numerators with degree <= `2degree + 1`, since if the denominator is
                # degree `degree` this entire variable goes in the residual anyway. The +1
                # is in case `degree == 0`.
                result, resid = semipolynomial_form(num, vars, 2degree + 1; consts = false)
                newpoly = SymbolicUtils.to_poly!(poly_to_bs, bs_to_poly, resid / den)
                if newpoly isa SymbolicUtils.PolyVarT
                    newpoly = MP.polynomial(newpoly, SymbolicUtils.PolyCoeffT)
                end
                for (monomial, coeff) in result
                    if den_has_vars
                        monomial = monomial / den
                        @match monomial begin
                            BSImpl.Div(; num = n2, den = d2) => begin
                                den_has_vars2 = isequal(den, d2) || SymbolicUtils.query(in(vars), den)
                                if den_has_vars2
                                    coeff *= monomial
                                    monomial = 1
                                end
                            end
                            _ => nothing
                        end
                    else
                        coeff = coeff / den
                    end
                    mono = SymbolicUtils.to_poly!(poly_to_bs, bs_to_poly, monomial, false)
                    coeff = if SymbolicUtils.isconst(coeff)
                        unwrap_const(coeff)
                    else
                        SymbolicUtils.basicsymbolic_to_polyvar(bs_to_poly, coeff)
                    end
                    MA.operate!(+, newpoly, mono * coeff)
                end
                push!(subskeys, pvar)
                push!(subsvals, newpoly)
            end
            _ => nothing
        end
    end
    return MP.subs(poly, subskeys => subsvals)
end

function _semipoly_query_recurse(ex::SymbolicT)
    @match ex begin
        BSImpl.Term(; f, args) && if f === getindex && hasmetadata(args[1], VariableSource) end => false
        _ => true
    end
end

"""
$(TYPEDSIGNATURES)

Returns a tuple of two objects:

1. A dictionary of coefficients keyed by monomials in `vars` upto the given `degree`,
2. A residual expression which has all terms not represented as a product of monomial and a coefficient

`degree` should be a nonnegative number.

If  `consts` is set to `true`, then the returned dictionary will contain
a key `1` and the corresponding value will be the constant term. If `false`, the constant term will be part of the residual.
"""
function semipolynomial_form(expr, vars, degree::Real; consts = true)
    if degree < 0
        @warn "Degree for semi-polynomial form should be ≥ 0"
        return SemipolyDictT(), expr
    end
    vars = Set([unwrap(x) for x in vars])
    for v in vars
        v isa BasicSymbolic{VartypeT} || continue
        @match v begin
            BSImpl.Term(; f, args) && if f === getindex end => push!(vars, args[1])
            _ => nothing 
        end
    end
    expr = unwrap(expr)
    expr = expand(expr, false)
    poly_to_bs = Bijections.Bijection{SymbolicUtils.PolyVarT, BasicSymbolic{VartypeT}}()
    bs_to_poly = Bijections.active_inv(poly_to_bs)
    poly = SymbolicUtils.to_poly!(poly_to_bs, bs_to_poly, expr, false)
    poly = canonicalize_poly(poly_to_bs, bs_to_poly, poly, degree, vars)
    pvars = MP.variables(poly)
    nonpoly_mask = falses(length(pvars))
    in_vars_mask = falses(length(pvars))
    for (i, pvar) in enumerate(pvars)
        var = poly_to_bs[pvar]
        in_vars_mask[i] = var in vars
        in_vars_mask[i] && continue
        nonpoly_mask[i] = SymbolicUtils.query(in(vars), var; recurse = _semipoly_query_recurse)
    end
    result = SemipolyDictT()
    constant = SymbolicUtils.zeropoly()
    residual = SymbolicUtils.zeropoly()
    for t in MP.terms(poly)
        is_monomial_in_vars = true
        monomial_degree = 0
        true_monomial = SymbolicUtils.MonomialT()
        coeff_monomial = SymbolicUtils.MonomialT()
        for (i, exp) in enumerate(MP.exponents(t))
            iszero(exp) && continue
            monomial_degree += in_vars_mask[i] * exp
            MA.operate!(*, in_vars_mask[i] ? true_monomial : coeff_monomial, MP.variables(t)[i] ^ exp)
            is_monomial_in_vars &= !nonpoly_mask[i]
        end
        if is_monomial_in_vars && monomial_degree <= degree
            if monomial_degree == 0
                MA.operate!(+, constant, t)
            else
                mono = SymbolicUtils.from_poly(poly_to_bs, true_monomial)
                result[mono] = get(result, mono, 0) + MP.coefficient(t) * SymbolicUtils.from_poly(poly_to_bs, coeff_monomial)
            end
        else
            MA.operate!(+, residual, t)
        end
    end

    if consts && !iszero(constant)
        result[Const{VartypeT}(1)] = SymbolicUtils.from_poly(poly_to_bs, constant)
    else
        MA.operate!(+, residual, constant)
    end
    residual = SymbolicUtils.from_poly(poly_to_bs, residual)
    return result, residual
end

"""
$(TYPEDSIGNATURES)

For every expression in `exprs` computes the semi-polynomial form and
returns a tuple of two objects -- a vector of coefficient dictionaries,
and a vector of residual terms.

If  `consts` is set to `true`, then the returned dictionary will contain
a key `1` and the corresponding value will be the constant term. If `false`, the constant term will be part of the residual.
"""
function semipolynomial_form(exprs::AbstractArray, vars, degree::Real; consts = true)
    if degree < 0
        @warn "Degree for semi-polynomial form should be ≥ 0"
        return fill(SemipolyDictT(), size(exprs)), exprs
    end
    if any(iswrapped, vars)
        vars = map(unwrap, vars)
    end
    if !(vars isa AbstractSet)
        vars = Set(vars)
    end
    results = similar(exprs, SemipolyDictT)
    residuals = similar(exprs, BasicSymbolic{VartypeT})

    for (i, expr) in enumerate(exprs)
        results[i], residuals[i] = semipolynomial_form(expr, vars, degree; consts)
    end
    return results, residuals
end

"""
$(SIGNATURES)

Find coefficients of a polynomial in `vars`.

Returns a tuple of two elements:
1. A dictionary of coefficients keyed by monomials in `vars`
2. A residual expression which is the constant term

(Same as `semipolynomial_form(expr, vars, Inf)`)
"""
polynomial_coeffs(expr, vars) = semipolynomial_form(expr, vars, Inf)

"""
$(TYPEDSIGNATURES)

Returns a tuple of a sparse matrix `A`, and a residual vector `c` such that,
`A * vars + c` is the same as `exprs`.
"""
function semilinear_form(exprs::AbstractArray, vars)
    ds, nls = semipolynomial_form(exprs, vars, 1; consts = false)

    idxmap = Dict(v=>i for (i, v) in enumerate(vars))

    I = Int[]
    J = Int[]
    V = Num[]

    for (i, d) in enumerate(ds)
        for (k, v) in d
            push!(I, i)
            push!(J, idxmap[k])
            push!(V, v)
        end
    end

    sparse(I,J,V, length(exprs), length(vars)), wrap.(nls)
end

"""
$(TYPEDSIGNATURES)

Returns a tuple of 4 objects:

1. a matrix `A` of dimensions (m x n)
2. a matrix `B` of dimensions (m x (n+1)*n/2)
3. a vector `v2` of length (n+1)*n/2 containing monomials of `vars` upto degree 2 and zero where they are not required.
4. a residual vector `c` of length m.

where `n == length(exprs)` and `m == length(vars)`.


The result is arranged such that, `A * vars + B * v2 + c` is the same as `exprs`.
"""
function semiquadratic_form(exprs, vars)
    ds, nls = semipolynomial_form(exprs, vars, 2; consts = false)

    idxmap = Dict(v=>i for (i, v) in enumerate(vars))

    m, n = length(exprs), length(vars)
    I1 = Int[]
    J1 = Int[]
    V1 = Num[]

    I2 = Int[]
    J2 = Int[]
    V2 = Num[]

    v2_I = Int[]
    v2_V = Num[]

    for (i, d) in enumerate(ds)
        for (k, v) in d
            if pdegree(k) == 1
                push!(I1, i)
                push!(J1, idxmap[k])
                push!(V1, v)
            elseif pdegree(k) == 2
                push!(I2, i)
                if isop(k, ^)
                    b, e = arguments(k)
                    e = unwrap_const(e)
                    @assert e == 2
                    q = idxmap[b]
                    j = div(q*(q+1), 2)
                    push!(J2, j) # or div(q*(q-1), 2) + q
                    push!(V2, v)
                else
                    @assert isop(k, *)
                    a, b = arguments(k)
                    p, q = extrema((idxmap[a], idxmap[b]))
                    j = div(q*(q-1), 2) + p
                    push!(J2, j)
                    push!(V2, v)
                end
                push!(v2_I, j)
                push!(v2_V, k)
            else
                error("This should never happen")
            end
        end
    end


    #v2 = SparseVector(div(n * (n + 1), 2), v2_I, v2_V) # When it works in the future
    # until then
    v2 = zeros(Num, div(n * (n + 1), 2))
    v2[v2_I] .= v2_V

    tuple(sparse(I1,J1,V1, m, n),
          sparse(I2,J2,V2, m, div(n * (n + 1), 2)),
          v2,
          wrap.(nls))
end

isop(x, op) = iscall(x) && operation(x) === op
isop(op) = Base.Fix2(isop, op)

function pdegrees(x)
    x = unwrap(x)
    if ismul(x)
        return x.dict
    elseif isdiv(x)
        num_dict = pdegrees(x.num)
        den_dict = pdegrees(x.den)
        inv_den_dict = Dict(keys(den_dict) .=> map(-, values(den_dict)))
        mergewith(+, num_dict, inv_den_dict)
    elseif ispow(x)
        base, exp = arguments(x)
        dict = pdegrees(base)
        degrees = map(degree -> degree * unwrap_const(exp), values(dict))
        Dict(keys(dict) .=> degrees)
    elseif issym(x) || iscall(x)
        return Dict(x=>1)
    elseif SymbolicUtils.isconst(x) || x isa Number
        return Dict()
    else
        error("pdegrees for $x unknown")
    end
end

pdegree(x::Number) = 0
function pdegree(x)
    degree_dict = pdegrees(x)
    if isempty(degree_dict)
        return 0
    end
    sum(values(degree_dict))
end

"""
$(TYPEDEF)

An inequality relationship between two expressions.

# Fields
$(FIELDS)
"""
struct Inequality
    """The expression on the left-hand side of the inequality."""
    lhs::BasicSymbolic{VartypeT}
    """The expression on the right-hand side of the inequality."""
    rhs::BasicSymbolic{VartypeT}
    """The relational operator of the inequality."""
    relational_op
    function Inequality(lhs, rhs, relational_op)
        new(unwrap(lhs), unwrap(rhs), relational_op)
    end
end

Base.:(==)(a::Inequality, b::Inequality) = isequal(a.lhs, b.lhs) && isequal(a.rhs, b.rhs) && isequal(a.relational_op, b.relational_op)::Bool
Base.hash(a::Inequality, salt::UInt) = hash(a.lhs, hash(a.rhs, hash(a.relational_op, salt)))

@enum RelationalOperator leq geq # strict less than or strict greater than are not supported by any solver

function SymbolicUtils.scalarize(ineq::Inequality)
    if ineq.relational_op == leq
        scalarize(ineq.lhs) ≲ scalarize(ineq.rhs)
    else
        scalarize(ineq.lhs) ≳ scalarize(ineq.rhs)
    end
end

function Base.show(io::IO, ineq::Inequality)
    warn_load_latexify()
    print(io, ineq.lhs, ineq.relational_op == leq ? " ≲ " : " ≳ ", ineq.rhs)
end

"""
$(TYPEDSIGNATURES)

Create an [`Inequality`](@ref) out of two [`Num`](@ref) instances, or an `Num` and a `Number`.
Unicode `≲` can be typed by writing `\\lesssim` then pressing tab in the Julia REPL, and in many editors.

# Examples

```jldoctest
julia> using Symbolics

julia> @variables x y;

julia> x ≲ y
x ≲ y

julia> x - y ≲ 0
x - y ≲ 0
```
"""
function ≲(lhs, rhs) 
    if isarraysymbolic(lhs) || isarraysymbolic(rhs)
        if isarraysymbolic(lhs) && isarraysymbolic(rhs)
            lhs .≲ rhs
        else
            throw(ArgumentError("Cannot relate an array with a scalar. Please use broadcast `.≲`."))
        end
    else
        Inequality(lhs, rhs, leq)
    end
end

"""
$(TYPEDSIGNATURES)

Create an [`Inequality`](@ref) out of two [`Num`](@ref) instances, or an `Num` and a `Number`.
Unicode `≳` can be typed by writing `\\gtrsim` then pressing tab in the Julia REPL, and in many editors.

# Examples

```jldoctest
julia> using Symbolics

julia> @variables x y;

julia> x ≳ y
x ≳ y

julia> x - y ≳ 0
x - y ≳ 0
```
"""
function ≳(lhs, rhs)
    if isarraysymbolic(lhs) || isarraysymbolic(rhs)
        if isarraysymbolic(lhs) && isarraysymbolic(rhs)
            lhs .≳ rhs
        else
            throw(ArgumentError("Cannot relate an array with a scalar. Please use broadcast `.≳`."))
        end
    else
    Inequality(lhs, rhs, geq)
    end
end

function canonical_form(cs::Inequality; form=leq)
    # do we need to flip the operator?
    if cs.relational_op == form
        Inequality(cs.lhs - cs.rhs, 0, cs.relational_op)
    else
        Inequality(-(cs.lhs - cs.rhs), 0, cs.relational_op == leq ? geq : leq)
    end
end

function SymbolicUtils.search_variables!(buffer, ineq::Inequality; kw...)
    search_variables!(buffer, ineq.lhs; kw...)
    search_variables!(buffer, ineq.rhs; kw...)
end

SymbolicUtils.simplify(cs::Inequality; kw...) = 
    Inequality(simplify(cs.lhs; kw...), simplify(cs.rhs; kw...), cs.relational_op)

function (s::SymbolicUtils.Substituter)(x::Inequality)
    Inequality(s(x.lhs), s(x.rhs), x.relational_op)
end

using Test
using Symbolics
using Symbolics: laplace, inverse_laplace
import Nemo, Groebner

@variables t, s
@syms f(t) F(s)

# https://sites.math.washington.edu/~aloveles/Math307Fall2019/m307LaplacePractice.pdf
@test isequal(laplace(exp(4t) + 5, f, t, F, s), 1/(s-4) + 5/s)
@test isequal(laplace(cos(2t) + 7sin(2t), f, t, F, s), s/(s^2 + 4) + 14/(s^2 + 4))
@test isequal(laplace(exp(-2t)*cos(3t) + 5exp(-2t)*sin(3t), f, t, F, s), (s+2)/((s+2)^2 + 9) + 15/((s+2)^2 + 9))
@test isequal(laplace(10 + 5t + t^2 - 4t^3, f, t, F, s), expand(10/s + 5/s^2 + 2/s^3 - 24/s^4))
@test isequal(laplace(exp(3t)*(t^2 + 4t + 2), f, t, F, s), 2/(s-3)^3 + 4/(s-3)^2 + 2/(s-3))
@test isequal(laplace(6exp(5t)*cos(2t) - exp(7t), f, t, F, s), 6(s-5)/((s-5)^2 + 4) + expand(-1/(s-7)))

# https://www.math.lsu.edu/~adkins/m2065/2065s08review2a.pdf
@test isequal(inverse_laplace(7/(s+3)^3, F, s, f, t), (7//2)t^2 * exp(-3t))
@test isequal(inverse_laplace((s-9)/(s^2 + 9), F, s, f, t), cos(3t) - 3sin(3t))
# partial fraction decomposition
@test isequal(inverse_laplace((s+2)/(s^2 - 3s - 4), F, s, f, t), (6//5)*exp(4t) - (1//5)*exp(-t))
@test isequal(inverse_laplace(1/(s^2 - 10s + 9), F, s, f, t), (1//8)*exp(9t) - (1//8)*exp(t))

Dt = Differential(t)
@test_skip isequal(laplace_solve_ode(Dt(f(t)) + 3f(t) ~ t^2*exp(-3t) + t*exp(-2t) + t, f, t, [1]), (1//3)*t^3*exp(-3t) + t*exp(-2t) + (1//3)*t + (19//9)*exp(-3t) - exp(-2t) - 1//9) # generates very large system of equations that solve_interms_ofvar has trouble with
@test isequal(laplace_solve_ode((Dt^2)(f(t)) - 3Dt(f(t)) + 2f(t) ~ 4, f, t, [2, 3]), 2 - 3exp(t) + 3exp(2t))
@test isequal(laplace_solve_ode((Dt^3)(f(t)) - Dt(f(t)) ~ 2, f, t, [4,4,4]), 5exp(t) - exp(-t) - 2t)
@test isequal(laplace_solve_ode((Dt^3)(f(t)) - Dt(f(t)) ~ 6 - 3t^2, f, t, [1, 1, 1]), exp(t) + t^3)
@test isequal(laplace_solve_ode((Dt^2)(f(t)) - f(t) ~ 2sin(t), f, t, [0, 0]), (1//2)exp(t) - (1//2)exp(-t) - sin(t))
@test isequal(laplace_solve_ode((Dt^2)(f(t)) + 2Dt(f(t)) ~ 5f(t), f, t, [0, 0]), 0)
@test isequal(laplace_solve_ode((Dt^2)(f(t)) + f(t) ~ sin(4t), f, t, [0, 0]), (4//15)sin(t) - (1//15)sin(4t))
@test isequal(laplace_solve_ode((Dt^2)(f(t)) + Dt(f(t)) ~ 1 + 2t, f, t, [0, 0]), 1 - exp(-t) + t^2 - t)
@test isequal(laplace_solve_ode((Dt^2)(f(t)) + 4Dt(f(t)) + 3f(t) ~ 6, f, t, [0, 0]), exp(-3t) - 3exp(-t) + 2)
@test isequal(laplace_solve_ode((Dt^2)(f(t)) - 2Dt(f(t)) ~ 3*(t + exp(2t)), f, t, [0, 0]), (3//8) - (3//4)t - (3//4)t^2 - (3//8)exp(2t) + (3//2)t*exp(2t))
@test_broken isequal(laplace_solve_ode((Dt^2)(f(t)) - 2Dt(f(t)) ~ 20*exp(-t)*cos(t), f, t, [0, 0], warns=false), 3exp(2t) - 5 + 2exp(-t)*cos(t) - 4exp(-t)*sin(t)) # irreducible quadratic in inverse laplace
@test isequal(laplace_solve_ode((Dt^2)(f(t)) + f(t) ~ 2 + 2cos(t), f, t, [0, 0]), 2 - 2cos(t) + t*sin(t))
@test isequal(laplace_solve_ode((Dt^2)(f(t)) - Dt(f(t)) ~ 30cos(3t), f, t, [0, 0]), 3exp(t) - 3cos(3t) - sin(3t))

:(function (u,)
      begin
          _out = (zeros)(Float64, (map)(length, (1:5, 1:5)))
          var"%_out" = begin
                  _out_input_1 = begin
                          _out = (zeros)(Float64, (map)(length, (Base.OneTo(5), Base.OneTo(5))))
                          var"%_out" = for var"%jj′" = (zip)(Base.OneTo(5), (Symbolics.reset_to_one)(Base.OneTo(5)))
                                  begin
                                      j = var"%jj′"[1]
                                      j′ = var"%jj′"[2]
                                      for var"%ii′" = (zip)(Base.OneTo(5), (Symbolics.reset_to_one)(Base.OneTo(5)))
                                          begin
                                              i = var"%ii′"[1]
                                              i′ = var"%ii′"[2]
                                              begin
                                                  _out[(CartesianIndex)(i′, j′)] = (+)((getindex)(_out, i′, j′), (getindex)(u, (Main.limit2)((+)(-1, i), 5), (Main.limit2)((+)(1, j), 5)))
                                                  nothing
                                              end
                                          end
                                      end
                                  end
                              end
                          _out
                      end
                  for var"%jj′" = (zip)(Base.OneTo(5), (Symbolics.reset_to_one)(Base.OneTo(5)))
                      begin
                          j = var"%jj′"[1]
                          j′ = var"%jj′"[2]
                          for var"%ii′" = (zip)(Base.OneTo(5), (Symbolics.reset_to_one)(Base.OneTo(5)))
                              begin
                                  i = var"%ii′"[1]
                                  i′ = var"%ii′"[2]
                                  begin
                                      _out[(CartesianIndex)(i′, j′)] = (+)((getindex)(_out, i′, j′), (getindex)(_out_input_1, j, i))
                                      nothing
                                  end
                              end
                          end
                      end
                  end
              end
          _out
      end
  end)

module SymbolicsForwardDiffExt

using ForwardDiff
using ForwardDiff.NaNMath
using ForwardDiff.DiffRules
using ForwardDiff: value, Dual, partials
using Symbolics

# The method generation in this file have been adapted from
# https://github.com/JuliaDiff/ForwardDiff.jl/blob/v0.10.36/src/dual.jl

const AMBIGUOUS_TYPES = (Num,)

####################################
# N-ary Operation Definition Tools #
####################################

macro define_binary_dual_op(f, xy_body, x_body, y_body, Ts)
    FD = ForwardDiff
    defs = quote end
    for R in Ts
        expr = quote
            @inline $(f)(x::$FD.Dual{Tx}, y::$R) where {Tx} = $x_body
            @inline $(f)(x::$R, y::$FD.Dual{Ty}) where {Ty} = $y_body
        end
        append!(defs.args, expr.args)
    end
    return esc(defs)
end

macro define_ternary_dual_op(f, xyz_body, xy_body, xz_body, yz_body, x_body, y_body, z_body, Ts)
    FD = ForwardDiff
    defs = quote end
    for R in Ts
        expr = quote
            @inline $(f)(x::$FD.Dual{Txy}, y::$FD.Dual{Txy}, z::$R) where {Txy} = $xy_body
            @inline $(f)(x::$FD.Dual{Tx}, y::$FD.Dual{Ty}, z::$R)  where {Tx, Ty} = Ty ≺ Tx ? $x_body : $y_body
            @inline $(f)(x::$FD.Dual{Txz}, y::$R, z::$FD.Dual{Txz}) where {Txz} = $xz_body
            @inline $(f)(x::$FD.Dual{Tx}, y::$R, z::$FD.Dual{Tz}) where {Tx,Tz} = Tz ≺ Tx ? $x_body : $z_body
            @inline $(f)(x::$R, y::$FD.Dual{Tyz}, z::$FD.Dual{Tyz}) where {Tyz} = $yz_body
            @inline $(f)(x::$R, y::$FD.Dual{Ty}, z::$FD.Dual{Tz}) where {Ty,Tz} = Tz ≺ Ty ? $y_body : $z_body
        end
        append!(defs.args, expr.args)
        for Q in Ts
            Q === R && continue
            expr = quote
                @inline $(f)(x::$FD.Dual{Tx}, y::$R, z::$Q) where {Tx} = $x_body
                @inline $(f)(x::$R, y::$FD.Dual{Ty}, z::$Q) where {Ty} = $y_body
                @inline $(f)(x::$R, y::$Q, z::$FD.Dual{Tz}) where {Tz} = $z_body
            end
            append!(defs.args, expr.args)
        end
        expr = quote
            @inline $(f)(x::$FD.Dual{Tx}, y::$R, z::$R) where {Tx} = $x_body
            @inline $(f)(x::$R, y::$FD.Dual{Ty}, z::$R) where {Ty} = $y_body
            @inline $(f)(x::$R, y::$R, z::$FD.Dual{Tz}) where {Tz} = $z_body
        end
        append!(defs.args, expr.args)
    end
    return esc(defs)
end

function binary_dual_definition(M, f, Ts)
    FD = ForwardDiff
    dvx, dvy = DiffRules.diffrule(M, f, :vx, :vy)
    Mf = M == :Base ? f : :($M.$f)
    xy_work = FD.qualified_cse!(quote
        val = $Mf(vx, vy)
        dvx = $dvx
        dvy = $dvy
    end)
    dvx, _ = DiffRules.diffrule(M, f, :vx, :y)
    x_work = FD.qualified_cse!(quote
        val = $Mf(vx, y)
        dvx = $dvx
    end)
    _, dvy = DiffRules.diffrule(M, f, :x, :vy)
    y_work = FD.qualified_cse!(quote
        val = $Mf(x, vy)
        dvy = $dvy
    end)
    expr = quote
        @define_binary_dual_op(
            $M.$f,
            begin
                vx, vy = $FD.value(x), $FD.value(y)
                $xy_work
                return $FD.dual_definition_retval(Val{Txy}(), val, dvx, $FD.partials(x), dvy, $FD.partials(y))
            end,
            begin
                vx = $FD.value(x)
                $x_work
                return $FD.dual_definition_retval(Val{Tx}(), val, dvx, $FD.partials(x))
            end,
            begin
                vy = $FD.value(y)
                $y_work
                return $FD.dual_definition_retval(Val{Ty}(), val, dvy, $FD.partials(y))
            end,
            $Ts
        )
    end
    return expr
end

#####################
# Generic Functions #
#####################

# Predicates #
#------------#

for pred in [:isequal, :(==)]
    @eval begin
        @define_binary_dual_op(
            Base.$(pred),
            $(pred)(value(x), value(y)) && $(pred)(partials(x), partials(y)),
            $(pred)(value(x), y)        && iszero(partials(x)),
            $(pred)(x, value(y))        && iszero(partials(y)),
            $AMBIGUOUS_TYPES
        )
    end
end

###################################
# General Mathematical Operations #
###################################

for (M, f, arity) in DiffRules.diffrules(filter_modules = nothing)
    if (M, f) in ((:Base, :^), (:NaNMath, :pow), (:Base, :/), (:Base, :+), (:Base, :-), (:Base, :sin), (:Base, :cos))
        continue  # Skip methods which we define elsewhere.
    elseif !(isdefined(@__MODULE__, M) && isdefined(getfield(@__MODULE__, M), f))
        continue  # Skip rules for methods not defined in the current scope
    end
    if arity == 1
        # no-op
    elseif arity == 2
        eval(binary_dual_definition(M, f, AMBIGUOUS_TYPES))
    else
        # no-op
    end
end

#################
# Special Cases #
#################

# +/- #
#-----#

@eval begin
    @define_binary_dual_op(
        Base.:+,
        begin
            vx, vy = value(x), value(y)
            Dual{Txy}(vx + vy, partials(x) + partials(y))
        end,
        Dual{Tx}(value(x) + y, partials(x)),
        Dual{Ty}(x + value(y), partials(y)),
        $AMBIGUOUS_TYPES
    )
end

@eval begin
    @define_binary_dual_op(
        Base.:-,
        begin
            vx, vy = value(x), value(y)
            Dual{Txy}(vx - vy, partials(x) - partials(y))
        end,
        Dual{Tx}(value(x) - y, partials(x)),
        Dual{Ty}(x - value(y), -partials(y)),
        $AMBIGUOUS_TYPES
    )
end

# / #
#---#

# We can't use the normal diffrule autogeneration for this because (x/y) === (x * (1/y))
# doesn't generally hold true for floating point; see issue #264
@eval begin
    @define_binary_dual_op(
        Base.:/,
        begin
            vx, vy = value(x), value(y)
            Dual{Txy}(vx / vy, _div_partials(partials(x), partials(y), vx, vy))
        end,
        Dual{Tx}(value(x) / y, partials(x) / y),
        begin
            v = value(y)
            divv = x / v
            Dual{Ty}(divv, -(divv / v) * partials(y))
        end,
        $AMBIGUOUS_TYPES
    )
end

# exponentiation #
#----------------#

for (f, log) in ((:(Base.:^), :(Base.log)), (:(NaNMath.pow), :(NaNMath.log)))
    @eval begin
        @define_binary_dual_op(
            $f,
            begin
                vx, vy = value(x), value(y)
                expv = ($f)(vx, vy)
                powval = vy * ($f)(vx, vy - 1)
                if isconstant(y)
                    logval = one(expv)
                elseif iszero(vx) && vy > 0
                    logval = zero(vx)
                else
                    logval = expv * ($log)(vx)
                end
                new_partials = _mul_partials(partials(x), partials(y), powval, logval)
                return Dual{Txy}(expv, new_partials)
            end,
            begin
                v = value(x)
                expv = ($f)(v, y)
                if y == zero(y) || iszero(partials(x))
                    new_partials = zero(partials(x))
                else
                    new_partials = partials(x) * y * ($f)(v, y - 1)
                end
                return Dual{Tx}(expv, new_partials)
            end,
            begin
                v = value(y)
                expv = ($f)(x, v)
                deriv = (iszero(x) && v > 0) ? zero(expv) : expv*($log)(x)
                return Dual{Ty}(expv, deriv * partials(y))
            end,
            $AMBIGUOUS_TYPES
        )
    end
end

# hypot #
#-------#

@eval begin
    @define_ternary_dual_op(
        Base.hypot,
        calc_hypot(x, y, z, Txyz),
        calc_hypot(x, y, z, Txy),
        calc_hypot(x, y, z, Txz),
        calc_hypot(x, y, z, Tyz),
        calc_hypot(x, y, z, Tx),
        calc_hypot(x, y, z, Ty),
        calc_hypot(x, y, z, Tz),
        $AMBIGUOUS_TYPES
    )
end

# muladd #
#--------#

@eval begin
    @define_ternary_dual_op(
        Base.muladd,
        calc_muladd_xyz(x, y, z),                         # xyz_body
        calc_muladd_xy(x, y, z),                          # xy_body
        calc_muladd_xz(x, y, z),                          # xz_body
        Base.muladd(y, x, z),                             # yz_body
        Dual{Tx}(muladd(value(x), y, z), partials(x) * y), # x_body
        Base.muladd(y, x, z),                             # y_body
        Dual{Tz}(muladd(x, y, value(z)), partials(z)),     # z_body
        $AMBIGUOUS_TYPES
    )
end

end

using Symbolics, SparseArrays, LinearAlgebra, Test
using ReferenceTests
using Symbolics: value
using SymbolicUtils.Code: DestructuredArgs, Func, NameState, Let, cse
@variables a b c1 c2 c3 d e g
oop, iip = Symbolics.build_function([sqrt(a), sin(b)], [a, b], nanmath = true)
oop = eval(oop)
@test all(isnan, @invokelatest oop([-1, Inf]))
out = [0, 0.0]
iip = eval(iip)
@invokelatest iip(out, [-1, Inf])
@test all(isnan, out)

# Multiple argument matrix
h = [a + b + c1 + c2,
     c3 + d + e + g,
     0] # uses the same number of arguments as our application
h_julia(a, b, c, d, e, g) = [a[1] + b[1] + c[1] + c[2],
                             c[3] + d[1] + e[1] + g[1],
                             0]
function h_julia!(out, a, b, c, d, e, g)
    out .= [a[1] + b[1] + c[1] + c[2], c[3] + d[1] + e[1] + g[1], 0]
end

h_str = Symbolics.build_function(h, [a], [b], [c1, c2, c3], [d], [e], [g])
h_str2 = Symbolics.build_function(h, [a], [b], [c1, c2, c3], [d], [e], [g])
@test h_str[1] == h_str2[1]
@test h_str[2] == h_str2[2]

h_oop = eval(h_str[1])
h_str_par = Symbolics.build_function(h, [a], [b], [c1, c2, c3], [d], [e], [g], parallel=Symbolics.MultithreadedForm())
h_str_3 = Symbolics.build_function(h, [a], [b], [c1, c2, c3], [d], [e], [g], iip_config = (false, true))
h_str_4 = Symbolics.build_function(h, [a], [b], [c1, c2, c3], [d], [e], [g], iip_config = (true, false))

@test contains(repr(h_str_par[1]), "schedule")
@test contains(repr(h_str_par[2]), "schedule")
h_oop_par = eval(h_str_par[1])
h_par_rgf = Symbolics.build_function(h, [a], [b], [c1, c2, c3], [d], [e], [g], parallel=Symbolics.MultithreadedForm(), expression=false)
h_ip! = eval(h_str[2])
h_ip_skip! = eval(Symbolics.build_function(h, [a], [b], [c1, c2, c3], [d], [e], [g], skipzeros=true, fillzeros=false)[2])
h_ip_skip_par! = eval(Symbolics.build_function(h, [a], [b], [c1, c2, c3], [d], [e], [g], skipzeros=true, parallel=Symbolics.MultithreadedForm(), fillzeros=false)[2])
h3_oop = let f = eval(h_str_3[1])
    (args...) -> @invokelatest f(args...)
end
h3_ip = let f = eval(h_str_3[2])
    (args...) -> @invokelatest f(args...)
end
h4_oop = let f = eval(h_str_4[1])
    (args...) -> @invokelatest f(args...)
end
h4_ip = let f = eval(h_str_4[2])
    (args...) -> @invokelatest f(args...)
end
inputs = ([1], [2], [3, 4, 5], [6], [7], [8])

@test h_oop(inputs...) == h_julia(inputs...)
@test h_oop_par(inputs...) == h_julia(inputs...)
@test h_par_rgf[1](inputs...) == h_julia(inputs...)
out_1 = similar(h, Int)
out_2 = similar(out_1)
h_ip!(out_1, inputs...)
h_julia!(out_2, inputs...)
@test_throws ArgumentError h3_oop(inputs...)
@test out_1 == out_2
h3_ip(out_1, inputs...)
@test out_1 == out_2
@test_throws ArgumentError h4_ip(out_1, inputs...)
@test h4_oop(inputs...) == h_julia(inputs...)
out_1 = similar(h, Int)
h_par_rgf[2](out_1, inputs...)
@test out_1 == out_2
fill!(out_1, 10)
h_ip_skip!(out_1, inputs...)
@test out_1[3] == 10
out_1[3] = 0
@test out_1 == out_2

fill!(out_1, 10)
h_ip_skip_par!(out_1, inputs...)
@test out_1[3] == 10
out_1[3] = 0
@test out_1 == out_2

# Multiple input matrix, some unused arguments
h_skip = [a + b + c1; c2 + c3 + g] # skip d, e
h_julia_skip(a, b, c, d, e, g) = [a[1] + b[1] + c[1]; c[2] + c[3] + g[1]]
function h_julia_skip!(out, a, b, c, d, e, g)
    out .= [a[1] + b[1] + c[1]; c[2] + c[3] + g[1]]
end

h_str_skip = Symbolics.build_function(h_skip, [a], [b], [c1, c2, c3], [], [], [g], checkbounds=true)
h_str_skip_cse = Symbolics.build_function(h_skip, [a], [b], [c1, c2, c3], [], [], [g], checkbounds=true, cse=true)
h_oop_skip = let f = eval(h_str_skip[1])
    (args...) -> @invokelatest f(args...)
end
h_ip!_skip = let f = eval(h_str_skip[2])
    (args...) -> @invokelatest f(args...)
end
h_oop_skip_cse = let f = eval(h_str_skip_cse[1])
    (args...) -> @invokelatest f(args...)
end
h_ip!_skip_cse = let f = eval(h_str_skip_cse[2])
    (args...) -> @invokelatest f(args...)
end
inputs_skip = ([1], [2], [3, 4, 5], [], [], [8])

@test h_oop_skip(inputs_skip...) == h_julia_skip(inputs_skip...) == h_oop_skip_cse(inputs_skip...)
out_1_skip = Array{Int64}(undef, 2)
out_2_skip = similar(out_1_skip)
h_ip!_skip(out_1_skip, inputs_skip...)
h_julia_skip!(out_2_skip, inputs_skip...)
@test out_1_skip == out_2_skip

# Same as above, except test ability to call with non-matrix arguments (i.e., for `nt`)
inputs_skip_2 = ([1], [2], [3, 4, 5], [], (a = 1, b = 2), [8])
@test h_oop_skip(inputs_skip_2...) == h_julia_skip(inputs_skip_2...)
out_1_skip_2 = Array{Int64}(undef, 2)
out_2_skip_2 = similar(out_1_skip_2)
h_ip!_skip(out_1_skip_2, inputs_skip_2...)
h_julia_skip!(out_2_skip_2, inputs_skip_2...)
@test out_1_skip_2 == out_2_skip_2

# Multiple input scalar
h_scalar = a + b + c1 + c2 + c3 + d + e + g
h_julia_scalar(a, b, c, d, e, g) = a[1] + b[1] + c[1] + c[2] + c[3] + d[1] + e[1] + g[1]
h_str_scalar = Symbolics.build_function(h_scalar, [a], [b], [c1, c2, c3], [d], [e], [g])
h_str_scalar2 = Symbolics.build_function(h_scalar, [a], [b], [c1, c2, c3], [d], [e], [g])
h_str_scalar_cse = Symbolics.build_function(h_scalar, [a], [b], [c1, c2, c3], [d], [e], [g], cse=true)
@test h_str_scalar == h_str_scalar2

h_oop_scalar = let f = eval(h_str_scalar)
    (args...) -> f(args...)
end
h_oop_scalar_cse = let f = eval(h_str_scalar_cse)
    (args...) -> f(args...)
end
@test h_oop_scalar(inputs...) == h_julia_scalar(inputs...) == h_oop_scalar_cse(inputs...)

@variables z[1:100]
@variables t x(t) y(t) k
f = let _f = eval(build_function((x+y)/k, [x,y,k]))
    (args...) -> @invokelatest _f(args...)
end
@test f([1,1,2]) == 1

f = let _f = eval(build_function([(x+y)/k], [x,y,k])[1])
    (args...) -> @invokelatest _f(args...)
end
@test f([1,1,2]) == [1]

f = let _f = eval(build_function([(x+y)/k], [x,y,k])[2])
    (args...) -> @invokelatest _f(args...)
end
z = [0.0]
f(z, [1,1,2])
@test z == [1]

f = let _f = eval(build_function(sparse([1],[1], [(x+y)/k], 10,10), [x,y,k])[1])
    (args...) -> @invokelatest _f(args...)
end

@test size(f([1.,1.,2])) == (10,10)
@test f([1.,1.,2])[1,1] == 1.0
@test sum(f([1.,1.,2])) == 1.0

# Reshaped SparseMatrix optimization
let
    @variables a b c

    x = reshape(sparse([0 a 0; 0 b c]), 3, 2)
    f1,f2=build_function(x, [a,b,c], expression=Val{false})
    y = f1([1,2,3])
    @test y isa Base.ReshapedArray
    @test y.parent isa SparseMatrixCSC
    @test y.parent.rowval == x.parent.rowval
    @test y == [0 2; 0 0; 1 3]

    f1,f2=build_function(@views(x[2:3,1:2]), [a,b,c], expression=Val{false})
    y = f1([1,2,3])
    @test y isa SparseMatrixCSC
    @test y == [0 0; 1 3]
end

let # ModelingToolkit.jl#800
    @variables x
    y = sparse(1:3,1:3,x)

    f1,f2 = build_function(y,x)
    sf1, sf2 = string(f1), string(f2)
    @test !contains(sf1, "CartesianIndex")
    @test !contains(sf2, "CartesianIndex")
    @test contains(sf2, ".nzval")
end

let # Symbolics.jl#123
    ns = 6
    @variables x[1:ns]
    @variables u
    @variables M[1:36]
    @variables qd[1:6]
    output_eq = u*(qd[1]*(M[1]*qd[1] + M[7]*qd[2]))

    @test_reference "target_functions/issue123.c" build_function(output_eq, x, target=Symbolics.CTarget())
end

using Symbolics: value
using SymbolicUtils.Code: Func, toexpr
@variables t x(t)
D = Differential(t)
expr = toexpr(Func([value(D(x))], [], value(D(x))))
@test expr.args[2].args[end] == expr.args[1].args[1] # check function body and function arg
@test expr.args[2].args[end] == :(var"Differential(t, 1)(x(t))")

## Oop Arr case:
#

a = rand(4)
@variables x[1:4]
f = eval(build_function(sin.(cos.(x)), cos.(x))[1])
@test @invokelatest(f(a)) == sin.(a)

# more skipzeros
@variables x,y
f = [0, x]
f_expr = build_function(f, [x,y];skipzeros=true, expression = Val{false})

out = Vector{Float64}(undef, 2)
u = [5.0, 3.1]
@test f_expr[1](u) == [0, 5]
old = out[1]
f_expr[2](out, u)
@test out[1] === old
@test out[2] === u[1]


let # issue#136
    N = 8
    @variables x y
    A = sparse(Tridiagonal([x^i for i in 1:N-1],
                           [x^i * y^(8-i) for i in 1:N],
                           [y^i for i in 1:N-1]))

    val = Dict(x=>1, y=>2)
    B = map(A) do e
        Num(substitute(e, val))::Num
    end

    C = copy(B) - 100*I
    C_2 = copy(C);

    f = build_function(A,[x,y],parallel=Symbolics.MultithreadedForm())[2]
    g = eval(f)
    f_cse = build_function(A,[x,y],parallel=Symbolics.MultithreadedForm(),cse=true)[2]
    g_cse = eval(f_cse)

    @invokelatest g(C, [1,2])
    @test contains(repr(f), "schedule")
    @test isequal(C, B)
    @invokelatest g_cse(C_2, [1,2])
    @test isequal(C_2, B)
end


let #issue#587
    using Symbolics, SparseArrays

    N = 100 # try with N = 5 and N = 100
    _S = sprand(N, N, 0.1)
    _Q = Array(sprand(N, N, 0.1))

    F(z) = [
            collect(_S * z)
            collect(_Q * z.^2)
           ]

    Symbolics.@variables z[1:N]

    sj = Symbolics.sparsejacobian(F(z), z)

    f_expr = build_function(sj, z)
    myf = eval(first(f_expr))
    J = @invokelatest myf(rand(N))

    @test typeof(J) <: SparseMatrixCSC
    @test nnz(J) == nnz(sj)
end

# test header wrapping of scalar build function
let
    @variables x p t
    ex = t + p * x^2
    integrator = gensym(:MTKIntegrator)
    header = expr -> let integrator = integrator
        Func([expr.args[1], expr.args[2], DestructuredArgs(expr.args[3:end], integrator,
                                                           inds = [:p])], [], expr.body)
    end
    f = build_function(ex, [value(x)], value(t), [value(p)]; expression = Val{false},
                                                                wrap_code = header)
    p = (a = 10, p = [2])
    @test f([3], 1, p) == 19
end

let #658
    using Symbolics
    @variables a, X1[1:3], X2[1:3]
    k = eval(build_function(a * X1 + X2, X1, X2, a)[1])
    @test @invokelatest(k(ones(3), ones(3), 1.5)) == [2.5, 2.5, 2.5]
end

@testset "ArrayOp codegen" begin
    @variables x[1:2]
    T = value(x .^ 2)
    @test_nowarn toexpr(T, NameState())
end

@testset "`similarto` keyword argument" begin
    @variables x[1:2]
    T = collect(value(x .^ 2))
    fn = build_function(T, collect(x); expression = false)[1]
    @test_throws MethodError fn((1.0, 2.0))
    fn = build_function(T, collect(x); similarto = Array, expression = false)[1]
    @test fn((1.0, 2.0)) ≈ [1.0, 4.0]
end

@testset "`build_function` with array symbolics" begin
    @variables x[1:4]
    for var in [x[1:2], x[1:2] .+ 0.0, Symbolics.unwrap(x[1:2])]
        foop, fiip = build_function(var[1:2], x; expression = false)
        @test foop(ones(4)) ≈ ones(2)
        buf = zeros(2)
        fiip(buf, ones(4))
        @test buf ≈ ones(2)
    end
end

@testset "cse with arrayops" begin
    @variables x[1:3] y f(..)
    t = x .+ y
    t = t .* f(t)
    res = cse(value(t))
    @test res isa Let
    @test !isempty(res.pairs)
end

@testset "`CallWithMetadata` in `DestructuredArgs` with `create_bindings = false`" begin
    @variables x f(..)
    fn = build_function(f(x), DestructuredArgs([f]; create_bindings = false), x; expression = Val{false})
    @test fn([isodd], 3)
end

@testset "iip_config with RGF" begin
    @variables a b
    oop, iip = build_function([a + b, a - b], a, b; iip_config = (false, false), expression = Val{false})
    @test_throws ArgumentError oop(1, 2)
    @test_throws ArgumentError iip(ones(2), 1, 2)

    @variables a[1:2]
    oop, iip = build_function(a .* 2, a; iip_config = (false, false), expression = Val{false})
    @test_throws ArgumentError oop(ones(2))
    @test_throws ArgumentError iip(ones(2), ones(2))
end

@testset "unwrapping/CSE in array of symbolics codegen" begin
    @variables a b
    oop, _ = build_function([a^2 + b^2, a^2 + b^2], a, b; expression = Val{true}, cse = true)

    function find_create_array(expr)
        while expr isa Expr && (!Meta.isexpr(expr, :call) || expr.args[1] != SymbolicUtils.Code.create_array)
            expr = expr.args[end]
        end
        return expr
    end

    expr = find_create_array(oop)
    # CSE works, we just need to test that it's happening and OOP is the easiest way to do it
    @test Meta.isexpr(expr, :call) && expr.args[1] == SymbolicUtils.Code.create_array &&
          expr.args[end] isa Symbol && expr.args[end-1] isa Symbol
end

@testset "CSE with operators" begin
    @variables t x(t)
    D = Differential(t)
    f = build_function(x + D(x), [x, D(x)]; cse = true, expression = Val{false})
    @test f([1, 2]) == 3
end

@testset "`build_function` with `UpperTriangular`" begin
    function f_test(J,u)
        J[1,1] = u[1]
        J[1,2] = u[2]
        J[2,1] = -u[1]
        J[2,2] = -u[2]
        return nothing
    end

    @variables u[1:2]
    J = fill!(Array{Num}(undef, 2, 2), 0)
    f_test(J, u)
    up_J = UpperTriangular(J - Diagonal(J))

    out, fjac_upper_expr = build_function(up_J, u; skipzeros = true, expression = false)
    Jtmp = UpperTriangular(zeros(2, 2))
    utmp = rand(2)
    @test_nowarn fjac_upper_expr(Jtmp, utmp)
    @test Jtmp[3] == utmp[2]
end

using SymbolicIndexingInterface
using Symbolics

struct FakeIntegrator{P}
    p::P
end

SymbolicIndexingInterface.symbolic_container(fp::FakeIntegrator) = fp.sys
SymbolicIndexingInterface.parameter_values(fp::FakeIntegrator) = fp.p

@variables a[1:2] b
sys = SymbolCache([:x, :y, :z], [a[1], a[2], b], [:t])
p = [1.0, 2.0, 3.0]
fi = FakeIntegrator(copy(p))
for (i, sym) in [(1, a[1]), (2, a[2]), (3, b), ([1,2], a), ([1, 3], [a[1], b]), ((2, 3), (a[2], b))]
    get = getp(sys, sym)
    set! = setp(sys, sym)
    true_value = i isa Tuple ? getindex.((p,), i) : p[i]
    @test get(fi) == true_value
    set!(fi, 0.5 .* i)
    @test get(fi) == 0.5 .* i
    set!(fi, true_value)
end

"""
    SymbolicsSparsityDetector <: ADTypes.AbstractSparsityDetector

Sparsity detection algorithm based on the [Symbolics.jl tracing system](https://symbolics.juliasymbolics.org/stable/manual/sparsity_detection/).

This type makes Symbolics.jl compatible with the [ADTypes.jl sparsity detection framework](https://sciml.github.io/ADTypes.jl/stable/#Sparsity-detector). The following functions are implemented:

- `ADTypes.jacobian_sparsity` based on [`Symbolics.jacobian_sparsity`](@ref)
- `ADTypes.hessian_sparsity` based on [`Symbolics.hessian_sparsity`](@ref)

# Reference

> [Sparsity Programming: Automated Sparsity-Aware Optimizations in Differentiable Programming](https://openreview.net/forum?id=rJlPdcY38B), Gowda et al. (2019)
"""
struct SymbolicsSparsityDetector <: ADTypes.AbstractSparsityDetector end

function ADTypes.jacobian_sparsity(f, x::AbstractArray, ::SymbolicsSparsityDetector)
    y = similar(f(x))
    f!(y, x) = copyto!(y, f(x))
    return jacobian_sparsity(f!, y, x)
end

function ADTypes.jacobian_sparsity(f!, y::AbstractArray, x::AbstractArray, ::SymbolicsSparsityDetector)
    f!_vec(y_vec, x_vec) = f!(reshape(y_vec, size(y)), reshape(x_vec, size(x)))
    return jacobian_sparsity(f!_vec, vec(y), vec(x))
end

function ADTypes.hessian_sparsity(f, x::AbstractArray, ::SymbolicsSparsityDetector)
    f_vec(x_vec) = f(reshape(x_vec, size(x)))
    return hessian_sparsity(f_vec, vec(x))
end

using Symbolics
using Symbolics: value, unwrap
import SymbolicUtils as SU
using LinearAlgebra
using Test

@variables t p(t) x y(t)
D = Differential(t)

# Test division by zero gives a NaN
# https://github.com/JuliaSymbolics/Symbolics.jl/issues/1540
@test value(Symbolics.symbolic_linear_solve((x~0), y)) === NaN

expr = x * p + y * (1 - p) ~ 0
sol = Symbolics.symbolic_linear_solve(expr, p)
@test sol isa Num
@test isequal(sol, y/(y - x))
a, b, islinear = Symbolics.linear_expansion(expr, p)
@test eltype((a, b)) <: Num
@test isequal((a, b, islinear), (-(x - y), -y, true))
@test isequal(unwrap_const(unwrap(Symbolics.symbolic_linear_solve(x * p ~ 0, p))), 0)
@test_throws Any Symbolics.symbolic_linear_solve(1/x + p * p/x ~ 0, p)
@test isequal(Symbolics.symbolic_linear_solve(x * y ~ p, x), p / y)
@test isequal(Symbolics.symbolic_linear_solve(x * -y ~ p, y), -p / x)
@test isequal(Symbolics.symbolic_linear_solve(x * y ~ p, p), x * y)
@test isequal(Symbolics.symbolic_linear_solve(x^2 * y ~ p, y), p / x^2)
@test isequal(Symbolics.symbolic_linear_solve(x^2 * y ~ p, p), x^2 * y)
@test_throws Any Symbolics.symbolic_linear_solve(x^2 * y - sin(p) ~ p, p)
@test Symbolics.symbolic_linear_solve(x^2 * y - sin(p) ~ p, p, check=false) === nothing
@test_throws Any Symbolics.symbolic_linear_solve(t*D(x) ~ y, t)
@test isequal(Symbolics.symbolic_linear_solve(t*D(x) ~ y, D(x)), y/t)
@test isequal(Symbolics.symbolic_linear_solve([t*D(x) ~ y], [D(x)]), [y/t])
@test isequal(Symbolics.symbolic_linear_solve(t*D(x) ~ y, y), t*D(x))
Dx = D(x)
expr = Dx * x + Dx*t - 2//3*x + y*Dx
a, b, islinear = Symbolics.linear_expansion(expr, x)
@test iszero(expand(a * x + b - expr))
@test isequal(Symbolics.symbolic_linear_solve(expr ~ Dx, Dx), (-2//3*x)/(1 - t - x - y))
@test isequal(Symbolics.symbolic_linear_solve(expr ~ Dx, x), (t*Dx + y*Dx - Dx) / ((2//3) - Dx))

exprs = [
 3//2*x + 2y + 10
 7x + 3y - 8
]
xs = [x, y]
A, b, islinear = Symbolics.linear_expansion(exprs, xs)
@test islinear
@test isequal(unwrap_const.(unwrap.(A)), [3//2 2; 7 3])
@test isequal(unwrap_const.(unwrap.(b)), [10; -8])

@variables x y z
eqs = [
        2//1 * x + y - z ~ 2//1
        2//1 + y - z ~ 3//1*x
        2//1 + y - 2z ~ 3//1*z
      ]
@test unwrap_const.(unwrap.([2 1 -1; -3 1 -1; 0 1 -5] * Symbolics.symbolic_linear_solve(eqs, [x, y, z]))) ≈ [2; -2; -2]
@test isequal(Symbolics.symbolic_linear_solve(2//1*x + y - 2//1*z ~ 9//1*x, 1//1*x), (y - 2//1*z) / 7)
@test isequal(Symbolics.symbolic_linear_solve(x + y ~ 0, x), Symbolics.symbolic_linear_solve([x + y ~ 0], x))
@test isequal(Symbolics.symbolic_linear_solve([x + y ~ 0], [x]), Symbolics.symbolic_linear_solve(x + y ~ 0, [x]))
@test isequal(Symbolics.symbolic_linear_solve(2x/z + sin(z), x), sin(z) / (-2 / z))

@testset "linear_expansion with array variables" begin
    @variables x[1:2] y[1:2] z(..)
    @test !Symbolics.linear_expansion(z(x) + x[1], x[1])[3]
    @test !Symbolics.linear_expansion(z(x[1]) + x[1], x[1])[3]
    a, b, islin = Symbolics.linear_expansion(z(x[2]) + x[1], x[1])
    @test islin && isequal(value(a), 1) && isequal(value(b), z(x[2]))
    a, b, islin = Symbolics.linear_expansion((x + x)[1], x[1])
    @test islin && isequal(value(a), 2) && isequal(value(b), 0)
    a, b, islin = Symbolics.linear_expansion(y[1], x[1])
    @test islin && isequal(value(a), 0) && isequal(value(b), y[1])
    @test !Symbolics.linear_expansion(z([x...]), x[1])[3]
    @test !Symbolics.linear_expansion(z(collect(Symbolics.unwrap(x))), x[1])[3]
    @test !Symbolics.linear_expansion(z([x, 2x]), x[1])[3]

    @variables x[0:2]
    a, b, islin = Symbolics.linear_expansion(x[0] - z(x[1]), z(x[1]))
    @test islin && isequal(a, -1) && isequal(b, x[0])

    @variables x::Vector{Real}
    a, b, islin = Symbolics.linear_expansion(x[0] - z(x[1]), z(x[1]))
    @test islin && isequal(a, -1) && isequal(b, x[0])

    @variables x y
    @test !Symbolics.linear_expansion(x + z([x, y]), y)[3]
end

@testset "linear_expansion of ifelse" begin
    @variables p
    a, b, islin = Symbolics.linear_expansion(ifelse(p < 1, 2p + 1, 3p + 2), p)
    @test islin
    @test isequal(a, ifelse(p < 1, 2, 3))
    @test isequal(b, ifelse(p < 1, 1, 2))

    a, b, islin = Symbolics.linear_expansion(ifelse(p < 1, 2p, 3p), p)
    @test islin
    @test isequal(a, ifelse(p < 1, 2, 3))
    @test isequal(b, 0)

    a, b, islin = Symbolics.linear_expansion(ifelse(p < 1, 2p, 2p + 1), p)
    @test islin
    @test isequal(a, 2)
    @test isequal(b, ifelse(p < 1, 0, 1))

    @test !Symbolics.linear_expansion(ifelse(p < 1, p^2, 2p), p)[3]
    @test !Symbolics.linear_expansion(ifelse(p < 1, 2p, p^2), p)[3]

    @testset "Strict mode" begin
        lex = Symbolics.LinearExpander(p; strict = true)
        @test !lex(ifelse(p < 1, 1, 2))[3]
    end
end

@testset "`linear_expansion` of `LinearAlgebra.dot`" begin
    @variables a b c d
    arr1 = Symbolics.SConst([a, b])
    arr2 = Symbolics.SConst([c, d])
    ex = dot(Symbolics.SConst([arr1, arr2]), [[1, 2], [3, 4]])
    @test isequal(
        Symbolics.scalarize(Symbolics.linear_expansion(ex, a)), 
        (Symbolics.SConst(1), 2b + dot(arr2, [3, 4]), true)
    )
    @test isequal(
        Symbolics.scalarize(Symbolics.linear_expansion(ex, b)), 
        (Symbolics.SConst(2), a + dot(arr2, [3, 4]), true)
    )
    @test isequal(
        Symbolics.scalarize(Symbolics.linear_expansion(ex, c)), 
        (Symbolics.SConst(3), 4d + dot(arr1, [1, 2]), true)
    )
    @test isequal(
        Symbolics.scalarize(Symbolics.linear_expansion(ex, d)),
        (Symbolics.SConst(4), 3c + dot(arr1, [1, 2]), true)
    )
end

@testset "`linear_expansion` of multiplication when multiplicand is singular" begin
    @variables x y

    ex = y * (3 * (x + y) - 3x)
    @test SU.query(isequal(x), unwrap(ex))
    @test isequal(expand(ex), 3y^2)
    a, b, islin = Symbolics.linear_expansion(ex, x)
    @test isequal(a, 0)
    @test isequal(b, 3y^2)
    @test islin

    # Also test case when expression itself is not singular, but a term is
    ex = y * (3 * (x + y) - 3x) * (x + 3)
    @test isequal(expand(ex), 3y^2 * x + 9y^2)
    a, b, islin = Symbolics.linear_expansion(ex, x)
    @test isequal(a, 3y^2)
    @test isequal(b, 9y^2)
    @test islin
end

matmulwrapper(a, b) = a * b
@register_array_symbolic matmulwrapper(a::AbstractMatrix{Real}, b::AbstractVector{Real}) begin
    size = size(b)
    eltype = eltype(a)
    ndims = 1
end

@testset "`linear_expansion` with `@register_array_symbolic`" begin
    @variables x[1:3] p[1:3, 1:3]
    ex = matmulwrapper(p, x)
    @test !Symbolics.linear_expansion(ex[1], x[1])[3]
end

# Alex: make sure `Num`s are not processed here as they'd break it.
_postprocess_root(x) = x

function _postprocess_root(x::Number)
    # N // 1 => N
    if x isa Rational
        if isone(denominator(x))
            return numerator(x)
        end
    end

    # N//1 + M//1*im => N + M*im
    if x isa Complex{Rational{T}} where {T <: Integer}
        if isone(denominator(real(x))) && isone(denominator(imag(x)))
            return numerator(real(x)) + numerator(imag(x))*im
        end
    end

    # A + im*0 => A
    if x isa Complex
        if iszero(imag(x))
            # Alex: maybe return _postprocess_root(real(x))
            return real(x)
        end
    end

    return x
end

function _postprocess_root(x::SymbolicUtils.BasicSymbolic)
    !iscall(x) && return x

    x = Symbolics.term(operation(x), map(_postprocess_root, arguments(x))...)
    oper = operation(x)

    # sqrt(0), cbrt(0) => 0
    # sqrt(1), cbrt(1) => 1
    if (oper === sqrt || oper === cbrt || oper === ssqrt ||
        oper === scbrt)
        arg = arguments(x)[1]
        if isequal(arg, 0) || isequal(arg, 1)
            return arg
        end
    end

    args = arguments(x)

    # (X)^0 => 1
    if oper === (^) && isequal(args[2], 0) && !isequal(args[1], 0)
        return 1
    end

    # (X)^1 => X
    if oper === (^) && isequal(args[2], 1)
        return args[1]
    end

    # (0)^X => 0
    if oper === (^) && isequal(args[1], 0) && !isequal(args[2], 0)
        return 0
    end

    # y / 0 => Inf
    if oper === (/) && !isequal(numerator(x), 0) && isequal(denominator(x), 0)
        return Inf
    end

    # sqrt((N / D)^2 * M) => N / D * sqrt(M)
    if (oper === sqrt || oper === ssqrt)
        function squarefree_decomp(x::Integer)
            square, squarefree = big(1), big(1)
            for (p, d) in collect(Primes.factor(abs(x)))
                q, r = divrem(d, 2)
                square *= p^q
                squarefree *= p^r
            end
            square, squarefree
        end
        arg = arguments(x)[1]
        if arg isa Integer
            square, squarefree = squarefree_decomp(arg)
            if arg < 0
                square = im * square
            end
            if !isone(square)
                return square * Symbolics.term(Symbolics.operation(x), squarefree)
            end
        elseif arg isa Rational
            n, d = numerator(arg), denominator(arg)
            n_square, n_squarefree = squarefree_decomp(n)
            if n < 0
                n_square = im * n_square
            end
            d_square, d_squarefree = squarefree_decomp(d)
            nd_square = n_square // d_square
            nd_squarefree = n_squarefree // d_squarefree
            if !isone(nd_square)
                return nd_square * Symbolics.term(Symbolics.operation(x), nd_squarefree)
            end
        end
    end

    # (sqrt(N))^M => N^div(M, 2)*sqrt(N)^(mod(M, 2))
    if oper === (^)
        arg1, arg2 = arguments(x)
        if iscall(arg1) && (operation(arg1) === sqrt || operation(arg1) === ssqrt)
            if arg2 isa Integer
                isequal(arg2, 2) && return arguments(arg1)[1]
                q, r = divrem(arg2, 2)
                if isequal(r, 1)
                    return arguments(arg1)[1]^q * arg1
                else
                    return arguments(arg1)[1]^q
                end
            end
        end
    end

    x = convert_consts(x)

    if oper === (+)
        args = arguments(x)
        for arg in args
            if isequal(arg, 0)
                after_removing = setdiff(args, arg)
                isone(length(after_removing)) && return after_removing[1]
                return Symbolics.term(+, after_removing)
            end
        end
    end

    return x
end

function postprocess_root(x)
    math_consts = (Base.MathConstants.pi, Base.MathConstants.e)
    while true
        old_x = deepcopy(x)
        contains_math_const = any([Symbolics.n_occurrences(x, c) > 0 for c in math_consts])
        if contains_math_const
            x = _postprocess_root(x)
        else
            x = x |> expand |> _postprocess_root |> expand
        end
        isequal(typeof(old_x), typeof(x)) && isequal(old_x, x) && return x
    end
    x # unreachable
end


inv_exacts = [0, Symbolics.term(*, pi),
        Symbolics.term(/,pi,3),
        Symbolics.term(/, pi, 2),
        Symbolics.term(/, Symbolics.term(*, 2, pi), 3),
        Symbolics.term(/, pi, 6),
        Symbolics.term(/, Symbolics.term(*, 5, pi), 6),
        Symbolics.term(/, pi, 4)
]
inv_evald = Symbolics.symbolic_to_float.(inv_exacts)

const inv_pairs = collect(zip(inv_exacts, inv_evald))
"""
    function convert_consts(x)
This function takes BasicSymbolic terms as input (x) and attempts
to simplify these basic symbolic terms using known values.
Currently, this function only supports inverse trigonometric functions.

## Examples
```jldoctest
julia> Symbolics.convert_consts(Symbolics.term(acos, 0))
π / 2

julia> Symbolics.convert_consts(Symbolics.term(atan, 0))
0

julia> Symbolics.convert_consts(Symbolics.term(atan, 1))
π / 4
```
"""
function convert_consts(x)
    !iscall(x) && return x

    oper = operation(x)
    inv_opers = [asin, acos, atan]

    if any(isequal(oper, o) for o in inv_opers) && isempty(Symbolics.get_variables(x))
        val = Symbolics.symbolic_to_float(x)
        for (exact, evald) in inv_pairs
            if isapprox(evald, val)
                return exact
            elseif isapprox(-evald, val)
                return -exact
            end
        end
    end

    # add [sin, cos, tan] simplifications in the future?
    return x
end

using Symbolics, Lux, Random, Test
using ComponentArrays

@testset "Dense" begin
    model = Dense(5, 6)
    rng = Random.default_rng()
    x = randn(rng, Float32, 5)
    ps, _ = LuxCore.setup(rng, model)

    ca = ComponentArray(ps)
    Symbolics.@variables sym_ca[1:length(ca)] = ca
    Symbolics.@variables sym_ps::typeof(ps) = ps
    Symbolics.@variables sym_x[1:5] = Float32[1,2,3,4,5]
    Symbolics.@variables sym_model::typeof(model) = model

    out_ref = LuxCore.stateless_apply(model, x, ps)
    @test out_ref isa Vector{Float32}

    out = LuxCore.stateless_apply(model, sym_x, ps)
    # if the symbolic function regstration wouldn't work, we'd get the
    # vector propagated through the neural network and get a Vector{Num}
    @test out isa Symbolics.Arr
    @test length(out) == 6
    # test that we  can recover the same value as when using concrete numbers
    out_sub = Symbolics.value.(Symbolics.substitute.(Symbolics.scalarize(out), (Dict(sym_x => x),)))
    @test out_sub == out_ref

    out = LuxCore.stateless_apply(model, sym_x, sym_ps)
    @test out isa Symbolics.Arr
    @test length(out) == 6
    out_sub = Symbolics.value.(Symbolics.substitute.(Symbolics.scalarize(out), (Dict(sym_x => x, sym_ps => ps),)))
    @test out_sub == out_ref

    out = LuxCore.stateless_apply(model, sym_x, ca)
    @test out isa Symbolics.Arr
    @test length(out) == 6
    out_sub = Symbolics.value.(Symbolics.substitute.(Symbolics.scalarize(out), (Dict(sym_x => x,),)))
    @test out_sub == out_ref

    out = LuxCore.stateless_apply(model, sym_x, sym_ca)
    @test out isa Symbolics.Arr
    @test length(out) == 6
    out_sub = Symbolics.value.(Symbolics.substitute.(Symbolics.scalarize(out), (Dict(sym_x => x, sym_ca => ca),)))
    @test out_sub == out_ref

    out = LuxCore.stateless_apply(sym_model, sym_x, sym_ca)
    @test out isa Symbolics.Arr
    @test length(out) == 6
    out_sub = Symbolics.value.(Symbolics.substitute.(Symbolics.scalarize(out), (Dict(sym_model => model, sym_x => x, sym_ca => ca),)))
    @test out_sub == out_ref
end

@testset "Chain" begin
    model = Chain(Dense(5, 6), Dense(6, 2), Dense(2, 3))
    rng = Random.default_rng()
    x = randn(rng, Float32, 5)
    ps, _ = LuxCore.setup(rng, model)

    ca = ComponentArray(ps)
    Symbolics.@variables sym_ca[1:length(ca)] = ca
    Symbolics.@variables sym_ps::typeof(ps) = ps
    Symbolics.@variables sym_x[1:5] = Float32[1, 2, 3, 4, 5]
    Symbolics.@variables sym_model::typeof(model) = model

    out_ref = LuxCore.stateless_apply(model, x, ps)
    @test out_ref isa Vector{Float32}

    out = LuxCore.stateless_apply(model, sym_x, ps)
    # if the symbolic function regstration wouldn't work, we'd get the
    # vector propagated through the neural network and get a Vector{Num}
    @test out isa Symbolics.Arr
    @test length(out) == 3
    # test that we  can recover the same value as when using concrete numbers
    out_sub = Symbolics.value.(Symbolics.substitute.(Symbolics.scalarize(out), (Dict(sym_x => x),)))
    @test out_sub == out_ref

    out = LuxCore.stateless_apply(model, sym_x, sym_ps)
    @test out isa Symbolics.Arr
    @test length(out) == 3
    out_sub = Symbolics.value.(Symbolics.substitute.(Symbolics.scalarize(out), (Dict(sym_x => x, sym_ps => ps),)))
    @test out_sub == out_ref

    out = LuxCore.stateless_apply(model, sym_x, ca)
    @test out isa Symbolics.Arr
    @test length(out) == 3
    out_sub = Symbolics.value.(Symbolics.substitute.(Symbolics.scalarize(out), (Dict(sym_x => x,),)))
    @test out_sub == out_ref

    out = LuxCore.stateless_apply(model, sym_x, sym_ca)
    @test out isa Symbolics.Arr
    @test length(out) == 3
    out_sub = Symbolics.value.(Symbolics.substitute.(Symbolics.scalarize(out), (Dict(sym_x => x, sym_ca => ca),)))
    @test out_sub == out_ref

    out = LuxCore.stateless_apply(sym_model, sym_x, sym_ca)
    @test out isa Symbolics.Arr
    @test length(out) == 3
    out_sub = Symbolics.value.(Symbolics.substitute.(Symbolics.scalarize(out), (Dict(sym_model => model, sym_x => x, sym_ca => ca),)))
    @test out_sub == out_ref
end

using ModelingToolkit, ParameterizedFunctions
import Symbolics

# Build the expected MATLAB string from the actual orderings reported by the
# `System` (parameter index assignment is determined by MTK and changes from
# time to time — e.g. PR #1863's `no-sort-addmul` flipped `[d, c]` to
# `[c, d]`). We look up the index of each named parameter so the test stays
# stable across reorderings.
function _matlab_lotka_volterra_expected(sys, a, b, c, d)
    ps = parameters(sys)
    idx(p) = findfirst(q -> isequal(q, Symbolics.unwrap(p)), Symbolics.unwrap.(ps))
    ia, ib, ic, id = idx(a), idx(b), idx(c), idx(d)
    return "diffeqf = @(internal_var___t,internal_var___u) [\n" *
        "  internal_var___p($ia) * internal_var___u(1) + -1 * internal_var___p($ib) * internal_var___u(1) * internal_var___u(2);\n" *
        "  -1 * internal_var___p($ic) * internal_var___u(2) + internal_var___p($id) * internal_var___u(1) * internal_var___u(2);\n" *
        "];\n"
end

# The order of operands within commutative `*` (and `+`) follows SymbolicUtils'
# argument sort, which is benign but version-dependent (e.g. `u(1) * u(2)` vs
# `u(2) * u(1)`). Compare the two RHS rows modulo that ordering so the test is
# stable across the CI Julia matrix, mirroring the build_targets tests.
function _normalize_matlab(matstr)
    rows = [m[1] for m in eachmatch(r"([^\[\];\n]+);", matstr)]
    return map(rows) do row
        summands = sort(map(strip, split(row, " + ")))
        join(map(s -> join(sort(strip.(split(s, " * "))), " * "), summands), " + ")
    end
end

### Capture MATLABDiffEq.jl type issues
@independent_variables t
@parameters a b c d
@variables x(t) y(t)
D = Differential(t)
eqs = [D(x) ~ a*x - b*x*y
       D(y) ~ -c*y + d*x*y]
@named sys = System(eqs, t)
equations(sys)
matstr = Symbolics.build_function(map(x->x.rhs,equations(sys)),unknowns(sys),
                                        parameters(sys),ModelingToolkit.get_iv(sys),
                                        target = Symbolics.MATLABTarget())
@test _normalize_matlab(matstr) == _normalize_matlab(_matlab_lotka_volterra_expected(sys, a, b, c, d))

f = @ode_def_bare LotkaVolterra begin
  dx = a*x - b*x*y
  dy = -c*y + d*x*y
end a b c d
p = [1.5,1,3,1]
tspan = (0.0,10.0)
u0 = [1.0,1.0]
prob = ODEProblem(f,u0,tspan,p)

sys = modelingtoolkitize(prob)
[eq.rhs for eq ∈ equations(sys)]
matstr = Symbolics.build_function(map(x->x.rhs,equations(sys)),unknowns(sys),
                                        parameters(sys),ModelingToolkit.get_iv(sys),
                                        target = Symbolics.MATLABTarget())
# `modelingtoolkitize` names the parameters `α, β, γ, δ` (in declaration
# order), so look them up by name from the resulting system.
let ps = parameters(sys)
    a2, b2, c2, d2 = ps[1], ps[2], ps[3], ps[4]
    @test _normalize_matlab(matstr) == _normalize_matlab(_matlab_lotka_volterra_expected(sys, a2, b2, c2, d2))
end

using Symbolics
using SymbolicIndexingInterface
using Symbolics: Differential, Operator

@variables t x(t) y(t)
@variables p[1:3, 1:3] q[1:3]

bar(x, p) = p * x
@register_array_symbolic bar(x::AbstractVector, p::AbstractMatrix) begin
    size = size(x)
    eltype = promote_type(eltype(x), eltype(p))
end

D = Differential(t)

expr1 = x + y + D(x)
@test isequal(symbolic_evaluate(expr1, Dict(x => 3)), 3 + y + D(3))
@test isequal(symbolic_evaluate(expr1, Dict(x => 3); operator = Operator), 3 + y + D(x))
@test isequal(symbolic_evaluate(expr1, Dict(x => 1, D(x) => 2)), y + 3)
@test symbolic_evaluate(expr1, Dict(x => 1, D(x) => 2, y => 3)) == 6
@test isequal(symbolic_evaluate(expr1, Dict(x => 3, y => 3x), operator = Operator), 12 + D(x))
@test symbolic_evaluate(expr1, Dict(x => 3, y => 3x, D(x) => 2)) == 14

expr2 = bar(q, p)
@test isequal(symbolic_evaluate(expr2, Dict(p => ones(3, 3))), bar(q, ones(3, 3)))
@test symbolic_evaluate(expr2, Dict(p => ones(3, 3), q => ones(3))) == 3ones(3)

expr3 = bar(3q, 3p)
@test isequal(symbolic_evaluate(expr3, Dict(p => ones(3, 3))), bar(3q, 3ones(3, 3)))
@test symbolic_evaluate(expr3, Dict(p => ones(3, 3), q => ones(3))) == 27ones(3)

expr4 = D(x) ~ 3x + y
@test isequal(symbolic_evaluate(expr4, Dict(x => 3)), D(3) ~ 9 + y)
@test isequal(symbolic_evaluate(expr4, Dict(x => 3); operator = Operator), D(x) ~ y + 9)
@test isequal(symbolic_evaluate(expr4, Dict(x => 1, D(x) => 2)), 2 ~ 3 + y)
@test isequal(symbolic_evaluate(expr4, Dict(x => 1, D(x) => 2, y => 3)), 2 ~ 6)

# Plot recipe plotting an expression as a function
# expression may have 1 (ex1) or 2 (ex2) free variables
# plot of ex:𝑹 → 𝐑: `plot(ex1, a, b)`
# parametric plot: `plot(ex1, ex1′, a, b)`
# surface plot: `surface(xs, ys, ex2)`
# contourplot: `contour(xs, ys, ex2)`.
# not plot([ex1, ex1′], a, b); use plot(ex1, a, b); plot!(ex1′)
@recipe f(::Type{T}, v::T) where {T<:Num} = build_function(v, Symbolics.get_variables(v)...; expression=Val{false})

using Symbolics
using Symbolics: degree
using Test

@variables x, y, z

@test isequal(degree(x^0), 0)
@test isequal(degree(x^1), 1)
@test isequal(degree(x^2), 2)

@test isequal(degree(1), 0)
@test isequal(degree(x), 1)
@test isequal(degree(x, x), 1)
@test isequal(degree(2x, x), 1)
@test isequal(degree(x, y), 0)

@test isequal(degree(x/2, x), 1)
@test isequal(degree(x/y, x), 1)

@test isequal(degree(x*y, y), 1)
@test isequal(degree(x*y, x), 1)
@test isequal(degree(x*y, x*y), 1)
@test isequal(degree(x*y, z), 0)

@test isequal(degree(x*y^2 + 2x + y^3*x^3), 6)
@test isequal(degree(x*y^2 + 2x + y^3*x^3, y), 3)
@test isequal(degree(x*y^2 + 2x + y^3*x^6, x), 6)

@test isequal(degree(x*y^2 + 2x + y^3*x^6, z), 0)
@test isequal(degree(x*y^2 + 2x + y^3*x^6 + z, z), 1)
@test isequal(degree(x*y^2 + 2x + y^3*x^6*z, z), 1)

@test isequal(degree(x^2 + y^2 + z^2, sin(z)), 0)
@test isequal(degree(sin(z), z), 0)
@test isequal(degree(sin(z)), 1)

@test isequal(degree(x^2*sin(z), x), 2)
@test isequal(degree(x+exp(z), x), 1)

@test isequal(degree((x - y)^2*((y + x*y)^3)), 8)
@test isequal(degree((x + z)*((y + x*y)^3), x), 4)

module SymbolicsSymPyPythonCallExt

if isdefined(Base, :get_extension)
    using Symbolics
    using SymPyPythonCall
else
    using ..Symbolics
    using ..SymPyPythonCall
end

using Symbolics: value, Differential, Num
using SymbolicUtils: iscall, operation, arguments, symtype, FnType, Symbolic, Term
using LinearAlgebra

# Use the high-level SymPyPythonCall API for conversion
function Symbolics.symbolics_to_sympy_pythoncall(expr)
    expr = value(expr)
    expr isa Symbolic || return expr
    if iscall(expr)
        op = operation(expr)
        args = arguments(expr)

        if op isa Differential
            @assert length(args) == 1 "Differential operator must have exactly one argument."
            return SymPyPythonCall.diff(symbolics_to_sympy_pythoncall(args[1]), symbolics_to_sympy_pythoncall(op.x))
        end

        sop = symbolics_to_sympy_pythoncall(op)
        sargs = map(symbolics_to_sympy_pythoncall, args)
        return sop === (^) && length(sargs) == 2 && sargs[2] isa Number ? sargs[1]^sargs[2] : sop(sargs...)
    else
        name = string(nameof(expr))
        return symtype(expr) <: FnType ? SymPyPythonCall.SymFunction(name) : SymPyPythonCall.Sym(name)
    end
end

function Symbolics.sympy_pythoncall_to_symbolics(sympy_expr, vars)
    # Check for infinity values
    sp = SymPyPythonCall._sympy_
    py_obj = sympy_expr isa SymPyPythonCall.Sym ? sympy_expr.o : sympy_expr
    
    if Bool(SymPyPythonCall.PythonCall.pyeq(py_obj, sp.oo))
        return Inf
    elseif Bool(SymPyPythonCall.PythonCall.pyeq(py_obj, -sp.oo))
        return -Inf
    end
    
    dict = Dict{Symbol, Any}()
    for v in vars
        dict[nameof(v)] = v
    end

    # Convert Python/SymPy notation to Julia notation
    expr_str = string(sympy_expr)
    expr_str = replace(expr_str, "**" => "^")  # Convert exponentiation
    Symbolics.parse_expr_to_symbolic(Meta.parse(expr_str), dict)
end

function Symbolics.sympy_pythoncall_linear_solve(A, b)
    A_sympy = map(symbolics_to_sympy_pythoncall, A)
    b_sympy = map(symbolics_to_sympy_pythoncall, b)
    
    # Create equations: Ax = b -> Ax - b = 0
    vars_in_system = unique(vcat(Symbolics.get_variables(A), Symbolics.get_variables(b)))
    equations = []
    for i in 1:size(A, 1)
        lhs = sum(A_sympy[i, j] * symbolics_to_sympy_pythoncall(vars_in_system[j]) for j in 1:length(vars_in_system) if j <= size(A, 2))
        eq = lhs - b_sympy[i]
        push!(equations, eq)
    end
    
    # Use high-level SymPyPythonCall solve function
    sol_sympy = SymPyPythonCall.solve(equations, [symbolics_to_sympy_pythoncall(v) for v in vars_in_system])
    all_expressions = vcat(vec(A), b)
    vars = Symbolics.get_variables(all_expressions)
    [sympy_pythoncall_to_symbolics(s, vars) for s in sol_sympy]
end

function Symbolics.sympy_pythoncall_algebraic_solve(expr, var)
    expr_sympy = expr isa AbstractVector ? map(symbolics_to_sympy_pythoncall, expr) : symbolics_to_sympy_pythoncall(expr)
    var_sympy = var isa AbstractVector ? map(symbolics_to_sympy_pythoncall, var) : symbolics_to_sympy_pythoncall(var)
    
    # Use high-level SymPyPythonCall solve function
    sol_sympy = SymPyPythonCall.solve(expr_sympy, var_sympy)
    vars = var isa AbstractVector ? var : [var]
    # Convert each solution
    return [sympy_pythoncall_to_symbolics(s, vars) for s in sol_sympy]
end

function Symbolics.sympy_pythoncall_integrate(expr, var)
    expr_sympy = symbolics_to_sympy_pythoncall(expr)
    var_sympy = symbolics_to_sympy_pythoncall(var)
    # Use high-level SymPyPythonCall integrate function
    result_sympy = SymPyPythonCall.integrate(expr_sympy, var_sympy)
    sympy_pythoncall_to_symbolics(result_sympy, Symbolics.get_variables(expr))
end

function Symbolics.sympy_pythoncall_limit(expr, var, val)
    expr_sympy = symbolics_to_sympy_pythoncall(expr)
    var_sympy = symbolics_to_sympy_pythoncall(var)
    val_sympy = symbolics_to_sympy_pythoncall(val)
    # Use high-level SymPyPythonCall limit function
    result_sympy = SymPyPythonCall.limit(expr_sympy, var_sympy, val_sympy)
    sympy_pythoncall_to_symbolics(result_sympy, Symbolics.get_variables(expr))
end

function Symbolics.sympy_pythoncall_simplify(expr)
    expr_sympy = symbolics_to_sympy_pythoncall(expr)
    # Use high-level SymPyPythonCall simplify function
    result_sympy = SymPyPythonCall.simplify(expr_sympy)
    sympy_pythoncall_to_symbolics(result_sympy, Symbolics.get_variables(expr))
end

function Symbolics.sympy_pythoncall_ode_solve(expr, func, var)
    expr_sympy = symbolics_to_sympy_pythoncall(expr)
    func_sympy = symbolics_to_sympy_pythoncall(func)
    var_sympy = symbolics_to_sympy_pythoncall(var)
    # Use high-level SymPyPythonCall dsolve function
    sol_sympy = SymPyPythonCall.dsolve(expr_sympy, func_sympy)
    sol_expr = SymPyPythonCall.rhs(sol_sympy)
    parsing_vars = Vector{SymbolicUtils.BasicSymbolic}()
    vars_in_expr = Symbolics.get_variables(value(expr))
    func_val = value(func)
    for v in vars_in_expr
        if !isequal(v, func_val)
            push!(parsing_vars, v)
        end
    end
    push!(parsing_vars, value(var))
    push!(parsing_vars, operation(func_val))
    unwrapped_vars = unique(parsing_vars)
    sympy_pythoncall_to_symbolics(sol_expr, unwrapped_vars)
end

end

module RegistrationWithoutUsingImport
import Symbolics
Symbolics.@register_symbolic foo(x, y)
Symbolics.@register_array_symbolic bar(x::AbstractVector) begin
    size = (length(x), length(x))
end false
end

module RegistrationWithoutUsingSelective
import Symbolics: @register_array_symbolic, @register_symbolic
@register_symbolic goo(x, y)
@register_array_symbolic hoo(x::AbstractVector) begin
    size = (length(x), length(x))
end false
end

using Test
using Symbolics
import Nemo, Groebner
import Symbolics: partial_frac_decomposition

@variables x

# https://en.neurochispas.com/algebra/4-types-of-partial-fractions-decomposition-with-examples/
@test isequal(partial_frac_decomposition((3x-1) / (x^2 + x - 6), x), 2/(x+3) + 1/(x-2))
@test isequal(partial_frac_decomposition((9x^2 + 34x + 14) / ((x+2)*(x^2 - x - 12)), x), expand(3/(x+2) + 7/(x-4) - 1/(x+3)))

# https://tutorial.math.lamar.edu/Problems/Alg/PartialFractions.aspx
@test isequal(partial_frac_decomposition((17x-53)/(x^2 - 2x - 15), x), expand(4/(x-5) + 13/(x+3)))
@test isequal(partial_frac_decomposition((34-12x)/(3x^2 - 10x - 8), x), (-3)/(2//3 + x) + -1/(-4 + x))
@test isequal(partial_frac_decomposition((125 + 4x - 9x^2)/((x-1)*(x+3)*(x+4)), x), expand(6/(x-1) - 8/(x+3) - 7/(x+4)))
@test isequal(partial_frac_decomposition((10x+35)/((x+4)^2), x), 10/(x+4) + -5/(x+4)^2)
@test isequal(partial_frac_decomposition((6x+5)/((2x-1)^2), x), 3/(2*(x-1//2)) + 2/(x-1//2)^2)
@test isequal(partial_frac_decomposition((7x^2-17x+38)/((x+6)*(x-1)^2), x), 8/(x+6) + -1/(x-1) + 4/(x-1)^2)
@test isequal(partial_frac_decomposition((4x^2 - 22x + 7)/((2x+3)*(x-2)^2), x), 2/(x+3//2) + -3/(x-2)^2)
@test_broken isequal(partial_frac_decomposition((3x^2 + 7x + 28)/(x*(x^2 + x + 7)), x, warns=false), expand(4/x + (3-x)/(x^2+x+7))) # irrational roots
@test isequal(partial_frac_decomposition((4x^3 + 16x + 7)/(x^2 + 4)^2, x), 4x/(x^2+4) + 7/(x^2+4)^2)

# check valid expressions
@test partial_frac_decomposition(sin(x), x) === nothing
@test partial_frac_decomposition(x^2/(x-1), x) === nothing
@test partial_frac_decomposition(1/(x^2 + 2), x, warns=false) === nothing # irrational roots, should eventually be fixed

using Symbolics, Test
using SymbolicUtils: metadata, unwrap_const
using Symbolics: unwrap
using SymbolicIndexingInterface: getname, hasname

@variables a b::Real z::Complex (Z::Complex)[1:10]

@testset "types" begin
    @test a isa Num
    @test b isa Num
    @test eltype(Z) <: Complex{Num}

    for x in [z, Z[1], z+a, z*a, z^2, z/z] # z/z is sus
        @test x isa Complex{Num}
        @test real(x) isa Num
        @test imag(x) isa Num
        @test conj(x) isa Complex{Num}
    end

    # issue #314
    bi = a+a*im
    bs = substitute(bi, (Dict(a=>1.0))) # returns 1.0 + im
    @test bs isa Complex{Num}
    bv = unwrap_const(Symbolics.value(bs))
    @test typeof(bv) == ComplexF64
end

@testset "repr" begin
    @test repr(z) == "z"
    @test repr(a + b*im) == "a + b*im"
end

@testset "metadata" begin
    z1 = z+1.0
    @test_nowarn substitute(z1, z=>1.0im)
    @test metadata(z1) == unwrap(z1.im).metadata
    @test metadata(z1) == unwrap(z1.re).metadata
    z2 = 1.0 + z*im
    @test isnothing(metadata(unwrap(z1.re)))
end

@testset "getname" begin
    @variables t a b x::Complex y(t)::Complex z(a, b)::Complex
    @test hasname(x)
    @test getname(x) == :x
    @test hasname(y)
    @test getname(y) == :y
    @test hasname(z)
    @test getname(z) == :z
    @test !hasname(2x)
    @test !hasname(x + y)
end

using ForwardDiff
using Symbolics
using Symbolics.SymbolicUtils
using Symbolics.SymbolicUtils.SpecialFunctions
using Symbolics.NaNMath
using Test

SF = SymbolicUtils.SpecialFunctions

@variables x

# Test functions from Symbolics #
#-------------------------------#

for f ∈ SymbolicUtils.basic_monadic
    fun = eval(:(ξ ->($f)(ξ)))

    fd = @invokelatest ForwardDiff.derivative(fun, x)
    sym = Symbolics.Differential(x)(@invokelatest fun(x)) |> expand_derivatives

    @test isequal(fd, sym)
end

for f ∈ SymbolicUtils.monadic
    # The polygamma and trigamma functions seem to be missing rules in ForwardDiff.
    # The abs rule uses conditionals and cannot be used with Symbolics.Num.
    # acsc, asech, NanMath.log2 and NaNMath.log10 are tested separately
    if f ∈ (abs, SF.polygamma, SF.trigamma, acsc, acsch, asech, NaNMath.log2, NaNMath.log10, sign, signbit, factorial, expinti, sinint)
        continue
    end

    fun = eval(:(ξ ->($f)(ξ)))

    fd = @invokelatest ForwardDiff.derivative(fun, x)
    sym = Symbolics.Differential(x)(@invokelatest fun(x)) |> expand_derivatives

    @test isequal(SymbolicUtils.evaluate(fd), SymbolicUtils.evaluate(sym))
end

# These are evaluated numerically. For some reason isequal evaluates to false for the symbolic expressions.
for f ∈ (acsc, asech, NaNMath.log2, NaNMath.log10)
    fun = eval(:(ξ ->($f)(ξ)))

    fd = @invokelatest ForwardDiff.derivative(fun, 1.0)
    sym = Symbolics.Differential(x)(@invokelatest fun(x)) |> expand_derivatives

    @test fd ≈ Symbolics.value(substitute(sym, Dict(x => 1.0); fold = Val(true)))
end

for f ∈ SymbolicUtils.basic_diadic
    if f ∈ (//,)
        continue
    end

    fun = eval(:(ξ ->($f)(ξ, 2.0)))

    fd = @invokelatest ForwardDiff.derivative(fun, x)
    sym = Symbolics.Differential(x)(@invokelatest fun(x)) |> expand_derivatives

    @test isequal(fd, unwrap_const(sym))
end

for f ∈ SymbolicUtils.diadic
    if f ∈ (max, min, NaNMath.atanh, mod, rem, copysign, besselj, bessely, besseli, besselk)
        continue
    end

    fun = eval(:(ξ ->($f)(ξ, 2.0)))

    fd = @invokelatest ForwardDiff.derivative(fun, x)
    sym = Symbolics.Differential(x)(@invokelatest fun(x)) |> expand_derivatives

    @test isequal(fd, sym)
end

for f ∈ (NaNMath.atanh,)
    fun = eval(:(ξ ->($f)(ξ)))

    fd = @invokelatest ForwardDiff.derivative(fun, x)
    sym = Symbolics.Differential(x)(@invokelatest fun(x)) |> expand_derivatives

    @test isequal(fd, sym)
end

for f ∈ (besselj, bessely, besseli, besselk)
    fun = eval(:(ξ ->($f)(ξ, 2)))

    fd = @invokelatest ForwardDiff.derivative(fun, x)
    sym = Symbolics.Differential(x)(@invokelatest fun(x)) |> expand_derivatives

    @test isequal(fd, sym)
end

# Additionally test these definitions from ForwardDiff #
#------------------------------------------------------#

# https://github.com/JuliaDiff/ForwardDiff.jl/blob/d3002093beb88ff0b98ed178377961dfd55c1247/src/dual.jl#L599
# and
# https://github.com/JuliaDiff/ForwardDiff.jl/blob/d3002093beb88ff0b98ed178377961dfd55c1247/src/dual.jl#L683
for f ∈ (hypot, muladd)
    fun = eval(:(ξ ->($f)(ξ, 2.0, 3.0)))

    fd = @invokelatest ForwardDiff.derivative(fun, 5.0)
    sym = Symbolics.Differential(x)(@invokelatest fun(x)) |> expand_derivatives

    @test Num(fd) ≈ substitute(sym, Dict(x => 5.0); fold = Val(true)) atol=1e-15
end

# fma is not defined for Symbolics.Num

# https://github.com/JuliaSymbolics/Symbolics.jl/issues/1246
@testset "isequal type ambiguity" begin
    @variables z
    y(x) = isequal(z, x) ? 0 : x
    @test ForwardDiff.derivative(y, 0) == 1 # expect ∂(x)/∂x
end

@testset "NaNMath.pow (issue #1399)" begin
    @variables x
    @test_throws DomainError substitute(ForwardDiff.derivative(z -> x^z, 0.5), x => -1.0)
    @test isnan(Symbolics.value(substitute(ForwardDiff.derivative(z -> NaNMath.pow(x, z), 0.5), x => -1.0; fold = Val(true))))
end

@testset "promote_rule ambiguities" begin
    @variables y
    @test ForwardDiff.derivative(x -> promote(x, y)[1], 1) === Num(1)
end

@testset "symbolic rounding discontinuities" begin
    @variables y
    @test iszero(ForwardDiff.derivative(floor, y))
    @test iszero(ForwardDiff.derivative(ceil, y))
end

function n_occurrences(expr, var)
    n = 0
    !iscall(unwrap(expr)) && any(isequal(var, x) for x in get_variables(expr)) && return 1
    !iscall(unwrap(expr)) && return 0

    args = arguments(unwrap(expr))

    for arg in args
        n += traverse(arg, var)
    end

    return n
end

function traverse(argument, var)
    args = []
    !iscall(argument) && isequal(argument, var) && return 1
    !iscall(argument) && !isequal(argument, var) && return 0

    args = arguments(argument)
    n = 0

    for arg in args
        n += traverse(arg, var)
    end
    return n
end

function n_func_occ(expr, var)
    expr = unwrap(expr)
    !iscall(expr) && return n_occurrences(expr, var)
    args, cur_oper = arguments(expr), operation(expr)
    counted_ops = [sqrt, cbrt, sin, log, log2, log10, cos, tan,
        asin, acos, atan, exp, ssqrt, scbrt, slog]
    n = 0

    if cur_oper === (*) || cur_oper === (+)
        outside = false
        for arg in args
            n_occurrences(arg, var) == 0 && continue

            # x
            if !iscall(arg) && isequal(var, first(get_variables(arg))) && !outside
                n += 1
                outside = true
                continue
            end

            !iscall(arg) && continue
            oper = operation(arg)

            args_arg = arguments(arg)
            oper_arg = operation(arg)
            function is_var_outside(arg)
                check_poly_inunivar(arg, var) && !outside && n_occurrences(arg, var) != 0
            end
            case_1_pow = oper_arg === (^) && n_occurrences(args_arg[2], var) == 0 &&
                         n_occurrences(args_arg[1], var) != 0 &&
                         check_poly_inunivar(args_arg[1], var) &&
                         n_occurrences(arg, var) != 0 && !(value(args_arg[2]) isa Number)
            case_2_pow = oper_arg === (^) && n_occurrences(args_arg[2], var) != 0 &&
                         n_occurrences(args_arg[1], var) == 0
            case_3_pow = oper_arg === (^) && n_occurrences(args_arg[2], var) == 0 &&
                         n_occurrences(args_arg[1], var) != 0 &&
                         !check_poly_inunivar(args_arg[1], var)

            # any transcedental operation and the case:  (weird_transcedental_f(x))^(something)
            if any(isequal(oper, op) for op in counted_ops) || case_3_pow
                n += n_func_occ(args_arg[1], var)

                # the case (some constant)^(f(x))
            elseif case_2_pow
                n += n_func_occ(args_arg[2], var)

                # var is outside 'x'+1
            elseif is_var_outside(arg)
                n += 1
                outside = true

                # case (f(x))^(weird stuff)
            elseif case_1_pow
                n += 1

                # n(2 / x) = 1; n(x/x^2) = 2?
            elseif oper_arg === (/)
                num, den = args_arg
                if SymbolicUtils.isconst(den)
                    if is_var_outside(num)
                        n += 1
                        outside = true
                    elseif !check_poly_inunivar(num, var)
                        n += n_func_occ(num, var)
                    end
                    continue
                end
                n += n_func_occ(numerator(arg), var)
                n += n_func_occ(denominator(arg), var)

                # multiplication cases
            elseif oper_arg === (*)
                args_arg = arguments(arg)
                for sub_arg in args_arg
                    # x*log(2)
                    if is_var_outside(sub_arg)
                        n += 1
                        outside = true
                        # log(x)*y
                    elseif !check_poly_inunivar(sub_arg, var)
                        n += n_func_occ(sub_arg, var)
                    end
                end
            end

        end

    else
        for arg in args
            n += n_func_occ(arg, var)
        end
    end

    return n
end

function arg_contains_log(arg, var)
    oper = operation(arg)
    isequal(oper, log) && return true

    if oper == (*)
        return find_logandexpon(arg, var, log, 1)
    end

    return false
end

function find_logandexpon(arg, var, oper, poly_index)
    args_arg = arguments(arg)

    oper_term, constant_term = 0, 0

    for a in args_arg
        if n_occurrences(a, var) != 0 && iscall(a) && operation(a) == (oper) &&
           check_poly_inunivar(arguments(a)[poly_index], var)
            oper_term = a
        elseif n_occurrences(a, var) == 0
            constant_term = a
        end
    end

    !isequal(oper_term, 0) && !isequal(constant_term, 0) && return true
    return false
end

"""
    ia_conditions!(f, lhs, rhs::Vector{Any}, conditions::Vector{Tuple})

If `f` is a left-invertible function, `lhs` and `rhs[i]` are univariate functions and
`f(lhs) ~ rhs[i]` for all `i in eachindex(rhss)`, push to `conditions` all the relevant
conditions on `lhs` or `rhs[i]`. Each condition is of the form `(sym, op)` where `sym`
is an expression involving `lhs` and/or `rhs[i]` and `op` is a binary relational operator.
The condition `op(sym, 0)` is then required to be true for the equation `f(lhs) ~ rhs[i]`
to be valid.

For example, if `f = log`, `lhs = x` and `rhss = [y, z]` then the condition `x > 0` must
be true. Thus, `(lhs, >)` is pushed to `conditions`. Similarly, if `f = sqrt`, `rhs[i] >= 0`
must be true for all `i`, and so `(y, >=)` and `(z, >=)` will be appended to `conditions`. 
"""
function ia_conditions!(args...; kwargs...) end

for fn in [log, log2, log10, NaNMath.log, NaNMath.log2, NaNMath.log10, slog]
    @eval function ia_conditions!(::typeof($fn), lhs, rhs, conditions)
        push!(conditions, (lhs, >))
    end
end

for fn in [log1p, NaNMath.log1p]
    @eval function ia_conditions!(::typeof($fn), lhs, rhs, conditions)
        push!(conditions, (lhs - 1, >))
    end
end

for fn in [sqrt, NaNMath.sqrt, ssqrt]
    @eval function ia_conditions!(::typeof($fn), lhs, rhs, conditions)
        for r in rhs
            push!(conditions, (r, >=))
        end
    end
end

"""
    is_periodic(f)

Return `true` if `f` is a single-input single-output periodic function. Return `false` by
default. If `is_periodic(f) == true`, then `fundamental_period(f)` must also be defined.

See also: [`fundamental_period`](@ref)
"""
is_periodic(f) = false

for fn in [
    sin, cos, tan, csc, sec, cot, NaNMath.sin, NaNMath.cos, NaNMath.tan, sind, cosd, tand,
    cscd, secd, cotd, cospi
]
    @eval is_periodic(::typeof($fn)) = true
end

"""
    fundamental_period(f)

Return the fundamental period of periodic function `f`. Must only be called if
`is_periodic(f) == true`.

see also: [`is_periodic`](@ref)
"""
function fundamental_period end

for fn in [sin, cos, csc, sec, NaNMath.sin, NaNMath.cos]
    @eval fundamental_period(::typeof($fn)) = 2pi
end

for fn in [sind, cosd, cscd, secd]
    @eval fundamental_period(::typeof($fn)) = 360.0
end

fundamental_period(::typeof(cospi)) = 2.0

for fn in [tand, cotd]
    @eval fundamental_period(::typeof($fn)) = 180.0
end

for fn in [tan, cot, NaNMath.tan]
    # `1pi isa Float64` whereas `pi isa Irrational{:π}`
    @eval fundamental_period(::typeof($fn)) = 1pi
end

using Symbolics, Test
import Symbolics: coeff

@variables x y z a b

@test isequal(coeff(2), 2)
@test isequal(coeff(2, x), 0)

@test isequal(coeff(2a, x), 0)
@test isequal(coeff(a*x, x), a)
@test isequal(coeff(2x*a, x), 2a)
# Symbolic powers:
@test isequal(coeff(a*x^b, x^b), a)
@test isequal(coeff(a*x^(b+1), x^(b+1)), a)
# Irrational powers:
@test isequal(coeff(a*x^sqrt(2), x^sqrt(2)), a)

@test isequal(coeff(a + x, x), 1)
@test isequal(unwrap_const(coeff(2(a + x), x)), 2)

e = 4 + x + 3x^2 + 2x^4 + a*x^2 + b
@test isequal(coeff(e), 4)
@test isequal(coeff(e, x^1), 1)
@test isequal(coeff(e, x^2), 3 + a)
@test isequal(coeff(e, x^3), 0)
@test isequal(coeff(e, x^4), 2)

e = x*y^2 + 2x + y^3*x^3
@test isequal(coeff(e, x), 2 + y^2)
@test isequal(coeff(e, x^3), y^3)
@test isequal(coeff(e, y^2), x)
@test isequal(coeff(e, y^3), x^3)

@test isequal(coeff(x^2 + y^2 + z^2, sin(z)), 0)
@test isequal(coeff(sin(z), z), 0)
@test isequal(coeff(sin(z)), 0)

# issue #236
@test isequal(coeff(3x + 2y, x), 3)
@test isequal(coeff(x*y, x), y)
@test isequal(coeff(x^2 + y, x^2), 1)

# expand - simplify needed
@test isequal(coeff(expand(((x + 1)^4 + x)^3), x^2), 93)
@test isequal(coeff(simplify((x^2 - 1) / (x - 1)), x), 1)
@test isequal(coeff(expand((x^(1//2) + y^0.5)^2), x), 1)


# issue #1098
@test isequal(coeff(x^2 + 1, x^0), 1)
@test isequal(coeff(e, x^0), 0)
@test isequal(coeff(a*x + 3, x^0), 3)

@test isequal(unwrap_const(coeff(x / 5, x)), 1//5)
@test isequal(coeff(x / y, x), 1/y)
@test isequal(coeff(x * 5y / (1 + y + z) , x), 5y / (1 + y + z))

# issue #1041 - coefficient of cross term in multivariate polynomial
@test isequal(unwrap_const(coeff(2*x*y + y, x*y)), 2)
@test isequal(unwrap_const(coeff(2*x^2*y + y, x^2*y)), 2)
@test_throws AssertionError coeff(2*x*y + y, 2*x*y) # numerical factors not allowed in second argument of `coeff`
@testset "Issue#1610 non-numeric coeff" begin
    @variables x a b c d
    @test isequal(coeff(c + (a + b*x)*d, x), b * d)
end

using Symbolics
using Test
using Latexify
using LaTeXStrings
using ReferenceTests
import SymbolicUtils as SU
using Symbolics: VartypeT

using DomainSets: Interval

const LatexifyExt = Base.get_extension(Symbolics, :SymbolicsLatexifyExt)
const _toexpr = LatexifyExt._toexpr

@variables x y z u(x) dx h[1:10, 1:10] hh(x, y)[1:10, 1:10] gg(x, y)[1:10, 1:10] [latexwrapper = string]
@variables AA(x) [latexwrapper = string] X₁(x) [latexwrapper = string]
@variables a[1:10]
Dx = Differential(x)
Dy = Differential(y)

# issue 260
@test _toexpr(3 * x / y) == :((3x) / y)
@test _toexpr(3 * x^y) == :(3x^y)

@test_reference "latexify_refs/inverse.txt" latexify(x^-1)

@test_reference "latexify_refs/integral1.txt" latexify(Integral(dx in Interval(0, 1))(x))
@test_reference "latexify_refs/integral2.txt" latexify(Integral(dx in Interval(-Inf, Inf))(u^2))
@test_reference "latexify_refs/integral3.txt" latexify(Integral(dx in Interval(-z, u))(x^2))

@test_reference "latexify_refs/frac1.txt" latexify((z + x * y^-1) / sin(z))
@test_reference "latexify_refs/frac2.txt"  latexify((3x - 7y * z^23) * (z - z^2) / x)

@test_reference "latexify_refs/minus1.txt" latexify(x - y)
@test_reference "latexify_refs/minus2.txt" latexify(x - y * z)
@test_reference "latexify_refs/minus3.txt" latexify(sin(x + y - z))

@test_reference "latexify_refs/unary_minus1.txt" latexify(-y)
@test_reference "latexify_refs/unary_minus2.txt" latexify(-y * z)

@test_reference "latexify_refs/derivative1.txt" latexify(Dx(y))
@test_reference "latexify_refs/derivative2.txt" latexify(Dx(u))
@test_reference "latexify_refs/derivative3.txt" latexify(Dx(x^2 + y^2 + z^2))
@test_reference "latexify_refs/derivative4.txt" latexify(Dy(u))
@test_reference "latexify_refs/derivative5.txt" latexify(Dx(Dy(Dx(y))))

@test_reference "latexify_refs/stable_mul_ordering1.txt" latexify(x * y)
@test_reference "latexify_refs/stable_mul_ordering2.txt" latexify(y * x)

@test_reference "latexify_refs/equation1.txt" latexify(x ~ y + z)
@test_reference "latexify_refs/equation2.txt" latexify(x ~ Dx(y + z))

# The relative order of the two degree-1 terms AA(x) and X₁(x) in this sum is
# decided by SymbolicUtils' hash-based tie-break, which differs across Julia
# versions, so no single reference string passes on all of them. Compare the set
# of additive terms instead of the exact rendered string. (was equation5.txt)
let
    body = strip(replace(string(latexify(AA^2 + AA + 1 + X₁)),
                         "\\begin{equation}" => "", "\\end{equation}" => ""))
    @test sort(strip.(split(body, " + "))) == sort([
        "1",
        "AA\\left( x \\right)",
        "X_1\\left( x \\right)",
        "\\left( AA\\left( x \\right) \\right)^{2}",
    ])
end

@test_reference "latexify_refs/equation_vec1.txt" latexify(
    [
        x ~ y + z
        y ~ x - 3z
    ]
)
@test_reference "latexify_refs/equation_vec2.txt" latexify(
    [
        Dx(u) ~ z
        Dx(y) ~ y * x
    ]
)

@variables s p(s)[1:2] q(s)[1:2] A[1:2, 1:2]
@test_reference "latexify_refs/equation_vec_array.txt" latexify([q ~ A * p])

@test_reference "latexify_refs/complex1.txt" latexify(x^2 - y^2 + 2im * x * y)
@test_reference "latexify_refs/complex2.txt" latexify(3im * x)
@test_reference "latexify_refs/complex3.txt" latexify(1 - x + (1 + 2x) * im; imaginary_unit = "\\mathbb{i}")
@test_reference "latexify_refs/complex4.txt" latexify(im * SU.Term{VartypeT}(sqrt, [2]; type = Real, shape = []))

@syms c
@test_reference "latexify_refs/complex5.txt" latexify((3 + im / im)c)

@test_reference "latexify_refs/indices1.txt" latexify(h[10, 10])
@test_reference "latexify_refs/indices2.txt" latexify(h[10, 10], index = :bracket)

# test for https://github.com/JuliaSymbolics/Symbolics.jl/issues/1167
# note these tests need updating if/when https://github.com/korsbo/Latexify.jl/issues/331 is fixed
@test_reference "latexify_refs/indices3.txt" latexify(hh[10, 10])
@test_reference "latexify_refs/indices4.txt" latexify(gg[10, 10])

@test_reference "latexify_refs/indices5.txt" latexify(a'a)

@variables f(..)
@test_reference "latexify_refs/call_with_metadata.txt" latexify(f)

# The `_toexpr_metadata`/`_toexpr_op` hooks live in `Symbolics`, so downstream code can
# extend them via `import Symbolics` without `Base.get_extension`. The Latexify-coupled
# helpers (`_toexpr_plain`, `default_latex_wrapper`) come from the loaded extension.
struct LatexHookCtx end
function Symbolics._toexpr_metadata(O, ::Type{LatexHookCtx}, val; latexwrapper = LatexifyExt.default_latex_wrapper)
    inner = LatexifyExt._toexpr_plain(O; latexwrapper)
    return Expr(:call, :_textbf, inner)
end
expr = SU.setmetadata(x + y, LatexHookCtx, true)
@test occursin("\\textbf", latexify(expr).s)

avgf(x) = x
function Symbolics._toexpr_op(::typeof(avgf), args; latexwrapper = LatexifyExt.default_latex_wrapper)
    inner = LatexifyExt._toexpr_plain(args[1]; latexwrapper)
    inner_s = strip(latexify(inner).s, '\$')
    return LaTeXString("\\langle " * inner_s * " \\rangle")
end
avg_expr = SU.term(avgf, x + y)
@test occursin("\\langle", latexify(avg_expr).s)

@test !occursin("identity", latexify(Num(π))) # issue #1254

# issue #1820: hasmetadata should not be called on Vector arguments in getindex
@testset "getindex with vector argument (#1820)" begin
    @variables kp
    # Create an expression that indexes a literal vector of symbolic expressions.
    # This mimics what happens in piecewise/ifelse expressions with vector results.
    vec_expr = Symbolics.value.(Symbolics.Num[2kp, 3kp^2, kp + 1])
    getindex_term = SU.term(getindex, vec_expr, 1; type=SU.SymReal)
    # This should not throw a MethodError about hasmetadata on Vector
    @test_nowarn latexify(getindex_term)
end

@testset "ifelse_eager / ifelse_branching render" begin
    @variables a b
    @test_nowarn latexify(ifelse_eager(a > 0, a^2, 1 / a))
    @test_nowarn latexify(ifelse_branching(a > 0, a^2, 1 / a))
end

module SymbolicsLuxExt

using Lux
using Symbolics
using Lux.LuxCore
using Lux.Random: AbstractRNG, default_rng
using Symbolics.SymbolicUtils

@static if isdefined(Lux.NilSizePropagation, :recursively_nillify)
    function Lux.NilSizePropagation.recursively_nillify(x::SymbolicUtils.BasicSymbolic{<:Vector{<:Real}})
        Lux.NilSizePropagation.recursively_nillify(Symbolics.wrap(x))
    end
end

function LuxCore.outputsize(model::SymbolicUtils.BasicSymbolic{<:LuxCore.AbstractLuxLayer}, x::Symbolics.Arr, rng::AbstractRNG)
    LuxCore.outputsize(Symbolics.getdefaultval(model), x, rng)
end

@register_array_symbolic LuxCore.stateless_apply(
    model::LuxCore.AbstractLuxLayer, x::AbstractArray, ps::Union{NamedTuple, <:AbstractVector}) begin
    size = LuxCore.outputsize(model, Symbolics.wrap(x), default_rng())
    eltype = Real
end

end

using Symbolics
using LogExpFunctions
using Test

N = 10

@variables a, b, c, x[1:N]

_a = -0.2
_b = -1.0
_c = 2.0
_x = rand(N)

vals = Dict(a => _a, b => _b, c => _c, x => _x)

@test substitute(logaddexp(a, b), vals; fold = Val(true)) ≈ Num(logaddexp(_a, _b)) atol=1e-15
@test substitute(logaddexp(a, _b), vals; fold = Val(true)) ≈ Num(logaddexp(_a, _b)) atol=1e-15
@test substitute(logaddexp(_a, b), vals; fold = Val(true)) ≈ Num(logaddexp(_a, _b)) atol=1e-15
@test substitute(logsubexp(a, b), vals; fold = Val(true)) ≈ Num(logsubexp(_a, _b) ) atol=1e-15
@test substitute(logsubexp(a, _b), vals; fold = Val(true)) ≈ Num(logsubexp(_a, _b) ) atol=1e-15
@test substitute(logsubexp(_a, b), vals; fold = Val(true)) ≈ Num(logsubexp(_a, _b) ) atol=1e-15
@test substitute(log1mexp(a), vals; fold = Val(true)) ≈ Num(log1mexp(_a)) atol=1e-15
@test substitute(log1pexp(a), vals; fold = Val(true)) ≈ Num(log1pexp(_a)) atol=1e-15
@test substitute(logexpm1(c), vals; fold = Val(true)) ≈ Num(logexpm1(_c)) atol=1e-15
@test substitute(logmxp1(c), vals; fold = Val(true)) ≈ Num(logmxp1(_c)) atol=1e-15
@test substitute(logsumexp(x), vals; fold = Val(true)) ≈ Num(logsumexp(_x)) atol=1e-15

"""
$(TYPEDEF)

Represents a differential operator.

# Fields
$(FIELDS)

# Examples

```jldoctest
julia> using Symbolics

julia> @variables x y;

julia> D = Differential(x)
Differential(x, 1)

julia> D(y) # Differentiate y wrt. x
Differential(x, 1)(y)

julia> Dx = Differential(x) * Differential(y) # d^2/dxy operator
Differential(x, 1) ∘ Differential(y, 1)

julia> D3 = Differential(x)^3 # 3rd order differential operator
Differential(x, 3)
```
"""
struct Differential <: Operator
    """The variable or expression to differentiate with respect to."""
    x::BasicSymbolic{VartypeT}
    """The derivative order. Can be rational for fractional derivatives."""
    order::Union{Int, Rational{Int}}
    function Differential(x::BasicSymbolic{VartypeT}, order = 1)
        @assert order > 0 "Derivative order must be positive"
        @match x begin
            BSImpl.Const(;) => throw(ArgumentError("Cannot take derivative with respect to constant."))
            _ => new(x, order)
        end
    end
    Differential(x::Union{Num, Arr}, order = 1) = Differential(unwrap(x), order)
    Differential(::CallAndWrap, order = 1) = throw(ArgumentError("Cannot take derivative with respect to a symbolic function."))
    Differential(::Union{AbstractFloat, Integer}) = error("D(::Number) is not a valid derivative. Derivatives must be taken w.r.t. symbolic variables.")
end
function (D::Differential)(x::BasicSymbolic{VartypeT})
    @match x begin
        BSImpl.Term(; f, args) && if f isa Differential && isequal(f.x, D.x) end => begin
            return Differential(D.x, D.order + f.order)(args[1])
        end
        _ => return BSImpl.Term{VartypeT}(D, SArgsT((x,)); type = symtype(x), shape = shape(x))
    end
end

(D::Differential)(::Union{AbstractFloat, Integer}) = Num(COMMON_ZERO)
(D::Differential)(x::Num) = Num(D(unwrap(x)))
(D::Differential)(x::Arr{T, N}) where {T, N} = Arr{T, N}(D(unwrap(x)))
(D::Differential)(x::Complex{Num}) = Complex{Num}(Num(D(unwrap(real(x)))), Num(D(unwrap(imag(x)))))
SymbolicUtils.isbinop(f::Differential) = false

function (s::SymbolicUtils.Substituter)(x::Differential)
    Differential(s(x.x), x.order)
end

function SymbolicUtils.operator_to_term(::Differential, ex::BasicSymbolic{VartypeT})
    return diff2term(ex)
end

"""
    is_derivative(x)

Return `true` if `x` is an unapplied derivative term, i.e. a symbolic expression whose
operation is a [`Differential`](@ref). Return `false` for everything else.

Applying a `Differential` does not differentiate immediately: `D(x^2)` is stored as the
symbolic application of `D` to `x^2` until [`expand_derivatives`](@ref) is called. This
predicate is the test for "this node is still an unapplied derivative", and is the usual
building block for finding them inside an expression.

Wrapper types are unwrapped first, so the `Num` that `D(x)` returns and the raw expression
tree `Symbolics.unwrap(D(x))` give the same answer. That holds for any registered wrapper
([`@symbolic_wrap`](@ref)), including `Arr`.

Two things to be aware of when calling it:

  - It only inspects the top node. `D(x) + y` is not a derivative term even though it
    contains one. Combine it with `Symbolics.hasnode` or `Symbolics.filterchildren` to ask
    about a whole tree.
  - A `Differential` applied to a `Complex{Num}` distributes over the real and imaginary
    parts rather than forming one derivative term, so `is_derivative` is `false` for it
    even though each part is a derivative.

```julia
julia> using Symbolics

julia> @variables t x(t);

julia> D = Differential(t);

julia> is_derivative(D(x))
true

julia> is_derivative(Symbolics.unwrap(D(x)))
true

julia> is_derivative(D(x) + x)
false

julia> is_derivative(expand_derivatives(D(x^2)))
false

julia> Symbolics.hasnode(is_derivative, D(x) + x)
true
```

See also: [`Differential`](@ref), [`expand_derivatives`](@ref), [`Symbolics.hasnode`](@ref),
[`Symbolics.filterchildren`](@ref),
[`SymbolicUtils.unwrap`](https://symbolicutils.juliasymbolics.org/api/#SymbolicUtils.unwrap).
"""
function is_derivative(x::SymbolicT)
    @match x begin
        BSImpl.Term(; f) && if f isa Differential end => true
        _ => false
    end
end
is_derivative(x) = iswrapped(x) && is_derivative(unwrap(x))

Base.:*(D1::ComposedFunction, D2::Differential) = D1 ∘ D2
Base.:*(D1::Differential, D2::Union{Operator, Function}) = D1 ∘ D2
function Base.:^(D::Differential, n::Integer)
    iszero(n) && return identity
    return Differential(D.x, D.order * n)
end

function Base.show(io::IO, D::Differential)
    warn_load_latexify()
    print(io, "Differential(", D.x, ", ", D.order, ")")
end
Base.nameof(D::Differential) = :Differential

Base.:(==)(D1::Differential, D2::Differential) = isequal(D1.x, D2.x) && isequal(D1.order, D2.order)
Base.hash(D::Differential, u::UInt) = hash(D.order, hash(D.x, xor(u, 0xdddddddddddddddd)))

"""
    $(TYPEDSIGNATURES)

Clear caches of all cached functions involved in computing derivatives.
"""
function clear_derivative_caches!() # public
    SymbolicUtils.clear_cache!(occursin_info)
    SymbolicUtils.clear_cache!(recursive_hasoperator)
end

"""
    $(TYPEDSIGNATURES)

Toggle caching in derivative related functions.
"""
function toggle_derivative_caching!(value::Bool) # public
    SymbolicUtils.toggle_caching!(occursin_info, value)
    SymbolicUtils.toggle_caching!(recursive_hasoperator, value)
end

"""
    $(TYPEDSIGNATURES)

Return a collection of all functions involved in derivative computation
that are cached.
"""
function cached_derivative_functions() # public
    (occursin_info, recursive_hasoperator)
end

SymbolicUtils.@cache limit = 500_000 function occursin_info(x::BasicSymbolic{VartypeT}, expr::BasicSymbolic{VartypeT}, fail::Bool = true)::Bool
    _occursin_info(x, expr, fail)
end

occursin_info(x::BasicSymbolic{VartypeT}, expr, fail::Bool = true) = false

# Allow scalarized expressions
@inline function is_scalar_indexed(ex::BasicSymbolic{VartypeT})
    # any `BSImpl.Term(; f = getindex)` is scalar - slicing is an arrayop
    @match ex begin
        BSImpl.Term(; f) && if f === getindex end => true
        _ => false
    end
end

function _occursin_info(x::BasicSymbolic{VartypeT}, expr::BasicSymbolic{VartypeT}, fail::Bool = true)
    shexpr = shape(expr)
    isix = is_scalar_indexed(x)
    isie = is_scalar_indexed(expr)

    if SymbolicUtils.is_array_shape(shexpr)
        fail && error("Differentiation with array expressions is not yet supported")
        if isix
            return isequal(expr, arguments(x)[1]) || SymbolicUtils.query(isequal(x), expr)
        end
        return SymbolicUtils.query(isequal(x), expr)
    end

    iscall(expr) || return isequal(x, expr)
    isequal(x, expr) && return true

    @match expr begin
        BSImpl.ArrayOp(; expr, term) && if term === nothing end => begin
            aop_pred = let x = x, isix = isix
                function _aop_pred(ex::SymbolicT)
                    isequal(ex, x) || isix && iscall(ex) && operation(ex) === getindex && isequal(arguments(ex)[1], arguments(x)[1])
                end
            end
            return SU.query(aop_pred, expr)
        end
        _ => nothing
    end
    if isie
        isix && return false
        return SymbolicUtils.query(isequal(x), expr)
    end

    op = operation(expr)

    if op isa Integral
        # check if x occurs in limits
        domain = op.domain
        lower, upper = unwrap.(IntervalSets.endpoints(domain.domain))
        (occursin_info(x, lower) || occursin_info(x, upper)) && return true

        # check if x is shadowed by integration variable in integrand
        isequal(domain.variables, x) && return false
    end

    predicate = let cond = op !== getindex &&
            op !== LinearAlgebra.dot &&
            op !== LinearAlgebra.norm &&
            !SU.isarrayop(expr),
            x = x
        function __predicate(a)
            return occursin_info(x, a, cond)
        end
    end
    any(predicate, arguments(expr))
end

"""
    hasderiv(O)

Returns true if the expression or equation `O` contains [`Differential`](@ref) terms.
"""
hasderiv(O) = recursive_hasoperator(Differential, O)


_recursive_hasoperator(::Type{op}, eq::Equation) where {op} = recursive_hasoperator(op, eq.lhs) || recursive_hasoperator(op, eq.rhs)
_recursive_hasoperator(::Type{op}) where {op} = Base.Fix1(recursive_hasoperator, op) # curry version
_recursive_hasoperator(::Type{T}, ::T) where T = true


"""
    recursive_hasoperator(op, O)

An internal function that contains the logic for [`hasderiv`](@ref).
Return true if `O` contains a term with `Operator` `op`.
"""
SymbolicUtils.@cache function recursive_hasoperator(op::Any, O::Any)::Bool
    _recursive_hasoperator(op, O)
end

function _recursive_hasoperator(::Type{op}, O::SymbolicT) where {op}
    @match O begin
        BSImpl.Const(;) => false
        BSImpl.Sym(;) => false
        BSImpl.Term(; f, args) => f isa op || any(_recursive_hasoperator(op), args)
        BSImpl.AddMul(; dict) => any(_recursive_hasoperator(op), keys(dict))
        BSImpl.Div(; num, den) => recursive_hasoperator(op, num) || recursive_hasoperator(op, den)
        BSImpl.ArrayOp(; expr, term) => begin
            if term isa SymbolicT
                recursive_hasoperator(op, term) && return true
            end
            recursive_hasoperator(op, expr)
        end
        BSImpl.ArrayMaker(; values) => any(_recursive_hasoperator(op), values)
    end
end
_recursive_hasoperator(::Type{op}, O) where {op} = false

struct DerivativeNotDefinedError <: Exception
    expr
    i::Int
end

function Base.showerror(io::IO, err::DerivativeNotDefinedError)
    op = operation(err.expr)
    nargs = length(arguments(err.expr))
    # `Markdown.parse` instead of `@md_str` to allow interpolating inside `literal` blocks
    # and code fences
    err_str = Markdown.parse("""
        Derivative of `$(err.expr)` with respect to its $(err.i)-th argument is not defined.
        Define a derivative by using `@register_derivative`:

        ```julia
        @register_derivative $op(args...) $(err.i) begin
            # ...
        end
        ```

        Refer to the documentation for `@register_derivative` and the
        "[Adding Analytical Derivatives](@ref)" section of the docs for further information.
        """)
    show(io, MIME"text/plain"(), err_str)
end

function symdiff_substitute_filter(ex::BasicSymbolic{T}) where {T}
    SymbolicUtils.default_substitute_filter(ex) || @match ex begin
        BSImpl.Term(; f) && if f isa Differential end => true
        _ => false
    end
end

"""
    $(TYPEDSIGNATURES)

Identical to `substitute` except it also substitutes inside `Differential` operator
applications.
"""
function substitute_in_deriv(ex, rules; kw...)
    substitute(ex, rules; kw..., filterer = symdiff_substitute_filter)
end

function deriv_and_depvar_substitute_filter(ex::SymbolicT)
    SymbolicUtils.default_substitute_filter(ex) || @match ex begin
        BSImpl.Term(; f) && if f isa Differential end => true
        BSImpl.Term(; f) && if f isa SymbolicT end => true
        _ => false
    end
end

"""
    $(TYPEDSIGNATURES)

Identical to `substitute` except it also substitutes inside `Differential` operator
applications and dependent variables.
"""
function substitute_in_deriv_and_depvar(ex, rules; kw...)
    substitute(ex, rules; kw..., filterer = deriv_and_depvar_substitute_filter)
end

function chain_diff(D::Differential, arg::BasicSymbolic{VartypeT}, inner_args::SymbolicUtils.ROArgsT{VartypeT}; kw...)
    any(isequal(D.x), inner_args) && return D(arg)

    summed_args = SymbolicUtils.ArgsT{VartypeT}()
    sizehint!(summed_args, length(inner_args))
    for a in inner_args
        t1 = executediff(Differential(a), arg; kw...)
        t2 = executediff(D, a; kw...)
        push!(summed_args, t1 * t2)
    end
    return SymbolicUtils.add_worker(VartypeT, summed_args)
end

"""
    executediff(D, arg; simplify=false, occurrences=nothing)

Apply the passed Differential D on the passed argument.

This function differs to `expand_derivatives` in that in only expands the
passed differential and not any other Differentials it encounters.

# Arguments
- `D::Differential`: The differential to apply
- `arg::BasicSymbolic`: The symbolic expression to apply the differential on.
- `simplify::Bool=false`: Whether to simplify the resulting expression using
    [`SymbolicUtils.simplify`](https://symbolicutils.juliasymbolics.org/api/#SymbolicUtils.simplify).
- `occurrences=nothing`: Information about the occurrences of the independent
    variable in the argument of the derivative. This is used internally for
    optimization purposes.
- `throw_no_derivative=false`: Whether to throw if a function with unknown
    derivative is encountered.
"""
function executediff(D::Differential, arg::BasicSymbolic{VartypeT}; simplify=false, throw_no_derivative=false)
    isinteger(D.order) || throw(ArgumentError("`executediff` requires integer derivative order."))
    order = floor(Int, D.order)
    if order > 1
        for _ in 1:order
            arg = executediff(Differential(D.x), arg; simplify, throw_no_derivative)
        end
        return arg
    end
    isequal(arg, D.x) && return COMMON_ONE
    @match arg begin
        BSImpl.Term(; f, args, shape) && if f === (*) && length(args) == 2 && isempty(shape) end => begin
            @match args[1] begin
                BSImpl.Term(; f = f2, args = args2) && if f2 === adjoint end => begin
                    arg = LinearAlgebra.dot(
                        collect(args2[1])::Vector{SymbolicT},
                        collect(args[2])::Vector{SymbolicT}
                    )
                end
                _ => nothing
            end
        end
        BSImpl.Term(; f, args) && if f === LinearAlgebra.dot end => begin
            arg = LinearAlgebra.dot(
                collect(args[1])::Vector{SymbolicT}, collect(args[2])::Vector{SymbolicT}
            )
        end
        BSImpl.Term(; f, args) && if f === LinearAlgebra.norm end => begin
            add_buffer = SArgsT()
            arr = args[1]
            for i in SymbolicUtils.stable_eachindex(arr)
                push!(add_buffer, abs2(arr[i]))
            end
            arg = sqrt(SymbolicUtils.add_worker(VartypeT, add_buffer))
        end
        BSImpl.ArrayOp(; output_idx) && if isempty(output_idx) end => begin
            # Some sort of `mapreduce`
            arg = SymbolicUtils.scalarize(arg)::SymbolicT
        end
        _ => nothing
    end
    occursin_info(D.x, arg) || return COMMON_ZERO

    # We can safely assume `arg` is scalar, else `occursin_info` would have errored.
    @match arg begin
        # Const case will never be reached because of `occursin_info`
        # if the sym were equal to `D.x` we wouldn't be here
        BSImpl.Sym(;) => return COMMON_ZERO
        BSImpl.Term(; f, args) => begin
            if f isa BasicSymbolic{VartypeT}
                # the only case where `f` is a symbolic is if this is a called symbolic
                # function or a dependent variable. In either case, we know it contains
                # `D.x` because of `occursin_info` and will just return `D(arg)`
                inner_args = arguments(arg)
                return chain_diff(D, arg, inner_args; simplify, throw_no_derivative)
            elseif f === getindex
                arr = arguments(arg)[1]
                inner_args = arguments(arguments(arg)[1])
                idx = SymbolicUtils.StableIndex(@views arguments(arg)[2:end])
                summed_args = SymbolicUtils.ArgsT{VartypeT}()
                sizehint!(summed_args, length(inner_args))
                # We know `D.x` is in `arg`, so the derivative is not identically zero.
                # `arg` cannot be `D.x` since, that would have also early exited.
                for (i, a) in enumerate(inner_args)
                    der = derivative_idx(arr, i)::Union{Nothing, SymbolicT}
                    if isequal(a, D.x)
                        der === nothing && return D(arg)
                        push!(summed_args, der[idx])
                        continue
                    elseif der === nothing
                        push!(summed_args, Differential(a)(arg) * executediff(D, a))
                    else
                        push!(summed_args, der[idx] * executediff(D, a))
                    end
                end
                return SymbolicUtils.add_worker(VartypeT, summed_args)
            elseif f === ifelse || f === ifelse_eager || f === ifelse_branching
                inner_args = arguments(arg)
                dtrue = executediff(D, inner_args[2]; throw_no_derivative)
                dfalse = executediff(D, inner_args[3]; throw_no_derivative)
                args = SymbolicUtils.ArgsT{VartypeT}((inner_args[1], dtrue, dfalse))
                # Preserve the conditional variant so the derivative keeps the same
                # eager/branching lowering behaviour as the primal.
                return BSImpl.Term{VartypeT}(f, args; type = symtype(arg), shape = shape(arg))
            elseif f isa Differential
                # The recursive expand_derivatives was not able to remove
                # a nested Differential. We can attempt to differentiate the
                # inner expression wrt to the outer iv. And leave the
                # unexpandable Differential outside.
                isequal(f.x, D.x) && return D(arg)
                inner_args = arguments(arg)
                innerdiff = executediff(D, inner_args[1]; simplify, throw_no_derivative)
                return @match innerdiff begin
                    BSImpl.Term(; f = finner) && if finner isa Differential end => D(arg)
                    _ => executediff(f, innerdiff; simplify, throw_no_derivative)
                end
            elseif f isa Integral && f.domain.domain isa AbstractInterval
                domain = f.domain.domain
                domainvars = f.domain.variables
                a, b = unwrap.(IntervalSets.endpoints(domain))
                summed_args = SymbolicUtils.ArgsT{VartypeT}()
                inner_function = arguments(arg)[1]
                if iscall(a) || isequal(a, D.x)
                    t1 = substitute_in_deriv_and_depvar(inner_function, Dict(domainvars => a))
                    t2 = executediff(D, a; simplify, throw_no_derivative)
                    push!(summed_args, -t1*t2)
                end
                if iscall(b) || isequal(b, D.x)
                    t1 = substitute_in_deriv_and_depvar(inner_function, Dict(domainvars => b))
                    t2 = executediff(D, b; simplify, throw_no_derivative)
                    push!(summed_args, t1*t2)
                end
                inner = executediff(D, inner_function; simplify, throw_no_derivative)
                push!(summed_args, f(inner))
                return SymbolicUtils.add_worker(VartypeT, summed_args)
            elseif f === (^) && SymbolicUtils.isconst(args[2])
                base, exp = args
                prod_args = (exp, (base ^ Const{VartypeT}(exp - 1))::BasicSymbolic{VartypeT}, executediff(D, base; simplify, throw_no_derivative))
                return SymbolicUtils.mul_worker(VartypeT, prod_args)
            elseif f isa SymbolicUtils.Operator # operator applications return a new variable
                return COMMON_ZERO
            else
                inner_args = arguments(arg)
                summed_args = SymbolicUtils.ArgsT{VartypeT}()

                for (i, iarg) in enumerate(inner_args)
                    t2 = executediff(D, iarg; simplify, throw_no_derivative)::SymbolicT
                    _iszero(t2) && continue
                    t = derivative_idx(arg, i)::Union{Nothing, SymbolicT}
                    if t === nothing
                        throw_no_derivative && throw(DerivativeNotDefinedError(arg, i))
                        t = D(arg)
                    end
                    if !_isone(t2)
                        t = t * t2
                    end
                    push!(summed_args, t)
                end
                return SymbolicUtils.add_worker(VartypeT, summed_args)
            end
        end
        BSImpl.AddMul(; coeff, dict, variant) => begin
                if variant == SymbolicUtils.AddMulVariant.ADD
                    inner_args = arguments(arg)
                    summed_args = SymbolicUtils.ArgsT{VartypeT}()
                    for iarg in inner_args
                        t2 = executediff(D, iarg; simplify, throw_no_derivative)
                        _iszero(t2) && continue
                        push!(summed_args, t2)
                    end
                    return SymbolicUtils.add_worker(VartypeT, summed_args)
                else
                    # Do the `add_with_div` trick where we write to `inner_args` to avoid
                    # copying the array but restore its state after.
                    # TODO: This might be possible to do faster by using `_mul_worker!`
                    # directly
                    inner_args = parent(arguments(arg))
                    summed_args = SymbolicUtils.ArgsT{VartypeT}()

                    for (i, iarg) in enumerate(inner_args)
                            t2 = executediff(D, iarg; simplify, throw_no_derivative)
                            _iszero(t2) && continue
                        try
                            inner_args[i] = t2
                            push!(summed_args, SymbolicUtils.mul_worker(VartypeT, inner_args))
                        finally
                            inner_args[i] = iarg
                        end
                    end
                    return SymbolicUtils.add_worker(VartypeT, summed_args)
                end
        end
        BSImpl.Div(; num, den) => begin
            dnum = executediff(D, num; simplify, throw_no_derivative)
            dden = executediff(D, den; simplify, throw_no_derivative)
            return (dnum / den - num * dden / den^2)
            newnum = den * dnum - num * dden
            newden = dden ^ 2
            return SymbolicUtils.Div{VartypeT}(newnum, newden, false; type = symtype(arg), shape = shape(arg))
        end
        BSImpl.ArrayOp(; output_idx, expr, reduce, term, ranges) => begin
            if term !== nothing
                term = executediff(D, term; simplify, throw_no_derivatives)
            end
            expr = executediff(D, expr; simplify, throw_no_derivatives)
            return BSImpl.ArrayOp{VartypeT}(output_idx, expr, reduce, term, ranges; type = symtype(arg), shape = shape(arg))
        end
    end
end
executediff(D::Differential, arg::Num; kw...) = executediff(D, unwrap(arg); kw...)
executediff(D::Differential, arg::Number; kw...) = COMMON_ZERO

"""
$(SIGNATURES)

Expands derivatives within a symbolic expression `O`.

This function recursively traverses a symbolic expression, applying the chain rule
and other derivative rules to expand any derivatives it encounters.

# Arguments
- `O::BasicSymbolic`: The symbolic expression to expand.
- `simplify::Bool=false`: Whether to simplify the resulting expression using
    [`SymbolicUtils.simplify`](https://symbolicutils.juliasymbolics.org/api/#SymbolicUtils.simplify).

# Keyword Arguments
- `throw_no_derivative=false`: Whether to throw if a function with unknown
   derivative is encountered.

# Examples
```jldoctest
julia> @variables x y z k;

julia> f = k*(abs(x-y)/y-z)^2
k*((-z + abs(x - y) / y)^2)

julia> Dx = Differential(x) # Differentiate wrt x
Differential(x, 1)

julia> dfx = expand_derivatives(Dx(f))
(2ifelse(signbit(x - y), -1, 1)*k*(-z + abs(x - y) / y)) / y
```
"""
function expand_derivatives(O::BasicSymbolic, simplify=false; throw_no_derivative=false)
    @match O begin
        BSImpl.Term(; f, args) && if f isa Differential end => begin
            arg = expand_derivatives(args[1], false; throw_no_derivative)
            return executediff(f, arg; simplify, throw_no_derivative)
        end
        BSImpl.Term(; f, args) && if f isa Integral end => begin
            return f(expand_derivatives(args[1]; throw_no_derivative))
        end
        if !hasderiv(O) end => return O
        _ => begin
            newargs = SArgsT()
            for arg in arguments(O)
                push!(newargs, expand_derivatives(arg, false; throw_no_derivative))
            end
            O1 = maketerm(SymbolicT, operation(O), newargs, nothing; type = symtype(O))
            return simplify ? SymbolicUtils.simplify(O1) : O1
        end
    end
end
function expand_derivatives(n::Num, simplify=false; kwargs...)
    Num(expand_derivatives(value(n), simplify; kwargs...))
end
function expand_derivatives(n::Complex{Num}, simplify=false; kwargs...)
    re = expand_derivatives(real(n), simplify; kwargs...)
    img = expand_derivatives(imag(n), simplify; kwargs...)
    Complex{Num}(Num(re), Num(img))
end
expand_derivatives(x, simplify=false; kwargs...) = x

function count_order(x)
    @assert !(x isa Symbol) "The variable $x must have an order of differentiation that is greater or equal to 1!"
    n = 1
    while !(x.args[1] isa Symbol)
        n = n+1
        x = x.args[1]
    end
    n, x.args[1]
end

_repeat_apply(f, n) = n == 1 ? f : ComposedFunction{Any,Any}(f, _repeat_apply(f, n-1))
function _differential_macro(x)
    ex = Expr(:block)
    push!(ex.args,  :(Base.depwarn("`@derivatives D'''~x` is deprecated. Use `Differential(x)^3` instead.", Symbol("@derivatives"))))
    lhss = Symbol[]
    x = x isa Tuple && first(x).head == :tuple ? first(x).args : x # tuple handling
    x = flatten_expr!(x)
    for di in x
        @assert di isa Expr && di.args[1] == :~ "@derivatives expects a form that looks like `@derivatives D''~t E'~t` or `@derivatives (D''~t), (E'~t)`"
        lhs = di.args[2]
        rhs = di.args[3]
        order, lhs = count_order(lhs)
        push!(lhss, lhs)
        expr = :($lhs = Differential($rhs, $order))
        push!(ex.args,  expr)
    end
    push!(ex.args, Expr(:tuple, lhss...))
    ex
end

"""
$(SIGNATURES)

Define one or more differentials.

# Examples

```jldoctest
julia> using Symbolics

julia> @variables x y z;

julia> Dx = Differential(x); Dy = Differential(y);  # Create differentials wrt. x and y

julia> Dx(z)  # Differentiate z wrt. x
Differential(x, 1)(z)

julia> Dy(z)  # Differentiate z wrt. y
Differential(y, 1)(z)
```
"""
macro derivatives(x...)
    esc(_differential_macro(x))
end


### Jacobians & Hessians

"""
$(SIGNATURES)

A helper function for computing the derivative of the expression `O` with respect to
`var`.

# Keyword Arguments

- `simplify=false`: The simplify argument of `expand_derivatives`.

All other keyword arguments are forwarded to `expand_derivatives`.
"""
function derivative(O, var; simplify=false, kwargs...)
    if O isa AbstractArray
        Num[Num(expand_derivatives(Differential(var)(unwrap(o)), simplify; kwargs...)) for o in O]
    else
        Num(expand_derivatives(Differential(var)(unwrap(O)), simplify; kwargs...))
    end
end
derivative(f::Function, var::Union{SymbolicT, Num}) = derivative(f(var), var)
derivative(::Function, x::Any) = throw(TypeError(:derivative, "2nd argument", Union{Num, SymbolicT}, x))

"""
$(SIGNATURES)

A helper function for computing the gradient of the expression `O` with respect to
an array of variable expressions.

# Keyword Arguments

- `simplify=false`: The simplify argument of `expand_derivatives`.

All other keyword arguments are forwarded to `expand_derivatives`.
"""
function gradient(O, vars::AbstractVector; simplify=false, kwargs...)
    Num[Num(expand_derivatives(Differential(vars[vi])(unwrap(O)),simplify; kwargs...)) for vi in eachindex(vars)]
end

"""
$(SIGNATURES)

A helper function for computing the Jacobian of an array of expressions with respect to
an array of variable expressions.

# Keyword Arguments

- `simplify=false`: The simplify argument of `expand_derivatives`.
- `scalarize=true`: Whether to scalarize `ops` and `vars` before computing the jacobian.

All other keyword arguments are forwarded to `expand_derivatives`.
"""
function jacobian(ops::AbstractVector, vars::AbstractVector{SymbolicT};
                  simplify=false, scalarize::Union{Val{true}, Val{false}}=Val(true), kwargs...)
    if scalarize isa Val{true}
        ops = Symbolics.scalarize(ops)
        vars = Symbolics.scalarize(vars)
    end
    # Pre-compute variable sets to skip differentiating trivially zero Jacobian entries.
    op_varsets = map(op -> _augment_with_call_args!(SymbolicUtils.search_variables(op)), ops)
    result = fill(COMMON_ZERO, length(ops), length(vars))
    for i in eachindex(ops), j in eachindex(vars)
        (vars[j] in op_varsets[i]) || continue
        result[i, j] = executediff(Differential(vars[j]), ops[i]; simplify, kwargs...)
    end
    return result
end

function _augment_with_call_args!(vs)
    extra = SymbolicT[]
    for s in vs
        SymbolicUtils.iscall(s) || continue
        for arg in SymbolicUtils.arguments(s)
            push!(extra, arg)
        end
    end
    for e in extra
        push!(vs, e)
    end
    return vs
end

function jacobian(ops, vars; simplify=false, kwargs...)
    ops = vec(scalarize(ops))
    if ops isa Vector{Num}
        ops = unwrap.(ops)::Vector{SymbolicT}
    elseif ops isa Vector{SymbolicT}
    else
        ops = ops::Vector{eltype(ops)}
    end
    # Suboptimal, but prevents wrong results on Arr for now. Arr resulting from a symbolic function will fail on this due to unknown size.
    vars = vec(scalarize(vars))
    if vars isa Vector{Num}
        vars = unwrap.(vars)::Vector{SymbolicT}
    elseif vars isa Vector{SymbolicT}
    else
        error("This should not happen! `vars` must be convertible to Vector{SymbolicT}. \nReceived vars = $vars")
    end
    _res = jacobian(ops, vars; simplify=simplify, scalarize=Val(false), kwargs...)
    res = similar(_res, Num)
    map!(Num, res, _res)
    return res
end

function faster_maybe_scalarize!(arg::Vector)
    for (i, x) in enumerate(arg)
        arg[i] = scalarize(x)
    end
    return arg
end

faster_maybe_scalarize!(arg) = scalarize(arg)

"""
$(SIGNATURES)

A helper function for computing the sparse Jacobian of an array of expressions with respect to
an array of variable expressions.

# Keyword Arguments

- `simplify=false`: The simplify argument of `expand_derivatives`.

All other keyword arguments are forwarded to `expand_derivatives`.
"""
function sparsejacobian(ops::AbstractVector, vars::AbstractVector; simplify::Bool=false, kwargs...)
    ops = faster_maybe_scalarize!(ops)
    vars = faster_maybe_scalarize!(vars)
    sp = jacobian_sparsity(ops, vars)
    I,J,_ = findnz(sp)

    exprs = sparsejacobian_vals(ops, vars, I, J; simplify=simplify, kwargs...)

    sparse(I, J, exprs, length(ops), length(vars))
end

"""
$(SIGNATURES)

A helper function for computing the values of the sparse Jacobian of an array of expressions with respect to
an array of variable expressions given the sparsity structure.

# Keyword Arguments

- `simplify=false`: The simplify argument of `expand_derivatives`.

All other keyword arguments are forwarded to `expand_derivatives`.
"""
function sparsejacobian_vals(ops::AbstractVector, vars::AbstractVector, I::AbstractVector, J::AbstractVector; simplify::Bool=false, kwargs...)
    ops = faster_maybe_scalarize!(ops)
    vars = faster_maybe_scalarize!(vars)

    exprs = Num[]
    sizehint!(exprs, length(I))

    for (i,j) in zip(I, J)
        push!(exprs, Num(expand_derivatives(Differential(vars[j])(ops[i]), simplify; kwargs...)))
    end
    exprs
end

"""
$(TYPEDSIGNATURES)

Return the sparsity pattern of the Jacobian of an array of expressions with respect to
an array of variable expressions.

# Arguments
- `exprs`: an array of symbolic expressions.
- `vars`: an array of symbolic variables.

# Examples
```jldoctest
julia> using Symbolics

julia> vars = @variables x₁ x₂;

julia> exprs = [2x₁, 3x₂, 4x₁ * x₂];

julia> Symbolics.jacobian_sparsity(exprs, vars)
3×2 SparseArrays.SparseMatrixCSC{Bool, Int64} with 4 stored entries:
 1  ⋅
 ⋅  1
 1  1
```
"""
function jacobian_sparsity(exprs::AbstractArray, vars::AbstractArray)
    if any(iswrapped, exprs)
        du = map(value, exprs)
    else
        du = exprs
    end
    if any(iswrapped, vars)
        u = map(value, vars)
    else
        u = vars
    end
    dict = Dict(zip(u, 1:length(u)))

    i = Ref(1)
    I = Int[]
    J = Int[]
    sizehint!(I, 2length(exprs))
    sizehint!(J, 2length(vars))


    # This rewriter notes down which u's appear in a
    # given du (whose index is stored in the `i` Ref)

    function r(x)
        if iscall(x)
            for y in arguments(x)
                r(y)
            end
        end
        j = get(dict, x, -1)
        if j != -1
            push!(I, i[])
            push!(J, j)
        end
    end

    for ii = 1:length(du)
        i[] = ii
        r(du[ii])
    end

    sparse(I, J, true, length(du), length(u))
end
"""
$(TYPEDSIGNATURES)

Return the sparsity pattern of the Jacobian of the mutating function `f!`.

# Arguments
- `f!`: an in-place function `f!(output, input, args...; kwargs...)`.
- `output`: output array.
- `input`: input array.

The [eltype](https://docs.julialang.org/en/v1/base/collections/#Base.eltype)
of `output` and `input` can be either symbolic or
[primitive](https://docs.julialang.org/en/v1/manual/types/#Primitive-Types).

# Examples
```jldoctest
julia> using Symbolics

julia> f!(y, x) = y .= [x[2], 2x[1], 3x[1] * x[2]];

julia> output = Vector{Float64}(undef, 3);

julia> input = Vector{Float64}(undef, 2);

julia> Symbolics.jacobian_sparsity(f!, output, input)
3×2 SparseArrays.SparseMatrixCSC{Bool, Int64} with 4 stored entries:
 ⋅  1
 1  ⋅
 1  1
```
"""
function jacobian_sparsity(f!, output::AbstractArray, input::AbstractArray,
                           args...; kwargs...)
    exprs = similar(output, Num)
    fill!(exprs, false)
    vars = ArrayInterface.restructure(input, map(variable, eachindex(input)))
    f!(exprs, vars, args...; kwargs...)
    jacobian_sparsity(exprs, vars)
end

"""
    exprs_occur_in(exprs::Vector, expr)

Return an array of booleans `finds` where `finds[i]` is true if `exprs[i]` occurs in `expr`
false otherwise.
"""
function exprs_occur_in(exprs, expr)
    vec(jacobian_sparsity([expr], exprs))
end

"""
$(SIGNATURES)

A helper function for computing the Hessian of the expression `O` with respect to
an array of variable expressions.

# Keyword Arguments

- `simplify=false`: The simplify argument of `expand_derivatives`.

All other keyword arguments are forwarded to `expand_derivatives`.
"""
function hessian(O, vars::AbstractVector; simplify=false, kwargs...)
    vars = map(value, vars)
    first_derivs = map(value, vec(jacobian([values(O)], vars; simplify=simplify, kwargs...)))
    n = length(vars)
    H = Array{Num, 2}(undef,(n, n))
    fill!(H, 0)
    for i=1:n
        for j=1:i
            H[j, i] = H[i, j] = expand_derivatives(Differential(vars[i])(first_derivs[j]), simplify; kwargs...)
        end
    end
    H
end

hessian(O, vars::Arr; kwargs...) = hessian(O, collect(vars); kwargs...)

isidx(x) = unwrap_const(x) isa TermCombination

basic_mkterm(t, g, args, m) = metadata(Term{VartypeT}(g, args; type = Any), m)

const _scalar = one(TermCombination)

const linearity_rules = (
      (@rule +(~~xs) => reduce(+, filter(isidx, map(unwrap_const, ~~xs)), init=_scalar)),
      (@rule *(~~xs) => reduce(*, filter(isidx, map(unwrap_const, ~~xs)), init=_scalar)),

      (@rule (~f)(~x) => isidx(~x) ? combine_terms_1(linearity_1(~f), ~x) : _scalar),
      (@rule (^)(~x::isidx, ~y) => ~y isa Number && isone(~y) ? ~x : (~x) * (~x)),
      (@rule (~f)(~x, ~y) => combine_terms_2(linearity_2(~f), isidx(~x) ? ~x : _scalar, isidx(~y) ? ~y : _scalar)),

      (@rule ~x::issym => 0),

      # `ifelse(cond, x, y)` can be written as cond * x + (1 - cond) * y
      # where condition `cond` is considered constant in differentiation
      (@rule ifelse(~cond, ~x, ~y) => (isidx(~x) ? ~x : _scalar) + (isidx(~y) ? ~y : _scalar)),
      (@rule ifelse_eager(~cond, ~x, ~y) => (isidx(~x) ? ~x : _scalar) + (isidx(~y) ? ~y : _scalar)),
      (@rule ifelse_branching(~cond, ~x, ~y) => (isidx(~x) ? ~x : _scalar) + (isidx(~y) ? ~y : _scalar)),

      # Fallback: Unknown functions with arbitrary number of arguments have non-zero partial derivatives
      # Functions with 1 and 2 arguments are already handled above
      (@rule (~f)(~~xs) => reduce(+, filter(isidx, map(unwrap_const, ~~xs)); init=_scalar)^2),
)
const linearity_rules_affine = (
      (@rule +(~~xs) => reduce(+, filter(isidx, map(unwrap_const, ~~xs)), init=_scalar)),
      (@rule *(~~xs) => reduce(*, filter(isidx, map(unwrap_const, ~~xs)), init=_scalar)),

      (@rule (~f)(~x) => isidx(~x) ? combine_terms_1(linearity_1(~f), ~x) : _scalar),
      (@rule (^)(~x::isidx, ~y) => ~y isa Number && isone(~y) ? unwrap_const(~x) : unwrap_const(~x) * unwrap_const(~x)),
      (@rule (~f)(~x, ~y) => combine_terms_2(linearity_2(~f), isidx(~x) ? unwrap_const(~x) : _scalar, isidx(~y) ? unwrap_const(~y) : _scalar)),

      (@rule ~x::issym => 0),
      # if the condition is dependent on the variable, do not consider this as affine
      (@rule ifelse(~cond, ~x, ~y) => combine_terms_ifelse_affine(
            isidx(~cond) ? unwrap_const(~cond)::TermCombination : _scalar,
            isidx(~x) ? unwrap_const(~x)::TermCombination : _scalar,
            isidx(~y) ? unwrap_const(~y)::TermCombination : _scalar)),
      (@rule ifelse_eager(~cond, ~x, ~y) => combine_terms_ifelse_affine(
            isidx(~cond) ? unwrap_const(~cond)::TermCombination : _scalar,
            isidx(~x) ? unwrap_const(~x)::TermCombination : _scalar,
            isidx(~y) ? unwrap_const(~y)::TermCombination : _scalar)),
      (@rule ifelse_branching(~cond, ~x, ~y) => combine_terms_ifelse_affine(
            isidx(~cond) ? unwrap_const(~cond)::TermCombination : _scalar,
            isidx(~x) ? unwrap_const(~x)::TermCombination : _scalar,
            isidx(~y) ? unwrap_const(~y)::TermCombination : _scalar)),
      # Fallback: Unknown functions with arbitrary number of arguments have non-zero partial derivatives
      # Functions with 1 and 2 arguments are already handled above
      (@rule (~f)(~~xs) => reduce(+, filter(isidx, map(unwrap_const, ~~xs)); init=_scalar)^2),
)
const linearity_propagator = Fixpoint(Postwalk(Chain(linearity_rules); maketerm=basic_mkterm))
const affine_linearity_propagator = Fixpoint(Postwalk(Chain(linearity_rules_affine); maketerm=basic_mkterm))

"""
$(TYPEDSIGNATURES)

Return the sparsity pattern of the Hessian of an expression with respect to
an array of variable expressions.

# Arguments
- `expr`: a symbolic expression.
- `vars`: a vector of symbolic variables.

# Examples
```jldoctest
julia> using Symbolics

julia> vars = @variables x₁ x₂;

julia> expr = 3x₁^2 + 4x₁ * x₂;

julia> Symbolics.hessian_sparsity(expr, vars)
2×2 SparseArrays.SparseMatrixCSC{Bool, Int64} with 3 stored entries:
 1  1
 1  ⋅
```
"""
function hessian_sparsity(expr, vars::AbstractVector; full::Bool=true, linearity_propagator = linearity_propagator)
    @assert !(expr isa AbstractArray)
    expr = value(expr)
    u = map(value, vars)
    dict = Dict(ui => TermCombination(Set([Dict(i=>1)])) for (i, ui) in enumerate(u))
    f = Rewriters.Prewalk(x-> get(dict, x, x); maketerm=basic_mkterm)(expr)
    lp = unwrap_const(linearity_propagator(f))
    S = _sparse(lp, length(u))
    S = full ? S : tril(S)
end

"""
$(TYPEDSIGNATURES)

Return the sparsity pattern of the Hessian of the given function `f`.

# Arguments
- `f`: an out-of-place function `f(input, args...; kwargs...)`.
- `input`: a vector of input values whose [eltype](https://docs.julialang.org/en/v1/base/collections/#Base.eltype) can be either symbolic or [primitive](https://docs.julialang.org/en/v1/manual/types/#Primitive-Types).

# Examples
```jldoctest
julia> using Symbolics

julia> f(x) = 4x[1] * x[2] - 5x[2]^2;

julia> input = Vector{Float64}(undef, 2);

julia> Symbolics.hessian_sparsity(f, input)
2×2 SparseArrays.SparseMatrixCSC{Bool, Int64} with 3 stored entries:
 ⋅  1
 1  1
```
"""
function hessian_sparsity(f::Function, input::AbstractVector, args...; full::Bool=true, kwargs...)
    vars = ArrayInterface.restructure(input, map(variable, eachindex(input)))
    expr = f(vars, args...; kwargs...)
    hessian_sparsity(expr, vars, full=full)
end

"""
$(SIGNATURES)

Check if an expression is affine with respect to a list of variable expressions.
"""
function isaffine(ex, u)
    isempty(hessian_sparsity(ex, u; linearity_propagator = affine_linearity_propagator).nzval)
end

"""
$(SIGNATURES)

Check if an expression is linear with respect to a list of variable expressions.
"""
function islinear(ex, u)
    isaffine(ex, u) && iszero(Num(substitute(ex, Dict(u .=> 0))))
end

"""
$(SIGNATURES)

A helper function for computing the sparse Hessian of an expression with respect to
an array of variable expressions.

# Keyword Arguments

- `simplify=false`: The simplify argument of `expand_derivatives`.
- `full=false`: Whether to construct the full hessian by also including entries in
  the upper-triangular half of the matrix.

All other keyword arguments are forwarded to `expand_derivatives`.
"""
function sparsehessian(op, vars::AbstractVector; simplify::Bool=false, full::Bool=true, kwargs...)
    op = value(op)
    vars = map(value, vars)
    S = hessian_sparsity(op, vars, full=full)
    I, J, _ = findnz(S)

    exprs = sparsehessian_vals(op, vars, I, J; simplify=simplify, kwargs...)

    H = sparse(I, J, exprs, length(vars), length(vars))

    if full
        for (i, j) in zip(I, J)
            j > i && (H[i, j] = H[j, i])
        end
    end
    return H
end

"""
$(SIGNATURES)

A helper function for computing the values of the sparse Hessian of an expression with respect to
an array of variable expressions given the sparsity structure.

# Keyword Arguments

- `simplify=false`: The simplify argument of `expand_derivatives`.

All other keyword arguments are forwarded to `expand_derivatives`.
"""
function sparsehessian_vals(op, vars::AbstractVector, I::AbstractVector, J::AbstractVector; simplify::Bool=false, kwargs...)
    vars = Symbolics.scalarize(vars)

    exprs = Array{Num}(undef, length(I))
    fill!(exprs, 0)

    prev_j = 0
    d = nothing
    for (k, (i, j)) in enumerate(zip(I, J))
        j > i && continue
        if j != prev_j
            d = expand_derivatives(Differential(vars[j])(op), false; kwargs...)
        end
        expr = expand_derivatives(Differential(vars[i])(d), simplify; kwargs...)
        exprs[k] = expr
        prev_j = j
    end
    exprs
end

using Symbolics

@test inverse(sin) == left_inverse(sin) == right_inverse(sin) == asin
@test inverse(asin) == left_inverse(asin) == right_inverse(asin) == sin
@test has_inverse(sin) && has_left_inverse(sin) && has_right_inverse(sin)
fn = left_inverse(sqrt)
@test right_inverse(fn) == sqrt
@test_throws MethodError inverse(sqrt)
@test_throws MethodError right_inverse(sqrt)
@test !has_inverse(fn) && !has_left_inverse(fn)
@test !has_inverse(sqrt) && !has_right_inverse(sqrt)
@test has_inverse(sin ∘ cos)
@test !has_inverse(sin ∘ sqrt)
@test has_left_inverse(sin ∘ sqrt)
@test inverse(sin ∘ cos) == acos ∘ asin
@test inverse(inverse(sin ∘ cos)) == sin ∘ cos
@test right_inverse(left_inverse(sin ∘ sqrt)) == sin ∘ sqrt
@test inverse(sin ∘ cos ∘ tan) == atan ∘ (acos ∘ asin)

using Symbolics
using SymbolicUtils, Test
using Symbolics: symtype, shape, wrap, unwrap, Arr, jacobian, @variables, value, get_variables, @arrayop, getname, metadata, scalarize, SConst
using Base: Slice
using SymbolicUtils: Sym, term, operation, search_variables
import SymbolicUtils.Code: toexpr
import LinearAlgebra
import LinearAlgebra: dot, Adjoint, cross, Diagonal, diagm, eigmax, eigmin
using StaticArraysCore: SArray
using SparseArrays: sparse
import ..limit2

struct TestMetaT end
Symbolics.option_to_metadata_type(::Val{:test_meta}) = TestMetaT

@testset "arrays" begin
    @variables X[1:5, 1:5] Y[1:5, 1:5]
    @test_throws ArgumentError X[1000]
    @test_throws BoundsError X[10, 1]
    @test typeof(X) <: Arr
    @test shape(X) == [1:5, 1:5]
    @test shape(Y) == [1:5, 1:5]

    A = Y[2, :]
    @test typeof(A) <: Arr{Num,1}
    @test axes(A) == (1:5,)

    B = A[3:5]
    @test axes(B) == (Slice(1:3),)

    @syms i::Int j::Int
    @test symtype(X[i, j]) == Real
    @test symtype(X[1, j]) == Real

    @variables t x(t)[1:2]
    @test isequal(collect(search_variables(0 ~ x[1])), [x[1]])
    @test search_variables(2x) == Set([x]) # both array elements are present
    @test isequal(collect(search_variables(2x[1])), [x[1]])
end

@testset "getname" begin
    @variables t x(t)[1:4]
    v = Symbolics.lower_varname(unwrap(x[2]), unwrap(t), 2)
    @test operation(v) == getindex
    @test unwrap_const(arguments(v)[2]) == 2
    @test getname(v) == getname(arguments(v)[1]) == Symbol("xˍtt")
end

@testset "getindex" begin
    @variables X[1:5, 1:5] Y[1:5, 1:5]

    @test isequal(X[1, 1], wrap(term(getindex, unwrap(X), 1, 1)))

    XX = unwrap(X)
    idxterm = term(getindex, XX, 1, :; type = Vector{Real}, shape = [1:5])
    @test isequal(unwrap(X[1, :]), Symbolics.@arrayop((j,), XX[1, j], term=idxterm))
    idxterm = term(getindex, XX, :, 2; type = Vector{Real}, shape = [1:5])
    @test isequal(unwrap(X[:, 2]), Symbolics.@arrayop((i,), XX[i, 2], term=idxterm))
    idxterm = term(getindex, XX, :, 2:3; type = Matrix{Real}, shape = [1:5, 1:2])
    @test isequal(unwrap(X[:, 2:3]), Symbolics.@arrayop((i, j), XX[i, j], (j in 2:3), term=idxterm))

    @variables t x(t)[1:4]
    @syms i::Int
    @test isequal(x[i], operation(unwrap(x))(t)[i])

    @variables tv v(tv)[1:2] [test_meta = 4] v2(tv)[1:3] [test_meta=[1, 2, 3]]
    @test !isnothing(metadata(unwrap(v)))
    @test hasmetadata(unwrap(v), TestMetaT)
    @test getmetadata(unwrap(v), TestMetaT) == 4
    @test getmetadata(unwrap(v2), TestMetaT) == [1, 2, 3]
    vs = scalarize(v)
    vsw = unwrap.(vs)
    vs2 = scalarize(v2)
    vsw2 = unwrap.(vs2)
    vswparent = arguments(vsw[1])[1]
    @test !isnothing(metadata(vswparent))
    @test hasmetadata(vswparent, TestMetaT)
    @test getmetadata(vswparent, TestMetaT) == 4
end

@testset "maketerm" begin
    @variables A[1:5, 1:5] B[1:5, 1:5] C

    T = unwrap(3A)
    @test isequal(T, Symbolics.maketerm(typeof(T), operation(T), arguments(T), nothing))
    T2 = unwrap(3B)
    @test isequal(T2, Symbolics.maketerm(typeof(T), operation(T), [3, unwrap(B)], nothing))
    T3 = unwrap(A .^ 2)
    @test isequal(T3, Symbolics.maketerm(typeof(T3), operation(T3), arguments(T3), nothing))
    T4 = unwrap(A .* C)
    @test isequal(T4, Symbolics.maketerm(typeof(T4), operation(T4), arguments(T4), nothing))
end

getdef(v) = Symbolics.getdefaultval(v)
@testset "broadcast & scalarize" begin
    @variables A[1:5,1:3]=42ones(5, 3) b[1:3]=[2, 3, 5] t x(t)[1:4] u[1:1]
    AA = Symbolics.scalarize(A)
    bb = Symbolics.scalarize(b)
    @test all(isequal(42), getdef.(AA))
    @test getdef.(bb) == [2, 3, 5]
    @test isequal(Symbolics.scalarize([b .* 1; b .* 1]), [bb; bb])
    @test isequal(Symbolics.scalarize(b .^ 1), bb)
    c = A * b

    # Test for issue #575: adjoint multiplication with Symbolics.Arr should not be ambiguous
    @variables d[1:3] E[1:3, 1:3]
    d_vec = collect(d)  # Convert to Vector{Num}
    # These should work without MethodError due to ambiguity
    @test d_vec' isa Adjoint{Num, Vector{Num}}
    @test E isa Symbolics.Arr{Num, 2}
    result1 = d_vec' * E  # This was causing ambiguity error
    result2 = d_vec' * inv(E) * d_vec  # The original failing expression from issue #575
    @test size(result1) == (1, 3)
    @test size(result2) == ()

    @test isequal(collect(sin.(x)),
        sin.([x[i] for i in 1:4]))

    @test isequal(Symbolics.scalarize(sin.(A .* c)[1, 1]),
        sin(A[1, 1] * (b[1] * A[1, 1] +
                       b[2] * A[1, 2] +
                       b[3] * A[1, 3])))

    D = Differential(t)
    # @test isequal(collect(D.(x) .~ x), map(i -> D(x[i]) ~ x[i], eachindex(x)))
    @test_throws ArgumentError A ~ t
    @test isequal(D(x[1]), D(x)[1])
    a = Symbolics.unwrap(D(x)[1])
    @test Symbolics.operation(a) == D
    @test isequal(only(Symbolics.arguments(a)), Symbolics.unwrap(x[1]))

    # #448
    @test isequal(Symbolics.scalarize(u + u), [2u[1]])

    # #417
    @test isequal(Symbolics.scalarize(x'), Symbolics.scalarize(unwrap(x))')

    # #483
    # examples by @gronniger
    @variables A[1:2, 1:2]

    test_mat = [1 2; 3 4]
    repl_dict = Dict(Symbolics.scalarize(A .=> test_mat))
    A2 = A^2
    A3 = A^3
    A4 = A^4
    A5 = A^5
    A6 = A^6
    A7 = A^7

    @syms i::Int j::Int k::Int l::Int m::Int n::Int

    A_ = unwrap(A)
    A3_ = wrap(@arrayop (i, j) A_[i, k] * A_[k, l] * A_[l, j])
    A4_ = wrap(@arrayop (i, j) A_[i, k] * A_[k, l] * A_[l, m] * A_[m, j])
    A5_ = wrap(@arrayop (i, j) A_[i, k] * A_[k, l] * A_[l, m] * A_[m, n] * A_[n, j])

    @test_broken isequal(Symbolics.scalarize((A*A)[k,k]), A[k, 1]*A[1, k] + A[2, k]*A[k, 2])

    # basic tests:
    @test SymbolicUtils._iszero(expand((Symbolics.scalarize(A^2) * Symbolics.scalarize(A))[1,1] -
                  Symbolics.scalarize(A^3)[1,1]))
    @testset "nested scalarize" begin
        @test isequal(unwrap_const.(substitute(Symbolics.scalarize(A2 ), repl_dict)), test_mat^2)
        @test isequal(unwrap_const.(substitute(Symbolics.scalarize(A3_), repl_dict)), test_mat^3)
        @test isequal(unwrap_const.(substitute(Symbolics.scalarize(A3 ), repl_dict)), test_mat^3)
        @test isequal(unwrap_const.(substitute(Symbolics.scalarize(A4_), repl_dict)), test_mat^4)
        @test isequal(unwrap_const.(substitute(Symbolics.scalarize(A4 ), repl_dict)), test_mat^4)
        @test isequal(unwrap_const.(substitute(Symbolics.scalarize(A5_), repl_dict)), test_mat^5)
        @test isequal(unwrap_const.(substitute(Symbolics.scalarize(A5 ), repl_dict)), test_mat^5)
        @test isequal(unwrap_const.(substitute(Symbolics.scalarize(A6 ), repl_dict)), test_mat^6)
        @test isequal(unwrap_const.(substitute(Symbolics.scalarize(A7 ), repl_dict)), test_mat^7)
    end
    @test isequal(Symbolics.scalarize(x'[1, 1]), x[1])

    ##653
    Symbolics.scalarize(inv(A)[1,1])

    ##895
    @test inv(Num.(reshape([1],1,1)))==Num.(reshape([1],1,1))

    # #831
    @syms symT sym1(symT) sym2(symT)
    symvec = [sym1(symT), sym2(symT)]
    weights = rand(2)
    @test isequal(symvec'weights, dot(symvec, weights))
    @test isequal(weights'symvec, dot(weights, symvec))
    @syms sym3(symT)::Real sym4(symT)::Real
    symvec = [sym3(symT), sym4(symT)]
    @test isequal(symvec'weights, weights'symvec)

    # ModelingToolkit.jl#1736
    #
    @variables t F(t)[1:1]

    @test isequal(collect(F ./ t), [F[1] / t])
end

n = 2
A = randn(n, n)
foo(x) = A * x # a function to represent symbolically, note, if this function is defined inside the testset, it's not found by the function fun_eval = eval(fun_ex)
#we use T instead of x to test #1882
@register_array_symbolic foo(T::Vector{Real}) begin
    size = (n,)
    eltype = eltype(T)
    ndims = 1
end

#=
The following two testsets test jacobians for symbolic functions of symbolic arrays. Getting it to work currently requires the user to manually specify propagate_ndims and propagate_shape. Making use of `@register` or `@syms` to specify symbolic functions fail to propagate array shape
=#

@testset "Functions and Jacobians using @syms" begin
    @variables x[1:n]

    x0 = randn(n)
    @test foo(x0) == A * x0
    ex = foo(x)

    fun_oop, fun_iip = build_function(ex, x, expression=Val{false})
    @test fun_oop(x0) == A * x0# UndefVarError: foo not defined

    # Generate an expression instead and eval it manually
    fun_ex_oop, fun_ex_iip = build_function(ex, x, expression=Val{true})
    fun_eval = eval(fun_ex_oop)
    @test fun_eval(x0) == foo(x0)
end


@testset "Functions and Jacobians using manual @wrapped" begin
    @variables x[1:n]

    x0 = randn(n)
    @test foo(x0) == A * x0
    ex = foo(x)

    @test shape(ex) == shape(x)

    fun_oop, fun_iip = build_function(ex, x, expression=Val{false})
    @test fun_oop(x0) == A * x0

    # Generate an expression instead and eval it manually
    fun_ex_oop, fun_ex_ip = build_function(ex, x, expression=Val{true})
    fun_eval = eval(fun_ex_oop)
    @test fun_eval(x0) == foo(x0)

    ## Jacobians
    @test_broken value.(jacobian(foo(x), x)) == A
    @test_broken value.(jacobian(ex , x)) == A

end

@testset "Rules" begin
    @variables X[1:10, 1:5] Y[1:5, 1:10] b[1:10]
   #r = @rule ((~A * ~B) * ~C) => (~A * (~B * ~C)) where (size(~A, 1) * size(~B, 2) >size(~B, 1)  * size(~C, 2))
   #@test isequal(r(unwrap((X * Y) * b)), unwrap(X * (Y * b)))
end

# @testset "2D Diffusion Composed With Stencil Interface" begin
#     n = rand(8:32)

#     @variables u[1:n, 1:n]
#     @makearray v[1:n, 1:n] begin
#         #interior
#         v[2:end-1, 2:end-1] => @arrayop (i, j) u[i-1, j] + u[i+1, j] + u[i, j-1] + u[i, j+1] - 4 * u[i, j]
#         #BCs
#         v[1, 1:end] => 0.0
#         v[n, 1:end] => 0.0
#         v[1:end, 1] => 0.0
#         v[1:end, n] => 0.0
#     end

#     #2D Diffusion composed
#     @makearray ucx[1:n, 1:n] begin
#         ucx[1:end, 1:end] => 0.0 # fill zeros
#         ucx[2:end-1, 2:end-1] => @arrayop (i, j) u[i-1, j] + u[i+1, j] - 2 * u[i, j] (j in 2:n-1)
#     end

#     @makearray ucy[1:n, 1:n] begin
#         ucy[1:end, 1:end] => 0.0 # fill zeros
#         ucy[2:end-1, 2:end-1] => @arrayop (i, j) u[i, j-1] + u[i, j+1] - 2 * u[i, j] (i in 2:n-1)
#     end

#     uc = ucx .+ ucy

#     global V, UC, UCX
#     V, UC, UCX = v, uc, (ucx, ucy)
#     @test isequal(collect(v), collect(uc))
# end

# @testset "ND Diffusion, Stencils with CartesianIndices" begin
#     n = rand(8:32)
#     N = 2

#     @variables t u(t)[fill(1:n, N)...]

#     Igrid = CartesianIndices((fill(1:n, N)...,))
#     Iinterior = CartesianIndices((fill(2:n-1, N)...,))

#     function unitindices(N::Int) #create unit CartesianIndex for each dimension
#         null = zeros(Int, N)
#         if N == 0
#             return CartesianIndex()
#         else
#             return map(1:N) do i
#                 unit_i = copy(null)
#                 unit_i[i] = 1
#                 CartesianIndex(Tuple(unit_i))
#             end
#         end
#     end
#     function Diffusion(N, n)
#         ē = unitindices(N) # for i.e N = 3 => ē = [CartesianIndex((1,0,0)),CartesianIndex((0,1,0)),CartesianIndex((0,0,1))]

#         Dss = map(1:N) do d
#             ranges = CartesianIndices((map(i->d == i ? (2:n-1) : (1:n), 1:N)...,))
#             @makearray x[1:n, 1:n] begin
#                 x[1:n, 1:n] => 0
#                 x[ranges] => @arrayop (i, j) u[CartesianIndex(i, j)-ē[d]] +
#                                                 u[CartesianIndex(i, j)+ē[d]] - 2 * u[i, j]
#             end
#         end

#         return reduce((D1, D2) -> D1 .+ D2, Dss)
#     end

#     D = Diffusion(N, n)

#     @makearray Dxxu[1:n, 1:n] begin
#         Dxxu[1:n, 1:n] => 0
#         Dxxu[2:end-1, 1:end] => @arrayop (i, j) u[i-1, j] + u[i+1, j] - 2 * u[i, j]
#     end

#     @makearray Dyyu[1:n, 1:n] begin
#         Dyyu[1:n, 1:n] => 0
#         Dyyu[1:end, 2:end-1] => @arrayop (i, j) u[i, j-1] + u[i, j+1] - 2 * u[i, j]
#     end

#     @test isequal(collect(D), collect(Dxxu .+ Dyyu))
# end

@testset "Brusselator stencil" begin
    n = 8
    @variables t u(t)[1:n, 1:n] v(t)[1:n, 1:n]

    brusselator_f(x, y, t) = (((x - 0.3)^2 + (y - 0.6)^2) <= 0.1^2) * (t >= 1.1) * 5.0

    x = y = range(0, stop=1, length=n)
    dx = step(x)

    A = 3.4
    alpha = 10.0

    dtu = @arrayop (i, j) alpha * (u[limit2(i - 1, n), j] +
                                   u[limit2(i + 1, n), j] +
                                   u[i, limit2(j + 1, n)] +
                                   u[i, limit2(j - 1, n)] -
                                   4u[i, j]) +
                          1.0 + u[i, j]^2 * v[i, j] - (A + 1) *
                            u[i, j] + brusselator_f(x[i], y[j], t) i in 1:n j in 1:n
    dtv = @arrayop (i, j) alpha * (v[limit2(i - 1, n), j] +
                                   v[limit2(i + 1, n), j] +
                                   v[i, limit2(j + 1, n)] +
                                   v[i, limit2(j - 1, n)] -
                                   4v[i, j]) -
                          u[i, j]^2 * v[i, j] + A * u[i, j] i in 1:n j in 1:n
    lapu = @arrayop (i, j) (u[limit2(i - 1, n), j] +
                            u[limit2(i + 1, n), j] +
                            u[i, limit2(j + 1, n)] +
                            u[i, limit2(j - 1, n)] -
                            4u[i, j]) i in 1:n j in 1:n
    lapv = @arrayop (i, j) (v[limit2(i - 1, n), j] +
                            v[limit2(i + 1, n), j] +
                            v[i, limit2(j + 1, n)] +
                            v[i, limit2(j - 1, n)] -
                            4v[i, j]) i in 1:n j in 1:n
    s = brusselator_f.(x, y', t)

    dtu = wrap(dtu)
    dtv = wrap(dtv)
    lapu = wrap(lapu)
    lapv = wrap(lapv)

    g, f = build_function(dtu, u, v, t, expression=Val{false}, nanmath = false)
    du = zeros(Num, 8, 8)
    f(du, u,v,t)
    @test isequal(collect(du), collect(dtu))

    @test isequal(collect(dtu), collect(1 .+ v .* u.^2 .- (A + 1) .* u .+ alpha .* lapu .+ s))
    @test isequal(collect(dtv), collect(A .* u .- u.^2 .* v .+ alpha .* lapv))
end

@testset "Unwrapped array equality" begin
    @variables x[1:3]
    ux = unwrap(x)
    @test isequal(x, x)
    @test isequal(x, ux)
    @test isequal(ux, x)
end

@testset "Array expression substitution" begin
    @variables x[1:3] p[1:3, 1:3]
    bar(x, p) = p * x
    @register_array_symbolic bar(x::AbstractVector, p::AbstractMatrix) begin
        size = size(x)
        eltype = promote_type(eltype(x), eltype(p))
        ndims = 1
    end

    @test isequal(substitute(bar(x, p), x => ones(3)), bar(ones(3), p))
    @test isequal(substitute(bar(x, p), Dict(x => ones(3), p => ones(3, 3)); fold = Val(true)), wrap(3ones(3)))
    @test isequal(substitute(bar(x, p), [x => ones(3), p => ones(3, 3)]; fold = Val(true)), wrap(3ones(3)))
end

@testset "Partial array substitution" begin
    @variables x[1:3] A[1:2, 1:2, 1:2]

    @test substitute(x[1], Dict(x => [1, 2, 3])) === Num(1)
    @test substitute(A[1,2,1], Dict(A => reshape(1:8, 2, 2, 2))) === Num(3)

    @test substitute(A[1,2,1], Dict(A[1,2,1] => 9)) === Num(9)
end

@testset "Hashes" begin
    @variables u[1:7]
    a, b, c = u[1:5], u[2:6], u[3:7]
    @test !isequal(a, b) && !isequal(b, c) && !isequal(a, c)
    @test hash(a) != hash(b) && hash(b) != hash(c) && hash(a) != hash(c)
end

@testset "Offset Indices" begin
    @variables k[0:3]

    @testset "i = $i" for i in 0:3
        sym = unwrap(k[i])
        @test operation(sym) === getindex
        args = arguments(sym)
        @test length(args) == 2
        @test args[1] === unwrap(k)
        @test unwrap_const(args[2]) === i
    end

    @test_throws BoundsError k[-1]
    @test_throws BoundsError k[4]
end

@testset "Arrayop sorted_arguments" begin
    @variables x[1:3] y[1:3]
    sym = unwrap(x + y)
    @test isequal(SymbolicUtils.sorted_arguments(sym), [unwrap(x), unwrap(y)])
    @test operation(sym) === +
end

@testset "Basic functions test" begin
    @variables a b c
    @variables x[1:3] y[1:3, 1:3]
    arrays = [
        x,
        y,
        unwrap(x),
        unwrap(y),
        collect(y),
        [a, b, c],
        diagm([a, b, c]) * x,
        diagm([a, b, c]) * [a, b, c],
        y * [a, b, c],
        diagm([a, b, c]) * y,
    ]

    xval = rand(3)
    yval = rand(3, 3)
    setup(ex) = quote
        let a = 1.0, b = 2.3, c = 4.5, x = $xval, y = $yval
            $(ex)
        end
    end

    @testset "$arr1 AND $arr2" for arr1 in arrays, arr2 in arrays
        val1 = eval(setup(toexpr(arr1)))
        val2 = eval(setup(toexpr(arr2)))
        if ndims(arr1) == ndims(arr2) == 1 && length(arr1) == length(arr2) == 3
            t1 = setup(toexpr(cross(arr1, arr2)))
            @test eval(t1) ≈ cross(val1, val2)
        end
        if size(arr1) == size(arr2)
            t1 = setup(toexpr(dot(arr1, arr2)))
            @test eval(t1) ≈ dot(val1, val2)

            t1 = setup(toexpr(arr1 .* arr2))
            @test eval(t1) ≈ val1 .* val2

            t1 = setup(toexpr(arr1 + arr2))
            @test eval(t1) ≈ val1 + val2
        end
        t1 = try
            setup(toexpr(arr1'arr2))
        catch
            nothing
        end
        if t1 !== nothing
            @test eval(t1) ≈ val1'val2
        end

        truth = try
            val1 / val2
        catch
            nothing
        end
        if truth !== nothing
            t1 = setup(toexpr(arr1 / arr2))
            @test eval(t1) ≈ truth
        end

        truth = try
            val1 \ val2
        catch
            nothing
        end
        t1 = try
            setup(toexpr(arr1 \ arr2))
        catch
            nothing
        end
        if truth !== nothing && t1 !== nothing
            @test eval(t1) ≈ truth
        end
    end
end

@testset "Scalarization of `Arr` retains type" begin
    @variables x[1:2, 1:2]
    scal = Symbolics.scalarize(x)
    @test scal isa Matrix{Num}
    @test isequal(scal, Num[x[1, 1] x[1, 2]; x[2, 1] x[2, 2]])
end

@testset "Issue#1751: `exp(::Arr)` works" begin
    @variables x[1:3, 1:3]
    @test isequal(exp(x), wrap(exp(unwrap(x))))
    @test isequal(exp(collect(x)), exp(SConst(collect(unwrap(x)))))
end

@testset "eigmax/eigmin build symbolic terms" begin
    @variables x[1:3, 1:3]
    @test operation(unwrap(eigmax(x))) === eigmax
    @test operation(unwrap(eigmin(x))) === eigmin
    # numeric behavior is untouched
    @test eigmax([2.0 0 0; 0 3 0; 0 0 5]) == 5.0
    @test eigmin([2.0 0 0; 0 3 0; 0 0 5]) == 2.0
end

@testset "`transpose(::Arr) * Arr`" begin
    @variables x[1:3]
    t = transpose(x)
    @test t isa Symbolics.Arr{Num, 2}
    @test isequal(unwrap(t), transpose(unwrap(x)))

    @test_nowarn t * x
end

@testset "Arr multiplication intersections" begin
    @variables x[1:2] A[1:2, 1:2]
    values = [1.0, 2.0]
    static_matrix = SArray{Tuple{2, 2}, Float64, 2, 4}((1.0, 0.0, 0.0, 1.0))

    @test Diagonal(values) * x isa SymbolicUtils.BasicSymbolic
    @test transpose(values) * x isa SymbolicUtils.BasicSymbolic
    @test adjoint(values) * x isa SymbolicUtils.BasicSymbolic
    @test static_matrix * x isa SymbolicUtils.BasicSymbolic
    @test x * transpose(values) isa SymbolicUtils.BasicSymbolic
    @test 2 * A * x isa SymbolicUtils.BasicSymbolic
    @test A * x * 2 isa SymbolicUtils.BasicSymbolic
end

@testset "Arr mapreduce intersections" begin
    @variables x[1:2] y[1:2]
    values = view([1.0, 2.0], :)

    @test isequal(scalarize(mapreduce(+, +, x)), x[1] + x[2])
    @test isequal(scalarize(mapreduce(+, +, x, y)), x[1] + x[2] + y[1] + y[2])
    @test isequal(scalarize(mapreduce(+, +, [1.0, 2.0], x)), 3.0 + x[1] + x[2])
    @test mapreduce(+, +, x, values) isa Num
end

@testset "Arr map intersections" begin
    @variables x[1:2] y[1:2]
    static_values = SArray{Tuple{2}}((1.0, 2.0))
    values = view([1.0, 2.0], :)

    @test isequal(scalarize(map(+, x)), scalarize(x))
    @test isequal(scalarize(map(+, x, y)), scalarize(x + y))
    @test isequal(scalarize(map(+, static_values, x)), scalarize(static_values + x))
    @test map(+, x, values) isa Arr
    @test map(+, unwrap(x), y) isa Arr
    @test map(+, x, unwrap(y)) isa Arr
end

@testset "Structured matrix Arr division intersections" begin
    @variables x[1:2] X[1:2, 1:2]
    bidiagonal = LinearAlgebra.Bidiagonal([1.0, 2.0], [3.0], :U)
    sparse_matrix = sparse([1.0 0.0; 0.0 2.0])
    structured = (
        bidiagonal,
        adjoint(bidiagonal),
        LinearAlgebra.Diagonal([1.0, 2.0]),
        LinearAlgebra.Diagonal(SArray{Tuple{2}}((1.0, 2.0))),
        LinearAlgebra.SymTridiagonal([1.0, 2.0], [3.0]),
        LinearAlgebra.Symmetric([1.0 2.0; 2.0 3.0]),
        LinearAlgebra.Hermitian([1.0 2.0; 2.0 3.0]),
        LinearAlgebra.UpperTriangular([1.0 2.0; 0.0 3.0]),
        LinearAlgebra.UnitLowerTriangular([1.0 0.0; 2.0 1.0]),
        sparse_matrix,
        transpose(sparse_matrix),
    )

    for matrix in structured, rhs in (x, X)
        @test matrix \ rhs isa Arr
    end
    for matrix in (X, Num[1 0; 0 1]), rhs in (x, X)
        @test matrix \ rhs isa Arr
    end

    num_bidiagonal = LinearAlgebra.Bidiagonal(Num[1, 2], Num[3], :U)
    right_divisors = (
        num_bidiagonal,
        adjoint(num_bidiagonal),
        transpose(num_bidiagonal),
        LinearAlgebra.Diagonal(Num[1, 2]),
        LinearAlgebra.UpperTriangular(Num[1 2; 0 3]),
        LinearAlgebra.UnitLowerTriangular(Num[1 0; 2 1]),
    )
    for divisor in right_divisors
        @test_throws ArgumentError x / divisor
        @test X / divisor isa Arr
    end
    @test adjoint(Num[1, 2]) / X isa Arr
    @test transpose(Num[1, 2]) / X isa Arr
end

@testset "`getindex(::Arr, ::Num)`" begin
    @variables t x(t)[1:3] i(t)::Int
    @test_nowarn x[i]

    @variables X[1:2, 1:2, 1:2]
    @test X[i, 1, i] isa SymbolicUtils.BasicSymbolic
end

@testset "Arr survives Base generic fallbacks" begin
    @variables x A[1:2, 1:2] b[1:2]
    M = [1.0 2.0; 3.0 4.0]
    @test copy(A) isa Symbolics.Arr{Num, 2}
    @test isequal(copy(A), A)
    @test A / M isa Symbolics.Arr{Num, 2}
    @test M / A isa Symbolics.Arr{Num, 2}
    @test A^x isa Symbolics.Arr
    @test b * adjoint(reshape([1.0, 2.0], 2, 1)) isa SymbolicUtils.BasicSymbolic
    @test b * transpose(reshape([1.0, 2.0], 2, 1)) isa SymbolicUtils.BasicSymbolic
    @test_throws ErrorException ifelse(x > 0, b, A)
    @test_throws ErrorException ifelse(x > 0, A, b)
end

@testset "Bridged mixed symbolic/numeric terms evaluate" begin
    @variables x A[1:2, 1:2] b[1:2]
    M = [1.0 2.0; 3.0 4.0]
    Dg = LinearAlgebra.Diagonal([1.0, 2.0])
    oop(expr, args...) = build_function(expr, args...; expression = Val{false})[1]
    @test oop(Dg / x, x)(2.0) == LinearAlgebra.Diagonal([0.5, 1.0])
    @test oop(Dg \ b, b)([2.0, 4.0]) == [2.0, 2.0]
    @test oop(2 * A * [1.0, 2.0], A)([1.0 0.0; 0.0 1.0]) == [2.0, 4.0]
    @test oop(A / M, A)([1.0 0.0; 0.0 1.0]) ≈ inv(M)
    @test build_function(x in 1:3, x; expression = Val{false})(5) === false
    @test build_function(x in 1:3, x; expression = Val{false})(2) === true
end

import StaticArraysCore
import SparseArrays
using StaticArraysCore: SArray
import Base: eltype, length, ndims, size, axes, eachindex

### Wrapper type for dispatch

"""
    Arr{T, N}(expr)

Array wrapper used by Symbolics to dispatch array-valued symbolic expressions as
`AbstractArray{T, N}`.

# Fields

- `value::BasicSymbolic`: the unwrapped symbolic expression represented by the
  array.

# Arguments

- `expr`: an array-valued symbolic expression whose symbolic type is compatible
  with `Array{T, N}`.

The one-argument constructor `Arr(expr)` infers `T` and `N` from `expr`. In
ordinary user code, array variables are created with [`@variables`](@ref), and
`Arr` is primarily useful when defining dispatch for array-valued symbolic
operations.

# Examples

```julia
julia> using Symbolics

julia> @variables A[1:2, 1:3]

julia> A isa Symbolics.Arr{<:Any, 2}
true
```
"""
struct Arr{T,N} <: AbstractArray{T, N}
    value::BasicSymbolic{VartypeT}

    function Arr{T, N}(ex) where {T, N}
        if is_wrapper_type(T)
            @assert symtype(ex) <: AbstractArray{<:wraps_type(T), N}
        else
            @assert !(T <: BasicSymbolic)
            @assert symtype(ex) <: AbstractArray{T, N}
        end
        new{T, N}(Const{VartypeT}(ex))
    end
end

has_symwrapper(::Type{T}) where {T <: AbstractArray} = true
has_symwrapper(::Type{T}) where {S <: BasicSymbolic, T <: AbstractArray{S}} = false
wrapper_type(::Type{T}) where {S, N, T <: AbstractArray{S, N}} = Arr{maybewrap(S), N}
wrapper_type(::Type{T}) where {T <: AbstractArray} = Arr
is_wrapper_type(::Type{T}) where {T <: Arr} = true # used in `@register`
wraps_type(::Type{T}) where {S, N, T <: Arr{S, N}} = Array{is_wrapper_type(S) ? wraps_type(S) : S, N}
iswrapped(::Arr) = true

Base.hash(x::Arr, u::UInt) = hash(unwrap(x), u)
Base.isequal(a::Arr, b::Arr) = isequal(unwrap(a), unwrap(b))
Base.isequal(a::Arr, b::BasicSymbolic) = isequal(unwrap(a), b)
Base.isequal(a::BasicSymbolic, b::Arr) = isequal(b, a)

function Arr(x)
    A = symtype(x)
    @assert A <: AbstractArray
    Arr{maybewrap(eltype(A)), ndims(A)}(x)
end

SymbolicUtils.unwrap(x::Arr) = x.value
SymbolicUtils.symtype(x::Arr) = symtype(unwrap(x))
SymbolicUtils.setmetadata(x::Arr{T, N}, t, v) where {T, N} = Arr{T, N}(SymbolicUtils.setmetadata(unwrap(x), t, v))
SymbolicUtils.getmetadata(x::Arr, t) = SymbolicUtils.getmetadata(unwrap(x), t)
SymbolicUtils.hasmetadata(x::Arr, t) = SymbolicUtils.hasmetadata(unwrap(x), t)
SymbolicUtils.infer_vartype(::Type{Arr{T, N}}) where {T, N} = VartypeT

function (s::SymbolicUtils.Substituter)(x::Arr{T, N}) where {T, N}
    Arr{T, N}(s(unwrap(x)))
end

maybewrap(T) = has_symwrapper(T) ? wrapper_type(T) : T
# These methods allow @wrapped methods to be more specific and not overwrite
# each other when defined both for matrix and vector
# wrapper_type(::Type{<:AbstractMatrix{T}}) where {T} = Arr{maybewrap(T), 2}

# wrapper_type(::Type{<:AbstractVector}) = Arr{<:Any, 1}
# wrapper_type(::Type{<:AbstractVector{T}}) where {T} = Arr{maybewrap(T), 1}

function Base.show(io::IO, arr::Arr)
    warn_load_latexify()
    x = unwrap(arr)
    iscall(x) && print(io, "(")
    print(io, unwrap(arr))
    iscall(x) && print(io, ")")
    print(io, "[")
    if shape(x) isa SymbolicUtils.Unknown
        print(io, shape(x))
    else
        print(io, join(string.(axes(arr)), ","))
    end
    print(io, "]")
end
Base.show(io::IO, ::MIME"text/plain", arr::Arr) = show(io, arr)

################# Base array functions
Base.IndexStyle(::Type{<:Arr}) = Base.IndexStyle(BasicSymbolic{VartypeT})
Base.length(A::Arr) = length(unwrap(A))
Base.size(A::Arr) = size(unwrap(A))
Base.axes(A::Arr) = axes(unwrap(A))
Base.eachindex(A::Arr) = eachindex(unwrap(A))

function SymbolicUtils.search_variables!(buffer, expr::Arr; kw...)
    SymbolicUtils.search_variables!(buffer, unwrap(expr); kw...)
end

# cannot use `@wrapped` since it will define `\(::BasicSymbolic, ::BasicSymbolic)`
# and because `\(::Arr, ::BasicSymbolic)` will be ambiguous.
for (T1, T2) in [
    (Arr{<:Any, 2}, Arr{<:Any, 1}),
    (Arr{<:Any, 2}, Arr{<:Any, 2}),
    (AbstractArray{<:Any, 2}, Arr{<:Any, 1}),
    (AbstractArray{<:Any, 2}, Arr{<:Any, 2}),
    (Arr{<:Any, 2}, AbstractArray{<:Any, 1}),
    (Arr{<:Any, 2}, AbstractArray{<:Any, 2}),
    (Arr{<:Any, 2}, BasicSymbolic{SymReal}),
    (Arr{<:Any, 2}, BasicSymbolic{SafeReal}),
    (Arr{<:Any, 2}, BasicSymbolic{TreeReal}),
    (BasicSymbolic{SymReal}, Arr{<:Any, 1}),
    (BasicSymbolic{SafeReal}, Arr{<:Any, 1}),
    (BasicSymbolic{TreeReal}, Arr{<:Any, 1}),
    (BasicSymbolic{SymReal}, Arr{<:Any, 2}),
    (BasicSymbolic{SafeReal}, Arr{<:Any, 2}),
    (BasicSymbolic{TreeReal}, Arr{<:Any, 2}),
]
    @eval function Base.:(\)(A::$T1, b::$T2)
        return wrap(unwrap(A) \ unwrap(b))
    end
end

const _HermitianOrSymmetric = Union{
    LinearAlgebra.Hermitian{T, S}, LinearAlgebra.Symmetric{T, S},
} where {T, S}
# SparseArrays dispatches `\` on this non-public abstract storage type, so exact
# intersections with its methods cannot be expressed through `SparseMatrixCSC`.
for T in (
            LinearAlgebra.Bidiagonal,
            LinearAlgebra.Diagonal,
            LinearAlgebra.SymTridiagonal,
            _HermitianOrSymmetric,
            Union{LinearAlgebra.LowerTriangular, LinearAlgebra.UpperTriangular},
            Union{LinearAlgebra.UnitLowerTriangular, LinearAlgebra.UnitUpperTriangular},
            Union{
                LinearAlgebra.Adjoint{<:Any, <:LinearAlgebra.Bidiagonal},
                LinearAlgebra.Transpose{<:Any, <:LinearAlgebra.Bidiagonal},
            },
            SparseArrays.AbstractSparseMatrixCSC,
            LinearAlgebra.Adjoint{<:Any, <:SparseArrays.AbstractSparseMatrixCSC},
            LinearAlgebra.Transpose{<:Any, <:SparseArrays.AbstractSparseMatrixCSC},
        ), N in (1, 2)
    @eval Base.:(\)(A::$T, b::Arr{<:Any, $N}) = wrap(unwrap(A) \ unwrap(b))
end
function Base.:(\)(
        A::LinearAlgebra.Diagonal{T, StaticArraysCore.SVector{N, T}}, b::Arr{<:Any, 1}
    ) where {T, N}
    return wrap(unwrap(A) \ unwrap(b))
end
function Base.:(\)(
        A::LinearAlgebra.Diagonal{Num, StaticArraysCore.SVector{N, Num}},
        b::Arr{Num, 1}
    ) where {N}
    return wrap(unwrap(A) \ unwrap(b))
end

Base.ifelse(x::Num, y::Arr{T, N}, z) where {T, N} = Arr{T, N}(ifelse(unwrap(x), unwrap(y), unwrap(z)))
Base.ifelse(x::Num, y, z::Arr{T, N}) where {T, N} = Arr{T, N}(ifelse(unwrap(x), unwrap(y), unwrap(z)))
function Base.ifelse(x::Num, y::Arr, z::Arr)
    size(y) == size(z) || error("Both branches of `ifelse` must have the same shape.")
    return Arr(ifelse(unwrap(x), unwrap(y), unwrap(z)))
end
Base.ifelse(x::Num, y::Arr{T, N}, z::Num) where {T, N} = Arr{T, N}(ifelse(unwrap(x), unwrap(y), unwrap(z)))
Base.ifelse(x::Num, y::Num, z::Arr{T, N}) where {T, N} = Arr{T, N}(ifelse(unwrap(x), unwrap(y), unwrap(z)))

Base.exp(A::Arr{T, 2}) where {T} = Arr{T, 2}(exp(unwrap(A)))
Base.:^(A::Arr{<:Any, 2}, x::Num) = wrap(unwrap(A)^unwrap(x))
# `Arr` has no `similar`; Base generics that `copy` an intermediate (e.g. `/`) need this.
Base.copy(x::Arr) = wrap(copy(unwrap(x)))
Base.inv(A::Arr{T, 2}) where {T} = Arr{T, 2}(inv(unwrap(A)))
LinearAlgebra.det(A::Arr{T, 2}) where {T} = T(det(unwrap(A)))
LinearAlgebra.adjoint(A::Arr{T, 2}) where {T} = Arr{T, 2}(adjoint(unwrap(A)))
LinearAlgebra.adjoint(A::Arr{T, 1}) where {T} = Arr{T, 2}(adjoint(unwrap(A)))
function LinearAlgebra.norm(A::Arr{T}) where {T}
    if is_wrapper_type(T)
        T(norm(unwrap(A)))
    else
        norm(unwrap(A))
    end
end
function LinearAlgebra.norm(A::Arr{T}, p::Num) where {T}
    if is_wrapper_type(T)
        T(norm(unwrap(A), unwrap(p)))
    else
        norm(unwrap(A), unwrap(p))
    end
end
function LinearAlgebra.norm(A::Arr{T}, p::Real) where {T}
    if is_wrapper_type(T)
        T(norm(unwrap(A), unwrap(p)))
    else
        norm(unwrap(A), unwrap(p))
    end
end

function SymbolicUtils.scalarize(x::Arr{T, N}, ::Val{toplevel}) where {toplevel, T, N}
    scal = SymbolicUtils.scalarize(unwrap(x), Val{toplevel}())::(AbstractArray{_T, N} where {_T})
    if is_wrapper_type(T)
        scal = map(T, scal)
    end
    return scal
end

Base.isempty(x::Arr) = isempty(unwrap(x))
Base.collect(x::Arr) = wrap.(collect(unwrap(x)))
isarraysymbolic(x) = false
# this should be validated in the constructor
isarraysymbolic(x::Arr) = true
isarraysymbolic(x::BasicSymbolic) = symtype(x) <: AbstractArray

Base.convert(::Type{<:Array{<:Any, N}}, arr::Arr{<:Any, N}) where {N} = scalarize(arr)

function SymbolicUtils.Code.toexpr(x::Arr, st)
    toexpr(unwrap(x), st)
end

"""
    $(TYPEDSIGNATURES)

Utility to represent `dst .= src` as a function call.
"""
function broadcast_assign!(dst, src)
    dst .= src
end

function inplace_expr(x, out_array, intermediates = nothing)
    x = unwrap(x)
    if SymbolicUtils.isarrayop(x) && x.term === nothing
        return x
    elseif symtype(x) <: Number
        return term(broadcast_assign!, out_array, x)
    else
        return term(copy!, out_array, x)
    end
end

function inplace_expr(x::AbstractArray, out, intermediates = nothing)
    expr = SetArray(false, out, x, true)
    if intermediates !== nothing
        expr = Let(map(k -> Assignment(intermediates[k], k), collect(keys(intermediates))), expr, false)
    end
    return expr
end

function inplace_builtin(term, outsym)
    isarr(n) = x->symtype(x) <: AbstractArray{<:Any, n}
    if iscall(term) && operation(term) == (*) && length(arguments(term)) == 2
        A, B = arguments(term)
        isarr(2)(A) && (isarr(1)(B) || isarr(2)(B)) && return term(mul!, outsym, A, B)
    end
    return nothing
end

hasnode(r::Function, y::Arr) = _hasnode(r, y)
hasnode(r::Union{Num, Arr}, y::Arr) = SymbolicUtils.query(isequal(unwrap(r)), unwrap(y))
hasnode(r::Arr, y::BasicSymbolic) = SymbolicUtils.query(isequal(unwrap(r)), unwrap(y))

#=
"""
Find any inputs to ArrayOp that are ArrayMaker, and return
how to split all the inputs simultaneously so that the blocks
can now interact.
"""
function get_simultaneous_ranges(ex::ArrayOp)
    rs = ranges(ex)
    combine_together = []
    for (i, arrs) in rs
        together = unique(map(a->(a.A, a.dim), arrs))
        if length(together) > 1
            push!(combine_together, together)
        end
    end

    splits = map(combine_together) do group
        map(group) do a
            (A, dim) = a
            if A isa ArrayMaker
                sort(map(x->x[dim], map(first, A.sequence)), by=first)
            else
                [axes(A, dim)]
            end
        end
    end

    combined_splits = map(splits) do rs
        new_starts = sort!(unique!(reduce(vcat, map(x->first.(x), rs))))
        lst = maximum(map(maximum, map(x->last.(x), rs)))
        UnitRange.(new_starts, vcat((new_starts .- 1)[2:end], lst))
    end

    collected = Dict(A => Any[[1:size(A, dim)] for dim in 1:ndims(A)]
                     for A in unique(reduce(vcat, map(x->map(a->a.A, x),
                                                      collect(values(rs))))))

    for (dims, rs) in zip(combine_together, combined_splits)
        for d in dims
            collected[d[1]][d[2]] = rs
        end
    end
    collected
end
=#

using Symbolics
using SymbolicUtils
using SymbolicIndexingInterface

@test all(symbolic_type.([SymbolicUtils.BasicSymbolic, Symbolics.Num, Complex{Symbolics.Num}, Symbolics.CallAndWrap]) .==
          (ScalarSymbolic(),))
@test symbolic_type(Symbolics.Arr) == ArraySymbolic()
@variables x
@test symbolic_type(x) == ScalarSymbolic()
@variables y[1:3]
@test symbolic_type(y) == ArraySymbolic()
@test symbolic_type(Symbolics.unwrap(y)) == ArraySymbolic()
@test all(symbolic_type.(collect(y)) .== (ScalarSymbolic(),))
@test symbolic_type(Symbolics.unwrap(y .* y)) == ArraySymbolic()
@variables z(..)
@test symbolic_type(z) == ScalarSymbolic()
@variables xc::Complex{Real}
@test symbolic_type(xc) == ScalarSymbolic()
@variables (yc::Complex{Real})[1:3]
@test symbolic_type(yc) == ArraySymbolic()

@variables x y z
subs = Dict(x => 0.1, y => 2z)
subs2 = merge(subs, Dict(z => 2x+3))

@test Symbolics.value(symbolic_evaluate(x, subs)) == 0.1
@test isequal(symbolic_evaluate(y, subs), 2z)
@test Symbolics.value(symbolic_evaluate(y, subs2)) == 6.4

@testset "`hasname` for `getindex`ed trees" begin
    @variables x[1:2] y[1:2]
    @test !Symbolics.hasname((x .+ y)[1])
end

using Symbolics, NaNMath, Test

function discontinuity_eval(fn, args...)
    if rootfunction(fn)(args...) < 0
        left_continuous_function(fn)(args...)
    else
        right_continuous_function(fn)(args...)
    end
end

@testset "abs" begin
    for x in -1.0:0.001:1.0
        @test abs(x) ≈ discontinuity_eval(abs, x)
    end
end

@testset "$(nameof(f))" for f in (mod, rem, div)
    y = 0.7
    for x in -2y:0.001:2y
        @test f(x, y) ≈ discontinuity_eval(f, x, y)
    end
end

@testset "$(nameof(f))" for f in (min, max, NaNMath.min, NaNMath.max, <, <=, >, >=)
    for x in 0.0:0.1:1.0
        for y in 0.0:0.1:1.0
            @test f(x, y) ≈ discontinuity_eval(f, x, y)
        end
    end
end

@testset "@register_discontinuities wraps in Const for symbolic arguments" begin
    @variables x
    @syms y::Real
    @test Symbolics.left_continuous_function(<=)(x, y) isa Symbolics.SymbolicT
    @test Symbolics.right_continuous_function(<=)(x, y) isa Symbolics.SymbolicT
    @test Symbolics.left_continuous_function(<=)(x, 1) isa Symbolics.SymbolicT
    @test Symbolics.right_continuous_function(<=)(1, y) isa Symbolics.SymbolicT
end

@testset "approximation/majorization/minorization registrations" begin
    for f in (max, NaNMath.max)
        @test approximation_function(f) isa Function
        @test majorization_function(f) isa Function
    end
    for f in (min, NaNMath.min)
        @test approximation_function(f) isa Function
        @test minorization_function(f) isa Function
    end
    @test approximation_function(abs) isa Function
    @test majorization_function(abs) isa Function
    for f in (>=, >, <=, <, ==)
        @test approximation_function(f) isa Function
    end
end

@testset "majorization: $(nameof(f))" for (f, g) in (max => max, NaNMath.max => max)
    m = 100.0
    for a in -2.0:0.5:2.0, b in -2.0:0.5:2.0
        @test majorization_function(f)(m, a, b) >= g(a, b)
    end
end

@testset "minorization: $(nameof(f))" for (f, g) in (min => min, NaNMath.min => min)
    m = 100.0
    for a in -2.0:0.5:2.0, b in -2.0:0.5:2.0
        @test minorization_function(f)(m, a, b) <= g(a, b)
    end
end

@testset "majorization: abs" begin
    m = 100.0
    for a in -2.0:0.5:2.0
        @test majorization_function(abs)(m, a) >= abs(a)
    end
end

@testset "approximation convergence: $(nameof(f))" for (f, g) in (max => max, min => min, NaNMath.max => max, NaNMath.min => min)
    m = 1000.0
    for a in -2.0:0.5:2.0, b in -2.0:0.5:2.0
        isapprox(a, b; atol = 0.1) && continue
        @test approximation_function(f)(m, a, b) ≈ g(a, b) atol=1e-2
    end
end

@testset "approximation: comparison operators" begin
    m = 100.0
    for a in -2.0:0.5:2.0, b in -2.0:0.5:2.0
        # range [0, 1]
        @test 0.0 <= approximation_function(>=)(m, a, b) <= 1.0
        @test 0.0 <= approximation_function(>)(m, a, b) <= 1.0
        @test 0.0 <= approximation_function(<=)(m, a, b) <= 1.0
        @test 0.0 <= approximation_function(<)(m, a, b) <= 1.0
        # symmetry
        @test approximation_function(>=)(m, a, b) ≈ approximation_function(<=)(m, b, a)
        @test approximation_function(>)(m, a, b) ≈ approximation_function(<)(m, b, a)
    end
    # convergence
    m = 1000.0
    for a in -2.0:0.5:2.0, b in -2.0:0.5:2.0
        isapprox(a, b; atol = 0.1) && continue
        @test approximation_function(>=)(m, a, b) ≈ Float64(a >= b) atol=1e-2
        @test approximation_function(>)(m, a, b) ≈ Float64(a > b) atol=1e-2
        @test approximation_function(<=)(m, a, b) ≈ Float64(a <= b) atol=1e-2
        @test approximation_function(<)(m, a, b) ≈ Float64(a < b) atol=1e-2
    end
end

@testset "approximation: ==" begin
    m = 100.0
    for a in -2.0:0.5:2.0
        @test approximation_function(==)(m, a, a) ≈ 1.0 atol=1e-10
    end
    m = 1000.0
    for a in -2.0:0.5:2.0, b in -2.0:0.5:2.0
        abs(a - b) < 0.5 && continue
        @test approximation_function(==)(m, a, b) ≈ 0.0 atol=1e-2
    end
end

:(function (x,)
      let _out = (zeros)(Float64, (map)(length, (1:5, 1:5)))
          var"%_out" = begin
                  _out_1 = (view)(_out, 1:5, 1:5)
                  var"%_out_1" = (Symbolics.broadcast_assign!)(_out_1, 0)
                  _out_2 = (view)(_out, 2:4, 2:4)
                  var"%_out_2" = for var"%jj′" = (zip)(2:4, (Symbolics.reset_to_one)(2:4))
                          begin
                              j = var"%jj′"[1]
                              j′ = var"%jj′"[2]
                              for var"%ii′" = (zip)(2:4, (Symbolics.reset_to_one)(2:4))
                                  begin
                                      i = var"%ii′"[1]
                                      i′ = var"%ii′"[2]
                                      begin
                                          _out_2[(CartesianIndex)(i′, j′)] = (+)((getindex)(_out_2, i′, j′), (*)(1//2, (+)((+)((+)((getindex)(x, (+)(-1, i), j), (getindex)(x, (+)(1, i), j)), (getindex)(x, i, (+)(-1, j))), (getindex)(x, i, (+)(1, j)))))
                                          nothing
                                      end
                                  end
                              end
                          end
                      end
                  nothing
              end
          _out
      end
  end)

"""
    derivative_rule(::typeof(f), ::Val{NArgs}, args::ArgsT{VartypeT}, ::Val{I})

Define the derivative rule for `f` with `Nargs` arguments `args` with respect to the `I`th
argument. Do not define this function directly. Prefer using
[`@register_derivative`](@ref). Instead of calling this function directly, prefer
[`@derivative_rule`](@ref).
"""
function derivative_rule end

"""
    @register_derivative fn(args...) Ith_arg derivative

Register a symbolic derivative for a function. This typically accompanies a call to
[`@register_symbolic`](@ref) or [`@register_array_symbolic`](@ref) and defines how
[`expand_derivatives`](@ref) will behave when it tries to differentiate the registered
function.

The first argument to the macro is a call to the function whose derivative is being
defined. The call cannot have keyword arguments or default arguments. The call must have
either an exact number of arguments or a single variadic argument. For example, `f(a)`,
`f(a, b)`, `f(a, b, c)` and `f(args...)` are valid signatures. `f(a, b, args...)` is
invalid. If an exact number of arguments is provided, the defined derivative is specific
to that number of arguments. If the variadic signature is used, the defined derivative
is valid for all numbers of arguments. In case multiple derivatives are registered for
the same function, they must have different numbers of arguments. A derivative for an
exact number of arguments is more specific than a variadic definition. For example,
`@register_derivatives f(a, b) #...` is more specific than
`@register_derivatives f(args...) #...` for a 2-argument call to `f`. The arguments
can be referred to with their declared names inside the derivative definition.

The second argument to the macro is the argument with respect to which the derivative
rule is defined. For example, `@register_derivative f(a, b) 2 #...` is a derivative rule
with respect to the second argument of `f`. Mathematically, it represents
``\\frac{ \\partial f(a, b) }{ \\partial b }``. To define a generic derivative, this
argument can be an identifier. For example, `@register_derivative f(a, b) I #...` makes
`I` available in the derivative definition as the index of the argument with respect to
which the derivative is being taken.

The third argument to the macro is the derivative expression. This should be a symbolically
traceable expression returning the derivative of the specified function with respect to
the specified argument. In case of a variadic definition, the identifier `Nargs` is available
to denote the number of arguments provided to the function. In case the variadic form is
used, the arguments are available as a read-only array (mutation will error). Mutating
the array is unsafe and undefined behavior.

!!! note
    For functions that return arrays (such as those registered via `@register_array_symbolic`)
    the returned expression must be the Jacobian. Currently, support for differentiating array
    functions is considered experimental.

!!! warning
    The derivative expression MUST return a symbolic value, or `nothing` if the derivative is
    not defined. In case the result is a non-symbolic value, such as a constant derivative or
    Jacobian of array functions, the result MUST be wrapped in `Symbolics.SConst(..)`.

Following are example definitions of derivatives:

```julia
@register_derivative sin(x) 1 cos(x)
@register_derivative max(x, y) 2 ifelse(x >= y, 0, 1)
@register_derivative min(args...) I begin
  error("The rule for the derivative of `min` with \$Nargs arguments w.r.t the \$I-th argument is undefined.")
end
@register_derivative (foo::MyCallableStruct)(args...) I begin
  error("Oops! Didn't implement the derivative for \$foo")
end
```
"""
macro register_derivative(f::Expr, I::Union{Symbol, Int}, body)
    @assert Meta.isexpr(f, :call) """
    Incorrect `@register_derivative` syntax. The function must be provided as a call \
    signature. Got `$f` which is not a call signature.
    """
    fnhead = f.args[1]
    fncallargs = @view f.args[2:end]
    is_struct_der = Meta.isexpr(fnhead, :(::))
    if is_struct_der
        @assert length(fnhead.args) == 2 """
        Incorrect `@register_derivative` syntax. Registering derivatives of callable \
        structs requires providing a name for the struct. For example, instead of
        `@register_derivative (::MyStruct) # ...` use \
        `@register_derivative (x::MyStruct) # ...`.
        """
    end
    @assert !any(Base.Fix2(Meta.isexpr, :kw), fncallargs) """
    Incorrect `@register_derivative` syntax. The function cannot have default arguments.
    """
    @assert !Meta.isexpr(fncallargs[1], :parameters) """
    Incorrect `@register_derivative` syntax. The function cannot have keyword arguments.
    """

    is_varargs = Meta.isexpr(fncallargs[end], :...)
    if is_varargs
        @assert length(fncallargs) == 1 """
        Incorrect `@register_derivative` syntax. The function call signature must either \
        be a single variadic argument `@register_derivative foo(args...) #...` or a \
        concrete number of arguments `@register_derivative foo(arg1, arg2, arg3) # ...`.
        """
    end

    derhead = Expr(:call, :($Symbolics.derivative_rule), is_struct_der ? fnhead : :(::($typeof($fnhead))))
    Nargs = is_varargs ? :Nargs : length(fncallargs)
    push!(derhead.args, :(::Val{$Nargs}))
    args_name = gensym(:args)
    push!(derhead.args, :($args_name::$SymbolicUtils.ROArgsT{$VartypeT}))
    push!(derhead.args, :(::Val{$I}))

    if is_varargs || I isa Symbol
        derhead = Expr(:where, derhead)
        is_varargs && push!(derhead.args, Nargs)
        I isa Symbol && push!(derhead.args, I)
    end

    if is_varargs
        unpack = Expr(:(=), fncallargs[1].args[1], args_name)
    else
        unpack = Expr(:tuple)
        append!(unpack.args, fncallargs)
        unpack = Expr(:(=), unpack, args_name)
    end

    return esc(Expr(:function, derhead, Expr(:block, unpack, body)))
end

# Fallback
@register_derivative (f::Any)(args...) I nothing

# Pre-defined derivatives
import DiffRules
for (modu, fun, arity) ∈ DiffRules.diffrules(; filter_modules=(:Base, :SpecialFunctions, :NaNMath))
    fun in [:*, :+, :abs, :mod, :rem, :max, :min] && continue # special
    for i ∈ 1:arity

        expr = if arity == 1
            DiffRules.diffrule(modu, fun, :(args[1]))
        else
            DiffRules.diffrule(modu, fun, ntuple(k->:(args[$k]), arity)...)[i]
        end

        # Using the macro here doesn't work somehow.
        @eval function derivative_rule(::typeof($modu.$fun), ::Val{$arity}, args::ROArgsT{VartypeT}, ::Val{$i})
            $SConst($expr)
        end
    end
end

Base.@propagate_inbounds function _derivative_rule_proxy(f, args::NTuple{N, SymbolicT}, ::Val{I}) where {N, I}
    _derivative_rule_proxy(f, Val{N}(), args, Val{I}())
end
Base.@propagate_inbounds function _derivative_rule_proxy(f, ::Val{N}, args::NTuple{N, SymbolicT}, ::Val{I}) where {N, I}
    _derivative_rule_proxy(f, Val{N}(), SymbolicUtils.ArgsT{VartypeT}(args), Val{I}())
end
Base.@propagate_inbounds function _derivative_rule_proxy(f, args::Tuple, ::Val{I}) where {I}
    _derivative_rule_proxy(f, Val{length(args)}(), args, Val{I}())
end
Base.@propagate_inbounds function _derivative_rule_proxy(f, ::Val{N}, args::Tuple{Vararg{Any, N}}, ::Val{I}) where {N, I}
    args = ntuple(BSImpl.Const{VartypeT} ∘ Base.Fix1(getindex, args), Val{N}())
    _derivative_rule_proxy(f, Val{N}(), args, Val{I}())
end
Base.@propagate_inbounds function _derivative_rule_proxy(f, args::ROArgsT{VartypeT}, ::Val{I}) where {I}
    @inbounds _derivative_rule_proxy(f, Val{length(args)}(), args, Val{I}())
end
Base.@propagate_inbounds function _derivative_rule_proxy(f, ::Val{N}, args::ROArgsT{VartypeT}, ::Val{I}) where {N, I}
    @boundscheck checkbounds(args, N)
    derivative_rule(f, Val{N}(), args, Val{I}())
end
Base.@propagate_inbounds function _derivative_rule_proxy(f, args::ArgsT{VartypeT}, ::Val{I}) where {I}
    @inbounds _derivative_rule_proxy(f, Val{length(args)}(), args, Val{I}())
end
Base.@propagate_inbounds function _derivative_rule_proxy(f, ::Val{N}, args::ArgsT{VartypeT}, ::Val{I}) where {N, I}
    @boundscheck checkbounds(args, N)
    _derivative_rule_proxy(f, Val{N}(), ROArgsT{VartypeT}(args), Val{I}())
end
Base.@propagate_inbounds function _derivative_rule_proxy(f, args::AbstractArray{SymbolicT}, ::Val{I}) where {I}
    @inbounds _derivative_rule_proxy(f, Val{length(args)}(), args, Val{I}())
end
Base.@propagate_inbounds function _derivative_rule_proxy(f, ::Val{N}, args::AbstractArray{SymbolicT}, ::Val{I}) where {N, I}
    @boundscheck checkbounds(args, N)
    _derivative_rule_proxy(f, Val{N}(), ArgsT{VartypeT}(args), Val{I}())
end
Base.@propagate_inbounds function _derivative_rule_proxy(f, args::AbstractArray, ::Val{I}) where {I}
    @inbounds _derivative_rule_proxy(f, Val{length(args)}(), args, Val{I}())
end
Base.@propagate_inbounds function _derivative_rule_proxy(f, ::Val{N}, args::AbstractArray, ::Val{I}) where {N, I}
    @boundscheck checkbounds(args, N)
    _args = ArgsT{VartypeT}()
    sizehint!(_args, N)
    for a in args
        push!(_args, BSImpl.Const{VartypeT}(a))
    end
    _derivative_rule_proxy(f, Val{N}(), _args, Val{I}())
end

"""
    @derivative_rule f(args...) I

Query Symbolics.jl's derivative rule system for the derivative of `f(args...)` with respect to
`args[I]`. Returns a symbolic result representing the derivative. In case the derivative rule is
not defined, evaluates to `nothing`.

The first argument to the macro must be a valid function call syntax. Splatting of arguments is
permitted. The second argument must be an expression or literal evaluating to the index of the
argument with respect to which the derivative is required.

The derivative rule can dispatch statically if `f`, the number of arguments and `I` are known
at compile time. Example invocations are:

```julia
# static dispatch
@derivative_rule sin(x) 1
# static dispatch if `xs` is a tuple
@derivative_rule max(xs...) 2
# static dispatch if `y` and `w` are tuples, and `N + 2K` is a compile-time constant
@derivative_rule foo(x, y..., z, w...) (N + 2K)
```
"""
macro derivative_rule(f, I)
    @assert Meta.isexpr(f, :call) """
    Incorrect `@derivative_rule` syntax. The function must be provided as a call \
    signature. Got `$f` which is not a call signature.
    """
    fnhead = f.args[1]
    fncallargs = @view f.args[2:end]
    result = Expr(:call, _derivative_rule_proxy, fnhead)
    if length(fncallargs) == 1 && Meta.isexpr(fncallargs[1], :...)
        push!(result.args, fncallargs[1].args[1])
    elseif any(Base.Fix2(Meta.isexpr, :...), fncallargs)
        args = Expr(:tuple)
        append!(args.args, fncallargs)
        push!(result.args, args)
    else
        push!(result.args, :(Val{$(length(fncallargs))}()))
        args = Expr(:tuple)
        append!(args.args, fncallargs)
        push!(result.args, args)
    end
    push!(result.args, :(Val{$I}()))
    return esc(result)
end

@register_derivative +(args...) I COMMON_ONE
@register_derivative *(args...) I begin
    if I == 1
        SymbolicUtils.mul_worker(VartypeT, view(args, 2:Nargs))
    elseif I == Nargs
        SymbolicUtils.mul_worker(VartypeT, view(args, 1:(Nargs-1)))
    else
        t1 = SymbolicUtils.mul_worker(VartypeT, view(args, 1:(Nargs-1)))
        t2 = SymbolicUtils.mul_worker(VartypeT, view(args, 2:Nargs))
        t1 * t2
    end
end
@register_derivative one(x) 1 COMMON_ZERO

"""
$(SIGNATURES)

Calculate the derivative of the op `O` with respect to its argument with index
`idx`.

# Examples

```jldoctest label1
julia> using Symbolics

julia> @variables x y;

julia> Symbolics.derivative_idx(Symbolics.value(sin(x)), 1)
cos(x)
```

Note that the function does not recurse into the operation's arguments, i.e., the
chain rule is not applied:

```jldoctest label1
julia> myop = Symbolics.value(sin(x) * y^2)
sin(x)*(y^2)

julia> Symbolics.operation(myop) === (*)
true

julia> Symbolics.derivative_idx(myop, 1)  # wrt. sin(x)
sin(x)

julia> Symbolics.derivative_idx(myop, 2)  # wrt. y^2
y^2
```
"""
@inline derivative_idx(::Any, ::Any) = COMMON_ZERO
function derivative_idx(O::SymbolicT, idx::Int)
    iscall(O) || return COMMON_ZERO
    f = operation(O)
    args = arguments(O)
    return @derivative_rule f(args...) idx
end

"""
    replacenode(expr::Symbolic, rules...)

Walk the expression and replacenode subexpressions according to `rules`. `rules`
could be rules constructed with `@rule`, a function, or a pair where the
left hand side is matched with equality (using `isequal`) and is replacenoded by the right hand side.

Rules will be applied left-to-right simultaneously,
so only one pattern will be applied to any subexpression,
and the patterns will only be applied to the input text,
not the replacenodements.

Set `fixpoint = true` to repeatedly apply rules until no
change to the expression remains to be made.
"""
function replacenode(expr::Num, r::Pair, rules::Pair...; fixpoint = false)
    _replacenode(unwrap(expr), r, rules...)
end
# Fix ambiguity
replacenode(expr::Num, rules...; fixpoint = false) = _replacenode(unwrap(expr), rules...; fixpoint)
replacenode(expr::Symbolic, rules...; fixpoint = false) = _replacenode(unwrap(expr), rules...; fixpoint)
replacenode(expr::Symbolic, r::Pair, rules::Pair...; fixpoint = false) = _replacenode(expr, r, rules...; fixpoint)
replacenode(expr::Number, rules...; fixpoint = false) = expr
replacenode(expr::Number, r::Pair, rules::Pair...; fixpoint = false) = expr

function _replacenode(expr::Symbolic, rules...; fixpoint = false)
    rs = map(r -> r isa Pair ? (x -> isequal(x, unwrap(r[1])) ? unwrap(r[2]) : nothing) : r, rules)
    R = Prewalk(Chain(rs))
    if fixpoint
        Fixpoint(R)(expr)
    else
        R(expr)
    end
end

"""
    hasnode(c, x)
Returns true if any part of `x` fulfills the condition given in c. c can be a function or an expression.
If it is a function, returns true if x is true for any part of x. If c is an expression, returns
true if x contains c.

Examples:
```julia
@syms x y
hasnode(x, log(x) + x + 1) # returns `true`.
hasnode(x, log(y) + y + 1) # returns `false`.
```

```julia
@variables t X(t)
D = Differential(t)
hasnode(Symbolics.is_derivative, X + D(X) + D(X^2)) # returns `true`.
```
"""
function hasnode(r::Function, y::Union{Num, Symbolic})
    _hasnode(r, y)
end
hasnode(r::Num, y::Union{Num, Symbolic}) = occursin(unwrap(r), unwrap(y))
hasnode(r::Symbolic, y::Union{Num, Symbolic}) = occursin(unwrap(r), unwrap(y))
hasnode(r::Union{Num, Symbolic, Function}, y::Number) = false

function _hasnode(r, y)
    y = unwrap(y)
    if r isa Function
        if r(y)
            return true
        end
    end

    if iscall(y)
        return r(operation(y)) ||
                any(y->_hasnode(r, y), arguments(y))
    else
        return false
    end
end

"""
    filterchildren(c, x)

Returns all parts of `x` that fulfills the condition given in c. c can be a function or an expression.
If it is a function, returns everything for which the function is `true`. If c is an expression, returns
all expressions that matches it.

Examples:
```julia
@syms x
Symbolics.filterchildren(x, log(x) + x + 1)
```
returns `[x, x]`

```julia
@variables t X(t)
D = Differential(t)
Symbolics.filterchildren(Symbolics.is_derivative, X + D(X) + D(X^2))
```
returns `[Differential(t)(X(t)^2), Differential(t)(X(t))]`
"""
filterchildren(r, y) = filterchildren!(r, y, [])

function filterchildren!(r::Any, y, acc)
    y = unwrap(y)
    r = unwrap(r)
    if isequal(r, y)
        push!(acc, y)
        return acc
    elseif r isa Function
        if r(y)
            push!(acc, y)
            return acc
        end
    end

    if iscall(y)
        if isequal(r, operation(y))
            push!(acc, operation(y))
        elseif r isa Function && r(operation(y))
            push!(acc, operation(y))
        end
        foreach(c->filterchildren!(r, c, acc),
                arguments(y))
        return acc
    end
end

(f::SymbolicUtils.Rule)(x::Num) = wrap(f(unwrap(x)))

module RewriteHelpers
import Symbolics: replacenode, hasnode, filterchildren, unwrap
export replacenode, hasnode, filterchildren, unwrap

end

const FLOAT_NUM_CONVERSION_ERROR = """

An implicit conversion of symbolic Num into a Float64 was encountered. Common causes for this error include:

1. A substitution resulted in numerical values, but is not automatically converted to numerical values. For example:

```julia
@variables x y
result = [1.0]
A = [x x^2
     y+x 2x + y]
sub = substitute(A, Dict([x=>2.0, y=>2]))
result[1] = sub[1]
```

The reason is because the result of `sub` is still symbolic:

```julia
julia> sub = substitute(A, Dict([x=>2.0, y=>2]))
2×2 Matrix{Num}:
 2.0  4.0
 4.0  6.0
```

Notice that the return is a `Matrix{Num}`, not a `Matrix{Float64}`. To fix this, ensure that the type is converted, i.e.
`sub = Symbolics.unwrap.(substitute(A, Dict([x=>2.0, y=>2])))`, or `result[1] = Symbolics.unwrap(sub[1])`.

2. Captured symbolic values inside of registered functions. An example of this version of the error is the following:

```julia
@variables x y
ff(x) = x + y
@register_symbolic ff(x)
result = [0.0]
result[1] = eval(build_function(ff(x),[x,y]))(1.0) # Error
```

Notice that the is the fact that the generated function call `eval(build_function(ff(x),x))(1.0)` returns a symbolic
value (`1.0 + y`), not a numerical value. This is because the value `y` is a global symbol enclosed into `ff`. To fix
this, ensure that any symbolic value that is used in registered functions is passed in, i.e. :

```julia
ff(x) = x + y
@register_symbolic ff(x)
```
"""

Base.Experimental.register_error_hint(MethodError) do io, e, args, kwargs
  if e isa MethodError && Num in args && e.f <: Number
      println(io, FLOAT_NUM_CONVERSION_ERROR)
  end
end

const SYMBOLIC_BOOLEAN_CONTROL_FLOW = """
    Symbolic expression found in a control flow expression that requires a boolean. This can occur
    for example in a function like:

    ```julia
    f(x) = if x > 1
        x^2
    else
        2x
    end
    ```

    Notice that if `x` is symbolic, then `x > 1` is a symbolic expression and `if x > 1`
    does not know which branch to take without knowing the value of `x`, and thus we
    cannot know the mathematical expression. Thus instead of using `if/else`, use the
    function `ifelse(x>1, x^2, 2x)`.

    Sometimes there are functions that are fundamentally incompatible with symbolic tracing.
    For example:

    ```julia 
    function factorial(x)
        out = x
        while x > 1
            x -= 1
            out *= x
        end
        out
    end
    ```

    In this function, if `x=5` then the expression is ` x*(x-1)*(x-2)*(x-3)*(x-4)`,
    while if `x=3` then ` x*(x-1)*(x-2)`. Thus the symbolic expression is ill-defined,
    and Symbolics is not compatible with this function. If you have this case, you
    may want to register the symbolic function as a primitive, i.e.

    ```julia
    @register_symbolic f(x)
    ```

    then makes `f(x)` work by not expanding this function.

    For more information, see https://docs.sciml.ai/Symbolics/stable/manual/faq/ and
    https://docs.sciml.ai/Symbolics/stable/manual/functions/ .
"""

const SYMBOLIC_ARRAY_BOUNDS_ERROR = """
    A symbolic variable was used in array bounds or range construction. This commonly occurs when:
    
    1. Trying to create arrays with symbolic dimensions:
    
    ```julia
    @variables n
    @variables X[1:n]  # Error: n is symbolic, array size must be concrete
    ```
    
    To fix this, use concrete (numerical) values for array bounds:
    
    ```julia
    @variables X[1:10]  # Works: concrete size
    ```
    
    If you need variable-sized arrays, consider using a vector of variables or working 
    with symbolic indexing at runtime rather than at variable declaration time.
    
    For more information about array variables, see https://docs.sciml.ai/Symbolics/stable/manual/variables/
"""

Base.Experimental.register_error_hint(TypeError) do io, e, args, kwargs
    if e.expected === Bool && typeof(e.got) <: Union{Symbolics.Arr, Num, Symbolics.BasicSymbolic}
        println(io, "\n")
        println(io, SYMBOLIC_BOOLEAN_CONTROL_FLOW)
        # Also show array bounds hint as this is a common case
        println(io, "\n") 
        println(io, SYMBOLIC_ARRAY_BOUNDS_ERROR)
    end
end

# A little trick for travis
using PkgBenchmark, Symbolics

pkgpath = dirname(dirname(pathof(Symbolics)))
# move it out of the repository so that you can check out different branches
script = tempname() * ".jl"
benchpath = joinpath(pkgpath, "benchmark", "benchmarks.jl")
cp(benchpath, script)

j = judge(pkgpath, "master", retune=true, script=script)

println("MASTER BRANCH")
println(j.baseline_results)

println("THIS BRANCH")
println(j.target_results)

println("DIFFGROUP")
println(j.benchmarkgroup)

println("MARKDOWN")
export_markdown(stdout, j, export_invariants=true)

module SymbolicsSymPyExt

if isdefined(Base, :get_extension)
    using Symbolics
    using SymPy
else
    using ..Symbolics
    using ..SymPy
end

using Symbolics: value, symbolics_to_sympy, sympy_to_symbolics, Differential, Num
using SymbolicUtils: iscall, operation, arguments, symtype, FnType, Symbolic, Term
using LinearAlgebra

function Symbolics.symbolics_to_sympy(expr)
    expr = value(expr)
    expr isa Symbolic || return expr
    if iscall(expr)
        op = operation(expr)
        args = arguments(expr)

        if op isa Differential
            @assert length(args) == 1 "Differential operator must have exactly one argument."
            return SymPy.sympy.Derivative(symbolics_to_sympy(args[1]), symbolics_to_sympy(op.x))
        end

        sop = symbolics_to_sympy(op)
        sargs = map(symbolics_to_sympy, args)
        return sop === (^) && length(sargs) == 2 ? sargs[1]^sargs[2] : sop(sargs...)
    else
        name = string(nameof(expr))
        return symtype(expr) <: FnType ? SymPy.SymFunction(name) : SymPy.Sym(name)
    end
end

function Symbolics.sympy_to_symbolics(sympy_expr, vars)
    if sympy_expr == SymPy.oo
        return Inf
    elseif sympy_expr == -SymPy.oo
        return -Inf
    end
    dict = Dict{Symbol, Any}()
    for v in vars
        dict[nameof(v)] = v
    end

    # Convert Python/SymPy notation to Julia notation
    expr_str = string(sympy_expr)
    expr_str = replace(expr_str, "**" => "^")  # Convert exponentiation
    Symbolics.parse_expr_to_symbolic(Meta.parse(expr_str), dict)
end

function Symbolics.sympy_linear_solve(A, b)
    A_sympy = map(symbolics_to_sympy, A)
    b_sympy = map(symbolics_to_sympy, b)
    A_mat = SymPy.Matrix(A_sympy)
    b_vec = SymPy.Matrix(reshape(b_sympy, length(b_sympy), 1))
    sol_sympy = A_mat \ b_vec
    all_expressions = vcat(vec(A), b)
    vars = Symbolics.get_variables(all_expressions)
    [sympy_to_symbolics(s, vars) for s in sol_sympy]
end

function Symbolics.sympy_algebraic_solve(expr, var)
    expr_sympy = expr isa AbstractVector ? map(symbolics_to_sympy, expr) :
                 symbolics_to_sympy(expr)
    var_sympy = var isa AbstractVector ? map(symbolics_to_sympy, var) :
                symbolics_to_sympy(var)
    sol_sympy = SymPy.solve(expr_sympy, var_sympy, dict = true)
    vars = var isa AbstractVector ? var : [var]
    if expr isa AbstractVector
        varmap = Dict(string(nameof(v)) => v for v in vars)
        return [Dict(varmap[string(k)] => sympy_to_symbolics(v, vars) for (k, v) in s)
                for s in sol_sympy]
    else
        return [sympy_to_symbolics(s[var_sympy], vars) for s in sol_sympy]
    end
end

function Symbolics.sympy_integrate(expr, var)
    expr_sympy = symbolics_to_sympy(expr)
    var_sympy = symbolics_to_sympy(var)
    result_sympy = SymPy.integrate(expr_sympy, var_sympy)
    sympy_to_symbolics(result_sympy, Symbolics.get_variables(expr))
end

function Symbolics.sympy_limit(expr, var, val)
    expr_sympy = symbolics_to_sympy(expr)
    var_sympy = symbolics_to_sympy(var)
    val_sympy = symbolics_to_sympy(val)
    result_sympy = SymPy.limit(expr_sympy, var_sympy => val_sympy)
    sympy_to_symbolics(result_sympy, Symbolics.get_variables(expr))
end

function Symbolics.sympy_simplify(expr)
    expr_sympy = symbolics_to_sympy(expr)
    result_sympy = SymPy.simplify(expr_sympy)
    sympy_to_symbolics(result_sympy, Symbolics.get_variables(expr))
end

function Symbolics.sympy_ode_solve(expr, func, var)
    expr_sympy = symbolics_to_sympy(expr)
    func_sympy = symbolics_to_sympy(func)
    var_sympy = symbolics_to_sympy(var)
    sol_sympy = SymPy.dsolve(expr_sympy, func_sympy)
    sol_expr = sol_sympy.rhs
    parsing_vars = Vector{SymbolicUtils.BasicSymbolic}()
    vars_in_expr = Symbolics.get_variables(value(expr))
    func_val = value(func)
    for v in vars_in_expr
        if !isequal(v, func_val)
            push!(parsing_vars, v)
        end
    end
    push!(parsing_vars, value(var))
    push!(parsing_vars, operation(func_val))
    unwrapped_vars = unique(parsing_vars)
    sympy_to_symbolics(sol_expr, unwrapped_vars)
end

end

isblock(x) = length(x) == 1 && x[1] isa Expr && x[1].head == :block
function flatten_expr!(x)
    isblock(x) || return x
    x = MacroTools.striplines(x[1])
    filter!(z -> z isa Symbol || z.head != :line, x.args)
    xs = []
    for ex in x.args
        if Meta.isexpr(ex, :tuple)
            append!(xs, ex.args)
        else
            push!(xs, ex)
        end
    end
    xs
end

"""
    $(TYPEDSIGNATURES)

Equivalent to `unwrap_const ∘ unwrap`.
"""
value(x) = unwrap_const(unwrap(x))

function is_singleton(e)
    if iscall(e)
        op = operation(e)
        op === getindex && return true
        iscall(op) && return is_singleton(op) # recurse to reach getindex for array element variables
        return issym(op) && !SymbolicUtils.is_function_symbolic(op)
    else
        return issym(e)
    end
end

"""
    get_variables(e, varlist = nothing; kw...)

Return a vector of variables appearing in e, optionally restricting to variables in varlist.
Takes the same keyword arguments as `SymbolicUtils.search_variables`.

Note that the returned variables are not wrapped in the Num type.

Examples
≡≡≡≡≡≡≡≡

```julia
julia> @variables t x y z(t);

julia> Symbolics.get_variables(x + y + sin(z))
3-element Vector{SymbolicUtils.BasicSymbolic}:
 x
 y
 z(t)

julia> Symbolics.get_variables(x - y)
2-element Vector{SymbolicUtils.BasicSymbolic}:
 x
 y
```
"""
function get_variables(e; kw...)
    return search_variables(unwrap(e); kw...)
end

"""
    get_variables!(buffer, e; kwargs...)
    get_variables!(buffer, e, varlist; is_atomic = SymbolicUtils.default_is_atomic, kwargs...)

Append the symbolic variables found in `e` to the supplied mutable `buffer` and
return `buffer`. The expression is unwrapped before traversal, so the returned
variables are not wrapped in `Num`.

# Arguments

- `buffer`: a mutable collection accepted by
  [`SymbolicUtils.search_variables!`](https://symbolicutils.juliasymbolics.org/api/#SymbolicUtils.search_variables!).
- `e`: the symbolic expression to traverse.
- `varlist`: an optional collection restricting which expressions are treated
  as atomic variables.

# Keywords

- `is_atomic`: predicate used with the `varlist` form to select variables.
- `kwargs...`: keyword arguments forwarded to
  [`SymbolicUtils.search_variables!`](https://symbolicutils.juliasymbolics.org/api/#SymbolicUtils.search_variables!).

# Examples

```julia
julia> using Symbolics

julia> @variables x y

julia> buffer = Set{SymbolicUtils.BasicSymbolic}()
Set{SymbolicUtils.BasicSymbolic}()

julia> Symbolics.get_variables!(buffer, x + y) === buffer
true

julia> sort!(collect(buffer), by = string)
2-element Vector{SymbolicUtils.BasicSymbolic}:
 x
 y
```
"""
function get_variables!(buffer, e; kw...)
    return search_variables!(buffer, unwrap(e); kw...)
end

function _get_is_atomic(varlist, prev_atomic)
    let vars = Set(varlist), prev_atomic = prev_atomic
        function _is_atomic(ex)
            prev_atomic(ex) && ex in vars
        end
    end
end

function get_variables(e, varlist; is_atomic = SymbolicUtils.default_is_atomic, kw...)
    search_variables(unwrap(e); kw..., is_atomic = _get_is_atomic(varlist, is_atomic))
end

function get_variables!(buffer, e, varlist; is_atomic = SymbolicUtils.default_is_atomic, kw...)
    search_variables!(buffer, unwrap(e); kw..., is_atomic = _get_is_atomic(varlist, is_atomic))
end

"""
    get_differential_vars(e, varlist = nothing; sort::Bool = false)

Return a vector of differential variables appearing in `e`, optionally restricting to variables in `varlist`.

A differential variable is an expression where the operation is a `Differential`, such as `D(u)` where `D = Differential(x)`.

Note that the returned differential variables are not wrapped in the `Num` type.

# Examples
```jldoctest
julia> using Symbolics

julia> vars = @variables t x u(x, t); length(vars)
3

julia> D = Differential(x)
Differential(x, 1)

julia> Dt = Differential(t)
Differential(t, 1)

julia> expr = D(u) + Dt(u) + u + sin(D(u));

julia> Symbolics.get_differential_vars(expr; sort = true)
2-element Vector{SymbolicUtils.BasicSymbolicImpl.var"typeof(BasicSymbolicImpl)"{T} where T}:
 Differential(t, 1)(u(x, t))
 Differential(x, 1)(u(x, t))
```
"""
function get_differential_vars(e::Num, varlist = nothing; sort::Bool = false)
    get_differential_vars(unwrap(e), varlist; sort)
end
function get_differential_vars(e, varlist = nothing; sort::Bool = false)
    vars = Vector{BasicSymbolic}()
    get_differential_vars!(vars, e, varlist)
    if sort
        sort!(vars; by = string)
    end
    vars
end

get_differential_vars!(vars, e::Num, varlist=nothing) = get_differential_vars!(vars, value(e), varlist)
get_differential_vars!(vars, e, varlist=nothing) = vars

get_differential_vars!(vars, e::Number, varlist=nothing) = vars

function get_differential_vars!(vars, e::BasicSymbolic, varlist=nothing)
    if is_derivative(e)
        if isnothing(varlist) || any(isequal(e), varlist)
            push!(vars, e)
        end
    end
    
    if iscall(e)
        get_differential_vars!(vars, operation(e), varlist)
        foreach(x -> get_differential_vars!(vars, x, varlist), arguments(e))
    end
    
    unique!(vars)
    return vars
end

function get_differential_vars!(vars, e::Equation, varlist=nothing)
    get_differential_vars!(vars, e.lhs, varlist)
    get_differential_vars!(vars, e.rhs, varlist)
end

# Sym / Term --> Symbol
Base.Symbol(x::Num) = Symbol(unwrap(x))
tosymbol(t::Num; kwargs...) = tosymbol(value(t); kwargs...)

"""
    diff2term(x) -> BasicSymbolic

Convert a differential variable to a `Term`. Note that it only takes a `Term`
not a `Num`.

```jldoctest
julia> using Symbolics

julia> vars = @variables x t u(x, t) z(t)[1:2]; length(vars)
4

julia> Dt = Differential(t)
Differential(t, 1)

julia> Dx = Differential(x)
Differential(x, 1)

julia> Symbolics.diff2term(Symbolics.value(Dx(Dt(u))))
uˍxt(x, t)

julia> Symbolics.diff2term(Symbolics.value(Dt(z[1])))
(zˍt(t))[1]
```
"""
function diff2term(O::SymbolicT)
    opchain = Differential[]
    inner = O
    while true
        @match inner begin
            BSImpl.Term(; f, args) && if f isa Differential end => begin
                isinteger(f.order) || throw(ArgumentError("`diff2term` only supports integer order derivatives."))
                push!(opchain, f)
                inner = args[1]
            end
            _ => break
        end
    end
    isempty(opchain) && return O

    # Handle struct field accesses: D(f.x) → diff2term(D(f)).x
    # References to SymbolicGetproperty / field_name / SymStruct are late-bound (from symstruct.jl).
    has_gp = false
    access_ops = Union{Symbol, SU.StableIndex{Int}}[]
    cur = inner
    while iscall(cur)
        f = operation(cur)
        args = arguments(cur)
        if f isa SymbolicGetproperty
            has_gp = true
            push!(access_ops, field_name(f))              # Symbol (field name)
            cur = args[1]
        elseif f === getindex
            push!(access_ops, SU.StableIndex{Int}(cur))  # StableIndex extracted from the full getindex term
            cur = args[1]
        else
            break
        end
    end

    if has_gp
        # Reconstruct D^n(cur) and apply diff2term to the base variable.
        diff_cur = cur
        for d in Iterators.reverse(opchain)    # opchain is outer→inner; reverse to build inside-out
            diff_cur = d(diff_cur)
        end
        result = diff2term(diff_cur)
        # Re-apply access ops (collected outer→inner, so reverse to apply inner-first).
        for op in Iterators.reverse(access_ops)
            if op isa Symbol
                T = symtype(result)
                result = unwrap(getproperty(SymStruct{T}(result), op))
            else   # SU.StableIndex{Int}
                result = result[op]
            end
        end
        return result
    end

    return rename(inner, diff2term_name(inner, opchain))
end
diff2term(O::Num) = Num(diff2term(unwrap(O)))
diff2term(O::Arr{T, N}) where {T, N} = Arr{T, N}(diff2term(unwrap(O)))

const DIFF2TERM_SEPARATOR = 'ˍ'

function diff2term_name(x::SymbolicT, oplist::Vector)
    isempty(oplist) && return getname(x)
    io = IOBuffer()
    write(io, getname(x))
    seekstart(io)
    has_sep = false
    for c in readeach(io, Char)
        has_sep = c == DIFF2TERM_SEPARATOR
        has_sep && break
    end
    seekend(io)
    has_sep || write(io, DIFF2TERM_SEPARATOR)
    for op in oplist
        iv = getname(op.x)
        for _ in 1:floor(Int, op.order)
            write(io, iv)
        end
    end
    return Symbol(take!(io))
end

setname(v, name) = setmetadata(v, Symbolics.VariableSource, (:variables, name))

"""
    tosymbol(x::Union{Num,BasicSymbolic}; states=nothing, escape=true) -> Symbol

Convert `x` to a symbol. `states` are the states of a system, and `escape`
means if the target has escapes like `val"y(t)"`. If `escape` is false, then
it will only output `y` instead of `y(t)`.

# Examples

```jldoctest
julia> @variables t z(t)
2-element Vector{Num}:
    t
 z(t)

julia> Symbolics.tosymbol(z)
Symbol("z(t)")

julia> Symbolics.tosymbol(z; escape=false)
:z
```
"""
function tosymbol(t; states=nothing, escape=true)
    if issym(t)
        return nameof(t)
    elseif iscall(t)
        if issym(operation(t))
            if states !== nothing && !(t in states)
                return nameof(operation(t))
            end
            op = nameof(operation(t))
            args = arguments(t)
        elseif operation(t) isa Differential
            term = diff2term(t)
            if issym(term)
                return nameof(term)
            else
                op = Symbol(operation(term))
                args = arguments(term)
            end
        else
            op = Symbol(repr(operation(t)))
            args = arguments(t)
        end

        return escape ? Symbol(op, "(", join(args, ", "), ")") : op
    else
        return t
    end
end

function lower_varname(var::BasicSymbolic, idv, order)
    order == 0 && return var
    D = Differential(idv)
    for _ in 1:order
        var = D(var)
    end
    return diff2term(var)
end

function var_from_nested_derivative(x,i=0)
    x = unwrap(x)
    if issym(x)
        (x, i)
    elseif iscall(x)
        operation(x) isa Differential ?
            var_from_nested_derivative(first(arguments(x)), i + 1) : (x, i)
    else
        error("Not a well formed derivative expression $x")
    end
end

"""
    degree(p, sym=nothing)

Extract the degree of `p` with respect to `sym`.

# Examples

```jldoctest
julia> @variables x;

julia> Symbolics.degree(x^0)
0

julia> Symbolics.degree(x)
1

julia> Symbolics.degree(x^2)
2
```
"""
function degree(p, sym=nothing)
    p = value(p)
    sym = value(sym)
    if SymbolicUtils.isconst(p) || p isa Number
        return 0
    end
    if isequal(p, sym)
        return 1
    end
    if isterm(p)
        if operation(p) === (^)
            base, exp = arguments(p)
            return unwrap_const(exp) * degree(base, sym)
        elseif sym === nothing
            return 1
        else
            return Int(isequal(p, sym))
        end
    elseif ismul(p)
        return sum(degree(k^v, sym) for (k, v) in zip(keys(p.dict), values(p.dict)))
    elseif isadd(p)
        return maximum(degree(key, sym) for key in keys(p.dict))
    elseif isdiv(p)
        return degree(p.num, sym) - degree(p.den, sym)
    elseif issym(p)
        if sym === nothing
            return 1
        else
            return Int(isequal(p, sym))
        end
    end
    throw(DomainError(p, "Datatype $(typeof(p)) not accepted."))
end

"""
    coeff(p, sym=nothing)

Extract the coefficient of `p` with respect to `sym`.
Note that `p` might need to be expanded and/or simplified with `expand` and/or `simplify`.

# Examples

```jldoctest
julia> @variables a x y;

julia> Symbolics.coeff(2a, x)
0

julia> Symbolics.coeff(3x + 2y, y)
2

julia> Symbolics.coeff(x^2 + y, x^2)
1

julia> Symbolics.coeff(2*x*y + y, x*y)
2
```
"""
function coeff(p, sym=nothing)
    # if `sym` is a product, iteratively compute the coefficient w.r.t. each term in `sym`
    if iscall(value(sym)) && operation(value(sym)) === (*)
        for t in arguments(value(sym))
            @assert !(t isa Number || SymbolicUtils.isconst(t)) "`coeff(p, sym)` does not allow `sym` containing numerical factors"
            p = coeff(p, t)
        end
        return p
    end
            
    p, sym = value(p), value(sym)

    if _isone(sym)
        sym = nothing
    end

    if issym(p) || SymbolicUtils.isconst(p) || isterm(p)
        sym === nothing ? 0 : Int(isequal(p, sym))
    elseif isadd(p)
        if sym===nothing
            p.coeff
        else
            sum(coeff(k, sym) * v for (k, v) in p.dict)
        end
    elseif ismul(p)
        args = arguments(p)
        coeffs = map(a->coeff(a, sym), args)
        if all(_iszero, coeffs)
            return 0
        else
            @views prod(Iterators.flatten((coeffs[findall(!_iszero, coeffs)], args[findall(_iszero, coeffs)])))
        end
    elseif isdiv(p)
        numerator, denominator = arguments(p)
        if !SymbolicUtils.query(isequal(sym), denominator)
            coeff(numerator, sym) / denominator
        else
            throw(DomainError(p, "coeff on fractions is not yet implemented."))
        end
    else
        p isa Number && return sym === nothing ? p : 0
        p isa BasicSymbolic && return coeff(p, sym)
        throw(DomainError(p, "Datatype $(typeof(p)) not accepted."))
    end
end

### Nums <--> Polys

const DP = DynamicPolynomials
# extracting underlying polynomial and coefficient type from Polyforms
underlyingpoly(x::Number) = x
coefftype(x::Number) = typeof(x)
coefftype(x::DP.Polynomial) = eltype(MP.coefficients(x))

as_concrete_polynomial(x::Number) = x
function as_concrete_polynomial(x::DP.Polynomial)
    coeffs = MP.coefficients(x)
    isconcretetype(eltype(coeffs)) && return x
    isempty(coeffs) && return poly_to_coefftype(Int, x)
    T = typeof(coeffs[1])
    for coeff in coeffs
        T = promote_type(T, typeof(coeff))
    end
    poly_to_coefftype(T, x)
end

function as_concrete_polynomial(x::SymbolicUtils.PolyVarT)
    mv = DP.MonomialVector{SymbolicUtils.PolyVarOrder, SymbolicUtils.MonomialOrder}([x], [Int[1]])
    return DP.Polynomial(Int[1], mv)
end

function poly_to_coefftype(::Type{T}, x::DP.Polynomial) where {T}
    DP.Polynomial(Vector{T}(MP.coefficients(x)), MP.monomials(x))
end

#=
Converts an array of symbolic polynomials
into an array of DynamicPolynomials.Polynomials
=#
function symbol_to_poly(sympolys::AbstractArray)
    @assert !isempty(sympolys) "Empty input."

    # standardize input
    stdsympolys = map(unwrap, sympolys)
    sort!(stdsympolys, lt = (<ₑ))

    symidx = findfirst(x -> x isa BasicSymbolic, stdsympolys)
    varT = vartype(stdsympolys[symidx])

    poly_to_bs = Bijections.Bijection{SymbolicUtils.PolyVarT, BasicSymbolic{varT}}()
    bs_to_poly = Bijections.active_inv(poly_to_bs)

    vars = BasicSymbolic{varT}[]
    for f in stdsympolys
        append!(vars, get_variables(f))
    end
    unique!(vars)
    sort!(vars, lt = (<ₑ))
    for var in vars
        SymbolicUtils.to_poly!(poly_to_bs, bs_to_poly, var)
    end

    polyforms = map(f -> as_concrete_polynomial(SymbolicUtils.to_poly!(poly_to_bs, bs_to_poly, f)), stdsympolys)
    # Discover common coefficient type
    commontype = mapreduce(coefftype, promote_type, polyforms, init = Int)
    @assert commontype <: Union{Integer, Rational} "Only integer and rational coefficients are supported as input."

    polynoms = map(Base.Fix1(poly_to_coefftype, commontype), polyforms)

    return polynoms, poly_to_bs
end

#=
Converts an array of AbstractPolynomialLike`s into an array of
symbolic expressions mapping variables w.r.t pvar2sym
=#
function poly_to_symbol(polys, poly_to_bs)
    map(Base.Fix1(SymbolicUtils.from_poly, poly_to_bs), polys)
end

"""
    symbolic_to_float(x::Union{Num, BasicSymbolic})::Union{AbstractFloat, BasicSymbolic}

If the symbolic value is exactly equal to a number, converts the symbolic value
to a floating point number. Otherwise retains the symbolic value.

## Examples

```julia
symbolic_to_float((1//2 * x)/x) # 0.5
symbolic_to_float((1/2 * x)/x) # 0.5
symbolic_to_float((1//2)*√(279//4)) # 4.175823272122517
```
"""
function symbolic_to_float end
symbolic_to_float(x::Num) = symbolic_to_float(unwrap(x))
symbolic_to_float(x::Number) = x
function symbolic_to_float(x::SymbolicUtils.BasicSymbolic)
    unwrap_const(SymbolicUtils.evaluate(x))
end

"""
    numerator(x)

Return the numerator of the symbolic expression `x`.

Examples
========
```julia-repl
julia> numerator(x/y)
x
```
"""
function Base.numerator(x::Union{Num, BasicSymbolic})
    x = unwrap(x)
    if iscall(x) && operation(x) == /
        x = arguments(x)[1] # get numerator
    end
    return wrap(x)
end

"""
    denominator(x)

Return the denominator of the symbolic expression `x`.

Examples
========
```julia-repl
julia> denominator(x/y)
y
```
"""
function Base.denominator(x::Union{Num, BasicSymbolic})
    x = unwrap(x)
    if iscall(x) && operation(x) == /
        x = arguments(x)[2] # get denominator
    else
        x = 1
    end
    return wrap(x)
end

"""
    arguments(x, op::Function)

Get the arguments of the symbolic expression `x` with respect to the operation or function `op`.
"""
function arguments(x, op::Function)
    x = unwrap(x)
    if iscall(x) && operation(x) == op
        args = [arguments(arg, op) for arg in arguments(x)] # recurse into each argument and obtain its factors
        args = reduce(vcat, args) # concatenate array of arrays into one array
    else
        args = [wrap(x)] # base case
    end
    return args
end

"""
    terms(x)

Get the terms of the symbolic expression `x`.

Examples
========
```julia-repl
julia> terms(-x + y - z)
3-element Vector{Num}:
 -z
  y
 -x
```
"""
terms(x) = arguments(x, +)

"""
    factors(x)

Get the factors of the symbolic expression `x`.

Examples
========
```julia-repl
julia> factors(2 * x * y)
3-element Vector{Num}:
 2
 y
 x
```
"""
factors(x) = arguments(x, *)

"""
    evaluate(eq::Equation, subs)
    evaluate(ineq::Inequality, subs)

Evaluate the equation `eq` or inequality `ineq`. `subs` is a dictionary of variable to numerical value substitutions. 
If both sides of the equation or inequality are numeric, then the result is a boolean. 

# Examples
```julia-repl
julia> @variables x y
julia> eq = x ~ y
julia> evaluate(eq, Dict(x => 1, y => 1))
true

julia> ltr = x ≲ y
julia> evaluate(ltr, Dict(x => 1, y => 2))
true

julia> gtr = x ≳ y
julia> evaluate(gtr, Dict(x => 1, y => 2))
false
```
"""
function evaluate end

function evaluate(eq::Equation, subs)
    lhs = substitute(eq.lhs, subs)
    rhs = substitute(eq.rhs, subs)
    return isequal(lhs, rhs)
end

function evaluate(ineq::Inequality, subs)
    lhs = substitute(ineq.lhs, subs)
    rhs = substitute(ineq.rhs, subs)
    if (ineq.relational_op == geq)
        return if SymbolicUtils.isconst(rhs) && SymbolicUtils.isconst(lhs)
            isless(unwrap_const(rhs), unwrap_const(lhs))::Bool
        else
            isless(rhs, lhs)
        end
    elseif (ineq.relational_op == leq)
        return if SymbolicUtils.isconst(lhs) && SymbolicUtils.isconst(rhs)
            isless(unwrap_const(lhs), unwrap_const(rhs))::Bool
        else
            isless(lhs, rhs)
        end
    else
        throw(ArgumentError("Inequality $ineq not supported"))
    end
end

function evaluate(x, subs)
    unwrap_const(substitute(x, subs; fold = Val(true)))
end

vartype_from_args(::BasicSymbolic{T}, args...) where {T} = T
vartype_from_args(_, args...) = vartype_from_args(args...)
vartype_from_args() = error("Cannot infer `vartype`.")

# Returns (pow, rest) such that term = sym^pow * rest.
# `rest` is a Number when sym^pow accounts for all symbolic content; otherwise a Num.
function _gather_split(term, sym)
    isequal(term, sym) && return 1, 1
    if !ismul(term)
        return 0, wrap(term)
    end
    pow = 0
    for (k, v) in term.dict
        if isequal(k, sym)
            pow = v
            break
        end
    end
    iszero(pow) && return 0, wrap(term)
    # Reconstruct the factor that remains after cancelling sym^pow.
    rest = term.coeff
    for (k, v) in term.dict
        isequal(k, sym) && continue
        rest = rest * wrap(k)^v   # promotes to Num on first symbolic factor
    end
    return pow, rest
end

"""
    gather_factor(expr, sym)
    gather_factor(expr, syms::AbstractArray)

Collect the additive terms of `expr` by grouping them according to the powers
of `sym` that they contain. Equivalent to SymPy's `collect`.

Operates directly on the `dict`-based representation of the `Add` / `Mul`
IR nodes for efficiency.

For multiple symbols, collection is applied sequentially left-to-right.

# Examples

```jldoctest
julia> @variables a b x;

julia> gather_factor(a*b*x + a*b + b*x, x)
a*b + (b + a*b)*x

julia> gather_factor(a*b*x + a*b + b*x, b)
(a + x + a*x)*b

julia> gather_factor(x^2 + 2x + 1, x)
1 + 2x + x^2
```
"""
function gather_factor(expr, sym)
    expr = expand(unwrap(expr))
    sym  = unwrap(sym)

    # power-of-sym => accumulated symbolic coefficient
    powers = Dict{Number, Any}()

    function _accum!(pow, contrib)
        prev = get(powers, pow, nothing)
        powers[pow] = prev === nothing ? contrib : prev + contrib
    end

    if isadd(expr)
        if !iszero(expr.coeff)
            _accum!(0, expr.coeff)
        end
        for (term, num_coeff) in expr.dict
            pow, rest = _gather_split(term, sym)
            _accum!(pow, num_coeff * rest)
        end
    else
        pow, rest = _gather_split(expr, sym)
        _accum!(pow, rest)
    end

    # Reconstruct: Σ coeff_n * sym^n
    sym_w  = wrap(sym)
    result = nothing
    for (pow, c) in powers
        term_part = if iszero(pow)
            c isa Num ? c : wrap(c)
        elseif isone(pow)
            c * sym_w
        else
            c * sym_w^pow
        end
        result = result === nothing ? term_part : result + term_part
    end
    return result === nothing ? wrap(0) : result
end

"""
    gather_factor(expr, syms::AbstractArray)

Apply [`gather_factor`](@ref) sequentially for each element of `syms`.
"""
function gather_factor(expr, syms::AbstractArray)
    for sym in syms
        expr = gather_factor(expr, sym)
    end
    return expr
end

using Symbolics
using SymbolicUtils
using Test
using LinearAlgebra
using SymbolicUtils: symtype

# Transpose and multiply

@variables A[1:2, 1:3] B[1:3, 1:1] x[1:2] y[1:3] C::(Matrix{Real}) z::(Vector{Complex})

stype(T::Type{<:Number}) = Float64
stype(T::Type{<:Complex}) = Complex{Float64}

AA = rand(2,3); BB = rand(3,2); xx = rand(2); yy = rand(3)

adjmul_leaf_nodes = (A, B, C, x, y, z, AA, BB, xx, yy)

function adjmul_rand_leaf()
    a = rand(adjmul_leaf_nodes)
    rand(Bool) ?  a' : a
end
function isadjvec(x)
    iscall(x) && (operation(x) === adjoint || operation(x) === transpose) && (
        ndims(arguments(x)[1]) == 1 ||
        ndims(arguments(x)[1]) == 2 && length(axes(arguments(x)[1], 2)) == 1)
end
isadjvec(x::Adjoint) = ndims(parent(x)) == 1
isadjvec(x::Transpose) = ndims(parent(x)) == 1
isdot(A, b) = isadjvec(A) && ndims(b) == 1

function rand_mul_expr(a=adjmul_rand_leaf(),
                       b=adjmul_rand_leaf())

    try
        a * b
    catch err1
        try
            rand(stype(eltype(a)), size(a)...) * rand(stype(eltype(b)), size(b)...)
        catch err2
            if typeof(err1) == typeof(err2)
                @test typeof(err1) == typeof(err2)
            else
                @test_skip typeof(err1) == typeof(err2)
            end
        end
    end
    sz = try size(a * b) catch err; nothing end

    if sz !== nothing
        if size(a) isa SymbolicUtils.Unknown || size(b) isa SymbolicUtils.Unknown
            return
        end

        if (isadjvec(Symbolics.unwrap(a)) && ndims(b) == 1) || isdot(a, b)
            if size(a*b) != ()
                println("a * b is wrong:")
                @show a b
                @show symtype(a) symtype(b)
                @show typeof(a) typeof(b)
                return @test size(a*b) == ()
            else
                return @test true
            end
        end

        ab_sample = rand(stype(eltype(a)), size(a)...) * rand(stype(eltype(b)), size(b)...)
        if size(a * b) == size(ab_sample)
            @test true
            @test (eltype(symtype(a*b)) <: Real && eltype(ab_sample) <: Real) || (eltype(ab_sample) <: Complex && eltype(symtype(a*b)) <: Complex)
        else
            println("a * b is wrong:")
            @show a b
                @show symtype(a) symtype(b)
            @show typeof(a) typeof(b)
            @show a * b
            @show isadjvec(Symbolics.unwrap(a))
            target_size = size(rand(size(a)...) * rand(size(b)...))
            @show target_size
            if target_size == (1,) && isadjvec(Symbolics.unwrap(a))
                target_size = ()
            end
            @test size(a * b) == target_size
        end
    end
end


@testset "fuzz ' and *" begin
    for i=1:1000
        rand_mul_expr()
    end
end

## Mapreduce
#

AA = rand(2,3); BB = rand(3,2); xx = rand(2); yy = rand(3)
CC = rand(2,3,4)

mapreduce_leaf_nodes = [A, B, x, y, AA, BB, CC, xx, yy]

function mapreduce_rand_leaf()
    a = rand(adjmul_leaf_nodes)
    rand(Bool) ?  a' : a
end

function rand_map_reduce(x=mapreduce_rand_leaf())
    n = ndims(x)

    reducedims = rand(1:n+1, rand(0:n))

    init=rand([nothing, rand(stype(eltype(x)))])
    function test_run(x)
        if init==nothing
            sum(x, dims=reducedims)
        else
            sum(x, dims=reducedims, init=init)
        end
    end

    @test size(test_run(rand(stype(eltype(x)), size(x)...))) == size(test_run(x))
end

using Symbolics

# https://github.com/JuliaSymbolics/Symbolics.jl/issues/1206
# test there is no extra white spaces on the left of e or f when displaying an array
@testset "e f alignment in array" begin
    r = @variables a b c d e f g h i j

    io = IOBuffer()
    td = TextDisplay(io)

    display(td, r)
    s = String(take!(io))
    @test s == "10-element Vector{Num}:\n a\n b\n c\n d\n e\n f\n g\n h\n i\n j\n"

    m = [a b c d
         b e f g
         c f h i
         d g i j]
    display(td, m)
    s = String(take!(io))
    @test s == "4×4 Matrix{Num}:\n a  b  c  d\n b  e  f  g\n c  f  h  i\n d  g  i  j\n"

    m *= [1, 2, 3, 4]
    display(td, m)
    s = String(take!(io))
    @test s ==
          "4-element Vector{Num}:\n a + 2b + 3c + 4d\n b + 2e + 3f + 4g\n c + 2f + 3h + 4i\n d + 2g + 3i + 4j\n"
end

# used to represent linear or irreducible quadratic factors
struct Factor
    expr
    root
    multiplicity
    x
end

function Factor(expr, multiplicity, x)
    fac_rule = @rule x + ~r => -~r
    return Factor(expr, fac_rule(expr), multiplicity, x)
end

function Base.isequal(a::Factor, b::Factor)
    return isequal(a.expr, b.expr) && a.multiplicity == b.multiplicity
end

# https://math.mit.edu/~hrm/18.031/pf-coverup.pdf
"""
    partial_frac_decomposition(expr, x)

Performs partial fraction decomposition for expressions with linear, repeated, or irreducible quadratic factors in the denominator. Can't currently handle irrational roots.

When leading coefficient of the denominator is not 1, it will be factored out and then put back in at the end, often leading to non-integer coefficients in the result. Will return `nothing` if the expression is not a valid polynomial fraction, or if it has irrational roots.

# Examples

```jldoctest
julia> @variables x
1-element Vector{Num}:
 x

julia> partial_frac_decomposition((3x-1) / (x^2 + x - 6), x)
(1//1) / (-(2//1) + x) + (2//1) / ((3//1) + x)

julia> partial_frac_decomposition((4x^3 + 16x + 7)/(x^2 + 4)^2, x)
((4//1)*x) / ((4//1) + x^2) + (7//1) / (((4//1) + x^2)^2)

julia> partial_frac_decomposition((4x^2 - 22x + 7)/((2x+3)*(x-2)^2), x)
2 / ((3//2) + x) + -3 / ((-(2//1) + x)^2)
```

!!! note that irreducible quadratic and repeated linear factors require the `Groebner` package to solve a system of equations
"""
function partial_frac_decomposition(expr, x; warns=true)
    A, B = numerator(expr), denominator(expr)

    # check if both numerator and denominator are polynomials
    if !_iszero(polynomial_coeffs(A, [x])[2]) || !_iszero(polynomial_coeffs(B, [x])[2])
        return nothing
    end

    if degree(A) >= degree(B)
        return nothing
    end
    
    facs = factorize(B, x, warns=warns)
    if facs === nothing
        return nothing
    end

    leading_coeff = coeff_vector(expand(B), x)[end] # of denominator
    
    # already in partial fraction form
    if length(facs) == 1 && only(facs).multiplicity == 1 && degree(A) <= 1
        return expr
    end

    result = []
    c_idx = 0 # index to keep track of which C subscript to use
    if length(facs) == 1
        fac = only(facs)

        if fac.root === nothing # irreducible quadratic factor
            for i = 1:fac.multiplicity
                push!(result, (variable(:𝒞, c_idx+=1)*x + variable(:𝒞, c_idx+=1))/(fac.expr^i)) # (Ax + B)/(x-r)^i
            end
        else
            append!(result, variables(:𝒞, (c_idx+1):(c_idx+=fac.multiplicity)) ./ fac.expr.^(1:fac.multiplicity)) # C1/(x-r) + C2/(x-2)^2 ...
        end
    else
        for fac in facs
            if fac.root === nothing # irreducible quadratic factor
                for i = 1:fac.multiplicity
                    push!(result, (variable(:𝒞, c_idx+=1)*x + variable(:𝒞, c_idx+=1))/(fac.expr^i)) # (Ax + B)/(x-r)^i
                end
                continue
            end

            # cover up method
            other_facs = filter(f -> !isequal(f, fac), facs)
            numerator = rationalize(unwrap_const(substitute(A / prod((f -> f.expr^f.multiplicity).(other_facs)), Dict(x => fac.root)))) # plug in root to expression without its factor in denominator
            push!(result, numerator / fac.expr^fac.multiplicity)

            if fac.multiplicity > 1
                append!(result, variables(:𝒞, (c_idx+1):(c_idx+=fac.multiplicity-1)) ./ fac.expr.^(1:fac.multiplicity-1)) # C1/(x-r) + C2/(x-2)^2 ...
            end
        end
    end

    # no unknowns, so just return
    if isequal(collect(get_variables(sum(result))), [unwrap(x)])
        return sum(result ./ leading_coeff)
    end

    lhs = numerator(expr)
    rhs = expand(sum(simplify.(numerator.(result) .* ((B/leading_coeff) ./ denominator.(result))))) # multiply each numerator by the common denominator/its denominator, and sum to get numerator of whole expression

    solution = solve_interms_ofvar(lhs - rhs, x)[1] # solve for unknowns (C's) by looking at coefficients of the polynomial

    # single unknown
    if !(solution isa Dict)
        solution = Dict(variable(:𝒞, 1) => solution)
    end
    
    return sum(substitute.(result, Ref(solution)) ./ leading_coeff) # substitute solutions back in and sum
end

# increasing from 0 to degree n. doesn't skip powers of x like polynomial_coeffs
function coeff_vector(poly, x, n)
    coeff_dict = polynomial_coeffs(poly, [x])[1]
    vec = []
    for i = 0:n
        if x^i in keys(coeff_dict)
            push!(vec, coeff_dict[x^i])
        else
            push!(vec, 0)
        end
    end

    return vec
end

# increasing from 0 to degree of poly
function coeff_vector(poly, x)
    return coeff_vector(poly, x, degree(poly))
end

function count_multiplicities(facs)
    counts = Dict()
    for fac in facs
        if haskey(counts, fac)
            counts[fac] += 1
        else
            counts[fac] = 1
        end
    end

    return counts
end

# for partial fractions, into linear and irreducible quadratic factors
function factorize(expr, x; warns=true)
    roots = symbolic_solve(expr, x, dropmultiplicity=false)

    counts = count_multiplicities(roots)
    facs = Set()

    for root in keys(counts)
        if !_iszero(imag(root))
            fac_expr = expand((x - root)*(x - conj(root)))
            if _iszero(real(root))
                # workaround for purely imaginary roots
                # otherwise, the fac_expr expansion will be real but imag(fac_expr) doesn't evaluate properly
                fac_expr = imag(root)^2 + x^2
            end

            if !_iszero(imag(fac_expr))
                warns && @warn "Encountered issue with complex irrational roots. Returning nothing."
                return nothing
            end
            push!(facs, Factor(real(fac_expr), counts[root], x))
            continue
        end

        push!(facs, Factor(x - root, root, counts[root], x))
    end

    return facs
end

# general helpers
function ssubs(expr, dict)
    if haskey(dict, expr)
        return dict[expr]
    end
    expr = unwrap(expr)
    if iscall(expr)
        op = ssubs(operation(expr), dict)
        args = map(arguments(expr)) do x
            ssubs(x, dict)
        end
        op(wrap.(args)...)
    else
        return expr
    end
end

# In the solver we might want to return Symbolics.term(sqrt, x)
# as a root. If x is a negative real number, the evaluation of such
# a root will fail since sqrt is not defined for Real n < 0.
# Thus we use Symbolics.term(Symbolics.ssqrt, x) that handles negative numbers.
# Similarly, scbrt and slog handle such similar cases.
function ssqrt(n)
    n = unwrap(n)

    if n isa Real
        isnan(n) && return n
        n > 0 && return sqrt(n)
        return sqrt(complex(n))
    end

    if n isa Complex
        return sqrt(n)
    end

    if n isa SymbolicUtils.BasicSymbolic{Real}
        return term(ssqrt, n)
    end
end

derivative(::typeof(ssqrt), args...) = substitute(derivative(sqrt, args...), sqrt => ssqrt)

function scbrt(n)
    n = unwrap(n)

    if n isa Real
    isnan(n) && return n
        return cbrt(n)
    end

    if n isa Complex
        return (n)^(1 / 3)
    end

    if n isa SymbolicUtils.BasicSymbolic{Real}
        return term(scbrt, n)
    end
end

derivative(::typeof(scbrt), args...) = substitute(derivative(cbrt, args...), cbrt => scbrt)

function slog(n)
    n = unwrap(n)

    if n isa Real
        isnan(n) && return n
        return n > 0 ? log(n) : log(complex(n))
    end

    if n isa Complex
        return log(n)
    end

    return term(slog, n)
end

derivative(::typeof(slog), args...) = substitute(derivative(log, args...), log => slog)

const RootsOf = (SymbolicUtils.@syms roots_of(poly,var))[1]

Base.show(io::IO, f::typeof(ssqrt)) = print(io, "√")
Base.show(io::IO, r::typeof(scbrt)) = print(io, "∛")
Base.show(io::IO, r::typeof(slog)) = print(io, "slog")

function check_expr_validity(expr)
    type_expr = typeof(expr)
    valid_type = false

    if type_expr <: Number || type_expr == Num || type_expr == SymbolicUtils.BasicSymbolic{Real} ||
       type_expr == Complex{Num} || type_expr == ComplexTerm{Real} || type_expr == SymbolicUtils.BasicSymbolic{Complex{Real}}
        valid_type = true
    end
    iscall(unwrap(expr)) && @assert !hasderiv(unwrap(expr)) "Differential equations are not currently supported"
    @assert valid_type "Invalid input" 
    valid_type && return nothing
    # @assert isequal(expr, 0) "Invalid input"
end
function check_x(x)
    iscall(unwrap(x)) && @assert !hasderiv(unwrap(x)) "Differential equations are not currently supported"
    @assert is_singleton(unwrap(x)) "Expected a variable, got $x"
end


function check_poly_inunivar(poly, var)
    subs, filtered = filter_poly(poly, var)
    coeffs, constant = polynomial_coeffs(filtered, [var])
    return isequal(constant, 0)
end

# converts everything to BIG
function bigify(n)
    n = unwrap(n)
    if n isa ComplexTerm || n isa Float64 || n isa Irrational
        return n
    end

    if n isa SymbolicUtils.BasicSymbolic
        !iscall(n) && return n
        args = copy(parent(arguments(n)))
        for i in eachindex(args)
            args[i] = bigify(args[i])
        end
        n = maketerm(typeof(n), operation(n), args, metadata(n))
        return n
    end

    if n isa Integer
        n = BigInt(n)
        return n
    end

    if n isa Complex
        real_part = bigify(n.re)
        im_part = bigify(n.im)
        return real_part + im_part * im
    end

    if n isa Rational && n isa Real
        n = big(n)
        return n
    end

    return n
end

function comp_rational(x, y)
    x, y = wrap(bigify(x)), wrap(bigify(y))
    if !(unwrap(x) isa AbstractFloat || x isa Complex) &&
       !(unwrap(y) isa AbstractFloat || y isa Complex)
        r = x // y
        return r
    end

    x, y = unwrap(x), unwrap(y)
    r = nothing
    if x isa ComplexF64
        real_p = real(x)
        imag_p = imag(x)
        r = Rational(real_p) // y
        if !isequal(imag_p, 0)
            r += (Rational(imag_p) // y) * im
        end
    elseif x isa Float64
        r = Rational{BigInt}(x) // y
    end

    return isequal(r, nothing) ? x / y : r
end

### multivar stuff ###
function contains_var(var, vars)
    for variable in vars
        if isequal(var, variable)
            return true
        end
    end
    return false
end

import DomainSets: Domain, Interval, AbstractInterval
import Symbolics: value, Sym, Term, Num

struct VarDomainPairing
  variables::BasicSymbolic{VartypeT}
  domain::Domain
end

const DomainedVar = Union{SymbolicT, Num}

Base.:∈(variable::DomainedVar,domain::Domain) = VarDomainPairing(unwrap(variable),domain)
Base.:∈(variable::DomainedVar,domain::Interval) = VarDomainPairing(unwrap(variable),domain)

# Construct Interval domain from a Tuple
Base.:∈(variable::DomainedVar,domain::NTuple{2,Real}) = VarDomainPairing(variable,Interval(domain...))

# Multiple variables
Base.:∈(variables::NTuple{N,DomainedVar},domain::Domain) where N = VarDomainPairing(unwrap.(variables),domain)

for D in (
        typeof(DomainSets.ℕ),
        DomainSets.Integers,
        DomainSets.RealNumbers,
        DomainSets.Rationals,
        DomainSets.ComplexNumbers,
        DomainSets.HalfLine{<:Any, :open},
        DomainSets.HalfLine{<:Any, :closed},
        DomainSets.NegativeHalfLine{<:Any, :open},
        DomainSets.NegativeHalfLine{<:Any, :closed},
    )
    @eval begin
        Base.:∈(variable::DomainedVar, domain::$D) = VarDomainPairing(unwrap(variable), domain)
        Base.:∈(variables::NTuple{N, DomainedVar}, domain::$D) where {N} =
            VarDomainPairing(unwrap.(variables), domain)
    end
end

# IntervalSets dispatches on this non-public concrete family, so the public
# `AbstractInterval` type is not specific enough to resolve the intersection.
function Base.:∈(variable::DomainedVar, domain::IntervalSets.TypedEndpointsInterval)
    return VarDomainPairing(unwrap(variable), domain)
end
function Base.:∈(
        variables::NTuple{N, DomainedVar}, domain::IntervalSets.TypedEndpointsInterval
    ) where {N}
    return VarDomainPairing(unwrap.(variables), domain)
end

"""
    Symbolics.infimum(d::AbstractInterval)

Deprecated. Use `IntervalSets.infimum` (also re-exported by DomainSets) instead.

Return the left endpoint of the interval domain `d`.

This function was added so that an interval with `Num` endpoints, such as the domain of a
PDE variable written `x ∈ Interval(a, b)`, could be queried for its lower bound. That
turned out to be unnecessary: `IntervalSets.infimum` is generic over the endpoint type and
already handles `Num`, so the only effect of a separate `Symbolics.infimum` is to shadow it
whenever both Symbolics and DomainSets are in scope.

`Symbolics.infimum` now forwards to `IntervalSets.infimum` and warns; it will be removed in
the next breaking release. Callers should switch to

```julia
import DomainSets
infimum(d)
```

See also: [`Symbolics.supremum`](@ref).
"""
function infimum(d::AbstractInterval)
    Base.depwarn(
        "`Symbolics.infimum` is deprecated, use `IntervalSets.infimum` (re-exported by " *
            "DomainSets) instead.", :infimum
    )
    return IntervalSets.infimum(d)
end

"""
    Symbolics.supremum(d::AbstractInterval)

Deprecated. Use `IntervalSets.supremum` (also re-exported by DomainSets) instead.

Return the right endpoint of the interval domain `d`. This is the counterpart of
[`Symbolics.infimum`](@ref) and is deprecated for the same reason: `IntervalSets.supremum`
is generic over the endpoint type and already handles `Num`, so a separate Symbolics
function only shadows it.

`Symbolics.supremum` now forwards to `IntervalSets.supremum` and warns; it will be removed
in the next breaking release.
"""
function supremum(d::AbstractInterval)
    Base.depwarn(
        "`Symbolics.supremum` is deprecated, use `IntervalSets.supremum` (re-exported by " *
            "DomainSets) instead.", :supremum
    )
    return IntervalSets.supremum(d)
end

@noinline __throw_absent_groebner_engine() = throw(
    """Groebner bases engine is required. Execute `using Groebner` to enable this functionality.""")

"""
    groebner_basis(polynomials; kwargs...)

Computes a Groebner basis of the ideal generated by the given `polynomials`
using Groebner.jl as the backend.

!!! note
    This function requires a Groebner bases backend (such as Groebner.jl) to be loaded.

The basis is guaranteed to be unique.
The algorithm is randomized, and the output is correct with high probability.

If a coefficient in the resulting basis becomes too large to be represented
exactly, `DomainError` is thrown.

## Optional Arguments

The Groebner.jl backend provides a number of useful keyword arguments, which are
also available for this function. See `?Groebner.groebner`.

## Example

```jldoctest
julia> using Symbolics, Groebner

julia> @variables x y;

julia> groebner_basis([x*y^2 + x, x^2*y + y])
```
"""
function groebner_basis(args; kwargs...)
    __throw_absent_groebner_engine()
end

"""
    groebner_basis(polynomials)

Checks whether the given `polynomials` forms a Groebner basis.

This function requires a Groebner bases backend (such as Groebner.jl) to be loaded.
"""
function is_groebner_basis(args; kwargs...)
    __throw_absent_groebner_engine()
end

using Documenter, Symbolics, SymbolicUtils
import Nemo, Groebner, SymPy

DocMeta.setdocmeta!(Symbolics, :DocTestSetup, :(using Symbolics); recursive = true)

cp("./docs/Manifest.toml", "./docs/src/assets/Manifest.toml", force = true)
cp("./docs/Project.toml", "./docs/src/assets/Project.toml", force = true)

# Make sure that plots don't throw a bunch of warnings / errors!
ENV["GKSwstype"] = "100"
using Plots

mathengine = MathJax3(Dict(:loader => Dict("load" => ["[tex]/require", "[tex]/mathtools"]),
                           :tex => Dict("inlineMath" => [["\$", "\$"], ["\\(", "\\)"]],
                                        "packages" => [
                                            "base",
                                            "ams",
                                            "autoload",
                                            "mathtools",
                                            "require",
                                        ])))

makedocs(
    sitename="Symbolics.jl",
    authors="Chris Rackauckas",
    modules=[Symbolics],
    clean=true, doctest=true, linkcheck = true, checkdocs = :public,
    format = Documenter.HTML(assets = ["assets/favicon.ico"],
                             mathengine = mathengine,
                             canonical="https://docs.sciml.ai/Symbolics/stable/"),
    pages=[
        "Home" => "index.md",
        "getting_started.md",
        "Tutorials" => Any[
            "tutorials/auto_parallel.md",
            "tutorials/converting_to_C.md",
            "tutorials/perturbation.md"
        ],
        "Manual" => Any[
            "Basics" => [
                "manual/variables.md",
                "manual/expression_manipulation.md",
                "manual/faq.md",
                "manual/external.md",
                "manual/arrays.md",
                "manual/build_function.md",
                "manual/functions.md",
                "manual/parsing.md",
                "manual/io.md",
                "manual/types.md",
                "manual/metadata.md",
            ],

            "Algebra" => [
                "manual/solver.md",
                "manual/groebner.md",
                "manual/constraint_satisfaction.md",
                "manual/partial_fractions.md",
            ],

            "Calculus" => [
                "manual/derivatives.md",
                "manual/integration.md",
                "manual/ode.md",
                "manual/taylor.md",
                "manual/sparsity_detection.md",
                "manual/limits.md",
            ],

            "manual/misc.md",
            "manual/discontinuities.md",
        ],
        "Comparison Against SymPy" => "comparison.md",
    ]
)

deploydocs(
   repo = "github.com/JuliaSymbolics/Symbolics.jl.git";
   push_preview = true
)

using Symbolics, Test
using DomainSets
@variables x y

I1 = Integral(x in ClosedInterval(1, 5))
I2 = Integral(x in ClosedInterval(1, 5))
@test I1 == I2

@test isequal(I1, I2)
@test hash(I1) == hash(I2)
@test isequal(I1, deepcopy(I1)) && hash(I1) == hash(deepcopy(I1))
let I3 = Integral(x in ClosedInterval(1, 6))
    @test !isequal(I1, I3)
    @test hash(I1) != hash(I3)
end
# As a `Term` operation, content-identical integrals hash-cons together.
@test isequal(I1(y), I2(y))
@test hash(I1(y)) == hash(I2(y))

let I1 = Integral(x in ClosedInterval(0.0, x)),
        I2 = Integral(x in ClosedInterval(0.0f0, x)),
        I3 = Integral(x in ClosedInterval(0.0, 1.0))
    @test isequal(I1, I2)
    @test hash(I1) == hash(I2)
    @test isequal(I1(y), I2(y))
    @test !isequal(I1, I3)
end

@variables v(..) u(..) x y a b

# test constant integrand
I = Integral(x in ClosedInterval(a, b))
@test isequal(I(0), 0)
@test isequal(I(2), 2*(b -a))
@test isequal(I(2.1), 2.1*(b - a))
@test isequal(I(pi), pi*(b - a))
@test isequal(I(1//2), 1//2 * (b - a))

# test complex integrand
@test I(2im) isa Complex{Num}
@test isequal(I(2im), 2im * (b - a))
@test isequal(I(1 + 2.1im), (1 + 2.1im)*(b - a))
@test I(x + im*x) isa Complex{Num}

D = Differential(x)
Dxx = Differential(x)^2
I = Integral(y in ClosedInterval(1, 5))
eq = D(I(u(x,y))) ~ 0
eq_test = I(D(u(x,y)))
@test isequal(expand_derivatives(eq.lhs), Symbolics.value(eq_test))

eq = Dxx((I(u(x,y)))) + I(D(u(x,y))) ~ 0
eq_test = I(D(u(x,y))) + I(D(D(u(x,y))))
@test isequal(expand_derivatives(eq.lhs), Symbolics.value(eq_test))

I = Integral(y in ClosedInterval(1, v(x)))
eq = D((I(u(x,y)))) ~ 0
eq_test = I(D(u(x,y))) + D(v(x))*u(x, v(x))
@test isequal(expand_derivatives(eq.lhs), Symbolics.value(eq_test))

I = Integral(y in ClosedInterval(1, v(x)))
eq = Dxx((I(u(x,y)))) ~ 0
eq_test = D(I(D(u(x,y))) + D(v(x))*u(x, v(x)))
eq_test_ = I(D(D(u(x,y)))) + D(D(v(x)))*u(x, v(x)) + 2D(u(x,v(x)))*D(v(x))
@test isequal(expand_derivatives(eq.lhs), Symbolics.value(eq_test_))
@test isequal(expand_derivatives(eq.lhs), expand_derivatives(eq_test))

eq = D((I(u(x,y)^2))) ~ 0
eq_test = I(2D(u(x,y))*u(x,y)) + D(v(x))*u(x, v(x))^2
@test isequal(expand_derivatives(eq.lhs), Symbolics.value(eq_test))

# case where limits of integral contain the variable to derive
# against
I = Integral(y in ClosedInterval(1, 2x))
@test isequal(expand_derivatives(D(I(1))), 2)

# same but case where limit of integral is not a call
I = Integral(y in ClosedInterval(1, x))
@test isequal(expand_derivatives(D(I(1))), 1)

# test shadowing by integration variable
# the result of a definite integral over x does not depend on x
# anymore unless it appears again in the limits
I = Integral(x in ClosedInterval(1, 2))
@test isequal(expand_derivatives(D(I(u(x)))), 0)

using Symbolics
using SymbolicUtils, SymbolicUtils.Code
import SymbolicUtils as SU
using Test

struct Record1
    x::Int
    y::String
    z::Vector{Real}
end

@symstruct Record1

@testset "`isequal` and `hash`" begin
    @variables rec1::Record1
    @test isequal(rec1, rec1)
    @test isequal(rec1, SU.unwrap(rec1))
    @test isequal(SU.unwrap(rec1), rec1)
    @test hash(rec1) == hash(SU.unwrap(rec1))
end

@testset "`getproperty` operation and arguments" begin
    @variables rec1::Record1
    ex = SU.unwrap(rec1.x)
    @test operation(ex) === Symbolics.SymbolicGetproperty{Record1, :x}()
    @test isequal(arguments(ex), [SU.unwrap(rec1)])
end

@testset "`promote_symtype`" begin
    @variables rec1::Record1
    @test SU.promote_symtype(operation(SU.unwrap(rec1.x)), Record1) === Int
    @test SU.promote_symtype(operation(SU.unwrap(rec1.y)), Record1) === String
    @test SU.promote_symtype(operation(SU.unwrap(rec1.z)), Record1) === Vector{Real}
end

@testset "Basic record" begin
    @variables rec::Record1

    @test rec isa Symbolics.SymStruct{Record1}
    ex = rec.x
    @test ex isa Num
    @test SU.symtype(SU.unwrap(ex)) === Int

    ex = rec.y
    @test ex isa Symbolics.SymbolicT
    @test SU.symtype(ex) === String

    ex = rec.z
    @test ex isa Symbolics.Arr{Num, 1}
    @test SU.symtype(SU.unwrap(ex)) === Vector{Real}
    @test SU.shape(SU.unwrap(ex)) === SU.Unknown(1)

    @test toexpr(rec.x) == :(rec.x)
    ex = [rec.y, rec.x + rec.z[1]]
    val = eval(quote
        let rec = Record1(1, "abc", [1.0, 2.0])
            $(toexpr(ex))
        end
    end)
    @test val == ["abc", 2.0]
end

struct Record2{T}
    x::Int
    y::String
    z::Vector{T}
end

@symstruct Record2{T} begin
    shape(:z) = [1:3]
end

@testset "Parametric record with specified shape" begin
    @variables rec::Record2{Int}

    ex = rec.z
    @test ex isa Symbolics.Arr{Num, 1}
    @test SU.symtype(SU.unwrap(ex)) === Vector{Int}
    @test SU.shape(SU.unwrap(ex)) == [1:3]

    ex = rec.z[1]
    @test ex isa Num
    @test SU.symtype(SU.unwrap(ex)) === Int
end

@testset "Recursive struct" begin
    @variables rec::Record2{Record2{Record1}}

    ex = rec.z
    @test ex isa Symbolics.Arr{Symbolics.SymStruct{Record2{Record1}}, 1}
    @test SU.symtype(SU.unwrap(ex)) === Vector{Record2{Record1}}
    @test SU.shape(SU.unwrap(ex)) == [1:3]

    ex = rec.z[1]
    @test ex isa Symbolics.SymStruct{Record2{Record1}}
    @test SU.symtype(SU.unwrap(ex)) === Record2{Record1}

    ex = rec.z[1].z
    @test ex isa Symbolics.Arr{Symbolics.SymStruct{Record1}, 1}
    @test SU.symtype(SU.unwrap(ex)) === Vector{Record1}
    @test SU.shape(SU.unwrap(ex)) == [1:3]

    ex = rec.z[1].z[1]
    @test ex isa Symbolics.SymStruct{Record1}
    @test SU.symtype(SU.unwrap(ex)) === Record1

    ex = rec.z[1].z[1].z
    @test ex isa Symbolics.Arr{Num, 1}
    @test SU.symtype(SU.unwrap(ex)) === Vector{Real}
    @test SU.shape(SU.unwrap(ex)) === SU.Unknown(1)

    @test toexpr(rec.z[1].z[2].z[3]) == :($getindex($getindex($getindex(rec.z, 1).z, 2).z, 3))
    @variables rec::Record2{Record1}
    val = eval(quote
        let rec = Record2{Record1}(1, "A",
                                   [Record1(2, "B", [2.0, 3.0]),
                                       Record1(3, "C", [3.0, 4.0]),
                                       Record1(4, "D", [4.0, 5.0])])
            $(toexpr(rec.x + rec.z[1].x + rec.z[2].z[1] + rec.z[3].z[2]))
        end
    end)
    @test val == 1 + 2 + 3.0 + 5.0
end

abstract type AbstractRecord1 end

@symstruct AbstractRecord1 begin
    shape(:x) = [1:3]
end

struct ConcreteRecord1_1 <: AbstractRecord1
    x::Vector{Int}
end

struct ConcreteRecord1_2 <: AbstractRecord1
    x::Vector{Int}
end

@symstruct ConcreteRecord1_2 begin
    shape(:x) = [1:2]
end

record_op1(x::ConcreteRecord1_1) = sum(x.x)
record_op1(x::ConcreteRecord1_2) = prod(x.x)

@register_symbolic record_op1(x::AbstractRecord1)

record_arrop1(x::Vector{<:AbstractRecord1}) = sum(record_op1, x)

@register_symbolic record_arrop1(x::Vector{AbstractRecord1})

@testset "`@symstruct` of simple abstract type" begin
    @test Symbolics.has_symwrapper(AbstractRecord1)
    @test Symbolics.wrapper_type(AbstractRecord1) == SymStruct{<:AbstractRecord1}
    @test Symbolics.wrapper_type(ConcreteRecord1_1) === SymStruct{ConcreteRecord1_1}

    @variables r1::ConcreteRecord1_1 r2::ConcreteRecord1_2
    @test SU.shape(r1.x) == [1:3]
    @test SU.shape(r2.x) == [1:2]
end

@testset "Function registration with symbolic structs" begin
    @variables r1::ConcreteRecord1_1 r2::ConcreteRecord1_2
    ex = record_op1(r1)
    @test operation(SU.unwrap(ex)) === record_op1

    val = eval(quote
        let r1 = ConcreteRecord1_1([2,2,3])
            $(toexpr(ex))
        end
    end)
    @test val == 7

    ex = record_op1(r2)
    @test operation(SU.unwrap(ex)) === record_op1

    val = eval(quote
        let r2 = ConcreteRecord1_2([2,2,3])
            $(toexpr(ex))
        end
    end)
    @test val == 12

    @variables r3[1:2]::ConcreteRecord1_1 r4[1:2]::ConcreteRecord1_2

    ex = record_arrop1(r3)
    @test operation(SU.unwrap(ex)) === record_arrop1
    val = eval(quote
        let r3 = [ConcreteRecord1_1([2,3,4]), ConcreteRecord1_1([3,4,5])]
            $(toexpr(ex))
        end
    end)
    @test val == 21

    ex = record_arrop1(r4)
    @test operation(SU.unwrap(ex)) === record_arrop1
    val = eval(quote
        let r4 = [ConcreteRecord1_2([2,3,4]), ConcreteRecord1_2([3,4,5])]
            $(toexpr(ex))
        end
    end)
    @test val == 84

    ex = record_arrop1([r3[1], r1])
    @test operation(SU.unwrap(ex)) === record_arrop1
    ex = record_arrop1([r4[1], r2])
    @test operation(SU.unwrap(ex)) === record_arrop1
end

abstract type AbstractRecord2{T} end

@symstruct AbstractRecord2

@testset "Registering type without parameters works" begin
    @test Symbolics.has_symwrapper(AbstractRecord2)
    @test Symbolics.wrapper_type(AbstractRecord2) == SymStruct{<:AbstractRecord2}
    @test Symbolics.has_symwrapper(AbstractRecord2{Int})
    @test Symbolics.wrapper_type(AbstractRecord2{Int}) == SymStruct{<:AbstractRecord2{Int}}
end

@testset "`issymstruct`" begin
    @variables x rec1::Record1
    # SymStruct instance → true
    @test Symbolics.issymstruct(rec1)
    # Unwrapped BasicSymbolic whose symtype is a registered struct → true
    @test Symbolics.issymstruct(SU.unwrap(rec1))
    # Plain scalar variable → false
    @test !Symbolics.issymstruct(x)
    @test !Symbolics.issymstruct(SU.unwrap(x))
    # Field-access result (symtype Int, not a struct type) → false
    @test !Symbolics.issymstruct(SU.unwrap(rec1.x))
    # Non-symbolic value → false
    @test !Symbolics.issymstruct(1)
end

@testset "Linear indexing" begin
    # Record1 has z::Vector{Real} with unknown shape → linear indexing not supported
    @test !Symbolics.symstruct_supports_linear_indexing(Record1)
    # Record2{Int} has shape(:z) = [1:3] → supported
    @test Symbolics.symstruct_supports_linear_indexing(Record2{Int})

    @variables rec::Record2{Int}
    # x::Int (1 element) + y::String (1 element) + z::Vector{Int} shape [1:3] (3 elements) = 5
    @test length(rec) == 5

    @test isequal(rec[1], SU.unwrap(rec.x))
    @test isequal(rec[2], SU.unwrap(rec.y))
    @test isequal(rec[3], SU.unwrap(rec.z[1]))
    @test isequal(rec[4], SU.unwrap(rec.z[2]))
    @test isequal(rec[5], SU.unwrap(rec.z[3]))

    @test_throws BoundsError rec[0]
    @test_throws BoundsError rec[6]

    elems = collect(rec)
    @test length(elems) == 5
    @test all(e -> e isa Symbolics.SymbolicT, elems)
    @test isequal(elems[1], rec[1])
    @test isequal(elems[5], rec[5])
end

@testset "Linear indexing with nested SymStruct" begin
    @test Symbolics.symstruct_supports_linear_indexing(Record2{Record2{Int}})
    # x(1) + y(1) + z::Vector{Record2{Int}} [1:3] × 5 each = 2 + 15 = 17
    @test Symbolics.symstruct_length(Record2{Record2{Int}}) == 17

    @variables rec::Record2{Record2{Int}}
    @test length(rec) == 17

    # z starts at index 3; z[1] contributes indices 3..7 (5 elements)
    @test isequal(rec[3], SU.unwrap(rec.z[1].x))     # z[1].x (first scalar field)
    @test isequal(rec[4], SU.unwrap(rec.z[1].y))     # z[1].y (second scalar field)
    @test isequal(rec[7], SU.unwrap(rec.z[1].z[3]))  # z[1].z[3] (last element of z[1])
    # z[2] starts at index 8
    @test isequal(rec[8], SU.unwrap(rec.z[2].x))
end

@testset "`diff2term` with SymStruct field access" begin
    @variables t rec(t)::Record2{Int}
    D = Differential(t)

    # diff2term(D(rec(t).x)) should equal the .x field of diff2term(D(rec(t)))
    x_term = SU.unwrap(rec.x)
    dt_x = Symbolics.diff2term(D(x_term))
    @test SU.symtype(dt_x) === Int

    rec_term = SU.unwrap(rec)
    dt_rec = Symbolics.diff2term(D(rec_term))
    @test isequal(dt_x, SU.unwrap(getproperty(Symbolics.SymStruct{Record2{Int}}(dt_rec), :x)))

    # diff2term(D(rec(t).z[2])) should equal diff2term(D(rec(t))).z[2]
    z2_term = SU.unwrap(rec.z[2])
    dt_z2 = Symbolics.diff2term(D(z2_term))
    @test SU.symtype(dt_z2) === Int
    z_arr = getproperty(Symbolics.SymStruct{Record2{Int}}(dt_rec), :z)
    @test isequal(dt_z2, SU.unwrap(z_arr[2]))
end

for (T1, T2) in Iterators.product([Number, BasicSymbolic{VartypeT}, Num], [Integer, BasicSymbolic{VartypeT}, Num])
    if T1 != Num && T2 != Num
        continue
    end
    @eval function Base.binomial(a::$T1, b::$T2)
        binomial(unwrap(a), unwrap(b))
    end
end

@register_derivative sign(x) 1 COMMON_ZERO
@register_derivative signbit(x) 1 COMMON_ZERO
@register_derivative abs(x) 1 ifelse(signbit(x),-one(x),one(x))
@register_derivative min(x, y) 1 ifelse(x < y, one(x), zero(x))
@register_derivative min(x, y) 2 ifelse(x < y, zero(y), one(y))
@register_derivative max(x, y) 1 ifelse(x > y, one(x), zero(x))
@register_derivative max(x, y) 2 ifelse(x > y, zero(y), one(y))
@register_derivative ceil(x) 1 COMMON_ZERO
@register_derivative floor(x) 1 COMMON_ZERO
@register_derivative factorial(x) 1 COMMON_ZERO

@register_symbolic Base.rand(x)
@register_symbolic Base.randn(x)

for (T1, T2, T3) in Iterators.product(Iterators.repeated((Num, BasicSymbolic{VartypeT}, Number), 3)...)
    if T1 != Num && T2 != Num && T3 != Num
        continue
    end
    @eval function Base.clamp(a::$T1, b::$T2, c::$T3)
        wrap(clamp(unwrap(a), unwrap(b), unwrap(c)))
    end
end

@register_derivative clamp(x, l, h) 1 ifelse(x < l, COMMON_ZERO, ifelse(x > h, COMMON_ZERO, COMMON_ONE))

for T1 in [Real, Num, BasicSymbolic{VartypeT}], T2 in [AbstractArray, Arr, BasicSymbolic{VartypeT}]
    if T1 != Num && T2 != Arr
        continue
    end
    T1 == Num && T2 == AbstractArray && continue
    @eval function Base.in(x::$T1, y::$T2)
        return in(unwrap(x), unwrap(y))
    end
end
Base.in(x::Num, y::AbstractArray) = SymbolicUtils.term(in, unwrap(x), y)
Base.in(x::Num, y::Array) = SymbolicUtils.term(in, unwrap(x), y)
Base.in(x::Num, y::SparseArrays.AbstractSparseArray) = SymbolicUtils.term(in, unwrap(x), y)
Base.in(x::Num, y::AbstractRange{Num}) = SymbolicUtils.term(in, unwrap(x), y)
Base.in(x::Num, y::AbstractRange{<:Real}) = SymbolicUtils.term(in, unwrap(x), y)
Base.in(x::Num, y::AbstractRange{<:Integer}) = SymbolicUtils.term(in, unwrap(x), y)
function Base.in(x::Num, y::AbstractRange{T}) where {T >: Num}
    return SymbolicUtils.term(in, unwrap(x), y)
end
Base.in(x::Num, y::_StaticArray) = SymbolicUtils.term(in, unwrap(x), y)
for (T1, T2) in Iterators.product(Iterators.repeated([AbstractArray, Arr, BasicSymbolic{VartypeT}], 2)...)
    if T1 != Arr && T2 != Arr
        continue
    end
    @eval function Base.union(a::$T1, b::$T2)
        union(unwrap(a), unwrap(b))
    end
    @eval function Base.intersect(a::$T1, b::$T2)
        intersect(unwrap(a), unwrap(b))
    end
    @eval function Base.issubset(a::$T1, b::$T2)
        issubset(unwrap(a), unwrap(b))
    end
end
Base.intersect(a::AbstractRange, b::Arr{<:Any, 1}) = intersect(a, unwrap(b))
Base.intersect(a::Arr{<:Any, 1}, b::AbstractRange) = intersect(unwrap(a), b)

LinearAlgebra.norm(x::Num, p::Real) = abs(x)

for f in (
        SpecialFunctions.besseli, SpecialFunctions.besselj,
        SpecialFunctions.besselk, SpecialFunctions.bessely,
    )
    @eval begin
        (f::$(typeof(f)))(a::Num, b::AbstractFloat) = invoke(f, Tuple{Num, Real}, a, b)
        (f::$(typeof(f)))(a::Num, b::Complex) = invoke(f, Tuple{Num, Number}, a, b)
    end
end
for T in (Signed, Rational, Float32, Float64)
    @eval Base.copysign(a::$T, b::Num) = invoke(copysign, Tuple{Real, Num}, a, b)
end
SpecialFunctions.polygamma(a::Integer, b::Num) =
    invoke(SpecialFunctions.polygamma, Tuple{Real, Num}, a, b)

# `Base.sincospi(::Real)` explicitly throws a `MethodError` so that subtypes of
# `Real` (like `Num`) have to opt in. Fall back to a tuple of `sinpi`/`cospi`,
# both of which are already registered.
Base.sincospi(x::Num) = (sinpi(x), cospi(x))

# `Base.sinpi(::Complex)` and `Base.cospi(::Complex)` branch on `isinteger` of
# the real/imaginary parts, so we need `isinteger(::Num)`. For a wrapped
# constant we can answer exactly; for a symbolic variable whose `symtype` is an
# `Integer` we know the value must be an integer; otherwise we conservatively
# return `false` (an unknown real is not assumed to be an integer).
function Base.isinteger(x::Num)
    val = unwrap(x)
    if SymbolicUtils.isconst(val)
        return isinteger(SymbolicUtils.unwrap_const(val))
    end
    return symtype(val) <: Integer
end

@register_derivative <(x, y) I COMMON_ZERO
@register_derivative <=(x, y) I COMMON_ZERO
@register_derivative >(x, y) I COMMON_ZERO
@register_derivative >=(x, y) I COMMON_ZERO
@register_derivative ==(x, y) I COMMON_ZERO
@register_derivative !=(x, y) I COMMON_ZERO
@register_derivative expinti(x) 1 exp(x) / x

"""
    sub(subs, place_to_sub)
Helper function for filter_poly. Generates a symbolics variable and adds it
to subs (changes the original array passed to the sub function). returns the
subbed value so the filter_poly function could change it in its scope.

# Arguments
- subs: Vector of dicts which consist of var_subbed => value_subbed in filter_poly
- place_to_sub: The place which should be substituted by a new variable.

"""
function sub(subs, place_to_sub)
    sub_var = gensym()
    sub_var = (@variables $sub_var)[1]

    subs[sub_var] = place_to_sub
    place_to_sub = sub_var.val

    return place_to_sub
end

"""
    clean_f(filtered_expr, var, subs)

Helper function for `filter_poly` which is called directly before returning
the `filtered_expression`. This function aims to get the filtered expressions
resulting from `filter_poly` ready to get used by solve, `get_roots`, and any other
function in the library. An important feature of it is that it simplifies fractions
to make the output "valid" in the eyes of `factor_use_nemo` and other Nemo functions.

# Arguments
- `filtered_expr`: The output from `_filter_poly`.
- var: The variable which is filtered for.
- subs: Vector of dicts which consist of `var_subbed` => `value_subbed` in `_filter_poly`.

"""
function clean_f(filtered_expr, var, subs)
    filtered_expr = simplify_fractions(simplify(real(filtered_expr)))
    unwrapped_f = unwrap(filtered_expr)
    !iscall(unwrapped_f) && return filtered_expr
    oper = operation(unwrapped_f)
    assumptions = []

    if oper === (/)
        if !all(isequal(var, x) for x in get_variables(denominator(unwrapped_f)))
            filtered_expr = numerator(unwrapped_f)
            push!(assumptions, substitute(denominator(unwrapped_f), subs, fold=Val(false)))
        end
    end
    return filtered_expr, assumptions
end

"""
    filter_stuff(expr)
Helper function for _filter_poly and filter_poly which aims to filter
constants and things that dont contain variables like term(sqrt, 2).
Filters only if the passed expr is scary (i.e. not a Rational or Int).

# Arguments
- expr: The detected constant in _filter_poly

# Examples
```jldoctest
julia> using Symbolics, SymbolicUtils

julia> length(Symbolics.filter_stuff(SymbolicUtils.term(sqrt, 2))[1]) == 1
true

julia> Symbolics.filter_stuff(123)
(Dict{Any, Any}(), 123)
```
"""
function filter_stuff(expr)
    expr = value(expr)
    if expr isa Integer
        return Dict(), expr
    elseif expr isa Rational || expr isa AbstractFloat || expr isa Complex
        return Dict(), comp_rational(expr, 1)
    else
        expr = isequal(expr, true) ? 1 : expr
        subs = Dict{Any, Any}()

        expr = sub(subs, expr)
        return subs, expr
    end
end

"""
    _filter_poly(expr, var)

Main mechanism for filter_poly. Traverses arguments as deep 
as needed/makes sense by recalling itself as many times as necessary.
Output is then returned to filter_poly. This function should not be used
(although functional) instead of filter_poly since it does not contain
the final touch of clean_f, which is needed if the output is going to get passed
to other functions.

# Arguments
- expr: Expression to be filtered passed from filter_poly
- var: Var that the expression should be filtered with respect to.

# Examples
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> Symbolics._filter_poly(x + sqrt(2), x)
(Dict{Any, Any}(), (6369051672525773//4503599627370496) + x)

julia> Symbolics._filter_poly(x*sqrt(2), x)
(Dict{Any, Any}(), (6369051672525773//4503599627370496)*x)
```
"""
function _filter_poly(expr, var)
    expr = unwrap(expr)
    vars = get_variables(expr)
    if !isempty(vars) && isequal(first(vars), expr)
        return (Dict{Any, Any}(), expr)
    elseif isempty(vars)
        return filter_stuff(expr)
    end

    args = copy(parent(arguments(expr)))
    if symtype(expr) <: Complex
        subs1, subs2 = Dict(), Dict()
        expr1, expr2 = 0, 0
        rr = real(expr)
        ii = imag(expr)
        if !isequal(rr, 0)
            subs1, expr1 = _filter_poly(rr, var)
        end
        if !isequal(ii, 0)
            subs2, expr2 = _filter_poly(ii, var)
        end

        subs = merge(subs1, subs2)
        i_var = gensym()
        i_var = (@variables $i_var)[1]

        subs[i_var] = im
        expr = unwrap(expr1 + i_var * expr2)

        args = map(unwrap, arguments(expr))
        oper = operation(expr)
        return subs, term(oper, args...)
    end
    subs = Dict{Any, Any}()
    for (i, arg) in enumerate(args)
        # handle constants
        arg = value(arg)
        vars = get_variables(arg)
        if isempty(vars)
            if arg isa Integer
                args[i] = Const{VartypeT}(bigify(args[i]))
                continue
            elseif arg isa Rational || arg isa AbstractFloat || arg isa Complex
                args[i] = Const{VartypeT}(comp_rational(arg, 1))
                continue
            end
            args[i] = Const{VartypeT}(sub(subs, args[i]))
            continue
        end

        # handle "x" as an argument
        if length(vars) == 1
            if isequal(arg, var) || isequal(first(vars), arg)
                continue
            end
        end

        oper = operation(arg)
        monomial = copy(parent(arguments(arg)))
        if oper === (^)
            if any(arg -> isequal(arg, var), monomial)
                continue
            end
            # filter(args[1]), filter[args[2]] and then merge
            subs1, __monomial_1 = _filter_poly(monomial[1], var)
            subs2, __monomial_2 = _filter_poly(monomial[2], var)
            monomial[1] = Const{VartypeT}(__monomial_1)
            monomial[2] = Const{VartypeT}(__monomial_2)

            merge!(subs, merge(subs1, subs2))
            args[i] = maketerm(typeof(arg), oper, monomial, metadata(arg))
            continue
        end

        if oper === (*)
            subs_of_monom = Dict{Any, Any}()
            for (j, x) in enumerate(monomial)
                vars = get_variables(x)
                if (!isempty(vars) && isequal(first(vars), x))
                    continue
                elseif x isa Integer
                    monomial[j] = bigify(monomial[j])
                    continue
                elseif x isa Rational || x isa AbstractFloat || x isa Complex
                    monomial[j] = comp_rational(x, 1)
                    continue
                end
                # filter each arg and then merge
                new_subs, __monomial_j = _filter_poly(monomial[j], var)
                monomial[j] = Const{VartypeT}(__monomial_j)
                merge!(subs_of_monom, new_subs)
            end
            merge!(subs, subs_of_monom)
            args[i] = maketerm(typeof(arg), oper, monomial, metadata(arg))
            continue
        end

        if oper === (/) || oper === (+)
            for (j, x) in enumerate(monomial)
                new_subs, new_filtered = _filter_poly(monomial[j], var)
                merge!(subs, new_subs)
            end
            continue
        end
    end

    args = map(unwrap, args)
    oper = operation(expr)
    expr = maketerm(typeof(expr), oper, args, metadata(expr))
    return subs, expr
end

"""
    filter_poly(og_expr, var)

Filters polynomial expressions from weird irrationals that mess up
the functionality of other helper functions for our solvers such as
polynomial_coeffs and factor_use_nemo.

# Arguments
- og_expr: Original passed expression. This is deepcopied so that the
user's expression is not altered unwillingly.
- var: Var that the expression should be filtered with respect to.

# Examples
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> y = only(@variables y)
y

julia> length(Symbolics.filter_poly(x + 2im, x)[1]) == 1
true

julia> z = only(@variables z)
z

julia> length(Symbolics.filter_poly((1/im)*x + 3*y*z, x)[1]) == 1
true

julia> length(Symbolics.filter_poly((x+1)*SymbolicUtils.term(log, 3), x)[1]) == 1
true
```
"""
function filter_poly(og_expr, var; assumptions=false)
    expr = deepcopy(og_expr)
    expr = unwrap(expr)
    vars = get_variables(expr)

    # handle edge cases
    if !isempty(vars) && isequal(first(vars), expr)
        assumptions && return Dict{Any, Any}(), expr, []
        return (Dict{Any, Any}(), expr)
    elseif isempty(vars)
        assumptions && return filter_stuff(expr), []
        return filter_stuff(expr)
    end

    # core filter
    subs, expr = _filter_poly(expr, var)

    # reassemble expr to avoid variables remembering original values issue and clean
    args = arguments(expr)
    oper = operation(expr)
    new_expr, assum_array = clean_f(term(oper, args...; type = symtype(expr), shape = shape(expr)), var, subs)

    assumptions && return subs, new_expr, assum_array
    return subs, new_expr
end

function filter_poly(og_expr; assumptions=false)
    new_var = gensym()
    new_var = (@variables $(new_var))[1]
    return filter_poly(og_expr, new_var; assumptions=assumptions)
end


"""
    sdegree(coeffs, var)
Gets the degree of a polynomial by traversing the `coeffs`
output from polynomial_coeffs.

# Arguments
- coeffs: output from polynomial_coeffs
- var: var present in polynomial_coeffs

# Examples
```jldoctest
julia> using Symbolics

julia> x = only(@variables x)
x

julia> coeffs, constant = Symbolics.polynomial_coeffs(x^2 + x + 1, [x]); length(coeffs)
3

julia> Symbolics.sdegree(coeffs, x)
2


julia> coeffs, constant = Symbolics.polynomial_coeffs(x^12 + 3x^2, [x]); length(coeffs)
2

julia> Symbolics.sdegree(coeffs, x)
12
```
"""
function sdegree(coeffs, var)
    degree = 0
    vars = collect(keys(coeffs))
    for n in vars
        SymbolicUtils._isone(n) && continue
        isequal(n, var) && degree > 1 && continue

        if isequal(n, var) && degree < 1
            degree = 1
            continue
        end

        args = arguments(n)
        degree = max(unwrap_const(args[2]), degree)
    end
    return degree
end

SymbolicUtils.promote_symtype(::typeof(imag), ::Type{Complex{T}}) where {T} = T
Base.promote_rule(::Type{Complex{T}}, ::Type{S}) where {T<:Real, S<:Num} =  Complex{S} # 283
Base.promote_rule(::Type{Complex{T}}, ::Type{Num}) where {T <: Real} = Complex{Num}

is_wrapper_type(::Type{Complex{Num}}) = true
has_symwrapper(::Type{<:Complex{T}}) where {T<:Real} = true
wraps_type(::Type{Complex{Num}}) = Complex{Real}
iswrapped(::Complex{Num}) = true
function wrapper_type(::Type{Complex{T}}) where T
    Symbolics.has_symwrapper(T) ? Complex{wrapper_type(T)} : Complex{T}
end

function SymbolicUtils.unwrap(a::Complex{<:Num})
    re, img = unwrap(real(a)), unwrap(imag(a))
    if SymbolicUtils.isconst(re) && SymbolicUtils.isconst(img)
        return Const{VartypeT}(complex(unwrap_const(re), unwrap_const(img)))
    end
    if iscall(re) && operation(re) === real && iscall(img) && operation(img) === imag && isequal(arguments(re)[1], arguments(img)[1])
        return arguments(re)[1]
    end
    sT = promote_type(symtype(re), symtype(img))
    return Term{VartypeT}(complex, SymbolicUtils.ArgsT{vartype(re)}((re, img)); type = Complex{sT}, shape = SymbolicUtils.ShapeVecT())
end

SymbolicUtils.infer_vartype(::Type{Complex{Num}}) = VartypeT

function Base.Complex{Num}(x::BasicSymbolic{VartypeT})
    Complex{Num}(wrap(real(x)), wrap(imag(x)))
end

const IM = Sym{VartypeT}(:im; type = Number)

function Base.show(io::IO, a::Complex{Num})
    rr = unwrap(real(a))
    ii = unwrap(imag(a))

    if iscall(rr) && (operation(rr) === real) &&
        iscall(ii) && (operation(ii) === imag) &&
        isequal(arguments(rr)[1], arguments(ii)[1])

        return print(io, arguments(rr)[1])
    end

    show(io, real(a) + IM * imag(a))
end

function (s::SymbolicUtils.Substituter)(x::Complex{Num})
    Complex{Num}(s(real(x)), s(imag(x)))
end

using Symbolics
import Symbolics: ssqrt, slog, scbrt, symbolic_solve, ia_solve, postprocess_root, value
using SymbolicUtils
using SymbolicUtils: Const
using Test

# @testset "ia_solve without Nemo" begin
#     @test Base.get_extension(Symbolics, :SymbolicsNemoExt) === nothing
#     @variables x
#     roots = ia_solve(log(2 + x), x)
#     roots = @test_warn ["Nemo", "required"] ia_solve(log(2 + x^2), x)
#     @test operation(roots[1]) === Symbolics.RootsOf
# end

using Groebner, Nemo
E = Base.MathConstants.e

function sort_roots(roots)
    return sort(roots, lt = (x,y) -> real(x)==real(y) ? imag(x)<imag(y) : real(x)<real(y))
end

function sort_arr(sols, vars)
    for i in eachindex(sols) 
        sols[i] = convert(Dict{Num, Any}, sols[i])
        for (var, root) in sols[i]
            sols[i][var] = eval(Symbolics.toexpr(root))
        end
    end

    extract_root(c) = (real(c), imag(c))
    sort_root(dict) = Tuple(extract_root(dict[var]) for var in vars)

    # Sorting the answers lexicographically
    sols = sort(sols, by=sort_root)
end

function check_equal(arr1, arr2)
    l1 = length(arr1)
    if l1 != length(arr2)
        return false
    end
    for i = 1:l1
        issetequal(keys(arr1[i]), keys(arr2[i])) || return false
        for k in keys(arr1[i])
            isequal(arr1[i][k], arr2[i][k]) || return false
        end
    end
    return true
end

function check_approx(arr1, arr2)
    l1 = length(arr1)
    if l1 != length(arr2)
        return false
    end
    for i = 1:l1
        if !isequal(keys(arr1[i]), keys(arr2[i]))
            return false
        end
        for (k1, v1) in arr1[i]
            isapprox(arr2[i][k1], v1; atol = 1e-6) || return false
        end
    end
    return true
end

@variables x y z a b c d e s

@testset "Solving in terms of a constant var" begin
    eq = ((s^2 + 1)/(s^2 + 2*s + 1)) - ((s^2 + a)/(b*c*s^2 + (b+c)*s + d))
    calcd_roots = sort_arr(Symbolics.solve_interms_ofvar(eq, s), [a,b,c,d])
    solve_roots = sort_arr(symbolic_solve(eq, [a,b,c,d]), [a,b,c,d])
    known_roots = sort_arr([Dict(a=>1, b=>1, c=>1, d=>1)], [a,b,c,d])
    @test check_approx(calcd_roots, known_roots)   
    @test check_approx(solve_roots, known_roots)   

    eq = (a+b)*s^2 - 2s^2 + 2*b*s - 3*s
    calcd_roots = sort_arr(Symbolics.solve_interms_ofvar(eq, s), [a,b])
    solve_roots = sort_arr(symbolic_solve(eq, [a,b]), [a,b])
    known_roots = sort_arr([Dict(a=>1/2, b=>3/2)], [a,b])
    @test check_approx(calcd_roots, known_roots)   
    @test check_approx(solve_roots, known_roots)   

    eq = (a*x^2+b)*s^2 - 2s^2 + 2*b*s - 3*s + 2(x^2)*(s^3) + 10*s^3
    calcd_roots = sort_arr(Symbolics.solve_interms_ofvar(eq, s), [a,b,x])
    solve_roots = sort_arr(symbolic_solve(eq, [a,b,x]), [a,b,x])
    known_roots = sort_arr([Dict(a=>-1/10, b=>3/2, x=>-im*sqrt(5)), Dict(a=>-1/10, b=>3/2, x=>im*sqrt(5))], [a,b,x])
    @test check_approx(calcd_roots, known_roots)   
    @test check_approx(solve_roots, known_roots)   
end

@testset "Invalid input" begin
    @test_throws AssertionError symbolic_solve(x, x^2)
end

@testset "Nice univar cases" begin
    found_roots = symbolic_solve(1/x^2 ~ 1/y^2 - 2/x^3 * (x-y), x)
    known_roots = Symbolics.unwrap.([y, -2y])
    @test isequal(found_roots, known_roots)
end

@testset "Deg 1 univar" begin
    @test isequal(unwrap_const(only(symbolic_solve(x+1, x))), -1)

    @test isequal(unwrap_const(only(symbolic_solve(2x+1, x))), -1/2)

    @test isequal(unwrap_const(only(symbolic_solve(x, x))), 0) 

    @test isequal(unwrap_const(only(symbolic_solve((x+1)^20, x))), -1)

    @test isequal(only(Symbolics.get_roots_deg1(x + y^3, x)), -y^3)

    expr = x - Symbolics.term(sqrt, 2)
    @test isequal(symbolic_solve(expr, x)[1], Symbolics.term(sqrt, 2))

    expr = x + im
    @test unwrap_const(symbolic_solve(expr, x)[1]) == -im
end

@testset "Deg 2 univar" begin
    expr = x^2 + 1
    arr_get_roots = sort_roots(eval.(Symbolics.toexpr.(Symbolics.get_roots_deg2(expr, x))))
    arr_solve_roots = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    arr_known_roots = sort_roots([-im, im])
    @test all(arr_get_roots .≈ arr_known_roots)
    @test all(arr_solve_roots .≈ arr_known_roots)

    expr = x^2 + 2x + 10
    arr_get_roots = sort_roots(eval.(Symbolics.toexpr.(Symbolics.get_roots_deg2(expr, x))))
    arr_solve_roots = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    arr_known_roots = sort_roots([-1 + 3im, -1 - 3im])
    @test all(arr_get_roots .≈ arr_known_roots)
    @test all(arr_solve_roots .≈ arr_known_roots)

    expr = x^2 - 10x + 25
    arr_get_roots = sort_roots(eval.(Symbolics.toexpr.(Symbolics.get_roots_deg2(expr, x))))
    arr_solve_roots = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    arr_known_roots = [5,5]
    @test all(arr_get_roots .≈ arr_known_roots)
    @test all(arr_solve_roots .≈ arr_known_roots)
end

@testset "Deg 3 univar" begin
    expr = x^3 - 2x^2 + x - 2 
    arr_get_roots = sort_roots(eval.(Symbolics.toexpr.(Symbolics.get_roots_deg3(expr, x))))
    arr_solve_roots = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    arr_known_roots = sort_roots([2, -im, im])
    @test all(isapprox.(arr_get_roots, arr_known_roots, atol=0.0000001))
    @test all(arr_solve_roots .≈ arr_known_roots)

    expr = x^3 + x^2 + x + 1
    arr_get_roots = sort_roots(eval.(Symbolics.toexpr.(Symbolics.get_roots_deg3(expr, x))))
    arr_solve_roots = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    arr_known_roots = sort_roots([-1, -im, im])
    @test all(isapprox.(arr_get_roots, arr_known_roots, atol=0.0000001))
    @test all(arr_solve_roots .≈ arr_known_roots)

    expr = x^3 + 10x
    arr_get_roots = sort_roots(eval.(Symbolics.toexpr.(Symbolics.get_roots_deg3(expr, x))))
    arr_solve_roots = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    arr_known_roots = sort_roots([0, -sqrt(10)*im, sqrt(10)*im])
    @test all(arr_get_roots .≈ arr_known_roots)
    @test all(arr_solve_roots .≈ arr_known_roots)
end

@testset "Deg 4 univar" begin
    expr = x^4 + 1
    arr_get_roots = sort_roots(eval.(Symbolics.toexpr.(Symbolics.get_roots_deg4(expr, x))))
    arr_solve_roots = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    arr_known_roots = sort_roots(eval.([-(complex(-1))^(1/4),(complex(-1))^(1/4), (complex(-1))^(3/4), -(complex(-1))^(3/4)]))
    @test all(arr_get_roots .≈ arr_known_roots)
    @test all(arr_solve_roots .≈ arr_known_roots)

    expr = x^4 - 3x^2 + 2
    arr_get_roots = sort_roots(eval.(Symbolics.toexpr.(Symbolics.get_roots_deg4(expr, x))))
    arr_solve_roots = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    arr_known_roots = sort_roots(eval.([-1, 1, sqrt(2), -sqrt(2)]))
    @test all(arr_get_roots .≈ arr_known_roots)
    @test all(arr_solve_roots .≈ arr_known_roots)

    expr = x^4 - x^3 - 2x^2 + 6x - 4
    arr_get_roots = sort_roots(eval.(Symbolics.toexpr.(Symbolics.get_roots_deg4(expr, x))))
    arr_solve_roots = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    arr_known_roots = sort_roots(eval.([-2, 1, 1-im, 1+im]))
    @test all(arr_get_roots .≈ arr_known_roots)
    @test all(arr_solve_roots .≈ arr_known_roots)

    expr = 386314 - 412163*x - 357800*(x^2) + 1029179*(x^3) - 111927*(x^4)
    arr_get_roots = sort_roots(eval.(Symbolics.toexpr.(Symbolics.get_roots_deg4(expr, x))))
    arr_solve_roots = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    r_novar = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr))))
    arr_known_roots = sort_roots(eval.([0.5840484 + 0.4176250im, 0.5840484 - 0.4176250im,
    8.788773679354421, -0.76177906049]))
    @test all(isapprox.(arr_known_roots, arr_get_roots, atol=0.00001))
    @test all(isapprox.(arr_known_roots, arr_solve_roots, atol=0.00001))
    @test all(isapprox.(arr_known_roots, r_novar, atol=0.00001))
end

@testset "Higher degree univar" begin
    expr = -b + a*x + c*x - d*x^2 + b*x^3 - a*x^4 - x^5
    root = only(symbolic_solve(expr, x))
    @test operation(root) === Symbolics.RootsOf
    @test isequal(arguments(root), [Symbolics.unwrap(expr), Symbolics.unwrap(x)])
end

@testset "Complex coeffs univar" begin
    expr = x^4 + sqrt(complex(-2//1))
    arr_get_roots = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    r_novar = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr))))
    arr_known_roots = sort_roots(eval.([-Complex(-1)^(3/8)*2^(1/8), Complex(-1)^(3/8)*2^(1/8), 
        Complex(-1)^(7/8)*2^(1/8), -Complex(-1)^(7/8)*2^(1/8)]))
    @test all(arr_get_roots .≈ arr_known_roots)
    @test all(r_novar .≈ arr_known_roots)

    # standby
    # expr = x^3 + sqrt(complex(-2//1))*x + 2
end

@testset "Multipoly solver" begin
    @test isequal(unwrap_const(symbolic_solve([x^2 - 1, x + 1], x)[1]), -1)
    @test isequal(symbolic_solve([x^2 - a^2, x + a], x)[1], -a)
    @test isequal(symbolic_solve([x^20 - a^20, x + a], x)[1], -a)
end
@testset "Multivar solver" begin
    @variables x y z
    @test symbolic_solve([x^4 - 1, x - 2], [x]) === nothing
    
    # TODO: test this properly
    sol = symbolic_solve([x^3 + 1, x*y^3 - 1], [x, y])

    eqs = [x*y + 2x^2, y^2 -1]
    arr_calcd_roots = sort_arr(symbolic_solve(eqs, [x,y]), [x,y])
    r_novar = sort_arr(symbolic_solve(eqs), [x,y])
    arr_known_roots = sort_arr([Dict(x=>-1//2, y=>1), Dict(x=>0, y=>-1), Dict(x=>0, y=>1), Dict(x=>1//2, y=>-1)], [x,y])
    arr_known_roots = sort_arr(arr_known_roots, [x,y])
    @test check_equal(arr_calcd_roots, arr_known_roots)   
    @test check_equal(r_novar, arr_known_roots)   

    eqs = [x-y-z, x+y-z^2, x^2 + y^2 - 1]
    eqs_in_equation_form = [x-y ~ z, x+y-z^2 ~ 0, x^2 + y^2 ~ 1]
    arr_calcd_roots = sort_arr(symbolic_solve(eqs, [x,y,z]), [x,y,z])
    r_novar = sort_arr(symbolic_solve(eqs_in_equation_form), [x,y,z])
    r_eq = sort_arr(symbolic_solve(eqs_in_equation_form, [x,y,z]), [x,y,z])
    arr_known_roots = sort_arr([Dict(x => 0, y=>1, z=>-1), Dict(x=>1, y=>0, z=>1),
        Dict(x=>(1/2)*(-2-sqrt(2)*im), y=>(1/2)*(-2+sqrt(2)*im), z=>-sqrt(2)*im),
        Dict(x=>(1/2)*(-2+sqrt(2)*im), y=>(1/2)*(-2-sqrt(2)*im), z=>sqrt(2)*im)], [x,y,z])
    @test check_approx(arr_calcd_roots, arr_known_roots)   
    @test check_approx(r_novar, arr_known_roots)   
    @test check_approx(r_eq, arr_known_roots)   

    eqs = [x^2, y, z]
    eqs_in_equation_form = [x^2 ~ 0, y ~ 0, z ~ 0]
    arr_calcd_roots = sort_arr(symbolic_solve(eqs, [x,y,z], dropmultiplicity=false), [x,y,z])
    r_novar = sort_arr(symbolic_solve(eqs, dropmultiplicity=false), [x,y,z])
    r_eq_novar = sort_arr(symbolic_solve(eqs_in_equation_form, dropmultiplicity=false), [x,y,z])
    arr_known_roots = sort_arr([Dict(x=>0, y=>0, z=>0), Dict(x=>0, y=>0, z=>0)], [x,y,z])
    @test check_equal(arr_calcd_roots, arr_known_roots)   
    @test check_equal(r_novar, arr_known_roots)   
    @test check_equal(r_eq_novar, arr_known_roots)   

    eqs = [y^2 - 1, x]
    arr_calcd_roots = sort_arr(symbolic_solve(eqs, [x,y]), [x,y])
    arr_known_roots = sort_arr([Dict(y=>1//1, x=>0//1), Dict(y=>-1//1, x=>0//1)], [x,y])
    @test check_equal(arr_calcd_roots, arr_known_roots)   


    eqs = [x^5 + x, y]
    arr_calcd_roots = sort_arr(symbolic_solve(eqs, [x,y]), [x,y])
    arr_known_roots = sort_arr([Dict(x=>0, y=>0), Dict(x=>-(complex(-1))^(1/4), y=>0),
    Dict(x=>(complex(-1))^(1/4), y=>0), Dict(x=>-(complex(-1))^(3/4), y=>0),
    Dict(x=>(complex(-1))^(3/4), y=>0)], [x,y])
    @test check_approx(arr_calcd_roots, arr_known_roots)   

    @test symbolic_solve([x*y - 1, y], [x,y]) === nothing
    @test symbolic_solve([x+y+1, x+y+2], [x,y]) === nothing

    eqs = [-1 + y + z + x^2,
           -1 + x + z + y^2,
           -1 + x + y + z^2]
    arr_calcd_roots = sort_arr(symbolic_solve(eqs, [x,y,z]), [x,y,z])
    arr_known_roots = sort_arr([Dict(z=>0, y=>1, x=>0),
    Dict(z=>1, y=>0, x=>0),
    Dict(z=>0, y=>0, x=>1),
    Dict(z=>-1+sqrt(2), y=>-1+sqrt(2), x=>-1+sqrt(2)),
    Dict(z=>-1-sqrt(2), y=>-1-sqrt(2), x=>-1-sqrt(2))], [x,y,z])
    @test check_approx(arr_calcd_roots, arr_known_roots)    

    # cyclic 3
    @variables z1 z2 z3
    eqs = [z1 + z2 + z3, z1*z2 + z1*z3 + z2*z3, z1*z2*z3 - 1]
    sol = symbolic_solve(eqs, [z1,z2,z3])
    backward = [Symbolics.substitute(eqs, s) for s in sol]
    @test all(x -> all(isapprox.(eval(Symbolics.toexpr(x)), 0; atol=1e-6)), backward)

    @variables x y
    eqs = [2332//232*x + 2131232*y - 1//343434, x + y + 1]
    sol = symbolic_solve(eqs, [x,y])
    backward = [Symbolics.substitute(eqs, s) for s in sol]
    @test all(x -> all(isapprox.(eval(Symbolics.toexpr(x)), 0; atol=1e-6)), backward)

    # TODO: broken
    # @variables H1 H2
    # eqs = [-288421779135875//1125899906842624*H1^2 + 1963378034549373//562949953421312*H1 - 4, -288421779135875//844424930131968*H1*H2 + 1963378034549373//562949953421312*H2 - 4]
    # symbolic_solve(eqs, [H1, H2])

    @test isnothing(symbolic_solve([x*y - 1, sin(x)], [x, y]))

    @variables x y z
    boot = 10
    for i in 1:boot
        # at most 4 roots by Bézout's theorem
        rand_eq(xs, d) = rand(-10:10) + rand(-10:10)*x + rand(-10:10)*y + rand(-10:10)*x*y + rand(-10:10)*x^2 + rand(-10:10)*y^2
        eqs = [rand_eq([x,y],2), rand_eq([x,y],2)]
        sol = symbolic_solve(eqs, [x,y])
        backward = [Symbolics.substitute(eqs, s) for s in sol]
        @test all(x -> all(isapprox.(eval(Symbolics.toexpr(x)), 0; atol=1e-6)), backward)
    end

    @test isnothing(symbolic_solve([x^2, x*y, y^2], [x,y], warns=false))
end

@testset "Multivar parametric" begin
    @variables x y a
    @test isequal(value(only(symbolic_solve([x + a, a - 1], x))), -1)
    @test isequal(symbolic_solve([x - a, y + a], [x, y]), [Dict(y => -a, x => a)])
    @test isequal(symbolic_solve([x*y - a, x*y + x], [x, y]), [Dict(y => Const{SymReal}(-1), x => -a)])
    @test symbolic_solve([x*y - a, 1 ~ 3], [x, y]) === nothing

    @test isnothing(symbolic_solve([x*y - 1, sin(x)], [x, y]))

    @test isnothing(symbolic_solve([x*y - a, sin(x)], [x, y]))

    @variables t w u v
    sol = symbolic_solve([t*w - 1 ~ 4, u + v + w ~ 1], [t,w])
    @test isequal(sol, [Dict(t => -5 / (-1//1 + u + v), w => 1//1 - u - v)])

    sol = symbolic_solve([x-y, y-z], [x])
    @test isequal(sol, [z]) || isequal(sol, [y])

    sol = symbolic_solve([x-y, y-z], [x, y])
    @test isequal(sol, [Dict(x=>z, y=>z)])

    sol = value.(symbolic_solve([x + y - z, y - z], [x]))
    @test isequal(sol, [0])
end

@testset "Factorisation" begin
    f = 10x
    u, factors = Symbolics.factor_use_nemo(f)
    @test isequal(u, 10) && isequal(factors, [x])

    f = Symbolics.wrap(10)
    u, factors = Symbolics.factor_use_nemo(f)
    @test isequal(u, 10) && isempty(factors)

    f = x^2 - 1
    u, factors = Symbolics.factor_use_nemo(f)
    @test isequal(u, 1) && isequal(expand(u*prod(factors) - f), 0)

    f = expand((x + 1//3) * ((x*y)^2 + 2x*y + y^2) * (x - z))
    u, factors = Symbolics.factor_use_nemo(f)
    @test isequal(expand(u*prod(factors) - f), 0)
end


# Post Process roots #
@testset "Post Process roots" begin
    SymbolicUtils.@syms __x
    __symsqrt(x) = SymbolicUtils.term(ssqrt, x)
    term = SymbolicUtils.term
    @test Symbolics.postprocess_root(2 // 1) == 2 && Symbolics.postprocess_root(2 + 0*im) == 2
    @test Symbolics.postprocess_root(__symsqrt(4)) == 2
    @test isequal(Symbolics.postprocess_root(__symsqrt(__x)^2), __x)


    @test isequal(Symbolics.postprocess_root(term(^, 0, __x)), 0)
    @test_broken isequal(Symbolics.postprocess_root(term(/, __x, 0)), Inf)
    @test value(Symbolics.postprocess_root(term(^, __x, 0) )) == 1
    @test value(Symbolics.postprocess_root(term(^, Base.MathConstants.e, 0) )) == 1
    @test value(Symbolics.postprocess_root(term(^, Base.MathConstants.pi, 1) )) ≈ Base.MathConstants.pi
    @test isequal(Symbolics.postprocess_root(term(^, __x, 1) ), __x)

    x = Symbolics.term(sqrt, 2)
    @test isequal(Symbolics.postprocess_root( expand((x + 1)^4) ), 17 + 12x)
    @test isequal(Symbolics.postprocess_root( x^5 ), 4 * x)

    @test isequal(Symbolics.postprocess_root(Symbolics.term(sqrt, 9//4)), 3//2)
    @test isequal(Symbolics.postprocess_root(Symbolics.term(sqrt, -27//8)), im*3//2*Symbolics.term(sqrt, 3//2))
end


# Filter Poly # For future reference, i think @check_polynomial is not enough of a test.
@testset "Filter poly" begin
    @variables x y z c1 c2 
    poly = x*sqrt(complex(-2)) + 2.23324234
    subs, filtered_poly = Symbolics.filter_poly(poly, x)
    @test Symbolics.check_polynomial(filtered_poly)

    poly = x + 2im
    subs, filtered_poly = Symbolics.filter_poly(poly, x)
    @test Symbolics.check_polynomial(filtered_poly)

    poly = im*x + Symbolics.wrap(Symbolics.term(sqrt, 2))
    subs, filtered_poly = Symbolics.filter_poly(poly, x)
    @test Symbolics.check_polynomial(filtered_poly)

    poly = (1/im)*x + 3*y*z
    subs, filtered_poly = Symbolics.filter_poly(poly, x)
    @test Symbolics.check_polynomial(filtered_poly)

    poly = (x+1)*Symbolics.term(log, 3)
    subs, filtered_poly = Symbolics.filter_poly(poly, x)
    @test Symbolics.check_polynomial(filtered_poly)
end


@testset "n func occ (smart occurrence counter)" begin
    @test Symbolics.n_func_occ(x, x) == 1
    @test Symbolics.n_func_occ(log(x), x) == 1
    @test Symbolics.n_func_occ(log(x) + x, x) == 2

    # standby
    # @test Symbolics.(log(y) + x , x) == 1
    @test Symbolics.n_func_occ(log(a*x) + b, x) == 1
    
    @test Symbolics.n_func_occ(log(x + sin((x^2 + x)/log(x))), x) == 3
    @test Symbolics.n_func_occ(x^2 + x + x^3, x) == 1
    @test Symbolics.n_func_occ(log(x)^2 - 17, x) == 1
    @test Symbolics.n_func_occ(2^(x^2 + x) + 5^(x+3), x) == 2

    expr = log( log(x) + log(x) ) + log( log(x) + log(x) ) - 11
    @test Symbolics.n_func_occ(expr, x) == 1

    # log(2) - 3log(5) + x*log(2) - x*log(5)
    expr = expand((1 + x)*Symbolics.term(log, 2) - (3 + x)*Symbolics.term(log, 5))
    @test Symbolics.n_func_occ(expr, x) == 1
end



@testset "Isolate/Attract solve" begin
    lhs = ia_solve(a*x^b + c, x)[1]
    lhs2 = symbolic_solve(a*x^b + c, x)[1]
    rhs = Symbolics.term(^, -c.val/a.val, 1/b.val) 
    @test_broken isequal(lhs, rhs)

    @test isequal(value(symbolic_solve(2/x, x)[1]), Inf)
    @test isequal(value(symbolic_solve(x^1.5, x)[1]), 0)

    lhs = symbolic_solve(log(a*x)-b,x)[1]
    @test isequal(Symbolics.value(substitute(lhs, Dict(a=>1, b=>1); fold = Val(true))), 1E)
    
    expr = x + 2
    lhs = eval.(Symbolics.toexpr.(ia_solve(expr, x)))
    lhs_solve = eval.(Symbolics.toexpr.(symbolic_solve(expr, x)))
    rhs = [-2]
    @test lhs[1] ≈ rhs[1]
    @test lhs_solve[1] ≈ rhs[1]

    expr = sqrt(log(cbrt(x^2)))
    lhs = sort_roots(eval.(Symbolics.toexpr.(ia_solve(expr, x))))
    lhs_solve = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    rhs = sort_roots([1, -1])
    @test all(isapprox.(lhs, rhs, atol=1e-6))
    @test all(isapprox.(lhs_solve, rhs, atol=1e-6))

    expr = log(x+1) + log(x-1)
    @test isapprox(eval(Symbolics.toexpr(symbolic_solve(expr, x)[1])), sqrt(2), atol=1e-6)

    expr = 2^(x+1) + 5^(x+3)
    lhs = ComplexF64.(eval.(Symbolics.toexpr.(ia_solve(expr, x))))
    lhs_solve = eval.(Symbolics.toexpr.(symbolic_solve(expr, x)))
    rhs = [(-im*Base.MathConstants.pi - log(2) + 3log(5))/(log(2) - log(5))]
    @test lhs[1] ≈ rhs[1] || conj(lhs[1]) ≈ rhs[1]
    @test lhs_solve[1] ≈ rhs[1] || conj(lhs_solve[1]) ≈ rhs[1]

    expr = 3*2^(x+3) + 2*5^(x+1)
    lhs = eval.(Symbolics.toexpr.(ia_solve(expr, x)))
    lhs_solve = eval.(Symbolics.toexpr.(symbolic_solve(expr, x)))
    rhs = [(-im*Base.MathConstants.pi + log(5) - log(12))/(log(2) - log(5))]
    @test lhs[1] ≈ rhs[1] || lhs[1] ≈ conj(rhs[1])
    @test lhs_solve[1] ≈ rhs[1] || lhs_solve[1] ≈ conj(rhs[1])

    expr = exp(2x)*exp(x^2 + 3) + 3
    lhs = sort_roots(eval.(Symbolics.toexpr.(ia_solve(expr, x))))
    lhs_solve = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    rhs = sort_roots([-1 + sqrt(-2 + im*Base.MathConstants.pi + log(3)),
        -1 - sqrt(-2 + im*Base.MathConstants.pi + log(3))])
    @test all(lhs .≈ rhs)
    @test all(lhs_solve .≈ rhs)

    expr = x/5 + 3x^2
    lhs = sort_roots(eval.(Symbolics.toexpr.(ia_solve(expr, x))))
    lhs_solve = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    rhs = sort_roots([0, -1//15])
    @test all(lhs .≈ rhs)
    @test all(lhs_solve .≈ rhs)


    expr = log(x)^2 + log(x) + 1
    lhs = sort_roots(eval.(Symbolics.toexpr.(ia_solve(expr, x))))
    lhs_solve = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    rhs = sort_roots([E^(-(complex(-1))^(1/3)), E^((complex(-1))^(2/3))])
    @test all(lhs .≈ rhs)
    @test all(lhs_solve .≈ rhs)

    expr = 2log(x^2 + 1)^2 + 3log(x^2 + 1) + 1
    lhs = sort_roots(eval.(Symbolics.toexpr.(ia_solve(expr, x))))
    lhs_solve = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    rhs = sort_roots([-im*ssqrt(1 - 1/E), im*ssqrt(1 - 1/E),
        -im*ssqrt(1 - 1/ssqrt(E)), im*ssqrt(1 - 1/ssqrt(E))])
    @test all(lhs .≈ rhs)
    @test all(lhs_solve .≈ rhs)


    # this has c1 subbed, ia_solve still needs to incl c1
    # much like sin and cos solutions (i.e. infinite solutions)
    expr = 9^(x^2 + 1) + 3^(x^2 + 1) + 2
    lhs = sort_roots(eval.(Symbolics.toexpr.(ia_solve(expr, x))))
    lhs_solve = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    rhs = sort_roots([-ssqrt(-1 + slog(1/2*(-1 - im*ssqrt(7)))/slog(3)),
        ssqrt(-1 + slog(1/2*(-1 - im*ssqrt(7)))/slog(3)),
        ssqrt(-1 + slog(1/2*(-1 + im*ssqrt(7)))/slog(3)),
        -ssqrt(-1 + slog(1/2*(-1 + im*ssqrt(7)))/slog(3))])

    @test all(lhs .≈ rhs)
    @test all(lhs_solve .≈ rhs)

    @testset "Keyword arguments" begin
        expr = sec(x ^ 2 + 4x + 4) ^ 3 - 3
        roots = ia_solve(expr, x)
        @test length(roots) == 6 # 2 quadratic roots * 3 roots from cbrt(3)
        @test length(Symbolics.get_variables(roots[1])) == 1
        _n = only(Symbolics.get_variables(roots[1]))
        vals = eval.(Symbolics.toexpr.(substitute.(roots, (Dict(_n => 0),))))
        @test all(x -> isapprox(value(abs(sec(x^2 + 4x + 4) ^ 3 - 3)), 0.0, atol = 1e-14), vals)

        roots = ia_solve(expr, x; complex_roots = false)
        @test length(roots) == 2
        # the `n` in `θ + n * 2π`
        @test length(Symbolics.get_variables(roots[1])) == 1
        _n = only(Symbolics.get_variables(roots[1]))
        vals = eval.(Symbolics.toexpr.(substitute.(roots, (Dict(_n => 0),))))
        @test all(x -> isapprox(norm(sec(x^2 + 4x + 4) ^ 3 - 3), 0.0, atol = 1e-14), vals)

        roots = ia_solve(expr, x; complex_roots = false, periodic_roots = false)
        @test length(roots) == 2
        @test length(Symbolics.get_variables(roots[1])) == 0
        @test length(Symbolics.get_variables(roots[2])) == 0
        vals = eval.(Symbolics.toexpr.(roots))
        @test all(x -> isapprox(norm(sec(x^2 + 4x + 4) ^ 3 - 3), 0.0, atol = 1e-14), vals)
    end
end

@testset "Sqrt case poly" begin
    # f(x) + sqrt(g(x)) + c
    expr = x + sqrt(x+1) - 5
    lhs_ia = ia_solve(expr, x)[1]
    lhs_att = Symbolics.attract_and_solve_sqrtpoly(expr, x)[1]
    lhs_solve = symbolic_solve(expr, x)[1]
    @test all(isequal(value(answer), 3) for answer in [lhs_ia, lhs_att, lhs_solve])

    expr = x^2 + x + sqrt(x) + 2
    lhs = sort_roots(eval.(Symbolics.toexpr.(ia_solve(expr, x))))
    lhs_solve = sort_roots(eval.(Symbolics.toexpr.(symbolic_solve(expr, x))))
    rhs = sort_roots([-0.860929555 - 1.604034315im, -0.860929555 + 1.604034315im])
    @test all(isapprox.(lhs, rhs, atol=1e-6))
    @test all(isapprox.(lhs_solve, rhs, atol=1e-6))
    @test all(isequal.(lhs, lhs_solve))
end

@testset "Turn to poly" begin
    @variables x
    # does not sub because these can not be solved as polys
    expr = log(x+1)^2 + log(x) + 1
    expr, sub = Symbolics.turn_to_poly(expr, x)
    @test isequal(sub, Dict())

    expr = 2log(x)^2 + sin(x) + 1
    expr, sub = Symbolics.turn_to_poly(expr, x)
    @test isequal(sub, Dict())

    
    # subs and turns to polys
    expr = log(x)^2 + log(x) + 1
    expr, sub = Symbolics.turn_to_poly(expr, x)
    @test Symbolics.check_polynomial(expr)

    expr = 2log(x^2 + 1)^2 + 3log(x^2 + 1) + 1
    expr, sub = Symbolics.turn_to_poly(expr, x)
    @test Symbolics.check_polynomial(expr)

    expr = sin(x^2)^2 + 3sin(x^2) + 1
    expr, sub = Symbolics.turn_to_poly(expr, x)
    @test Symbolics.check_polynomial(expr)

    expr = 9^(x^2 + 1) + 3^(x^2 + 1) + 2
    expr, sub = Symbolics.turn_to_poly(expr, x)
    @test Symbolics.check_polynomial(expr)
end


using LambertW


#Testing

@testset "Algebraic solver tests" begin
    function correctAns(solve_roots, known_roots)
        solve_roots = sort_roots(eval.(Symbolics.toexpr.(solve_roots)))
        known_roots = sort_roots(known_roots)
        r = isapprox.(solve_roots, known_roots, atol=1e-6)
        isequal(r, []) && return false
        return all(r)
    end

    #quadratics
    @test correctAns(symbolic_solve(x^2~4,x), [-2, 2])
    @test correctAns(symbolic_solve(x^2~2,x),[-sqrt(2.0),sqrt(2.0)])
    @test correctAns(symbolic_solve(x^2~32,x),[-sqrt(32.0),sqrt(32.0)])
    @test correctAns([symbolic_solve(x^3~32,x)[1]],[32.0^(1.0/3.0)])

    #lambert w, currently unsupported
    @test_broken correctAns(symbolic_solve(x^x~2, x, warns=false),[log(2.0)/LambertW.lambertw(log(2.0))])
    @test_broken correctAns(symbolic_solve(2*x*exp(x)~3, x, warns=false),[LambertW.lambertw(3.0/2.0)])

    #more challenging quadratics
    @test correctAns(symbolic_solve(x+sqrt(1+x)~5,x),[3.0])
    @test correctAns(symbolic_solve(2*x^2-6*x-7~0,x),[(3.0/2.0)-sqrt(23.0)/2.0,(3.0/2.0)+sqrt(23.0)/2.0])

    #functions inverses
    @test correctAns(symbolic_solve(exp(x^2)~7,x),[-sqrt(log(7.0)),sqrt(log(7.0))])

    root = symbolic_solve(sin(x+3)~1//3,x)[1]
    var = first(Symbolics.get_variables(root))
    root = Symbolics.ssubs(root, Dict(var=>0))
    @test correctAns([root],[asin(1.0/3.0)-3.0])

    @test_broken correctAns(symbolic_solve(sin(x+2//5)+cos(x+2//5)~1//2 , x, warns=false), [acos(0.5/sqrt(2.0))+pi/4.0-(2.0/5.0)])

    #product
    @test correctAns(symbolic_solve((x^2-4)*(x+1)~0,x),[-2.0,-1.0,2.0])
end

@testset "`NaN` handling in `$fn`" for fn in [ssqrt, slog, scbrt]
    x = fn(NaN)
    @test x isa Real && isnan(x)
    x = fn(NaN + NaN * im)
    @test x isa Complex && isnan(x)
end

module SymbolicsGroebnerExt

using Groebner
const Nemo = Groebner.Nemo
using Symbolics
using Symbolics: Num, symtype, BasicSymbolic
import Symbolics.PrecompileTools
import Symbolics.Bijections
import Symbolics: SymbolicUtils
import Symbolics: DP, MP

function Symbolics.groebner_basis(polynomials::Vector{Num}; ordering=InputOrdering(), kwargs...)
    polynoms, poly_to_bs = Symbolics.symbol_to_poly(polynomials)
    basis = groebner_basis_poly(polynoms, poly_to_bs; ordering, kwargs...)
    Symbolics.poly_to_symbol(basis, poly_to_bs)
end

function groebner_basis_poly(polynoms::Vector{<:DP.Polynomial}, poly_to_bs::Bijections.Bijection; ordering=InputOrdering(), kwargs...)
    bs_to_poly = Bijections.active_inv(poly_to_bs)
    ordering = Groebner.ordering_transform(ordering, bs_to_poly)
    return Groebner.groebner(polynoms; ordering=ordering, kwargs...)
end

"""
    is_groebner_basis(polynomials; kwargs...)

Checks whether the given `polynomials` forms a Groebner basis using Groebner.jl
as the backend.

## Optional Arguments

The Groebner.jl backend provides a number of useful keyword arguments, which are
also available for this function. See `?Groebner.isgroebner`.

## Example

```jldoctest
julia> using Symbolics, Groebner

julia> @variables x y;

julia> is_groebner_basis([x^2 - y^2, x*y^2 + x, y^3 + y])
```
"""
function Symbolics.is_groebner_basis(polynomials::Vector{<:Union{Num, BasicSymbolic}}; kwargs...)
    polynoms, _ = Symbolics.symbol_to_poly(polynomials)
    Groebner.isgroebner(polynoms; kwargs...)
end

### Solver ###

# Map each variable of the given poly.
# Can be used to transform Nemo polynomial to expression.
function nemo_crude_evaluate(poly::Nemo.MPolyRingElem, varmap)
    new_poly = 0
    for (i, term) in enumerate(Nemo.terms(poly))
        new_term = nemo_crude_evaluate(Nemo.coeff(poly, i), varmap)
        for var in Nemo.vars(term)
            exp = Nemo.degree(term, var)
            exp == 0 && continue
            new_var = varmap[var]
            new_term *= new_var^exp
        end
        new_poly += new_term
    end
    new_poly
end

function nemo_crude_evaluate(poly::Nemo.FracElem, varmap)
    num = nemo_crude_evaluate(numerator(poly), varmap)
    den = nemo_crude_evaluate(denominator(poly), varmap)
    if num isa Num || den isa Num
        num / den
    else
        num // den
    end
end

function nemo_crude_evaluate(poly::Nemo.ZZRingElem, varmap)
    BigInt(poly)
end

function gen_separating_var(vars)
    n = 1
    new_var = (Symbolics.@variables _T)[1]
    present = any(isequal(new_var, var) for var in vars)
    while present
        new_var = Symbolics.variables(repeat("_", n) * "_T")[1]
        present = any(isequal(new_var, var) for var in vars)
        n += 1
    end
    return new_var
end

# Given a GB in k[params][vars] produces a GB in k(params)[vars]
function demote(gb, gb_as_poly, bs_to_poly, vars::Vector{Num}, params::Vector{Num})
    length(gb) == 1 && SymbolicUtils._isone(gb[1]) && return gb
    isequal(gb, [1]) && return gb
    # gb = Symbolics.wrap.(SymbolicUtils.toterm.(gb))
    Symbolics.check_polynomial.(gb)

    all_vars = [vars..., params...]
    nemo_ring, nemo_all_vars = Nemo.polynomial_ring(Nemo.QQ, map(string, all_vars))

    sym_to_nemo = Dict(all_vars .=> nemo_all_vars)
    nemo_to_sym = Dict(v => k for (k, v) in sym_to_nemo)
    pvar_to_nemo = [bs_to_poly[v] for v in all_vars] => nemo_all_vars
    nemo_gb = [poly(pvar_to_nemo) for poly in gb_as_poly]

    nemo_vars = view(nemo_all_vars, 1:length(vars))
    nemo_params = view(nemo_all_vars, length(vars)+1:length(all_vars))

    ring_flat = parent(nemo_vars[1])
    ring_param, params_demoted = Nemo.polynomial_ring(Nemo.base_ring(ring_flat), map(string, nemo_params))
    ring_demoted, vars_demoted = Nemo.polynomial_ring(Nemo.fraction_field(ring_param), map(string, nemo_vars), internal_ordering=:lex)
    varmap = Dict(vcat(nemo_vars .=> vars_demoted, nemo_params .=> params_demoted))
    gb_demoted = map(f -> ring_demoted(nemo_crude_evaluate(f, varmap)), nemo_gb)
    result = empty(gb_demoted)
    while true
        gb_demoted = map(f -> Nemo.map_coefficients(c -> c // Nemo.leading_coefficient(f), f), gb_demoted)
        for i in 1:length(gb_demoted)
            f = gb_demoted[i]
            f_nf = Nemo.normal_form(f, result)
            if !iszero(f_nf)
                push!(result, f_nf)
            end
        end
        isequal(gb_demoted, result) && break
        gb_demoted = result
        result = empty(result)
    end
    @assert all(f -> isone(Nemo.leading_coefficient(f)), result)

    sym_to_nemo = Dict(all_vars .=> [vars_demoted; params_demoted])
    nemo_to_sym = Dict(v => k for (k, v) in sym_to_nemo)

    final_result = Num[]

    for i in eachindex(result)

        monoms = collect(Nemo.monomials(result[i]))
        coeffs = collect(Nemo.coefficients(result[i]))

        poly = 0
        for j in eachindex(monoms)
            poly += nemo_crude_evaluate(coeffs[j], nemo_to_sym) * nemo_crude_evaluate(monoms[j], nemo_to_sym)
        end
        push!(final_result, poly)
    end
        
    final_result
end

function solve_zerodim(eqs::Vector, vars::Vector{Num}; dropmultiplicity=true, warns=true)
    # Reference: Rouillier, F. Solving Zero-Dimensional Systems
    # Through the Rational Univariate Representation.
    # AAECC 9, 433–461 (1999). https://doi.org/10.1007/s002000050114
    
    rng = Groebner.Random.Xoshiro(42)
    all_indeterminates = collect(reduce(union!, map(Symbolics.get_variables, eqs)))
    params = map(Symbolics.Num, setdiff(all_indeterminates, vars))

    # Use a new variable to separate the input polynomials (Reference above)
    new_var = gen_separating_var(vars)
    old_len = length(vars)
    old_vars = deepcopy(vars)
    vars = vcat(vars, new_var)

    new_eqs = []
    generating = true
    n_iterations = 1
    separating_form = new_var
    eqs = Symbolics.wrap.(eqs)

    while generating
        new_eqs = copy(eqs)
        separating_form = new_var
        for i = 1:(old_len)
            separating_form += BigInt(rand(rng, -n_iterations:n_iterations))*vars[i]
        end

        if isequal(separating_form, new_var)
            continue
        end

        push!(new_eqs, separating_form)

        polynoms, poly_to_bs = Symbolics.symbol_to_poly(new_eqs)
        basis = groebner_basis_poly(polynoms, poly_to_bs; ordering = Lex(vcat(vars, params)))
        new_eqs = Symbolics.poly_to_symbol(basis, poly_to_bs)

        # handle "unsolvable" case
        if SymbolicUtils._iszero(new_eqs[1])
            return []
        end

        for i in reverse(eachindex(new_eqs))
            all_present = Symbolics.get_variables(new_eqs[i])
            if length(intersect(all_present, vars)) < 1
                deleteat!(new_eqs, i)
                deleteat!(basis, i)
            end
        end
        new_eqs = demote(new_eqs, basis, Bijections.active_inv(poly_to_bs), vars, params)
        new_eqs = map(Symbolics.unwrap, new_eqs)
        # condition for positive dimensionality, i.e. infinite solutions
        if length(new_eqs) < length(vars)
            warns && @warn("Infinite number of solutions")
            return nothing
        end

        # Exit in the Shape Lemma case:
        # g(T, params) = 0
        # x1 - f1(T, params) = 0
        # ...
        # xn - fn(T, params) = 0
        generating = !(length(new_eqs) == length(vars))
        if length(new_eqs) == length(vars)
            vars_in_1 = Symbolics.get_variables(new_eqs[1])
            setdiff!(vars_in_1, params)
            generating |= !(length(vars_in_1) == 1 && isequal(first(vars_in_1), new_var))
            for i in eachindex(new_eqs)[2:end]
                present_vars = setdiff(Symbolics.get_variables(new_eqs[i]), new_var)
                present_vars = setdiff(present_vars, params)
                isempty(present_vars) && (generating = false; break;)
                var_i = first(present_vars)
                condition1 = length(present_vars) == 1
                condition2 = Symbolics.degree(new_eqs[i], var_i) == 1
                generating |= !(condition1 && condition2)
            end
        end

        # non-cyclic case
        if n_iterations > 10 
            warns && @warn("symbolic_solve can not currently solve this system of polynomials.")
            return nothing
        end

        n_iterations += 1
    end

    solutions = []

    # first, solve the first minimal polynomial
    @assert length(new_eqs) == length(vars)
    vars_in_1 = Symbolics.get_variables(new_eqs[1])
    setdiff!(vars_in_1, params)
    @assert length(vars_in_1) == 1 && isequal(first(vars_in_1), new_var)
    minpoly_sols = Symbolics.symbolic_solve(Symbolics.wrap(new_eqs[1]), new_var, dropmultiplicity=dropmultiplicity)
    solutions = [Dict{Num, Any}(new_var => sol) for sol in minpoly_sols]

    new_eqs = new_eqs[2:end]

    # second, iterate over eqs and sub each found solution
    # then add the roots of the remaining unknown variables 
    for (i, eq) in enumerate(new_eqs)
        present_vars = setdiff!(Symbolics.get_variables(eq), params)
        present_vars = setdiff!(present_vars, new_var)
        @assert length(present_vars) == 1
        var_tosolve = first(present_vars)
        @assert Symbolics.degree(eq, var_tosolve) == 1
        @assert !isempty(solutions)
        for roots in solutions
            subbded_eq = Symbolics.substitute(eq, Dict([new_var => roots[new_var]]); fold=Val(false))
            subbded_eq = Symbolics.substitute(subbded_eq, Dict([var_tosolve => 0]); fold=Val(false))
            new_var_sols = [-subbded_eq]
            @assert length(new_var_sols) == 1
            root = new_var_sols[1]
            roots[var_tosolve] = root
        end
    end

    vars = vars[1:end-1]
    for roots in solutions
        delete!(roots, new_var)
    end

    return solutions
end

function transendence_basis(sys, vars)
    J = Symbolics.jacobian(sys, vars)
    x0 = Dict(v => rand(-10:10) for v in vars)
    J_x0 = map(Symbolics.value, substitute(J, x0))
    rk, rref = Nemo.rref(Nemo.matrix(Nemo.QQ, J_x0))
    pivots = Int[]
    for i in 1:length(sys)
        col = findfirst(!iszero, rref[i, :])
        !isnothing(col) && push!(pivots, col)
    end
    vars[setdiff(collect(1:length(vars)), pivots)]
end

function Symbolics.solve_multivar(eqs::Vector, vars::Vector{Num}; dropmultiplicity=true, warns=true)
    sol = solve_zerodim(eqs, vars; dropmultiplicity=dropmultiplicity, warns=warns)
    !isnothing(sol) && return sol
    tr_basis = transendence_basis(eqs, vars)
    isempty(tr_basis) && return nothing
    vars_gen = setdiff(vars, tr_basis)
    sol = solve_zerodim(eqs, vars_gen; dropmultiplicity=dropmultiplicity, warns=warns)
    sol === nothing && return nothing
    for roots in sol
        for x in tr_basis
            roots[x] = x
        end
    end

    sol
end

end # module

# import Symbolics: symbolic_solve

"""
Returns evolution matrix e^(tD)
"""
evo_mat(D::Matrix{<:Number}, t::Num) = diagm(exp.(t .* diag(D)))

"""
    solve_linear_ode_system(A::Matrix{<:Number}, x0::Vector{<:Number}, t::Num)
Solve linear continuous dynamical system of differential equations of the form Ax = x' with initial condition x0

# Arguments
- `A`: matrix of coefficients
- `x0`: initial conditions vector
- `t`: independent variable

# Returns
vector of symbolic solutions

# Examples
!!! note uses method `symbolic_solve`, so packages `Nemo` and `Groebner` are often required
```jldoctest
julia> using Symbolics

julia> import Nemo, Groebner

julia> @variables t
1-element Vector{Num}:
 t

julia> solve_linear_ode_system([1 0; 0 -1], [1, -1], t)
2-element Vector{Num}:
   exp(t)
 -exp(-t)

julia> solve_linear_ode_system([-3 4; -2 3], [7, 2], t)
2-element Vector{Num}:
 -(3//1)*exp(t) + (10//1)*exp(-t)
  -(3//1)*exp(t) + (5//1)*exp(-t)
```
"""
function solve_linear_ode_system(A::Matrix{<:Number}, x0::Vector{<:Number}, t::Num)
    # Check A is square
    if size(A, 1) != size(A, 2)
        throw(ArgumentError("Matrix A must be square."))
    end

    # Check x0 matches size of A
    if size(A, 1) != length(x0)
        throw(ArgumentError("Initial condition vector x0 must match the size of matrix A."))
    end

    if isdiag(A)
        # If A is diagonal, use uncoupled system solver
        return solve_uncoupled_system(A, x0, t)
    end

    S, D = diagonalize(A)

    return simplify.(S * evo_mat(D, t) * rationalize.(S^-1) * x0)
end

"""
Solve a system of uncoupled ODEs of the form:

    dx/dt = A*x
    
where A is a diagonal matrix.
"""
function solve_uncoupled_system(A::Matrix{<:Number}, x0::Vector{<:Number}, t::Num)
    # Check A is diagonal
    if !isdiag(A)
        throw(ArgumentError("Matrix A must be diagonal."))
    end

    return evo_mat(A, t) * x0
end

"""
Diagonalize matrix A, returning matrix S with eigenvectors as columns and diagonal matrix D with eigenvalues
"""
function diagonalize(A::Matrix{<:Number})::Tuple{Matrix{<:Number},Matrix{<:Number}}
    eigs::Eigen = symbolic_eigen(A)
    S = eigs.vectors
    D = diagm(eigs.values)
    return S, D
end


"""
Replacement for `LinearAlgebra.eigen` function that uses symbolic functions to avoid floating-point inaccuracies
"""
function symbolic_eigen(A::Matrix{<:Number})
    λ = variable(:ℰ) # eigenvalue
    v = variables(:𝓋, 1:size(A, 1)) # vector of subscripted variables to represent eigenvector
    
    # find eigenvalues first
    p = det(λ*I - A) ~ 0 # polynomial to solve
    values = symbolic_solve(p, λ) # solve polynomial
    values = map(unwrap_const, values)
    # then, find eigenvectors
    S::Matrix{Number} = Matrix(I, size(A, 1), 0) # matrix storing vertical eigenvectors
    for value in values
        eqs = (value*I - A) * v# .~ zeros(size(A, 1)) # equations to give eigenvectors
        eqs = substitute(eqs, Dict(v[1] => 1)) # set first element to 1 to constrain solution space

        sol = symbolic_solve(eqs[1:end-1], v[2:end]) # solve all but one equation (because of constraining solutions above)

        # parse multivar solutions into Vector (in order)
        if sol[1] isa Dict
            sol = [sol[1][var] for var in v[2:end]]
        end
        sol = map(unwrap_const, sol)
        vec::Vector{Number} = prepend!(sol, [1]) # add back the 1 (representing v_1) from substitution
        S = [S vec] # add vec to matrix
    end

    return Eigen(values, S)
end

using Symbolics
using SymbolicUtils
using Test
using LinearAlgebra, SparseArrays
using Symbolics: value, unwrap

# Derivatives
@variables t σ ρ β
@variables x y z
@variables uu(t) uuˍt(t) v(t)[1:3]
D = Differential(t)
D2 = Differential(t)^2
Dx = Differential(x)

@test Symbol(D(D(uu))) === Symbol("uuˍtt(t)")
@test Symbol(D(uuˍt)) === Symbol(D(D(uu)))
@test Symbol(D(v[2])) === Symbol("(vˍt(t))[2]")

test_equal(a, b) = @test isequal(unwrap_const(simplify(unwrap(a))), unwrap_const(simplify(unwrap(b))))

@testset "ZeroOperator handling" begin
    @test_throws ErrorException Differential(0.1)(x)
    @test_throws ErrorException Differential(1)(x)
    @test_throws ErrorException Differential(2)(2x)
end

#@test @macroexpand(@derivatives D'~t D2''~t) == @macroexpand(@derivatives (D'~t), (D2''~t))

@test isequal(unwrap_const(expand_derivatives(D(t))), 1)
@test isequal(unwrap_const(expand_derivatives(D(D(t)))), 0)

dsin = D(sin(t))
@test isequal(expand_derivatives(dsin), cos(t))

dcsch = D(csch(t))
@test isequal(expand_derivatives(dcsch), simplify(-coth(t) * csch(t)))

@test isequal(unwrap_const(unwrap(expand_derivatives(D(-7)))), 0)
@test isequal(expand_derivatives(D(sin(2t))), simplify(cos(2t) * 2))
@test isequal(expand_derivatives(D2(sin(t))), simplify(-sin(t)))
@test isequal(expand_derivatives(D2(sin(2t))), simplify(-sin(2t) * 4))
@test isequal(unwrap_const(unwrap(expand_derivatives(D2(t)))), 0)
@test isequal(unwrap_const(unwrap(expand_derivatives(D2(5)))), 0)

# Chain rule
dsinsin = D(sin(sin(t)))
test_equal(expand_derivatives(dsinsin), cos(sin(t))*cos(t))

d1 = D(sin(t)*t)
d2 = D(sin(t)*cos(t))
@test isequal(expand_derivatives(d1), simplify(t*cos(t)+sin(t)))
@test isequal(expand_derivatives(d2), cos(t)^2-sin(t)^2)

eqs = [σ*(y-x),
       x*(ρ-z)-y,
       x*y - β*z]
jac = Symbolics.jacobian(eqs, [x, y, z])
test_equal(jac[1,1], -1σ)
test_equal(jac[1,2], σ)
test_equal(jac[1,3], 0)
test_equal(jac[2,1],  ρ - z)
test_equal(jac[2,2], -1)
test_equal(jac[2,3], -1x)
test_equal(jac[3,1], y)
test_equal(jac[3,2], x)
test_equal(jac[3,3], -1β)

# issue #545
z = t + t^2
test_equal(expand_derivatives(D(z)), 1 + t * 2)

z = t-2t
test_equal(expand_derivatives(D(z)), -1)

# Variable dependence checking in differentiation
@variables a(t) b(a)
@test !isequal(D(b), 0)
test_equal(expand_derivatives(D(t)), 1)
test_equal(expand_derivatives(Dx(x)), 1)

@variables x(t) y(t) z(t)

@test isequal(expand_derivatives(D(x * y)), simplify(y*D(x) + x*D(y)))
@test isequal(expand_derivatives(D(x * y)), simplify(D(x)*y + x*D(y)))

test_equal(expand_derivatives(D(2t)), 2)
@test isequal(expand_derivatives(D(2x)), 2D(x))
@test isequal(expand_derivatives(D(x^2)), simplify(2 * x * D(x)))

# n-ary * and +
# isequal(Symbolics.derivative(Term(*, [x, y, z*ρ]), 1), y*(z*ρ))
# isequal(Symbolics.derivative(Term(+, [x*y, y, z]), 1), 1)

@test iszero(expand_derivatives(D(42)))
@test all(iszero, Symbolics.gradient(42, [t, x, y, z]))
@test all(iszero, Symbolics.hessian(42, [t, x, y, z]))
foreach(test_equal, Symbolics.jacobian([t, x, 42], [t, x]),
              Num[1  0
                  Differential(t)(x)           1
                  0  0])

# issue 252
@variables beta, alpha, delta
@variables x1, x2, x3

# expression
tmp = beta * (alpha * exp(x1) * x2 ^ (alpha - 1) + 1 - delta) / x3
# derivative w.r.t. x1 and x2
t1 = Symbolics.gradient(tmp, [x1, x2])
@test_nowarn Symbolics.gradient(t1[1], [beta])

@variables t k
@variables x(t)
D = Differential(k)
@test Symbolics.tosymbol(value(D(x))) === Symbol("xˍk(t)")

@variables t x(t)
∂ₜ = Differential(t)
∂ₓ = Differential(x)
L = .5 * ∂ₜ(x)^2 - .5 * x^2
@test isequal(expand_derivatives(∂ₓ(L)), -1 * x)
@test isequal(expand_derivatives(Differential(x)(L) - ∂ₜ(Differential(∂ₜ(x))(L))), -1 * (∂ₜ(∂ₜ(x)) + x))
@test isequal(expand_derivatives(Differential(x)(L) - ∂ₜ(Differential(∂ₜ(x))(L))), (-1 * x) - ∂ₜ(∂ₜ(x)))

@variables x2(t)
@test isequal(expand_derivatives(Differential(x)(2 * x + x2 * x)), 2 + x2)

@variables x y
@variables u(..)
Dy = Differential(y)
Dx = Differential(x)
dxyu = Dx(Dy(u(x,y)))
@test isequal(expand_derivatives(dxyu), dxyu)
dxxu = Dx(Dx(u(x,y)))
@test isequal(expand_derivatives(dxxu), dxxu)

canonequal(a, b) = isequal(simplify(unwrap_const(unwrap(a))), simplify(unwrap_const(unwrap(b))))

# Calculus
@variables t σ ρ β
@variables x y z
@test isequal(
    (Differential(z) * Differential(y) * Differential(x))(t),
    Differential(z)(Differential(y)(Differential(x)(t)))
)
@test isequal((Differential(x) * identity)(t), Differential(x)(t))
@test_throws MethodError Differential(x) * 2

@test canonequal(
                 Symbolics.derivative(sin(cos(x)), x),
                 -sin(x) * cos(cos(x))
                )

Symbolics.@register_symbolic no_der(x)
@test canonequal(
                 Symbolics.derivative([sin(cos(x)), hypot(x, no_der(x))], x),
                 [
                  -sin(x) * cos(cos(x)),
                  x/hypot(x, no_der(x)) +
                      no_der(x)*Differential(x)(no_der(x))/hypot(x, no_der(x))
                 ]
                )

Symbolics.@register_symbolic intfun(x)::Int
@test Symbolics.symtype(intfun(x).val) === Int

eqs = [σ*(y-x),
       x*(ρ-z)-y,
       x*y - β*z]

∂ = Symbolics.jacobian(eqs,[x,y,z])
for i in 1:3
    ∇ = Symbolics.gradient(eqs[i],[x,y,z])
    @test canonequal(∂[i,:],∇)
end

@test all(canonequal.(Symbolics.gradient(eqs[1],[x,y,z]),[σ * -1,σ,0]))
@test all(canonequal.(Symbolics.hessian(eqs[1],[x,y,z]),0))

du = [x^2, y^3, x^4, sin(y), x+y, x+z^2, z+x, x+y^2+sin(z)]
reference_jac = sparse(Symbolics.jacobian(du, [x,y,z]))

@test findnz(Symbolics.jacobian_sparsity(du, [x,y,z]))[[1,2]] == findnz(reference_jac)[[1,2]]

let
    @variables t x(t) y(t) z(t)
    @test Symbolics.exprs_occur_in([x,y,z], x^2*y) == [true, true, false]
end

@test isequal(Symbolics.sparsejacobian(du, [x,y,z]), reference_jac)


function f!(res,u)
    (x,y,z)=u
    res.=[x^2, y^3, x^4, sin(y), x+y, x+z^2, z+x, x+y^2+sin(z)]
end
function f1!(res,u,a,b;c)
    (x,y,z)=u
    res.=[a*x^2, y^3, b*x^4, sin(y), c*x+y, x+z^2, a*z+x, x+y^2+sin(z)]
end

input=rand(3)
output=rand(8)

@test findnz(Symbolics.jacobian_sparsity(f!, output, input))[[1,2]] == findnz(reference_jac)[[1,2]]
@test findnz(Symbolics.jacobian_sparsity(f1!, output, input,1,2,c=3))[[1,2]] == findnz(reference_jac)[[1,2]]

input = rand(2,2)
function f2!(res,u,a,b,c)
    (x,y,z)=u[1,1],u[2,1],u[3,1]
    res.=[a*x^2, y^3, b*x^4, sin(y), c*x+y, x+z^2, a*z+x, x+y^2+sin(z)]
end

@test findnz(Symbolics.jacobian_sparsity(f!, output, input))[[1,2]] == findnz(reference_jac)[[1,2]]

# Check for failures due to du[4] undefined
function f_undef(du,u)
    du[1] = u[1]
    du[2] = u[2]
    du[3] = u[3] + u[4]
end
u0 = rand(4)
du0 = similar(u0)
sparsity_pattern = Symbolics.jacobian_sparsity(f_undef,du0,u0)
udef_ref = sparse([1 0 0 0
                    0 1 0 0
                    0 0 1 1
                    0 0 0 0])
@test findnz(sparsity_pattern)[[1,2]] == findnz(udef_ref)[[1,2]]

rosenbrock(X) = sum(1:length(X)-1) do i
    100 * (X[i+1] - X[i]^2)^2 + (1 - X[i])^2
end
rosenbrock2(X,a;b) = sum(1:length(X)-1) do i
    a * (X[i+1] - X[i]^2)^2 + (b - X[i])^2
end

@variables a,b
X = [a,b]
input = rand(2)

spoly(x) = simplify(x, expand=true)
rr = rosenbrock(X)

reference_hes = Symbolics.hessian(rr, X)
@test findnz(sparse(reference_hes))[1:2] == findnz(Symbolics.hessian_sparsity(rr, X))[1:2]
@test findnz(sparse(reference_hes))[1:2] == findnz(Symbolics.hessian_sparsity(rosenbrock, input))[1:2]
@test findnz(sparse(reference_hes))[1:2] == findnz(Symbolics.hessian_sparsity(rosenbrock2, input,100,b=1))[1:2]

sp_hess = Symbolics.sparsehessian(rr, X)
@test findnz(sparse(reference_hes))[1:2] == findnz(sp_hess)[1:2]
@test isequal(map(spoly, findnz(sparse(reference_hes))[3]), map(spoly, findnz(sp_hess)[3]))

#96
@variables t x(t)[1:4] ẋ(t)[1:4]
expression = sin(x[1] + x[2] + x[3] + x[4]) |> Differential(t) |> expand_derivatives
expression2 = substitute(expression, Dict(collect(Differential(t).(x) .=> ẋ)))
@test isequal(expression2, (ẋ[1] + ẋ[2] + ẋ[3] + ẋ[4])*cos(x[1] + x[2] + x[3] + x[4]))

@test isequal(
    Symbolics.derivative(ifelse(signbit(b), b^2, sqrt(b)), b),
    ifelse(signbit(b), 2b,(^(2Symbolics.unwrap(sqrt(b)), -1)))
)

# Chain rule
#
let
    @variables t x(..) y(..) z(..)
    Dt = Differential(t)

    @test isequal(expand_derivatives(Dt(x(y(t)))),
                  Dt(y(t))*Differential(y(t))(x(y(t))))

    @test isequal(expand_derivatives(Dt(x(y(t), z(t)))),
                  Dt(y(t))*Differential(y(t))(x(y(t), z(t))) + Dt(z(t))*Differential(z(t))(x(y(t), z(t))))
end

@variables x y
@register_symbolic foo(x, y, z::Array)
D = Differential(x)
@test_throws ErrorException expand_derivatives(D(foo(x, y, [1.2]) * x^2))

@variables t x(t) y(t)
D = Differential(t)

eqs = [D(x) ~ x, D(y) ~ y + x]

sub_eqs = substitute(eqs, Dict([D(x)=>D(x), x=>1]))
@test sub_eqs == [D(x) ~ 1, D(y) ~ 1 + y]

@variables x y
@test unwrap_const.(unwrap.(substitute([x + y; x - y], Dict(x=>1, y=>2)))) == [3, -1]


# 530#discussion_r825125589
let
    @variables u[1:2] y[1:1] t
    u = collect(u)
    y = collect(y)
    @test isequal(Symbolics.jacobian([u;u[1]^2; y], u), Num[1 0
                                                            0 1
                                                            2u[1] 0
                                                            0 0])
end

# make sure derivative(x[1](t), y) does not fail
let
    @variables t a(t)
    vars = collect(@variables(x(t)[1:1])[1])
    ps = collect(@variables(ps[1:1])[1])
    @test unwrap_const(unwrap(Symbolics.derivative(ps[1], vars[1]))) == 0
    @test unwrap_const(unwrap(Symbolics.derivative(ps[1], a))) == 0
    @test unwrap_const(unwrap(Symbolics.derivative(x[1], a))) == 0
end

# 580
let
    @variables x[1:3]
    y = [sin.(x); cos.(x)]
    dj = Symbolics.jacobian(y, x)
    @test !iszero(dj)
    @test isequal(dj, Symbolics.jacobian(Symbolics.scalarize.(y), x))
    sj = Symbolics.sparsejacobian(y, x)
    @test !iszero(sj)
    @test isequal(sj, Symbolics.jacobian(Symbolics.scalarize.(y), x))
end

# substituting iv of differentials
@variables t t2 x(t)
D = Differential(t)
ex = D(x)
ex2 = substitute(ex, [t=>t2]; filterer = Returns(true))
@test isequal(operation(Symbolics.unwrap(ex2)).x, t2)
ex3 = substitute(D(x) * 2 + x / t, [t=>t2]; filterer = Returns(true))
xt2 = substitute(x, [t => t2]; filterer = Returns(true))
@test isequal(ex3, xt2 / t2 + 2Differential(t2)(xt2))

# 581
#
let
    @variables x(t)[1:3]
    @test iszero(Symbolics.derivative(x[1], x[2]))
end

#908
#
let
    @variables t
    @test isequal(unwrap_const(unwrap(expand_derivatives(Differential(t)(im*t)))), im)
    @test isequal(expand_derivatives(Differential(t)(t^2 + im*t)), 2t + im)
end

# 1262
#
let
    @variables t  b(t)
	D = Differential(t)
	expr = b - ((D(b))^2) * D(D(b))
	expr2 = D(expr)
	@test isequal(expand_derivatives(expr), expr)
    @test isequal(expand_derivatives(expr2), D(b) - (D(b)^2)*D(D(D(b))) - 2D(b)*(D(D(b))^2))
end

# 1126
#
let
    @syms y f(y) g(y) h(y)
    D = Differential(y)

    expr_gen = (fun) -> D(D(((-D(D(fun))) / g(y))))

    expr = expr_gen(g(y))
    # just make sure that no errors are thrown in the following, the results are to complicated to compare
    expand_derivatives(expr)
    expr = expr_gen(h(y))
    expand_derivatives(expr)

    expr = expr_gen(f(y))
    expand_derivatives(expr)
end

# Check `is_derivative` function
let
    @variables t X(t) Y(t)
    @syms a b
    D = Differential(t)
    my_f(x, y) = x^3 + 2y

    # Single expressions.
    @test !Symbolics.is_derivative(Symbolics.unwrap(D))
    @test !Symbolics.is_derivative(Symbolics.unwrap(t))
    @test !Symbolics.is_derivative(Symbolics.unwrap(X))
    @test !Symbolics.is_derivative(Symbolics.unwrap(a))
    @test !Symbolics.is_derivative(Symbolics.unwrap(1))

    # Composite expressions.
    @test Symbolics.is_derivative(Symbolics.unwrap(D(X)))
    @test !Symbolics.is_derivative(Symbolics.unwrap(D(X) + 3))
    @test Symbolics.is_derivative(Symbolics.unwrap(D(X + 2a*Y)))
    @test !Symbolics.is_derivative(Symbolics.unwrap(D(X) + D(Y)))
    @test !Symbolics.is_derivative(Symbolics.unwrap(my_f(X, D(Y))))

    # Wrapper types give the same answer as the expression they wrap (#1942).
    @test !Symbolics.is_derivative(D)
    @test !Symbolics.is_derivative(t)
    @test !Symbolics.is_derivative(X)
    @test !Symbolics.is_derivative(1)
    @test Symbolics.is_derivative(D(X))
    @test !Symbolics.is_derivative(D(X) + 3)
    @test Symbolics.is_derivative(D(X + 2a * Y))
    @test !Symbolics.is_derivative(D(X) + D(Y))
    @test !Symbolics.is_derivative(my_f(X, D(Y)))
    @test !Symbolics.is_derivative(expand_derivatives(D(X^2)))

    @variables Z(t)[1:3]
    @test Symbolics.is_derivative(D(Z))
    @test !Symbolics.is_derivative(Z)

    # `Differential` distributes over the parts of a `Complex{Num}`, so the result is a
    # `complex` term rather than a single derivative term.
    @variables W(t)::Complex
    @test !Symbolics.is_derivative(D(W))
    @test !Symbolics.is_derivative(Symbolics.unwrap(D(W)))
end

# Zeroth derivative (#1163)
let
    @variables t
    Dt = Differential(t)^0
    @test isequal(Dt, identity)
    test_equal(Dt(t + 2t^2), t + 2t^2)
end

# Check `Function` inputs for derivative (#1085)
let
    @variables x
    @testset for f in [sqrt, sin, acos, exp, cis]
        @test isequal(
            Symbolics.derivative(f, x),
            Symbolics.derivative(f(x), x)
        )
    end
end

# Check `Function` inputs throw for non-Num second input (#1085)
let
    @testset for f in [sqrt, sin, acos, exp, cis]
        @test_throws TypeError Symbolics.derivative(f, rand())
        @test_throws TypeError Symbolics.derivative(f, Val(rand(Int)))
    end
end

# Derivative of a `BasicSymbolic` (#1085)
let
    x = Symbolics.Sym{SymReal}(:x; type = Int)
    @testset for f in [sqrt, sin, acos, exp]
        @test isequal(
            Symbolics.derivative(f, x),
            Symbolics.derivative(
                f,
                x
            )
        )
    end
end

# Check ssqrt, scbrt, slog
let
    @variables x
    D = Differential(x)
    @test isequal(expand_derivatives(D(Symbolics.ssqrt(1 + x ^ 2))), simplify((2x) / (2Symbolics.ssqrt(1 + x^2))))
    @test isequal(expand_derivatives(D(Symbolics.scbrt(1 + x ^ 2))), simplify((2x) / (3Symbolics.scbrt(1 + x^2)^2)))
    @test isequal(expand_derivatives(D(Symbolics.slog(1 + x ^ 2))), simplify((2x) / (1 + x ^ 2)))
end

# Hessian sparsity involving unknown functions
let
    @variables x₁ x₂ p q[1:1]
    expr = 3x₁^2 + 4x₁ * x₂
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]

    expr = 3x₁^2 + 4x₁ * x₂ + p
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]

    # issue 643: example test2_num
    expr = 3x₁^2 + 4x₁ * x₂ + q[1]
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]

    # Custom function: By default assumed to be non-linear
    myexp(x) = exp(x)
    @register_symbolic myexp(x)
    expr = 3x₁^2 + 4x₁ * x₂ + myexp(p)
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]
    expr = 3x₁^2 + 4x₁ * x₂ + myexp(x₂)
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true true]

    mylogaddexp(x, y) = log(exp(x) + exp(y))
    @register_symbolic mylogaddexp(x, y)
    expr = 3x₁^2 + 4x₁ * x₂ + mylogaddexp(p, 2)
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]
    expr = 3x₁^2 + 4x₁ * x₂ + mylogaddexp(3, p)
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]
    expr = 3x₁^2 + 4x₁ * x₂ + mylogaddexp(p, 2)
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]
    expr = 3x₁^2 + 4x₁ * x₂ + mylogaddexp(p, q[1])
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]
    expr = 3x₁^2 + 4x₁ * x₂ + mylogaddexp(p, x₂)
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true true]
    expr = 3x₁^2 + 4x₁ * x₂ + mylogaddexp(x₂, 4)
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true true]

    # Custom linear function: Possible to extend `Symbolics.linearity_1`/`Symbolics.linearity_2`
    myidentity(x) = x
    @register_symbolic myidentity(x)
    Symbolics.linearity_1(::typeof(myidentity)) = true
    expr = 3x₁^2 + 4x₁ * x₂ + myidentity(p)
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]
    expr = 3x₁^2 + 4x₁ * x₂ + myidentity(q[1])
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]
    expr = 3x₁^2 + 4x₁ * x₂ + myidentity(x₂)
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]

    mymul1plog(x, y) = x * (1 + log(y))
    @register_symbolic mymul1plog(x, y)
    Symbolics.linearity_2(::typeof(mymul1plog)) = (true, false, false)
    expr = 3x₁^2 + 4x₁ * x₂ + mymul1plog(p, q[1])
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]
    expr = 3x₁^2 + 4x₁ * x₂ + mymul1plog(x₂, q[1])
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true false]
    expr = 3x₁^2 + 4x₁ * x₂ + mymul1plog(q[1], x₂)
    @test Matrix(Symbolics.hessian_sparsity(expr, [x₁, x₂])) == [true true; true true]
end

# issue #555
let
    # first example
    @variables p[1:1] x[1:1]
    p = collect(p)
    x = collect(x)
    test_equal.(collect(Symbolics.sparsehessian(p[1] * x[1], x)), [0;;])
    @test isequal(collect(Symbolics.sparsehessian(p[1] * x[1]^2, x)), [2p[1];;])

    # second example
    @variables a[1:2]
    a = collect(a)
    ex = (a[1]+a[2])^2
    test_equal.(Symbolics.hessian(ex, [a[1]]), [2;;])
    test_equal.(collect(Symbolics.sparsehessian(ex, [a[1]])), [2;;])
    test_equal.(collect(Symbolics.sparsehessian(ex, a)), fill(2, 2, 2))
end

# issue #847
let
    @variables x[1:2] y[1:2]
    x = Symbolics.scalarize(x)
    y = Symbolics.scalarize(y)

    z = (x[1] + x[2]) * (y[1] + y[2])
    @test Symbolics.islinear(z, x)
    @test Symbolics.isaffine(z, x)

    z = (x[1] + x[2])
    @test Symbolics.islinear(z, x)
    @test Symbolics.isaffine(z, x)
end

# issue #790
let
    c(x) = [sum(x) - 1]
    @variables xs[1:2] ys[1:1]
    w = Symbolics.scalarize(xs)
    v = Symbolics.scalarize(ys)
    expr = dot(v, c(w))
    @test !Symbolics.islinear(expr, w)
    @test Symbolics.isaffine(expr, w)
    @test collect(Symbolics.hessian_sparsity(expr, w)) == fill(false, 2, 2)
end

# issue #749
let
    @variables x y
    @register_symbolic Base.FastMath.exp_fast(x, y)
    expr = Base.FastMath.exp_fast(x, y)
    @test !Symbolics.islinear(expr, [x, y])
    @test !Symbolics.isaffine(expr, [x, y])
    @test collect(Symbolics.hessian_sparsity(expr, [x, y])) == fill(true, 2, 2)
end

let
    @variables x
    expr = ifelse(x <= 0, -x, x)
    @test Symbolics.hessian_sparsity(expr, [x]) == [false;;]
    @test iszero(Symbolics.simplify(only(Symbolics.hessian(expr, [x]))))

    expr = ifelse(x <= 0, -x^2, x^2)
    @test Symbolics.hessian_sparsity(expr, [x]) == [true;;]
    @test !iszero(Symbolics.simplify(only(Symbolics.hessian(expr, [x]))))

    expr = ifelse(x <= 0, -x^2, x)
    @test Symbolics.hessian_sparsity(expr, [x]) == [true;;]
    @test !iszero(Symbolics.simplify(only(Symbolics.hessian(expr, [x]))))
end

@testset "`throw_no_derivative`" begin
    @variables t x(t) y::Bool z(..)
    D = Differential(t)
    @register_symbolic f(x)

    for expr in [D(f(x)), D(f(x)) + x^2, ifelse(y, D(f(x)), x^2), D(z(f(x))), z(D(f(x)))]
        @test_throws Symbolics.DerivativeNotDefinedError expand_derivatives(expr; throw_no_derivative = true)
        @test_throws Symbolics.DerivativeNotDefinedError Symbolics.derivative(expr, t; throw_no_derivative = true)
    end

    arr = [f(x) + t, x * t]
    vars = [x, t]
    @test_throws Symbolics.DerivativeNotDefinedError Symbolics.derivative(arr, t; throw_no_derivative = true)
    @test_throws Symbolics.DerivativeNotDefinedError Symbolics.gradient(arr[1], vars; throw_no_derivative = true)
    @test_throws Symbolics.DerivativeNotDefinedError Symbolics.jacobian(arr, vars; throw_no_derivative = true)
    @test_throws Symbolics.DerivativeNotDefinedError Symbolics.sparsejacobian(arr, vars; throw_no_derivative = true)
    @test_throws Symbolics.DerivativeNotDefinedError Symbolics.hessian(arr[1], vars; throw_no_derivative = true)
    @test_throws Symbolics.DerivativeNotDefinedError Symbolics.sparsehessian(arr[1], vars; throw_no_derivative = true)

    @variables x(t)[1:2]
    @test isequal(expand_derivatives(D(x[1]); throw_no_derivative = true), D(x[1]))
end

# issue #1452
let
    @variables x y z
    f(x, y, z) = x * y^2 + z
    @test Symbolics.hessian_sparsity(f(x, y, z), [x, y, z]) == [false true false; true true false; false false false]
    g(x, y, z) = x * y^2 + z
    @register_symbolic g(x, y, z)
    @test Symbolics.hessian_sparsity(g(x, y, z), [x, y, z]) == fill(true, 3, 3)
end

# Chain rule for array variables (issue #1383)
let
    @variables t x(t) y1(x) y(x)[1:1] Y(x)[1:1,1:1]
    Dt, Dx = Differential.([t, x])
    @test isequal(expand_derivatives(Dt(y1)), Dt(x) * Dx(y1)) # scalar
    @test isequal(expand_derivatives(Dt(y[1])), Dt(x) * Dx(y[1])) # same for vector var
    @test isequal(expand_derivatives(Dt(Y[1,1])), Dt(x) * Dx(Y[1,1])) # same for matrix arr
end

@testset "Derivatives of Array Variables" begin
    @variables p[1:9]
    vp = collect(p)

    f = - 1.5log(5 + p[3]) - 1.5log(7 + p[1]) - 1.5log(8 - p[2]) - 1.5log(9 - p[4]) + 0.08p[4]*p[9] -1.5log(5 + p[3]) - 1.5log(7 + p[1]) - 1.5log(8 - p[2]) - 1.5log(9 - p[4]) + 0.08p[4]*p[9]

    test_equal.(Symbolics.unwrap.(Symbolics.gradient(f, vp) .- Symbolics.gradient(f, p)), 0)
    test_equal.(Symbolics.unwrap.(Symbolics.hessian(f, vp) .- Symbolics.hessian(f, p)), 0)
    test_equal.(Symbolics.unwrap.(Symbolics.jacobian([f], vp) .- Symbolics.jacobian([f], p)), 0)
end

@register_array_symbolic foobar(x, y) begin
    size = (2,)
    eltype = Real
    ndims = 1
end
@register_array_symbolic dfoobar1(x, y) begin
    size = (2,)
    eltype = Real
    ndims = 1
end
@register_array_symbolic dfoobar2(x, y) begin
    size = (2,)
    eltype = Real
    ndims = 1
end
@register_derivative foobar(x, y) 1 dfoobar1(x, y)
@register_derivative foobar(x, y) 2 dfoobar2(x, y)

@testset "Derivatives of indexed array expressions" begin
    @variables x y
    ex = foobar(x + 2y, y)
    @test ex isa Symbolics.Arr
    @test size(ex) == (2,)

    der = Symbolics.derivative(ex[1], x)
    @test isequal(der, dfoobar1(x + 2y, y)[1])
    
    der = Symbolics.derivative(ex[1], y)
    @test isequal(der, dfoobar1(x + 2y, y)[1] * 2 + dfoobar2(x + 2y, y)[1])
end

@testset "Derivative of x'x" begin
    @variables x[1:3] y[1:3]
    @test isequal(Symbolics.derivative(x'x, x[1]), 2x[1])
    @test isequal(Symbolics.derivative(y'x, x[1]), y[1])
    @test isequal(Symbolics.derivative(y'x, y[1]), x[1])
end

@testset "Derivative of `LinearAlgebra.dot`" begin
    @variables x[1:3] y[1:3]
    @test isequal(Symbolics.derivative(dot(x, x), x[1]), 2x[1])
    @test isequal(Symbolics.derivative(dot(y, x), x[1]), y[1])
    @test isequal(Symbolics.derivative(dot(y, x), y[1]), x[1])
    @test isequal(Symbolics.derivative(sqrt(dot(x, x)), x[1]), x[1] / sqrt(dot(x, x)))
    @test isequal(Symbolics.derivative(sqrt(dot(x, y)), x[1]), y[1] / 2sqrt(dot(x, y)))
end

@testset "Derivative of `mapreduce` and similar arrayops" begin
    @variables x[1:3] y[1:3]
    @test isequal(Symbolics.derivative(sum(x), x[1]), Symbolics.SConst(1))
    @test isequal(Symbolics.derivative(prod(x), x[1]), x[2]*x[3])
    ex = @arrayop () x[i] * y[i]
    @test isequal(Symbolics.derivative(ex, x[1]), y[1])
    @test isequal(Symbolics.derivative(sqrt(sum(x)), x[1]), 1/2sqrt(sum(x)))
    @test isequal(Symbolics.derivative(sqrt(prod(x)), x[1]), (x[2] * x[3])/2sqrt(prod(x)))
    @test isequal(Symbolics.derivative(sqrt(ex), x[1]), y[1] / 2sqrt(ex))
end

struct Op <: SymbolicUtils.Operator end

@testset "Derivative of non-`Differential` operators" begin
    @variables x
    ex = Symbolics.STerm(Op(), [x]; type = Real, shape = UnitRange{Int}[])
    @test SymbolicUtils._iszero(Symbolics.derivative(ex, x))
end

@testset "Derivative of `LinearAlgebra.norm`" begin
    @variables x[1:3] y[1:3, 1:3]
    for i in 1:3
        @test isequal(Symbolics.derivative(norm(x), x[i]), Symbolics.derivative(norm(collect(x)), x[i]))
        @test isequal(Symbolics.derivative(norm(x) ^ 2, x[i]), (2x[i] * norm(x)) / sqrt(abs2(x[1]) + abs2(x[2]) + abs2(x[3])))
    end
    for i in 1:3, j in 1:3
        @test isequal(Symbolics.derivative(norm(y), y[i, j]), Symbolics.derivative(norm(collect(y)), y[i, j]))
    end
end

# `recursive_hasoperator` on `ArrayMaker` (issue: was not handled, always returned false)
@testset "`recursive_hasoperator` with `ArrayMaker`" begin
    @variables t x(t)[1:2]
    D = Differential(t)

    arr_with_deriv = @makearray arr[1:2] begin
        arr[1:1] => Symbolics.SConst([unwrap(D(x[1]))])
        arr[2:2] => [unwrap(x[2])]
    end
    @test SymbolicUtils.isarraymaker(arr_with_deriv)
    @test Symbolics.hasderiv(arr_with_deriv)

    arr_no_deriv = @makearray arr[1:2] begin
        arr[1:1] => Symbolics.SConst([unwrap(x[1])])
        arr[2:2] => [unwrap(x[2])]
    end
    @test SymbolicUtils.isarraymaker(arr_no_deriv)
    @test !Symbolics.hasderiv(arr_no_deriv)
end

using Symbolics, Test
using ReferenceTests

# The ordering of operands within commutative `+` and `*` in the generated code
# follows SymbolicUtils' argument sorting, which is benign but has changed across
# versions (e.g. `a * b` vs `b * a`). To keep these tests stable across the CI
# Julia/SymbolicUtils matrix we compare structure modulo that ordering rather than
# byte-for-byte against a reference file. This mirrors the scalar Stan/MATLAB
# tests further down, which were already converted for the same reason.
function normalize_terms(rhs)
    summands = map(strip, split(rhs, " + "))
    canonical = map(summands) do summand
        join(sort(map(strip, split(summand, " * "))), " * ")
    end
    return sort(canonical)
end

@variables t a x(t) y(t)
expr = [a*x - x*y,-3y + x*y]

# StanTarget structural test (was target_functions/1.stan)
let
    sfunc = Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.StanTarget())
    @test occursin("vector diffeqf(real t,vector internal_var___u,vector internal_var___p)", sfunc)
    @test occursin("vector[2] internal_var___du;", sfunc)
    @test occursin("return internal_var___du;", sfunc)
    m1 = match(r"internal_var___du\[1\] = (.+);", sfunc)
    m2 = match(r"internal_var___du\[2\] = (.+);", sfunc)
    @test m1 !== nothing && m2 !== nothing
    @test normalize_terms(m1[1]) ==
        normalize_terms("internal_var___p[1] * internal_var___u[1] + -1 * internal_var___u[1] * internal_var___u[2]")
    @test normalize_terms(m2[1]) ==
        normalize_terms("-3 * internal_var___u[2] + internal_var___u[1] * internal_var___u[2]")
end

# CTarget structural test (was target_functions/1.c)
let
    cfunc = Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.CTarget(),
                                     lhsname=:internal_var___du,
                                     rhsnames=[:internal_var___u,:internal_var___p,:t])
    @test occursin("#include <math.h>", cfunc)
    @test occursin("void diffeqf(double* internal_var___du, const double* internal_var___u, const double* internal_var___p, const double t)", cfunc)
    m1 = match(r"internal_var___du\[0\] = (.+);", cfunc)
    m2 = match(r"internal_var___du\[1\] = (.+);", cfunc)
    @test m1 !== nothing && m2 !== nothing
    @test normalize_terms(m1[1]) ==
        normalize_terms("internal_var___p[0] * internal_var___u[0] + -1 * internal_var___u[0] * internal_var___u[1]")
    @test normalize_terms(m2[1]) ==
        normalize_terms("-3 * internal_var___u[1] + internal_var___u[0] * internal_var___u[1]")
end

# MATLABTarget structural test (was target_functions/1.m)
@test Base.ispublic(Symbolics, :MATLABTarget)

let
    mfunc = Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.MATLABTarget())
    @test occursin("diffeqf = @(internal_var___t,internal_var___u)", mfunc)
    rows = [m[1] for m in eachmatch(r"([^\[\];\n]+);", mfunc)]
    @test length(rows) == 2
    @test normalize_terms(rows[1]) ==
        normalize_terms("internal_var___p(1) * internal_var___u(1) + -1 * internal_var___u(1) * internal_var___u(2)")
    @test normalize_terms(rows[2]) ==
        normalize_terms("-3 * internal_var___u(2) + internal_var___u(1) * internal_var___u(2)")
end

@test Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.CTarget(),
                                     lhsname=:internal_var___du,
                                     rhsnames=[:internal_var___u,:internal_var___p,:t]) ==
    Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.CTarget(),
                                   lhsname=:internal_var___du,
                                   rhsnames=[:internal_var___u,:internal_var___p,:t])

@test Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.StanTarget()) ==
      Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.StanTarget())

@test Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.MATLABTarget()) ==
      Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.MATLABTarget())

@test Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.CTarget(),
                                     lhsname=:internal_var___du,
                                     rhsnames=[:internal_var___u,:internal_var___p,:t]) ==
      Symbolics.build_function(expr,vcat(x,y),[a],t,target = Symbolics.CTarget(),
                                     lhsname=:internal_var___du,
                                     rhsnames=[:internal_var___u,:internal_var___p,:t])

@test Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.StanTarget()) ==
      Symbolics.build_function(expr,vcat(x,y),[a],t,target = Symbolics.StanTarget())

@test Symbolics.build_function(expr,[x,y],[a],t,target = Symbolics.MATLABTarget()) ==
      Symbolics.build_function(expr,vcat(x,y),[a],t,target = Symbolics.MATLABTarget())


# Matrix CTarget test
let
    @variables x[1:4] y[1:4] z[1:4]
    expression = hcat(x,y,z) # Results in [x1 y1 z1; x2 y2 z2; ...]
    variables  = vcat(x,y,z) # Results in [x1, x2, x3, x4, y1, ...]
    cfunc      = build_function(expression, variables; target = Symbolics.CTarget(), expression = Val{true})
    @test_reference "target_functions/matrix.c" cfunc
end

# Scalar CTarget test
let
    @variables x y t
    expression = x + y + t
    cfunc = build_function(expression, [x], [y], t; target = Symbolics.CTarget(), expression = Val{true})

    @test occursin("void diffeqf(double* du, const double* RHS1, const double* RHS2, const double RHS3)", cfunc)
    m = match(r"du\[0\] = (.+);", cfunc)
    @test m !== nothing
    terms = sort(strip.(split(m[1], "+")))
    @test terms == ["RHS1[0]", "RHS2[0]", "RHS3"]
end

# Scalar CTarget test with scalar multiplication and powers
let
    @variables x y a t
    expression = x^2 + y^-1 + sin(a)^3.5 + 2t + 1//1
    cfunc = build_function(expression, [x, y], [a], t; target = Symbolics.CTarget(), expression = Val{true})

    @test_reference "target_functions/scalar2.c" cfunc
end


# Safe solver functions (ssqrt/scbrt/slog) must map to their math.h names in C
# (https://github.com/JuliaSymbolics/Symbolics.jl/issues/1873)
let
    @variables y
    expression = (1//2) * Symbolics.term(Symbolics.ssqrt, 4y) +
                 Symbolics.term(Symbolics.scbrt, y) + Symbolics.term(Symbolics.slog, y)
    cfunc = build_function([expression], y; target = Symbolics.CTarget(), expression = Val{true})

    @test occursin("sqrt(", cfunc)
    @test occursin("cbrt(", cfunc)
    @test occursin("log(", cfunc)
    @test !occursin("ssqrt", cfunc)
    @test !occursin("scbrt", cfunc)
    @test !occursin("slog", cfunc)
end

# Matrix StanTarget test
let
    @variables x[1:4] y[1:4] z[1:4]
    expression = hcat(x,y,z) # Results in [x1 y1 z1; x2 y2 z2; ...]
    variables  = vcat(x,y,z) # Results in [x1, x2, x3, x4, y1, ...]
    sfunc      = build_function(expression, vcat(x,y), z, []; target = Symbolics.StanTarget(), expression = Val{true})

    @test_reference "target_functions/matrix.stan" sfunc
end

# Scalar StanTarget test
let
    @variables t x(t) y(t) z(t)
    expression = x + y + z
    sfunc = build_function(expression, vcat(x,y), [z], t; target = Symbolics.StanTarget(), expression = Val{true})

    # Term ordering in additions depends on hash-based sorting which is
    # non-deterministic across Julia processes, so we check structurally
    # rather than using an exact reference file.
    @test occursin("vector diffeqf(real t,vector internal_var___u,vector internal_var___p)", sfunc)
    @test occursin("vector[1] internal_var___du;", sfunc)
    @test occursin("return internal_var___du;", sfunc)
    # Check that the RHS contains exactly the expected terms
    m = match(r"internal_var___du\[1\] = (.+);", sfunc)
    @test m !== nothing
    terms = sort(strip.(split(m[1], "+")))
    @test terms == ["internal_var___p[1]", "internal_var___u[1]", "internal_var___u[2]"]
end

# Matrix MATLABTarget test
let
    @variables x[1:4] y[1:4] z[1:4]
    expression = hcat(x,y,z) # Results in [x1 y1 z1; x2 y2 z2; ...]
    variables  = vcat(x,y,z) # Results in [x1, x2, x3, x4, y1, ...]
    mfunc      = build_function(expression, vcat(x,y,z); target = Symbolics.MATLABTarget(), expression = Val{true})

    @test_reference "target_functions/matrix.m" mfunc
end

# Scalar MATLABTarget test
let
    @variables x y z
    expression = x + y + z
    mfunc = build_function(expression, vcat(x,y,z); target = Symbolics.MATLABTarget(), expression = Val{true})

    @test occursin("diffeqf = @(internal_var___t,internal_var___u)", mfunc)
    m = match(r"\[\s*(.+);", mfunc)
    @test m !== nothing
    terms = sort(strip.(split(m[1], "+")))
    @test terms == ["internal_var___u(1)", "internal_var___u(2)", "internal_var___u(3)"]
end

using Symbolics
using SymbolicUtils
using SymbolicUtils.Code
using SymbolicUtils: unwrap
using SparseArrays
using LinearAlgebra
using RuntimeGeneratedFunctions

RuntimeGeneratedFunctions.init(@__MODULE__)

@variables a b c1 c2 c3 d e g

ir = IRStructure{SymReal}()

@testset "NaNMath" begin
    oop, iip = Symbolics.codegen_function(ir, [sqrt(a), sin(b)], [[a, b]]; nanmath = true, sort_addmul = true)
    oop = eval(oop)
    @test all(isnan, @invokelatest oop([-1, Inf]))
    out = [0, 0.0]
    iip = eval(iip)
    @invokelatest iip(out, [-1, Inf])
    @test all(isnan, out)
end

@testset "Multiple arguments" begin
    h = [
        a + b + c1 + c2,
        c3 + d + e + g,
        0,
    ] # uses the same number of arguments as our application
    h_julia(a, b, c, d, e, g) = [
        a[1] + b[1] + c[1] + c[2],
        c[3] + d[1] + e[1] + g[1],
        0,
    ]
    function h_julia!(out, a, b, c, d, e, g)
        out .= [a[1] + b[1] + c[1] + c[2], c[3] + d[1] + e[1] + g[1], 0]
    end

    h_str = Symbolics.codegen_function(ir, h, [[a], [b], [c1, c2, c3], [d], [e], [g]]; sort_addmul = true)
    h_str2 = Symbolics.codegen_function(ir, h, [[a], [b], [c1, c2, c3], [d], [e], [g]]; sort_addmul = true)
    @test h_str[1] == h_str2[1]
    @test h_str[2] == h_str2[2]

    h_oop = eval(h_str[1])
    h_str_3 = Symbolics.codegen_function(ir, h, [[a], [b], [c1, c2, c3], [d], [e], [g]]; iip_config = (false, true), sort_addmul = true)
    h_str_4 = Symbolics.codegen_function(ir, h, [[a], [b], [c1, c2, c3], [d], [e], [g]]; iip_config = (true, false), sort_addmul = true)

    h_ip! = eval(h_str[2])
    h_ip_skip! = eval(Symbolics.codegen_function(ir, h, [[a], [b], [c1, c2, c3], [d], [e], [g]], skipzeros = true, sort_addmul = true)[2])

    h3_oop = let f = eval(h_str_3[1])
        (args...) -> @invokelatest f(args...)
    end
    h3_ip = let f = eval(h_str_3[2])
        (args...) -> @invokelatest f(args...)
    end
    h4_oop = let f = eval(h_str_4[1])
        (args...) -> @invokelatest f(args...)
    end
    h4_ip = let f = eval(h_str_4[2])
        (args...) -> @invokelatest f(args...)
    end
    inputs = ([1], [2], [3, 4, 5], [6], [7], [8])

    @test h_oop(inputs...) == h_julia(inputs...)
    out_1 = similar(h, Int)
    out_2 = similar(out_1)
    h_ip!(out_1, inputs...)
    h_julia!(out_2, inputs...)
    @test_throws Symbolics.FunctionUnimplementedError h3_oop(inputs...)
    @test out_1 == out_2
    h3_ip(out_1, inputs...)
    @test out_1 == out_2
    @test_throws Symbolics.FunctionUnimplementedError h4_ip(out_1, inputs...)
    @test h4_oop(inputs...) == h_julia(inputs...)
    out_1 = similar(h, Int)
    fill!(out_1, 10)
    h_ip_skip!(out_1, inputs...)
    @test out_1[3] == 10
    out_1[3] = 0
    @test out_1 == out_2
end

@testset "With unused arguments" begin
    h_skip = [a + b + c1; c2 + c3 + g] # skip d, e
    h_julia_skip(a, b, c, d, e, g) = [a[1] + b[1] + c[1]; c[2] + c[3] + g[1]]
    function h_julia_skip!(out, a, b, c, d, e, g)
        out .= [a[1] + b[1] + c[1]; c[2] + c[3] + g[1]]
    end

    h_str_skip = Symbolics.codegen_function(ir, h_skip, [[a], [b], [c1, c2, c3], [], [], [g]]; checkbounds = true, sort_addmul = true)
    h_oop_skip = let f = eval(h_str_skip[1])
        (args...) -> @invokelatest f(args...)
    end
    h_ip!_skip = let f = eval(h_str_skip[2])
        (args...) -> @invokelatest f(args...)
    end
    inputs_skip = ([1], [2], [3, 4, 5], [], [], [8])

    @test h_oop_skip(inputs_skip...) == h_julia_skip(inputs_skip...)
    out_1_skip = Array{Int64}(undef, 2)
    out_2_skip = similar(out_1_skip)
    h_ip!_skip(out_1_skip, inputs_skip...)
    h_julia_skip!(out_2_skip, inputs_skip...)
    @test out_1_skip == out_2_skip

    # Same as above, except test ability to call with non-matrix arguments (i.e., for `nt`)
    inputs_skip_2 = ([1], [2], [3, 4, 5], [], (a = 1, b = 2), [8])
    @test h_oop_skip(inputs_skip_2...) == h_julia_skip(inputs_skip_2...)
    out_1_skip_2 = Array{Int64}(undef, 2)
    out_2_skip_2 = similar(out_1_skip_2)
    h_ip!_skip(out_1_skip_2, inputs_skip_2...)
    h_julia_skip!(out_2_skip_2, inputs_skip_2...)
    @test out_1_skip_2 == out_2_skip_2
end

@testset "Multiple input scalar result" begin
    h_scalar = a + b + c1 + c2 + c3 + d + e + g
    h_julia_scalar(a, b, c, d, e, g) = a[1] + b[1] + c[1] + c[2] + c[3] + d[1] + e[1] + g[1]
    h_str_scalar, _ = Symbolics.codegen_function(ir, h_scalar, [[a], [b], [c1, c2, c3], [d], [e], [g]]; sort_addmul = true)
    h_str_scalar2, _ = Symbolics.codegen_function(ir, h_scalar, [[a], [b], [c1, c2, c3], [d], [e], [g]]; sort_addmul = true)
    @test h_str_scalar == h_str_scalar2

    h_oop_scalar = let f = eval(h_str_scalar)
        (args...) -> f(args...)
    end
    inputs = ([1], [2], [3, 4, 5], [6], [7], [8])
    @test h_oop_scalar(inputs...) == h_julia_scalar(inputs...)
end

@testset "Dependent variable arguments" begin
    @variables t x(t) y(t) k
    f = let _f = eval(Symbolics.codegen_function(ir, (x + y) / k, [[x, y, k]]; sort_addmul = true)[1])
        (args...) -> @invokelatest _f(args...)
    end
    @test f([1, 1, 2]) == 1

    f = let _f = eval(Symbolics.codegen_function(ir, [(x + y) / k], [[x, y, k]]; sort_addmul = true)[1])
        (args...) -> @invokelatest _f(args...)
    end
    @test f([1, 1, 2]) == [1]

    f = let _f = eval(Symbolics.codegen_function(ir, [(x + y) / k], [[x, y, k]]; sort_addmul = true)[2])
        (args...) -> @invokelatest _f(args...)
    end
    z = [0.0]
    f(z, [1, 1, 2])
    @test z == [1]

    f = let _f = eval(Symbolics.codegen_function(ir, sparse([1], [1], [(x + y) / k], 10, 10), [[x, y, k]]; sort_addmul = true)[1])
        (args...) -> @invokelatest _f(args...)
    end

    @test size(f([1.0, 1.0, 2])) == (10, 10)
    @test f([1.0, 1.0, 2])[1, 1] == 1.0
    @test sum(f([1.0, 1.0, 2])) == 1.0
end

@testset "Reshaped SparseMatrix" begin
    @variables a b c

    x = reshape(sparse([0 a 0; 0 b c]), 3, 2)
    f1, f2 = Symbolics.codegen_function(ir, x, [[a, b, c]]; sort_addmul = true)
    f1 = @RuntimeGeneratedFunction(f1)
    f2 = @RuntimeGeneratedFunction(f2)
    y = f1([1, 2, 3])
    @test y isa Base.ReshapedArray
    @test y.parent isa SparseMatrixCSC
    @test y.parent.rowval == x.parent.rowval
    @test y == [0 2; 0 0; 1 3]

    f1, f2 = Symbolics.codegen_function(ir, @views(x[2:3, 1:2]), [[a, b, c]]; sort_addmul = true)
    f1 = @RuntimeGeneratedFunction(f1)
    f2 = @RuntimeGeneratedFunction(f2)
    y = f1([1, 2, 3])
    @test y isa SparseMatrixCSC
    @test y == [0 0; 1 3]
end

@testset "ModelingToolkit.jl#800" begin
    @variables x
    y = sparse(1:3, 1:3, x)

    f1, f2 = Symbolics.codegen_function(ir, y, [x]; sort_addmul = true)
    sf1, sf2 = string(f1), string(f2)
    @test !contains(sf1, "CartesianIndex")
    @test !contains(sf2, "CartesianIndex")
    @test contains(sf2, ".nzval")
end

@testset "Issue#587" begin
    N = 100 # try with N = 5 and N = 100
    _S = sprand(N, N, 0.1)
    _Q = Array(sprand(N, N, 0.1))

    F(z) = [
        collect(_S * z)
        collect(_Q * z .^ 2)
    ]

    Symbolics.@variables z[1:N]

    sj = Symbolics.sparsejacobian(F(z), z)

    f_expr = Symbolics.codegen_function(ir, sj, [z]; sort_addmul = true)
    myf = eval(first(f_expr))
    J = @invokelatest myf(rand(N))

    @test typeof(J) <: SparseMatrixCSC
    @test nnz(J) == nnz(sj)
end

@testset "`wrap_code`" begin
    @variables x p t
    ex = t + p * x^2
    integrator = gensym(:MTKIntegrator)
    header = expr -> let integrator = integrator
        Func(
            [
                expr.args[1], expr.args[2], DestructuredArgs(
                    expr.args[3:end], integrator,
                    inds = [:p]
                ),
            ], [], expr.body
        )
    end
    f, _ = Symbolics.codegen_function(
        ir, ex, [[unwrap(x)], unwrap(t), [unwrap(p)]];
        wrap_code = (header, identity), sort_addmul = true
    )
    f = @RuntimeGeneratedFunction(f)
    p = (a = 10, p = [2])
    @test f([3], 1, p) == 19
end

@testset "Issue#658" begin
    @variables a, X1[1:3], X2[1:3]
    k = eval(Symbolics.codegen_function(ir, a * X1 + X2, [X1, X2, a]; sort_addmul = true)[1])
    @test @invokelatest(k(ones(3), ones(3), 1.5)) == [2.5, 2.5, 2.5]
end

@testset "`similarto`" begin
    @variables x[1:2]
    T = collect(unwrap(x .^ 2))
    fn = @RuntimeGeneratedFunction(Symbolics.codegen_function(ir, T, [collect(x)]; sort_addmul = true)[1])
    @test_throws MethodError fn((1.0, 2.0))
    fn = @RuntimeGeneratedFunction(Symbolics.codegen_function(ir, T, [collect(x)]; similarto = Array, sort_addmul = true)[1])
    @test fn((1.0, 2.0)) ≈ [1.0, 4.0]
end

@testset "`codegen_function` with `UpperTriangular`" begin
    function f_test(J,u)
        J[1,1] = u[1]
        J[1,2] = u[2]
        J[2,1] = -u[1]
        J[2,2] = -u[2]
        return nothing
    end

    @variables u[1:2]
    J = fill!(Array{Num}(undef, 2, 2), 0)
    f_test(J, u)
    up_J = UpperTriangular(J - Diagonal(J))

    out, fjac_upper_expr = Symbolics.codegen_function(ir, up_J, [u]; skipzeros = true, sort_addmul = true)
    fjac_upper_expr = @RuntimeGeneratedFunction(fjac_upper_expr)
    Jtmp = UpperTriangular(zeros(2, 2))
    utmp = rand(2)
    @test_nowarn fjac_upper_expr(Jtmp, utmp)
    @test Jtmp[3] == utmp[2]
end

@testset "Repeated codegen produces identical expressions" begin
    @variables t x(t) fn(..) y(t)
    expr = [x + fn(y + 2t), fn(x + 3sin(t)) * y]
    args = [[x, y], [fn], t]
    oopexprs = Expr[]
    iipexprs = Expr[]
    for i in 1:10
        foop, fiip = Symbolics.codegen_function(ir, expr, args; sort_addmul = true)
        push!(oopexprs, foop)
        push!(iipexprs, fiip)
    end
    @test allequal(oopexprs)
    @test allequal(iipexprs)
end


@testset "`CodegenFunctionOptions` struct interface" begin
    @variables a b c1 c2 c3 d e g
    @test (@doc Symbolics.CodegenFunctionOptions) !== nothing
    @test (@doc Symbolics.codegen_function) !== nothing
    @static if VERSION >= v"1.11"
        @test Base.ispublic(Symbolics, :CodegenFunctionOptions)
        @test Base.ispublic(Symbolics, :codegen_function)
    end
    # `CodegenFunctionOptions` is a single concrete type regardless of which options are set, so
    # functions that thread it through do not recompile per option-combination.
    @test isconcretetype(Symbolics.CodegenFunctionOptions)
    o1 = Symbolics.CodegenFunctionOptions(; nanmath = true)
    o2 = Symbolics.CodegenFunctionOptions(;
        nanmath = false, wrap_code = (x -> x, x -> x), checkbounds = true,
        iip_config = (true, false), sort_addmul = true, skipzeros = true, optimize = nothing)
    @test typeof(o1) === typeof(o2) === Symbolics.CodegenFunctionOptions

    # scalar/vector path: keyword form and struct form are identical
    kw = Symbolics.codegen_function(ir, [sqrt(a), sin(b)], [[a, b]]; nanmath = true, sort_addmul = true)
    st = Symbolics.codegen_function(ir, [sqrt(a), sin(b)], [[a, b]],
        Symbolics.CodegenFunctionOptions(; nanmath = true, sort_addmul = true))
    @test string(kw) == string(st)

    # array path: keyword form and struct form are identical
    h = [a + b, c1 * c2, d / e]
    args = [[a], [b], [c1, c2, c3], [d], [e], [g]]
    kw2 = Symbolics.codegen_function(ir, h, args; skipzeros = true, checkbounds = true, sort_addmul = true)
    st2 = Symbolics.codegen_function(ir, h, args,
        Symbolics.CodegenFunctionOptions(; skipzeros = true, checkbounds = true, sort_addmul = true))
    @test string(kw2) == string(st2)

    # unknown keyword arguments are dropped (backwards compatible with the old `kwargs...` sink)
    with_bogus = Symbolics.codegen_function(ir, [sqrt(a)], [[a]]; nanmath = true, sort_addmul = true, bogus = 42)
    without = Symbolics.codegen_function(ir, [sqrt(a)], [[a]]; nanmath = true, sort_addmul = true)
    @test string(with_bogus) == string(without)
end

# Implement a few of the LogExpFunctions methods when those rely on boolean workflows.

LogExpFunctions.log1mexp(x::RCNum) = log(1 - exp(x))
LogExpFunctions.log1pexp(x::RCNum) = log(1 + exp(x))
LogExpFunctions.logexpm1(x::RCNum) = log(exp(x) - 1)
LogExpFunctions.logmxp1(x::RCNum) = log(x) - x + 1
for (f, op) in ((:logaddexp, +), (:logsubexp, -))
    @eval begin
        LogExpFunctions.$(f)(x::RCNum, y::Real) = log($(op)(exp(x), exp(y)))
        LogExpFunctions.$(f)(x::Real, y::RCNum) = log($(op)(exp(x), exp(y)))
        LogExpFunctions.$(f)(x::RCNum, y::RCNum) = log($(op)(exp(x), exp(y)))
    end
end
function LogExpFunctions.logsumexp(x::Union{AbstractVector{<:Num}, Arr})
    log(sum(exp, x; init = 0.0))
end

module SymbolicsNemoExt
using Nemo
import Symbolics.PrecompileTools
import Symbolics.Bijections

if isdefined(Base, :get_extension)
    using Symbolics
    using Symbolics: Num, symtype
else
    using ..Symbolics
    using ..Symbolics: Num, symtype
end

# Map each variable of the given poly.
# Can be used to transform Nemo polynomial to expression.
function nemo_crude_evaluate(poly::Nemo.MPolyRingElem, varmap)
    new_poly = 0
    for (i, term) in enumerate(Nemo.terms(poly))
        new_term = nemo_crude_evaluate(Nemo.coeff(poly, i), varmap)
        for var in Nemo.vars(term)
            exp = Nemo.degree(term, var)
            exp == 0 && continue
            new_var = varmap[var]
            new_term *= new_var^exp
        end
        new_poly += new_term
    end
    new_poly
end

function nemo_crude_evaluate(poly::Nemo.FracElem, varmap)
    nemo_crude_evaluate(numerator(poly), varmap) // nemo_crude_evaluate(denominator(poly), varmap)
end

function nemo_crude_evaluate(poly::Nemo.ZZRingElem, varmap)
    Rational(poly)
end

# factor(x^2*y + b*x*y - a*x - a*b)  ->  (x*y - a)*(x + b)
function Symbolics.factor_use_nemo(poly::Num)
    Symbolics.check_polynomial(poly)
    Symbolics.degree(poly) == 0 && return poly, Num[]
    mp_polys, poly_to_bs = Symbolics.symbol_to_poly([poly])
    mp_poly = only(mp_polys)
    vars = collect(Symbolics.get_variables(poly))
    bs_to_poly = Bijections.active_inv(poly_to_bs)
    poly_vars = map(Base.Fix1(getindex, bs_to_poly), vars)
    nemo_ring, nemo_vars = Nemo.polynomial_ring(Nemo.QQ, map(string, vars))
    nemo_poly = mp_poly(poly_vars => nemo_vars)
    nemo_fac = Nemo.factor(nemo_poly)
    nemo_unit = Nemo.unit(nemo_fac)
    nemo_factors = collect(keys(nemo_fac.fac)) 
    sym_unit = Rational(Nemo.coeff(nemo_unit, 1))
    nemo_to_sym = Dict(nemo_vars .=> vars)
    sym_factors = map(f -> Symbolics.wrap(nemo_crude_evaluate(f, nemo_to_sym)), nemo_factors)
    for (i, fac) in enumerate(sym_factors)
        sym_factors[i] = fac^(collect(values(nemo_fac.fac))[i])
    end

    return sym_unit, sym_factors
end

# Helps with precompilation time
# PrecompileTools.@setup_workload begin
#     @variables a b c x y z
#     expr_with_params = expand((x + b)*(x^2 + 2x + 1)*(x^2 - a))
#     equation1 = a*log(x)^b + c ~ 0
#     equation_polynomial = 9^x + 3^x + 2
#     exp_eq = 5*2^(x+1) + 7^(x+3)
#     PrecompileTools.@compile_workload begin
#         symbolic_solve(equation1, x)
#         symbolic_solve(equation_polynomial, x)
#         symbolic_solve(exp_eq)
#         symbolic_solve(expr_with_params, x, dropmultiplicity=false)
#         symbolic_solve(x^10 - a^10, x, dropmultiplicity=false)
#     end
# end

end # module

# basic integral struct with upper bound and lower bound.
"""
    Integral(domain)

Defines an Integral operator I(ex) which represents the integral of `I` of the
expression `ex` over the `domain`. Note that the `domain` must be a
`Symbolics.VarDomainPairing` where the chosen variable is the variable being
integrated over, i.e. `Integral(x in domain)` means that `I` is the integral
operator with respect to `dx`.

## Examples

```julia
I1 = Integral(x in ClosedInterval(1, 5))
I2 = Integral(x in ClosedInterval(1, 5))

@variables a b
I = Integral(x in ClosedInterval(a, b))
@test isequal(I(0), 0)
@test isequal(I(2), 2*(b -a))
```
"""
struct Integral
    domain::VarDomainPairing
end

Base.nameof(::Integral) = :Integral

const AnyInterval{T} = DomainSets.Interval{A, B, T} where {A, B}

function (I::Integral)(x::Union{Rational, AbstractIrrational, AbstractFloat, Integer})
    domain = I.domain.domain
    # Despite this not being a concrete type, `endpoints` only needs to access fields
    # of `Interval` so this ends up being type-stable. There doesn't seem to be a way
    # to test this and ensure it remains type-stable.
    if domain isa AnyInterval{Num}
        a, b = unwrap.(IntervalSets.endpoints(domain))
        return Num((b - a) * x)
    elseif domain isa AnyInterval{SymbolicT}
        a, b = IntervalSets.endpoints(domain)
        return Num((b - a) * x)
    elseif domain isa AnyInterval{Int}
        a, b = IntervalSets.endpoints(domain)
        return Num((b - a) * x)
    elseif domain isa AnyInterval{Float64}
        a, b = IntervalSets.endpoints(domain)
        return Num((b - a) * x)
    else
        # ::NTuple{2, Any} avoids `indexed_iterate` dynamic dispatching
        a, b = IntervalSets.endpoints(domain)::NTuple{2, Any}
        # SConst avoids `*` dynamic dispatching
        return Num(SConst(b - a) * x)
    end
end
(I::Integral)(x::Complex) = Complex{Num}(Num(I(unwrap(real(x)))), Num(I(unwrap(imag(x)))))
function (I::Integral)(x)
    return Term{VartypeT}(
        I, SArgsT((x,));
        type = SymbolicUtils.symtype(x), shape = SymbolicUtils.shape(x)
    )
end
(I::Integral)(x::Num) = Num(I(unwrap(x)))
SymbolicUtils.promote_symtype(::Integral, T::SymbolicUtils.TypeT) = T
SymbolicUtils.promote_shape(::Integral, @nospecialize(sh::SymbolicUtils.ShapeT)) = sh

function Base.show(io::IO, I::Integral)
    print(io, "Integral(", I.domain.variables, ", ", I.domain.domain, ")")
end

Base.:(==)(I1::Integral, I2::Integral) = convert(Bool, simplify(isequal(I1.domain, I2.domain)))

const INTEGRAL_SALT = 0xb7d4e1928c3a6f50
function _isequal_integral_domain(
        d1::IntervalSets.AbstractInterval, d2::IntervalSets.AbstractInterval
    )
    if eltype(d1) <: Union{Num, SymbolicT} || eltype(d2) <: Union{Num, SymbolicT}
        return IntervalSets.closedendpoints(d1) == IntervalSets.closedendpoints(d2) &&
            isequal(IntervalSets.endpoints(d1), IntervalSets.endpoints(d2))
    end
    return isequal(d1, d2)
end
_isequal_integral_domain(d1, d2) = isequal(d1, d2)

Base.isequal(I1::Integral, I2::Integral) =
    isequal(I1.domain.variables, I2.domain.variables) &&
    _isequal_integral_domain(I1.domain.domain, I2.domain.domain)
Base.hash(I::Integral, h::UInt) =
    hash(I.domain.domain, hash(I.domain.variables, hash(INTEGRAL_SALT, h)))

using Symbolics
using Symbolics: solve_linear_ode_system, SymbolicLinearODE, has_const_coeffs, to_homogeneous, symbolic_solve_ode, find_particular_solution, IVP, solve_symbolic_IVP
using Groebner, Nemo
using Test

@variables x, y, t
Dt = Symbolics.Differential(t)

# Systems
# ideally, `isapprox` would all be `isequal`, but there seem to be some floating point inaccuracies
@test isapprox(solve_linear_ode_system([1 0; 0 -1], [1, -1], t), [exp(t), -exp(-t)])
@test isapprox(solve_linear_ode_system([-3 4; -2 3], [7, 2], t), [10exp(-t) - 3exp(t), 5exp(-t) - 3exp(t)])
@test isapprox(solve_linear_ode_system([4 -3; 8 -6], [7, 2], t), [18 - 11exp(-2t), 24 - 22exp(-2t)])

@test_broken isapprox(solve_linear_ode_system([-1 -2; 2 -1], [1, -1], t), [exp(-t)*(cos(2t) + sin(2t)), exp(-t)*(sin(2t) - cos(2t))]) # can't handle complex eigenvalues (though it should be able to)

@test isapprox(solve_linear_ode_system([1 -1 0; 1 2 1; -2 1 -1], [7, 2, 3], t), (5//3)*exp(-t)*[-1, -2, 7] - 14exp(t)*[-1, 0, 1] + (16//3)*exp(2t)*[-1, 1, 1])

@test isequal(solve_linear_ode_system([1 0; 0 -1], [1, -1], t), [exp(t), -exp(-t)])
@test isequal(solve_linear_ode_system([-3 4; -2 3], [7, 2], t), [10exp(-t) - 3exp(t), 5exp(-t) - 3exp(t)])
@test isapprox(solve_linear_ode_system([4 -3; 8 -6], [7, 2], t), [18 - 11exp(-2t), 24 - 22exp(-2t)])

@test isequal(solve_linear_ode_system([1 -1 0; 1 2 1; -2 1 -1], [7, 2, 3], t), (5//3)*exp(-t)*[-1, -2, 7] - 14exp(t)*[-1, 0, 1] + (16//3)*exp(2t)*[-1, 1, 1])

@test_throws ArgumentError solve_linear_ode_system([1 2; 3 4], [1, 2, 3], t) # mismatch between A and x0
@test_throws ArgumentError solve_linear_ode_system([1 2 3; 4 5 6], [1, 2], t) # A isn't square
@test_throws ArgumentError Symbolics.solve_uncoupled_system([1 2; 3 4], [1, 2], t) # A isn't diagonal

# LinearODEs
@test Symbolics.is_homogeneous(SymbolicLinearODE(x, t, [1, 1], 0))
@test !Symbolics.is_homogeneous(SymbolicLinearODE(x, t, [t, 1], t^2))

@test has_const_coeffs(SymbolicLinearODE(x, t, [1, 1], 0))
@test !has_const_coeffs(SymbolicLinearODE(x, t, [t^2, 1], 0))

@test Symbolics.is_homogeneous(to_homogeneous(SymbolicLinearODE(x, t, [t, 1], t^2)))
@test !Symbolics.is_linear_ode(((Dt^2)(x))^2 ~ x^3, x, t)

C = Symbolics.variables(:C, 1:5)

## constant coefficients, nth-order
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [-1], 0)), C[1]*exp(t))
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [-4, 3], 0)), C[1]*exp(-4t) + C[2]*exp(t))

## first order (solving via integrating factor can be found in test/sympy.jl)
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [1], 2sin(t))), C[1]*exp(-t) + sin(t) - cos(t))

## repeated characteristic roots
@test isequal(symbolic_solve_ode((Dt^2)(x) + 2(Dt^1)(x) + x ~ 0, x, t), C[1]*exp(-t) + C[2]*t*exp(-t))
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [0, 0, 0, 4, -4], 0)), C[1] + C[2]*t + C[3]*t^2 + C[4]*exp(2t) + C[5]*t*exp(2t))
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [8, 12, 6], 0)), C[1]*exp(-2t) + C[2]*t*exp(-2t) + C[3]*t^2*exp(-2t))

## complex characteristic roots
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [1, 0], 0)), C[1]*cos(t) + C[2]*sin(t))
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [0, 1, 0], 0)), C[1] + C[2]*cos(t) + C[3]*sin(t))

## resonant response formula
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [9, -6], 4exp(3t))), C[1]*exp(3t) + C[2]*t*exp(3t) + 2(t^2)*exp(3t))
### trig functions
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [6, 5], 2exp(-t)*cos(t))), C[1]*exp(-2t) + C[2]*exp(-3t) + (1//5)*exp(-t)*cos(t)+(3//5)*exp(-t)*sin(t))

## undetermined coefficients
@test isequal(symbolic_solve_ode(SymbolicLinearODE(x, t, [-3, 2], 2t - 5)), C[1]exp(t) + C[2]exp(-3t) - (2//3)t + 11//9)
@test isequal(find_particular_solution(SymbolicLinearODE(x, t, [1, 0], t^2)), t^2 - 2)

# Parsing
@test isequal(SymbolicLinearODE(x, t, [1], 0), SymbolicLinearODE(Dt(x) + x ~ 0, x, t))
@test isequal(SymbolicLinearODE(x, t, [sin(t), 0, 3t^2], exp(2t) + 2cos(t)), SymbolicLinearODE(6t^2*(Dt^2)(x) + 2sin(t)*x - 2exp(2t) + 2(Dt^3)(x) ~ 4cos(t), x, t))

# IVP
@test isequal(solve_symbolic_IVP(IVP(SymbolicLinearODE(x, t, [-3, 2], 0), [1, -1])), (1//2)exp(-3t) + (1//2)exp(t))
@test isequal(solve_symbolic_IVP(IVP(SymbolicLinearODE(x, t, [9, -6], 4exp(3t)), [5, 6])), 5exp(3t) - 9t*exp(3t) + 2(t^2)*exp(3t))

# Other methods

## Clairaut's equation
@test isequal(symbolic_solve_ode(x ~ Dt(x)*t - ((Dt(x))^3), x, t), C[1]*t - C[1]^3)
@test isequal(symbolic_solve_ode(Dt(x)*t + (Dt(x))^2 - sin(Dt(x)) + 2 ~ x, x, t), C[1]*t + C[1]^2 - sin(C[1]) + 2)
@test isnothing(symbolic_solve_ode(Dt(x) + (Dt(x))^2 ~ x, x, t))
@test isnothing(symbolic_solve_ode(Dt(x)*t + 2t*(Dt(x))^2 ~ x, x, t))
@test isnothing(symbolic_solve_ode(Dt(x) + x*(Dt(x))^2 ~ x, x, t))

## Bernoulli equations (integrating factor solve in test/sympy.jl)
@test isequal(symbolic_solve_ode(Dt(x) - 5x ~ exp(-2t)*x^(-2), x, t), (C[1]exp(15t) - (3//17)exp(-2t))^(1//3))
@test isnothing(symbolic_solve_ode(sqrt((Dt^4)(x)) ~ log(x)^t, x, t))

# Helper function tests
ys = Symbolics.variables(:y, 1:2)
@test isequal(Symbolics.reduce_order((Dt^2)(x) + 3Dt(x) + 2x ~ 0, x, t, ys), [ys[2], -2ys[1] - 3ys[2]])
@test isequal(Symbolics.unreduce_order([ys[1], ys[2]], x, t, ys), [x, Dt(x)])

@test Symbolics.is_solution(C[1]*exp(3t) + C[2]*t*exp(3t) + 2(t^2)*exp(3t), SymbolicLinearODE(x, t, [9, -6], 4exp(3t)))
@test Symbolics.is_solution(C[1]*exp(-t) + C[2]*t*exp(-t), (Dt^2)(x) + 2(Dt^1)(x) + x ~ 0, x, t)

"""
$(DocStringExtensions.README)
"""
module Symbolics

import PrecompileTools
using PrecompileTools: @compile_workload, @setup_workload

import PrecompileTools: @recompile_invalidations

@recompile_invalidations begin
    import CommonWorldInvalidations

import DocStringExtensions, Markdown
using DocStringExtensions: FIELDS, SIGNATURES, TYPEDEF, TYPEDSIGNATURES

import LinearAlgebra
using LinearAlgebra: Adjoint, Eigen, I, LU, LowerTriangular, SingularException,
    Transpose, UnitLowerTriangular, UpperTriangular, cond, det, diag, diagm, isdiag,
    istril, istriu, lu, mul!, norm, tril

import Primes

import Setfield

    import DomainSets: Domain, DomainSets
    import IntervalSets

import TermInterface
using TermInterface: sorted_arguments
import TermInterface: maketerm, iscall, operation, arguments, metadata

import SymbolicUtils: Term, Sym, BasicSymbolic, Const,
    FnType, @rule, Rewriters, substitute, symtype, shape, unwrap, unwrap_const,
    promote_symtype, isadd, ismul, ispow, isterm, issym, isdiv, BSImpl, scalarize,
    Operator, _iszero, _isone, search_variables, search_variables!, ArgsT, ROArgsT,
    ifelse_eager, ifelse_branching, Unknown
import SymbolicUtils as SU

import SymbolicUtils.Code
using SymbolicUtils.Code: Assignment, AtIndex, DestructuredArgs, Func, Let,
    LiteralExpr, MakeArray, SetArray, SpawnFetch

import SymbolicUtils.Rewriters: Chain, Prewalk, Postwalk, Fixpoint

import SymbolicUtils.Code: toexpr

import ArrayInterface
import RuntimeGeneratedFunctions
using RuntimeGeneratedFunctions: @RuntimeGeneratedFunction, RuntimeGeneratedFunction, drop_expr
import MacroTools

import SymbolicIndexingInterface
using SymbolicIndexingInterface: ArraySymbolic, NotSymbolic, ScalarSymbolic, getname,
    hasname, symbolic_type

import SymbolicLimits

using ADTypes: ADTypes

import SymbolicUtils
using SymbolicUtils: @acrule, @syms, IRStructure, SafeReal, SymReal, TreeReal, expand,
    flatten_fractions, getmetadata, hasmetadata, setmetadata, simplify,
    simplify_fractions, term, vartype
RuntimeGeneratedFunctions.init(@__MODULE__)

import SciMLPublic: @public

using Moshi.Match: @match

import Preferences: @load_preference
end

using SymbolicUtils: @arrayop, @makearray, @rule, BS, Rewriters, RuleSet,
    arguments, get_reachability, ifelse_branching, ifelse_eager, iscall, istree,
    operation, populate_ir!, print_ir, quick_cancel, substitute, unwrap_const
export @acrule, @arrayop, @makearray, @rule, @syms, BS, IRStructure, Rewriters, RuleSet,
    SafeReal, SymReal, SymbolicUtils, TreeReal, Unknown, arguments, expand,
    flatten_fractions, get_reachability, getmetadata, hasmetadata, ifelse_branching,
    ifelse_eager, iscall, istree, operation, populate_ir!, print_ir, quick_cancel,
    scalarize, setmetadata, shape, simplify, simplify_fractions, sorted_arguments,
    substitute, term, unwrap, unwrap_const, vartype
const DEFAULT_VARTYPE_PREF = @load_preference("vartype", "SymReal")
const VartypeT = @static if DEFAULT_VARTYPE_PREF == "SymReal"
    SymReal
elseif DEFAULT_VARTYPE_PREF == "SafeReal"
    SafeReal
elseif DEFAULT_VARTYPE_PREF == "TreeReal"
    TreeReal
else
    error("""
    Invalid vartype preference: $DEFAULT_VARTYPE_PREF. Must be one of "SymReal", \
    "SafeReal" or "TreeReal".
    """)
end
const COMMON_ONE = SymbolicUtils.one_of_vartype(VartypeT)
const COMMON_ZERO = SymbolicUtils.zero_of_vartype(VartypeT)
const SymbolicT = BasicSymbolic{VartypeT}
const SArgsT = SymbolicUtils.ArgsT{VartypeT}
const SConst = SymbolicUtils.BSImpl.Const{VartypeT}
const SSym = SymbolicUtils.Sym{VartypeT}
const STerm = SymbolicUtils.Term{VartypeT}

export simplify, substitute, substitute_in_deriv, substitute_in_deriv_and_depvar # (re-)export

import AbstractPlutoDingetjes: is_inside_pluto
const WARNED_LATEXIFY = Ref(false)
function warn_load_latexify()
    is_inside_pluto() || return
    WARNED_LATEXIFY[] && return
    @warn """
    Attempting to print a symbolic expression in a Pluto notebook. Please run \
    `import Latexify` to enable pretty-printing of symbolic expressions. This \
    warning will only display once.
    """
    WARNED_LATEXIFY[] = true
    return nothing
end

export Num
import MacroTools: splitdef
include("wrapper-types.jl")

@recompile_invalidations begin
    include("num.jl")
end
function (s::SymbolicUtils.Substituter)(x::Num)
    Num(s(unwrap(x)))
end


include("rewrite-helpers.jl")
include("complex.jl")

"""
    substitute(expr, s; fold=Val(false))

Performs the substitution on `expr` according to rule(s) `s`.
If `fold=Val(true)`, expressions which can be fully evaluated will be evaluated to a number.

!!! warning "Does not penetrate `Differential`"
    As of Symbolics.jl v7 (SymbolicUtils.jl v4), `substitute` does **not** recurse into
    the arguments of `Differential` expressions. For example,
    `substitute(D(x), Dict(x => y))` returns `D(x)`, not `D(y)`.
    Use [`substitute_in_deriv`](@ref) or [`substitute_in_deriv_and_depvar`](@ref) to
    substitute inside `Differential` applications.


# Examples

```jldoctest
julia> using Symbolics

julia> @variables t x y z(t)
4-element Vector{Num}:
    t
    x
    y
 z(t)

julia> ex = x + y + sin(z)
sin(z(t)) + x + y

julia> substitute(ex, Dict([x => z, sin(z) => z^2]))
y + z(t) + z(t)^2

julia> substitute(sqrt(2x), Dict([x => 1]))
sqrt(2)

julia> substitute(sqrt(2x), Dict([x => 1]); fold=Val(true))
1.4142135623730951
```
"""
substitute

export Equation
include("equations.jl")

export Inequality, ≲, ≳
include("inequality.jl")

import Bijections, DynamicPolynomials
import DynamicPolynomials as DP
import MultivariatePolynomials as MP
import MutableArithmetics as MA

import ConstructionBase
include("arrays.jl")

export tosymbol, terms, factors
export gather_factor
include("utils.jl")

export @register_symbolic, @register_array_symbolic
include("register.jl")

import SparseArrays
using SparseArrays: AbstractSparseArray, AbstractSparseVector, SparseMatrixCSC,
    SparseVector, findnz, issparse, nnz, sparse
export @variables
include("variable.jl")

function slog end; function ssqrt end; function scbrt end
import DiffRules, SpecialFunctions, NaNMath
using SpecialFunctions: airyai, airyaiprime, airybi, airybiprime, besselj0, besselj1,
    bessely0, bessely1, beta, dawson, digamma, erf, erfc, erfcinv, erfcx, erfi,
    erfinv, expinti, gamma, invdigamma, lbeta, lgamma, trigamma
include("linearity.jl")


export Differential, expand_derivatives, is_derivative, @register_derivative, @derivative_rule
include("register_derivatives.jl")
include("diff.jl")

export SymbolicsSparsityDetector

include("adtypes.jl")

export infimum, supremum
include("domains.jl")

export Integral
include("integral.jl")

include("array-lib.jl")

import LogExpFunctions
include("logexpfunctions-lib.jl")

include("linear_algebra.jl")
export symbolic_linear_solve, solve_for

include("groebner_basis.jl")
export groebner_basis, is_groebner_basis

include("taylor.jl")
export series, taylor, taylor_coeff

export SymStruct, @symstruct
include("symstruct.jl")

import Libdl
include("build_function.jl")
include("codegen_fn.jl")
export build_function

include("conditionals.jl")

include("extra_functions.jl")

import RecipesBase
using RecipesBase: @recipe
include("plot_recipes.jl")

include("latexify_recipes.jl")

include("semipoly.jl")


include("parsing.jl")
export parse_expr_to_symbolic

include("error_hints.jl")

include("limits.jl")
export limit

include("partialfractions.jl")
export partial_frac_decomposition

# Hacks to make wrappers "nicer"
const NumberTypes = Union{AbstractFloat,Integer,Complex{<:AbstractFloat},Complex{<:Integer}}
(::Type{T})(x::SymbolicUtils.BasicSymbolic) where {T<:NumberTypes} = throw(ArgumentError("Cannot convert Sym to $T since Sym is symbolic and $T is concrete. Use `substitute` to replace the symbolic unwraps."))
for T in [Num, Complex{Num}]
    @eval begin
        #(::Type{S})(x::$T) where {S<:Union{NumberTypes,AbstractArray}} = S(Symbolics.unwrap(x))::S

        SymbolicUtils.simplify(n::$T; kw...) = $T(SymbolicUtils.simplify(unwrap(n); kw...))
        SymbolicUtils.simplify_fractions(n::$T; kw...) = $T(SymbolicUtils.simplify_fractions(unwrap(n); kw...))
        SymbolicUtils.expand(n::$T) = $T(SymbolicUtils.expand(unwrap(n)))

        SymbolicUtils.Code.toexpr(x::$T) = SymbolicUtils.Code.toexpr(unwrap(x))

        SymbolicUtils.setmetadata(x::$T, t, v) = $T(SymbolicUtils.setmetadata(unwrap(x), t, v))
        SymbolicUtils.getmetadata(x::$T, t) = SymbolicUtils.getmetadata(unwrap(x), t)
        SymbolicUtils.hasmetadata(x::$T, t) = SymbolicUtils.hasmetadata(unwrap(x), t)

        Broadcast.broadcastable(x::$T) = x
        SymbolicUtils.scalarize(x::$T) = $T(scalarize(unwrap(x)))
    end
end

# Symbolic solver
include("solver/preprocess.jl")
include("solver/nemo_stuff.jl")
include("solver/solve_helpers.jl")
include("solver/postprocess.jl")
include("solver/univar.jl")
include("solver/ia_helpers.jl")
include("solver/polynomialization.jl")
include("solver/attract.jl")
include("solver/ia_main.jl")
include("solver/main.jl")
include("solver/special_cases.jl")
export symbolic_solve

# Diff Eq Solver
include("diffeqs/diffeqs.jl")
include("diffeqs/systems.jl")
include("diffeqs/diffeq_helpers.jl")
include("diffeqs/laplace.jl")
export SymbolicLinearODE, symbolic_solve_ode, solve_linear_ode_system, solve_symbolic_IVP, laplace, inverse_laplace, laplace_solve_ode

# Sympy Functions

"""
    symbolics_to_sympy(expr)

Converts a Symbolics.jl expression to a SymPy expression. It is represented in
[SymPy.jl](https://juliapy.github.io/SymPy.jl/dev/) format and thus can use all
of the wrapped functionality from SymPy.jl.

For conversion back to Symbolics, see `sympy_to_symbolics`.

# Arguments

- `expr`: A Symbolics.jl expression

# Example

```julia
using Symbolics
@variables x y
expr = x^2 + y
sympy_expr = symbolics_to_sympy(expr)
```
"""
function symbolics_to_sympy end

"""
    sympy_to_symbolics(sympy_expr, vars)
Converts a SymPy expression to Symbolics.jl.
# Arguments
- `sympy_expr`: SymPy expression.
- `vars`: List or dictionary of Symbolics variables.
# Example
```julia
@variables x y
sympy_expr = SymPy.Sym("x")^2 + SymPy.Sym("y")
symbolics_expr = sympy_to_symbolics(sympy_expr, [x, y])
```
"""
function sympy_to_symbolics end

"""
    sympy_linear_solve(A, b)
Solves linear system Ax = b using SymPy.
# Arguments
- `A`: Matrix of Symbolics expressions.
- `b`: Vector of Symbolics expressions.
# Returns
Vector of Symbolics solutions.
# Example
```julia
@variables x y
A = [1 2; 3 4]
b = [x, y]
sol = sympy_linear_solve(A, b)
```
"""
function sympy_linear_solve end

"""
    sympy_algebraic_solve(expr, var)
Solves algebraic equation(s) expr = 0 for var(s) using SymPy.
# Arguments
- `expr`: Symbolics expression or vector of expressions for a system of equations (linear or nonlinear).
- `var`: Symbolics variable or vector of variables to solve for.
# Returns
- For a single equation: List of Symbolics solutions.
- For a system: List of dictionaries mapping variables to solutions.
# Example
```julia
@variables x y
# Single equation
expr = x^2 - 4
sol = sympy_algebraic_solve(expr, x)  # Returns [2, -2]
# Nonlinear system
eqs = [x^2 + y^2 - 4, x - y]  # Circle and line
sol = sympy_algebraic_solve(eqs, [x, y])  # Returns [{x=>1, y=>1}, {x=>-1, y=>-1}]
```
"""
function sympy_algebraic_solve end

"""
    sympy_integrate(expr, var)
Computes indefinite integral of expr w.r.t. var using SymPy.
# Arguments
- `expr`: Symbolics expression.
- `var`: Symbolics variable.
# Returns
Symbolics integral.
# Example
```julia
@variables x
expr = x^2
result = sympy_integrate(expr, x)
```
"""
function sympy_integrate end

"""
    sympy_limit(expr, var, val)
Computes limit of expr as var approaches val using SymPy.
# Arguments
- `expr`: Symbolics expression.
- `var`: Symbolics variable.
- `val`: Symbolics expression or number.
# Returns
Symbolics limit.
# Example
```julia
@variables x
expr = 1/x
result = sympy_limit(expr, x, 0)
```
"""
function sympy_limit end

"""
    sympy_simplify(expr)
Simplifies a Symbolics expression using SymPy.
# Arguments
- `expr`: Symbolics expression.
# Returns
Simplified Symbolics expression.
# Example
```julia
@variables x
expr = x^2 + 2x^2
result = sympy_simplify(expr)
```
"""
function sympy_simplify end

"""
    sympy_ode_solve(expr, func, var)
Solves ODE expr = 0 for function func w.r.t. var using SymPy.
# Arguments
- `expr`: Symbolics expression representing ODE (set to 0).
- `func`: Symbolics function (e.g., f(x)).
- `var`: Independent Symbolics variable.
# Returns
Symbolics solution(s).
# Example
```julia
@variables x
@syms f(x)
expr = Symbolics.Derivative(f, x) - 2*f
sol = sympy_ode_solve(expr, f, x)  # Returns C1*exp(2*x)
```
"""
function sympy_ode_solve end

export symbolics_to_sympy, sympy_to_symbolics
export sympy_linear_solve, sympy_algebraic_solve, sympy_integrate, sympy_limit, sympy_simplify,sympy_ode_solve

"""
    symbolics_to_sympy_pythoncall(expr)
Converts a Symbolics expression to SymPyPythonCall.
For conversion back to Symbolics, see `sympy_pythoncall_to_symbolics`.
# Arguments
- `expr`: Symbolics expression.
# Example
```julia
@variables x
expr = x^2 + 1
sympy_expr = symbolics_to_sympy_pythoncall(expr)
```
"""
function symbolics_to_sympy_pythoncall end

"""
    sympy_pythoncall_to_symbolics(sympy_expr, vars)
Converts a SymPyPythonCall expression to Symbolics.jl.
# Arguments
- `sympy_expr`: SymPyPythonCall expression.
- `vars`: List or dictionary of Symbolics variables.
# Example
```julia
@variables x y
# Assuming sympy_expr is a SymPyPythonCall expression
symbolics_expr = sympy_pythoncall_to_symbolics(sympy_expr, [x, y])
```
"""
function sympy_pythoncall_to_symbolics end

"""
    sympy_pythoncall_linear_solve(A, b)
Solves linear system Ax = b using SymPyPythonCall.
# Arguments
- `A`: Matrix of Symbolics expressions.
- `b`: Vector of Symbolics expressions.
# Returns
Vector of Symbolics solutions.
# Example
```julia
@variables x y
A = [1 2; 3 4]
b = [x, y]
sol = sympy_pythoncall_linear_solve(A, b)
```
"""
function sympy_pythoncall_linear_solve end

"""
    sympy_pythoncall_algebraic_solve(expr, var)
Solves algebraic equations using SymPyPythonCall.
# Arguments
- `expr`: Symbolics expression or vector of expressions.
- `var`: Variable or vector of variables to solve for.
# Returns
Symbolics solution(s).
# Example
```julia
@variables x y
expr = x^2 - 4
sol = sympy_pythoncall_algebraic_solve(expr, x)  # Returns [2, -2]
eqs = [x^2 + y^2 - 2, x - y]
sol = sympy_pythoncall_algebraic_solve(eqs, [x, y])  # Returns [{x=>1, y=>1}, {x=>-1, y=>-1}]
```
"""
function sympy_pythoncall_algebraic_solve end

"""
    sympy_pythoncall_integrate(expr, var)
Performs symbolic integration using SymPyPythonCall.
# Arguments
- `expr`: Symbolics expression to integrate.
- `var`: Variable of integration.
# Returns
Symbolics expression representing the integral.
# Example
```julia
@variables x
expr = x^2
result = sympy_pythoncall_integrate(expr, x)
```
"""
function sympy_pythoncall_integrate end

"""
    sympy_pythoncall_limit(expr, var, val)
Computes symbolic limits using SymPyPythonCall.
# Arguments
- `expr`: Symbolics expression.
- `var`: Variable approaching the limit.
- `val`: Value the variable approaches.
# Returns
Symbolics expression representing the limit.
# Example
```julia
@variables x
expr = sin(x)/x
result = sympy_pythoncall_limit(expr, x, 0)
```
"""
function sympy_pythoncall_limit end

"""
    sympy_pythoncall_simplify(expr)
Simplifies symbolic expressions using SymPyPythonCall.
# Arguments
- `expr`: Symbolics expression to simplify.
# Returns
Simplified Symbolics expression.
# Example
```julia
@variables x
expr = (x^2 - 1)/(x - 1)
result = sympy_pythoncall_simplify(expr)
```
"""
function sympy_pythoncall_simplify end

"""
    sympy_pythoncall_ode_solve(expr, func, var)
Solves ordinary differential equations using SymPyPythonCall.
# Arguments
- `expr`: Symbolics expression representing the ODE.
- `func`: Function to solve for.
- `var`: Independent variable.
# Returns
Symbolics solution(s).
# Example
```julia
@variables x
@syms f(x)
expr = Symbolics.Derivative(f, x) - 2*f
sol = sympy_pythoncall_ode_solve(expr, f, x)  # Returns C1*exp(2*x)
```
"""
function sympy_pythoncall_ode_solve end

export symbolics_to_sympy_pythoncall, sympy_pythoncall_to_symbolics
export sympy_pythoncall_linear_solve, sympy_pythoncall_algebraic_solve, sympy_pythoncall_integrate, sympy_pythoncall_limit, sympy_pythoncall_simplify, sympy_pythoncall_ode_solve

function __init__()
    Base.Experimental.register_error_hint(TypeError) do io, exc
        if exc.expected == Bool && exc.got isa Num
            println(io,
                "\nA symbolic expression appeared in a Boolean context. This error arises in situations where Julia expects a Bool, like ")
            printstyled(io, "if boolean_condition", color = :blue)
            printstyled(
                io, "\t\t use ifelse(boolean_condition, then branch, else branch)\n",
                color = :green)
            printstyled(io, "x && y", color = :blue)
            printstyled(io, "\t\t\t\t use x & y\n", color = :green)
            printstyled(io, "boolean_condition ? a : b", color = :blue)
            printstyled(io, "\t use ifelse(boolean_condition, a, b)\n", color = :green)
            print(io,
                "but a symbolic expression appeared instead of a Bool. For help regarding control flow with symbolic variables, see https://docs.sciml.ai/ModelingToolkit/dev/basics/FAQ/#How-do-I-handle-if-statements-in-my-symbolic-forms?")
        end
    end
    SymbolicUtils.hashcons(RootsOf, true)
    SymbolicUtils.hashcons(IM, true)
    SymbolicUtils.hashcons(COMMON_ONE, true)
    SymbolicUtils.hashcons(COMMON_ZERO, true)
    SymbolicUtils.hashcons(IIP_OUTSYM, true)
    SymbolicUtils.hashcons(IIP_ALLOCATOR, true)
end

export inverse, left_inverse, right_inverse, @register_inverse, has_inverse, has_left_inverse, has_right_inverse
include("inverse.jl")

export rootfunction, left_continuous_function, right_continuous_function, @register_discontinuity,
    majorization_function, minorization_function, approximation_function
include("discontinuities.jl")

include("despecialize.jl")

@public Arr, NAMESPACE_SEPARATOR, VariableDefaultValue, VariableSource
@public _parse_vars, derivative, gradient, jacobian, sparsejacobian, hessian, sparsehessian
@public get_variables, get_variables!, get_differential_vars, option_to_metadata_type
@public variable, wrap, linear_expansion, LinearExpander
@public _toexpr_metadata, _toexpr_op
@public value
@public CodegenFunctionOptions, codegen_function
@public diff2term, map_subscripts
@public fixpoint_sub

@setup_workload begin
    fold1 = Val{false}()
    @compile_workload begin
        @syms x y f(t) q[1:5]
        SymbolicUtils.Sym{SymReal}(:a; type = Real, shape = SymbolicUtils.ShapeVecT())
        x + y
        x * y
        x / y
        x ^ y
        x ^ 5
        6 ^ x
        x - y
        -y
        2y
        z = 2
        dict = SymbolicUtils.ACDict{VartypeT}()
        dict[x] = 1
        dict[y] = 1
        type::typeof(DataType) = rand() < 0.5 ? Real : Float64
        nt = (; type, shape, unsafe = true)
        Base.pairs(nt)
        BSImpl.AddMul{VartypeT}(1, dict, SymbolicUtils.AddMulVariant.MUL; type, shape = SymbolicUtils.ShapeVecT(), unsafe = true)
        *(y, z)
        *(z, y)
        SymbolicUtils.symtype(y)
        f(x)
        (5x / 5)
        expand((x + y) ^ 2)
        simplify(x ^ (1//2) + (sin(x) ^ 2 + cos(x) ^ 2) + 2(x + y) - x - y)
        ex = x + 2y + sin(x)
        rules1 = Dict(x => y)
        rules2 = Dict(x => 1)
        Dx = Differential(x)
        Differential(y)(ex)
        uex = unwrap(ex)
        executediff(Dx, uex)
        # Running `fold = Val(true)` invalidates the precompiled statements
        # for `fold = Val(false)` and itself doesn't precompile anyway.
        # substitute(ex, rules1)
        substitute(ex, rules1; fold = fold1)
        substitute(ex, rules2; fold = fold1)
        @variables foo
        f(foo)
        @variables x y f(::Real) q[1:5]
        x + y
        x * y
        x / y
        x ^ y
        x ^ 5
        # 6 ^ x
        x - y
        -y
        2y
        symtype(y)
        z = 2
        *(y, z)
        *(z, y)
        f(x)
        (5x / 5)
        [x, y]
        [x, f, f]
        promote_type(Int, Num)
        promote_type(Real, Num)
        promote_type(Float64, Num)
        # expand((x + y) ^ 2)
        # simplify(x ^ (1//2) + (sin(x) ^ 2 + cos(x) ^ 2) + 2(x + y) - x - y)
        ex = x + 2y + sin(x)
        rules1 = Dict(x => y)
        # rules2 = Dict(x => 1)
        # Running `fold = Val(true)` invalidates the precompiled statements
        # for `fold = Val(false)` and itself doesn't precompile anyway.
        # substitute(ex, rules1)
        substitute(ex, rules1; fold = fold1)
        linear_expansion(ex, y)
        # substitute(ex, rules2; fold = fold1)
        # substitute(ex, rules2)
        # substitute(ex, rules1; fold = fold2)
        # substitute(ex, rules2; fold = fold2)
        q[1]
        q'q
        
    end
end

precompile(Tuple{typeof(Base.:(^)), SymbolicUtils.BasicSymbolicImpl.var"typeof(BasicSymbolicImpl)"{SymbolicUtils.SymReal}, Int64})

end # module

:(function (ˍ₋out, u)
      for var"%jj′" = (zip)(Base.OneTo(5), (Symbolics.reset_to_one)(Base.OneTo(5)))
          begin
              j = var"%jj′"[1]
              j′ = var"%jj′"[2]
              for var"%ii′" = (zip)(Base.OneTo(5), (Symbolics.reset_to_one)(Base.OneTo(5)))
                  begin
                      i = var"%ii′"[1]
                      i′ = var"%ii′"[2]
                      begin
                          ˍ₋out[(CartesianIndex)(i′, j′)] = (+)((getindex)(ˍ₋out, i′, j′), (getindex)(u, (Main.limit2)((+)(-1, i), 5), (Main.limit2)((+)(1, j), 5)))
                          nothing
                      end
                  end
              end
          end
      end
  end)

using Symbolics, Test
@variables t, x(t), y(t), z(t)
@test Symbolics.islinear(x + y,[x,y])
@test Symbolics.islinear(x,[x,y])
@test Symbolics.islinear(y,[x,y])
@test !Symbolics.islinear(z,[x,y])

@test Symbolics.isaffine(x + y,[x,y])
@test Symbolics.isaffine(x,[x,y])
@test Symbolics.isaffine(y,[x,y])
@test Symbolics.isaffine(z,[x,y])
@test Symbolics.isaffine(x + y + z,[x,y])

@test Symbolics.isaffine(x + z * y,[x,y])
@test Symbolics.islinear(x + z * y,[x,y])
@test Symbolics.islinear(z * x + z * y,[x,y])
@test Symbolics.islinear(z * (x + y),[x,y])
@test Symbolics.isaffine(z * (x + y),[x,y])

@test Symbolics.isaffine(ifelse(x < 1, y, z), [z])
@test !Symbolics.isaffine(ifelse(x < 1, x, z), [x])

@test !Symbolics.isaffine(ifelse(y < 2, ifelse(x < 1, 0, 1), y), [x])

using Base.Threads
using SymbolicUtils.Code: LazyState, apply_optimization_rules

abstract type BuildTargets end
struct JuliaTarget <: BuildTargets end
struct StanTarget <: BuildTargets end
struct CTarget <: BuildTargets end

"""
    MATLABTarget()

A `build_function` target that generates an anonymous function expression for MATLAB and
GNU Octave.

# Arguments

None.

# Keywords

None. Pass this target as `target` to [`build_function`](@ref).

# Examples

```julia
julia> @variables x
1-element Vector{Num}:
 x

julia> build_function(x^2, x; target = MATLABTarget()) isa String
true
```
"""
struct MATLABTarget <: BuildTargets end
@public MATLABTarget

abstract type ParallelForm end
struct SerialForm <: ParallelForm end

"""
    ShardedForm{multithread}(cutoff, ncalls)

Split a long array construction into nested functions where each function calls
`ncalls` other functions, and the leaf functions populate at most `cutoff` number
of items in the array. If `multithread` is true, uses threading.
"""
struct ShardedForm{multithreaded} <: ParallelForm
    cutoff::Union{Nothing,Int}
    ncalls::Int
end

ShardedForm(cutoff, ncalls) = ShardedForm{false}(cutoff, ncalls)
ShardedForm() = ShardedForm(80, 4)

const MultithreadedForm = ShardedForm{true}

MultithreadedForm() = MultithreadedForm(nothing, 2*nthreads())

function throw_missing_specialization(n)
    throw(ArgumentError("Missing specialization for $n arguments. Check `iip_config`."))
end

"""
    build_function(ex, args...;
                   expression = Val{true},
                   target = JuliaTarget(),
                   parallel=nothing,
                   kwargs...)

Generates a numerically-usable function from a Symbolics `Num`.

Arguments:

- `ex`: The `Num` to compile
- `args`: The arguments of the function
- `expression`: Whether to generate code or whether to generate the compiled form.
  By default, `expression = Val{true}`, which means that the code for the
  function is returned. If `Val{false}`, then the returned value is compiled.

Keyword Arguments:

- `target`: The output target of the compilation process. Possible options are:
    - `JuliaTarget`: Generates a Julia function
    - `CTarget`: Generates a C function
    - `StanTarget`: Generates a function for compiling with the Stan probabilistic
      programming language
    - `MATLABTarget`: Generates an anonymous function for use in MATLAB and Octave
      environments
- `parallel`: The kind of parallelism to use in the generated function. Defaults
  to `SerialForm()`, i.e. no parallelism, if `ex` is a single expression or an
  array containing <= 1500 non-zero expressions. If `ex` is an array of > 1500
  non-zero expressions, then `ShardedForm(80, 4)` is used. See below for more on
  `ShardedForm`.
  Note that the parallel forms are not exported and thus need to be chosen like
  `Symbolics.SerialForm()`.
  The choices are:
  - `SerialForm()`: Serial execution.
  - `ShardedForm(cutoff, ncalls)`: splits the output function into sub-functions
     which contain at most `cutoff` number of output `rhss`. These sub-functions
     are called by the top-level function that _build_function returns.
     This helps in reducing the compile time of the generated function.
  - `MultithreadedForm()`: Multithreaded execution with a static split, evenly
    splitting the number of expressions per thread.
- `fname`: Used by some targets for the name of the function in the target space.

Note that not all build targets support the full compilation interface. Check the
individual target documentation for details.
"""
function build_function(args...;target = JuliaTarget(),kwargs...)
  _build_function(target,args...;kwargs...)
end

# Scalar output

unwrap_nometa(x) = unwrap(x)
function destructure_arg(arg::Union{AbstractArray, Tuple,NamedTuple}, inbounds, name)
    if !(arg isa Arr)
        DestructuredArgs(map(unwrap_nometa, arg), name, inbounds=inbounds, create_bindings=false)
    else
        unwrap_nometa(arg)
    end
end
destructure_arg(arg, _, _) = unwrap_nometa(arg)

function default_arg_name(i)
    Symbol("ˍ₋arg$(i)")
end

const DEFAULT_OUTSYM = Symbol("ˍ₋out")

# don't CSE inside operators
SymbolicUtils.Code.cse_inside_expr(sym, ::Symbolics.Operator) = false
# don't CSE inside `getindex` of things created via `@variables`
# EXCEPT called variables
function SymbolicUtils.Code.cse_inside_expr(sym, ::typeof(getindex))
    x = arguments(sym)[1]
    return !hasmetadata(x, VariableSource) || SymbolicUtils.is_called_function_symbolic(x)
end

function _build_function(target::JuliaTarget, op, args...;
                         conv = toexpr,
                         expression = Val{true},
                         expression_module = @__MODULE__(),
                         checkbounds = false,
                         states = LazyState(),
                         linenumbers = true,
                         wrap_code = nothing,
                         cse = false,
                         nanmath = true,
                         kwargs...)
    op = _recursive_unwrap(op)
    if symtype(op) <: AbstractArray
        if wrap_code === nothing
            wrap_code = (identity, identity)
        end
        return _build_function(target, wrap(op), args...; conv, expression, expression_module, checkbounds, states, linenumbers, cse, nanmath, wrap_code, kwargs...)
    end
    states.rewrites[:nanmath] = nanmath
    dargs = map((x) -> destructure_arg(x[2], !checkbounds, default_arg_name(x[1])), enumerate(collect(args)))
    fun = Func(dargs, [], op)
    if wrap_code !== nothing
        fun = wrap_code(fun)
    end
    if cse
        fun = Code.cse(fun)
    end
    expr = conv(fun, states)
    if !checkbounds
        @assert Meta.isexpr(expr, :function)
        expr.args[2] = :(@inbounds begin; $(expr.args[2]); end)
    end
    if expression == Val{true}
        expr
    else
        _build_and_inject_function(expression_module, expr)
    end
end

function get_unimplemented_expr(dargs)
    Func(dargs, [], term(throw_missing_specialization, length(dargs)))
end

SymbolicUtils.Code.get_rewrites(x::Arr) = SymbolicUtils.Code.get_rewrites(unwrap(x))

function _build_function(target::JuliaTarget, op::Arr, args...;
                         conv = toexpr,
                         expression = Val{true},
                         expression_module = @__MODULE__(),
                         checkbounds = false,
                         states = LazyState(),
                         linenumbers = true,
                         cse = false,
                         nanmath = true,
                         wrap_code = (identity, identity),
                         iip_config = (true, true),
                         kwargs...)
    op = _recursive_unwrap(op)
    dargs = map((x) -> destructure_arg(x[2], !checkbounds, default_arg_name(x[1])), enumerate(collect(args)))
    states.rewrites[:nanmath] = nanmath
    if iip_config[1]
        oop_expr = wrap_code[1](Func(dargs, [], op))
    else
        oop_expr = get_unimplemented_expr(dargs)
    end

    outsym = DEFAULT_OUTSYM
    if iip_config[2]
        body = inplace_expr(op, outsym)
        iip_expr = wrap_code[2](Func(vcat(outsym, dargs), [], body))
    else
        iip_expr = get_unimplemented_expr([outsym; dargs])
    end

    if cse
        oop_expr = Code.cse(oop_expr)
        iip_expr = Code.cse(iip_expr)
    end
    oop_expr = conv(oop_expr, states)
    if SymbolicUtils.isarrayop(op) && !haskey(states.rewrites, :arrayop_output)
        states.rewrites[:arrayop_output] = outsym
    end
    iip_expr = conv(iip_expr, states)

    if !checkbounds
        @assert Meta.isexpr(oop_expr, :function)
        oop_expr.args[2] = :(@inbounds begin; $(oop_expr.args[2]); end)
        @assert Meta.isexpr(iip_expr, :function)
        iip_expr.args[2] = :(@inbounds begin; $(iip_expr.args[2]); end)
    end
    if expression == Val{true}
        oop_expr, iip_expr
    else
        _build_and_inject_function(expression_module, oop_expr),
        _build_and_inject_function(expression_module, iip_expr)
    end
end

function _build_and_inject_function(mod::Module, ex)
    if ex.head == :function && ex.args[1].head == :tuple
        ex.args[1] = Expr(:call, :($mod.$(gensym())), ex.args[1].args...)
    elseif ex.head == :(->)
        return _build_and_inject_function(mod, Expr(:function, ex.args...))
    end
    RuntimeGeneratedFunction(mod, mod, ex)
end

toexpr(n::Num, st) = toexpr(value(n), st)

function fill_array_with_zero!(x::AbstractArray)
    if eltype(x) <: AbstractArray
        foreach(fill_array_with_zero!, x)
    else
        fill!(x, false)
    end
    return x
end

"""
    _build_function(target::JuliaTarget, rhss::AbstractArray, args...;
                       conv=toexpr,
                       expression = Val{true},
                       expression_module = @__MODULE__(),
                       checkbounds = false,
                       postprocess_fbody=ex -> ex,
                       linenumbers = false,
                       outputidxs=nothing,
                       skipzeros = false,
                       force_SA = false,
                       wrap_code = (nothing, nothing),
                       fillzeros = skipzeros && !(rhss isa SparseMatrixCSC),
                       states = LazyState(),
                       iip_config = (true, true),
                       parallel=nothing, cse = false, kwargs...)

Build function target: `JuliaTarget`

```julia
_build_function(target::JuliaTarget, rhss, args...;
                conv = toexpr,
                expression = Val{true},
                checkbounds = false,
                linenumbers = false,
                headerfun = addheader, outputidxs=nothing,
                convert_oop = true, force_SA = false,
                skipzeros = outputidxs===nothing,
                fillzeros = skipzeros && !(typeof(rhss)<:SparseMatrixCSC),
                parallel=SerialForm(), kwargs...)
```

Generates a Julia function which can then be utilized for further evaluations.
If expression=Val{false}, the return is a Julia function which utilizes
RuntimeGeneratedFunctions.jl to be free of world-age issues.

If the `rhss` is a scalar, the generated function is a function
with a scalar output. Otherwise, if it's an `AbstractArray`, the output
is two functions, one for out-of-place AbstractArray output and a second which
is a mutating function. The outputted functions match the given argument order,
i.e., f(u,p,args...) for the out-of-place and scalar functions and
`f!(du,u,p,args..)` for the in-place version.

Special Keyword Arguments:

- `parallel`: The kind of parallelism to use in the generated function. Defaults
  to `SerialForm()`, i.e. no parallelism. Note that the parallel forms are not
  exported and thus need to be chosen like `Symbolics.SerialForm()`.
  The choices are:
  - `SerialForm()`: Serial execution.
  - `ShardedForm(cutoff, ncalls)`: splits the output function into sub-functions
     which contain at most `cutoff` number of output `rhss`. These sub-functions
     are called by the top-level function that _build_function returns.
  - `MultithreadedForm()`: Multithreaded execution with a static split, evenly
    splitting the number of expressions per thread.
- `conv`: The conversion function of symbolic types to Expr. By default, this uses
  the `toexpr` function.
- `checkbounds`: For whether to enable bounds checking inside the generated
  function. Defaults to false, meaning that `@inbounds` is applied.
- `linenumbers`: Determines whether the generated function expression retains
  the line numbers. Defaults to true.
- `convert_oop`: Determines whether the OOP version should try to convert
  the output to match the type of the first input. This is useful for
  cases like LabelledArrays or other array types that carry extra
  information. Defaults to true.
- `force_SA`: Forces the output of the OOP version to be a StaticArray.
  Defaults to `false`, and outputs a static array when the first argument
  is a static array.
- `similarto`: An `AbstractArray` subtype which controls the type of the
  returned array for the OOP version. If provided, it ignores the value of `force_SA`.
- `skipzeros`: Whether to skip filling zeros in the in-place version if the
  filling function is 0.
- `fillzeros`: Whether to perform `fill(out,0)` before the calculations to ensure
  safety with `skipzeros`.
"""
function _build_function(target::JuliaTarget, rhss::AbstractArray, args...;
                       conv=toexpr,
                       expression = Val{true},
                       expression_module = @__MODULE__(),
                       checkbounds = false,
                       postprocess_fbody=ex -> ex,
                       linenumbers = false,
                       outputidxs=nothing,
                       skipzeros = false,
                       force_SA = false,
                       similarto = nothing,
                       wrap_code = (nothing, nothing),
                       fillzeros = skipzeros && !(rhss isa SparseMatrixCSC),
                       states = LazyState(),
                       iip_config = (true, true),
                       nanmath = true,
                       parallel=nothing, cse = false,
                       optimize = nothing,
                       kwargs...)
    if rhss isa SubArray
        rhss = copy(rhss)
    end
    rhss = _recursive_unwrap(rhss)
    states.rewrites[:nanmath] = nanmath
    # We cannot switch to ShardedForm because it deadlocks with
    # RuntimeGeneratedFunctions
    dargs = map((x) -> destructure_arg(x[2], !checkbounds,
                                  Symbol("ˍ₋arg$(x[1])")), enumerate([args...]))
    i = findfirst(x->x isa DestructuredArgs, dargs)
    if similarto === nothing
        similarto = force_SA ? SArray : i === nothing ? Array : dargs[i].name
    end

    oop, iip = iip_config
    if oop
        oop_expr = Func(dargs, [], postprocess_fbody(make_array(parallel, dargs, rhss, similarto)))
        if wrap_code[1] !== nothing
            oop_expr = wrap_code[1](oop_expr)
        end
    else
        oop_expr = get_unimplemented_expr(dargs)
    end


    if iip
        out = Sym{VartypeT}(DEFAULT_OUTSYM; type = Any, shape = SymbolicUtils.Unknown(-1))
        iip_expr = Func(vcat(out, dargs), [], postprocess_fbody(set_array(parallel,
                                    dargs,
                                    out,
                                    outputidxs,
                                    rhss,
                                    checkbounds,
                                    skipzeros)))
        if wrap_code[2] !== nothing
            iip_expr = wrap_code[2](iip_expr)
        end
    else
        iip_expr = get_unimplemented_expr([DEFAULT_OUTSYM; dargs])
    end

    if cse
        oop_expr = Code.cse(oop_expr)
        iip_expr = Code.cse(iip_expr)
    end

    if !isnothing(optimize) 
        iip_expr = apply_optimization_rules(iip_expr, states, optimize)
        oop_expr = apply_optimization_rules(oop_expr, states, optimize)
    end

    oop_expr = conv(oop_expr, states)
    iip_expr = conv(iip_expr, states)

    if !checkbounds
        @assert Meta.isexpr(oop_expr, :function)
        oop_expr.args[2] = :(@inbounds begin; $(oop_expr.args[2]); end)
        @assert Meta.isexpr(iip_expr, :function)
        iip_expr.args[2] = :(@inbounds begin; $(iip_expr.args[2]); end)
    end
    if expression == Val{true}
        return oop_expr, iip_expr
    else
        return _build_and_inject_function(expression_module, oop_expr),
        _build_and_inject_function(expression_module, iip_expr)
    end
end

_nnz(x::AbstractArray) = length(x)
_nnz(x::AbstractSparseArray) = nnz(x)
_nnz(x::Union{Base.ReshapedArray, LinearAlgebra.Transpose}) = _nnz(parent(x))

function make_array(s, dargs, arr, similarto)
    s !== nothing && Base.@warn("Parallel form of $(typeof(s)) not implemented")
    _make_array(arr, similarto)
end

function make_array(s::SerialForm, dargs, arr, similarto)
    _make_array(arr, similarto)
end

function make_array(s::ShardedForm, closed_args, arr, similarto)
    if arr isa AbstractSparseArray
        return term(SparseMatrixCSC, arr.m, arr.n, copy(arr.colptr), copy(arr.rowval), make_array(s, closed_args, arr.nzval, Vector))
    end
    per_task = ceil(Int, length(arr) / s.ncalls)
    slices = collect(Iterators.partition(arr, per_task))
    arrays = map(slices) do slice
        Func(closed_args, [], _make_array(slice, similarto)), closed_args
    end
    SpawnFetch{typeof(s)}(first.(arrays), last.(arrays), vcat)
end

struct Funcall{F, T}
    f::F
    args::T
end

(f::Funcall)() = f.f(f.args...)

function toexpr(p::SpawnFetch{MultithreadedForm}, st)
    args = isnothing(p.args) ?
              Iterators.repeated((), length(p.exprs)) : p.args
    spawns = map(p.exprs, args) do thunk, a
        ex = :($Funcall($(drop_expr(@RuntimeGeneratedFunction(@__MODULE__, toexpr(thunk, st), false))),
                       ($(toexpr.(a, (st,))...),)))
        quote
            let
                task = Base.Task($ex)
                task.sticky = false
                Base.schedule(task)
                task
            end
        end
    end
    quote
        $(toexpr(p.combine, st))(map(fetch, ($(spawns...),))...)
    end
end

function toexpr(p::SpawnFetch{ShardedForm{false}}, st)
    args = isnothing(p.args) ?
              Iterators.repeated((), length(p.exprs)) : p.args
    spawns = map(p.exprs, args) do thunk, a
        :($(drop_expr(@RuntimeGeneratedFunction(@__MODULE__, toexpr(thunk, st), false)))($(toexpr.(a, (st,))...),))
    end
    quote
        $(toexpr(p.combine, st))($(spawns...))
    end
end

function nzmap(f, x::Union{Base.ReshapedArray, LinearAlgebra.Transpose})
    Setfield.@set x.parent = nzmap(f, x.parent)
end

function nzmap(f, x::SubArray)
    unview = copy(x)
    if unview isa Union{SparseMatrixCSC, SparseVector}
        n = nnz(unview)
        if n != length(unview.nzval)
            resize!(unview.nzval, n)
            resize!(unview.rowval, n)
        end
    end
    nzmap(f, unview)
end

function nzmap(f, x::AbstractSparseArray)
    Setfield.@set x.nzval = nzmap(f, x.nzval)
end

function nzmap(f, x::UpperTriangular)
    UpperTriangular(nzmap(f, parent(x)))
end

function nzmap(f, x::LowerTriangular)
    UpperTriangular(nzmap(f, parent(x)))
end

nzmap(f, x) = map(f, x)

_issparse(x::AbstractArray) = issparse(x)
_issparse(x::Union{SubArray, Base.ReshapedArray, LinearAlgebra.Transpose}) = _issparse(parent(x))

function setparent(arr, val)
    Setfield.@set arr.parent = val
end

function set_nzval(arr, val)
    Setfield.@set arr.nzval = val
end

function _make_sparse_array(arr, similarto)
    if arr isa Union{SubArray, Base.ReshapedArray, LinearAlgebra.Transpose}
        newarr = _make_array(parent(arr), typeof(parent(arr)))
        return term(setparent, nzmap(Returns(true), arr), newarr)
    else
        newarr = _make_array(arr.nzval, Vector{symtype(eltype(arr))})
        return Let([Assignment(:__reference, term(copy, nzmap(Returns(true), arr)))], term(set_nzval, :__reference, newarr), false)
    end
end

function _make_array(rhs::UpperTriangular, similarto)
    return term(UpperTriangular, _make_array(parent(rhs), similarto))
end
function _make_array(rhs::LowerTriangular, similarto)
    return term(LowerTriangular, _make_array(parent(rhs), similarto))
end

function _make_array(rhss::AbstractArray, similarto)
    arr = nzmap(x->_make_array(x, similarto), rhss)
    if _issparse(arr)
        _make_sparse_array(arr, similarto)
    else
        MakeArray(arr, similarto)
    end
end

_make_array(x, similarto) = x

## In-place version

function set_array(p, closed_vars, args...)
    p !== nothing && Base.@warn("Parallel form of $(typeof(p)) not implemented")
    _set_array(args...)
end

function set_array(s::SerialForm, closed_vars, args...)
    _set_array(args...)
end

function recursive_split(leaf_f, s, out, args, outputidxs, xs)
    cutoff = isnothing(s.cutoff) ? ceil(Int, length(xs) / (2*s.ncalls)) : s.cutoff
    if length(xs) <= cutoff
        return leaf_f(outputidxs, xs)
    else
        per_part = ceil(Int, length(xs) / s.ncalls)
        slices = collect(Iterators.partition(zip(outputidxs, xs), per_part))
        fs = map(slices) do slice
            recursive_split(leaf_f, s, out, args, first.(slice), last.(slice))
        end
        return Func(args, [],
                    SpawnFetch{typeof(s)}(fs, [args for f in fs],
                                          (@inline noop(x...) = nothing)),
                    [])
    end
end

function set_array(s::ShardedForm, closed_args, out, outputidxs, rhss, checkbounds, skipzeros)
    if rhss isa AbstractSparseArray
        return set_array(s,
                         closed_args,
                         LiteralExpr(:($out.nzval)),
                         nothing,
                         rhss.nzval,
                         checkbounds,
                         skipzeros)
    end

    outvar = !(out isa Sym) ? gensym("out") : out

    if outputidxs === nothing
        outputidxs = collect(eachindex(rhss))
    end
    all_args = [outvar, closed_args...]
    ex = recursive_split(s, outvar, all_args, outputidxs, rhss) do idxs, xs
        Func(all_args, [],
             _set_array(outvar, idxs, xs, checkbounds, skipzeros),
             [])
    end.body

    return out isa Sym ? ex : LiteralExpr(quote
        $outvar = $out
        $ex
    end)
end

function _set_array(out, outputidxs, rhss::AbstractSparseArray, checkbounds, skipzeros)
    Let([Assignment(Symbol("%$out"), _set_array(LiteralExpr(:($out.nzval)), nothing, rhss.nzval, checkbounds, skipzeros))], out, false)
end

function _set_array(out, outputidxs, rhss::AbstractArray, checkbounds, skipzeros)
    if parent(rhss) !== rhss
        return _set_array(out, outputidxs, parent(rhss), checkbounds, skipzeros)
    end
    if outputidxs === nothing
        outputidxs = collect(eachindex(rhss))
    end
    indexes = AtIndex[]
    for (i, outi) in enumerate(outputidxs)
        if !(rhss[i] isa AbstractArray) && !(skipzeros && _iszero(rhss[i]))
            push!(indexes, AtIndex(outi, rhss[i]))
        elseif rhss[i] isa AbstractArray
            push!(indexes, AtIndex(outi, _set_array(LiteralExpr(:($out[$outi])), nothing, rhss[outi], checkbounds, skipzeros)))
        end
    end
    return SetArray(!checkbounds, out, indexes, true)
end

_set_array(out, outputidxs, rhs, checkbounds, skipzeros) = rhs


function vars_to_pairs(name,vs::Union{Tuple, AbstractArray}, symsdict=Dict())
    vs_names = tosymbol.(vs)
    for (v,k) in zip(vs_names, vs)
        symsdict[k] = Sym{symtype(k)}(v)
    end
    exs = [:($name[$i]) for (i, u) ∈ enumerate(vs)]
    vs_names,exs
end
function vars_to_pairs(name,vs, symsdict)
    symsdict[vs] = Sym{symtype(vs)}(tosymbol(vs))
    [tosymbol(vs)], [name]
end

get_varnumber(varop, vars::Vector) =  findfirst(x->isequal(x,varop),vars)
get_varnumber(varop, var) =  isequal(var,varop) ? 0 : nothing

function buildvarnumbercache(args...)
    varnumsdict = Pair[]
    for (argi,arg) in enumerate(args)
        if isa(arg,AbstractArray)
            for (eli,el) in enumerate(arg)
                push!(varnumsdict, el=>(argi,eli))
            end
        else
            push!(varnumsdict ,arg=>(argi,0))
        end
    end
    return Dict(varnumsdict)
end

function numbered_expr(O::BasicSymbolic,varnumbercache,args...;varordering = args[1],offset = 0,
                       states = LazyState(),
                       lhsname=:du,rhsnames=[Symbol("MTK$i") for i in 1:length(args)])
    O = value(O)
    O isa BasicSymbolic || return O
    if (issym(O) || issym(operation(O))) || (iscall(O) && operation(O) == getindex)
        (j,i) = get(varnumbercache, O, (nothing, nothing))
        if !isnothing(j)
            return i==0 ? :($(rhsnames[j])) : :($(rhsnames[j])[$(i+offset)])
        end
    end
    if iscall(O)
        if operation(O) === getindex
            args = arguments(O)
            Expr(:ref, toexpr(args[1], states), toexpr.(args[2:end] .+ offset, (states,))...)
        else
            Expr(:call, Symbol(operation(O)), (numbered_expr(x,varnumbercache,args...;offset=offset,lhsname=lhsname,
                                                             rhsnames=rhsnames,varordering=varordering) for x in sorted_arguments(O))...)
        end
    elseif issym(O)
        tosymbol(O, escape=false)
    else
        O
    end
end

function numbered_expr(de::Equation,varnumbercache,args...;varordering = args[1],
                       lhsname=:du,rhsnames=[Symbol("MTK$i") for i in 1:length(args)],offset=0)

    varordering = value.(args[1])
    var = var_from_nested_derivative(de.lhs)[1]
    i = findfirst(x->isequal(tosymbol(issym(x) ? x : operation(x), escape=false), tosymbol(var, escape=false)),varordering)
    :($lhsname[$(i+offset)] = $(numbered_expr(de.rhs,varnumbercache,args...;offset=offset,
                                              varordering = varordering,
                                              lhsname = lhsname,
                                              rhsnames = rhsnames)))
end
numbered_expr(c,args...;kwargs...) = c
numbered_expr(c::Num,args...;kwargs...) = error("Num found")


# The solver introduces "safe" variants of some math functions that handle
# negative/complex inputs in Julia. They have no C equivalent, so map them back
# to the standard math.h names when generating C code.
const c_safe_function_renames = Dict(:ssqrt => :sqrt, :scbrt => :cbrt, :slog => :log)

# Replace certain multiplication and power expressions so they form valid C code
# Extra factors of 1 are hopefully eliminated by the C compiler
function coperators(expr)
    expr isa Expr || return expr
    for e in expr.args
        if e isa Expr
            coperators(e)
        end
    end
    if expr.head == :call && expr.args[1] isa Symbol
        expr.args[1] = get(c_safe_function_renames, expr.args[1], expr.args[1])
    end
    for i in eachindex(expr.args)
        if expr.args[i] isa Rational
            expr.args[i] = float(expr.args[i]) # Evaluate rational numbers to floating-point
        end
    end
    # Introduce another factor 1 to prevent contraction of terms like "5 * t" to "5t" (not valid C code)
    if expr.head==:call && expr.args[1]==:* && length(expr.args)==3 && isa(expr.args[2], Real) && isa(expr.args[3], Symbol)
        push!(expr.args, 1)
    # Power operator does not exist in C, replace by multiplication or "pow"
    elseif expr.head==:call && expr.args[1]==:^
        @assert length(expr.args)==3 "Don't know how to handle ^ operation with <> 2 arguments"
        x = expr.args[2]
        n = expr.args[3]
        empty!(expr.args)
        # Replace by multiplication/division if
        #   x is a symbol and  n is a small integer
        #   x is a more complex expression and n is ±1
        #   n is exactly 0
        if (isa(n,Integer) && ((isa(x, Symbol) && abs(n) <= 3) || abs(n) <= 1)) || n==0
            if n >= 0
                append!(expr.args, [:*, fill(x, n)...])
                # fill up with factor 1 so this expr can still be a multiplication
                while length(expr.args) < 3
                    push!(expr.args, 1)
                end
            else # inverse of the above
                if n==-1
                    term = x
                else
                    term = :( ($(x)) ^ ($(-n)))
                    coperators(term)
                end
                append!(expr.args, [:/, 1., term])
            end
        #... otherwise use "pow" function
        else
            append!(expr.args, [:pow, x, n])
        end
    end
    expr
end


"""
Build function target: `CTarget`

```julia
_build_function(target::CTarget, eqs::Array{<:Equation}, args...;
                conv = toexpr, expression = Val{true},
                fname = :diffeqf,
                lhsname=:du,rhsnames=[Symbol("RHS\$i") for i in 1:length(args)],
                libpath=tempname(), compiler=:gcc)
```

This builds an in-place C function. Only works on arrays of equations. If
`expression == Val{false}`, then this builds a function in C, compiles it,
and returns a lambda to that compiled function. These special keyword arguments
control the compilation:

- libpath: the path to store the binary. Defaults to a temporary path.
- compiler: which C compiler to use. Defaults to `:gcc`, which is currently the
  only available option.
"""
function _build_function(target::CTarget, eqs::Array{<:Equation}, args...;
                         conv = toexpr, expression = Val{true},
                         fname = :diffeqf,
                         lhsname=:du,rhsnames=[Symbol("RHS$i") for i in 1:length(args)],
                         libpath=tempname(),compiler=:gcc)

    @warn "build_function(::Array{<:Equation}...) is deprecated. Use build_function(::AbstractArray...) instead."

    varnumbercache = buildvarnumbercache(args...)
    differential_equation = string(join([numbered_expr(eq,varnumbercache,args...,lhsname=lhsname,
                                  rhsnames=rhsnames,offset=-1) for
                                  (i, eq) ∈ enumerate(eqs)],";\n  "),";")

    argstrs = join(vcat("double* $(lhsname)",[typeof(args[i])<:AbstractArray ? "double* $(rhsnames[i])" : "double $(rhsnames[i])" for i in 1:length(args)]),", ")
    ex = """
    void $fname($(argstrs...)) {
      $differential_equation
    }
    """

    if expression == Val{true}
        return ex
    else
        @assert compiler == :gcc
        ex = build_function(eqs,args...;target=Symbolics.CTarget())
        open(`gcc -fPIC -O3 -msse3 -xc -shared -o $(libpath * "." * Libdl.dlext) -`, "w") do f
            print(f, ex)
        end
        drop_expr(@RuntimeGeneratedFunction(@__MODULE__,
                                            :((du::Array{Float64},u::Array{Float64},p::Array{Float64},t::Float64)
                                              -> ccall(("diffeqf", $libpath),
                                                       Cvoid, (Ptr{Float64},
                                                               Ptr{Float64},
                                                               Ptr{Float64},
                                                               Float64), du, u,
                                                               p, t)), false))
    end
end


"""
Build function target: `CTarget`

```julia
_build_function(target::CTarget, ex::AbstractArray, args...;
                columnmajor = true,
                conv        = toexpr,
                expression  = Val{true},
                fname       = :diffeqf,
                lhsname     = :du,
                rhsnames    = [Symbol("RHS\$i") for i in 1:length(args)],
                libpath     = tempname(),
                compiler    = :gcc)
```

This builds an in-place C function. Only works on expressions. If
`expression == Val{false}`, then this builds a function in C, compiles it,
and returns a lambda to that compiled function. These special keyword arguments
control the compilation:

- libpath: the path to store the binary. Defaults to a temporary path.
- compiler: which C compiler to use. Defaults to :gcc, which is currently the
  only available option.
"""
function _build_function(target::CTarget, ex::AbstractArray, args...;
                         columnmajor = true,
                         conv        = toexpr,
                         expression  = Val{true},
                         fname       = :diffeqf,
                         lhsname     = :du,
                         rhsnames    = [Symbol("RHS$i") for i in 1:length(args)],
                         libpath     = tempname(),
                         compiler    = :gcc)

    if !columnmajor
        return _build_function(target, hcat([row for row ∈ eachrow(ex)]...), args...;
                               columnmajor = true,
                               conv        = conv,
                               fname       = fname,
                               lhsname     = lhsname,
                               rhsnames    = rhsnames,
                               libpath     = libpath,
                               compiler    = compiler)
    end


    varnumbercache = buildvarnumbercache(args...)
    equations = Vector{String}()
    for col ∈ 1:size(ex,2)
        for row ∈ 1:size(ex,1)
            lhs = string(lhsname, "[", (col-1) * size(ex,1) + row-1, "]")
            rhs = numbered_expr(value(ex[row, col]), varnumbercache, args...;
                                lhsname  = lhsname,
                                rhsnames = rhsnames,
                                offset   = -1) |> coperators |> string  # Filter through coperators to produce valid C code in more cases
            push!(equations, string(lhs, " = ", rhs, ";"))
        end
    end

    argstrs = join(vcat("double* $(lhsname)",[typeof(args[i])<:AbstractArray ? "const double* $(rhsnames[i])" : "const double $(rhsnames[i])" for i in 1:length(args)]),", ")

    ccode = """
    #include <math.h>
    void $fname($(argstrs...)) {$([string("\n  ", eqn) for eqn ∈ equations]...)\n}
    """

    if expression == Val{true}
        return ccode
    else
        @assert compiler == :gcc
        open(`gcc -fPIC -O3 -msse3 -xc -shared -o $(libpath * "." * Libdl.dlext) -`, "w") do f
            print(f, ccode)
        end
        drop_expr(@RuntimeGeneratedFunction(@__MODULE__,
                                            :((du::Array{Float64},u::Array{Float64},p::Array{Float64},t::Float64)
                                              -> ccall(("diffeqf", $libpath),
                                                       Cvoid, (Ptr{Float64},
                                                               Ptr{Float64},
                                                               Ptr{Float64},
                                                               Float64), du, u,
                                                       p, t)), false))
    end

end
_build_function(target::CTarget, ex::Num, args...; kwargs...) = _build_function(target, [ex], args...; kwargs...)


"""
Build function target: `StanTarget`

```julia
_build_function(target::StanTarget, eqs::Array{<:Equation}, vs, ps, iv;
                conv = toexpr, expression = Val{true},
                fname = :diffeqf, lhsname=:internal_var___du,
                rhsnames=[:internal_var___u,:internal_var___p,:internal_var___t])
```

This builds an in-place Stan function compatible with the Stan differential equation solvers.
Unlike other build targets, this one requires `(vs, ps, iv)` as the function arguments.
Only allowed on arrays of equations.
"""
function _build_function(target::StanTarget, eqs::Array{<:Equation}, vs, ps, iv;
                         conv = toexpr, expression = Val{true},
                         fname = :diffeqf, lhsname=:internal_var___du,
                         rhsnames=[:internal_var___u,:internal_var___p,:internal_var___t])

    @warn "build_function(::Array{<:Equation}...) is deprecated. Use build_function(::AbstractArray...) instead."
    @assert expression == Val{true}

    varnumbercache = buildvarnumbercache(vs,ps...)
    par_str = join(["real $(rhsnames[2])_$i" for i in 1:length(ps)], ", ")
    rhsnames_mod = [:internal_var___u, [Symbol("$(rhsnames[2])_$i") for i in 1:length(ps)]..., :internal_var___t]
    differential_equation = string(join([numbered_expr(eq,varnumbercache,vs,ps,lhsname=lhsname,
                                   rhsnames=rhsnames_mod) for
                                   (i, eq) ∈ enumerate(eqs)],";\n  "),";")


    """
    vector $fname(real $(conv(iv)),vector $(rhsnames[1]), $par_str) {
      vector[$(length(eqs))] $lhsname;
      $differential_equation
      return $lhsname;
    }
    """
end

"""
Build function target: `StanTarget`

```julia
_build_function(target::StanTarget, ex::AbstractArray, vs, ps, iv;
                columnmajor = true,
                conv        = toexpr,
                expression  = Val{true},
                fname       = :diffeqf, lhsname=:internal_var___du,
                rhsnames    =  [:internal_var___u,:internal_var___p,:internal_var___t])
```

This builds an in-place Stan function compatible with the Stan differential equation solvers.
Unlike other build targets, this one requires `(vs, ps, iv)` as the function arguments.
Only allowed on expressions, and arrays of expressions.
"""
function _build_function(target::StanTarget, ex::AbstractArray, vs, ps, iv;
                         columnmajor = true,
                         conv        = toexpr,
                         expression  = Val{true},
                         fname       = :diffeqf, lhsname=:internal_var___du,
                         rhsnames    =  [:internal_var___u,:internal_var___p,:internal_var___t])

    @assert expression == Val{true}

    if !columnmajor
        return _build_function(target, hcat([row for row ∈ eachrow(ex)]...), vs, ps, iv;
                            columnmajor = true,
                            conv        = conv,
                            expression  = expression,
                            fname       = fname,
                            lhsname     = lhsname,
                            rhsnames    = rhsnames)
    end

    varnumbercache = buildvarnumbercache(vs,ps,iv)
    equations = Vector{String}()
    for col ∈ 1:size(ex,2)
        for row ∈ 1:size(ex,1)
            lhs = string(lhsname, "[", (col-1) * size(ex,1) + row, "]")
            rhs = numbered_expr(value(ex[row, col]), varnumbercache, vs, ps, iv;
                                lhsname  = lhsname,
                                rhsnames = rhsnames,
                                offset   = 0) |> string
            push!(equations, string(lhs, " = ", rhs, ";"))
        end
    end

    """
    vector $fname(real $(conv(iv)),vector $(rhsnames[1]),vector $(rhsnames[2])) {
      vector[$(length(equations))] $lhsname;
    $([eqn == equations[end] ? string("  ", eqn) : string("  ", eqn, "\n") for eqn ∈ equations]...)
      return $lhsname;
    }
    """
end
_build_function(target::StanTarget, ex::Num, vs, ps, iv; kwargs...) = _build_function(target, [ex], vs, ps, iv; kwargs...)

"""
Build function target: `MATLABTarget`

```julia
_build_function(target::MATLABTarget, eqs::Array{<:Equation}, args...;
                conv = toexpr, expression = Val{true},
                lhsname=:internal_var___du,
                rhsnames=[:internal_var___u,:internal_var___p,:internal_var___t])
```

This builds an out of place anonymous function `@(t,rhsnames[1])` to be used in MATLAB.
Compatible with the MATLAB differential equation solvers. Only allowed on expressions,
and arrays of expressions.
"""
function _build_function(target::MATLABTarget, eqs::Array{<:Equation}, args...;
                         conv = toexpr, expression = Val{true},
                         fname = :diffeqf, lhsname=:internal_var___du,
                         rhsnames=[:internal_var___u,:internal_var___p,:internal_var___t])

    @warn "build_function(::Array{<:Equation}...) is deprecated. Use build_function(::AbstractArray...) instead."
    @assert expression == Val{true}

    varnumbercache = buildvarnumbercache(args...)
    matstr = join([numbered_expr(eq.rhs,varnumbercache,args...,lhsname=lhsname,
                                  rhsnames=rhsnames) for
                                  (i, eq) ∈ enumerate(eqs)],"; ")

    matstr = replace(matstr,"["=>"(")
    matstr = replace(matstr,"]"=>")")
    matstr = "$fname = @($(rhsnames[3]),$(rhsnames[1])) ["*matstr*"];"
    matstr
end

"""
Build function target: `MATLABTarget`

```julia
_build_function(target::MATLABTarget, ex::AbstractArray, args...;
                columnmajor = true,
                conv        = toexpr,
                expression  = Val{true},
                fname       = :diffeqf,
                lhsname     = :internal_var___du,
                rhsnames    = [:internal_var___u,:internal_var___p,:internal_var___t])
```

This builds an out of place anonymous function @(t,rhsnames[1]) to be used in MATLAB.
Compatible with the MATLAB differential equation solvers. Only allowed on expressions,
and arrays of expressions.
"""
function _build_function(target::MATLABTarget, ex::AbstractArray, args...;
                         columnmajor = true,
                         conv        = toexpr,
                         expression  = Val{true},
                         fname       = :diffeqf,
                         lhsname     = :internal_var___du,
                         rhsnames    = [:internal_var___u,:internal_var___p,:internal_var___t])

    @assert expression == Val{true}

    if !columnmajor
        return _build_function(target, hcat([row for row ∈ eachrow(ex)]...), args...;
                               columnmajor = true,
                               conv        = conv,
                               expression  = expression,
                               fname       = fname,
                               lhsname     = lhsname,
                               rhsnames    = rhsnames)
    end

    varnumbercache = buildvarnumbercache(args...)
    matstr = ""
    for row ∈ 1:size(ex,1)
        row_strings = Vector{String}()
        for col ∈ 1:size(ex,2)
            lhs = string(lhsname, "[", (col-1) * size(ex,1) + row-1, "]")
            rhs = numbered_expr(value(ex[row, col]), varnumbercache, args...;
                                lhsname  = lhsname,
                                rhsnames = rhsnames,
                                offset   = 0) |> string
            push!(row_strings, rhs)
        end
        matstr = matstr * "  " * join(row_strings, ", ") * ";\n"
    end

    matstr = replace(matstr,"["=>"(")
    matstr = replace(matstr,"]"=>")")
    matstr = "$fname = @($(rhsnames[3]),$(rhsnames[1])) [\n"*matstr*"];\n"

    return matstr

end
_build_function(target::MATLABTarget, ex::Num, args...; kwargs...) = _build_function(target, [ex], args...; kwargs...)

:(function (ˍ₋out, x)
      begin
          ˍ₋out_1 = (view)(ˍ₋out, 2:5, 2:5)
          var"%ˍ₋out_1" = for var"%jj′" = (zip)(Base.OneTo(4), (Symbolics.reset_to_one)(Base.OneTo(4)))
                  begin
                      j = var"%jj′"[1]
                      j′ = var"%jj′"[2]
                      for var"%ii′" = (zip)(Base.OneTo(4), (Symbolics.reset_to_one)(Base.OneTo(4)))
                          begin
                              i = var"%ii′"[1]
                              i′ = var"%ii′"[2]
                              begin
                                  ˍ₋out_1[(CartesianIndex)(i′, j′)] = (+)((getindex)(ˍ₋out_1, i′, j′), (getindex)(x, j, i))
                                  nothing
                              end
                          end
                      end
                  end
              end
          nothing
      end
  end)

using Symbolics
using Symbolics: unwrap, operation, symtype
using Test

@variables x y

# A registered function that errors if it is ever actually evaluated. Used to detect whether
# the untaken branch of a conditional is being evaluated by generated code.
boom(v) = error("untaken branch was evaluated: boom($v)")
Symbolics.@register_symbolic boom(v)

@testset "Construction and operation identity" begin
    @test operation(unwrap(ifelse_eager(x > 0, x^2, 1 / x))) === ifelse_eager
    @test operation(unwrap(ifelse_branching(x > 0, x^2, 1 / x))) === ifelse_branching

    # condition must be Bool-typed, branches share type/shape with `ifelse`
    @test symtype(unwrap(ifelse_branching(x > 0, x, y))) ==
          symtype(unwrap(ifelse(x > 0, x, y)))

    # literal condition folds to the taken branch (matches `ifelse`)
    @test isequal(ifelse_branching(true, x, 1 / x), x)
    @test isequal(ifelse_eager(false, 1 / x, x), x)

    # literal (non-symbolic) branches are allowed
    @test operation(unwrap(ifelse_branching(x > 0, x, 5))) === ifelse_branching
    @test operation(unwrap(ifelse_eager(x > 0, 5, x))) === ifelse_eager
end

@testset "Both variants match `ifelse` numerically on valid inputs" begin
    for op in (ifelse_eager, ifelse_branching)
        f = build_function(op(x > 0, x^2, -x), x; expression = Val{false})
        @test f(3.0) == 9.0
        @test f(-3.0) == 3.0
    end
end

@testset "ifelse_branching does not evaluate the untaken branch" begin
    for cse in (true, false)
        f = build_function(
            ifelse_branching(x > 0, x^2 + 3x, boom(x)), x;
            expression = Val{false}, cse = cse
        )
        @test f(2.0) == 10.0          # takes the valid branch, `boom` never runs
        g = build_function(
            ifelse_branching(x > 0, boom(x), 1 / x), x;
            expression = Val{false}, cse = cse
        )
        @test g(-2.0) == -0.5
    end
end

# Counts how many times it is evaluated; used to detect duplicated computation.
const FIRE_COUNT = Ref(0)
fire(v) = (FIRE_COUNT[] += 1; v)
Symbolics.@register_symbolic fire(v)

@testset "multiply-referenced ifelse_branching is computed once under CSE" begin
    z = ifelse_branching(x > 0, fire(x)^2, boom(x))
    f = build_function(sin(z) + cos(z), x; expression = Val{false}, cse = true)
    FIRE_COUNT[] = 0
    @test f(2.0) == sin(4.0) + cos(4.0)
    @test FIRE_COUNT[] == 1     # the shared `if`/`else` ran once; `boom` not at all

    fvec = build_function([sin(z), cos(z)], x; expression = Val{false}, cse = true)[1]
    FIRE_COUNT[] = 0
    @test fvec(2.0) == [sin(4.0), cos(4.0)]
    @test FIRE_COUNT[] == 1
end

@testset "ifelse_eager evaluates both branches" begin
    for cse in (true, false)
        f = build_function(
            ifelse_eager(x > 0, x^2, boom(x)), x;
            expression = Val{false}, cse = cse
        )
        @test_throws ErrorException f(2.0)
    end
end

@testset "Nested and vector-valued conditionals stay lazy" begin
    f = build_function(
        ifelse_branching(x > 0, ifelse_branching(y > 0, x + y, boom(x)), boom(y)),
        x, y; expression = Val{false}, cse = true
    )
    @test f(2.0, 5.0) == 7.0

    fvec = build_function(
        [ifelse_branching(x > 0, x, boom(x)), 2y], x, y;
        expression = Val{false}, cse = true
    )[1]
    @test fvec(4.0, 3.0) == [4.0, 6.0]
end

@testset "Differentiation preserves the conditional variant" begin
    for op in (ifelse_eager, ifelse_branching)
        d = Symbolics.derivative(op(x > 0, x^2, x^3), x)
        @test operation(unwrap(d)) === op
        df = build_function(d, x; expression = Val{false})
        @test df(2.0) == 4.0        # d/dx x^2 = 2x
        @test df(-2.0) == 12.0      # d/dx x^3 = 3x^2
    end

    # the derivative of a branching conditional is itself lazy
    d = Symbolics.derivative(ifelse_branching(x > 0, x^2, boom(x)), x)
    df = build_function(d, x; expression = Val{false}, cse = true)
    @test df(2.0) == 4.0
end

@testset "substitute preserves the conditional variant" begin
    for op in (ifelse_eager, ifelse_branching)
        s = substitute(op(x > 0, x^2, 1 / x), Dict(x => y))
        @test operation(unwrap(s)) === op
    end
end

@testset "Lowering forms" begin
    @test Symbolics.toexpr(unwrap(ifelse_branching(x > 0, x, 1 / x))).head === :if
    @test Symbolics.toexpr(unwrap(ifelse_eager(x > 0, x, 1 / x))).head === :call

    # the eager call appears verbatim, the branching one as an `if`
    eager_code = build_function(ifelse_eager(x > 0, x, 1 / x), x; expression = Val{true})
    @test occursin("ifelse", string(eager_code))
    branch_code = string(build_function(
        ifelse_branching(x > 0, x, 1 / x), x; expression = Val{true}))
    @test occursin("if", branch_code)
end

@testset "Mixed scalar/array branches dispatch unambiguously" begin
    @variables v[1:3] complex_v[1:3]::Complex
    for op in (ifelse, ifelse_eager, ifelse_branching)
        # same-shape array branches build fine
        @test operation(unwrap(op(x > 0, v, v))) === op
        result = op(x > 0, v, complex_v)
        @test result isa Symbolics.Arr{Complex{Num}, 1}
        @test operation(unwrap(result)) === op
        # mismatched scalar/array branches are shape-invalid: dispatch resolves to a
        # concrete method that then raises a shape error, rather than an ambiguity MethodError
        @test_throws ErrorException op(x > 0, x, v)
        @test_throws ErrorException op(x > 0, v, x)
    end
end

@testset "Non-Bool condition is rejected" begin
    # a non-Bool scalar condition with symbolic branches has no applicable method and errors
    @test_throws Exception ifelse_eager(1, x, y)
    @test_throws Exception ifelse_branching(1, x, y)
end

@testset "Sparsity detection matches `ifelse`" begin
    ref = Symbolics.hessian_sparsity(ifelse(x > 0, x^2 + y, x * y), [x, y])
    for op in (ifelse_eager, ifelse_branching)
        @test Symbolics.hessian_sparsity(op(x > 0, x^2 + y, x * y), [x, y]) == ref
    end
    refj = Symbolics.jacobian_sparsity([ifelse(x > 0, x * y, y)], [x, y])
    for op in (ifelse_eager, ifelse_branching)
        @test Symbolics.jacobian_sparsity([op(x > 0, x * y, y)], [x, y]) == refj
    end
end

using Symbolics: scalarize
using Symbolics
using ReferenceTests
using Test
using SymbolicUtils.Code: toexpr, LiteralExpr
import ..limit2

_repr(x) = repr(toexpr(LiteralExpr(x)) |> Base.remove_linenums!)
function test_funcs(name, f, args...; broken=false)
    outplace, inplace = build_function(f, args...; checkbounds = true)
    if broken
        @test_broken open(x->read(x, String), "build_function_tests/$name-outplace.jl") == _repr(outplace)
        @test_broken open(x->read(x, String), "build_function_tests/$name-inplace.jl") == _repr(outplace)
    else
        @test_reference "build_function_tests/$name-outplace.jl" _repr(outplace)
        @test_reference "build_function_tests/$name-inplace.jl" _repr(inplace)
    end
end

@testset "array codegen basics" begin
    @variables x[1:4, 1:4]

    broken = VERSION < v"1.7"
    # Simple test with ArrayOp and no term
    test_funcs("transpose", @arrayop((i, j), x[j, i]), x)

    # Simple test with ArrayOp and Term
    test_funcs("transpose-term", @arrayop((i, j), x[j, i], term=x'), x)

    # Partial view set to an arrayop
    @makearray y[1:6, 1:6] begin
        y[2:end-1, 2:end-1] => @arrayop (i, j) x[j, i]
    end
    @test isequal(scalarize(y[2,3]), x[2,1])
    @test isequal(scalarize(y[3,2]), x[1,2])

    # Test UndefRef is thrown
    @test_throws UndefRefError scalarize(y[1,1])

    test_funcs("stencil-transpose-arrayop", y, x)

    # Fill zero
    @makearray y[1:6, 1:6] begin
        y[:, :] => 0
        y[2:end-1, 2:end-1] => x .+ x' .+ 1
    end

    @test iszero(scalarize(y[1,1]))

    test_funcs("stencil-broadcast", y, x)

    @variables x[1:5, 1:5]
    @makearray y[1:5, 1:5] begin
        y[:, :] => 0
        y[2:end-1, 2:end-1] => @arrayop (i, j) (x[i+1,j] + x[i-1, j] + x[i, j+1] + x[i, j-1])/2
    end

    @test iszero(scalarize(y[1,1]))
    test_funcs("stencil-extents", y, x)

    @variables u[1:5, 1:5]
    n = 5
    y = @arrayop (i, j) u[limit2(i-1, n), limit2(j+1,n)] i in 1:n j in 1:n
    test_funcs("manual-limits", y, u)

    z = @arrayop (i, j) y[j, i]
    test_funcs("intermediate-exprs", z, u)
end

"""
    @register_symbolic(expr, define_promotion = true, Ts = [Real])

Overload appropriate methods so that Symbolics can stop tracing into the
registered function. If `define_promotion` is true, then a promotion method in
the form of
```julia
SymbolicUtils.promote_symtype(::typeof(f_registered), args...) = Real # or the annotated return type
```
is defined for the register function. Note that when defining multiple register
overloads for one function, all the rest of the registers must set
`define_promotion` to `false` except for the first one, to avoid method
overwriting.

# Examples
```julia
@register_symbolic foo(x, y)
@register_symbolic foo(x, y::Bool) false # do not overload a duplicate promotion rule
@register_symbolic goo(x, y::Int) # `y` is not overloaded to take symbolic objects
@register_symbolic hoo(x, y)::Int # `hoo` returns `Int`
```
See `@register_array_symbolic` to register functions which return arrays.
"""
macro register_symbolic(expr, define_promotion = true, wrap_arrays = true)
    f, ftype, argnames, Ts, ret_type = destructure_registration_expr(expr)

    args′ = map((a, T) -> :($a::$T), argnames, Ts)
    ret_type = isnothing(ret_type) ? Real : ret_type
    N = length(args′)
    symbolicT = Union{BasicSymbolic{VartypeT}, AbstractArray{BasicSymbolic{VartypeT}}}
    inner = :(function $f($(args′...))
        args = ($(argnames...),)
        if Base.Cartesian.@nany $N i -> args[i] isa $symbolicT
            args = Base.Cartesian.@ntuple $N i -> $Const{$VartypeT}(args[i])
            $Term{$VartypeT}($f, $(SymbolicUtils.ArgsT){$VartypeT}(args); type = $ret_type, shape = $(SymbolicUtils.ShapeVecT()))
        else
            $f($(argnames...))
        end
    end)
    fexpr = wrap_func_expr(__module__, inner, wrap_arrays)

    if define_promotion
        type_args = [:($name::$Type) for name in argnames]
        T = type_T_tag(f,argnames)
        promote_expr = quote
            if $ftype === DataType || $ftype === Union || $ftype === UnionAll
                function (::$typeof($promote_symtype))(::Type{$T}, $(type_args...)) where {$T <: $f}
                    $ret_type
                end
                function (::$(typeof(SymbolicUtils.promote_shape)))(::Type{$T}, args::$(SymbolicUtils.ShapeT)...) where {$T <: $f}
                    @nospecialize args
                    $(SymbolicUtils.ShapeVecT)()
                end
            else
                (::$typeof($promote_symtype))(::$ftype, $(type_args...)) = $ret_type
                function (::$(typeof(SymbolicUtils.promote_shape)))(::$ftype, args::$(SymbolicUtils.ShapeT)...)
                    @nospecialize args
                    $(SymbolicUtils.ShapeVecT)()
                end
            end
        end
        fexpr = :($fexpr; $promote_expr)
    end
    esc(fexpr)
end

function destructure_registration_expr(expr)
    if expr.head === :(::)
        ret_type = expr.args[2]
        expr = expr.args[1]
    else
        ret_type = nothing
    end
    @assert expr.head === :call

    f = expr.args[1]
    args = expr.args[2:end]

    # Default arg types to Real
    Ts = map(a -> a isa Symbol ? Real : (@assert(a.head == :(::)); a.args[2]), args)
    argnames = map(a -> a isa Symbol ? a : a.args[1], args)

    ftype = if f isa Expr && f.head == :(::)
        if length(f.args) == 1
            error("please name the callable object, i.e. use (f::$(f.args[end])) instead of $f")
        end
        @assert length(f.args) == 2
        f.args[end]
    else
        :($typeof($f))
    end
    f, ftype, argnames, Ts, ret_type
end

function type_T_tag(f,argnames)
    T = :T
    for i in 1:length(argnames) + 1
        if T == f || T in argnames
            T = Symbol(:_,T)
        else
            break
        end
    end
    return T
end

nested_unwrap(x) = unwrap(x)
nested_unwrap(x::Arr) = unwrap(x)
nested_unwrap(x::AbstractArray) = unwrap.(x)

function is_symbolic_or_array_of_symbolic(x)
    return issym(x) || iscall(x)
end
function is_symbolic_or_array_of_symbolic(arr::AbstractArray)
    return any(is_symbolic_or_array_of_symbolic.(arr))
end

symbolic_eltype(x) = eltype(x)
symbolic_eltype(x::AbstractArray{BasicSymbolic{T}}) where {T} = eltype(symtype(Const{T}(x)))
symbolic_eltype(::AbstractArray{Num}) = Real
symbolic_eltype(::AbstractArray{symT}) where {eT, symT <: Arr{eT}} = eT

function register_array_symbolic(f, ftype, argnames, Ts, ret_type, partial_defs = :(), define_promotion = true, wrap_arrays = true, caller = @__MODULE__)
    def_assignments = MacroTools.rmlines(partial_defs).args
    defs = map(def_assignments) do ex
        @assert ex.head == :(=)
        ex.args[1] => ex.args[2]
    end |> Dict

    shape_expr = if haskey(defs, :size)
        quote
            sz = $(defs[:size])
            nd = length(sz)
            sh = $(SymbolicUtils.ShapeVecT)(map(Base.UnitRange{Int} ∘ Base.OneTo, sz))
        end
    else
        quote
            nd = $(get(defs, :ndims, -1))
            sh = $(SymbolicUtils.Unknown)(nd)
        end
    end
    eltype_expr = get(defs, :eltype, Any)
    container_type = get(defs, :container_type, Array)

    args′ = map((a, T) -> :($a::$T), argnames, Ts)
    N = length(args′)
    symbolicT = Union{BasicSymbolic{VartypeT}, AbstractArray{BasicSymbolic{VartypeT}}}
    assigns = macroexpand(@__MODULE__, :(Base.Cartesian.@nexprs $N i -> ($argnames[i] = args[i])))
    inner = :(function $f($(args′...))
        args = ($(argnames...),)
        if Base.Cartesian.@nany $N i -> args[i] isa $symbolicT
            args = Base.Cartesian.@ntuple $N i -> $Const{$VartypeT}(args[i])
            $assigns
            $shape_expr
            eltype = $eltype ∘ $symtype
            type = if nd == -1
                $container_type{$eltype_expr}
            else
                $container_type{$eltype_expr, nd}
            end
            $Term{$VartypeT}($f, $(SymbolicUtils.ArgsT){$VartypeT}(args); type, shape = sh)
        else
            $f($(argnames...))
        end
    end)
    fexpr = wrap_func_expr(caller, inner, wrap_arrays)

    if define_promotion
        is_callable_struct = f isa Expr && f.head == :(::)
        fn_arg = if is_callable_struct
            f
        else
            :(f::$ftype)
        end
        fn_arg_name = if is_callable_struct
            f.args[1]
        else
            :f
        end

        shape_args = [:($name::$(SymbolicUtils.ShapeT)) for name in argnames]
        type_args = [:($name::$Type) for name in argnames]
        promote_symtype_body = quote
            f = $fn_arg_name
            container_type = $container_type
            nd = $(get(defs, :ndims, -1))
            etype = $eltype_expr
            if nd == -1
                return container_type{etype}
            else
                return container_type{etype, nd}
            end
        end
        promote_shape_body = quote
            @nospecialize $(argnames...)
            size = identity
            $shape_expr
            return sh
        end
        T = type_T_tag(f,argnames)
        promote_expr = quote
            if $ftype === DataType || $ftype === Union || $ftype === UnionAll
                function (::$typeof($promote_symtype))(::Type{$T}, $(type_args...)) where {$T <: $f}
                    $promote_symtype_body
                end
                function (::$(typeof(SymbolicUtils.promote_shape)))(::Type{$T}, $(shape_args...)) where {$T <: $f}
                    $promote_shape_body
                end
            else
                function (::$typeof($promote_symtype))($fn_arg, $(type_args...))
                    $promote_symtype_body
                end
                function (::$(typeof(SymbolicUtils.promote_shape)))($fn_arg, $(shape_args...))
                    $promote_shape_body
                end
            end
        end
        fexpr = :($fexpr; $promote_expr)
    end

    return fexpr
end

"""
    @register_array_symbolic(expr, define_promotion = true)

Example:

```julia
# Let's say vandermonde takes an n-vector and returns an n x n matrix
@register_array_symbolic vandermonde(x::AbstractVector) begin
    size=(length(x), length(x))
    eltype=eltype(x) # optional, will default to the promoted eltypes of x
end
```

You can also register calls on callable structs:

```julia
@register_array_symbolic (c::Conv)(x::AbstractMatrix) begin
    size=size(x) .- size(c.kernel) .+ 1
    eltype=promote_type(eltype(x), eltype(c))
end
```

If `define_promotion = true` then a promotion method in the form of
```julia
SymbolicUtils.promote_symtype(::typeof(f_registered), args...) = # inferred or annotated return type
```

is defined for the register function. Note that when defining multiple register
overloads for one function, all the rest of the registers must set
`define_promotion` to `false` except for the first one, to avoid method
overwriting.
"""
macro register_array_symbolic(expr, block, define_promotion = true, wrap_arrays = true)
    f, ftype, argnames, Ts, ret_type = destructure_registration_expr(expr)
    esc(register_array_symbolic(f, ftype, argnames, Ts, ret_type, block, define_promotion, wrap_arrays, __module__))
end

using ForwardDiff, SparseArrays, Symbolics, PreallocationTools, Test
# Test Nesting https://discourse.julialang.org/t/preallocationtools-jl-with-nested-forwarddiff-and-sparsity-pattern-detection-errors/107897

function foo(x, cache)
    d = get_tmp(cache, x)

    d[:] = x

    0.5 * x'*x
end

function residual(r, x, cache)
    function foo_wrap(x)
        foo(x, cache)
    end

    r[:] = ForwardDiff.gradient(foo_wrap, x)
end

cache = DiffCache(zeros(2))
pattern = Symbolics.jacobian_sparsity((r, x) -> residual(r, x, cache), zeros(2), zeros(2))
@test pattern == sparse([1 0
                         0 1])

@testset "symbolic dual cache methods" begin
    dual_type = ForwardDiff.Dual{Nothing, Num, 2}
    dual = dual_type(Num(1), ForwardDiff.Partials((Num(1), Num(0))))
    duals = fill(dual, 2)

    for cache in (DiffCache(zeros(2)), FixedSizeDiffCache(zeros(2), 2))
        for input in (dual, dual_type, duals)
            workspace = get_tmp(cache, input)
            workspace .= duals
            @test get_tmp(cache, input) == duals
        end
    end
end

import SpecialFunctions
import Base.Broadcast

const linearity_map_1 = IdDict{Function, Bool}()
const linearity_map_2 = IdDict{Function, Tuple{Bool, Bool, Bool}}()

# 1-arg
const monadic_linear = [deg2rad, +, rad2deg, transpose, -, conj]

const monadic_nonlinear = [asind, log1p, acsch, erfc, digamma, acos, asec, acosh, airybiprime, acsc, cscd, log, tand, log10, csch, asinh, airyai, abs2, gamma, lgamma, erfcx, bessely0, cosh, sin, cos, atan, cospi, cbrt, acosd, bessely1, acoth, erfcinv, erf, dawson, inv, acotd, airyaiprime, erfinv, trigamma, asecd, besselj1, exp, acot, sqrt, sind, sinpi, asech, log2, tan, invdigamma, airybi, exp10, sech, erfi, coth, asin, cotd, cosd, sinh, abs, besselj0, csc, tanh, secd, atand, sec, acscd, cot, exp2, expm1, atanh, slog, ssqrt, scbrt]

for f in monadic_linear
    linearity_map_1[f] = true
end

for f in monadic_nonlinear
    linearity_map_1[f] = false
end

# 2-arg
for f in [+, rem2pi, -, >, isless, <, isequal, max, min, convert, <=, >=]
    linearity_map_2[f] = (true, true, true)
end

for f in [*]
    linearity_map_2[f] = (true, true, false)
end

for f in [/]
    linearity_map_2[f] = (true, false, false)
end
for f in [\]
    linearity_map_2[f] = (false, true, false)
end

for f in [hypot, atan, mod, rem, lbeta, ^, beta]
    linearity_map_2[f] = (false, false, false)
end

# Fallback assumption: Function is not linear, i.e., derivatives are non-zero 
linearity_1(@nospecialize(f)) = get(linearity_map_1, f, false)
linearity_2(@nospecialize(f)) = get(linearity_map_2, f, (false, false, false))

# TermCombination datastructure

struct TermCombination
    terms::Set{Dict{Int, Int}} # idx => pow
end

@eval Base.one(::Type{TermCombination}) = $(TermCombination(Set([Dict{Int,Int}()])))
@eval Base.zero(::Type{TermCombination}) = $(TermCombination(Set{Dict{Int,Int}}()))

#=
function Base.:(==)(comb1::TermCombination, comb2::TermCombination)
    comb1.terms == comb2.terms && return true

    n1 = reduce(max, (k for (k,_) in Iterators.flatten(comb1.terms)), init=0)
    n2 = reduce(max, (k for (k,_) in Iterators.flatten(comb2.terms)), init=0)
    n = max(n1, n2)

    _sparse(comb1, n) == _sparse(comb2, n)
end
=#

# to make Mul and Add work
function Base.:^(comb::TermCombination, ::Number)
    isone(comb) && return comb
    iszero(comb) && return _scalar
    return comb *  comb
end

function Base.:+(comb1::TermCombination, comb2::TermCombination)
    if isone(comb1) && !iszero(comb2)
        return comb2
    elseif isone(comb2) && !iszero(comb1)
        return comb1
    elseif comb1 === comb2
        return comb1
    end
    TermCombination(union(comb1.terms, comb2.terms))
end

Base.:+(comb1::TermCombination) = comb1

function _merge(dict1, dict2)
    d = copy(dict1)
    for (k, v) in dict2
        d[k] = min(2, get(dict1, k, 0) + v)
    end
    d
end

function Base.:*(comb1::TermCombination, comb2::TermCombination)
    if isone(comb1)
        return comb2
    elseif isone(comb2)
        return comb1
    elseif comb1 === comb2 # squaring optimization
        terms = comb1.terms
        # turns out it's enough to track
        # a^2*b^2
        # and a^2 + b^2 + ab
        # have the same hessian sparsity
        t = Dict(k=>2 for (k,_) in
                 Iterators.flatten(terms))
        TermCombination(Set([t]))
        #=
        # square each term
        t1 = [Dict(k=>2 for (k,_) in dict)
              for dict in comb1.terms]
        # multiply each term
        t2 = Dict{Int,Int}[]
        for i in 1:length(terms)
            for j in i+1:length(terms)
                push!(t2, _merge(terms[i], terms[j]))
            end
        end
        TermCombination(union(t1, t2))
        =#
    else
        Set([_merge(dict1, dict2)
             for dict1 in comb1.terms,
             dict2 in comb2.terms]) |> TermCombination
    end
end
Base.:*(comb1::TermCombination) = comb1
Base.iszero(c::TermCombination) = isempty(c.terms)
Base.isone(c::TermCombination) = all(isempty, c.terms)

function _sparse(t::TermCombination, n)
    I = Int[]
    J = Int[]
    for dict in t.terms
        kv = collect(pairs(dict))
        for i in 1:length(kv)
            k, v = kv[i]
            if v>=2
                push!(I, k)
                push!(J, k)
            end
            for j in i+1:length(kv)
                if v >= 1 && kv[j][2] >= 1
                    push!(I, k)
                    push!(J, kv[j][1])
                end
            end
        end
    end
    s1 = sparse(I,J,fill!(BitVector(undef, length(I)), true),n,n)
    s1 .| s1'
end

_sparse(x::Number, n) = sparse(Int[],Int[],Int[],n,n)

# 1-arg functions
combine_terms_1(lin, term) = lin ? term : term * term

# 2-arg functions
function combine_terms_2(linearity, term1, term2)

    linear11, linear22, linear12 = linearity
    term = zero(TermCombination)
    if linear11
        if !linear12
            term += term1
        end
    else
        term += term1 * term1
    end

    if linear22
        if !linear12
            term += term2
        end
    else
        term += term2 * term2
    end

    if linear12
        term += term1 + term2
    else
        term += term1 * term2
    end
    term
end

function combine_terms_ifelse_affine(cond, iftrue, iffalse)
    return cond * cond + iftrue + iffalse
end

struct __Despecialize1 end
struct __Despecialize2 <: Real end
struct __Despecialize3 <: AbstractVector{Int} end

hide_lhs(::__Despecialize1) = false
hide_lhs(::__Despecialize2) = false
hide_lhs(::__Despecialize3) = false

"""
    NAMESPACE_SEPARATOR

Character used to separate nested symbolic names when Symbolics displays a
namespace-qualified variable.

The separator is `₊` and is used by variable construction and display code.
"""
const NAMESPACE_SEPARATOR = '₊'

hide_lhs(_) = false

"""
$(TYPEDEF)

An equality relationship between two expressions.

# Fields
$(FIELDS)
"""
struct Equation
    """The expression on the left-hand side of the equation."""
    lhs::BasicSymbolic{VartypeT}
    """The expression on the right-hand side of the equation."""
    rhs::BasicSymbolic{VartypeT}
    function Equation(lhs, rhs)
        new(unwrap(lhs), unwrap(rhs))
    end
end
Base.:(==)(a::Equation, b::Equation) = isequal(a.lhs, b.lhs) && isequal(a.rhs, b.rhs)
Base.hash(a::Equation, salt::UInt) = hash(a.lhs, hash(a.rhs, salt))

function Base.show(io::IO, eq::Equation)
    warn_load_latexify()
    if hide_lhs(unwrap_const(eq.lhs))::Bool
        show(io, unwrap_const(eq.rhs))
    else
        print(io, eq.lhs, " ~ ", eq.rhs)
    end
end

SymbolicUtils.scalarize(eq::Equation, args...) = scalarize(eq.lhs, args...) .~ scalarize(eq.rhs, args...)
SymbolicUtils.simplify(x::Equation; kw...) = simplify(x.lhs; kw...) ~ simplify(x.rhs; kw...)
function (s::SymbolicUtils.Substituter)(eq::Equation)
    s(eq.lhs) ~ s(eq.rhs)
end

lhss(xs) = map(x->x.lhs, xs)
rhss(xs) = map(x->x.rhs, xs)

"""
$(TYPEDSIGNATURES)

Create an [`Equation`](@ref) out of two [`Num`](@ref) instances, or an
`Num` and a `Number`.

# Examples

```jldoctest
julia> using Symbolics

julia> @variables x y;

julia> @variables A[1:3, 1:3] B[1:3, 1:3];

julia> x ~ y
x ~ y

julia> x - y ~ 0
x - y ~ 0

julia> A ~ B
A ~ B

julia> A .~ 3x
(broadcast(~, A, 3x))[1:3,1:3]
```
"""
function Base.:~(lhs, rhs)
    if (isarraysymbolic(lhs) || isarraysymbolic(rhs)) && ((sl = size(lhs)) != (sr = size(rhs)))
        throw(ArgumentError("Cannot equate an array of different sizes. Got $sl and $sr."))
    else
        Equation(lhs, rhs)
    end
end
for T in [:Num, :Complex, :Number], S in [:Num, :Complex, :Number]
    (T != :Complex && S != :Complex) && continue
    @eval Base.:~(a::$T, b::$S) = let ar = value(real(a)), br = value(real(b)),
                                      ai = value(imag(a)), bi = value(imag(b))
        if ar isa Number && br isa Number && ai isa Number && bi isa Number
            error("Equation $a ~ $b does not contain any symbols")
        elseif ar isa Number && br isa Number
            ai ~ bi
        elseif ai isa Number && bi isa Number
            ar ~ br
        else
            [ar ~ br
            ai ~ bi]
        end
    end
end

canonical_form(eq::Equation) = eq.lhs - eq.rhs ~ 0

function SymbolicUtils.search_variables!(buffer, eq::Equation; kw...)
    SymbolicUtils.search_variables!(buffer, eq.lhs; kw...)
    SymbolicUtils.search_variables!(buffer, eq.rhs; kw...)
end

function expand_derivatives(eq::Equation, simplify=false)
    return Equation(expand_derivatives(eq.lhs, simplify), expand_derivatives(eq.rhs, simplify))
end

using Symbolics: diff2term, value
using ModelingToolkit
using Test

# Test diff2term basic functionality (unit-specific tests removed as API changed in MTK v11)

@variables x y t
D = Differential(t)
# Test simple variable derivative
@test Symbolics.diff2term(D(x)) isa Num

@variables x(t)[1:2] p[1:2, 1:2]
@test ModelingToolkit.is_diff_equation(D(x) ~ p*x)

struct FunctionUnimplementedError <: Exception
    type::String
end

function Base.showerror(io::IO, err::FunctionUnimplementedError)
    print(io, "The $(err.type) version for this function is invalid")
end

function get_unimplemented_fn(nargs, type)
    expr = :(function unimplemented()
        throw($FunctionUnimplementedError($type))
     end)

    for i in 1:nargs
        push!(expr.args[1].args, Symbol(:x, i))
    end
    return expr
end

const IIP_OUTSYM = only(@syms $DEFAULT_OUTSYM::Any)
const IIP_ALLOCATOR = SU.Term{VartypeT}(
    Returns, SArgsT((IIP_OUTSYM,));
    type = FnType{Tuple, Any, Returns{Any}}, shape = SU.ShapeVecT()
)

function canonicalize_args(args::Vector, inbounds::Bool)
    return map(enumerate(args)) do (i, arg)
        if arg isa Arr
            unwrap(arg)
        elseif arg isa AbstractArray
            DestructuredArgs(map(unwrap, arg), default_arg_name(i); inbounds, create_bindings = false)
        elseif arg isa Union{Tuple, NamedTuple}
            DestructuredArgs(map(unwrap, collect(arg)), default_arg_name(i); inbounds, create_bindings = false)
        else
            unwrap(arg)
        end
    end
end

"""
    CodegenFunctionOptions(; kwargs...)

Bundle of options controlling code generation in [`codegen_function`](@ref).

Historically `codegen_function` accepted these as a `kwargs...` splat. Threading a
`kwargs...` bundle means every function that forwards codegen options gets specialized (and
recompiled) once per distinct *set* of keyword arguments, even when the values it forwards
are irrelevant to it. `CodegenFunctionOptions` is a single, non-parametric concrete type: no matter
which options are set, its type is always `CodegenFunctionOptions`, so functions that thread it
through only need to be compiled once.

The keyword constructor mirrors the historical keyword arguments of `codegen_function`
exactly, including their defaults. Unknown keyword arguments are ignored (as they were
previously silently dropped by `codegen_function`), preserving backwards compatibility.

Fields:

- `nanmath`: rewrite math functions to their `NaN`-safe variants.
- `wrap_code`: a 2-tuple of transformations applied to the out-of-place and in-place
  `Func`s respectively.
- `checkbounds`: emit bounds checks (when `false`, generated code is wrapped in
  `@inbounds`).
- `iip_config`: a 2-tuple of `Bool`s indicating whether to generate the out-of-place and
  in-place functions respectively.
- `sort_addmul`: sort the arguments of `+`/`*` for deterministic codegen.
- `optimize`: optimization rules to apply, or `nothing`.
- `similarto`: the array type (or name) to generate for array outputs, or `nothing` to
  infer it.
- `outputidxs`: explicit output indices for in-place array codegen, or `nothing`.
- `skipzeros`: skip writing structural zeros in in-place array codegen.
"""
struct CodegenFunctionOptions
    nanmath::Bool
    wrap_code::Tuple
    checkbounds::Bool
    iip_config::NTuple{2, Bool}
    sort_addmul::Bool
    optimize::Any
    similarto::Any
    outputidxs::Any
    skipzeros::Bool
end

function CodegenFunctionOptions(;
        nanmath::Bool = true, wrap_code::Tuple = (identity, identity),
        checkbounds = false, iip_config::NTuple{2, Bool} = (true, true),
        sort_addmul = false, optimize = nothing, similarto = nothing,
        outputidxs = nothing, skipzeros = false, kwargs...
    )
    return CodegenFunctionOptions(
        nanmath, wrap_code, checkbounds, iip_config, sort_addmul, optimize,
        similarto, outputidxs, skipzeros
    )
end

"""
    codegen_function(ir, expr, args[, options])
    codegen_function(ir, expr, args; kwargs...)

Generate out-of-place and in-place Julia function expressions for `expr` using a
`SymbolicUtils.IRStructure`. `args` is a vector whose elements describe each generated function
argument as either a scalar symbolic value or a collection of symbolic values.

Pass a [`CodegenFunctionOptions`](@ref) as `options`, or pass the same settings as keyword
arguments. The result is a 2-tuple containing the out-of-place and in-place function
expressions. The requested `iip_config` and the shape of `expr` determine which variants are
implemented.

This is the low-level code-generation interface for consumers that already maintain a
`SymbolicUtils.IRStructure`. Prefer [`build_function`](@ref) when starting from ordinary symbolic
expressions.
"""
function codegen_function(ir::IRStructure{VartypeT}, expr, args::Vector; kwargs...)
    return codegen_function(ir, expr, args, CodegenFunctionOptions(; kwargs...))
end

function codegen_function(
        ir::IRStructure{VartypeT}, expr, args::Vector, opts::CodegenFunctionOptions
    )
    (; nanmath, wrap_code, checkbounds, iip_config, sort_addmul, optimize) = opts
    args = canonicalize_args(args, !checkbounds)
    rewrites = Dict()
    if nanmath
        rewrites[:nanmath] = true
    end
    rewrites[:sort_addmul] = sort_addmul

    ir, expr = Code.apply_optimization_rules(ir, expr, optimize)

    if iip_config[1]
        oopfn = wrap_code[1](Func(args, [], expr))
        oop = Code.fast_toexpr(oopfn, ir, rewrites)
        if !checkbounds
            @assert Meta.isexpr(oop, :function)
            oop.args[2] = Expr(
                :macrocall, nameof(var"@inbounds"), LineNumberNode(0),
                Expr(:block, oop.args[2])
            )
        end
    else
        oop = get_unimplemented_fn(length(args), "out-of-place")
    end
    if iip_config[2] && SU.is_array_shape(SU.shape(expr))
        expr = SConst(expr)
        iipexpr = if Code.supports_with_allocator(expr)
            Code.with_allocator(IIP_ALLOCATOR, expr)
        else
            SU.Term{VartypeT}(
                copyto!, SArgsT((IIP_OUTSYM, expr));
                type = SU.symtype(expr), shape = SU.shape(expr)
            )
        end
        iipfn = wrap_code[2](Func([IIP_OUTSYM; args], [], iipexpr))
        iip = Code.fast_toexpr(iipfn, ir, rewrites)
        if !checkbounds
            @assert Meta.isexpr(iip, :function)
            iip.args[2] = Expr(
                :macrocall, nameof(var"@inbounds"), LineNumberNode(0),
                Expr(:block, iip.args[2])
            )
        end
    else
        iip = get_unimplemented_fn(length(args) + 1, "in-place")
    end
    return oop, iip
end

function codegen_function(
        ir::IRStructure{VartypeT}, expr::Union{Arr, Num, CallAndWrap, SymStruct},
        args::Vector, opts::CodegenFunctionOptions
    )
    return codegen_function(ir, unwrap(expr), args, opts)
end

function codegen_function(
        ir::IRStructure{VartypeT}, expr::AbstractArray, args::Vector,
        opts::CodegenFunctionOptions
    )
    (; similarto, nanmath, wrap_code, iip_config, outputidxs, skipzeros, checkbounds,
        optimize, sort_addmul) = opts
    args = canonicalize_args(args, !checkbounds)
    rewrites = Dict()
    if nanmath
        rewrites[:nanmath] = true
    end
    rewrites[:sort_addmul] = sort_addmul

    expr = _recursive_unwrap(expr)

    ir, expr = Code.apply_optimization_rules(ir, expr, optimize)

    i = findfirst(x -> x isa DestructuredArgs, args)
    if similarto === nothing
        similarto = i === nothing ? Array : (args[i]::DestructuredArgs).name
    end
    if iip_config[1]
        oopfn = wrap_code[1](Func(args, [], make_array(nothing, args, expr, similarto)))
        oop = Code.fast_toexpr(oopfn, ir, rewrites)
        if !checkbounds
            @assert Meta.isexpr(oop, :function)
            oop.args[2] = Expr(
                :macrocall, nameof(var"@inbounds"), LineNumberNode(0),
                Expr(:block, oop.args[2])
            )
        end
    else
        oop = get_unimplemented_fn(length(args), "out-of-place")
    end

    if iip_config[2]
        iipfn = wrap_code[2](
            Func(
                [IIP_OUTSYM; args], [], set_array(
                    nothing,
                    args,
                    IIP_OUTSYM,
                    outputidxs,
                    expr,
                    checkbounds,
                    skipzeros
                )
            )
        )
        iip = Code.fast_toexpr(iipfn, ir, rewrites)
        if !checkbounds
            @assert Meta.isexpr(iip, :function)
            iip.args[2] = Expr(
                :macrocall, nameof(var"@inbounds"), LineNumberNode(0),
                Expr(:block, iip.args[2])
            )
        end
    else
        iip = get_unimplemented_fn(length(args) + 1, "in-place")
    end
    return oop, iip
end

# Groebner bases

Groebner bases use the implementation of the F4 algorithm from 
Groebner.jl package as its backend.
We refer to the [documentation of Groebner.jl](https://sumiya11.github.io/Groebner.jl/),
which lists some implementations details and possible use-cases of Groebner bases.

```@docs
Symbolics.is_groebner_basis
Symbolics.polynomial_coeffs
Symbolics.semilinear_form
Symbolics.semipolynomial_form
Symbolics.semiquadratic_form
```

# Symbolic Structs

It is occasionally useful to represent structs symbolically, and retain the ability to perform
`getproperty` on them. For example, let us consider the following struct representing a point in
2D cartesian coordinates.

```@example symstruct
using Symbolics, SymbolicUtils

struct Point2D{T}
    x::T
    y::T
end
```

To allow this struct to be used symbolically, the [`@symstruct`](@ref) macro must be used:

```@example symstruct
@symstruct Point2D{T}
```

Note that this macro _requires_ that all type parameters of the struct be present in the macro use.
With this, we can create symbolic structs like any other variable:

```@repl symstruct
@variables point::Point2D{Real}
typeof(point)
@assert point.x isa Num
@assert point.y isa Num
```

Subsequently, fields of the struct can be accessed symbolically:

```@repl symstruct
point.x^2 + point.y^2
```

## Array fields

What if we have a general point type capable of representing arbitrary dimensional cartesian
coordinates?

```@example symstruct
struct PointN{T, N}
    x::Vector{T}

    function PointN{T, N}(x::Vector{T}) where {T, N}
        @assert length(x) == N
        new{T, N}(x)
    end
end
```

The standard `@symstruct PointN{T, N}` would work. However, Symbolics cannot infer the length
of field `x` simply from the type `PointN{T, N}`. As a result, the field would be inferred as
an unknown length vector, and allow arbitrary indexing such as `point.x[1234]`. To provide this
information, the `@symstruct` macro allows specifying additional metadata:

```@example symstruct
@symstruct PointN{T, N} begin
    shape(:x) = (1:N,)
end
```

The `shape` option allows specifying the shape of array fields. Here, we're saying that the shape
of field `:x` is `(1:N,)` (i.e. it is a 1-indexed vector of length `N`). The expression can use
type information of the registered struct type. The specific details of all options are documented
in the [`@symstruct`](@ref) macro. With the above declaration, we can now have safe symbolic `PointN`.

```@repl symstruct
@variables point::PointN{Real, 3}
point.x[1]^2 + point.x[2]^2 + point.x[3]^2
@assert size(point.x) == (3,)
try
    point.x[4]
catch e
    Base.showerror(e)
end
```

## Abstract types

Often, it is useful to specify that all subtypes of a given abstract type should be considered
symbolic structs. The `@symstruct` macro can be used on abstract types to enable this behavior.

```@example symstruct
abstract type AbstractRecord{T} end

struct Record1{T} <: AbstractRecord{T}
    x::Vector{T}
    y::T
end

struct Record2{T} <: AbstractRecord{T}
    x::Vector{T}
    z::T
end

@symstruct AbstractRecord{T} begin
    shape(:x) = (1:3,)
end
```

As evidenced above, even options such as `shape` can be specified for abstract types. These are
applicable to all subtypes.

```@repl symstruct
@variables rec1::Record1{Real} rec2::Record2{Real}
@assert size(rec1.x) == (3,)
@assert size(rec2.x) == (3,)
rec1.x[1] + rec2.x[2] + rec1.y + rec2.z
```

The `@symstruct` macro roughly follows Julia subtyping behavior. This means that more specific
`@symstruct` declarations override less specific ones.

```@example symstruct
struct Record3{T} <: AbstractRecord{T}
    x::Vector{T}
    w::T
end

@symstruct Record3{T} begin
    shape(:x) = (1:4,)
end

struct Record4{T} <: AbstractRecord{T}
    x::Vector{T}
    f::Vector{T}
end

@symstruct Record4{T} begin
    shape(:f) = (1:5,)
end
```

```@repl symstruct
@variables rec3::Record3{Real} rec4::Record4{Real}
@assert size(rec3.x) == (4,) # Different from the one declared by `AbstractRecord`
@assert size(rec4.x) == (3,) # Falls back to the `AbstractRecord` definition
@assert size(rec4.f) == (5,) # Uses the more specific declaration
```

## Arrays of symbolic structs

Arrays of symbolic structs are required to have a concrete `eltype`

```@repl symstruct
@variables pts[1:3]::PointN{Real, 3}
pts[1].x[1] + pts[2].x[2]
```

## Nested structs

Symbolic struct types can be nested inside each other.

```@repl symstruct
@variables recs::Record1{Record1{Real}}
recs.x[1].x[1] + recs.x[2].y.y
```

## Registered functions of symbolic structs

There is some unique behavior when registering functions where arguments are (arrays of)
symbolic structs. The `@symstruct` macro works by defining some interface functions to allow
using the `Symbolics.SymStruct` wrapper type, similar to how `Num` is a wrapper type. All
registration functions behave the same as they did prior to this feature if the `SymStruct` is
unwrapped (using `SymbolicUtils.unwrap`). The difference in behavior arises from how wrapped
`SymStruct` types are handled. In general, the `@register_symbolic` and `@register_array_symbolic`
macros can only use information from the provided type annotations. They cannot know to declare
methods for `SymStruct{ConcreteFoo}` if the function is registered with `AbstractFoo`. For
example, the following syntax:

```julia
@register_symbolic foofn(foo::AbstractFoo)
```

Will only work for a variable declared as `@variables foo::ConcreteFoo` if `@symstruct AbstractFoo`
is declared, regardless of whether `@symstruct ConcreteFoo` is declared or not. This will always
work for `@variables afoo::AbstractFoo`.

```julia
@register_symbolic foofn2(foos::Vector{AbstractFoo})
```

Suppose we have declared `@variables a::ConcreteFoo b::ConcreteFoo cs[1:3]::ConcreteFoo`.
`foofn2([a, b])` will work only if `@symstruct AbstractFoo` is declared, regardless of
whether `@symstruct ConcreteFoo` is declared or not. The same applies for `foofn2(cs)`.

If you are not using symbolic structs, the registration macros behave exactly as they
did prior to this feature.

## API

```@docs
@symstruct
SymStruct
```

# Symbolic Limits

Experimental symbolic limit support is provided by the [`limit`](@ref) function, documented
below. See [SymbolicLimits.jl](https://github.com/SciML/SymbolicLimits.jl) for more
information and implementation details.

```@docs
limit
```

### SymPy Integration

SymPy also includes limits as well, and the SymPy.jl extensions allow for automatically converting
Symbolics expressions for use in its solvers.

```@docs
Symbolics.sympy_limit
Symbolics.sympy_pythoncall_limit
```

# Symbolic ODE Solving

While not all ODEs have an analytical solution, symbolic ODE solving is provided by Symbolics.jl for 
subsets of cases for which known analytical solutions can be obtained. These expressions can then
be merged with other techniques in order to accelerate code or gain a deeper understanding of real-world
systems.

## Merging Symbolic ODEs with Numerical Methods: ModelingToolkit.jl

If you are looking to merge Symbolics.jl manipulations with numerical solvers such as
[DifferentialEquations.jl](https://docs.sciml.ai/DiffEqDocs/stable/), then we highly recommend
checking out the [ModelingToolkit.jl](https://docs.sciml.ai/ModelingToolkit/dev/) system. It represents
systems of differentible-algebraic equations (DAEs, and extension to ODEs) for which a sophisticated
symbolic analysis pipeline is used to generate highly efficient code. This `mtkcompile` pipeline
makes use of all tricks from Symbolics.jl and many that are more specific to numerical code generation,
such as Pantelides index reduction and tearing of nonlinear systems, and it will analytically solve
subsets of the ODE system as finds possible. Thus if you are attempting to use Symbolics to pre-solve
some parts of an ODE analytically, we recommend allowing ModelingToolkit.jl to do this optimization.

Note that if ModelingToolkit is able to analytically solve the equation, it will give an `ODEProblem`
where `prob.u0 === nothing`, and then running `solve` on the `ODEProblem` will give a numerical
`ODESolution` object that on-demand uses the analytical solution to generate any plots or other artifacts.
The analytical solution can be investigated symbolically using `observed(sys)`.

## Symbolically Solving ODEs

!!! note
    This area is currently under heavy development. More solvers will be available in the near future.

```@docs
Symbolics.SymbolicLinearODE
```

```@docs
Symbolics.symbolic_solve_ode
```

```@docs
Symbolics.solve_symbolic_IVP
```

```@docs
Symbolics.solve_linear_ode_system
```

### Laplace Transform

The Laplace transform can be used to solve ODEs by transforming the whole equation, solving algebraically, then applying the inverse transform. The Laplace transform and inverse transform functionality is currently based on a rule table and applying linearity, so this method is limited in what expressions are able to be transformed and inverse transformed.

```@docs
Symbolics.laplace
Symbolics.inverse_laplace
Symbolics.laplace_solve_ode
```

### SymPy 

```@docs
Symbolics.sympy_ode_solve
```

```@docs
Symbolics.sympy_pythoncall_ode_solve
```

# [Mixed Symbolic-Numeric Perturbation Theory](@id perturb_alg)

[**Symbolics.jl**](https://github.com/JuliaSymbolics/Symbolics.jl) is a fast and modern Computer Algebra System (CAS) written in Julia. It is an integral part of the [SciML](https://sciml.ai/) ecosystem of differential equation solvers and scientific machine learning packages. While **Symbolics.jl** is primarily designed for modern scientific computing (e.g. automatic differentiation and machine learning), it is also a powerful CAS that can be used for *classic* scientific computing. One such application is using *perturbation theory* to solve algebraic and differential equations.

Perturbation methods are a collection of techniques to solve hard problems that generally don't have a closed solution, but depend on a tunable parameter and have closed or easy solutions for some values of this parameter. The main idea is to assume a solution that is a power series in the tunable parameter (say $ϵ$), such that $ϵ = 0$ corresponds to an easy solution, and then solve iteratively for higher-order corrections.

The hallmark of perturbation theory is the generation of long and convoluted intermediate equations by this process. These are subjected to algorithmic and mechanical manipulations, which makes perturbation methods an excellent fit for a CAS. In fact, CAS software have been used for perturbation calculations since the early 1970s.

This tutorial shows how to mix symbolic manipulations and numerical methods to solve algebraic equations with perturbation theory. [Another tutorial applies it to differential equations](https://docs.sciml.ai/ModelingToolkit/stable/examples/perturbation/).

## Solving the quintic equation

The “hello world!” analog of perturbation problems is to find a real solution $x$ to the quintic (fifth-order) equation
```@example perturb
using Symbolics
@variables x
quintic = x^5 + x ~ 1
```
According to Abel's theorem, a general quintic equation does not have a closed form solution. But we can easily solve it numerically using Newton's method (here implemented for simplicity, and not performance):
```@example perturb
function solve_newton(eq, x, x₀; abstol=1e-8, maxiters=50)
    # symbolic expressions for f(x) and f′(x)
    f = eq.lhs - eq.rhs # want to find root of f(x)
    f′ = Symbolics.derivative(f, x)

    xₙ = x₀ # numerical value of the initial guess
    for i = 1:maxiters
        # calculate new guess by numerically evaluating symbolic expression at previous guess
        xₙ₊₁ = substitute(x - f / f′, x => xₙ)
        if abs(xₙ₊₁ - xₙ) < abstol
            return xₙ₊₁ # converged
        else
            xₙ = xₙ₊₁
        end
    end
    error("Newton's method failed to converge")
end

x_newton = solve_newton(quintic, x, 1.0)
println("Newton's method solution: x = ", x_newton)
```

To solve the same problem with perturbation theory, we must introduce an expansion variable $ϵ$ in the equation:
```@example perturb
@variables ϵ # expansion variable
quintic = x^5 + ϵ*x ~ 1
```
If $ϵ = 1$, we get our original problem. With $ϵ = 0$, the problem transforms to the easy quintic equation $x^5 = 1$ with the trivial real solution $x = 1$ (and four complex solutions which we ignore). Next, expand $x$ as a power series in $ϵ$:
```@example perturb
x_coeffs, = @variables a[0:7] # create Taylor series coefficients
x_taylor = series(x_coeffs, ϵ) # expand x in a power series in ϵ
```
Then insert this into the quintic equation and expand it, too, to the same order:
```@example perturb
quintic_taylor = substitute(quintic, x => x_taylor)
quintic_taylor = taylor(quintic_taylor, ϵ, 0:7)
```
This messy equation must hold for each power of $ϵ$, so we can separate it into one nicer equation per order:
```@example perturb
quintic_eqs = taylor_coeff(quintic_taylor, ϵ, 0:7)
quintic_eqs[1:5] # for readability, show only 5 shortest equations
```
These equations show three important features of perturbation theory:
1. The $0$-th order equation is *trivial* in $x_0$: here $x_0^5 = 1$ has the trivial real solution $x_0 = 1$.
2. The $n$-th order equation is *linear* in $x_n$ (except the trivial $0$-th order equation).
3. The equations are *triangular* in $x_n$: the $n$-th order equation can be solved for $x_n$ given only $x_m$ for $m<n$.
This structure is what makes the perturbation theory so attractive: we can start with the trivial solution $x_0 = 1$, then linearly solve for $x_n$ order-by-order and substitute in the solutions of $x_m$ for $m<n$ obtained so far.

Here is a simple function that uses this *cascading* strategy to solve such a set of equations `eqs` for the variables `xs`, given a solution `x₀` of the first equation `eqs[begin]`:
```@example perturb
function solve_cascade(eqs, xs, x₀, ϵ)
    sol = Dict(xs[begin] => x₀) # store solutions in a map

    # verify that x₀ is a solution of the first equation
    eq0 = substitute(eqs[1], sol)
    isequal(eq0.lhs, eq0.rhs) || error("$sol does not solve $(eqs[1])")

    # solve remaining equations sequentially
    for i in 2:length(eqs)
        eq = substitute(eqs[i], sol) # insert previous solutions
        x = xs[begin+i-1] # need not be 1-indexed
        xsol = Symbolics.symbolic_linear_solve(eq, x) # solve current equation
        sol = merge(sol, Dict(x => xsol)) # store solution
    end

    return sol
end
```
Let us solve our order-separated quintics for the coefficients, and substitute them into the full series for $x$:
```@example perturb
x_coeffs_sol = solve_cascade(quintic_eqs, x_coeffs, 1, ϵ)
x_pert = substitute(x_taylor, x_coeffs_sol)
```
The $n$-th order solution of our original quintic equation is the sum up to the $ϵ^n$-th order term, evaluated at $ϵ=1$:
```@example perturb
for n in 0:7
    x_pert_sol = substitute(taylor(x_pert, ϵ, 0:n), ϵ => 1)
    println("$n-th order solution: x = $x_pert_sol = $(x_pert_sol * 1.0)")
end
```
This is close to the solution from Newton's method!

## Solving Kepler's Equation

Historically, perturbation methods were first invented to calculate orbits of the Moon and the planets. In homage to this history, our second example is to solve [Kepler's equation](https://en.wikipedia.org/wiki/Kepler's_equation), which is central to solving two-body Keplerian orbits:
```@example perturb
@variables e E M
kepler = E - e * sin(E) ~ M
```
We want to solve for the *eccentric anomaly* $E$ given the *eccentricity* $e$ and *mean anomaly* $M$.
This is also easy with Newton's method. With Earth's eccentricity $e = 0.01671$ and $M = \pi/2$:
```@example perturb
vals_earth = Dict(e => 0.01671, M => π/2)
E_newton = solve_newton(substitute(kepler, vals_earth), E, π/2)
println("Newton's method solution: E = ", E_newton)
```

Next, let us solve the same problem with the perturbative method. It is most common to expand $E$ as a series in $M$. Repeating the procedure from the quintic example, we get these equations:
```@example perturb
E_taylor = series(E, M, 0:5) # this auto-creates coefficients E[0:5]
E_coeffs = taylor_coeff(E_taylor, M) # get a handle to the coefficients
kepler_eqs = taylor_coeff(substitute(kepler, E => E_taylor), M, 0:5)
kepler_eqs[1:4] # for readability
```
The trivial $0$-th order solution (when $M=0$) is $E_0=0$. This gives this full perturbative solution:
```@example perturb
E_coeffs_sol = solve_cascade(kepler_eqs, E_coeffs, 0, M)
E_pert = substitute(E_taylor, E_coeffs_sol)
```

Numerically, the result again converges to that from Newton's method:
```@example perturb
for n in 0:5
    println("$n-th order solution: E = ", substitute(taylor(E_pert, M, 0:n), vals_earth))
end
```
But unlike Newtons method, this example shows how perturbation theory also gives us the powerful *symbolic* series solution for $E$ (*before* numbers for $e$ and $M$ are inserted). Our series matches [this result from Wikipedia](https://en.wikipedia.org/wiki/Kepler%27s_equation#Inverse_Kepler_equation):
```@example perturb
E_wiki = 1/(1-e)*M - e/(1-e)^4*M^3/factorial(3) + (9e^2+e)/(1-e)^7*M^5/factorial(5)
```

Alternatively, we can expand $E$ in $e$ instead of $M$, giving the solution (the trivial solution when $e = 0$ is $E_0=M$):
```@example perturb
E_taylor′ = series(E, e, 0:5)
E_coeffs′ = taylor_coeff(E_taylor′, e)
kepler_eqs′ = taylor_coeff(substitute(kepler, E => E_taylor′), e, 0:5)
E_coeffs_sol′ = solve_cascade(kepler_eqs′, E_coeffs′, M, e)
E_pert′ = substitute(E_taylor′, E_coeffs_sol′)
```
This looks very different from our first series `E_pert`. If they are the same, we should get $0$ if we subtract and expand both as multivariate Taylor series in $(e,M)$. Indeed:
```@example perturb
@assert taylor(taylor(E_pert′ - E_pert, e, 0:4), M, 0:4) == 0 # use this as a test # hide
taylor(taylor(E_pert′ - E_pert, e, 0:4), M, 0:4)
```

# [Function Registration and Tracing](@id function_registration)

Function registration is the ability to define new nodes in the symbolic
graph. This is useful because symbolic computing is declarative, i.e.
symbolic computations express *what* should be computed, not *how* it
should be computed. However, at some level someone must describe
how a given operation is computed. These are the primitive functions,
and a symbolic expression is made up of primitive functions.

Symbolics.jl comes pre-registered with a large set of standard mathematical
functions, like `*` and `sin` to special functions like `erf`, and even
deeper operations like DataInterpolations.jl's `AbstractInterpolation`.
However, in many cases you may need to add your own function, i.e. you
may want to give an imperative code and use this to define a new symbolic
code. Symbolics.jl calls the declaration of new declarative primitives
from an imperative function definition **registration**. This page
describes both the registration process and its companion process,
tracing, for interacting with code written in Julia.

## Direct Tracing

Because Symbolics expressions respect Julia semantics, one way
to generate symbolic expressions is to simply place Symbolics
variables as inputs into existing Julia code. For example, the following
uses the standard Julia function for the Lorenz equations to generate
the symbolic expression for the Lorenz equations:

```@example registration
using Symbolics
function lorenz(du,u,p,t)
 du[1] = 10.0(u[2]-u[1])
 du[2] = u[1]*(28.0-u[3]) - u[2]
 du[3] = u[1]*u[2] - (8/3)*u[3]
end
@variables t p[1:3] u(t)[1:3]
du = Array{Any}(undef, 3)
lorenz(du,u,p,t)
du
```
Or similarly:

```@example registration
@variables t x(t) y(t) z(t) dx(t) dy(t) dz(t) σ ρ β
du = [dx,dy,dz]
u = [x,y,z]
p = [σ,ρ,β]
lorenz(du,u,p,t)
du
```

Note that what has been done here is that the imperative Julia code
for the function `lorenz` has been transformed into a declarative
symbolic graph. Importantly, the code of `lorenz` is transformed
into an expression consisting only of primitive registered functions,
things like `*` and `-`, which come pre-registered with Symbolics.jl
This then allows for symbolic manipulation of the expressions, 
allowing things like simplification and operation
reordering done on its generated expressions. 

### Utility and Scope of Tracing

This notably describes one limitation of tracing: tracing only 
works if the expression being traced is composed of already 
registered functions. If unregistered functions, such as calls
to C code, are used, then the tracing process will error.

However, we note that symbolic tracing by definition does not 
guarantee that the exact choices. The symbolic expressions
may re-distribute the arithmetic, simplify out expressions, or
do other modifications. Thus if this function is function is
sensitive to numerical details in its calculation, one would not
want to trace the function and thus would instead register it
as a new primitive function.

For the symbolic system to be as powerful in its manipulations
as possible, it is recommended that the registration of functions
be minimized to the simplest possible set, and thus registration
should only be used when necessary. This is because any code within
a registered function is treated as a blackbox imperative code that
cannot be manipulated, thus decreasing the potential for simplifications.

## Registering Functions

The Symbolics graph only allows registered Julia functions within its type.
All other functions are automatically traced down to registered
functions. By default, Symbolics.jl pre-registers the common functions
utilized in [SymbolicUtils.jl](https://github.com/JuliaSymbolics/SymbolicUtils.jl)
and pre-defines their derivatives. However, the user can utilize the
[`@register_symbolic`](@ref) macro to add their function to allowed functions
of the computation graph.

Additionally, [`@register_array_symbolic`](@ref) can be used to define array functions.
For size propagation it's required that a computation of how the sizes are computed is
also supplied.

### Defining Derivatives of Registered Functions

In order for symbolic differentiation to work, an overload of `Symbolics.derivative` is
required. The syntax is `derivative(typeof(f), args::NTuple{i,Any}, ::Val{j})` where
`i` is the number of arguments to the function and `j` is which argument is being
differentiated. So for example:

```julia
function derivative(::typeof(min), args::NTuple{2,Any}, ::Val{1})
    x, y = args
    ifelse(x < y, one(x), zero(x))
end
```

is the partial derivative of the Julia `min(x,y)` function with respect to `x`.

!!! note
    Downstream symbolic derivative functionality only work if every partial derivative that
    is required in the derivative expression is defined. Note that you only need to define
    the partial derivatives which are actually computed.

### Registration of Array Functions

Similar to scalar functions, array functions can be registered to define new primitives for
functions which either take in or return arrays. This is done by using the `@register_array_symbolic`
macro. It acts similarly to the scalar function registration but requires a calculation of the
input and output sizes. For example, let's assume we wanted to have a function that computes the
solution to `Ax = b`, i.e. a linear solve, using an SVD factorization. In Julia, the code for this
would be `svdsolve(A,b) = svd(A)\b`. We would create this function as follows:

```@example array_registration
using LinearAlgebra, Symbolics

svdsolve(A, b) = svd(A)\b
@register_array_symbolic svdsolve(A::AbstractMatrix, b::AbstractVector) begin
    size = size(b)
    eltype = promote_type(eltype(A), eltype(b))
end
```

Now using the function `svdsolve` with symbolic array variables will be kept lazy:

```@example array_registration
@variables A[1:3, 1:3] b[1:3]
svdsolve(A,b)
```

Note that at this time array derivatives cannot be defined.

## Registration API

```@docs
@register_symbolic
@register_array_symbolic
```

## Direct Registration API (Advanced, Experimental)

!!! warning

    This is a lower level API which is not as stable as the macro APIs.

In some circumstances you may need to use the direct API in order to define
registration on functions or types without using the macro. This is done
by directly defining dispatches on symbolic objects.

A good example of this is DataInterpolations.jl's interpolations object.
On an interpolation by a symbolic variable, we generate the symbolic
function (the `term`) for the interpolation function. This looks like:

```julia
using DataInterpolations, Symbolics, SymbolicUtils
(interp::AbstractInterpolation)(t::Num) = SymbolicUtils.term(interp, unwrap(t))
```

In order for this to work, it is required that we define the `symtype` for the
symbolic type inference. This is done via:

```julia
SymbolicUtils.promote_symtype(t::AbstractInterpolation, args...) = Real
```

Additionally a symbolic name is required:

```julia
Base.nameof(interp::AbstractInterpolation) = :Interpolation
```

The derivative is defined similarly to the macro case:

```julia
function Symbolics.derivative(interp::AbstractInterpolation, args::NTuple{1, Any}, ::Val{1})
    Symbolics.unwrap(derivative(interp, Symbolics.wrap(args[1])))
end
```

## Inverse function registration

Symbolics.jl allows defining and querying the inverses of functions.

```@docs
inverse
left_inverse
right_inverse
@register_inverse
has_inverse
has_left_inverse
has_right_inverse
```

Symbolics.jl implements inverses for standard trigonometric and logarithmic functions,
as well as their variants from `NaNMath`. It also implements inverses of
`ComposedFunction`s.

# Symbolics.jl

```@docs
Symbolics.Symbolics
```

Symbolics.jl is a fast and modern Computer Algebra System (CAS) for a fast and modern
programming language (Julia). The goal is to have a high-performance and parallelized
symbolic algebra system that is directly extendable in the same language as that of the
users.

## Installation

To install Symbolics.jl, use the Julia package manager:

```julia
using Pkg
Pkg.add("Symbolics")
```

## Citation

If you use Symbolics.jl, please [cite this paper](https://arxiv.org/abs/2105.03949)

```
@article{gowda2021high,
  title={High-performance symbolic-numerics via multiple dispatch},
  author={Gowda, Shashi and Ma, Yingbo and Cheli, Alessandro and Gwozdz, Maja and Shah, Viral B and Edelman, Alan and Rackauckas, Christopher},
  journal={arXiv preprint arXiv:2105.03949},
  year={2021}
}
```

## Feature Summary

Because Symbolics.jl is built into the Julia language and works
with its dispatches, generic functions in Base Julia will work with symbolic
expressions! Make matrices of symbolic expressions and multiply them: it will
just work. Take the LU-factorization. Etc. Thus, see
[the Julia Documentation](https://docs.julialang.org/en/v1/) for a large list
of functionality available in Symbolics.jl.

A general list of the features is:

- Symbolic arithmetic with type information and multiple dispatch
- Symbolic polynomials and trigonometric functions
- Pattern matching, simplification and substitution
- Differentiation
- Symbolic linear algebra (factorizations, inversion, determinants, eigencomputations, etc.)
- Discrete math (representations of summations, products, binomial coefficients, etc.)
- Logical and Boolean expressions
- Symbolic equation solving and conversion to arbitrary precision
- Support for non-standard algebras (non-commutative symbols and customizable rulesets)
- Special functions (list provided by [SpecialFunctions.jl](https://github.com/JuliaMath/SpecialFunctions.jl))
- Automatic conversion of Julia code to symbolic code
- Generation of (high performance and parallel) functions from symbolic expressions
- Fast automated sparsity detection and generation of sparse Jacobians and Hessians

and much more.

## Extension Packages

Below is a list of known extension packages. If you would like your package
to be listed here, feel free to open a pull request!

- [ModelingToolkit.jl](https://github.com/SciML/ModelingToolkit.jl): Symbolic representations of common numerical systems
    - Ordinary differential equations
    - Stochastic differential equations
    - Partial differential equations
    - Nonlinear systems
    - Optimization problems
    - Optimal Control
    - Causal and acausal modeling (Simulink/Modelica)
    - Automated model transformation, simplification, and composition
- [Catalyst.jl](https://github.com/SciML/Catalyst.jl): Symbolic representations of chemical reactions
    - Symbolically build and represent large systems of chemical reactions
    - Generate code for ODEs, SDEs, continuous-time Markov Chains, and more
    - Simulate the models using the SciML ecosystem with O(1) Gillespie methods
- [DataDrivenDiffEq.jl](https://github.com/SciML/DataDrivenDiffEq.jl): Automatic identification of equations from data
    - Automated construction of ODEs and DAEs from data
    - Representations of Koopman operators and Dynamic Mode Decomposition (DMD)
- [SymbolicRegression.jl](https://github.com/astroautomata/SymbolicRegression.jl): Distributed High-Performance symbolic regression
    - Parallelized generic algorithms for finding equations from data
    - Pareto frontier-based scoring
- [ReversePropagation.jl](https://github.com/JuliaIntervals/ReversePropagation.jl): Source-to-source reverse mode automatic differentiation
    - Automated tracing of code and construction of backpropagation equations
    - Composes with symbolic transformation and simplification functionality

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@eval
using TOML
using Markdown
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link_manifest = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
                "/assets/Manifest.toml"
link_project = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
               "/assets/Project.toml"
Markdown.parse("""You can also download the
[manifest]($link_manifest)
file and the
[project]($link_project)
file.
""")
```

# Metadata

Symbolics.jl provides a metadata system for attaching additional information to symbolic variables. This system allows for extensible annotations that can be used to store default values, source information, and custom user-defined metadata.

## Using Metadata

Metadata can be attached to variables when they are created with the `@variables` macro. Common metadata includes default values and other annotations:

```julia
using Symbolics

# Variable with default value
@variables x=1.0 y=2.0

# Variables with custom metadata (once registered)
@variables z [description="Temperature in Kelvin"]
```

## Extending Metadata

You can define custom metadata types for use with the `@variables` macro by defining a new metadata type and registering it:

```julia
using Symbolics

# Define a custom metadata type
struct MyCustomMetadata <: Symbolics.AbstractVariableMetadata end

# Register it for use in @variables
Symbolics.option_to_metadata_type(::Val{:my_custom}) = MyCustomMetadata

# Now you can use it
@variables x [my_custom = "some value"]
```

## Metadata API

```@docs
Symbolics.VariableDefaultValue
Symbolics.VariableSource
Symbolics.option_to_metadata_type
```

`Symbolics.Unknown` is reexported from
[SymbolicUtils](https://symbolicutils.juliasymbolics.org/api/#SymbolicUtils.Unknown).

# Constraint Satisfaction

Symbolic constraint satisfaction is a powerful technique for solving problems where you need to find values for symbolic variables that satisfy a set of constraints. Symbolics.jl provides constraint satisfaction capabilities through integration with SAT solvers and theorem provers.

!!! note
    Constraint satisfaction in symbolic computation is an active area of research. The available tools provide experimental functionality that continues to evolve.

## What is Constraint Satisfaction?

A Constraint Satisfaction Problem (CSP) consists of:
- A set of variables
- A domain for each variable (the possible values it can take)
- A set of constraints that define relationships between variables

The goal is to find an assignment of values to variables that satisfies all constraints simultaneously.

In symbolic computation, constraint satisfaction extends beyond simple numerical domains to handle symbolic expressions, boolean formulas, and mathematical relationships.

## SymbolicSMT.jl

SymbolicSMT.jl extends SymbolicUtils expression simplification with theorem proving capabilities through the Z3 Theorem Prover. It allows adding boolean constraints to the symbolic simplification process.

### Key Features

- **Z3 Integration**: Uses the powerful Z3 SMT (Satisfiability Modulo Theories) solver
- **Symbolic Constraints**: Work with symbolic mathematical expressions as constraints
- **Satisfiability Checking**: Determine if expressions can be satisfied under constraints
- **Provability Checking**: Prove or disprove statements under constraints
- **Boolean Logic**: Handle complex boolean formulas and logical relationships

### Basic Usage

```@example constraint_sat
using Symbolics, SymbolicSMT

@variables x::Real y::Real

# Define constraints
constraints = Constraints([x > 0, y > 0])

# Check if an expression is satisfiable under constraints
issatisfiable(x + y > 1, constraints)
```

```@example constraint_sat
# Check if an expression is provable (always true) under constraints
isprovable(x >= 0, constraints)
```

```@example constraint_sat
# Check if x can be negative (it cannot, given x > 0)
issatisfiable(x < 0, constraints)
```

### Example Applications

#### Bound Checking

```@example constraint_sat
@variables a::Integer b::Integer

# Define bounds
bounds = Constraints([a >= 0, a <= 10, b >= 0, b <= 10])

# Can the sum exceed 15?
issatisfiable(a + b > 15, bounds)
```

```@example constraint_sat
# Is the sum always at most 20?
isprovable(a + b <= 20, bounds)
```

#### Quadratic Constraints

```@example constraint_sat
@variables p::Integer q::Integer

# Circle-like constraint
circle = Constraints([p^2 + q^2 < 25])

# Can p be 3?
issatisfiable(p == 3, circle)
```

```@example constraint_sat
# Can p be 5? (No, because 5^2 = 25 is not < 25)
issatisfiable(p == 5, circle)
```

## SAT Solving in Julia

### What is SAT?

Boolean Satisfiability Testing (SAT) is the problem of determining whether there exists an assignment of truth values to boolean variables that makes a given boolean formula evaluate to true. SAT is fundamental to many computational problems and is NP-complete.

### Applications of SAT Solvers

SAT solvers have wide applications in:

- **Software Verification**: Model checking, program analysis
- **Hardware Verification**: Circuit verification and testing
- **Planning and Scheduling**: Resource allocation, job scheduling
- **Artificial Intelligence**: Automated reasoning, knowledge representation
- **Cryptography**: Cryptanalysis and security analysis
- **Operations Research**: Optimization problems
- **Combinatorial Problems**: Sudoku, graph coloring, constraint puzzles

### SAT in Symbolic Computation

In symbolic computation, SAT solvers enable:

1. **Constraint Solving**: Finding symbolic solutions to constraint systems
2. **Theorem Proving**: Automatically proving or disproving mathematical statements
3. **Expression Simplification**: Simplifying expressions under logical constraints
4. **Satisfiability Checking**: Determining if constraint systems have solutions

### Boolean Constraints

```@example constraint_sat
@variables flag1::Bool flag2::Bool

# Boolean constraints
bool_constraints = Constraints([flag1, flag2])

# Both flags are true, so their AND is satisfiable
issatisfiable(flag1 & flag2, bool_constraints)
```

```@example constraint_sat
# Can flag1 be false? No, it's constrained to be true
issatisfiable(!flag1, bool_constraints)
```

## SMT Solvers

Satisfiability Modulo Theories (SMT) solvers extend SAT solvers to handle richer mathematical structures:

- **Arithmetic**: Integer and real number constraints
- **Arrays**: Array indexing and element constraints
- **Bit-vectors**: Fixed-width integer arithmetic
- **Strings**: String manipulation and pattern matching
- **Algebraic Data Types**: Custom mathematical structures

### Z3 Theorem Prover

Z3 is Microsoft Research's high-performance SMT solver that SymbolicSMT.jl uses:

- **Multiple Theories**: Supports arithmetic, bit-vectors, arrays, and more
- **Decision Procedures**: Efficient algorithms for theory-specific reasoning
- **Model Generation**: Can provide example solutions when constraints are satisfiable
- **Proof Generation**: Can generate proofs of unsatisfiability

## Advanced Constraint Satisfaction

### Multi-Variable Arithmetic

SymbolicSMT.jl supports multi-variable arithmetic expressions:

```@example constraint_sat
@variables m::Integer n::Integer

# Multi-variable constraints
multi_constraints = Constraints([m >= 1, n >= 1])

# Check multi-variable expressions - can sum be <= 0?
issatisfiable(m + n <= 0, multi_constraints)  # false - m + n >= 2 when m,n >= 1
```

```@example constraint_sat
# Is sum always >= 2?
isprovable(m + n >= 2, multi_constraints)  # true - always satisfied when m,n >= 1
```

### Power Operators

```@example constraint_sat
@variables t::Integer

power_constraints = Constraints([t >= 0, t <= 3])

# Can t^2 be at most 9?
issatisfiable(t^2 <= 9, power_constraints)
```

```@example constraint_sat
# Is t^2 always <= 9 when t is in [0,3]?
isprovable(t^2 <= 9, power_constraints)
```

### Expression Resolution

The `resolve` function attempts to determine if an expression is provably true or false:

```@example constraint_sat
@variables v::Integer

resolve_constraints = Constraints([v > 5])

# v > 0 is provably true when v > 5
resolve(v > 0, resolve_constraints)
```

```@example constraint_sat
# v < 0 is provably false when v > 5
resolve(v < 0, resolve_constraints)
```

```@example constraint_sat
# v > 10 cannot be determined - returns the expression
resolve(v > 10, resolve_constraints)
```

## Integration with Symbolic Computation

Constraint satisfaction integrates naturally with other symbolic computation features:

- **Symbolic Differentiation**: Optimize constraint systems using gradients
- **Symbolic Integration**: Handle constraints involving integrals
- **Expression Manipulation**: Simplify complex constraint expressions
- **Code Generation**: Generate efficient constraint checking code

## Further Reading

- [SymbolicSMT.jl Repository](https://github.com/JuliaSymbolics/SymbolicSMT.jl)
- [Z3 Theorem Prover](https://github.com/Z3Prover/z3)
- [Satisfiability.jl](https://github.com/dpsanders/SatisfiabilityInterface.jl) - Alternative SAT interface for Julia
- [SMT-LIB Standard](http://smtlib.cs.uiowa.edu/) - Standard format for SMT solvers

# Expression Manipulation

Symbolics.jl provides functionality for easily manipulating expressions.
Most of the functionality comes by the expression objects obeying the standard
mathematical semantics. For example, if one has `A` a matrix of symbolic
expressions wrapped in `Num`, then `A^2` calculates the expressions for the
squared matrix.  It is thus encouraged to use standard Julia
for performing many of the manipulation on the IR. For example,
calculating the sparse form of the matrix via `sparse(A)` is valid, legible,
and easily understandable to all Julia programmers.

## Functionality Inherited From SymbolicUtils.jl

```@docs
SymbolicUtils.substitute
SymbolicUtils.simplify
```
Documentation for `rewriter` can be found [here](https://symbolicutils.juliasymbolics.org/rewrite/), using the `@rule` macro or the `@acrule` macro from SymbolicUtils.jl.

## Functionality Provided by SymPy.jl Integration

SymPy also includes solves as well, and the SymPy.jl extensions allow for automatically converting
Symbolics expressions for use in its simplifier.

```@docs
Symbolics.sympy_simplify
```

## Additional Manipulation Functions

Other additional manipulation functions are given below.

```@docs
Symbolics.get_variables
Symbolics.tosymbol
Symbolics.diff2term
Symbolics.degree
Symbolics.coeff
Symbolics.replace
Symbolics.occursin
Symbolics.filterchildren
Symbolics.fixpoint_sub
Symbolics.fast_substitute
Symbolics.evaluate
Symbolics.symbolic_to_float
Symbolics.terms(x)
Symbolics.factors(x)
numerator(x::Union{Num, Symbolics.Symbolic})
denominator(x::Union{Num, Symbolics.Symbolic})
```

# Function Building and Compilation (build_function)

At any time, callable functions can be generated from Symbolics IR by
using `Symbolics.toexpr`. This performs some cleaning to return an
expression without extraneous pieces that commonly matches expressions one
would write in functions like those for differential equation solvers and
optimization libraries. These functions can be automatically parallelized and
specialize on Julia types like static arrays and sparse matrices.

The core compilation process of Symbolics IR is `build_function`.
`build_function` takes an operation or an `AbstractArray` of operations and
generates a compilable version of the model for numerical solvers. The form of
this output is dependent on the `target`. By default, the target outputs
Julia code, but other formats, such as C, Stan, and MATLAB are available.
These can be generated as expressions which can then be evaluated into a callable
function, or the compilers for the respective targets can be invoked to directly
give back the function handle.

## build_function

```@docs
build_function
```

## Target-Specific Definitions

```@docs
Symbolics._build_function(target::Symbolics.JuliaTarget,rhss::AbstractArray,args...;kwargs...)
Symbolics._build_function(target::Symbolics.CTarget,eqs::Array{<:Equation},args...;kwargs...)
Symbolics._build_function(target::Symbolics.StanTarget,eqs::Array{<:Equation}, vs, ps, iv;kwargs...)
Symbolics._build_function(target::Symbolics.MATLABTarget,eqs::Array{<:Equation},args...;kwargs...)
```

## Limitations

`build_function` 

# Derivatives and Differentials

A `Differential(op)` is a partial derivative with respect to `op`,
which can then be applied to some other operations. For example, `D=Differential(t)`
is what would commonly be referred to as `d/dt`, which can then be applied to
other operations using its function call, so `D(x+y)` is `d(x+y)/dt`.

By default, the derivatives are left unexpanded to capture the symbolic
representation of the differential equation. If the user would like to expand
out all the differentials, the `expand_derivatives` function eliminates all
the differentials down to basic one-variable expressions.

```@docs
Differential
expand_derivatives
is_derivative
```

!!! note
    For symbolic differentiation, all registered functions in the symbolic expression
    need a registered derivative. For more information, see the
    [function registration](@ref function_registration) page.

## High-Level Differentiation Functions

The following functions are not exported and thus must be accessed in a namespaced
way, i.e. `Symbolics.jacobian`.

```@docs
Symbolics.derivative
Symbolics.jacobian
Symbolics.sparsejacobian
Symbolics.sparsejacobian_vals
Symbolics.gradient
Symbolics.hessian
Symbolics.sparsehessian
Symbolics.sparsehessian_vals
```

## Adding Analytical Derivatives

There are many derivatives pre-defined by
[DiffRules.jl](https://github.com/JuliaDiff/DiffRules.jl).
For example,
```@example derivatives
using Symbolics
@variables x y z
f(x,y,z) = x^2 + sin(x+y) - z
```

`f` automatically has the derivatives defined via the tracing mechanism. It will do
this by directly building the internals of your function and
differentiating that.

However, often you may want to define your own derivatives so that way
automatic Jacobian etc. calculations can utilize this information. This can
allow for more succinct versions of the derivatives to be calculated
to scale to larger systems. You can define derivatives for your
function via the dispatch:

```julia
# `N` arguments are accepted by the relevant method of `my_function`
Symbolics.derivative(::typeof(my_function), args::NTuple{N,Any}, ::Val{i})
```

where `i` means that it's the derivative with respect to the `i`th argument. `args` is the
array of arguments, so, for example, if your function is `f(x,t)`, then `args = [x,t]`.
You should return an `Term` for the derivative of your function.

For example, `sin(t)`'s derivative (by `t`) is given by the following:

```@example derivatives
Symbolics.derivative(::typeof(sin), args::NTuple{1,Any}, ::Val{1}) = cos(args[1])
```

# Symbolic Integrals

Symbolics.jl provides a the `Integral` operator for defining integrals. These can be used with
various functionalities in order to represent integro-differential equations and as a representation
for symbolic solving of integrals.

## Defining Symbolic Integrals

Note that integration domains are defined using 
[DomainSets.jl](https://github.com/JuliaApproximation/DomainSets.jl).

```@docs
Symbolics.Integral
```

## Solving Symbolic Integrals

Symbolics.jl currently has the following options for solving integrals symbolically:

| Package    | Method | Description | Pros | Cons |
| ---------- | ------ | ----------- | ---- | ---- |
| SymbolicIntegration.jl | Risch Algorithm | Implements theoretical Risch algorithm for elementary functions | Mathematically rigorous, returns exact symbolic results, handles rational functions and transcendental functions (exp, log, trig) | Still in early development, unstable, limited to specific function classes, no support for algebraic functions |
| SymbolicIntegration.jl | Rule-Based Method | Applies over 3,400 integration rules systematically | Handles non-integer powers, supports multiple symbolic variables, more flexible than pure Risch | Rule-dependent success, no theoretical completeness guarantee, limited by predefined rule set |
| SymbolicNumericIntegration.jl  | Symbolic-Numeric Hybrid | Uses numeric integrators with symbolic regression machine learning methods | Can solve some hard integrals very fast and easily, works differently from pure symbolic methods | Can be unreliable in easy cases, will give floats (0.5) instead of rational values (1//2), precision loss |
| SymPy's Integrate | Hybrid Methods | Uses SymPy (through SymPy.jl) to integrate the expression | Reasonably robust and tested solution, mature implementation | Extremely slow, Python overhead |

### SymbolicIntegration.jl

SymbolicIntegration.jl provides pure symbolic integration using multiple algorithmic approaches.
Unlike numerical methods, it returns exact symbolic results with rational coefficients (e.g., `1//2`
instead of `0.5`). The package implements a flexible framework for symbolic integration that uses Julia's
multiple dispatch to select appropriate algorithms for different types of integrands.

The package offers two main integration methods:

#### Risch Algorithm Method

The `RischMethod` implements the theoretical Risch algorithm for integrating:
- Polynomial functions
- Rational functions  
- Exponential functions
- Logarithmic functions
- Trigonometric functions
- Combinations of the above

This method is mathematically rigorous and provides guaranteed results when an elementary antiderivative exists.
However, it is still under development and may not handle all cases robustly.

#### Rule-Based Method

The rule-based approach systematically applies over 3,400 integration rules to solve integrals:
- Handles non-integer powers and algebraic functions
- Supports more complex integrations than pure Risch
- Can handle multiple symbolic variables
- More flexible but depends on the predefined rule set

The package automatically tries the Risch algorithm first, then falls back to rule-based methods if needed.

For using SymbolicIntegration.jl, see [the SymbolicIntegration.jl repository](https://github.com/JuliaSymbolics/SymbolicIntegration.jl) 
for more details. Quick examples:

```julia
using Symbolics
using SymbolicIntegration

@variables x

# Basic integrations (automatic method selection)
integrate(x^2, x)           # Returns (1//3)*(x^3)
integrate(1/x, x)           # Returns log(x)
integrate(exp(x), x)        # Returns exp(x)
integrate(1/(x^2 + 1), x)   # Returns atan(x)

# Rational function with complex roots (typically uses Risch)
f = (x^3 + x^2 + x + 2)/(x^4 + 3*x^2 + 2)
integrate(f, x)  # Returns (1//2)*log(2 + x^2) + atan(x)

# Nested transcendental functions (uses Risch)
integrate(1/(x*log(x)), x)  # Returns log(log(x))

# Explicit Risch method selection
integrate(sin(x)*cos(x), x, RischMethod())

# Configurable Risch method
risch = RischMethod(use_algebraic_closure=true, catch_errors=false)
integrate(exp(x)/(1 + exp(x)), x, risch)

# Rule-based method for cases not handled by Risch
integrate(x^(1/2), x)       # Uses rule-based method for non-integer powers
integrate(sqrt(x + 1), x)   # Handles algebraic functions via rules
```

### SymbolicNumericIntegration.jl

SymbolicNumericIntegration.jl is a package for solving symbolic integrals using numerical methods. 
Specifically, it mixes numerical integration with machine learning symbolic regression in order to
discover the basis for the integrals solution, for which it then finds the coefficients and uses
differentiation to prove the correctness of the result. While this technique is unusual and new,
[see the paper for details](https://arxiv.org/abs/2201.12468v2), it has the advantage of working
very differently from the purely symbolic methods, and thus the problems which it finds hard can
be entirely different from ones which the purely symbolic methods find hard. That is, while purely
symbolic methods have difficulty depending on the complexity of the expression, this method has
difficulty depending on the uniqueness of the numerical solution of the expression, and there are many
complex expressions which have a very distinct solution behavior and thus can be easy to solve through
this method.

One major downside to this method is that, because it works numerically, there can be precision loss
in the coefficients. Thus the returned solution may have `0.5` instead of `1//2`. 

For using SymbolicNumericIntegration.jl, see [the SymbolicNumericIntegration.jl documentation](https://docs.sciml.ai/SymbolicNumericIntegration/stable/) for more details. A quick example is:

```julia
using Symbolics
using SymbolicNumericIntegration

@variables x a b

integrate(3x^3 + 2x - 5)
# (x^2 + (3 // 4) * (x^4) - (5 // 1) * x, 0, 0)

integrate(exp(a * x), x; symbolic = true)
# (exp(a * x) / a, 0, 0)

integrate(sin(a * x) * cos(b * x), x; symbolic = true, detailed = false)
# (-a * cos(a * x) * cos(b * x) - b * sin(a * x) * sin(b * x)) / (a^2 - (b^2))
```

### SymPy

The function `sympy_integrate` allows one to call 
[SymPy's integration functionality](https://docs.sympy.org/latest/modules/integrals/integrals.html).
While it's generally slow, if you leave your computer on for long enough it can solve some difficult
expressions.

```@docs
Symbolics.sympy_integrate
Symbolics.sympy_pythoncall_integrate
```

# Automated Sparse Parallelism of Julia Functions via Tracing

Because the Symbolics.jl expressions obey Julia semantics, one can
directly transform existing Julia functions into Symbolics.jl symbolic
representations of the function by simply inputting the symbolic values into
the function and using what is returned. For example, let's take [the following
numerical PDE discretization](https://www.stochasticlifestyle.com/solving-systems-stochastic-pdes-using-gpus-julia/):

```@example auto_parallel
using Symbolics, LinearAlgebra, SparseArrays, Plots

# Define the constants for the PDE
const α₂ = 1.0
const α₃ = 1.0
const β₁ = 1.0
const β₂ = 1.0
const β₃ = 1.0
const r₁ = 1.0
const r₂ = 1.0
const _DD = 100.0
const γ₁ = 0.1
const γ₂ = 0.1
const γ₃ = 0.1
const N = 32
const X = reshape([i for i in 1:N for j in 1:N], N, N)
const Y = reshape([j for i in 1:N for j in 1:N], N, N)
const α₁ = 1.0 .* (X .>= 4*N/5)

const Mx = Array(Tridiagonal([1.0 for i in 1:N-1], [-2.0 for i in 1:N], [1.0 for i in 1:N-1]))
const My = copy(Mx)
Mx[2, 1] = 2.0
Mx[end-1,end] = 2.0
My[1, 2] = 2.0
My[end,end-1] = 2.0

# Define the discretized PDE as an ODE function
function f(u, p, t)
    A = u[:,:,1]
    B = u[:,:,2]
    C = u[:,:,3]
    MyA = My*A
    AMx = A*Mx
    DA = @. _DD*(MyA + AMx)
    dA = @. DA + α₁ - β₁*A - r₁*A*B + r₂*C
    dB = @. α₂ - β₂*B - r₁*A*B + r₂*C
    dC = @. α₃ - β₃*C + r₁*A*B - r₂*C
    cat(dA, dB, dC, dims=3)
end
```

We can build the Symbolics version of this model by tracing the
model function:

```@example auto_parallel
# Define the initial condition as normal arrays
@variables u[1:N, 1:N, 1:3]
du = simplify.(f(collect(u), nothing, 0.0))
vec(du)[1:10]
```

The output, here the in-place modified `du`, is a symbolic representation of
each output of the function. We can then utilize this in the Symbolics
functionality. For example, let's build a parallel version of `f` first:

```@example auto_parallel
fastf = eval(Symbolics.build_function(du,u,
            parallel=Symbolics.MultithreadedForm())[2])
```

Now let's compute the sparse Jacobian function and compile a fast multithreaded version:

```@example auto_parallel
jac = Symbolics.sparsejacobian(vec(du), vec(u))
row,col,val = findnz(jac)
scatter(row,col,legend=false,ms=1,c=:black)
```
```@example auto_parallel
fjac = eval(Symbolics.build_function(jac,u,
            parallel=Symbolics.MultithreadedForm())[2])
```

It takes awhile for this to generate, but the results will be worth it!
Now let's set up the parabolic PDE to be solved by DifferentialEquations.jl.
We will set up the vanilla version and the sparse multithreaded
version:

```@example auto_parallel
using OrdinaryDiffEq
u0 = zeros(N, N, 3)
MyA = zeros(N, N);
AMx = zeros(N, N);
DA = zeros(N, N);
prob = ODEProblem(f, u0, (0.0, 10.0))
fastprob = ODEProblem(ODEFunction((du, u, p, t) -> fastf(du, u),
                                   jac = (du, u, p, t) -> fjac(du, u),
                                   jac_prototype = similar(jac, Float64)),
                                   u0, (0.0, 10.0))
```

Let's see the timing difference:

```@example auto_parallel
using BenchmarkTools
#@btime solve(prob, TRBDF2()); # 33.073 s (895404 allocations: 23.87 GiB)
#warning the following solve takes a long time to compile, but afterwards is very fast.
#@btime solve(fastprob, TRBDF2()); # 209.670 ms (8208 allocations: 109.25 MiB)
```

Boom, an automatic 157x acceleration that grows as the size of the problem
increases!

# Discontinuities and Inequality Helpers

These interfaces describe how a discontinuous function behaves at a root or
across a discontinuity. They are used by symbolic solvers and by code that
needs to preserve one-sided or approximate inequality semantics.

```@docs
Symbolics.rootfunction
Symbolics.left_continuous_function
Symbolics.right_continuous_function
Symbolics.majorization_function
Symbolics.minorization_function
Symbolics.approximation_function
Symbolics.@register_discontinuity
```

# Getting Started with Symbolics.jl

Symbolics.jl is a symbolic modeling language. In this tutorial, we will walk you through
the process of getting Symbolics.jl up and running, and start doing our first symbolic
calculations.

## Installing Symbolics.jl

Installing Symbolics.jl is as simple as using the Julia package manager. This is done via
the command `]add Symbolics`. After precompilation is complete, do `using Symbolics`
in the terminal (REPL) and when that command is completed, you're ready to start!

## Building Symbolic Expressions

The way to define symbolic variables is via the `@variables` macro:

```@example symbolic_basics
using Symbolics
@variables x y
```

After defining variables as symbolic, symbolic expressions, which we call a
`iscall` object, can be generated by utilizing Julia expressions. For example:

```@example symbolic_basics
z = x^2 + y
```

Here, `z` is an expression tree for “square `x` and add `y`”. To make an array
of symbolic expressions, simply make an array of symbolic expressions:

```@example symbolic_basics
A = [x^2 + y 0 2x
     0       0 2y
     y^2 + x 0 0]
```

Note that by default, `@variables` returns `Sym` or `iscall` objects wrapped in
`Num` to make them behave like subtypes of `Real`. Any operation on
these `Num` objects will return a new `Num` object, wrapping the result of
computing symbolically on the underlying values.

If you are following this tutorial in the Julia REPL, `A` will not be shown with LaTeX equations.
To get these equations, we can use [Latexify.jl](https://github.com/korsbo/Latexify.jl).
Symbolics.jl comes with Latexify recipes, so it works automatically:

```@example symbolic_basics
using Latexify
latexify(A)
```

Normal Julia functions work on Symbolics expressions, so if we
want to create the sparse version of `A` we would just call `sparse`:

```@example symbolic_basics
using SparseArrays
spA = sparse(A)
latexify(A)
```

We can thus use normal Julia functions as generators for sparse
expressions. For example, here we will define

```@example symbolic_basics
function f(u)
  [u[1] - u[3], u[1]^2 - u[2], u[3] + u[2]]
end
f([x, y, z]) # Recall that z = x^2 + y
```

Or we can build an array of variables and use it to trace the function:

```@example symbolic_basics
u = Symbolics.variables(:u, 1:5)
f(u)
```

!!! note
    `Symbolics.variables(:u, 1:5)` creates a Julia array of symbolic variables. This uses
    O(n) compute and memory but is a very general representation. Symbolics.jl also has the
    ability to represent symbolic arrays which gives an O(1) representation but is more
    limited in its functionality. For more information, see the
    [Symbolic Arrays](@ref symbolic_arrays) page.

## Derivatives

One common thing to compute in a symbolic system is derivatives. In
Symbolics.jl, derivatives are represented lazily via operations,
just like any other function. To build a differential operator, use
`Differential` like:

```@example symbolic_basics
@variables t
D = Differential(t)
```

This is the differential operator ``D = \frac{\partial}{\partial t}``. We can
compose the differential operator by `*`, e.g.
`Differential(t) * Differential(x)` or `Differential(t)^2`.
Now let's write down the derivative of some expression:

```@example symbolic_basics
z = t + t^2
D(z)
```

Notice that this hasn't computed anything yet: `D` is a lazy operator
because it lets us symbolically represent “The derivative of ``z`` with
respect to ``t``”, which is useful for example when representing our
favorite thing in the world, differential equations. However, if we
want to expand the derivative operators, we'd use `expand_derivatives`:

```@example symbolic_basics
expand_derivatives(D(z))
```

The variable, that you are taking the derivative with respect to, is accessed with:

```@example symbolic_basics
D.x
```

We can also have simplified functions for multivariable calculus.
For example, we can compute the Jacobian of an array of expressions
like:

```@example symbolic_basics
Symbolics.jacobian([x + x*y, x^2 + y], [x, y])
```

and similarly we can do Hessians, gradients, and define whatever other
derivatives you want.

## Simplification and Substitution

Symbolics interfaces with [SymbolicUtils.jl](https://github.com/JuliaSymbolics/SymbolicUtils.jl)
to allow for simplifying symbolic expressions. This is done simply
through the `simplify` command:

```@example symbolic_basics
simplify(2x + 2y)
```

This can be applied to arrays by using Julia's broadcast mechanism:

```@example symbolic_basics
B = simplify.([t + t^2 + t + t^2  2t + 4t
               x + y + y + 2t     x^2 - x^2 + y^2])
```

We can then use `substitute` to change values of an expression around:

```@example symbolic_basics
simplify.(substitute.(B, (Dict(x => y^2),)))
```

and we can use this to interactively evaluate expressions without
generating and compiling Julia functions:

```@example symbolic_basics
V = substitute.(B, (Dict(x => 2.0, y => 3.0, t => 4.0),))
```

Where we can reference the values via:

```@example symbolic_basics
Symbolics.value.(V)
```

## Non-Interactive Development

Note that the macros are for the high-level case where you're doing symbolic
computation on your own code. If you want to do symbolic computation on someone
else's code, like in a macro, you may not want to do `@variables x` because you
might want the name “x” to come from the user's code. For these cases, you can
use the interpolation operator to interpolate the runtime value of `x`, i.e.
`@variables $x`. Check the documentation of `@variables` for more details.

```@example symbolic_basics
a, b, c = :runtime_symbol_value, :value_b, :value_c
```
```@example symbolic_basics
vars = @variables t $a $b(t) $c(t)[1:3]
```
```@example symbolic_basics
(t, a, b, c)
```

One could also use `variable` and `variables`. Read their documentation for more
details.

If we need to use this to generate new Julia code, we can simply
convert the output to an `Expr`:

```@example symbolic_basics
Symbolics.toexpr(x + y^2)
```

The other way around is also possible, parsing Julia expressions into symbolic expressions

```@example symbolic_basics
ex = [:(v ~ w)
      :(w ~ -v)]
eqs = parse_expr_to_symbolic.(ex, (Main,))
eqs_lhs = [eq.lhs for eq in eqs]
eqs_rhs = [eq.rhs for eq in eqs]
Symbolics.jacobian(eqs_rhs, eqs_lhs)
```

## `Sym`s and callable `Sym`s

In the definition

```@example symbolic_basics
@variables t x(t) y(t)
```

`t` is of type `Sym{Real}`, but the name `x` refers to an object that represents the `Term` `x(t)`. The operation of this expression is itself the object `Sym{FnType{Tuple{Real}, Real}}(:x)`. The type `Sym{FnType{...}}` represents a callable object. In this case specifically, it's a function that takes 1 Real argument (noted by `Tuple{Real}`) and returns a `Real` result. You can call such a callable `Sym` with either a number or a symbolic expression of a permissible type.

This expression also defines `t` as an independent variable, while `x(t)` and `y(t)` are
dependent variables. This is accounted for in differentiation:

```@example symbolic_basics
z = x + y*t
expand_derivatives(D(z))
```

Since `x` and `y` are time-dependent, they are not automatically eliminated
from the expression, and thus the `D(x)` and `D(y)` operations still
exist in the expanded derivatives for correctness.

We can also define unrestricted functions:

```@example symbolic_basics
@variables g(..)
```

Here, `g` is a variable that is a function of other variables. Any time
that we reference `g` we have to utilize it as a function:

```@example symbolic_basics
z = g(x) + g(y)
```

## Registering Functions

One of the benefits of a one-language Julia symbolic stack is that the
primitives are all written in Julia, and therefore it's trivially
extendable from Julia itself. By default, new functions are traced
to the primitives and the symbolic expressions are written on the
primitives. However, we can expand the allowed primitives by registering
new functions. For example, let's register a new function `h`:

```@example symbolic_basics
h(x, y) = x^2 + y
@register_symbolic h(x, y)
```

When we use `h(x, y)`, it is a symbolic expression and doesn't expand:

```@example symbolic_basics
h(x, y) + y^2
```

To use it with the differentiation system, we need to register
its derivatives. We would do it like this:

```@example symbolic_basics
# Derivative w.r.t. the first argument
Symbolics.derivative(::typeof(h), args::NTuple{2,Any}, ::Val{1}) = 2args[1]
# Derivative w.r.t. the second argument
Symbolics.derivative(::typeof(h), args::NTuple{2,Any}, ::Val{2}) = 1
```

and now it works with the rest of the system:

```@example symbolic_basics
Symbolics.derivative(h(x, y) + y^2, x)
```
```@example symbolic_basics
Symbolics.derivative(h(x, y) + y^2, y)
```

!!! note
    `@register_symbolic` only allows for scalar outputs. If full array functions are needed,
    then see `@register_array_symbolic` for registering functions of symbolic arrays.

## Building Functions

The function for building functions from symbolic expressions is the aptly-named `build_function`.
The first argument is the symbolic expression or the array of symbolic
expressions to compile, and the trailing arguments are the arguments
for the function. For example:

```@example symbolic_basics
to_compute = [x^2 + y, y^2 + x]
f_expr = build_function(to_compute, [x, y])
Base.remove_linenums!.(f_expr)
```

gives back two codes. The first is a function `f([x, y])` that computes
and builds an output vector `[x^2 + y, y^2 + x]`. Because this tool
was made to be used by all the cool kids writing fast Julia codes, it
is specialized to Julia and supports features like StaticArrays. For
example:

```@example symbolic_basics
using StaticArrays
myf = eval(f_expr[1])
myf(SA[2.0, 3.0])
```

The second function is an in-place non-allocating mutating function
which mutates its first value. Thus, we'd use it like the following:

```@example symbolic_basics
myf! = eval(f_expr[2])
out = zeros(2)
myf!(out, [2.0, 3.0])
out
```

To save the symbolic calculations for later, we can take this expression
and save it out to a file:

```@example symbolic_basics
write("function.jl", string(f_expr[2]))
```

Note that if we need to avoid `eval`, for example to avoid world-age
issues, one could do `expression = Val{false}`:

```@example symbolic_basics
Base.remove_linenums!(build_function(to_compute, [x, y], expression=Val{false})[1])
```

which will use [RuntimeGeneratedFunctions.jl](https://github.com/SciML/RuntimeGeneratedFunctions.jl)
to build Julia functions which avoid world-age issues.

## Building Non-Allocating Parallel Functions for Sparse Matrices

Now let's show off a little bit. `build_function` is kind of like if
[`lambdify`](https://docs.sympy.org/latest/modules/utilities/lambdify.html)
ate its spinach. To show this, **let's build a non-allocating
function that fills sparse matrices in a multithreaded manner**. To do
this, we just have to represent the operation that we're turning into
a function via a sparse matrix. For example:

```@example symbolic_basics
using LinearAlgebra
N = 8
A = sparse(Tridiagonal([x^i for i in 1:N-1], [x^i * y^(8-i) for i in 1:N], [y^i for i in 1:N-1]))
show(A)
```

Now we call `build_function`:

```@example symbolic_basics
Base.remove_linenums!(build_function(A,[x,y],parallel=Symbolics.MultithreadedForm())[2])
```
Let's unpack what that's doing. It's using `A.nzval` to linearly
index through the sparse matrix, avoiding the `A[i,j]` form because that
is a more expensive way to index a sparse matrix if you know exactly the
order that the data is stored. Then, it's splitting up the calculation
into Julia threads, so they can be operated on in parallel. It synchronizes
after spawning all the tasks, so the computation is ensured to be
complete before moving on. And it does this with all in-place operations
to the original matrix instead of generating arrays. This is the fanciest
way you could fill a sparse matrix, and Symbolics makes this
dead simple.

(Note: this example may be slower with multithreading due to the
thread spawning overhead, but the full version was not included in the
documentation for brevity. It will be the faster version if `N` is
sufficiently large!)

Importantly, when using the in-place functions generated by
[`build_function`](@ref), it is important that the mutating argument matches the
sparse structure of the original function, as demonstrated below.
```@example symbolic_basics
using Symbolics, SparseArrays, LinearAlgebra

N = 10
_S = sprand(N, N, 0.1)
_Q = sprand(N, N, 0.1)

F(z) = [ # some complicated sparse amenable function
    _S * z
    _Q * z.^2
]

Symbolics.@variables z[1:N]

sj = Symbolics.sparsejacobian(F(z), z) # sparse jacobian

f_expr = build_function(sj, z)

rows, cols, _ = findnz(sj)
out = sparse(rows, cols, zeros(length(cols)), size(sj)...) # pre-allocate, and correct structure
myf = eval(last(f_expr))
myf(out, rand(N)) # note that out matches the sparsity structure of sj
out
```

# Supported types and dispatch in Symbolics

There is a tension between types as a representation of expression trees and types that are a subtype of types already present in Julia.

We want to be able to deal with expression trees in a unified way and not constrain expression trees themselves to be under an abstract type in Julia's type hierarchy. (For example, if we said that all expression trees are subtype of Real, then we couldn't represent array operations using the same expression tree.). But we also want to be able to pass in expression trees into places in existing code that accept `Real` values.

We accomplish this by **wrapping** expression trees in a simple wrapper type which is a subtype of our desired abstract type. For example, we wrap expression trees in the type `Num` which is a subtype of `Real` to make it behave like a Real number.

The methods on `Num` objects are forwarded to the wrapped expression tree. And care is taken so that an expression tree never internally contains `Num` -- this is both for performance and separation of concerns.

User-facing APIs in Symbolics always take wrapped objects like `Num`, they are then internally unwrapped for expression tree manipulation.

Due to it requiring such wrappers, we only fully support a limited number of types as both the types of expression trees and the type as Julia sees them.

These types are

- Real numbers (wrapped using `Num`)
- complex numbers (stored as `Complex{Num}` where `Complex` is from Base Julia)
- arrays of Real and complex numbers (wrapped using `Arr`, so `Arr{Num}` or `Arr{Complex{Num}}`)

## `@variables` and types

Use the syntax `@variables x::T` to create a symbol named `x` of symbolic type `T`. If `T` is a subtype of any of the above listed types which support a wrapper, the resulting variable will be wrapped in that type. As seen in the examples below, x,z,X,Z all have a suitable wrapper type. Hence, their types are shown. However, `s` being of symbolic type `String` does not have a corresponding wrapper supported by Symbolics, and hence, it returns a `Sym{String}` object. This is the trivial expression tree of a single variable without a wrapper, and is not a subtype of String or AbstractString.

```@example types
using Symbolics
@variables x::Real z::Complex{Real} (X::Real)[1:10, 1:10] (Z::Complex{Real})[1:10] s::String
```
```@example types
typeof(x)
```
```@example types
typeof(z)
```
```@example types
typeof(X)
```
```@example types
typeof(Z)
```
```@example types
typeof(s)
```

## Type Wrapper API

```@docs
Symbolics.wrap
Symbolics.unwrap
```

# Partial Fraction Decomposition

Partial fraction decomposition is performed using the cover-up method. This involves "covering up" a factor in the denominator and substituting the root into the remaining expression. When the denominator can be completely factored into non-repeated linear factors, this produces the desired result. When there are repeated or irreducible quadratic factors, it produces terms with unknown coefficients in the numerator that is solved as a system of equations.

It is often used when solving integrals or performing an inverse Laplace transform (see [`inverse_laplace`](@ref)).

```@docs
Symbolics.partial_frac_decomposition
```

# Parsing Julia Expressions to Symbolic Expressions

Julia expressions such as `:(y - x)` are fundamentally different from symbolic
expressions, as they do not have an algebra defined on them. Thus, it can be
very helpful when building domain-specific languages (DSLs) and parsing files
to convert from Julia expressions to Symbolics.jl expressions for further
manipulation. Towards this end is the `parse_expr_to_symbolic` which performs
the parsing.

!!! warning
    Take the limitations mentioned in the `parse_expr_to_symbolic` docstrings
    seriously! Because Julia expressions contain no symbolic metadata, there
    is limited information and thus the parsing requires heuristics to work.

```@docs
parse_expr_to_symbolic
@parse_expr_to_symbolic
```

# Variable and Equation Types

Symbolics IR mirrors the Julia AST but allows for easy mathematical
manipulation by itself following mathematical semantics. The base of the IR is
the `Sym` type, which defines a symbolic variable. Registered (mathematical)
functions on `Sym`s (or `iscall` objects) return an expression that `iscall`.
For example, `op1 = x+y` is one symbolic object and `op2 = 2z` is another, and
so `op1*op2` is another tree object. Then, at the top, an `Equation`, normally
written as `op1 ~ op2`, defines the symbolic equality between two operations.

## Types

`Sym`, `Term`, and `FnType` are from
[SymbolicUtils.jl](https://symbolicutils.juliasymbolics.org/api/). Note that in
Symbolics, we always use `Sym{Real}`, `Term{Real}`, and
`FnType{Tuple{Any}, Real}`. To get the arguments of an `iscall` object, use
`arguments(t::Term)`, and to get the operation, use `operation(t::Term)`.
However, note that one should never dispatch on `Term` or test `isa Term`.
Instead, one needs to use `SymbolicUtils.iscall` to check if `arguments` and
`operation` is defined.

```@docs
@variables
Symbolics.variable
Symbolics.variables
Equation
Base.:~(::Num, ::Num)
```

## A note about functions restricted to `Number`s

`Sym` and `Term` objects are NOT subtypes of `Number`. Symbolics provides
a simple wrapper type called `Num` which is a subtype of `Real`. `Num` wraps
either a Sym or a Term or any other object, defines the same set of operations
as symbolic expressions and forwards those to the values it wraps. You can use
`Symbolics.value` function to unwrap a `Num`.

By default, the `@variables` macros return Num-wrapped objects to allow
calling functions which are restricted to `Number` or `Real`.

```@example variables
using Symbolics
@variables t x y z(t);
Symbolics.operation(Symbolics.value(x + y))
```
```@example variables
Symbolics.operation(Symbolics.value(z))
```
```@example variables
Symbolics.arguments(Symbolics.value(x + y))
```

Note that Julia converts irrationals — like `π` and `ℯ` — to `Float64`
whenever they are involved in arithmetic with other numbers, including
integers.  An expression like `2π` will be converted to a float immediately,
so an expression like `2π * x` will leave the symbolic `x` multiplied by a
`Float64`.  It may be preferable to have a symbolic representation of `π`
also, which can be achieved with `Num(π)`.  For generic programming, it may be
helpful to simply redefine the variable `π` to be of the same type as some
other argument, as in
```@example variables
function f(x)
    let π=oftype(x, π)
        1 + (2//3 + 4π/5) * x
    end
end
f(t)
```
This will work for any floating-point input, as well as symbolic input.


## Symbolic Control Flow

Control flow can be expressed in Symbolics.jl in the following way:

```@docs
Base.ifelse(::Num, ::Any, ::Any)
```

## Inspection Functions

```@docs
SymbolicUtils.iscall
SymbolicUtils.operation
SymbolicUtils.arguments
```

## Variable Utilities

```@docs
Symbolics.get_variables!
Symbolics.getparent
```

## Variable Parsing

For implementing custom variable-creating macros:

```@docs
Symbolics._parse_vars
```

# Comparison of Julia's Symbolics.jl vs SymPy for Symbolic Computation

Symbolics.jl is a symbolic modeling language for Julia, built in
Julia. Its goal is very different from Sympy: it was made to support
symbolic-numerics, the combination of symbolic computing with numerical
methods to allow for extreme performance computing that would not be
possible without modifying the model. Because of this, Symbolics.jl
excels in many areas due to purposeful design decisions:

- Performance: Symbolics.jl is built in Julia, whereas SymPy was
  built in Python. Thus, the performance bar for Symbolics.jl is
  much higher. Symbolics.jl started because SymPy was far too
  slow and SymEngine was far too inflexible for the projects they were
  doing. Performance is key to Symbolics.jl. If you find any
  performance issues, please file an issue.
- `build_function`: `lambdify` is “fine” for some people, but if you're building
  a super fast MPI-enabled Julia/C/Fortran simulation code, having a
  function that hits the Python interpreter is less than optimal. By
  default, `build_function` builds fast JIT-compiled functions due
  to being in Julia. However, it has support for things like static
  arrays, non-allocating functions via mutation, fast functions on
  sparse matrices and arrays of arrays, etc.: all core details of
  doing high performance computing.
- Parallelism: Symbolics.jl has pervasive parallelism. The
  symbolic simplification via [SymbolicUtils.jl](https://github.com/JuliaSymbolics/SymbolicUtils.jl)
  has built-in parallelism, Symbolics.jl builds functions that
  parallelize across threads. Symbolics.jl is compatible with GPU libraries like CUDA.jl.
- Extensible: Symbolics.jl and its underlying tools are written in
  pure Julia. Want to add new or better simplification rules? Add some Julia code!
  Need to add new derivatives? Add some Julia code! You get the picture. Breaking
  down these barriers makes it easier for the user to tailor the program to their
  needs and accelerates the development of the library.
- Deep integration with the Julia ecosystem: Symbolics.jl's integration
  with neural networks is not the only thing that's deep. Symbolics.jl
  is built with the same philosophy as other SciML packages, eschewing
  “monorepos” for a distributed development approach that ties together
  the work of many developers. The differentiation parts utilize tools
  from automatic differentiation libraries, all linear algebra functionality
  comes from tracing Julia Base itself, symbolic rewriting (simplification
  and substitution) comes from
  [SymbolicUtils.jl](https://github.com/JuliaSymbolics/SymbolicUtils.jl),
  parallelism comes from Julia Base libraries, Dagger.jl, etc.
  SciML Tools like
  [DataDrivenDiffEq.jl](https://docs.sciml.ai/DataDrivenDiffEq/stable/) can reconstruct
  symbolic expressions from neural networks and data, while
  [NeuralPDE.jl](https://github.com/SciML/NeuralPDE.jl)
  can automatically solve partial differential equations from symbolic
  descriptions using physics-informed neural networks.
  The list keeps going. All told, by design Symbolics.jl's development
  moves fast because it's effectively using the work of hundreds of
  Julia developers, allowing it to grow fast.
- While Symbolics.jl has many features missing from SymPy, it does not superset
  SymPy's functionality. For a list of missing features, see [this issue](https://github.com/JuliaSymbolics/Symbolics.jl/issues/59).

# [Symbolic Arrays](@id symbolic_arrays)

## Symbolic Arrays vs Arrays of Symbolic Expressions

Symbolics.jl contains two forms for handling symbolic arrays:

1. Arrays of symbolic expressions: these are Julia arrays with Symbolics.jl objects in them.
2. Symbolic Arrays: these are symbolic (O(1)) representations of arrays.

Arrays of symbolic expressions are simply Symbolics.jl objects put into Julia arrays. For
example:

```@example arrays
using Symbolics
@variables x y
u = [x,y]
```

is a vector of two symbolic variables. As shorthand,

```@example arrays
u2 = Symbolics.variables(:x, 1:3, 3:6)
```

creates a Julia matrix of symbolic variables. Indexing `u` or `u2` gives symbolic values
which act as a normal scalar symbolic value. This form these uses Julia's array functionality
and performs symbolic operations on the scalar values.

On the otherhand, Julia's symbolic array form is an O(1) representation of the whole array.

```@example arrays
@variables A[1:5, 1:3]
```

When using this form, `A[1,1]` is not a symbolic variable but a symbolic expression for
indexing the variable `A`. This representation holds linear algebra expressions in a
non-expanded form. For example:

```@example arrays
@variables B[1:3, 1:3]
A * B
```

in comparison to:

```@example arrays
a = Symbolics.variables(:a, 1:5, 1:3)
b = Symbolics.variables(:b, 1:3, 1:3)
a * b
```

This makes the symbolic array form much more efficient, but requires that the expressions
uses things with registered symbolic array functions which currently has much lower coverage.
Also, there are many fallbacks for which arrays of symbolics which makes this approach
more accessible but with larger expressions.

We recommend defaulting to arrays of symbolics unless you need the expression symplifications
of the symbolic array approach.

## Using Symbolic Arrays

Symbolic array-valued expressions (symbolic arrays) are supported by Symbolics. Symbolic array expressions propagate useful metadata that depends on input arrays: array dimension, element type and shape.

You can create a symbolic array variable with the following syntax:

```@example arrays
using Symbolics
@variables A[1:5, 1:3] b[1:3]
```

Here, `A` is a symbolic matrix of size `(5, 3)` and `b` is a symbolic vector of length 3.

```@example arrays
size(A)
```
```@example arrays
size(b)
```
```@example arrays
ndims(A)
```
```@example arrays
ndims(b)
```
```@example arrays
eltype(A)
```
```@example arrays
eltype(b)
```

## Array operations

Operations on symbolic arrays return symbolic array expressions:

```@example arrays
c = A * b
```
```@example arrays
size(c)
```
```@example arrays
eltype(c)
```

Adjoints, matrix-matrix, and matrix-vector multiplications are supported. Dot product returns a scalar-valued expression:

```@example arrays
b'b
```
```@example arrays
size(b'b)
```

Outer product returns a matrix:

```@example arrays
b * b'
```
```@example arrays
size(b*b')
```

Tensor or Einstein notation can also be used for array operations using the `@arrayop` macro. For example, a matrix-vector product can be written as:

```julia
julia> d = Symbolics.@arrayop (i,) A[i,j]*b[j]
@arrayop(_[i] := A[i, j]*b[j])
```
These array operations are computed lazily:

```julia
julia> c = A*b
(A*b)[1:5]

julia> isequal(collect(c), collect(d))
true
```

This can be useful for vector calculus operations such as the gradient of a vector expression:

```julia
julia> @variables x y;

julia> V = [sin(x), x^2 + y]
2-element Vector{Num}:
  sin(x)
 y + x^2

julia> D = Differential.([x,y]);
julia> expand_derivatives.(collect(Symbolics.@arrayop (i,j) D[i](V[j])))
2×2 Matrix{Num}:
 cos(x)  2x
      0   1
```
or the divergence of a vector expression:
```julia
julia> expand_derivatives.(collect(Symbolics.@arrayop () D[i](V[i])))
1 + cos(x)
```
### Broadcast, map and reduce


```@example arrays
A .* b'
```
```@example arrays
map(asin, (A*b))
```
```julia
#sum(A) #latexify not working
```
```@example arrays
typeof(sum(A))
```
```@example arrays
typeof(sum(A, dims=2))
```

### Indexing and delayed computation

Indexing array expressions is fairly flexible in Symbolics. Let's go through all the possible ways to index arrays.

#### Scalar indexing and scalarization

```@example arrays
AAt = A*A'
```
```@example arrays
AAt[2,3]
```

Here we indexed for the element (2,3), but we got back a symbolic indexing expression. You may want to force the element to be computed in terms of the elements of A. This can be done, using the `scalarize` function.

```@example arrays
Symbolics.scalarize(AAt[2,3])
```
```julia
@syms i::Int j::Int
Symbolics.scalarize(AAt[i,j])
```

In general, any scalar expression which is derived from array expressions can be scalarized.

```julia
#sum(A[:,1]) + sum(A[2,:])#latexify not working
```
```julia
Symbolics.scalarize(sum(A[:,1]) + sum(A[2,:]))
```

## Array API Reference

```@docs
Symbolics.Arr
```

The [`Symbolics.scalarize`](https://symbolicutils.juliasymbolics.org/api/#SymbolicUtils.scalarize)
and [`Symbolics.shape`](https://symbolicutils.juliasymbolics.org/api/#SymbolicUtils.shape)
functions are provided by SymbolicUtils and reexported by Symbolics.

# Miscellaneous API

This page documents various utility functions and constants that don't fit into other categories.

## Constants

```@docs
Symbolics.NAMESPACE_SEPARATOR
```

## Utility functions

```@docs
Symbolics.linear_expansion
Symbolics.LinearExpander
Symbolics._toexpr_metadata
Symbolics._toexpr_op
```

## Deprecated

These names are still exported so that existing code keeps working, but each one warns on
use and will be removed in the next breaking release.

```@docs
Symbolics.infimum
Symbolics.supremum
```

# [Solving Symbolic Equations](@id symbolic_solver)

The main symbolic solver for Symbolics.jl is `symbolic_solve`. Symbolic solving
means that it only uses symbolic (algebraic) methods and outputs exact solutions.

```@docs
Symbolics.symbolic_solve
```

One other symbolic solver is `symbolic_linear_solve` which is limited compared to 
`symbolic_solve` as it only solves linear equations.

```@docs
Symbolics.symbolic_linear_solve
```

`symbolic_solve` only supports symbolic, i.e. non-floating point computations, and thus prefers equations
where the coefficients are integer, rational, or symbolic. Floating point coefficients are transformed into
rational values and BigInt values are used internally with a potential performance loss, and thus it is recommended
that this functionality is only used with floating point values if necessary. In contrast, `symbolic_linear_solve`
directly handles floating point values using standard factorizations.

### More technical details and examples

#### Technical details

The `symbolic_solve` function uses 4 hidden solvers in order to solve the user's input. Its base,
`solve_univar`, uses analytic solutions up to polynomials of degree 4 and factoring as its method
for solving univariate polynomials. The function's `solve_multipoly` uses GCD on the input polynomials then throws passes the result
to `solve_univar`. The function's `solve_multivar` uses Groebner basis and a separating form in order to create linear equations in the
input variables and a single high degree equation in the separating variable [^1]. Each equation resulting from the basis is then passed
to `solve_univar`. We can see that essentially, `solve_univar` is the building block of `symbolic_solve`. If the input is not a valid polynomial and can not be solved by the algorithm above, `symbolic_solve` passes
it to `ia_solve`, which attempts solving by attraction and isolation [^2]. This only works when the input is a single expression
and the user wants the answer in terms of a single variable. Say `log(x) - a == 0` gives us `[e^a]`.

```@docs
Symbolics.solve_univar
Symbolics.solve_multivar
Symbolics.ia_solve
Symbolics.ia_conditions!
Symbolics.is_periodic
Symbolics.fundamental_period
```

#### Nice examples

```@example solver
using Symbolics, Nemo;
@variables x;
Symbolics.symbolic_solve(9^x + 3^x ~ 8, x)
```

```@example solver
@variables x y z;
Symbolics.symbolic_linear_solve(2//1*x + y - 2//1*z ~ 9//1*x, 1//1*x)
```

```@example solver
using Groebner;
@variables x y z;

eqs = [x^2 + y + z - 1, x + y^2 + z - 1, x + y + z^2 - 1]
Symbolics.symbolic_solve(eqs, [x,y,z])
```

### SymPy Integration

SymPy also includes solves as well, and the SymPy.jl extensions allow for automatically converting
Symbolics expressions for use in its solvers.

```@docs
Symbolics.sympy_linear_solve
Symbolics.sympy_algebraic_solve
```

### Feature completeness

- [x] Linear and polynomial equations
- [x] Systems of linear and polynomial equations
- [x] Some transcendental functions
- [x] Systems of linear equations with parameters (via `symbolic_linear_solve`)
- [ ] Equations with radicals
- [x] Systems of polynomial equations with parameters and positive dimensional systems
- [ ] Inequalities

### Expressions we can not solve (but aim to)
```
# Mathematica

In[1]:= Reduce[x^2 - x - 6 > 0, x]
Out[1]= x < -2 || x > 3

In[2]:= Reduce[x+a > 0, x]
Out[2]= a \[Element] Reals && x > -a

In[3]:= Solve[x^(x)  + 3 == 0, x]
Out[3]= {{x -> (I \[Pi] + Log[3])/ProductLog[I \[Pi] + Log[3]]}}
```

# References

[^1]: [Rouillier, F. Solving Zero-Dimensional Systems Through the Rational Univariate Representation. AAECC 9, 433–461 (1999).](https://doi.org/10.1007/s002000050114)
[^2]: [R. W. Hamming, Coding and Information Theory, ScienceDirect, 1980](https://www.sciencedirect.com/science/article/pii/S0747717189800070).

# Working with External Symbolics Packages: SymPy, Mathematica, Oscar, and Beyond

Symbolics.jl takes an inclusive development philosophy: yes there are other computer algebra systems
such as SymPy and Mathematica, yes they can do some things that Symbolics.jl cannot natively do, and
no that is not a bad thing. Instead, we maintain bridges to these other languages in order to encourage
users to take full advantage of other tools as part of their workflow!

The following are the wrappers and interactions users should be aware of.

## Using Symbolics.jl with SymPy 

SymPy is a Python-based symbolic library. While it is generally not computationally performant, it is
good in its completeness of features and as such it can be helpful to call its functions from time to
time. Because of this, Symbolics.jl maintains extensions for SymPy.jl which facilitates translations.
The extension is triggered by adding the SymPy.jl packages doing `using SymPy`. When this is done,
Symbolics.jl gives functions which allow for translating to and from SymPy expressions:

```@docs
Symbolics.symbolics_to_sympy
Symbolics.sympy_to_symbolics
Symbolics.symbolics_to_sympy_pythoncall
Symbolics.sympy_pythoncall_to_symbolics
```

In addition, many of the features pages include docstrings for functionality given by this bridge.
These functions all have `sympy` in the name, and includes:

* `sympy_simplify`
* `sympy_linear_solve`
* `sympy_algebraic_solve`
* `sympy_integrate`
* `sympy_limit`
* `sympy_simplify`
* `sympy_ode_solve`
* `sympy_pythoncall_to_symbolics`
* `sympy_pythoncall_simplify`

## Using Symbolics.jl with Mathematica / Wolfram's MathLink

The library [SymbolicsMathLink.jl](https://github.com/eswagel/SymbolicsMathLink.jl) is capable of
converting Symbolics.jl expressions for use with Mathematica calls via Wolfram's MathLink.
The package requires an installation of either [Mathematica](http://www.wolfram.com/mathematica/) or the free [Wolfram Engine](https://www.wolfram.com/engine/). It will attempt to find the installation at build time; if this fails, please see the [installation troubleshoot on the MathLink.jl README](https://github.com/JuliaInterop/MathLink.jl?tab=readme-ov-file#installation-troubleshoot).

Round-trip conversion is given by the functions:

```julia
expr_to_mathematica(juliaSymbolicExpression)
mathematica_to_expr(W`Some Mathematica expression`)
```

Some examples in action include using Mathematica for equation solving:

```julia
julia> using SymbolicsMathLink

julia> @variables x;
julia> expr = x^2 + x - 1;

julia> result = wcall("Solve", expr~0)
2-element Array{Num,1}:
    -1 + x
    1 + x
```

and solving differential equations:

```julia
julia> @variables vars(x)[1:2];
julia> expr = Differential(x)(vars[1]) + 2
2 + Differential(x)((vars(x))[1])
julia> result = wcall("DSolveValue", expr~0, vars[1], x)
C_1 - 2x
```

## Groebner Basis via Groebner.jl

[Groebner.jl](https://github.com/sumiya11/Groebner.jl) is a very efficient system for computing
Groebner basis written in Julia. Its publication 
[details how it is much more efficient than Maple, msolve, Mathematica, and Singular](https://arxiv.org/pdf/2304.06935) for these computing a Groebner basis. As such, it is highly recommended that one use this
system for the computation. Symbolics.jl provides an extension which automatically converts Symbolics.jl
polynomials into its specialized form for the computation and converts the result back, and thus no work
is required on the users end for integrating.

```@docs
Symbolics.groebner_basis
```

## Nemo.jl

[Nemo.jl's abstract algebra functionality (and by extension FLINT)](https://nemocas.github.io/Nemo.jl/stable/) 
is used as part of many of the symbolic solver routines. If Nemo is required an error message specifying
the requirement to load Nemo.jl will be given. For more information, see the 
[symbolic solver page](@ref symbolic_solver)

# Frequently Asked Questions

## Limits of Symbolic Computation

### Transforming my function to a symbolic equation has failed. What do I do?

If you see the error:

```
ERROR: TypeError: non-boolean (Num) used in boolean context
```

this is likely coming from an algorithm which cannot be traced into a purely
symbolic algorithm. Many numerical solvers, for instance, have this property. It
shows up when you're doing something like if `x < tol`. If x is a number, then
this is true or false. If x is a symbol, then it's `x < tol`, so Julia just cannot
know how many iterations to do and throws an error.

This shows up in adaptive algorithms, for example:

```@example faq
function factorial(x)
  out = x
  while x > 1
    x -= 1
    out *= x
  end
  out
end
```

The number of iterations this algorithm runs for is dependent on the value of
`x`, and so there is no static representation of the algorithm. If `x` is 5,
then it's `out = x*(x-1)*(x-2)*(x-3)*(x-4)`, while if `x` is 3, then it's
`out = x*(x-1)*(x-2)`. It should thus be no surprise that:

```@example faq
using Symbolics
@variables x
try
    factorial(x)
catch e
    e
end
```

fails. It's not that there is anything wrong with this code, but it's not going
to work because fundamentally this is not a symbolically-representable algorithm.

The space of algorithms which can be turned into symbolic algorithms is what we
call quasi-static, that is, there is a way to represent the algorithm as static.
Loops are allowed, but the amount of loop iterations should not require that you
know the value of the symbol `x`. If the algorithm is quasi-static, then Symbolics.jl
tracing will produce the static form of the code, unrolling the operations, and
generating a flat representation of the algorithm.

#### What can be done?

If you need to represent this function `f` symbolically, then you'll need to make
sure it's not traced and instead is directly represented in the underlying
computational graph. Just like how `sqrt(x)` symbolically does not try to
represent the underlying algorithm, this must be done to your `f`. This is
done by doing `@register_symbolic f(x)`. If you have to define things like derivatives to
`f`, then [the function registration documentation](@ref function_registration).

## Equality and set membership tests
Comparing symbols with `==` produces a symbolic equality, not a `Bool`. To produce a `Bool`, call `isequal`.

To test if a symbol is part of a collection of symbols, i.e., a vector, either create a `Set` and use `in`, e.g.
```@example faq
try 
    x in [x]
catch e
    e
end
```
```@example faq
x in Set([x])
```
```@example faq
any(isequal(x), [x])
```

If `==` is used instead, you will receive `TypeError: non-boolean (Num) used in boolean context`. What this error 
is telling you is that the symbolic `x == y` expression is being used where a `Bool` is required, such as
`if x == y`, and since the symbolic expression is held lazily this will error because the appropriate branch cannot
be selected (since `x == y` is unknown for arbitrary symbolic values!). This is why the check `isequal(x,y)` is
required, since this is a non-lazy check of whether the symbol `x` is always equal to the symbol `y`, rather than
an expression of whether `x` and `y` currently have the same value.

## Understanding the Difference Between the Julia Variable and the Symbolic Variable

In the most basic usage of Symbolics, the name of the Julia variable
and the symbolic variable are the same. For example, when we do:

```@example faq
@variables a
```

the name of the symbolic variable is `a` and same with the Julia variable. However, we can
de-couple these by setting `a` to a new symbolic variable, for example:

```@example faq
b = only(@variables(a))
```

Now the Julia variable `b` refers to the variable named `a`. However, the downside of this current
approach is that it requires that the user writing the script knows the name `a` that they want to
place to the variable. But what if for example we needed to get the variable's name from a file?

To do this, one can interpolate a symbol into the `@variables` macro using `$`. For example:

```@example faq
a = :c
b = only(@variables($a))
```

In this example, `@variables($a)` created a variable named `c`, and set this variable to `b`.

# Automatic Conversion of Julia Code to C Functions

Since Symbolics.jl can trace Julia code into Symbolics IR that can be built and
compiled via `build_function` to C, this gives us a nifty way to automatically
generate C functions from Julia code! To see this in action, let's start with
[the Lotka-Volterra equations](https://en.wikipedia.org/wiki/Lotka%E2%80%93Volterra_equations):

```@example converting_to_C
using Symbolics
function lotka_volterra!(du, u, p, t)
  x, y = u
  α, β, δ, γ = p
  du[1] = dx = α*x - β*x*y
  du[2] = dy = -δ*y + γ*x*y
end
```

Now we trace this into Symbolics:

```@example converting_to_C
@variables t du[1:2] u[1:2] p[1:4]
du = collect(du)
lotka_volterra!(du, u, p, t)
du
```
and then we build the function:

```@example converting_to_C
build_function(du, u, p, t, target=Symbolics.CTarget())
```

If we want to compile this, we do `expression=Val{false}`:

```@example converting_to_C
f = build_function(du, u, p, t, target=Symbolics.CTarget(), expression=Val{false})
```

now we check it computes the same thing:

```@example converting_to_C
du = rand(2); du2 = rand(2)
u = rand(2)
p = rand(4)
t = rand()
f(du, u, p, t)
lotka_volterra!(du2, u, p, t)
du == du2 # true!
```

# Structure and Sparsity Detection

Using the tracing system provided by Symbolics.jl expressions, Symbolics.jl
can automatically detect the sparsity patterns of Julia functions efficiently.
This functionality is described in more detail in the paper:

```
@article{gowda2019sparsity,
  title={Sparsity Programming: Automated Sparsity-Aware Optimizations in Differentiable Programming},
  author={Gowda, Shashi and Ma, Yingbo and Churavy, Valentin and Edelman, Alan and Rackauckas, Christopher},
  year={2019}
}
```

Please cite this work if the functionality is used.

## Sparsity Detection

```@docs
Symbolics.jacobian_sparsity
Symbolics.hessian_sparsity
```

## Structure Detection

```@docs
Symbolics.islinear
Symbolics.isaffine
```

## ADTypes.jl interface

```@docs
Symbolics.SymbolicsSparsityDetector
```

# I/O, Saving, and Latex

Note that Julia's standard I/O functionality can be used to save
Symbolics expressions out to files. For example, here we will
generate an in-place version of `f` and save the anonymous function to
a `.jl` file:

```@example io
using Symbolics
@variables u[1:3]
function f(u)
  [u[1]-u[3],u[1]^2-u[2],u[3]+u[2]]
end
ex1, ex2 = build_function(f(u),u)
write("function.jl", string(ex2))
```

Now we can do something like:

```@example io
g = include("function.jl")
```

and that will load the function back in. Note that this can be done
to save the transformation results of Symbolics.jl so that
they can be stored and used in a precompiled Julia package.

## Latexification

Symbolics.jl's expressions support Latexify.jl, and thus

```julia
using Latexify
latexify(ex)
```

will produce LaTeX output from Symbolics models and expressions.
This works on basics like `Term` all the way to higher primitives
like `ODESystem` and `ReactionSystem`.
